#define LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ LDKCVec_TransactionOutputsZ
#define CVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ_free CVec_TransactionOutputsZ_free
#include "js-wasm.h"
#include <stdatomic.h>
#include <lightning.h>

// These should be provided...somehow...
void *memset(void *s, int c, size_t n);
void *memcpy(void *dest, const void *src, size_t n);
int memcmp(const void *s1, const void *s2, size_t n);

extern void __attribute__((noreturn)) abort(void);
static inline void assert(bool expression) {
	if (!expression) { abort(); }
}

uint32_t __attribute__((export_name("test_bigint_pass_deadbeef0badf00d"))) test_bigint_pass_deadbeef0badf00d(uint64_t val) {
	return val == 0xdeadbeef0badf00dULL;
}


void *malloc(size_t size);
void free(void *ptr);

#define MALLOC(a, _) malloc(a)
#define do_MALLOC(a, _b, _c) malloc(a)
#define FREE(p) if ((unsigned long)(p) > 4096) { free(p); }
#define DO_ASSERT(a) (void)(a)
#define CHECK(a)
#define CHECK_ACCESS(p)
#define CHECK_INNER_FIELD_ACCESS_OR_NULL(v)

// We assume that CVec_u8Z and u8slice are the same size and layout (and thus pointers to the two can be mixed)
_Static_assert(sizeof(LDKCVec_u8Z) == sizeof(LDKu8slice), "Vec<u8> and [u8] need to have been mapped identically");
_Static_assert(offsetof(LDKCVec_u8Z, data) == offsetof(LDKu8slice, data), "Vec<u8> and [u8] need to have been mapped identically");
_Static_assert(offsetof(LDKCVec_u8Z, datalen) == offsetof(LDKu8slice, datalen), "Vec<u8> and [u8] need to have been mapped identically");

_Static_assert(sizeof(void*) == 4, "Pointers mut be 32 bits");

#define DECL_ARR_TYPE(ty, name) \
	struct name##array { \
		uint32_t arr_len; \
		ty elems[]; \
	}; \
	typedef struct name##array * name##Array; \
	static inline name##Array init_##name##Array(size_t arr_len, int lineno) { \
		name##Array arr = (name##Array)do_MALLOC(arr_len * sizeof(ty) + sizeof(uint32_t), #name" array init", lineno); \
		arr->arr_len = arr_len; \
		return arr; \
	}

DECL_ARR_TYPE(int64_t, int64_t);
DECL_ARR_TYPE(int8_t, int8_t);
DECL_ARR_TYPE(uint32_t, uint32_t);
DECL_ARR_TYPE(void*, ptr);
DECL_ARR_TYPE(char, char);
typedef charArray jstring;

static inline jstring str_ref_to_ts(const char* chars, size_t len) {
	charArray arr = init_charArray(len, __LINE__);
	memcpy(arr->elems, chars, len);
	return arr;
}
static inline LDKStr str_ref_to_owned_c(const jstring str) {
	char* newchars = MALLOC(str->arr_len + 1, "String chars");
	memcpy(newchars, str->elems, str->arr_len);
	newchars[str->arr_len] = 0;
	LDKStr res = {
		.chars = newchars,
		.len = str->arr_len,
		.chars_is_owned = true
	};
	return res;
}

typedef bool jboolean;

uint32_t __attribute__((export_name("TS_malloc"))) TS_malloc(uint32_t size) {
	return (uint32_t)MALLOC(size, "JS-Called malloc");
}
void __attribute__((export_name("TS_free"))) TS_free(uint32_t ptr) {
	FREE((void*)ptr);
}

jstring __attribute__((export_name("TS_get_ldk_c_bindings_version"))) TS_get_ldk_c_bindings_version() {
	const char *res = check_get_ldk_bindings_version();
	if (res == NULL) return NULL;
	return str_ref_to_ts(res, strlen(res));
}
jstring __attribute__((export_name("TS_get_ldk_version"))) get_ldk_version() {
	const char *res = check_get_ldk_version();
	if (res == NULL) return NULL;
	return str_ref_to_ts(res, strlen(res));
}
#include "version.c"
static inline struct LDKThirtyTwoBytes ThirtyTwoBytes_clone(const struct LDKThirtyTwoBytes *orig) { struct LDKThirtyTwoBytes ret; memcpy(ret.data, orig->data, 32); return ret; }
static inline LDKAccessError LDKAccessError_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKAccessError_UnknownChain;
		case 1: return LDKAccessError_UnknownTx;
	}
	abort();
}
static inline int32_t LDKAccessError_to_js(LDKAccessError val) {
	switch (val) {
		case LDKAccessError_UnknownChain: return 0;
		case LDKAccessError_UnknownTx: return 1;
		default: abort();
	}
}
static inline LDKCOption_NoneZ LDKCOption_NoneZ_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKCOption_NoneZ_Some;
		case 1: return LDKCOption_NoneZ_None;
	}
	abort();
}
static inline int32_t LDKCOption_NoneZ_to_js(LDKCOption_NoneZ val) {
	switch (val) {
		case LDKCOption_NoneZ_Some: return 0;
		case LDKCOption_NoneZ_None: return 1;
		default: abort();
	}
}
static inline LDKChannelMonitorUpdateErr LDKChannelMonitorUpdateErr_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKChannelMonitorUpdateErr_TemporaryFailure;
		case 1: return LDKChannelMonitorUpdateErr_PermanentFailure;
	}
	abort();
}
static inline int32_t LDKChannelMonitorUpdateErr_to_js(LDKChannelMonitorUpdateErr val) {
	switch (val) {
		case LDKChannelMonitorUpdateErr_TemporaryFailure: return 0;
		case LDKChannelMonitorUpdateErr_PermanentFailure: return 1;
		default: abort();
	}
}
static inline LDKConfirmationTarget LDKConfirmationTarget_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKConfirmationTarget_Background;
		case 1: return LDKConfirmationTarget_Normal;
		case 2: return LDKConfirmationTarget_HighPriority;
	}
	abort();
}
static inline int32_t LDKConfirmationTarget_to_js(LDKConfirmationTarget val) {
	switch (val) {
		case LDKConfirmationTarget_Background: return 0;
		case LDKConfirmationTarget_Normal: return 1;
		case LDKConfirmationTarget_HighPriority: return 2;
		default: abort();
	}
}
static inline LDKCreationError LDKCreationError_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKCreationError_DescriptionTooLong;
		case 1: return LDKCreationError_RouteTooLong;
		case 2: return LDKCreationError_TimestampOutOfBounds;
		case 3: return LDKCreationError_InvalidAmount;
		case 4: return LDKCreationError_MissingRouteHints;
	}
	abort();
}
static inline int32_t LDKCreationError_to_js(LDKCreationError val) {
	switch (val) {
		case LDKCreationError_DescriptionTooLong: return 0;
		case LDKCreationError_RouteTooLong: return 1;
		case LDKCreationError_TimestampOutOfBounds: return 2;
		case LDKCreationError_InvalidAmount: return 3;
		case LDKCreationError_MissingRouteHints: return 4;
		default: abort();
	}
}
static inline LDKCurrency LDKCurrency_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKCurrency_Bitcoin;
		case 1: return LDKCurrency_BitcoinTestnet;
		case 2: return LDKCurrency_Regtest;
		case 3: return LDKCurrency_Simnet;
		case 4: return LDKCurrency_Signet;
	}
	abort();
}
static inline int32_t LDKCurrency_to_js(LDKCurrency val) {
	switch (val) {
		case LDKCurrency_Bitcoin: return 0;
		case LDKCurrency_BitcoinTestnet: return 1;
		case LDKCurrency_Regtest: return 2;
		case LDKCurrency_Simnet: return 3;
		case LDKCurrency_Signet: return 4;
		default: abort();
	}
}
static inline LDKLevel LDKLevel_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKLevel_Gossip;
		case 1: return LDKLevel_Trace;
		case 2: return LDKLevel_Debug;
		case 3: return LDKLevel_Info;
		case 4: return LDKLevel_Warn;
		case 5: return LDKLevel_Error;
	}
	abort();
}
static inline int32_t LDKLevel_to_js(LDKLevel val) {
	switch (val) {
		case LDKLevel_Gossip: return 0;
		case LDKLevel_Trace: return 1;
		case LDKLevel_Debug: return 2;
		case LDKLevel_Info: return 3;
		case LDKLevel_Warn: return 4;
		case LDKLevel_Error: return 5;
		default: abort();
	}
}
static inline LDKNetwork LDKNetwork_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKNetwork_Bitcoin;
		case 1: return LDKNetwork_Testnet;
		case 2: return LDKNetwork_Regtest;
		case 3: return LDKNetwork_Signet;
	}
	abort();
}
static inline int32_t LDKNetwork_to_js(LDKNetwork val) {
	switch (val) {
		case LDKNetwork_Bitcoin: return 0;
		case LDKNetwork_Testnet: return 1;
		case LDKNetwork_Regtest: return 2;
		case LDKNetwork_Signet: return 3;
		default: abort();
	}
}
static inline LDKRecipient LDKRecipient_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKRecipient_Node;
		case 1: return LDKRecipient_PhantomNode;
	}
	abort();
}
static inline int32_t LDKRecipient_to_js(LDKRecipient val) {
	switch (val) {
		case LDKRecipient_Node: return 0;
		case LDKRecipient_PhantomNode: return 1;
		default: abort();
	}
}
static inline LDKSecp256k1Error LDKSecp256k1Error_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKSecp256k1Error_IncorrectSignature;
		case 1: return LDKSecp256k1Error_InvalidMessage;
		case 2: return LDKSecp256k1Error_InvalidPublicKey;
		case 3: return LDKSecp256k1Error_InvalidSignature;
		case 4: return LDKSecp256k1Error_InvalidSecretKey;
		case 5: return LDKSecp256k1Error_InvalidRecoveryId;
		case 6: return LDKSecp256k1Error_InvalidTweak;
		case 7: return LDKSecp256k1Error_TweakCheckFailed;
		case 8: return LDKSecp256k1Error_NotEnoughMemory;
	}
	abort();
}
static inline int32_t LDKSecp256k1Error_to_js(LDKSecp256k1Error val) {
	switch (val) {
		case LDKSecp256k1Error_IncorrectSignature: return 0;
		case LDKSecp256k1Error_InvalidMessage: return 1;
		case LDKSecp256k1Error_InvalidPublicKey: return 2;
		case LDKSecp256k1Error_InvalidSignature: return 3;
		case LDKSecp256k1Error_InvalidSecretKey: return 4;
		case LDKSecp256k1Error_InvalidRecoveryId: return 5;
		case LDKSecp256k1Error_InvalidTweak: return 6;
		case LDKSecp256k1Error_TweakCheckFailed: return 7;
		case LDKSecp256k1Error_NotEnoughMemory: return 8;
		default: abort();
	}
}
static inline LDKSemanticError LDKSemanticError_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKSemanticError_NoPaymentHash;
		case 1: return LDKSemanticError_MultiplePaymentHashes;
		case 2: return LDKSemanticError_NoDescription;
		case 3: return LDKSemanticError_MultipleDescriptions;
		case 4: return LDKSemanticError_NoPaymentSecret;
		case 5: return LDKSemanticError_MultiplePaymentSecrets;
		case 6: return LDKSemanticError_InvalidFeatures;
		case 7: return LDKSemanticError_InvalidRecoveryId;
		case 8: return LDKSemanticError_InvalidSignature;
		case 9: return LDKSemanticError_ImpreciseAmount;
	}
	abort();
}
static inline int32_t LDKSemanticError_to_js(LDKSemanticError val) {
	switch (val) {
		case LDKSemanticError_NoPaymentHash: return 0;
		case LDKSemanticError_MultiplePaymentHashes: return 1;
		case LDKSemanticError_NoDescription: return 2;
		case LDKSemanticError_MultipleDescriptions: return 3;
		case LDKSemanticError_NoPaymentSecret: return 4;
		case LDKSemanticError_MultiplePaymentSecrets: return 5;
		case LDKSemanticError_InvalidFeatures: return 6;
		case LDKSemanticError_InvalidRecoveryId: return 7;
		case LDKSemanticError_InvalidSignature: return 8;
		case LDKSemanticError_ImpreciseAmount: return 9;
		default: abort();
	}
}
static inline LDKSiPrefix LDKSiPrefix_from_js(int32_t ord) {
	switch (ord) {
		case 0: return LDKSiPrefix_Milli;
		case 1: return LDKSiPrefix_Micro;
		case 2: return LDKSiPrefix_Nano;
		case 3: return LDKSiPrefix_Pico;
	}
	abort();
}
static inline int32_t LDKSiPrefix_to_js(LDKSiPrefix val) {
	switch (val) {
		case LDKSiPrefix_Milli: return 0;
		case LDKSiPrefix_Micro: return 1;
		case LDKSiPrefix_Nano: return 2;
		case LDKSiPrefix_Pico: return 3;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKBech32Error_ty_from_ptr"))) TS_LDKBech32Error_ty_from_ptr(uint32_t ptr) {
	LDKBech32Error *obj = (LDKBech32Error*)(ptr & ~1);
	switch(obj->tag) {
		case LDKBech32Error_MissingSeparator: return 0;
		case LDKBech32Error_InvalidChecksum: return 1;
		case LDKBech32Error_InvalidLength: return 2;
		case LDKBech32Error_InvalidChar: return 3;
		case LDKBech32Error_InvalidData: return 4;
		case LDKBech32Error_InvalidPadding: return 5;
		case LDKBech32Error_MixedCase: return 6;
		default: abort();
	}
}
int32_t __attribute__((export_name("TS_LDKBech32Error_InvalidChar_get_invalid_char"))) TS_LDKBech32Error_InvalidChar_get_invalid_char(uint32_t ptr) {
	LDKBech32Error *obj = (LDKBech32Error*)(ptr & ~1);
	assert(obj->tag == LDKBech32Error_InvalidChar);
	return obj->invalid_char;
}
int8_t __attribute__((export_name("TS_LDKBech32Error_InvalidData_get_invalid_data"))) TS_LDKBech32Error_InvalidData_get_invalid_data(uint32_t ptr) {
	LDKBech32Error *obj = (LDKBech32Error*)(ptr & ~1);
	assert(obj->tag == LDKBech32Error_InvalidData);
	return obj->invalid_data;
}
static inline LDKCVec_u8Z CVec_u8Z_clone(const LDKCVec_u8Z *orig) {
	LDKCVec_u8Z ret = { .data = MALLOC(sizeof(int8_t) * orig->datalen, "LDKCVec_u8Z clone bytes"), .datalen = orig->datalen };
	memcpy(ret.data, orig->data, sizeof(int8_t) * ret.datalen);
	return ret;
}
struct LDKCVec_u8Z TxOut_get_script_pubkey (struct LDKTxOut* thing) {	return CVec_u8Z_clone(&thing->script_pubkey);}int8_tArray  __attribute__((export_name("TS_TxOut_get_script_pubkey"))) TS_TxOut_get_script_pubkey(uint32_t thing) {
	LDKTxOut* thing_conv = (LDKTxOut*)(thing & ~1);
	LDKCVec_u8Z ret_var = TxOut_get_script_pubkey(thing_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint64_t TxOut_get_value (struct LDKTxOut* thing) {	return thing->value;}int64_t  __attribute__((export_name("TS_TxOut_get_value"))) TS_TxOut_get_value(uint32_t thing) {
	LDKTxOut* thing_conv = (LDKTxOut*)(thing & ~1);
	int64_t ret_val = TxOut_get_value(thing_conv);
	return ret_val;
}

static inline void CResult_NoneNoneZ_get_ok(LDKCResult_NoneNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
void  __attribute__((export_name("TS_CResult_NoneNoneZ_get_ok"))) TS_CResult_NoneNoneZ_get_ok(uint32_t owner) {
	LDKCResult_NoneNoneZ* owner_conv = (LDKCResult_NoneNoneZ*)(owner & ~1);
	CResult_NoneNoneZ_get_ok(owner_conv);
}

static inline void CResult_NoneNoneZ_get_err(LDKCResult_NoneNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_NoneNoneZ_get_err"))) TS_CResult_NoneNoneZ_get_err(uint32_t owner) {
	LDKCResult_NoneNoneZ* owner_conv = (LDKCResult_NoneNoneZ*)(owner & ~1);
	CResult_NoneNoneZ_get_err(owner_conv);
}

static inline struct LDKCounterpartyCommitmentSecrets CResult_CounterpartyCommitmentSecretsDecodeErrorZ_get_ok(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return CounterpartyCommitmentSecrets_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_get_ok"))) TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* owner_conv = (LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ*)(owner & ~1);
	LDKCounterpartyCommitmentSecrets ret_var = CResult_CounterpartyCommitmentSecretsDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_CounterpartyCommitmentSecretsDecodeErrorZ_get_err(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_get_err"))) TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* owner_conv = (LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_CounterpartyCommitmentSecretsDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKSecretKey CResult_SecretKeyErrorZ_get_ok(LDKCResult_SecretKeyErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
int8_tArray  __attribute__((export_name("TS_CResult_SecretKeyErrorZ_get_ok"))) TS_CResult_SecretKeyErrorZ_get_ok(uint32_t owner) {
	LDKCResult_SecretKeyErrorZ* owner_conv = (LDKCResult_SecretKeyErrorZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CResult_SecretKeyErrorZ_get_ok(owner_conv).bytes, 32);
	return ret_arr;
}

static inline enum LDKSecp256k1Error CResult_SecretKeyErrorZ_get_err(LDKCResult_SecretKeyErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
uint32_t  __attribute__((export_name("TS_CResult_SecretKeyErrorZ_get_err"))) TS_CResult_SecretKeyErrorZ_get_err(uint32_t owner) {
	LDKCResult_SecretKeyErrorZ* owner_conv = (LDKCResult_SecretKeyErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKSecp256k1Error_to_js(CResult_SecretKeyErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline struct LDKPublicKey CResult_PublicKeyErrorZ_get_ok(LDKCResult_PublicKeyErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
int8_tArray  __attribute__((export_name("TS_CResult_PublicKeyErrorZ_get_ok"))) TS_CResult_PublicKeyErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PublicKeyErrorZ* owner_conv = (LDKCResult_PublicKeyErrorZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, CResult_PublicKeyErrorZ_get_ok(owner_conv).compressed_form, 33);
	return ret_arr;
}

static inline enum LDKSecp256k1Error CResult_PublicKeyErrorZ_get_err(LDKCResult_PublicKeyErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
uint32_t  __attribute__((export_name("TS_CResult_PublicKeyErrorZ_get_err"))) TS_CResult_PublicKeyErrorZ_get_err(uint32_t owner) {
	LDKCResult_PublicKeyErrorZ* owner_conv = (LDKCResult_PublicKeyErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKSecp256k1Error_to_js(CResult_PublicKeyErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline struct LDKTxCreationKeys CResult_TxCreationKeysDecodeErrorZ_get_ok(LDKCResult_TxCreationKeysDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return TxCreationKeys_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysDecodeErrorZ_get_ok"))) TS_CResult_TxCreationKeysDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_TxCreationKeysDecodeErrorZ* owner_conv = (LDKCResult_TxCreationKeysDecodeErrorZ*)(owner & ~1);
	LDKTxCreationKeys ret_var = CResult_TxCreationKeysDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_TxCreationKeysDecodeErrorZ_get_err(LDKCResult_TxCreationKeysDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysDecodeErrorZ_get_err"))) TS_CResult_TxCreationKeysDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_TxCreationKeysDecodeErrorZ* owner_conv = (LDKCResult_TxCreationKeysDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_TxCreationKeysDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelPublicKeys CResult_ChannelPublicKeysDecodeErrorZ_get_ok(LDKCResult_ChannelPublicKeysDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelPublicKeys_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelPublicKeysDecodeErrorZ_get_ok"))) TS_CResult_ChannelPublicKeysDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelPublicKeysDecodeErrorZ* owner_conv = (LDKCResult_ChannelPublicKeysDecodeErrorZ*)(owner & ~1);
	LDKChannelPublicKeys ret_var = CResult_ChannelPublicKeysDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelPublicKeysDecodeErrorZ_get_err(LDKCResult_ChannelPublicKeysDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelPublicKeysDecodeErrorZ_get_err"))) TS_CResult_ChannelPublicKeysDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelPublicKeysDecodeErrorZ* owner_conv = (LDKCResult_ChannelPublicKeysDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelPublicKeysDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKTxCreationKeys CResult_TxCreationKeysErrorZ_get_ok(LDKCResult_TxCreationKeysErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return TxCreationKeys_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysErrorZ_get_ok"))) TS_CResult_TxCreationKeysErrorZ_get_ok(uint32_t owner) {
	LDKCResult_TxCreationKeysErrorZ* owner_conv = (LDKCResult_TxCreationKeysErrorZ*)(owner & ~1);
	LDKTxCreationKeys ret_var = CResult_TxCreationKeysErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline enum LDKSecp256k1Error CResult_TxCreationKeysErrorZ_get_err(LDKCResult_TxCreationKeysErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysErrorZ_get_err"))) TS_CResult_TxCreationKeysErrorZ_get_err(uint32_t owner) {
	LDKCResult_TxCreationKeysErrorZ* owner_conv = (LDKCResult_TxCreationKeysErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKSecp256k1Error_to_js(CResult_TxCreationKeysErrorZ_get_err(owner_conv));
	return ret_conv;
}

uint32_t __attribute__((export_name("TS_LDKCOption_u32Z_ty_from_ptr"))) TS_LDKCOption_u32Z_ty_from_ptr(uint32_t ptr) {
	LDKCOption_u32Z *obj = (LDKCOption_u32Z*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_u32Z_Some: return 0;
		case LDKCOption_u32Z_None: return 1;
		default: abort();
	}
}
int32_t __attribute__((export_name("TS_LDKCOption_u32Z_Some_get_some"))) TS_LDKCOption_u32Z_Some_get_some(uint32_t ptr) {
	LDKCOption_u32Z *obj = (LDKCOption_u32Z*)(ptr & ~1);
	assert(obj->tag == LDKCOption_u32Z_Some);
	return obj->some;
}
static inline struct LDKHTLCOutputInCommitment CResult_HTLCOutputInCommitmentDecodeErrorZ_get_ok(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return HTLCOutputInCommitment_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_get_ok"))) TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* owner_conv = (LDKCResult_HTLCOutputInCommitmentDecodeErrorZ*)(owner & ~1);
	LDKHTLCOutputInCommitment ret_var = CResult_HTLCOutputInCommitmentDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_HTLCOutputInCommitmentDecodeErrorZ_get_err(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_get_err"))) TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* owner_conv = (LDKCResult_HTLCOutputInCommitmentDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_HTLCOutputInCommitmentDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKCounterpartyChannelTransactionParameters CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_get_ok(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return CounterpartyChannelTransactionParameters_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_get_ok"))) TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* owner_conv = (LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ*)(owner & ~1);
	LDKCounterpartyChannelTransactionParameters ret_var = CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_get_err(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_get_err"))) TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* owner_conv = (LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelTransactionParameters CResult_ChannelTransactionParametersDecodeErrorZ_get_ok(LDKCResult_ChannelTransactionParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelTransactionParameters_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelTransactionParametersDecodeErrorZ_get_ok"))) TS_CResult_ChannelTransactionParametersDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* owner_conv = (LDKCResult_ChannelTransactionParametersDecodeErrorZ*)(owner & ~1);
	LDKChannelTransactionParameters ret_var = CResult_ChannelTransactionParametersDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelTransactionParametersDecodeErrorZ_get_err(LDKCResult_ChannelTransactionParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelTransactionParametersDecodeErrorZ_get_err"))) TS_CResult_ChannelTransactionParametersDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* owner_conv = (LDKCResult_ChannelTransactionParametersDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelTransactionParametersDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKHolderCommitmentTransaction CResult_HolderCommitmentTransactionDecodeErrorZ_get_ok(LDKCResult_HolderCommitmentTransactionDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return HolderCommitmentTransaction_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_HolderCommitmentTransactionDecodeErrorZ_get_ok"))) TS_CResult_HolderCommitmentTransactionDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* owner_conv = (LDKCResult_HolderCommitmentTransactionDecodeErrorZ*)(owner & ~1);
	LDKHolderCommitmentTransaction ret_var = CResult_HolderCommitmentTransactionDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_HolderCommitmentTransactionDecodeErrorZ_get_err(LDKCResult_HolderCommitmentTransactionDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_HolderCommitmentTransactionDecodeErrorZ_get_err"))) TS_CResult_HolderCommitmentTransactionDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* owner_conv = (LDKCResult_HolderCommitmentTransactionDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_HolderCommitmentTransactionDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKBuiltCommitmentTransaction CResult_BuiltCommitmentTransactionDecodeErrorZ_get_ok(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return BuiltCommitmentTransaction_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_get_ok"))) TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* owner_conv = (LDKCResult_BuiltCommitmentTransactionDecodeErrorZ*)(owner & ~1);
	LDKBuiltCommitmentTransaction ret_var = CResult_BuiltCommitmentTransactionDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_BuiltCommitmentTransactionDecodeErrorZ_get_err(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_get_err"))) TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* owner_conv = (LDKCResult_BuiltCommitmentTransactionDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_BuiltCommitmentTransactionDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKTrustedClosingTransaction *CResult_TrustedClosingTransactionNoneZ_get_ok(LDKCResult_TrustedClosingTransactionNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return &*owner->contents.result;
}
uint32_t  __attribute__((export_name("TS_CResult_TrustedClosingTransactionNoneZ_get_ok"))) TS_CResult_TrustedClosingTransactionNoneZ_get_ok(uint32_t owner) {
	LDKCResult_TrustedClosingTransactionNoneZ* owner_conv = (LDKCResult_TrustedClosingTransactionNoneZ*)(owner & ~1);
	LDKTrustedClosingTransaction ret_var = *CResult_TrustedClosingTransactionNoneZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner & ~1;
	return ret_ref;
}

static inline void CResult_TrustedClosingTransactionNoneZ_get_err(LDKCResult_TrustedClosingTransactionNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_TrustedClosingTransactionNoneZ_get_err"))) TS_CResult_TrustedClosingTransactionNoneZ_get_err(uint32_t owner) {
	LDKCResult_TrustedClosingTransactionNoneZ* owner_conv = (LDKCResult_TrustedClosingTransactionNoneZ*)(owner & ~1);
	CResult_TrustedClosingTransactionNoneZ_get_err(owner_conv);
}

static inline struct LDKCommitmentTransaction CResult_CommitmentTransactionDecodeErrorZ_get_ok(LDKCResult_CommitmentTransactionDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return CommitmentTransaction_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_CommitmentTransactionDecodeErrorZ_get_ok"))) TS_CResult_CommitmentTransactionDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_CommitmentTransactionDecodeErrorZ* owner_conv = (LDKCResult_CommitmentTransactionDecodeErrorZ*)(owner & ~1);
	LDKCommitmentTransaction ret_var = CResult_CommitmentTransactionDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_CommitmentTransactionDecodeErrorZ_get_err(LDKCResult_CommitmentTransactionDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_CommitmentTransactionDecodeErrorZ_get_err"))) TS_CResult_CommitmentTransactionDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_CommitmentTransactionDecodeErrorZ* owner_conv = (LDKCResult_CommitmentTransactionDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_CommitmentTransactionDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKTrustedCommitmentTransaction *CResult_TrustedCommitmentTransactionNoneZ_get_ok(LDKCResult_TrustedCommitmentTransactionNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return &*owner->contents.result;
}
uint32_t  __attribute__((export_name("TS_CResult_TrustedCommitmentTransactionNoneZ_get_ok"))) TS_CResult_TrustedCommitmentTransactionNoneZ_get_ok(uint32_t owner) {
	LDKCResult_TrustedCommitmentTransactionNoneZ* owner_conv = (LDKCResult_TrustedCommitmentTransactionNoneZ*)(owner & ~1);
	LDKTrustedCommitmentTransaction ret_var = *CResult_TrustedCommitmentTransactionNoneZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner & ~1;
	return ret_ref;
}

static inline void CResult_TrustedCommitmentTransactionNoneZ_get_err(LDKCResult_TrustedCommitmentTransactionNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_TrustedCommitmentTransactionNoneZ_get_err"))) TS_CResult_TrustedCommitmentTransactionNoneZ_get_err(uint32_t owner) {
	LDKCResult_TrustedCommitmentTransactionNoneZ* owner_conv = (LDKCResult_TrustedCommitmentTransactionNoneZ*)(owner & ~1);
	CResult_TrustedCommitmentTransactionNoneZ_get_err(owner_conv);
}

static inline struct LDKCVec_SignatureZ CResult_CVec_SignatureZNoneZ_get_ok(LDKCResult_CVec_SignatureZNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
ptrArray  __attribute__((export_name("TS_CResult_CVec_SignatureZNoneZ_get_ok"))) TS_CResult_CVec_SignatureZNoneZ_get_ok(uint32_t owner) {
	LDKCResult_CVec_SignatureZNoneZ* owner_conv = (LDKCResult_CVec_SignatureZNoneZ*)(owner & ~1);
	LDKCVec_SignatureZ ret_var = CResult_CVec_SignatureZNoneZ_get_ok(owner_conv);
	ptrArray ret_arr = NULL;
	ret_arr = init_ptrArray(ret_var.datalen, __LINE__);
	int8_tArray *ret_arr_ptr = (int8_tArray*)(((uint8_t*)ret_arr) + 4);
	for (size_t m = 0; m < ret_var.datalen; m++) {
		int8_tArray ret_conv_12_arr = init_int8_tArray(64, __LINE__);
		memcpy(ret_conv_12_arr->elems, ret_var.data[m].compact_form, 64);
		ret_arr_ptr[m] = ret_conv_12_arr;
	}
	
	return ret_arr;
}

static inline void CResult_CVec_SignatureZNoneZ_get_err(LDKCResult_CVec_SignatureZNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_CVec_SignatureZNoneZ_get_err"))) TS_CResult_CVec_SignatureZNoneZ_get_err(uint32_t owner) {
	LDKCResult_CVec_SignatureZNoneZ* owner_conv = (LDKCResult_CVec_SignatureZNoneZ*)(owner & ~1);
	CResult_CVec_SignatureZNoneZ_get_err(owner_conv);
}

static inline struct LDKShutdownScript CResult_ShutdownScriptDecodeErrorZ_get_ok(LDKCResult_ShutdownScriptDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ShutdownScript_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptDecodeErrorZ_get_ok"))) TS_CResult_ShutdownScriptDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ShutdownScriptDecodeErrorZ* owner_conv = (LDKCResult_ShutdownScriptDecodeErrorZ*)(owner & ~1);
	LDKShutdownScript ret_var = CResult_ShutdownScriptDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ShutdownScriptDecodeErrorZ_get_err(LDKCResult_ShutdownScriptDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptDecodeErrorZ_get_err"))) TS_CResult_ShutdownScriptDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ShutdownScriptDecodeErrorZ* owner_conv = (LDKCResult_ShutdownScriptDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ShutdownScriptDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKShutdownScript CResult_ShutdownScriptInvalidShutdownScriptZ_get_ok(LDKCResult_ShutdownScriptInvalidShutdownScriptZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ShutdownScript_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptInvalidShutdownScriptZ_get_ok"))) TS_CResult_ShutdownScriptInvalidShutdownScriptZ_get_ok(uint32_t owner) {
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* owner_conv = (LDKCResult_ShutdownScriptInvalidShutdownScriptZ*)(owner & ~1);
	LDKShutdownScript ret_var = CResult_ShutdownScriptInvalidShutdownScriptZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKInvalidShutdownScript CResult_ShutdownScriptInvalidShutdownScriptZ_get_err(LDKCResult_ShutdownScriptInvalidShutdownScriptZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return InvalidShutdownScript_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptInvalidShutdownScriptZ_get_err"))) TS_CResult_ShutdownScriptInvalidShutdownScriptZ_get_err(uint32_t owner) {
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* owner_conv = (LDKCResult_ShutdownScriptInvalidShutdownScriptZ*)(owner & ~1);
	LDKInvalidShutdownScript ret_var = CResult_ShutdownScriptInvalidShutdownScriptZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKRouteHop CResult_RouteHopDecodeErrorZ_get_ok(LDKCResult_RouteHopDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return RouteHop_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHopDecodeErrorZ_get_ok"))) TS_CResult_RouteHopDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_RouteHopDecodeErrorZ* owner_conv = (LDKCResult_RouteHopDecodeErrorZ*)(owner & ~1);
	LDKRouteHop ret_var = CResult_RouteHopDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_RouteHopDecodeErrorZ_get_err(LDKCResult_RouteHopDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHopDecodeErrorZ_get_err"))) TS_CResult_RouteHopDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_RouteHopDecodeErrorZ* owner_conv = (LDKCResult_RouteHopDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_RouteHopDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_RouteHopZ CVec_RouteHopZ_clone(const LDKCVec_RouteHopZ *orig) {
	LDKCVec_RouteHopZ ret = { .data = MALLOC(sizeof(LDKRouteHop) * orig->datalen, "LDKCVec_RouteHopZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = RouteHop_clone(&orig->data[i]);
	}
	return ret;
}
static inline LDKCVec_CVec_RouteHopZZ CVec_CVec_RouteHopZZ_clone(const LDKCVec_CVec_RouteHopZZ *orig) {
	LDKCVec_CVec_RouteHopZZ ret = { .data = MALLOC(sizeof(LDKCVec_RouteHopZ) * orig->datalen, "LDKCVec_CVec_RouteHopZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = CVec_RouteHopZ_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKRoute CResult_RouteDecodeErrorZ_get_ok(LDKCResult_RouteDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Route_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteDecodeErrorZ_get_ok"))) TS_CResult_RouteDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_RouteDecodeErrorZ* owner_conv = (LDKCResult_RouteDecodeErrorZ*)(owner & ~1);
	LDKRoute ret_var = CResult_RouteDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_RouteDecodeErrorZ_get_err(LDKCResult_RouteDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteDecodeErrorZ_get_err"))) TS_CResult_RouteDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_RouteDecodeErrorZ* owner_conv = (LDKCResult_RouteDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_RouteDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKRouteParameters CResult_RouteParametersDecodeErrorZ_get_ok(LDKCResult_RouteParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return RouteParameters_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteParametersDecodeErrorZ_get_ok"))) TS_CResult_RouteParametersDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_RouteParametersDecodeErrorZ* owner_conv = (LDKCResult_RouteParametersDecodeErrorZ*)(owner & ~1);
	LDKRouteParameters ret_var = CResult_RouteParametersDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_RouteParametersDecodeErrorZ_get_err(LDKCResult_RouteParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteParametersDecodeErrorZ_get_err"))) TS_CResult_RouteParametersDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_RouteParametersDecodeErrorZ* owner_conv = (LDKCResult_RouteParametersDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_RouteParametersDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_RouteHintZ CVec_RouteHintZ_clone(const LDKCVec_RouteHintZ *orig) {
	LDKCVec_RouteHintZ ret = { .data = MALLOC(sizeof(LDKRouteHint) * orig->datalen, "LDKCVec_RouteHintZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = RouteHint_clone(&orig->data[i]);
	}
	return ret;
}
uint32_t __attribute__((export_name("TS_LDKCOption_u64Z_ty_from_ptr"))) TS_LDKCOption_u64Z_ty_from_ptr(uint32_t ptr) {
	LDKCOption_u64Z *obj = (LDKCOption_u64Z*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_u64Z_Some: return 0;
		case LDKCOption_u64Z_None: return 1;
		default: abort();
	}
}
int64_t __attribute__((export_name("TS_LDKCOption_u64Z_Some_get_some"))) TS_LDKCOption_u64Z_Some_get_some(uint32_t ptr) {
	LDKCOption_u64Z *obj = (LDKCOption_u64Z*)(ptr & ~1);
	assert(obj->tag == LDKCOption_u64Z_Some);
	return obj->some;
}
static inline struct LDKPaymentParameters CResult_PaymentParametersDecodeErrorZ_get_ok(LDKCResult_PaymentParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return PaymentParameters_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentParametersDecodeErrorZ_get_ok"))) TS_CResult_PaymentParametersDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PaymentParametersDecodeErrorZ* owner_conv = (LDKCResult_PaymentParametersDecodeErrorZ*)(owner & ~1);
	LDKPaymentParameters ret_var = CResult_PaymentParametersDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_PaymentParametersDecodeErrorZ_get_err(LDKCResult_PaymentParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentParametersDecodeErrorZ_get_err"))) TS_CResult_PaymentParametersDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_PaymentParametersDecodeErrorZ* owner_conv = (LDKCResult_PaymentParametersDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_PaymentParametersDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_RouteHintHopZ CVec_RouteHintHopZ_clone(const LDKCVec_RouteHintHopZ *orig) {
	LDKCVec_RouteHintHopZ ret = { .data = MALLOC(sizeof(LDKRouteHintHop) * orig->datalen, "LDKCVec_RouteHintHopZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = RouteHintHop_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKRouteHint CResult_RouteHintDecodeErrorZ_get_ok(LDKCResult_RouteHintDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return RouteHint_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHintDecodeErrorZ_get_ok"))) TS_CResult_RouteHintDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_RouteHintDecodeErrorZ* owner_conv = (LDKCResult_RouteHintDecodeErrorZ*)(owner & ~1);
	LDKRouteHint ret_var = CResult_RouteHintDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_RouteHintDecodeErrorZ_get_err(LDKCResult_RouteHintDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHintDecodeErrorZ_get_err"))) TS_CResult_RouteHintDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_RouteHintDecodeErrorZ* owner_conv = (LDKCResult_RouteHintDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_RouteHintDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKRouteHintHop CResult_RouteHintHopDecodeErrorZ_get_ok(LDKCResult_RouteHintHopDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return RouteHintHop_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHintHopDecodeErrorZ_get_ok"))) TS_CResult_RouteHintHopDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_RouteHintHopDecodeErrorZ* owner_conv = (LDKCResult_RouteHintHopDecodeErrorZ*)(owner & ~1);
	LDKRouteHintHop ret_var = CResult_RouteHintHopDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_RouteHintHopDecodeErrorZ_get_err(LDKCResult_RouteHintHopDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHintHopDecodeErrorZ_get_err"))) TS_CResult_RouteHintHopDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_RouteHintHopDecodeErrorZ* owner_conv = (LDKCResult_RouteHintHopDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_RouteHintHopDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_ChannelDetailsZ CVec_ChannelDetailsZ_clone(const LDKCVec_ChannelDetailsZ *orig) {
	LDKCVec_ChannelDetailsZ ret = { .data = MALLOC(sizeof(LDKChannelDetails) * orig->datalen, "LDKCVec_ChannelDetailsZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = ChannelDetails_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKRoute CResult_RouteLightningErrorZ_get_ok(LDKCResult_RouteLightningErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Route_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteLightningErrorZ_get_ok"))) TS_CResult_RouteLightningErrorZ_get_ok(uint32_t owner) {
	LDKCResult_RouteLightningErrorZ* owner_conv = (LDKCResult_RouteLightningErrorZ*)(owner & ~1);
	LDKRoute ret_var = CResult_RouteLightningErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKLightningError CResult_RouteLightningErrorZ_get_err(LDKCResult_RouteLightningErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return LightningError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_RouteLightningErrorZ_get_err"))) TS_CResult_RouteLightningErrorZ_get_err(uint32_t owner) {
	LDKCResult_RouteLightningErrorZ* owner_conv = (LDKCResult_RouteLightningErrorZ*)(owner & ~1);
	LDKLightningError ret_var = CResult_RouteLightningErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKTxOut CResult_TxOutAccessErrorZ_get_ok(LDKCResult_TxOutAccessErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return TxOut_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_TxOutAccessErrorZ_get_ok"))) TS_CResult_TxOutAccessErrorZ_get_ok(uint32_t owner) {
	LDKCResult_TxOutAccessErrorZ* owner_conv = (LDKCResult_TxOutAccessErrorZ*)(owner & ~1);
	LDKTxOut* ret_ref = MALLOC(sizeof(LDKTxOut), "LDKTxOut");
	*ret_ref = CResult_TxOutAccessErrorZ_get_ok(owner_conv);
	return (uint32_t)ret_ref;
}

static inline enum LDKAccessError CResult_TxOutAccessErrorZ_get_err(LDKCResult_TxOutAccessErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return AccessError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_TxOutAccessErrorZ_get_err"))) TS_CResult_TxOutAccessErrorZ_get_err(uint32_t owner) {
	LDKCResult_TxOutAccessErrorZ* owner_conv = (LDKCResult_TxOutAccessErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKAccessError_to_js(CResult_TxOutAccessErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline uintptr_t C2Tuple_usizeTransactionZ_get_a(LDKC2Tuple_usizeTransactionZ *NONNULL_PTR owner){
	return owner->a;
}
uint32_t  __attribute__((export_name("TS_C2Tuple_usizeTransactionZ_get_a"))) TS_C2Tuple_usizeTransactionZ_get_a(uint32_t owner) {
	LDKC2Tuple_usizeTransactionZ* owner_conv = (LDKC2Tuple_usizeTransactionZ*)(owner & ~1);
	uint32_t ret_val = C2Tuple_usizeTransactionZ_get_a(owner_conv);
	return ret_val;
}

static inline struct LDKTransaction C2Tuple_usizeTransactionZ_get_b(LDKC2Tuple_usizeTransactionZ *NONNULL_PTR owner){
	return owner->b;
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_usizeTransactionZ_get_b"))) TS_C2Tuple_usizeTransactionZ_get_b(uint32_t owner) {
	LDKC2Tuple_usizeTransactionZ* owner_conv = (LDKC2Tuple_usizeTransactionZ*)(owner & ~1);
	LDKTransaction ret_var = C2Tuple_usizeTransactionZ_get_b(owner_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	return ret_arr;
}

static inline LDKCVec_C2Tuple_usizeTransactionZZ CVec_C2Tuple_usizeTransactionZZ_clone(const LDKCVec_C2Tuple_usizeTransactionZZ *orig) {
	LDKCVec_C2Tuple_usizeTransactionZZ ret = { .data = MALLOC(sizeof(LDKC2Tuple_usizeTransactionZ) * orig->datalen, "LDKCVec_C2Tuple_usizeTransactionZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = C2Tuple_usizeTransactionZ_clone(&orig->data[i]);
	}
	return ret;
}
static inline LDKCVec_TxidZ CVec_TxidZ_clone(const LDKCVec_TxidZ *orig) {
	LDKCVec_TxidZ ret = { .data = MALLOC(sizeof(LDKThirtyTwoBytes) * orig->datalen, "LDKCVec_TxidZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = ThirtyTwoBytes_clone(&orig->data[i]);
	}
	return ret;
}
static inline void CResult_NoneChannelMonitorUpdateErrZ_get_ok(LDKCResult_NoneChannelMonitorUpdateErrZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
void  __attribute__((export_name("TS_CResult_NoneChannelMonitorUpdateErrZ_get_ok"))) TS_CResult_NoneChannelMonitorUpdateErrZ_get_ok(uint32_t owner) {
	LDKCResult_NoneChannelMonitorUpdateErrZ* owner_conv = (LDKCResult_NoneChannelMonitorUpdateErrZ*)(owner & ~1);
	CResult_NoneChannelMonitorUpdateErrZ_get_ok(owner_conv);
}

static inline enum LDKChannelMonitorUpdateErr CResult_NoneChannelMonitorUpdateErrZ_get_err(LDKCResult_NoneChannelMonitorUpdateErrZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return ChannelMonitorUpdateErr_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NoneChannelMonitorUpdateErrZ_get_err"))) TS_CResult_NoneChannelMonitorUpdateErrZ_get_err(uint32_t owner) {
	LDKCResult_NoneChannelMonitorUpdateErrZ* owner_conv = (LDKCResult_NoneChannelMonitorUpdateErrZ*)(owner & ~1);
	uint32_t ret_conv = LDKChannelMonitorUpdateErr_to_js(CResult_NoneChannelMonitorUpdateErrZ_get_err(owner_conv));
	return ret_conv;
}

uint32_t __attribute__((export_name("TS_LDKMonitorEvent_ty_from_ptr"))) TS_LDKMonitorEvent_ty_from_ptr(uint32_t ptr) {
	LDKMonitorEvent *obj = (LDKMonitorEvent*)(ptr & ~1);
	switch(obj->tag) {
		case LDKMonitorEvent_HTLCEvent: return 0;
		case LDKMonitorEvent_CommitmentTxConfirmed: return 1;
		case LDKMonitorEvent_UpdateCompleted: return 2;
		case LDKMonitorEvent_UpdateFailed: return 3;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKMonitorEvent_HTLCEvent_get_htlc_event"))) TS_LDKMonitorEvent_HTLCEvent_get_htlc_event(uint32_t ptr) {
	LDKMonitorEvent *obj = (LDKMonitorEvent*)(ptr & ~1);
	assert(obj->tag == LDKMonitorEvent_HTLCEvent);
			LDKHTLCUpdate htlc_event_var = obj->htlc_event;
			uint32_t htlc_event_ref = 0;
			CHECK((((uintptr_t)htlc_event_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&htlc_event_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(htlc_event_var);
			htlc_event_ref = (uintptr_t)htlc_event_var.inner & ~1;
	return htlc_event_ref;
}
uint32_t __attribute__((export_name("TS_LDKMonitorEvent_CommitmentTxConfirmed_get_commitment_tx_confirmed"))) TS_LDKMonitorEvent_CommitmentTxConfirmed_get_commitment_tx_confirmed(uint32_t ptr) {
	LDKMonitorEvent *obj = (LDKMonitorEvent*)(ptr & ~1);
	assert(obj->tag == LDKMonitorEvent_CommitmentTxConfirmed);
			LDKOutPoint commitment_tx_confirmed_var = obj->commitment_tx_confirmed;
			uint32_t commitment_tx_confirmed_ref = 0;
			CHECK((((uintptr_t)commitment_tx_confirmed_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&commitment_tx_confirmed_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(commitment_tx_confirmed_var);
			commitment_tx_confirmed_ref = (uintptr_t)commitment_tx_confirmed_var.inner & ~1;
	return commitment_tx_confirmed_ref;
}
uint32_t __attribute__((export_name("TS_LDKMonitorEvent_UpdateCompleted_get_funding_txo"))) TS_LDKMonitorEvent_UpdateCompleted_get_funding_txo(uint32_t ptr) {
	LDKMonitorEvent *obj = (LDKMonitorEvent*)(ptr & ~1);
	assert(obj->tag == LDKMonitorEvent_UpdateCompleted);
			LDKOutPoint funding_txo_var = obj->update_completed.funding_txo;
			uint32_t funding_txo_ref = 0;
			CHECK((((uintptr_t)funding_txo_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&funding_txo_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_var);
			funding_txo_ref = (uintptr_t)funding_txo_var.inner & ~1;
	return funding_txo_ref;
}
int64_t __attribute__((export_name("TS_LDKMonitorEvent_UpdateCompleted_get_monitor_update_id"))) TS_LDKMonitorEvent_UpdateCompleted_get_monitor_update_id(uint32_t ptr) {
	LDKMonitorEvent *obj = (LDKMonitorEvent*)(ptr & ~1);
	assert(obj->tag == LDKMonitorEvent_UpdateCompleted);
	return obj->update_completed.monitor_update_id;
}
uint32_t __attribute__((export_name("TS_LDKMonitorEvent_UpdateFailed_get_update_failed"))) TS_LDKMonitorEvent_UpdateFailed_get_update_failed(uint32_t ptr) {
	LDKMonitorEvent *obj = (LDKMonitorEvent*)(ptr & ~1);
	assert(obj->tag == LDKMonitorEvent_UpdateFailed);
			LDKOutPoint update_failed_var = obj->update_failed;
			uint32_t update_failed_ref = 0;
			CHECK((((uintptr_t)update_failed_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&update_failed_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(update_failed_var);
			update_failed_ref = (uintptr_t)update_failed_var.inner & ~1;
	return update_failed_ref;
}
static inline LDKCVec_MonitorEventZ CVec_MonitorEventZ_clone(const LDKCVec_MonitorEventZ *orig) {
	LDKCVec_MonitorEventZ ret = { .data = MALLOC(sizeof(LDKMonitorEvent) * orig->datalen, "LDKCVec_MonitorEventZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = MonitorEvent_clone(&orig->data[i]);
	}
	return ret;
}
uint32_t __attribute__((export_name("TS_LDKCOption_C2Tuple_usizeTransactionZZ_ty_from_ptr"))) TS_LDKCOption_C2Tuple_usizeTransactionZZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_C2Tuple_usizeTransactionZZ *obj = (LDKCOption_C2Tuple_usizeTransactionZZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_C2Tuple_usizeTransactionZZ_Some: return 0;
		case LDKCOption_C2Tuple_usizeTransactionZZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_C2Tuple_usizeTransactionZZ_Some_get_some"))) TS_LDKCOption_C2Tuple_usizeTransactionZZ_Some_get_some(uint32_t ptr) {
	LDKCOption_C2Tuple_usizeTransactionZZ *obj = (LDKCOption_C2Tuple_usizeTransactionZZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_C2Tuple_usizeTransactionZZ_Some);
			LDKC2Tuple_usizeTransactionZ* some_conv = MALLOC(sizeof(LDKC2Tuple_usizeTransactionZ), "LDKC2Tuple_usizeTransactionZ");
			*some_conv = obj->some;
			*some_conv = C2Tuple_usizeTransactionZ_clone(some_conv);
	return ((uint32_t)some_conv);
}
uint32_t __attribute__((export_name("TS_LDKClosureReason_ty_from_ptr"))) TS_LDKClosureReason_ty_from_ptr(uint32_t ptr) {
	LDKClosureReason *obj = (LDKClosureReason*)(ptr & ~1);
	switch(obj->tag) {
		case LDKClosureReason_CounterpartyForceClosed: return 0;
		case LDKClosureReason_HolderForceClosed: return 1;
		case LDKClosureReason_CooperativeClosure: return 2;
		case LDKClosureReason_CommitmentTxConfirmed: return 3;
		case LDKClosureReason_FundingTimedOut: return 4;
		case LDKClosureReason_ProcessingError: return 5;
		case LDKClosureReason_DisconnectedPeer: return 6;
		case LDKClosureReason_OutdatedChannelManager: return 7;
		default: abort();
	}
}
jstring __attribute__((export_name("TS_LDKClosureReason_CounterpartyForceClosed_get_peer_msg"))) TS_LDKClosureReason_CounterpartyForceClosed_get_peer_msg(uint32_t ptr) {
	LDKClosureReason *obj = (LDKClosureReason*)(ptr & ~1);
	assert(obj->tag == LDKClosureReason_CounterpartyForceClosed);
			LDKStr peer_msg_str = obj->counterparty_force_closed.peer_msg;
			jstring peer_msg_conv = str_ref_to_ts(peer_msg_str.chars, peer_msg_str.len);
	return peer_msg_conv;
}
jstring __attribute__((export_name("TS_LDKClosureReason_ProcessingError_get_err"))) TS_LDKClosureReason_ProcessingError_get_err(uint32_t ptr) {
	LDKClosureReason *obj = (LDKClosureReason*)(ptr & ~1);
	assert(obj->tag == LDKClosureReason_ProcessingError);
			LDKStr err_str = obj->processing_error.err;
			jstring err_conv = str_ref_to_ts(err_str.chars, err_str.len);
	return err_conv;
}
uint32_t __attribute__((export_name("TS_LDKCOption_ClosureReasonZ_ty_from_ptr"))) TS_LDKCOption_ClosureReasonZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_ClosureReasonZ *obj = (LDKCOption_ClosureReasonZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_ClosureReasonZ_Some: return 0;
		case LDKCOption_ClosureReasonZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_ClosureReasonZ_Some_get_some"))) TS_LDKCOption_ClosureReasonZ_Some_get_some(uint32_t ptr) {
	LDKCOption_ClosureReasonZ *obj = (LDKCOption_ClosureReasonZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_ClosureReasonZ_Some);
			uint32_t some_ref = ((uintptr_t)&obj->some) | 1;
	return some_ref;
}
static inline struct LDKCOption_ClosureReasonZ CResult_COption_ClosureReasonZDecodeErrorZ_get_ok(LDKCResult_COption_ClosureReasonZDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return COption_ClosureReasonZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_ClosureReasonZDecodeErrorZ_get_ok"))) TS_CResult_COption_ClosureReasonZDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* owner_conv = (LDKCResult_COption_ClosureReasonZDecodeErrorZ*)(owner & ~1);
	LDKCOption_ClosureReasonZ *ret_copy = MALLOC(sizeof(LDKCOption_ClosureReasonZ), "LDKCOption_ClosureReasonZ");
	*ret_copy = CResult_COption_ClosureReasonZDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_COption_ClosureReasonZDecodeErrorZ_get_err(LDKCResult_COption_ClosureReasonZDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_ClosureReasonZDecodeErrorZ_get_err"))) TS_CResult_COption_ClosureReasonZDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* owner_conv = (LDKCResult_COption_ClosureReasonZDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_COption_ClosureReasonZDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKNetworkUpdate_ty_from_ptr"))) TS_LDKNetworkUpdate_ty_from_ptr(uint32_t ptr) {
	LDKNetworkUpdate *obj = (LDKNetworkUpdate*)(ptr & ~1);
	switch(obj->tag) {
		case LDKNetworkUpdate_ChannelUpdateMessage: return 0;
		case LDKNetworkUpdate_ChannelClosed: return 1;
		case LDKNetworkUpdate_NodeFailure: return 2;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKNetworkUpdate_ChannelUpdateMessage_get_msg"))) TS_LDKNetworkUpdate_ChannelUpdateMessage_get_msg(uint32_t ptr) {
	LDKNetworkUpdate *obj = (LDKNetworkUpdate*)(ptr & ~1);
	assert(obj->tag == LDKNetworkUpdate_ChannelUpdateMessage);
			LDKChannelUpdate msg_var = obj->channel_update_message.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int64_t __attribute__((export_name("TS_LDKNetworkUpdate_ChannelClosed_get_short_channel_id"))) TS_LDKNetworkUpdate_ChannelClosed_get_short_channel_id(uint32_t ptr) {
	LDKNetworkUpdate *obj = (LDKNetworkUpdate*)(ptr & ~1);
	assert(obj->tag == LDKNetworkUpdate_ChannelClosed);
	return obj->channel_closed.short_channel_id;
}
jboolean __attribute__((export_name("TS_LDKNetworkUpdate_ChannelClosed_get_is_permanent"))) TS_LDKNetworkUpdate_ChannelClosed_get_is_permanent(uint32_t ptr) {
	LDKNetworkUpdate *obj = (LDKNetworkUpdate*)(ptr & ~1);
	assert(obj->tag == LDKNetworkUpdate_ChannelClosed);
	return obj->channel_closed.is_permanent;
}
int8_tArray __attribute__((export_name("TS_LDKNetworkUpdate_NodeFailure_get_node_id"))) TS_LDKNetworkUpdate_NodeFailure_get_node_id(uint32_t ptr) {
	LDKNetworkUpdate *obj = (LDKNetworkUpdate*)(ptr & ~1);
	assert(obj->tag == LDKNetworkUpdate_NodeFailure);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->node_failure.node_id.compressed_form, 33);
	return node_id_arr;
}
jboolean __attribute__((export_name("TS_LDKNetworkUpdate_NodeFailure_get_is_permanent"))) TS_LDKNetworkUpdate_NodeFailure_get_is_permanent(uint32_t ptr) {
	LDKNetworkUpdate *obj = (LDKNetworkUpdate*)(ptr & ~1);
	assert(obj->tag == LDKNetworkUpdate_NodeFailure);
	return obj->node_failure.is_permanent;
}
uint32_t __attribute__((export_name("TS_LDKCOption_NetworkUpdateZ_ty_from_ptr"))) TS_LDKCOption_NetworkUpdateZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_NetworkUpdateZ *obj = (LDKCOption_NetworkUpdateZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_NetworkUpdateZ_Some: return 0;
		case LDKCOption_NetworkUpdateZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_NetworkUpdateZ_Some_get_some"))) TS_LDKCOption_NetworkUpdateZ_Some_get_some(uint32_t ptr) {
	LDKCOption_NetworkUpdateZ *obj = (LDKCOption_NetworkUpdateZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_NetworkUpdateZ_Some);
			uint32_t some_ref = ((uintptr_t)&obj->some) | 1;
	return some_ref;
}
uint32_t __attribute__((export_name("TS_LDKSpendableOutputDescriptor_ty_from_ptr"))) TS_LDKSpendableOutputDescriptor_ty_from_ptr(uint32_t ptr) {
	LDKSpendableOutputDescriptor *obj = (LDKSpendableOutputDescriptor*)(ptr & ~1);
	switch(obj->tag) {
		case LDKSpendableOutputDescriptor_StaticOutput: return 0;
		case LDKSpendableOutputDescriptor_DelayedPaymentOutput: return 1;
		case LDKSpendableOutputDescriptor_StaticPaymentOutput: return 2;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKSpendableOutputDescriptor_StaticOutput_get_outpoint"))) TS_LDKSpendableOutputDescriptor_StaticOutput_get_outpoint(uint32_t ptr) {
	LDKSpendableOutputDescriptor *obj = (LDKSpendableOutputDescriptor*)(ptr & ~1);
	assert(obj->tag == LDKSpendableOutputDescriptor_StaticOutput);
			LDKOutPoint outpoint_var = obj->static_output.outpoint;
			uint32_t outpoint_ref = 0;
			CHECK((((uintptr_t)outpoint_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&outpoint_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(outpoint_var);
			outpoint_ref = (uintptr_t)outpoint_var.inner & ~1;
	return outpoint_ref;
}
uint32_t __attribute__((export_name("TS_LDKSpendableOutputDescriptor_StaticOutput_get_output"))) TS_LDKSpendableOutputDescriptor_StaticOutput_get_output(uint32_t ptr) {
	LDKSpendableOutputDescriptor *obj = (LDKSpendableOutputDescriptor*)(ptr & ~1);
	assert(obj->tag == LDKSpendableOutputDescriptor_StaticOutput);
			uint32_t output_ref = ((uintptr_t)&obj->static_output.output) | 1;
	return (uint32_t)output_ref;
}
uint32_t __attribute__((export_name("TS_LDKSpendableOutputDescriptor_DelayedPaymentOutput_get_delayed_payment_output"))) TS_LDKSpendableOutputDescriptor_DelayedPaymentOutput_get_delayed_payment_output(uint32_t ptr) {
	LDKSpendableOutputDescriptor *obj = (LDKSpendableOutputDescriptor*)(ptr & ~1);
	assert(obj->tag == LDKSpendableOutputDescriptor_DelayedPaymentOutput);
			LDKDelayedPaymentOutputDescriptor delayed_payment_output_var = obj->delayed_payment_output;
			uint32_t delayed_payment_output_ref = 0;
			CHECK((((uintptr_t)delayed_payment_output_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&delayed_payment_output_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(delayed_payment_output_var);
			delayed_payment_output_ref = (uintptr_t)delayed_payment_output_var.inner & ~1;
	return delayed_payment_output_ref;
}
uint32_t __attribute__((export_name("TS_LDKSpendableOutputDescriptor_StaticPaymentOutput_get_static_payment_output"))) TS_LDKSpendableOutputDescriptor_StaticPaymentOutput_get_static_payment_output(uint32_t ptr) {
	LDKSpendableOutputDescriptor *obj = (LDKSpendableOutputDescriptor*)(ptr & ~1);
	assert(obj->tag == LDKSpendableOutputDescriptor_StaticPaymentOutput);
			LDKStaticPaymentOutputDescriptor static_payment_output_var = obj->static_payment_output;
			uint32_t static_payment_output_ref = 0;
			CHECK((((uintptr_t)static_payment_output_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&static_payment_output_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(static_payment_output_var);
			static_payment_output_ref = (uintptr_t)static_payment_output_var.inner & ~1;
	return static_payment_output_ref;
}
static inline LDKCVec_SpendableOutputDescriptorZ CVec_SpendableOutputDescriptorZ_clone(const LDKCVec_SpendableOutputDescriptorZ *orig) {
	LDKCVec_SpendableOutputDescriptorZ ret = { .data = MALLOC(sizeof(LDKSpendableOutputDescriptor) * orig->datalen, "LDKCVec_SpendableOutputDescriptorZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = SpendableOutputDescriptor_clone(&orig->data[i]);
	}
	return ret;
}
uint32_t __attribute__((export_name("TS_LDKPaymentPurpose_ty_from_ptr"))) TS_LDKPaymentPurpose_ty_from_ptr(uint32_t ptr) {
	LDKPaymentPurpose *obj = (LDKPaymentPurpose*)(ptr & ~1);
	switch(obj->tag) {
		case LDKPaymentPurpose_InvoicePayment: return 0;
		case LDKPaymentPurpose_SpontaneousPayment: return 1;
		default: abort();
	}
}
int8_tArray __attribute__((export_name("TS_LDKPaymentPurpose_InvoicePayment_get_payment_preimage"))) TS_LDKPaymentPurpose_InvoicePayment_get_payment_preimage(uint32_t ptr) {
	LDKPaymentPurpose *obj = (LDKPaymentPurpose*)(ptr & ~1);
	assert(obj->tag == LDKPaymentPurpose_InvoicePayment);
			int8_tArray payment_preimage_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_preimage_arr->elems, obj->invoice_payment.payment_preimage.data, 32);
	return payment_preimage_arr;
}
int8_tArray __attribute__((export_name("TS_LDKPaymentPurpose_InvoicePayment_get_payment_secret"))) TS_LDKPaymentPurpose_InvoicePayment_get_payment_secret(uint32_t ptr) {
	LDKPaymentPurpose *obj = (LDKPaymentPurpose*)(ptr & ~1);
	assert(obj->tag == LDKPaymentPurpose_InvoicePayment);
			int8_tArray payment_secret_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_secret_arr->elems, obj->invoice_payment.payment_secret.data, 32);
	return payment_secret_arr;
}
int8_tArray __attribute__((export_name("TS_LDKPaymentPurpose_SpontaneousPayment_get_spontaneous_payment"))) TS_LDKPaymentPurpose_SpontaneousPayment_get_spontaneous_payment(uint32_t ptr) {
	LDKPaymentPurpose *obj = (LDKPaymentPurpose*)(ptr & ~1);
	assert(obj->tag == LDKPaymentPurpose_SpontaneousPayment);
			int8_tArray spontaneous_payment_arr = init_int8_tArray(32, __LINE__);
			memcpy(spontaneous_payment_arr->elems, obj->spontaneous_payment.data, 32);
	return spontaneous_payment_arr;
}
uint32_t __attribute__((export_name("TS_LDKEvent_ty_from_ptr"))) TS_LDKEvent_ty_from_ptr(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	switch(obj->tag) {
		case LDKEvent_FundingGenerationReady: return 0;
		case LDKEvent_PaymentReceived: return 1;
		case LDKEvent_PaymentSent: return 2;
		case LDKEvent_PaymentPathFailed: return 3;
		case LDKEvent_PaymentFailed: return 4;
		case LDKEvent_PendingHTLCsForwardable: return 5;
		case LDKEvent_SpendableOutputs: return 6;
		case LDKEvent_PaymentForwarded: return 7;
		case LDKEvent_ChannelClosed: return 8;
		case LDKEvent_DiscardFunding: return 9;
		case LDKEvent_PaymentPathSuccessful: return 10;
		case LDKEvent_OpenChannelRequest: return 11;
		default: abort();
	}
}
int8_tArray __attribute__((export_name("TS_LDKEvent_FundingGenerationReady_get_temporary_channel_id"))) TS_LDKEvent_FundingGenerationReady_get_temporary_channel_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_FundingGenerationReady);
			int8_tArray temporary_channel_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(temporary_channel_id_arr->elems, obj->funding_generation_ready.temporary_channel_id.data, 32);
	return temporary_channel_id_arr;
}
int64_t __attribute__((export_name("TS_LDKEvent_FundingGenerationReady_get_channel_value_satoshis"))) TS_LDKEvent_FundingGenerationReady_get_channel_value_satoshis(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_FundingGenerationReady);
	return obj->funding_generation_ready.channel_value_satoshis;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_FundingGenerationReady_get_output_script"))) TS_LDKEvent_FundingGenerationReady_get_output_script(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_FundingGenerationReady);
			LDKCVec_u8Z output_script_var = obj->funding_generation_ready.output_script;
			int8_tArray output_script_arr = init_int8_tArray(output_script_var.datalen, __LINE__);
			memcpy(output_script_arr->elems, output_script_var.data, output_script_var.datalen);
	return output_script_arr;
}
int64_t __attribute__((export_name("TS_LDKEvent_FundingGenerationReady_get_user_channel_id"))) TS_LDKEvent_FundingGenerationReady_get_user_channel_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_FundingGenerationReady);
	return obj->funding_generation_ready.user_channel_id;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentReceived_get_payment_hash"))) TS_LDKEvent_PaymentReceived_get_payment_hash(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentReceived);
			int8_tArray payment_hash_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_hash_arr->elems, obj->payment_received.payment_hash.data, 32);
	return payment_hash_arr;
}
int64_t __attribute__((export_name("TS_LDKEvent_PaymentReceived_get_amt"))) TS_LDKEvent_PaymentReceived_get_amt(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentReceived);
	return obj->payment_received.amt;
}
uint32_t __attribute__((export_name("TS_LDKEvent_PaymentReceived_get_purpose"))) TS_LDKEvent_PaymentReceived_get_purpose(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentReceived);
			uint32_t purpose_ref = ((uintptr_t)&obj->payment_received.purpose) | 1;
	return purpose_ref;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentSent_get_payment_id"))) TS_LDKEvent_PaymentSent_get_payment_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentSent);
			int8_tArray payment_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_id_arr->elems, obj->payment_sent.payment_id.data, 32);
	return payment_id_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentSent_get_payment_preimage"))) TS_LDKEvent_PaymentSent_get_payment_preimage(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentSent);
			int8_tArray payment_preimage_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_preimage_arr->elems, obj->payment_sent.payment_preimage.data, 32);
	return payment_preimage_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentSent_get_payment_hash"))) TS_LDKEvent_PaymentSent_get_payment_hash(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentSent);
			int8_tArray payment_hash_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_hash_arr->elems, obj->payment_sent.payment_hash.data, 32);
	return payment_hash_arr;
}
uint32_t __attribute__((export_name("TS_LDKEvent_PaymentSent_get_fee_paid_msat"))) TS_LDKEvent_PaymentSent_get_fee_paid_msat(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentSent);
			uint32_t fee_paid_msat_ref = ((uintptr_t)&obj->payment_sent.fee_paid_msat) | 1;
	return fee_paid_msat_ref;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentPathFailed_get_payment_id"))) TS_LDKEvent_PaymentPathFailed_get_payment_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathFailed);
			int8_tArray payment_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_id_arr->elems, obj->payment_path_failed.payment_id.data, 32);
	return payment_id_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentPathFailed_get_payment_hash"))) TS_LDKEvent_PaymentPathFailed_get_payment_hash(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathFailed);
			int8_tArray payment_hash_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_hash_arr->elems, obj->payment_path_failed.payment_hash.data, 32);
	return payment_hash_arr;
}
jboolean __attribute__((export_name("TS_LDKEvent_PaymentPathFailed_get_rejected_by_dest"))) TS_LDKEvent_PaymentPathFailed_get_rejected_by_dest(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathFailed);
	return obj->payment_path_failed.rejected_by_dest;
}
uint32_t __attribute__((export_name("TS_LDKEvent_PaymentPathFailed_get_network_update"))) TS_LDKEvent_PaymentPathFailed_get_network_update(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathFailed);
			uint32_t network_update_ref = ((uintptr_t)&obj->payment_path_failed.network_update) | 1;
	return network_update_ref;
}
jboolean __attribute__((export_name("TS_LDKEvent_PaymentPathFailed_get_all_paths_failed"))) TS_LDKEvent_PaymentPathFailed_get_all_paths_failed(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathFailed);
	return obj->payment_path_failed.all_paths_failed;
}
uint32_tArray __attribute__((export_name("TS_LDKEvent_PaymentPathFailed_get_path"))) TS_LDKEvent_PaymentPathFailed_get_path(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathFailed);
			LDKCVec_RouteHopZ path_var = obj->payment_path_failed.path;
			uint32_tArray path_arr = NULL;
			path_arr = init_uint32_tArray(path_var.datalen, __LINE__);
			uint32_t *path_arr_ptr = (uint32_t*)(((uint8_t*)path_arr) + 4);
			for (size_t k = 0; k < path_var.datalen; k++) {
				LDKRouteHop path_conv_10_var = path_var.data[k];
				uint32_t path_conv_10_ref = 0;
				CHECK((((uintptr_t)path_conv_10_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
				CHECK((((uintptr_t)&path_conv_10_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
				CHECK_INNER_FIELD_ACCESS_OR_NULL(path_conv_10_var);
				path_conv_10_ref = (uintptr_t)path_conv_10_var.inner & ~1;
				path_arr_ptr[k] = path_conv_10_ref;
			}
			
	return path_arr;
}
uint32_t __attribute__((export_name("TS_LDKEvent_PaymentPathFailed_get_short_channel_id"))) TS_LDKEvent_PaymentPathFailed_get_short_channel_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathFailed);
			uint32_t short_channel_id_ref = ((uintptr_t)&obj->payment_path_failed.short_channel_id) | 1;
	return short_channel_id_ref;
}
uint32_t __attribute__((export_name("TS_LDKEvent_PaymentPathFailed_get_retry"))) TS_LDKEvent_PaymentPathFailed_get_retry(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathFailed);
			LDKRouteParameters retry_var = obj->payment_path_failed.retry;
			uint32_t retry_ref = 0;
			if ((uintptr_t)retry_var.inner > 4096) {
				CHECK((((uintptr_t)retry_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
				CHECK((((uintptr_t)&retry_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(retry_var);
				retry_ref = (uintptr_t)retry_var.inner & ~1;
			}
	return retry_ref;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentFailed_get_payment_id"))) TS_LDKEvent_PaymentFailed_get_payment_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentFailed);
			int8_tArray payment_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_id_arr->elems, obj->payment_failed.payment_id.data, 32);
	return payment_id_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentFailed_get_payment_hash"))) TS_LDKEvent_PaymentFailed_get_payment_hash(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentFailed);
			int8_tArray payment_hash_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_hash_arr->elems, obj->payment_failed.payment_hash.data, 32);
	return payment_hash_arr;
}
int64_t __attribute__((export_name("TS_LDKEvent_PendingHTLCsForwardable_get_time_forwardable"))) TS_LDKEvent_PendingHTLCsForwardable_get_time_forwardable(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PendingHTLCsForwardable);
	return obj->pending_htl_cs_forwardable.time_forwardable;
}
uint32_tArray __attribute__((export_name("TS_LDKEvent_SpendableOutputs_get_outputs"))) TS_LDKEvent_SpendableOutputs_get_outputs(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_SpendableOutputs);
			LDKCVec_SpendableOutputDescriptorZ outputs_var = obj->spendable_outputs.outputs;
			uint32_tArray outputs_arr = NULL;
			outputs_arr = init_uint32_tArray(outputs_var.datalen, __LINE__);
			uint32_t *outputs_arr_ptr = (uint32_t*)(((uint8_t*)outputs_arr) + 4);
			for (size_t b = 0; b < outputs_var.datalen; b++) {
				uint32_t outputs_conv_27_ref = ((uintptr_t)&outputs_var.data[b]) | 1;
				outputs_arr_ptr[b] = outputs_conv_27_ref;
			}
			
	return outputs_arr;
}
uint32_t __attribute__((export_name("TS_LDKEvent_PaymentForwarded_get_fee_earned_msat"))) TS_LDKEvent_PaymentForwarded_get_fee_earned_msat(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentForwarded);
			uint32_t fee_earned_msat_ref = ((uintptr_t)&obj->payment_forwarded.fee_earned_msat) | 1;
	return fee_earned_msat_ref;
}
jboolean __attribute__((export_name("TS_LDKEvent_PaymentForwarded_get_claim_from_onchain_tx"))) TS_LDKEvent_PaymentForwarded_get_claim_from_onchain_tx(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentForwarded);
	return obj->payment_forwarded.claim_from_onchain_tx;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_ChannelClosed_get_channel_id"))) TS_LDKEvent_ChannelClosed_get_channel_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_ChannelClosed);
			int8_tArray channel_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(channel_id_arr->elems, obj->channel_closed.channel_id.data, 32);
	return channel_id_arr;
}
int64_t __attribute__((export_name("TS_LDKEvent_ChannelClosed_get_user_channel_id"))) TS_LDKEvent_ChannelClosed_get_user_channel_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_ChannelClosed);
	return obj->channel_closed.user_channel_id;
}
uint32_t __attribute__((export_name("TS_LDKEvent_ChannelClosed_get_reason"))) TS_LDKEvent_ChannelClosed_get_reason(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_ChannelClosed);
			uint32_t reason_ref = ((uintptr_t)&obj->channel_closed.reason) | 1;
	return reason_ref;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_DiscardFunding_get_channel_id"))) TS_LDKEvent_DiscardFunding_get_channel_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_DiscardFunding);
			int8_tArray channel_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(channel_id_arr->elems, obj->discard_funding.channel_id.data, 32);
	return channel_id_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_DiscardFunding_get_transaction"))) TS_LDKEvent_DiscardFunding_get_transaction(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_DiscardFunding);
			LDKTransaction transaction_var = obj->discard_funding.transaction;
			int8_tArray transaction_arr = init_int8_tArray(transaction_var.datalen, __LINE__);
			memcpy(transaction_arr->elems, transaction_var.data, transaction_var.datalen);
	return transaction_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentPathSuccessful_get_payment_id"))) TS_LDKEvent_PaymentPathSuccessful_get_payment_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathSuccessful);
			int8_tArray payment_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_id_arr->elems, obj->payment_path_successful.payment_id.data, 32);
	return payment_id_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_PaymentPathSuccessful_get_payment_hash"))) TS_LDKEvent_PaymentPathSuccessful_get_payment_hash(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathSuccessful);
			int8_tArray payment_hash_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_hash_arr->elems, obj->payment_path_successful.payment_hash.data, 32);
	return payment_hash_arr;
}
uint32_tArray __attribute__((export_name("TS_LDKEvent_PaymentPathSuccessful_get_path"))) TS_LDKEvent_PaymentPathSuccessful_get_path(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_PaymentPathSuccessful);
			LDKCVec_RouteHopZ path_var = obj->payment_path_successful.path;
			uint32_tArray path_arr = NULL;
			path_arr = init_uint32_tArray(path_var.datalen, __LINE__);
			uint32_t *path_arr_ptr = (uint32_t*)(((uint8_t*)path_arr) + 4);
			for (size_t k = 0; k < path_var.datalen; k++) {
				LDKRouteHop path_conv_10_var = path_var.data[k];
				uint32_t path_conv_10_ref = 0;
				CHECK((((uintptr_t)path_conv_10_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
				CHECK((((uintptr_t)&path_conv_10_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
				CHECK_INNER_FIELD_ACCESS_OR_NULL(path_conv_10_var);
				path_conv_10_ref = (uintptr_t)path_conv_10_var.inner & ~1;
				path_arr_ptr[k] = path_conv_10_ref;
			}
			
	return path_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_OpenChannelRequest_get_temporary_channel_id"))) TS_LDKEvent_OpenChannelRequest_get_temporary_channel_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_OpenChannelRequest);
			int8_tArray temporary_channel_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(temporary_channel_id_arr->elems, obj->open_channel_request.temporary_channel_id.data, 32);
	return temporary_channel_id_arr;
}
int8_tArray __attribute__((export_name("TS_LDKEvent_OpenChannelRequest_get_counterparty_node_id"))) TS_LDKEvent_OpenChannelRequest_get_counterparty_node_id(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_OpenChannelRequest);
			int8_tArray counterparty_node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(counterparty_node_id_arr->elems, obj->open_channel_request.counterparty_node_id.compressed_form, 33);
	return counterparty_node_id_arr;
}
int64_t __attribute__((export_name("TS_LDKEvent_OpenChannelRequest_get_funding_satoshis"))) TS_LDKEvent_OpenChannelRequest_get_funding_satoshis(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_OpenChannelRequest);
	return obj->open_channel_request.funding_satoshis;
}
int64_t __attribute__((export_name("TS_LDKEvent_OpenChannelRequest_get_push_msat"))) TS_LDKEvent_OpenChannelRequest_get_push_msat(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_OpenChannelRequest);
	return obj->open_channel_request.push_msat;
}
uint32_t __attribute__((export_name("TS_LDKEvent_OpenChannelRequest_get_channel_type"))) TS_LDKEvent_OpenChannelRequest_get_channel_type(uint32_t ptr) {
	LDKEvent *obj = (LDKEvent*)(ptr & ~1);
	assert(obj->tag == LDKEvent_OpenChannelRequest);
			LDKChannelTypeFeatures channel_type_var = obj->open_channel_request.channel_type;
			uint32_t channel_type_ref = 0;
			CHECK((((uintptr_t)channel_type_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&channel_type_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_type_var);
			channel_type_ref = (uintptr_t)channel_type_var.inner & ~1;
	return channel_type_ref;
}
uint32_t __attribute__((export_name("TS_LDKCOption_EventZ_ty_from_ptr"))) TS_LDKCOption_EventZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_EventZ *obj = (LDKCOption_EventZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_EventZ_Some: return 0;
		case LDKCOption_EventZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_EventZ_Some_get_some"))) TS_LDKCOption_EventZ_Some_get_some(uint32_t ptr) {
	LDKCOption_EventZ *obj = (LDKCOption_EventZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_EventZ_Some);
			uint32_t some_ref = ((uintptr_t)&obj->some) | 1;
	return some_ref;
}
static inline struct LDKCOption_EventZ CResult_COption_EventZDecodeErrorZ_get_ok(LDKCResult_COption_EventZDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return COption_EventZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_EventZDecodeErrorZ_get_ok"))) TS_CResult_COption_EventZDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_COption_EventZDecodeErrorZ* owner_conv = (LDKCResult_COption_EventZDecodeErrorZ*)(owner & ~1);
	LDKCOption_EventZ *ret_copy = MALLOC(sizeof(LDKCOption_EventZ), "LDKCOption_EventZ");
	*ret_copy = CResult_COption_EventZDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_COption_EventZDecodeErrorZ_get_err(LDKCResult_COption_EventZDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_EventZDecodeErrorZ_get_err"))) TS_CResult_COption_EventZDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_COption_EventZDecodeErrorZ* owner_conv = (LDKCResult_COption_EventZDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_COption_EventZDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKErrorAction_ty_from_ptr"))) TS_LDKErrorAction_ty_from_ptr(uint32_t ptr) {
	LDKErrorAction *obj = (LDKErrorAction*)(ptr & ~1);
	switch(obj->tag) {
		case LDKErrorAction_DisconnectPeer: return 0;
		case LDKErrorAction_IgnoreError: return 1;
		case LDKErrorAction_IgnoreAndLog: return 2;
		case LDKErrorAction_IgnoreDuplicateGossip: return 3;
		case LDKErrorAction_SendErrorMessage: return 4;
		case LDKErrorAction_SendWarningMessage: return 5;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKErrorAction_DisconnectPeer_get_msg"))) TS_LDKErrorAction_DisconnectPeer_get_msg(uint32_t ptr) {
	LDKErrorAction *obj = (LDKErrorAction*)(ptr & ~1);
	assert(obj->tag == LDKErrorAction_DisconnectPeer);
			LDKErrorMessage msg_var = obj->disconnect_peer.msg;
			uint32_t msg_ref = 0;
			if ((uintptr_t)msg_var.inner > 4096) {
				CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
				CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
				msg_ref = (uintptr_t)msg_var.inner & ~1;
			}
	return msg_ref;
}
uint32_t __attribute__((export_name("TS_LDKErrorAction_IgnoreAndLog_get_ignore_and_log"))) TS_LDKErrorAction_IgnoreAndLog_get_ignore_and_log(uint32_t ptr) {
	LDKErrorAction *obj = (LDKErrorAction*)(ptr & ~1);
	assert(obj->tag == LDKErrorAction_IgnoreAndLog);
			uint32_t ignore_and_log_conv = LDKLevel_to_js(obj->ignore_and_log);
	return ignore_and_log_conv;
}
uint32_t __attribute__((export_name("TS_LDKErrorAction_SendErrorMessage_get_msg"))) TS_LDKErrorAction_SendErrorMessage_get_msg(uint32_t ptr) {
	LDKErrorAction *obj = (LDKErrorAction*)(ptr & ~1);
	assert(obj->tag == LDKErrorAction_SendErrorMessage);
			LDKErrorMessage msg_var = obj->send_error_message.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
uint32_t __attribute__((export_name("TS_LDKErrorAction_SendWarningMessage_get_msg"))) TS_LDKErrorAction_SendWarningMessage_get_msg(uint32_t ptr) {
	LDKErrorAction *obj = (LDKErrorAction*)(ptr & ~1);
	assert(obj->tag == LDKErrorAction_SendWarningMessage);
			LDKWarningMessage msg_var = obj->send_warning_message.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
uint32_t __attribute__((export_name("TS_LDKErrorAction_SendWarningMessage_get_log_level"))) TS_LDKErrorAction_SendWarningMessage_get_log_level(uint32_t ptr) {
	LDKErrorAction *obj = (LDKErrorAction*)(ptr & ~1);
	assert(obj->tag == LDKErrorAction_SendWarningMessage);
			uint32_t log_level_conv = LDKLevel_to_js(obj->send_warning_message.log_level);
	return log_level_conv;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_ty_from_ptr"))) TS_LDKMessageSendEvent_ty_from_ptr(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	switch(obj->tag) {
		case LDKMessageSendEvent_SendAcceptChannel: return 0;
		case LDKMessageSendEvent_SendOpenChannel: return 1;
		case LDKMessageSendEvent_SendFundingCreated: return 2;
		case LDKMessageSendEvent_SendFundingSigned: return 3;
		case LDKMessageSendEvent_SendFundingLocked: return 4;
		case LDKMessageSendEvent_SendAnnouncementSignatures: return 5;
		case LDKMessageSendEvent_UpdateHTLCs: return 6;
		case LDKMessageSendEvent_SendRevokeAndACK: return 7;
		case LDKMessageSendEvent_SendClosingSigned: return 8;
		case LDKMessageSendEvent_SendShutdown: return 9;
		case LDKMessageSendEvent_SendChannelReestablish: return 10;
		case LDKMessageSendEvent_BroadcastChannelAnnouncement: return 11;
		case LDKMessageSendEvent_BroadcastNodeAnnouncement: return 12;
		case LDKMessageSendEvent_BroadcastChannelUpdate: return 13;
		case LDKMessageSendEvent_SendChannelUpdate: return 14;
		case LDKMessageSendEvent_HandleError: return 15;
		case LDKMessageSendEvent_SendChannelRangeQuery: return 16;
		case LDKMessageSendEvent_SendShortIdsQuery: return 17;
		case LDKMessageSendEvent_SendReplyChannelRange: return 18;
		case LDKMessageSendEvent_SendGossipTimestampFilter: return 19;
		default: abort();
	}
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendAcceptChannel_get_node_id"))) TS_LDKMessageSendEvent_SendAcceptChannel_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendAcceptChannel);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_accept_channel.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendAcceptChannel_get_msg"))) TS_LDKMessageSendEvent_SendAcceptChannel_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendAcceptChannel);
			LDKAcceptChannel msg_var = obj->send_accept_channel.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendOpenChannel_get_node_id"))) TS_LDKMessageSendEvent_SendOpenChannel_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendOpenChannel);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_open_channel.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendOpenChannel_get_msg"))) TS_LDKMessageSendEvent_SendOpenChannel_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendOpenChannel);
			LDKOpenChannel msg_var = obj->send_open_channel.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendFundingCreated_get_node_id"))) TS_LDKMessageSendEvent_SendFundingCreated_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendFundingCreated);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_funding_created.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendFundingCreated_get_msg"))) TS_LDKMessageSendEvent_SendFundingCreated_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendFundingCreated);
			LDKFundingCreated msg_var = obj->send_funding_created.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendFundingSigned_get_node_id"))) TS_LDKMessageSendEvent_SendFundingSigned_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendFundingSigned);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_funding_signed.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendFundingSigned_get_msg"))) TS_LDKMessageSendEvent_SendFundingSigned_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendFundingSigned);
			LDKFundingSigned msg_var = obj->send_funding_signed.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendFundingLocked_get_node_id"))) TS_LDKMessageSendEvent_SendFundingLocked_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendFundingLocked);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_funding_locked.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendFundingLocked_get_msg"))) TS_LDKMessageSendEvent_SendFundingLocked_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendFundingLocked);
			LDKFundingLocked msg_var = obj->send_funding_locked.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendAnnouncementSignatures_get_node_id"))) TS_LDKMessageSendEvent_SendAnnouncementSignatures_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendAnnouncementSignatures);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_announcement_signatures.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendAnnouncementSignatures_get_msg"))) TS_LDKMessageSendEvent_SendAnnouncementSignatures_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendAnnouncementSignatures);
			LDKAnnouncementSignatures msg_var = obj->send_announcement_signatures.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_UpdateHTLCs_get_node_id"))) TS_LDKMessageSendEvent_UpdateHTLCs_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_UpdateHTLCs);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->update_htl_cs.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_UpdateHTLCs_get_updates"))) TS_LDKMessageSendEvent_UpdateHTLCs_get_updates(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_UpdateHTLCs);
			LDKCommitmentUpdate updates_var = obj->update_htl_cs.updates;
			uint32_t updates_ref = 0;
			CHECK((((uintptr_t)updates_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&updates_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(updates_var);
			updates_ref = (uintptr_t)updates_var.inner & ~1;
	return updates_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendRevokeAndACK_get_node_id"))) TS_LDKMessageSendEvent_SendRevokeAndACK_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendRevokeAndACK);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_revoke_and_ack.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendRevokeAndACK_get_msg"))) TS_LDKMessageSendEvent_SendRevokeAndACK_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendRevokeAndACK);
			LDKRevokeAndACK msg_var = obj->send_revoke_and_ack.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendClosingSigned_get_node_id"))) TS_LDKMessageSendEvent_SendClosingSigned_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendClosingSigned);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_closing_signed.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendClosingSigned_get_msg"))) TS_LDKMessageSendEvent_SendClosingSigned_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendClosingSigned);
			LDKClosingSigned msg_var = obj->send_closing_signed.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendShutdown_get_node_id"))) TS_LDKMessageSendEvent_SendShutdown_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendShutdown);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_shutdown.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendShutdown_get_msg"))) TS_LDKMessageSendEvent_SendShutdown_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendShutdown);
			LDKShutdown msg_var = obj->send_shutdown.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendChannelReestablish_get_node_id"))) TS_LDKMessageSendEvent_SendChannelReestablish_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendChannelReestablish);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_channel_reestablish.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendChannelReestablish_get_msg"))) TS_LDKMessageSendEvent_SendChannelReestablish_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendChannelReestablish);
			LDKChannelReestablish msg_var = obj->send_channel_reestablish.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_BroadcastChannelAnnouncement_get_msg"))) TS_LDKMessageSendEvent_BroadcastChannelAnnouncement_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_BroadcastChannelAnnouncement);
			LDKChannelAnnouncement msg_var = obj->broadcast_channel_announcement.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_BroadcastChannelAnnouncement_get_update_msg"))) TS_LDKMessageSendEvent_BroadcastChannelAnnouncement_get_update_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_BroadcastChannelAnnouncement);
			LDKChannelUpdate update_msg_var = obj->broadcast_channel_announcement.update_msg;
			uint32_t update_msg_ref = 0;
			CHECK((((uintptr_t)update_msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&update_msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(update_msg_var);
			update_msg_ref = (uintptr_t)update_msg_var.inner & ~1;
	return update_msg_ref;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_BroadcastNodeAnnouncement_get_msg"))) TS_LDKMessageSendEvent_BroadcastNodeAnnouncement_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_BroadcastNodeAnnouncement);
			LDKNodeAnnouncement msg_var = obj->broadcast_node_announcement.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_BroadcastChannelUpdate_get_msg"))) TS_LDKMessageSendEvent_BroadcastChannelUpdate_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_BroadcastChannelUpdate);
			LDKChannelUpdate msg_var = obj->broadcast_channel_update.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendChannelUpdate_get_node_id"))) TS_LDKMessageSendEvent_SendChannelUpdate_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendChannelUpdate);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_channel_update.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendChannelUpdate_get_msg"))) TS_LDKMessageSendEvent_SendChannelUpdate_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendChannelUpdate);
			LDKChannelUpdate msg_var = obj->send_channel_update.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_HandleError_get_node_id"))) TS_LDKMessageSendEvent_HandleError_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_HandleError);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->handle_error.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_HandleError_get_action"))) TS_LDKMessageSendEvent_HandleError_get_action(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_HandleError);
			uint32_t action_ref = ((uintptr_t)&obj->handle_error.action) | 1;
	return action_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendChannelRangeQuery_get_node_id"))) TS_LDKMessageSendEvent_SendChannelRangeQuery_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendChannelRangeQuery);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_channel_range_query.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendChannelRangeQuery_get_msg"))) TS_LDKMessageSendEvent_SendChannelRangeQuery_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendChannelRangeQuery);
			LDKQueryChannelRange msg_var = obj->send_channel_range_query.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendShortIdsQuery_get_node_id"))) TS_LDKMessageSendEvent_SendShortIdsQuery_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendShortIdsQuery);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_short_ids_query.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendShortIdsQuery_get_msg"))) TS_LDKMessageSendEvent_SendShortIdsQuery_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendShortIdsQuery);
			LDKQueryShortChannelIds msg_var = obj->send_short_ids_query.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendReplyChannelRange_get_node_id"))) TS_LDKMessageSendEvent_SendReplyChannelRange_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendReplyChannelRange);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_reply_channel_range.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendReplyChannelRange_get_msg"))) TS_LDKMessageSendEvent_SendReplyChannelRange_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendReplyChannelRange);
			LDKReplyChannelRange msg_var = obj->send_reply_channel_range.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
int8_tArray __attribute__((export_name("TS_LDKMessageSendEvent_SendGossipTimestampFilter_get_node_id"))) TS_LDKMessageSendEvent_SendGossipTimestampFilter_get_node_id(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendGossipTimestampFilter);
			int8_tArray node_id_arr = init_int8_tArray(33, __LINE__);
			memcpy(node_id_arr->elems, obj->send_gossip_timestamp_filter.node_id.compressed_form, 33);
	return node_id_arr;
}
uint32_t __attribute__((export_name("TS_LDKMessageSendEvent_SendGossipTimestampFilter_get_msg"))) TS_LDKMessageSendEvent_SendGossipTimestampFilter_get_msg(uint32_t ptr) {
	LDKMessageSendEvent *obj = (LDKMessageSendEvent*)(ptr & ~1);
	assert(obj->tag == LDKMessageSendEvent_SendGossipTimestampFilter);
			LDKGossipTimestampFilter msg_var = obj->send_gossip_timestamp_filter.msg;
			uint32_t msg_ref = 0;
			CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
			msg_ref = (uintptr_t)msg_var.inner & ~1;
	return msg_ref;
}
static inline LDKCVec_MessageSendEventZ CVec_MessageSendEventZ_clone(const LDKCVec_MessageSendEventZ *orig) {
	LDKCVec_MessageSendEventZ ret = { .data = MALLOC(sizeof(LDKMessageSendEvent) * orig->datalen, "LDKCVec_MessageSendEventZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = MessageSendEvent_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKFixedPenaltyScorer CResult_FixedPenaltyScorerDecodeErrorZ_get_ok(LDKCResult_FixedPenaltyScorerDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return FixedPenaltyScorer_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_FixedPenaltyScorerDecodeErrorZ_get_ok"))) TS_CResult_FixedPenaltyScorerDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* owner_conv = (LDKCResult_FixedPenaltyScorerDecodeErrorZ*)(owner & ~1);
	LDKFixedPenaltyScorer ret_var = CResult_FixedPenaltyScorerDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_FixedPenaltyScorerDecodeErrorZ_get_err(LDKCResult_FixedPenaltyScorerDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_FixedPenaltyScorerDecodeErrorZ_get_err"))) TS_CResult_FixedPenaltyScorerDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* owner_conv = (LDKCResult_FixedPenaltyScorerDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_FixedPenaltyScorerDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKScoringParameters CResult_ScoringParametersDecodeErrorZ_get_ok(LDKCResult_ScoringParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ScoringParameters_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ScoringParametersDecodeErrorZ_get_ok"))) TS_CResult_ScoringParametersDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ScoringParametersDecodeErrorZ* owner_conv = (LDKCResult_ScoringParametersDecodeErrorZ*)(owner & ~1);
	LDKScoringParameters ret_var = CResult_ScoringParametersDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ScoringParametersDecodeErrorZ_get_err(LDKCResult_ScoringParametersDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ScoringParametersDecodeErrorZ_get_err"))) TS_CResult_ScoringParametersDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ScoringParametersDecodeErrorZ* owner_conv = (LDKCResult_ScoringParametersDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ScoringParametersDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKScorer *CResult_ScorerDecodeErrorZ_get_ok(LDKCResult_ScorerDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return &*owner->contents.result;
}
uint32_t  __attribute__((export_name("TS_CResult_ScorerDecodeErrorZ_get_ok"))) TS_CResult_ScorerDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ScorerDecodeErrorZ* owner_conv = (LDKCResult_ScorerDecodeErrorZ*)(owner & ~1);
	LDKScorer ret_var = *CResult_ScorerDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner & ~1;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ScorerDecodeErrorZ_get_err(LDKCResult_ScorerDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ScorerDecodeErrorZ_get_err"))) TS_CResult_ScorerDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ScorerDecodeErrorZ* owner_conv = (LDKCResult_ScorerDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ScorerDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKProbabilisticScorer *CResult_ProbabilisticScorerDecodeErrorZ_get_ok(LDKCResult_ProbabilisticScorerDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return &*owner->contents.result;
}
uint32_t  __attribute__((export_name("TS_CResult_ProbabilisticScorerDecodeErrorZ_get_ok"))) TS_CResult_ProbabilisticScorerDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ProbabilisticScorerDecodeErrorZ* owner_conv = (LDKCResult_ProbabilisticScorerDecodeErrorZ*)(owner & ~1);
	LDKProbabilisticScorer ret_var = *CResult_ProbabilisticScorerDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner & ~1;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ProbabilisticScorerDecodeErrorZ_get_err(LDKCResult_ProbabilisticScorerDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ProbabilisticScorerDecodeErrorZ_get_err"))) TS_CResult_ProbabilisticScorerDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ProbabilisticScorerDecodeErrorZ* owner_conv = (LDKCResult_ProbabilisticScorerDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ProbabilisticScorerDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKInitFeatures CResult_InitFeaturesDecodeErrorZ_get_ok(LDKCResult_InitFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return InitFeatures_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_InitFeaturesDecodeErrorZ_get_ok"))) TS_CResult_InitFeaturesDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_InitFeaturesDecodeErrorZ* owner_conv = (LDKCResult_InitFeaturesDecodeErrorZ*)(owner & ~1);
	LDKInitFeatures ret_var = CResult_InitFeaturesDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_InitFeaturesDecodeErrorZ_get_err(LDKCResult_InitFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_InitFeaturesDecodeErrorZ_get_err"))) TS_CResult_InitFeaturesDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_InitFeaturesDecodeErrorZ* owner_conv = (LDKCResult_InitFeaturesDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_InitFeaturesDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelFeatures CResult_ChannelFeaturesDecodeErrorZ_get_ok(LDKCResult_ChannelFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelFeatures_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelFeaturesDecodeErrorZ_get_ok"))) TS_CResult_ChannelFeaturesDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelFeaturesDecodeErrorZ* owner_conv = (LDKCResult_ChannelFeaturesDecodeErrorZ*)(owner & ~1);
	LDKChannelFeatures ret_var = CResult_ChannelFeaturesDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelFeaturesDecodeErrorZ_get_err(LDKCResult_ChannelFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelFeaturesDecodeErrorZ_get_err"))) TS_CResult_ChannelFeaturesDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelFeaturesDecodeErrorZ* owner_conv = (LDKCResult_ChannelFeaturesDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelFeaturesDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKNodeFeatures CResult_NodeFeaturesDecodeErrorZ_get_ok(LDKCResult_NodeFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return NodeFeatures_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeFeaturesDecodeErrorZ_get_ok"))) TS_CResult_NodeFeaturesDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NodeFeaturesDecodeErrorZ* owner_conv = (LDKCResult_NodeFeaturesDecodeErrorZ*)(owner & ~1);
	LDKNodeFeatures ret_var = CResult_NodeFeaturesDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_NodeFeaturesDecodeErrorZ_get_err(LDKCResult_NodeFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeFeaturesDecodeErrorZ_get_err"))) TS_CResult_NodeFeaturesDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_NodeFeaturesDecodeErrorZ* owner_conv = (LDKCResult_NodeFeaturesDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_NodeFeaturesDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKInvoiceFeatures CResult_InvoiceFeaturesDecodeErrorZ_get_ok(LDKCResult_InvoiceFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return InvoiceFeatures_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceFeaturesDecodeErrorZ_get_ok"))) TS_CResult_InvoiceFeaturesDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_InvoiceFeaturesDecodeErrorZ* owner_conv = (LDKCResult_InvoiceFeaturesDecodeErrorZ*)(owner & ~1);
	LDKInvoiceFeatures ret_var = CResult_InvoiceFeaturesDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_InvoiceFeaturesDecodeErrorZ_get_err(LDKCResult_InvoiceFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceFeaturesDecodeErrorZ_get_err"))) TS_CResult_InvoiceFeaturesDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_InvoiceFeaturesDecodeErrorZ* owner_conv = (LDKCResult_InvoiceFeaturesDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_InvoiceFeaturesDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelTypeFeatures CResult_ChannelTypeFeaturesDecodeErrorZ_get_ok(LDKCResult_ChannelTypeFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelTypeFeatures_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelTypeFeaturesDecodeErrorZ_get_ok"))) TS_CResult_ChannelTypeFeaturesDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelTypeFeaturesDecodeErrorZ* owner_conv = (LDKCResult_ChannelTypeFeaturesDecodeErrorZ*)(owner & ~1);
	LDKChannelTypeFeatures ret_var = CResult_ChannelTypeFeaturesDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelTypeFeaturesDecodeErrorZ_get_err(LDKCResult_ChannelTypeFeaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelTypeFeaturesDecodeErrorZ_get_err"))) TS_CResult_ChannelTypeFeaturesDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelTypeFeaturesDecodeErrorZ* owner_conv = (LDKCResult_ChannelTypeFeaturesDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelTypeFeaturesDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDelayedPaymentOutputDescriptor CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_get_ok(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return DelayedPaymentOutputDescriptor_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_get_ok"))) TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* owner_conv = (LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ*)(owner & ~1);
	LDKDelayedPaymentOutputDescriptor ret_var = CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_get_err(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_get_err"))) TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* owner_conv = (LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKStaticPaymentOutputDescriptor CResult_StaticPaymentOutputDescriptorDecodeErrorZ_get_ok(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return StaticPaymentOutputDescriptor_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_get_ok"))) TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* owner_conv = (LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ*)(owner & ~1);
	LDKStaticPaymentOutputDescriptor ret_var = CResult_StaticPaymentOutputDescriptorDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_StaticPaymentOutputDescriptorDecodeErrorZ_get_err(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_get_err"))) TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* owner_conv = (LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_StaticPaymentOutputDescriptorDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKSpendableOutputDescriptor CResult_SpendableOutputDescriptorDecodeErrorZ_get_ok(LDKCResult_SpendableOutputDescriptorDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return SpendableOutputDescriptor_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_SpendableOutputDescriptorDecodeErrorZ_get_ok"))) TS_CResult_SpendableOutputDescriptorDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* owner_conv = (LDKCResult_SpendableOutputDescriptorDecodeErrorZ*)(owner & ~1);
	LDKSpendableOutputDescriptor *ret_copy = MALLOC(sizeof(LDKSpendableOutputDescriptor), "LDKSpendableOutputDescriptor");
	*ret_copy = CResult_SpendableOutputDescriptorDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_SpendableOutputDescriptorDecodeErrorZ_get_err(LDKCResult_SpendableOutputDescriptorDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_SpendableOutputDescriptorDecodeErrorZ_get_err"))) TS_CResult_SpendableOutputDescriptorDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* owner_conv = (LDKCResult_SpendableOutputDescriptorDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_SpendableOutputDescriptorDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_PaymentPreimageZ CVec_PaymentPreimageZ_clone(const LDKCVec_PaymentPreimageZ *orig) {
	LDKCVec_PaymentPreimageZ ret = { .data = MALLOC(sizeof(LDKThirtyTwoBytes) * orig->datalen, "LDKCVec_PaymentPreimageZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = ThirtyTwoBytes_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKSignature C2Tuple_SignatureCVec_SignatureZZ_get_a(LDKC2Tuple_SignatureCVec_SignatureZZ *NONNULL_PTR owner){
	return owner->a;
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_SignatureCVec_SignatureZZ_get_a"))) TS_C2Tuple_SignatureCVec_SignatureZZ_get_a(uint32_t owner) {
	LDKC2Tuple_SignatureCVec_SignatureZZ* owner_conv = (LDKC2Tuple_SignatureCVec_SignatureZZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_SignatureCVec_SignatureZZ_get_a(owner_conv).compact_form, 64);
	return ret_arr;
}

static inline struct LDKCVec_SignatureZ C2Tuple_SignatureCVec_SignatureZZ_get_b(LDKC2Tuple_SignatureCVec_SignatureZZ *NONNULL_PTR owner){
	return owner->b;
}
ptrArray  __attribute__((export_name("TS_C2Tuple_SignatureCVec_SignatureZZ_get_b"))) TS_C2Tuple_SignatureCVec_SignatureZZ_get_b(uint32_t owner) {
	LDKC2Tuple_SignatureCVec_SignatureZZ* owner_conv = (LDKC2Tuple_SignatureCVec_SignatureZZ*)(owner & ~1);
	LDKCVec_SignatureZ ret_var = C2Tuple_SignatureCVec_SignatureZZ_get_b(owner_conv);
	ptrArray ret_arr = NULL;
	ret_arr = init_ptrArray(ret_var.datalen, __LINE__);
	int8_tArray *ret_arr_ptr = (int8_tArray*)(((uint8_t*)ret_arr) + 4);
	for (size_t m = 0; m < ret_var.datalen; m++) {
		int8_tArray ret_conv_12_arr = init_int8_tArray(64, __LINE__);
		memcpy(ret_conv_12_arr->elems, ret_var.data[m].compact_form, 64);
		ret_arr_ptr[m] = ret_conv_12_arr;
	}
	
	return ret_arr;
}

static inline struct LDKC2Tuple_SignatureCVec_SignatureZZ CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_get_ok(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return C2Tuple_SignatureCVec_SignatureZZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_get_ok"))) TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_get_ok(uint32_t owner) {
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* owner_conv = (LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ*)(owner & ~1);
	LDKC2Tuple_SignatureCVec_SignatureZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_SignatureCVec_SignatureZZ), "LDKC2Tuple_SignatureCVec_SignatureZZ");
	*ret_conv = CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_get_ok(owner_conv);
	return ((uint32_t)ret_conv);
}

static inline void CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_get_err(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_get_err"))) TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_get_err(uint32_t owner) {
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* owner_conv = (LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ*)(owner & ~1);
	CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_get_err(owner_conv);
}

static inline struct LDKSignature CResult_SignatureNoneZ_get_ok(LDKCResult_SignatureNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
int8_tArray  __attribute__((export_name("TS_CResult_SignatureNoneZ_get_ok"))) TS_CResult_SignatureNoneZ_get_ok(uint32_t owner) {
	LDKCResult_SignatureNoneZ* owner_conv = (LDKCResult_SignatureNoneZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, CResult_SignatureNoneZ_get_ok(owner_conv).compact_form, 64);
	return ret_arr;
}

static inline void CResult_SignatureNoneZ_get_err(LDKCResult_SignatureNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_SignatureNoneZ_get_err"))) TS_CResult_SignatureNoneZ_get_err(uint32_t owner) {
	LDKCResult_SignatureNoneZ* owner_conv = (LDKCResult_SignatureNoneZ*)(owner & ~1);
	CResult_SignatureNoneZ_get_err(owner_conv);
}

static inline struct LDKSignature C2Tuple_SignatureSignatureZ_get_a(LDKC2Tuple_SignatureSignatureZ *NONNULL_PTR owner){
	return owner->a;
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_SignatureSignatureZ_get_a"))) TS_C2Tuple_SignatureSignatureZ_get_a(uint32_t owner) {
	LDKC2Tuple_SignatureSignatureZ* owner_conv = (LDKC2Tuple_SignatureSignatureZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_SignatureSignatureZ_get_a(owner_conv).compact_form, 64);
	return ret_arr;
}

static inline struct LDKSignature C2Tuple_SignatureSignatureZ_get_b(LDKC2Tuple_SignatureSignatureZ *NONNULL_PTR owner){
	return owner->b;
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_SignatureSignatureZ_get_b"))) TS_C2Tuple_SignatureSignatureZ_get_b(uint32_t owner) {
	LDKC2Tuple_SignatureSignatureZ* owner_conv = (LDKC2Tuple_SignatureSignatureZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_SignatureSignatureZ_get_b(owner_conv).compact_form, 64);
	return ret_arr;
}

static inline struct LDKC2Tuple_SignatureSignatureZ CResult_C2Tuple_SignatureSignatureZNoneZ_get_ok(LDKCResult_C2Tuple_SignatureSignatureZNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return C2Tuple_SignatureSignatureZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureSignatureZNoneZ_get_ok"))) TS_CResult_C2Tuple_SignatureSignatureZNoneZ_get_ok(uint32_t owner) {
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* owner_conv = (LDKCResult_C2Tuple_SignatureSignatureZNoneZ*)(owner & ~1);
	LDKC2Tuple_SignatureSignatureZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_SignatureSignatureZ), "LDKC2Tuple_SignatureSignatureZ");
	*ret_conv = CResult_C2Tuple_SignatureSignatureZNoneZ_get_ok(owner_conv);
	return ((uint32_t)ret_conv);
}

static inline void CResult_C2Tuple_SignatureSignatureZNoneZ_get_err(LDKCResult_C2Tuple_SignatureSignatureZNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_C2Tuple_SignatureSignatureZNoneZ_get_err"))) TS_CResult_C2Tuple_SignatureSignatureZNoneZ_get_err(uint32_t owner) {
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* owner_conv = (LDKCResult_C2Tuple_SignatureSignatureZNoneZ*)(owner & ~1);
	CResult_C2Tuple_SignatureSignatureZNoneZ_get_err(owner_conv);
}

static inline struct LDKSecretKey CResult_SecretKeyNoneZ_get_ok(LDKCResult_SecretKeyNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
int8_tArray  __attribute__((export_name("TS_CResult_SecretKeyNoneZ_get_ok"))) TS_CResult_SecretKeyNoneZ_get_ok(uint32_t owner) {
	LDKCResult_SecretKeyNoneZ* owner_conv = (LDKCResult_SecretKeyNoneZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CResult_SecretKeyNoneZ_get_ok(owner_conv).bytes, 32);
	return ret_arr;
}

static inline void CResult_SecretKeyNoneZ_get_err(LDKCResult_SecretKeyNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_SecretKeyNoneZ_get_err"))) TS_CResult_SecretKeyNoneZ_get_err(uint32_t owner) {
	LDKCResult_SecretKeyNoneZ* owner_conv = (LDKCResult_SecretKeyNoneZ*)(owner & ~1);
	CResult_SecretKeyNoneZ_get_err(owner_conv);
}

typedef struct LDKBaseSign_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKBaseSign_JCalls;
static void LDKBaseSign_JCalls_free(void* this_arg) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKPublicKey get_per_commitment_point_LDKBaseSign_jcall(const void* this_arg, uint64_t idx) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_1(j_calls->instance_ptr, 0, (uint32_t)idx);
	LDKPublicKey ret_ref;
	CHECK(ret->arr_len == 33);
	memcpy(ret_ref.compressed_form, ret->elems, 33); FREE(ret);
	return ret_ref;
}
LDKThirtyTwoBytes release_commitment_secret_LDKBaseSign_jcall(const void* this_arg, uint64_t idx) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_1(j_calls->instance_ptr, 1, (uint32_t)idx);
	LDKThirtyTwoBytes ret_ref;
	CHECK(ret->arr_len == 32);
	memcpy(ret_ref.data, ret->elems, 32); FREE(ret);
	return ret_ref;
}
LDKCResult_NoneNoneZ validate_holder_commitment_LDKBaseSign_jcall(const void* this_arg, const LDKHolderCommitmentTransaction * holder_tx, LDKCVec_PaymentPreimageZ preimages) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKHolderCommitmentTransaction holder_tx_var = *holder_tx;
	uint32_t holder_tx_ref = 0;
	holder_tx_var = HolderCommitmentTransaction_clone(&holder_tx_var);
	CHECK((((uintptr_t)holder_tx_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&holder_tx_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(holder_tx_var);
	holder_tx_ref = (uintptr_t)holder_tx_var.inner;
	if (holder_tx_var.is_owned) {
		holder_tx_ref |= 1;
	}
	LDKCVec_PaymentPreimageZ preimages_var = preimages;
	ptrArray preimages_arr = NULL;
	preimages_arr = init_ptrArray(preimages_var.datalen, __LINE__);
	int8_tArray *preimages_arr_ptr = (int8_tArray*)(((uint8_t*)preimages_arr) + 4);
	for (size_t m = 0; m < preimages_var.datalen; m++) {
		int8_tArray preimages_conv_12_arr = init_int8_tArray(32, __LINE__);
		memcpy(preimages_conv_12_arr->elems, preimages_var.data[m].data, 32);
		preimages_arr_ptr[m] = preimages_conv_12_arr;
	}
	
	FREE(preimages_var.data);
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 2, (uint32_t)holder_tx_ref, (uint32_t)preimages_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneNoneZ ret_conv = *(LDKCResult_NoneNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKThirtyTwoBytes channel_keys_id_LDKBaseSign_jcall(const void* this_arg) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_0(j_calls->instance_ptr, 3);
	LDKThirtyTwoBytes ret_ref;
	CHECK(ret->arr_len == 32);
	memcpy(ret_ref.data, ret->elems, 32); FREE(ret);
	return ret_ref;
}
LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ sign_counterparty_commitment_LDKBaseSign_jcall(const void* this_arg, const LDKCommitmentTransaction * commitment_tx, LDKCVec_PaymentPreimageZ preimages) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKCommitmentTransaction commitment_tx_var = *commitment_tx;
	uint32_t commitment_tx_ref = 0;
	commitment_tx_var = CommitmentTransaction_clone(&commitment_tx_var);
	CHECK((((uintptr_t)commitment_tx_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&commitment_tx_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(commitment_tx_var);
	commitment_tx_ref = (uintptr_t)commitment_tx_var.inner;
	if (commitment_tx_var.is_owned) {
		commitment_tx_ref |= 1;
	}
	LDKCVec_PaymentPreimageZ preimages_var = preimages;
	ptrArray preimages_arr = NULL;
	preimages_arr = init_ptrArray(preimages_var.datalen, __LINE__);
	int8_tArray *preimages_arr_ptr = (int8_tArray*)(((uint8_t*)preimages_arr) + 4);
	for (size_t m = 0; m < preimages_var.datalen; m++) {
		int8_tArray preimages_conv_12_arr = init_int8_tArray(32, __LINE__);
		memcpy(preimages_conv_12_arr->elems, preimages_var.data[m].data, 32);
		preimages_arr_ptr[m] = preimages_conv_12_arr;
	}
	
	FREE(preimages_var.data);
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 4, (uint32_t)commitment_tx_ref, (uint32_t)preimages_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ ret_conv = *(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_NoneNoneZ validate_counterparty_revocation_LDKBaseSign_jcall(const void* this_arg, uint64_t idx, const uint8_t (* secret)[32]) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	int8_tArray secret_arr = init_int8_tArray(32, __LINE__);
	memcpy(secret_arr->elems, *secret, 32);
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 5, (uint32_t)idx, (uint32_t)secret_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneNoneZ ret_conv = *(LDKCResult_NoneNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ sign_holder_commitment_and_htlcs_LDKBaseSign_jcall(const void* this_arg, const LDKHolderCommitmentTransaction * commitment_tx) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKHolderCommitmentTransaction commitment_tx_var = *commitment_tx;
	uint32_t commitment_tx_ref = 0;
	commitment_tx_var = HolderCommitmentTransaction_clone(&commitment_tx_var);
	CHECK((((uintptr_t)commitment_tx_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&commitment_tx_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(commitment_tx_var);
	commitment_tx_ref = (uintptr_t)commitment_tx_var.inner;
	if (commitment_tx_var.is_owned) {
		commitment_tx_ref |= 1;
	}
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 6, (uint32_t)commitment_tx_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ ret_conv = *(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_SignatureNoneZ sign_justice_revoked_output_LDKBaseSign_jcall(const void* this_arg, LDKTransaction justice_tx, uintptr_t input, uint64_t amount, const uint8_t (* per_commitment_key)[32]) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKTransaction justice_tx_var = justice_tx;
	int8_tArray justice_tx_arr = init_int8_tArray(justice_tx_var.datalen, __LINE__);
	memcpy(justice_tx_arr->elems, justice_tx_var.data, justice_tx_var.datalen);
	Transaction_free(justice_tx_var);
	int8_tArray per_commitment_key_arr = init_int8_tArray(32, __LINE__);
	memcpy(per_commitment_key_arr->elems, *per_commitment_key, 32);
	uint32_t ret = js_invoke_function_4(j_calls->instance_ptr, 7, (uint32_t)justice_tx_arr, (uint32_t)input, (uint32_t)amount, (uint32_t)per_commitment_key_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_SignatureNoneZ ret_conv = *(LDKCResult_SignatureNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_SignatureNoneZ sign_justice_revoked_htlc_LDKBaseSign_jcall(const void* this_arg, LDKTransaction justice_tx, uintptr_t input, uint64_t amount, const uint8_t (* per_commitment_key)[32], const LDKHTLCOutputInCommitment * htlc) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKTransaction justice_tx_var = justice_tx;
	int8_tArray justice_tx_arr = init_int8_tArray(justice_tx_var.datalen, __LINE__);
	memcpy(justice_tx_arr->elems, justice_tx_var.data, justice_tx_var.datalen);
	Transaction_free(justice_tx_var);
	int8_tArray per_commitment_key_arr = init_int8_tArray(32, __LINE__);
	memcpy(per_commitment_key_arr->elems, *per_commitment_key, 32);
	LDKHTLCOutputInCommitment htlc_var = *htlc;
	uint32_t htlc_ref = 0;
	htlc_var = HTLCOutputInCommitment_clone(&htlc_var);
	CHECK((((uintptr_t)htlc_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&htlc_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(htlc_var);
	htlc_ref = (uintptr_t)htlc_var.inner;
	if (htlc_var.is_owned) {
		htlc_ref |= 1;
	}
	uint32_t ret = js_invoke_function_5(j_calls->instance_ptr, 8, (uint32_t)justice_tx_arr, (uint32_t)input, (uint32_t)amount, (uint32_t)per_commitment_key_arr, (uint32_t)htlc_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_SignatureNoneZ ret_conv = *(LDKCResult_SignatureNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_SignatureNoneZ sign_counterparty_htlc_transaction_LDKBaseSign_jcall(const void* this_arg, LDKTransaction htlc_tx, uintptr_t input, uint64_t amount, LDKPublicKey per_commitment_point, const LDKHTLCOutputInCommitment * htlc) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKTransaction htlc_tx_var = htlc_tx;
	int8_tArray htlc_tx_arr = init_int8_tArray(htlc_tx_var.datalen, __LINE__);
	memcpy(htlc_tx_arr->elems, htlc_tx_var.data, htlc_tx_var.datalen);
	Transaction_free(htlc_tx_var);
	int8_tArray per_commitment_point_arr = init_int8_tArray(33, __LINE__);
	memcpy(per_commitment_point_arr->elems, per_commitment_point.compressed_form, 33);
	LDKHTLCOutputInCommitment htlc_var = *htlc;
	uint32_t htlc_ref = 0;
	htlc_var = HTLCOutputInCommitment_clone(&htlc_var);
	CHECK((((uintptr_t)htlc_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&htlc_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(htlc_var);
	htlc_ref = (uintptr_t)htlc_var.inner;
	if (htlc_var.is_owned) {
		htlc_ref |= 1;
	}
	uint32_t ret = js_invoke_function_5(j_calls->instance_ptr, 9, (uint32_t)htlc_tx_arr, (uint32_t)input, (uint32_t)amount, (uint32_t)per_commitment_point_arr, (uint32_t)htlc_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_SignatureNoneZ ret_conv = *(LDKCResult_SignatureNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_SignatureNoneZ sign_closing_transaction_LDKBaseSign_jcall(const void* this_arg, const LDKClosingTransaction * closing_tx) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKClosingTransaction closing_tx_var = *closing_tx;
	uint32_t closing_tx_ref = 0;
	closing_tx_var = ClosingTransaction_clone(&closing_tx_var);
	CHECK((((uintptr_t)closing_tx_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&closing_tx_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(closing_tx_var);
	closing_tx_ref = (uintptr_t)closing_tx_var.inner;
	if (closing_tx_var.is_owned) {
		closing_tx_ref |= 1;
	}
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 10, (uint32_t)closing_tx_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_SignatureNoneZ ret_conv = *(LDKCResult_SignatureNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_C2Tuple_SignatureSignatureZNoneZ sign_channel_announcement_LDKBaseSign_jcall(const void* this_arg, const LDKUnsignedChannelAnnouncement * msg) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKUnsignedChannelAnnouncement msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = UnsignedChannelAnnouncement_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 11, (uint32_t)msg_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ ret_conv = *(LDKCResult_C2Tuple_SignatureSignatureZNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
void ready_channel_LDKBaseSign_jcall(void* this_arg, const LDKChannelTransactionParameters * channel_parameters) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) this_arg;
	LDKChannelTransactionParameters channel_parameters_var = *channel_parameters;
	uint32_t channel_parameters_ref = 0;
	channel_parameters_var = ChannelTransactionParameters_clone(&channel_parameters_var);
	CHECK((((uintptr_t)channel_parameters_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&channel_parameters_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_parameters_var);
	channel_parameters_ref = (uintptr_t)channel_parameters_var.inner;
	if (channel_parameters_var.is_owned) {
		channel_parameters_ref |= 1;
	}
	js_invoke_function_1(j_calls->instance_ptr, 12, (uint32_t)channel_parameters_ref);
}
static void LDKBaseSign_JCalls_cloned(LDKBaseSign* new_obj) {
	LDKBaseSign_JCalls *j_calls = (LDKBaseSign_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKBaseSign LDKBaseSign_init (JSValue o, uint32_t pubkeys) {
	LDKBaseSign_JCalls *calls = MALLOC(sizeof(LDKBaseSign_JCalls), "LDKBaseSign_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKChannelPublicKeys pubkeys_conv;
	pubkeys_conv.inner = (void*)(pubkeys & (~1));
	pubkeys_conv.is_owned = (pubkeys & 1) || (pubkeys == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(pubkeys_conv);

	LDKBaseSign ret = {
		.this_arg = (void*) calls,
		.get_per_commitment_point = get_per_commitment_point_LDKBaseSign_jcall,
		.release_commitment_secret = release_commitment_secret_LDKBaseSign_jcall,
		.validate_holder_commitment = validate_holder_commitment_LDKBaseSign_jcall,
		.channel_keys_id = channel_keys_id_LDKBaseSign_jcall,
		.sign_counterparty_commitment = sign_counterparty_commitment_LDKBaseSign_jcall,
		.validate_counterparty_revocation = validate_counterparty_revocation_LDKBaseSign_jcall,
		.sign_holder_commitment_and_htlcs = sign_holder_commitment_and_htlcs_LDKBaseSign_jcall,
		.sign_justice_revoked_output = sign_justice_revoked_output_LDKBaseSign_jcall,
		.sign_justice_revoked_htlc = sign_justice_revoked_htlc_LDKBaseSign_jcall,
		.sign_counterparty_htlc_transaction = sign_counterparty_htlc_transaction_LDKBaseSign_jcall,
		.sign_closing_transaction = sign_closing_transaction_LDKBaseSign_jcall,
		.sign_channel_announcement = sign_channel_announcement_LDKBaseSign_jcall,
		.ready_channel = ready_channel_LDKBaseSign_jcall,
		.free = LDKBaseSign_JCalls_free,
		.pubkeys = pubkeys_conv,
		.set_pubkeys = NULL,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKBaseSign_new"))) TS_LDKBaseSign_new(JSValue o, uint32_t pubkeys) {
	LDKBaseSign *res_ptr = MALLOC(sizeof(LDKBaseSign), "LDKBaseSign");
	*res_ptr = LDKBaseSign_init(o, pubkeys);
	return (long)res_ptr;
}
int8_tArray  __attribute__((export_name("TS_BaseSign_get_per_commitment_point"))) TS_BaseSign_get_per_commitment_point(uint32_t this_arg, int64_t idx) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, (this_arg_conv->get_per_commitment_point)(this_arg_conv->this_arg, idx).compressed_form, 33);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_BaseSign_release_commitment_secret"))) TS_BaseSign_release_commitment_secret(uint32_t this_arg, int64_t idx) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, (this_arg_conv->release_commitment_secret)(this_arg_conv->this_arg, idx).data, 32);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_BaseSign_validate_holder_commitment"))) TS_BaseSign_validate_holder_commitment(uint32_t this_arg, uint32_t holder_tx, ptrArray preimages) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKHolderCommitmentTransaction holder_tx_conv;
	holder_tx_conv.inner = (void*)(holder_tx & (~1));
	holder_tx_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(holder_tx_conv);
	LDKCVec_PaymentPreimageZ preimages_constr;
	preimages_constr.datalen = preimages->arr_len;
	if (preimages_constr.datalen > 0)
		preimages_constr.data = MALLOC(preimages_constr.datalen * sizeof(LDKThirtyTwoBytes), "LDKCVec_PaymentPreimageZ Elements");
	else
		preimages_constr.data = NULL;
	int8_tArray* preimages_vals = (void*) preimages->elems /* XXX preimages leaks */;
	for (size_t m = 0; m < preimages_constr.datalen; m++) {
		int8_tArray preimages_conv_12 = preimages_vals[m];
		LDKThirtyTwoBytes preimages_conv_12_ref;
		CHECK(preimages_conv_12->arr_len == 32);
		memcpy(preimages_conv_12_ref.data, preimages_conv_12->elems, 32); FREE(preimages_conv_12);
		preimages_constr.data[m] = preimages_conv_12_ref;
	}
	LDKCResult_NoneNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneNoneZ), "LDKCResult_NoneNoneZ");
	*ret_conv = (this_arg_conv->validate_holder_commitment)(this_arg_conv->this_arg, &holder_tx_conv, preimages_constr);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_BaseSign_channel_keys_id"))) TS_BaseSign_channel_keys_id(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, (this_arg_conv->channel_keys_id)(this_arg_conv->this_arg).data, 32);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_BaseSign_sign_counterparty_commitment"))) TS_BaseSign_sign_counterparty_commitment(uint32_t this_arg, uint32_t commitment_tx, ptrArray preimages) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKCommitmentTransaction commitment_tx_conv;
	commitment_tx_conv.inner = (void*)(commitment_tx & (~1));
	commitment_tx_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(commitment_tx_conv);
	LDKCVec_PaymentPreimageZ preimages_constr;
	preimages_constr.datalen = preimages->arr_len;
	if (preimages_constr.datalen > 0)
		preimages_constr.data = MALLOC(preimages_constr.datalen * sizeof(LDKThirtyTwoBytes), "LDKCVec_PaymentPreimageZ Elements");
	else
		preimages_constr.data = NULL;
	int8_tArray* preimages_vals = (void*) preimages->elems /* XXX preimages leaks */;
	for (size_t m = 0; m < preimages_constr.datalen; m++) {
		int8_tArray preimages_conv_12 = preimages_vals[m];
		LDKThirtyTwoBytes preimages_conv_12_ref;
		CHECK(preimages_conv_12->arr_len == 32);
		memcpy(preimages_conv_12_ref.data, preimages_conv_12->elems, 32); FREE(preimages_conv_12);
		preimages_constr.data[m] = preimages_conv_12_ref;
	}
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ), "LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ");
	*ret_conv = (this_arg_conv->sign_counterparty_commitment)(this_arg_conv->this_arg, &commitment_tx_conv, preimages_constr);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_BaseSign_validate_counterparty_revocation"))) TS_BaseSign_validate_counterparty_revocation(uint32_t this_arg, int64_t idx, int8_tArray secret) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	unsigned char secret_arr[32];
	CHECK(secret->arr_len == 32);
	memcpy(secret_arr, secret->elems, 32); FREE(secret);
	unsigned char (*secret_ref)[32] = &secret_arr;
	LDKCResult_NoneNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneNoneZ), "LDKCResult_NoneNoneZ");
	*ret_conv = (this_arg_conv->validate_counterparty_revocation)(this_arg_conv->this_arg, idx, secret_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_BaseSign_sign_holder_commitment_and_htlcs"))) TS_BaseSign_sign_holder_commitment_and_htlcs(uint32_t this_arg, uint32_t commitment_tx) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKHolderCommitmentTransaction commitment_tx_conv;
	commitment_tx_conv.inner = (void*)(commitment_tx & (~1));
	commitment_tx_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(commitment_tx_conv);
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ), "LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ");
	*ret_conv = (this_arg_conv->sign_holder_commitment_and_htlcs)(this_arg_conv->this_arg, &commitment_tx_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_BaseSign_sign_justice_revoked_output"))) TS_BaseSign_sign_justice_revoked_output(uint32_t this_arg, int8_tArray justice_tx, uint32_t input, int64_t amount, int8_tArray per_commitment_key) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKTransaction justice_tx_ref;
	justice_tx_ref.datalen = justice_tx->arr_len;
	justice_tx_ref.data = MALLOC(justice_tx_ref.datalen, "LDKTransaction Bytes");
	memcpy(justice_tx_ref.data, justice_tx->elems, justice_tx_ref.datalen); FREE(justice_tx);
	justice_tx_ref.data_is_owned = true;
	unsigned char per_commitment_key_arr[32];
	CHECK(per_commitment_key->arr_len == 32);
	memcpy(per_commitment_key_arr, per_commitment_key->elems, 32); FREE(per_commitment_key);
	unsigned char (*per_commitment_key_ref)[32] = &per_commitment_key_arr;
	LDKCResult_SignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SignatureNoneZ), "LDKCResult_SignatureNoneZ");
	*ret_conv = (this_arg_conv->sign_justice_revoked_output)(this_arg_conv->this_arg, justice_tx_ref, input, amount, per_commitment_key_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_BaseSign_sign_justice_revoked_htlc"))) TS_BaseSign_sign_justice_revoked_htlc(uint32_t this_arg, int8_tArray justice_tx, uint32_t input, int64_t amount, int8_tArray per_commitment_key, uint32_t htlc) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKTransaction justice_tx_ref;
	justice_tx_ref.datalen = justice_tx->arr_len;
	justice_tx_ref.data = MALLOC(justice_tx_ref.datalen, "LDKTransaction Bytes");
	memcpy(justice_tx_ref.data, justice_tx->elems, justice_tx_ref.datalen); FREE(justice_tx);
	justice_tx_ref.data_is_owned = true;
	unsigned char per_commitment_key_arr[32];
	CHECK(per_commitment_key->arr_len == 32);
	memcpy(per_commitment_key_arr, per_commitment_key->elems, 32); FREE(per_commitment_key);
	unsigned char (*per_commitment_key_ref)[32] = &per_commitment_key_arr;
	LDKHTLCOutputInCommitment htlc_conv;
	htlc_conv.inner = (void*)(htlc & (~1));
	htlc_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(htlc_conv);
	LDKCResult_SignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SignatureNoneZ), "LDKCResult_SignatureNoneZ");
	*ret_conv = (this_arg_conv->sign_justice_revoked_htlc)(this_arg_conv->this_arg, justice_tx_ref, input, amount, per_commitment_key_ref, &htlc_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_BaseSign_sign_counterparty_htlc_transaction"))) TS_BaseSign_sign_counterparty_htlc_transaction(uint32_t this_arg, int8_tArray htlc_tx, uint32_t input, int64_t amount, int8_tArray per_commitment_point, uint32_t htlc) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKTransaction htlc_tx_ref;
	htlc_tx_ref.datalen = htlc_tx->arr_len;
	htlc_tx_ref.data = MALLOC(htlc_tx_ref.datalen, "LDKTransaction Bytes");
	memcpy(htlc_tx_ref.data, htlc_tx->elems, htlc_tx_ref.datalen); FREE(htlc_tx);
	htlc_tx_ref.data_is_owned = true;
	LDKPublicKey per_commitment_point_ref;
	CHECK(per_commitment_point->arr_len == 33);
	memcpy(per_commitment_point_ref.compressed_form, per_commitment_point->elems, 33); FREE(per_commitment_point);
	LDKHTLCOutputInCommitment htlc_conv;
	htlc_conv.inner = (void*)(htlc & (~1));
	htlc_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(htlc_conv);
	LDKCResult_SignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SignatureNoneZ), "LDKCResult_SignatureNoneZ");
	*ret_conv = (this_arg_conv->sign_counterparty_htlc_transaction)(this_arg_conv->this_arg, htlc_tx_ref, input, amount, per_commitment_point_ref, &htlc_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_BaseSign_sign_closing_transaction"))) TS_BaseSign_sign_closing_transaction(uint32_t this_arg, uint32_t closing_tx) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKClosingTransaction closing_tx_conv;
	closing_tx_conv.inner = (void*)(closing_tx & (~1));
	closing_tx_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(closing_tx_conv);
	LDKCResult_SignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SignatureNoneZ), "LDKCResult_SignatureNoneZ");
	*ret_conv = (this_arg_conv->sign_closing_transaction)(this_arg_conv->this_arg, &closing_tx_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_BaseSign_sign_channel_announcement"))) TS_BaseSign_sign_channel_announcement(uint32_t this_arg, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKUnsignedChannelAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureSignatureZNoneZ), "LDKCResult_C2Tuple_SignatureSignatureZNoneZ");
	*ret_conv = (this_arg_conv->sign_channel_announcement)(this_arg_conv->this_arg, &msg_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_BaseSign_ready_channel"))) TS_BaseSign_ready_channel(uint32_t this_arg, uint32_t channel_parameters) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKChannelTransactionParameters channel_parameters_conv;
	channel_parameters_conv.inner = (void*)(channel_parameters & (~1));
	channel_parameters_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_parameters_conv);
	(this_arg_conv->ready_channel)(this_arg_conv->this_arg, &channel_parameters_conv);
}

LDKChannelPublicKeys LDKBaseSign_set_get_pubkeys(LDKBaseSign* this_arg) {
	if (this_arg->set_pubkeys != NULL)
		this_arg->set_pubkeys(this_arg);
	return this_arg->pubkeys;
}
uint32_t  __attribute__((export_name("TS_BaseSign_get_pubkeys"))) TS_BaseSign_get_pubkeys(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBaseSign* this_arg_conv = (LDKBaseSign*)this_arg_ptr;
	LDKChannelPublicKeys ret_var = LDKBaseSign_set_get_pubkeys(this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

typedef struct LDKSign_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
	LDKBaseSign_JCalls* BaseSign;
} LDKSign_JCalls;
static void LDKSign_JCalls_free(void* this_arg) {
	LDKSign_JCalls *j_calls = (LDKSign_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCVec_u8Z write_LDKSign_jcall(const void* this_arg) {
	LDKSign_JCalls *j_calls = (LDKSign_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_0(j_calls->instance_ptr, 13);
	LDKCVec_u8Z ret_ref;
	ret_ref.datalen = ret->arr_len;
	ret_ref.data = MALLOC(ret_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(ret_ref.data, ret->elems, ret_ref.datalen); FREE(ret);
	return ret_ref;
}
static void LDKSign_JCalls_cloned(LDKSign* new_obj) {
	LDKSign_JCalls *j_calls = (LDKSign_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
	atomic_fetch_add_explicit(&j_calls->BaseSign->refcnt, 1, memory_order_release);
}
static inline LDKSign LDKSign_init (JSValue o, JSValue BaseSign, uint32_t pubkeys) {
	LDKSign_JCalls *calls = MALLOC(sizeof(LDKSign_JCalls), "LDKSign_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKChannelPublicKeys pubkeys_conv;
	pubkeys_conv.inner = (void*)(pubkeys & (~1));
	pubkeys_conv.is_owned = (pubkeys & 1) || (pubkeys == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(pubkeys_conv);

	LDKSign ret = {
		.this_arg = (void*) calls,
		.write = write_LDKSign_jcall,
		.cloned = LDKSign_JCalls_cloned,
		.free = LDKSign_JCalls_free,
		.BaseSign = LDKBaseSign_init(BaseSign, pubkeys),
	};
	calls->BaseSign = ret.BaseSign.this_arg;
	return ret;
}
long  __attribute__((export_name("TS_LDKSign_new"))) TS_LDKSign_new(JSValue o, JSValue BaseSign, uint32_t pubkeys) {
	LDKSign *res_ptr = MALLOC(sizeof(LDKSign), "LDKSign");
	*res_ptr = LDKSign_init(o, BaseSign, pubkeys);
	return (long)res_ptr;
}
int8_tArray  __attribute__((export_name("TS_Sign_write"))) TS_Sign_write(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKSign* this_arg_conv = (LDKSign*)this_arg_ptr;
	LDKCVec_u8Z ret_var = (this_arg_conv->write)(this_arg_conv->this_arg);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

static inline struct LDKSign CResult_SignDecodeErrorZ_get_ok(LDKCResult_SignDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Sign_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_SignDecodeErrorZ_get_ok"))) TS_CResult_SignDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_SignDecodeErrorZ* owner_conv = (LDKCResult_SignDecodeErrorZ*)(owner & ~1);
	LDKSign* ret_ret = MALLOC(sizeof(LDKSign), "LDKSign");
	*ret_ret = CResult_SignDecodeErrorZ_get_ok(owner_conv);
	return (uint32_t)ret_ret;
}

static inline struct LDKDecodeError CResult_SignDecodeErrorZ_get_err(LDKCResult_SignDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_SignDecodeErrorZ_get_err"))) TS_CResult_SignDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_SignDecodeErrorZ* owner_conv = (LDKCResult_SignDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_SignDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKRecoverableSignature CResult_RecoverableSignatureNoneZ_get_ok(LDKCResult_RecoverableSignatureNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
int8_tArray  __attribute__((export_name("TS_CResult_RecoverableSignatureNoneZ_get_ok"))) TS_CResult_RecoverableSignatureNoneZ_get_ok(uint32_t owner) {
	LDKCResult_RecoverableSignatureNoneZ* owner_conv = (LDKCResult_RecoverableSignatureNoneZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(68, __LINE__);
	memcpy(ret_arr->elems, CResult_RecoverableSignatureNoneZ_get_ok(owner_conv).serialized_form, 68);
	return ret_arr;
}

static inline void CResult_RecoverableSignatureNoneZ_get_err(LDKCResult_RecoverableSignatureNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_RecoverableSignatureNoneZ_get_err"))) TS_CResult_RecoverableSignatureNoneZ_get_err(uint32_t owner) {
	LDKCResult_RecoverableSignatureNoneZ* owner_conv = (LDKCResult_RecoverableSignatureNoneZ*)(owner & ~1);
	CResult_RecoverableSignatureNoneZ_get_err(owner_conv);
}

static inline LDKCVec_CVec_u8ZZ CVec_CVec_u8ZZ_clone(const LDKCVec_CVec_u8ZZ *orig) {
	LDKCVec_CVec_u8ZZ ret = { .data = MALLOC(sizeof(LDKCVec_u8Z) * orig->datalen, "LDKCVec_CVec_u8ZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = CVec_u8Z_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKCVec_CVec_u8ZZ CResult_CVec_CVec_u8ZZNoneZ_get_ok(LDKCResult_CVec_CVec_u8ZZNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return CVec_CVec_u8ZZ_clone(&*owner->contents.result);
}
ptrArray  __attribute__((export_name("TS_CResult_CVec_CVec_u8ZZNoneZ_get_ok"))) TS_CResult_CVec_CVec_u8ZZNoneZ_get_ok(uint32_t owner) {
	LDKCResult_CVec_CVec_u8ZZNoneZ* owner_conv = (LDKCResult_CVec_CVec_u8ZZNoneZ*)(owner & ~1);
	LDKCVec_CVec_u8ZZ ret_var = CResult_CVec_CVec_u8ZZNoneZ_get_ok(owner_conv);
	ptrArray ret_arr = NULL;
	ret_arr = init_ptrArray(ret_var.datalen, __LINE__);
	int8_tArray *ret_arr_ptr = (int8_tArray*)(((uint8_t*)ret_arr) + 4);
	for (size_t m = 0; m < ret_var.datalen; m++) {
		LDKCVec_u8Z ret_conv_12_var = ret_var.data[m];
		int8_tArray ret_conv_12_arr = init_int8_tArray(ret_conv_12_var.datalen, __LINE__);
		memcpy(ret_conv_12_arr->elems, ret_conv_12_var.data, ret_conv_12_var.datalen);
		CVec_u8Z_free(ret_conv_12_var);
		ret_arr_ptr[m] = ret_conv_12_arr;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

static inline void CResult_CVec_CVec_u8ZZNoneZ_get_err(LDKCResult_CVec_CVec_u8ZZNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_CVec_CVec_u8ZZNoneZ_get_err"))) TS_CResult_CVec_CVec_u8ZZNoneZ_get_err(uint32_t owner) {
	LDKCResult_CVec_CVec_u8ZZNoneZ* owner_conv = (LDKCResult_CVec_CVec_u8ZZNoneZ*)(owner & ~1);
	CResult_CVec_CVec_u8ZZNoneZ_get_err(owner_conv);
}

static inline struct LDKInMemorySigner CResult_InMemorySignerDecodeErrorZ_get_ok(LDKCResult_InMemorySignerDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return InMemorySigner_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_InMemorySignerDecodeErrorZ_get_ok"))) TS_CResult_InMemorySignerDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_InMemorySignerDecodeErrorZ* owner_conv = (LDKCResult_InMemorySignerDecodeErrorZ*)(owner & ~1);
	LDKInMemorySigner ret_var = CResult_InMemorySignerDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_InMemorySignerDecodeErrorZ_get_err(LDKCResult_InMemorySignerDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_InMemorySignerDecodeErrorZ_get_err"))) TS_CResult_InMemorySignerDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_InMemorySignerDecodeErrorZ* owner_conv = (LDKCResult_InMemorySignerDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_InMemorySignerDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_TxOutZ CVec_TxOutZ_clone(const LDKCVec_TxOutZ *orig) {
	LDKCVec_TxOutZ ret = { .data = MALLOC(sizeof(LDKTxOut) * orig->datalen, "LDKCVec_TxOutZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = TxOut_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKTransaction CResult_TransactionNoneZ_get_ok(LDKCResult_TransactionNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
int8_tArray  __attribute__((export_name("TS_CResult_TransactionNoneZ_get_ok"))) TS_CResult_TransactionNoneZ_get_ok(uint32_t owner) {
	LDKCResult_TransactionNoneZ* owner_conv = (LDKCResult_TransactionNoneZ*)(owner & ~1);
	LDKTransaction ret_var = CResult_TransactionNoneZ_get_ok(owner_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	return ret_arr;
}

static inline void CResult_TransactionNoneZ_get_err(LDKCResult_TransactionNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_TransactionNoneZ_get_err"))) TS_CResult_TransactionNoneZ_get_err(uint32_t owner) {
	LDKCResult_TransactionNoneZ* owner_conv = (LDKCResult_TransactionNoneZ*)(owner & ~1);
	CResult_TransactionNoneZ_get_err(owner_conv);
}

uint32_t __attribute__((export_name("TS_LDKCOption_u16Z_ty_from_ptr"))) TS_LDKCOption_u16Z_ty_from_ptr(uint32_t ptr) {
	LDKCOption_u16Z *obj = (LDKCOption_u16Z*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_u16Z_Some: return 0;
		case LDKCOption_u16Z_None: return 1;
		default: abort();
	}
}
int16_t __attribute__((export_name("TS_LDKCOption_u16Z_Some_get_some"))) TS_LDKCOption_u16Z_Some_get_some(uint32_t ptr) {
	LDKCOption_u16Z *obj = (LDKCOption_u16Z*)(ptr & ~1);
	assert(obj->tag == LDKCOption_u16Z_Some);
	return obj->some;
}
uint32_t __attribute__((export_name("TS_LDKAPIError_ty_from_ptr"))) TS_LDKAPIError_ty_from_ptr(uint32_t ptr) {
	LDKAPIError *obj = (LDKAPIError*)(ptr & ~1);
	switch(obj->tag) {
		case LDKAPIError_APIMisuseError: return 0;
		case LDKAPIError_FeeRateTooHigh: return 1;
		case LDKAPIError_RouteError: return 2;
		case LDKAPIError_ChannelUnavailable: return 3;
		case LDKAPIError_MonitorUpdateFailed: return 4;
		case LDKAPIError_IncompatibleShutdownScript: return 5;
		default: abort();
	}
}
jstring __attribute__((export_name("TS_LDKAPIError_APIMisuseError_get_err"))) TS_LDKAPIError_APIMisuseError_get_err(uint32_t ptr) {
	LDKAPIError *obj = (LDKAPIError*)(ptr & ~1);
	assert(obj->tag == LDKAPIError_APIMisuseError);
			LDKStr err_str = obj->api_misuse_error.err;
			jstring err_conv = str_ref_to_ts(err_str.chars, err_str.len);
	return err_conv;
}
jstring __attribute__((export_name("TS_LDKAPIError_FeeRateTooHigh_get_err"))) TS_LDKAPIError_FeeRateTooHigh_get_err(uint32_t ptr) {
	LDKAPIError *obj = (LDKAPIError*)(ptr & ~1);
	assert(obj->tag == LDKAPIError_FeeRateTooHigh);
			LDKStr err_str = obj->fee_rate_too_high.err;
			jstring err_conv = str_ref_to_ts(err_str.chars, err_str.len);
	return err_conv;
}
int32_t __attribute__((export_name("TS_LDKAPIError_FeeRateTooHigh_get_feerate"))) TS_LDKAPIError_FeeRateTooHigh_get_feerate(uint32_t ptr) {
	LDKAPIError *obj = (LDKAPIError*)(ptr & ~1);
	assert(obj->tag == LDKAPIError_FeeRateTooHigh);
	return obj->fee_rate_too_high.feerate;
}
jstring __attribute__((export_name("TS_LDKAPIError_RouteError_get_err"))) TS_LDKAPIError_RouteError_get_err(uint32_t ptr) {
	LDKAPIError *obj = (LDKAPIError*)(ptr & ~1);
	assert(obj->tag == LDKAPIError_RouteError);
			LDKStr err_str = obj->route_error.err;
			jstring err_conv = str_ref_to_ts(err_str.chars, err_str.len);
	return err_conv;
}
jstring __attribute__((export_name("TS_LDKAPIError_ChannelUnavailable_get_err"))) TS_LDKAPIError_ChannelUnavailable_get_err(uint32_t ptr) {
	LDKAPIError *obj = (LDKAPIError*)(ptr & ~1);
	assert(obj->tag == LDKAPIError_ChannelUnavailable);
			LDKStr err_str = obj->channel_unavailable.err;
			jstring err_conv = str_ref_to_ts(err_str.chars, err_str.len);
	return err_conv;
}
uint32_t __attribute__((export_name("TS_LDKAPIError_IncompatibleShutdownScript_get_script"))) TS_LDKAPIError_IncompatibleShutdownScript_get_script(uint32_t ptr) {
	LDKAPIError *obj = (LDKAPIError*)(ptr & ~1);
	assert(obj->tag == LDKAPIError_IncompatibleShutdownScript);
			LDKShutdownScript script_var = obj->incompatible_shutdown_script.script;
			uint32_t script_ref = 0;
			CHECK((((uintptr_t)script_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&script_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(script_var);
			script_ref = (uintptr_t)script_var.inner & ~1;
	return script_ref;
}
static inline void CResult_NoneAPIErrorZ_get_ok(LDKCResult_NoneAPIErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
void  __attribute__((export_name("TS_CResult_NoneAPIErrorZ_get_ok"))) TS_CResult_NoneAPIErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NoneAPIErrorZ* owner_conv = (LDKCResult_NoneAPIErrorZ*)(owner & ~1);
	CResult_NoneAPIErrorZ_get_ok(owner_conv);
}

static inline struct LDKAPIError CResult_NoneAPIErrorZ_get_err(LDKCResult_NoneAPIErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return APIError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NoneAPIErrorZ_get_err"))) TS_CResult_NoneAPIErrorZ_get_err(uint32_t owner) {
	LDKCResult_NoneAPIErrorZ* owner_conv = (LDKCResult_NoneAPIErrorZ*)(owner & ~1);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = CResult_NoneAPIErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline LDKCVec_CResult_NoneAPIErrorZZ CVec_CResult_NoneAPIErrorZZ_clone(const LDKCVec_CResult_NoneAPIErrorZZ *orig) {
	LDKCVec_CResult_NoneAPIErrorZZ ret = { .data = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ) * orig->datalen, "LDKCVec_CResult_NoneAPIErrorZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = CResult_NoneAPIErrorZ_clone(&orig->data[i]);
	}
	return ret;
}
static inline LDKCVec_APIErrorZ CVec_APIErrorZ_clone(const LDKCVec_APIErrorZ *orig) {
	LDKCVec_APIErrorZ ret = { .data = MALLOC(sizeof(LDKAPIError) * orig->datalen, "LDKCVec_APIErrorZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = APIError_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKThirtyTwoBytes CResult__u832APIErrorZ_get_ok(LDKCResult__u832APIErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ThirtyTwoBytes_clone(&*owner->contents.result);
}
int8_tArray  __attribute__((export_name("TS_CResult__u832APIErrorZ_get_ok"))) TS_CResult__u832APIErrorZ_get_ok(uint32_t owner) {
	LDKCResult__u832APIErrorZ* owner_conv = (LDKCResult__u832APIErrorZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CResult__u832APIErrorZ_get_ok(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKAPIError CResult__u832APIErrorZ_get_err(LDKCResult__u832APIErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return APIError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult__u832APIErrorZ_get_err"))) TS_CResult__u832APIErrorZ_get_err(uint32_t owner) {
	LDKCResult__u832APIErrorZ* owner_conv = (LDKCResult__u832APIErrorZ*)(owner & ~1);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = CResult__u832APIErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKPaymentSendFailure_ty_from_ptr"))) TS_LDKPaymentSendFailure_ty_from_ptr(uint32_t ptr) {
	LDKPaymentSendFailure *obj = (LDKPaymentSendFailure*)(ptr & ~1);
	switch(obj->tag) {
		case LDKPaymentSendFailure_ParameterError: return 0;
		case LDKPaymentSendFailure_PathParameterError: return 1;
		case LDKPaymentSendFailure_AllFailedRetrySafe: return 2;
		case LDKPaymentSendFailure_PartialFailure: return 3;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKPaymentSendFailure_ParameterError_get_parameter_error"))) TS_LDKPaymentSendFailure_ParameterError_get_parameter_error(uint32_t ptr) {
	LDKPaymentSendFailure *obj = (LDKPaymentSendFailure*)(ptr & ~1);
	assert(obj->tag == LDKPaymentSendFailure_ParameterError);
			uint32_t parameter_error_ref = ((uintptr_t)&obj->parameter_error) | 1;
	return parameter_error_ref;
}
uint32_tArray __attribute__((export_name("TS_LDKPaymentSendFailure_PathParameterError_get_path_parameter_error"))) TS_LDKPaymentSendFailure_PathParameterError_get_path_parameter_error(uint32_t ptr) {
	LDKPaymentSendFailure *obj = (LDKPaymentSendFailure*)(ptr & ~1);
	assert(obj->tag == LDKPaymentSendFailure_PathParameterError);
			LDKCVec_CResult_NoneAPIErrorZZ path_parameter_error_var = obj->path_parameter_error;
			uint32_tArray path_parameter_error_arr = NULL;
			path_parameter_error_arr = init_uint32_tArray(path_parameter_error_var.datalen, __LINE__);
			uint32_t *path_parameter_error_arr_ptr = (uint32_t*)(((uint8_t*)path_parameter_error_arr) + 4);
			for (size_t w = 0; w < path_parameter_error_var.datalen; w++) {
				LDKCResult_NoneAPIErrorZ* path_parameter_error_conv_22_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
				*path_parameter_error_conv_22_conv = path_parameter_error_var.data[w];
				*path_parameter_error_conv_22_conv = CResult_NoneAPIErrorZ_clone(path_parameter_error_conv_22_conv);
				path_parameter_error_arr_ptr[w] = (uint32_t)path_parameter_error_conv_22_conv;
			}
			
	return path_parameter_error_arr;
}
uint32_tArray __attribute__((export_name("TS_LDKPaymentSendFailure_AllFailedRetrySafe_get_all_failed_retry_safe"))) TS_LDKPaymentSendFailure_AllFailedRetrySafe_get_all_failed_retry_safe(uint32_t ptr) {
	LDKPaymentSendFailure *obj = (LDKPaymentSendFailure*)(ptr & ~1);
	assert(obj->tag == LDKPaymentSendFailure_AllFailedRetrySafe);
			LDKCVec_APIErrorZ all_failed_retry_safe_var = obj->all_failed_retry_safe;
			uint32_tArray all_failed_retry_safe_arr = NULL;
			all_failed_retry_safe_arr = init_uint32_tArray(all_failed_retry_safe_var.datalen, __LINE__);
			uint32_t *all_failed_retry_safe_arr_ptr = (uint32_t*)(((uint8_t*)all_failed_retry_safe_arr) + 4);
			for (size_t k = 0; k < all_failed_retry_safe_var.datalen; k++) {
				uint32_t all_failed_retry_safe_conv_10_ref = ((uintptr_t)&all_failed_retry_safe_var.data[k]) | 1;
				all_failed_retry_safe_arr_ptr[k] = all_failed_retry_safe_conv_10_ref;
			}
			
	return all_failed_retry_safe_arr;
}
uint32_tArray __attribute__((export_name("TS_LDKPaymentSendFailure_PartialFailure_get_results"))) TS_LDKPaymentSendFailure_PartialFailure_get_results(uint32_t ptr) {
	LDKPaymentSendFailure *obj = (LDKPaymentSendFailure*)(ptr & ~1);
	assert(obj->tag == LDKPaymentSendFailure_PartialFailure);
			LDKCVec_CResult_NoneAPIErrorZZ results_var = obj->partial_failure.results;
			uint32_tArray results_arr = NULL;
			results_arr = init_uint32_tArray(results_var.datalen, __LINE__);
			uint32_t *results_arr_ptr = (uint32_t*)(((uint8_t*)results_arr) + 4);
			for (size_t w = 0; w < results_var.datalen; w++) {
				LDKCResult_NoneAPIErrorZ* results_conv_22_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
				*results_conv_22_conv = results_var.data[w];
				*results_conv_22_conv = CResult_NoneAPIErrorZ_clone(results_conv_22_conv);
				results_arr_ptr[w] = (uint32_t)results_conv_22_conv;
			}
			
	return results_arr;
}
uint32_t __attribute__((export_name("TS_LDKPaymentSendFailure_PartialFailure_get_failed_paths_retry"))) TS_LDKPaymentSendFailure_PartialFailure_get_failed_paths_retry(uint32_t ptr) {
	LDKPaymentSendFailure *obj = (LDKPaymentSendFailure*)(ptr & ~1);
	assert(obj->tag == LDKPaymentSendFailure_PartialFailure);
			LDKRouteParameters failed_paths_retry_var = obj->partial_failure.failed_paths_retry;
			uint32_t failed_paths_retry_ref = 0;
			if ((uintptr_t)failed_paths_retry_var.inner > 4096) {
				CHECK((((uintptr_t)failed_paths_retry_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
				CHECK((((uintptr_t)&failed_paths_retry_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(failed_paths_retry_var);
				failed_paths_retry_ref = (uintptr_t)failed_paths_retry_var.inner & ~1;
			}
	return failed_paths_retry_ref;
}
int8_tArray __attribute__((export_name("TS_LDKPaymentSendFailure_PartialFailure_get_payment_id"))) TS_LDKPaymentSendFailure_PartialFailure_get_payment_id(uint32_t ptr) {
	LDKPaymentSendFailure *obj = (LDKPaymentSendFailure*)(ptr & ~1);
	assert(obj->tag == LDKPaymentSendFailure_PartialFailure);
			int8_tArray payment_id_arr = init_int8_tArray(32, __LINE__);
			memcpy(payment_id_arr->elems, obj->partial_failure.payment_id.data, 32);
	return payment_id_arr;
}
static inline struct LDKThirtyTwoBytes CResult_PaymentIdPaymentSendFailureZ_get_ok(LDKCResult_PaymentIdPaymentSendFailureZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ThirtyTwoBytes_clone(&*owner->contents.result);
}
int8_tArray  __attribute__((export_name("TS_CResult_PaymentIdPaymentSendFailureZ_get_ok"))) TS_CResult_PaymentIdPaymentSendFailureZ_get_ok(uint32_t owner) {
	LDKCResult_PaymentIdPaymentSendFailureZ* owner_conv = (LDKCResult_PaymentIdPaymentSendFailureZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CResult_PaymentIdPaymentSendFailureZ_get_ok(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKPaymentSendFailure CResult_PaymentIdPaymentSendFailureZ_get_err(LDKCResult_PaymentIdPaymentSendFailureZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return PaymentSendFailure_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentSendFailureZ_get_err"))) TS_CResult_PaymentIdPaymentSendFailureZ_get_err(uint32_t owner) {
	LDKCResult_PaymentIdPaymentSendFailureZ* owner_conv = (LDKCResult_PaymentIdPaymentSendFailureZ*)(owner & ~1);
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = CResult_PaymentIdPaymentSendFailureZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline void CResult_NonePaymentSendFailureZ_get_ok(LDKCResult_NonePaymentSendFailureZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
void  __attribute__((export_name("TS_CResult_NonePaymentSendFailureZ_get_ok"))) TS_CResult_NonePaymentSendFailureZ_get_ok(uint32_t owner) {
	LDKCResult_NonePaymentSendFailureZ* owner_conv = (LDKCResult_NonePaymentSendFailureZ*)(owner & ~1);
	CResult_NonePaymentSendFailureZ_get_ok(owner_conv);
}

static inline struct LDKPaymentSendFailure CResult_NonePaymentSendFailureZ_get_err(LDKCResult_NonePaymentSendFailureZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return PaymentSendFailure_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NonePaymentSendFailureZ_get_err"))) TS_CResult_NonePaymentSendFailureZ_get_err(uint32_t owner) {
	LDKCResult_NonePaymentSendFailureZ* owner_conv = (LDKCResult_NonePaymentSendFailureZ*)(owner & ~1);
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = CResult_NonePaymentSendFailureZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKThirtyTwoBytes C2Tuple_PaymentHashPaymentIdZ_get_a(LDKC2Tuple_PaymentHashPaymentIdZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->a);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentIdZ_get_a"))) TS_C2Tuple_PaymentHashPaymentIdZ_get_a(uint32_t owner) {
	LDKC2Tuple_PaymentHashPaymentIdZ* owner_conv = (LDKC2Tuple_PaymentHashPaymentIdZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_PaymentHashPaymentIdZ_get_a(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKThirtyTwoBytes C2Tuple_PaymentHashPaymentIdZ_get_b(LDKC2Tuple_PaymentHashPaymentIdZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->b);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentIdZ_get_b"))) TS_C2Tuple_PaymentHashPaymentIdZ_get_b(uint32_t owner) {
	LDKC2Tuple_PaymentHashPaymentIdZ* owner_conv = (LDKC2Tuple_PaymentHashPaymentIdZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_PaymentHashPaymentIdZ_get_b(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKC2Tuple_PaymentHashPaymentIdZ CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_get_ok(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return C2Tuple_PaymentHashPaymentIdZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_get_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_get_ok(uint32_t owner) {
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* owner_conv = (LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ*)(owner & ~1);
	LDKC2Tuple_PaymentHashPaymentIdZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentIdZ), "LDKC2Tuple_PaymentHashPaymentIdZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_get_ok(owner_conv);
	return ((uint32_t)ret_conv);
}

static inline struct LDKPaymentSendFailure CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_get_err(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return PaymentSendFailure_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_get_err"))) TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_get_err(uint32_t owner) {
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* owner_conv = (LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ*)(owner & ~1);
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKNetAddress_ty_from_ptr"))) TS_LDKNetAddress_ty_from_ptr(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	switch(obj->tag) {
		case LDKNetAddress_IPv4: return 0;
		case LDKNetAddress_IPv6: return 1;
		case LDKNetAddress_OnionV2: return 2;
		case LDKNetAddress_OnionV3: return 3;
		default: abort();
	}
}
int8_tArray __attribute__((export_name("TS_LDKNetAddress_IPv4_get_addr"))) TS_LDKNetAddress_IPv4_get_addr(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_IPv4);
			int8_tArray addr_arr = init_int8_tArray(4, __LINE__);
			memcpy(addr_arr->elems, obj->i_pv4.addr.data, 4);
	return addr_arr;
}
int16_t __attribute__((export_name("TS_LDKNetAddress_IPv4_get_port"))) TS_LDKNetAddress_IPv4_get_port(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_IPv4);
	return obj->i_pv4.port;
}
int8_tArray __attribute__((export_name("TS_LDKNetAddress_IPv6_get_addr"))) TS_LDKNetAddress_IPv6_get_addr(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_IPv6);
			int8_tArray addr_arr = init_int8_tArray(16, __LINE__);
			memcpy(addr_arr->elems, obj->i_pv6.addr.data, 16);
	return addr_arr;
}
int16_t __attribute__((export_name("TS_LDKNetAddress_IPv6_get_port"))) TS_LDKNetAddress_IPv6_get_port(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_IPv6);
	return obj->i_pv6.port;
}
int8_tArray __attribute__((export_name("TS_LDKNetAddress_OnionV2_get_onion_v2"))) TS_LDKNetAddress_OnionV2_get_onion_v2(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_OnionV2);
			int8_tArray onion_v2_arr = init_int8_tArray(12, __LINE__);
			memcpy(onion_v2_arr->elems, obj->onion_v2.data, 12);
	return onion_v2_arr;
}
int8_tArray __attribute__((export_name("TS_LDKNetAddress_OnionV3_get_ed25519_pubkey"))) TS_LDKNetAddress_OnionV3_get_ed25519_pubkey(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_OnionV3);
			int8_tArray ed25519_pubkey_arr = init_int8_tArray(32, __LINE__);
			memcpy(ed25519_pubkey_arr->elems, obj->onion_v3.ed25519_pubkey.data, 32);
	return ed25519_pubkey_arr;
}
int16_t __attribute__((export_name("TS_LDKNetAddress_OnionV3_get_checksum"))) TS_LDKNetAddress_OnionV3_get_checksum(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_OnionV3);
	return obj->onion_v3.checksum;
}
int8_t __attribute__((export_name("TS_LDKNetAddress_OnionV3_get_version"))) TS_LDKNetAddress_OnionV3_get_version(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_OnionV3);
	return obj->onion_v3.version;
}
int16_t __attribute__((export_name("TS_LDKNetAddress_OnionV3_get_port"))) TS_LDKNetAddress_OnionV3_get_port(uint32_t ptr) {
	LDKNetAddress *obj = (LDKNetAddress*)(ptr & ~1);
	assert(obj->tag == LDKNetAddress_OnionV3);
	return obj->onion_v3.port;
}
static inline LDKCVec_NetAddressZ CVec_NetAddressZ_clone(const LDKCVec_NetAddressZ *orig) {
	LDKCVec_NetAddressZ ret = { .data = MALLOC(sizeof(LDKNetAddress) * orig->datalen, "LDKCVec_NetAddressZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = NetAddress_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKThirtyTwoBytes C2Tuple_PaymentHashPaymentSecretZ_get_a(LDKC2Tuple_PaymentHashPaymentSecretZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->a);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentSecretZ_get_a"))) TS_C2Tuple_PaymentHashPaymentSecretZ_get_a(uint32_t owner) {
	LDKC2Tuple_PaymentHashPaymentSecretZ* owner_conv = (LDKC2Tuple_PaymentHashPaymentSecretZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_PaymentHashPaymentSecretZ_get_a(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKThirtyTwoBytes C2Tuple_PaymentHashPaymentSecretZ_get_b(LDKC2Tuple_PaymentHashPaymentSecretZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->b);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentSecretZ_get_b"))) TS_C2Tuple_PaymentHashPaymentSecretZ_get_b(uint32_t owner) {
	LDKC2Tuple_PaymentHashPaymentSecretZ* owner_conv = (LDKC2Tuple_PaymentHashPaymentSecretZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_PaymentHashPaymentSecretZ_get_b(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKC2Tuple_PaymentHashPaymentSecretZ CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_get_ok(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return C2Tuple_PaymentHashPaymentSecretZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_get_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_get_ok(uint32_t owner) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* owner_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ*)(owner & ~1);
	LDKC2Tuple_PaymentHashPaymentSecretZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentSecretZ), "LDKC2Tuple_PaymentHashPaymentSecretZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_get_ok(owner_conv);
	return ((uint32_t)ret_conv);
}

static inline void CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_get_err(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_get_err"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_get_err(uint32_t owner) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* owner_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ*)(owner & ~1);
	CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_get_err(owner_conv);
}

static inline struct LDKC2Tuple_PaymentHashPaymentSecretZ CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_get_ok(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return C2Tuple_PaymentHashPaymentSecretZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_get_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_get_ok(uint32_t owner) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* owner_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ*)(owner & ~1);
	LDKC2Tuple_PaymentHashPaymentSecretZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentSecretZ), "LDKC2Tuple_PaymentHashPaymentSecretZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_get_ok(owner_conv);
	return ((uint32_t)ret_conv);
}

static inline struct LDKAPIError CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_get_err(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return APIError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_get_err"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_get_err(uint32_t owner) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* owner_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ*)(owner & ~1);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKThirtyTwoBytes CResult_PaymentSecretNoneZ_get_ok(LDKCResult_PaymentSecretNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ThirtyTwoBytes_clone(&*owner->contents.result);
}
int8_tArray  __attribute__((export_name("TS_CResult_PaymentSecretNoneZ_get_ok"))) TS_CResult_PaymentSecretNoneZ_get_ok(uint32_t owner) {
	LDKCResult_PaymentSecretNoneZ* owner_conv = (LDKCResult_PaymentSecretNoneZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CResult_PaymentSecretNoneZ_get_ok(owner_conv).data, 32);
	return ret_arr;
}

static inline void CResult_PaymentSecretNoneZ_get_err(LDKCResult_PaymentSecretNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_PaymentSecretNoneZ_get_err"))) TS_CResult_PaymentSecretNoneZ_get_err(uint32_t owner) {
	LDKCResult_PaymentSecretNoneZ* owner_conv = (LDKCResult_PaymentSecretNoneZ*)(owner & ~1);
	CResult_PaymentSecretNoneZ_get_err(owner_conv);
}

static inline struct LDKThirtyTwoBytes CResult_PaymentSecretAPIErrorZ_get_ok(LDKCResult_PaymentSecretAPIErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ThirtyTwoBytes_clone(&*owner->contents.result);
}
int8_tArray  __attribute__((export_name("TS_CResult_PaymentSecretAPIErrorZ_get_ok"))) TS_CResult_PaymentSecretAPIErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PaymentSecretAPIErrorZ* owner_conv = (LDKCResult_PaymentSecretAPIErrorZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CResult_PaymentSecretAPIErrorZ_get_ok(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKAPIError CResult_PaymentSecretAPIErrorZ_get_err(LDKCResult_PaymentSecretAPIErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return APIError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretAPIErrorZ_get_err"))) TS_CResult_PaymentSecretAPIErrorZ_get_err(uint32_t owner) {
	LDKCResult_PaymentSecretAPIErrorZ* owner_conv = (LDKCResult_PaymentSecretAPIErrorZ*)(owner & ~1);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = CResult_PaymentSecretAPIErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKThirtyTwoBytes CResult_PaymentPreimageAPIErrorZ_get_ok(LDKCResult_PaymentPreimageAPIErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ThirtyTwoBytes_clone(&*owner->contents.result);
}
int8_tArray  __attribute__((export_name("TS_CResult_PaymentPreimageAPIErrorZ_get_ok"))) TS_CResult_PaymentPreimageAPIErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PaymentPreimageAPIErrorZ* owner_conv = (LDKCResult_PaymentPreimageAPIErrorZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CResult_PaymentPreimageAPIErrorZ_get_ok(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKAPIError CResult_PaymentPreimageAPIErrorZ_get_err(LDKCResult_PaymentPreimageAPIErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return APIError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentPreimageAPIErrorZ_get_err"))) TS_CResult_PaymentPreimageAPIErrorZ_get_err(uint32_t owner) {
	LDKCResult_PaymentPreimageAPIErrorZ* owner_conv = (LDKCResult_PaymentPreimageAPIErrorZ*)(owner & ~1);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = CResult_PaymentPreimageAPIErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKCounterpartyForwardingInfo CResult_CounterpartyForwardingInfoDecodeErrorZ_get_ok(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return CounterpartyForwardingInfo_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_get_ok"))) TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* owner_conv = (LDKCResult_CounterpartyForwardingInfoDecodeErrorZ*)(owner & ~1);
	LDKCounterpartyForwardingInfo ret_var = CResult_CounterpartyForwardingInfoDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_CounterpartyForwardingInfoDecodeErrorZ_get_err(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_get_err"))) TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* owner_conv = (LDKCResult_CounterpartyForwardingInfoDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_CounterpartyForwardingInfoDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelCounterparty CResult_ChannelCounterpartyDecodeErrorZ_get_ok(LDKCResult_ChannelCounterpartyDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelCounterparty_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelCounterpartyDecodeErrorZ_get_ok"))) TS_CResult_ChannelCounterpartyDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelCounterpartyDecodeErrorZ* owner_conv = (LDKCResult_ChannelCounterpartyDecodeErrorZ*)(owner & ~1);
	LDKChannelCounterparty ret_var = CResult_ChannelCounterpartyDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelCounterpartyDecodeErrorZ_get_err(LDKCResult_ChannelCounterpartyDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelCounterpartyDecodeErrorZ_get_err"))) TS_CResult_ChannelCounterpartyDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelCounterpartyDecodeErrorZ* owner_conv = (LDKCResult_ChannelCounterpartyDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelCounterpartyDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelDetails CResult_ChannelDetailsDecodeErrorZ_get_ok(LDKCResult_ChannelDetailsDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelDetails_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelDetailsDecodeErrorZ_get_ok"))) TS_CResult_ChannelDetailsDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelDetailsDecodeErrorZ* owner_conv = (LDKCResult_ChannelDetailsDecodeErrorZ*)(owner & ~1);
	LDKChannelDetails ret_var = CResult_ChannelDetailsDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelDetailsDecodeErrorZ_get_err(LDKCResult_ChannelDetailsDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelDetailsDecodeErrorZ_get_err"))) TS_CResult_ChannelDetailsDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelDetailsDecodeErrorZ* owner_conv = (LDKCResult_ChannelDetailsDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelDetailsDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKPhantomRouteHints CResult_PhantomRouteHintsDecodeErrorZ_get_ok(LDKCResult_PhantomRouteHintsDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return PhantomRouteHints_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_PhantomRouteHintsDecodeErrorZ_get_ok"))) TS_CResult_PhantomRouteHintsDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PhantomRouteHintsDecodeErrorZ* owner_conv = (LDKCResult_PhantomRouteHintsDecodeErrorZ*)(owner & ~1);
	LDKPhantomRouteHints ret_var = CResult_PhantomRouteHintsDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_PhantomRouteHintsDecodeErrorZ_get_err(LDKCResult_PhantomRouteHintsDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PhantomRouteHintsDecodeErrorZ_get_err"))) TS_CResult_PhantomRouteHintsDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_PhantomRouteHintsDecodeErrorZ* owner_conv = (LDKCResult_PhantomRouteHintsDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_PhantomRouteHintsDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_ChannelMonitorZ CVec_ChannelMonitorZ_clone(const LDKCVec_ChannelMonitorZ *orig) {
	LDKCVec_ChannelMonitorZ ret = { .data = MALLOC(sizeof(LDKChannelMonitor) * orig->datalen, "LDKCVec_ChannelMonitorZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = ChannelMonitor_clone(&orig->data[i]);
	}
	return ret;
}
typedef struct LDKWatch_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKWatch_JCalls;
static void LDKWatch_JCalls_free(void* this_arg) {
	LDKWatch_JCalls *j_calls = (LDKWatch_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCResult_NoneChannelMonitorUpdateErrZ watch_channel_LDKWatch_jcall(const void* this_arg, LDKOutPoint funding_txo, LDKChannelMonitor monitor) {
	LDKWatch_JCalls *j_calls = (LDKWatch_JCalls*) this_arg;
	LDKOutPoint funding_txo_var = funding_txo;
	uint32_t funding_txo_ref = 0;
	CHECK((((uintptr_t)funding_txo_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&funding_txo_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_var);
	funding_txo_ref = (uintptr_t)funding_txo_var.inner;
	if (funding_txo_var.is_owned) {
		funding_txo_ref |= 1;
	}
	LDKChannelMonitor monitor_var = monitor;
	uint32_t monitor_ref = 0;
	CHECK((((uintptr_t)monitor_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&monitor_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(monitor_var);
	monitor_ref = (uintptr_t)monitor_var.inner;
	if (monitor_var.is_owned) {
		monitor_ref |= 1;
	}
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 14, (uint32_t)funding_txo_ref, (uint32_t)monitor_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneChannelMonitorUpdateErrZ ret_conv = *(LDKCResult_NoneChannelMonitorUpdateErrZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_NoneChannelMonitorUpdateErrZ update_channel_LDKWatch_jcall(const void* this_arg, LDKOutPoint funding_txo, LDKChannelMonitorUpdate update) {
	LDKWatch_JCalls *j_calls = (LDKWatch_JCalls*) this_arg;
	LDKOutPoint funding_txo_var = funding_txo;
	uint32_t funding_txo_ref = 0;
	CHECK((((uintptr_t)funding_txo_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&funding_txo_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_var);
	funding_txo_ref = (uintptr_t)funding_txo_var.inner;
	if (funding_txo_var.is_owned) {
		funding_txo_ref |= 1;
	}
	LDKChannelMonitorUpdate update_var = update;
	uint32_t update_ref = 0;
	CHECK((((uintptr_t)update_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&update_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_var);
	update_ref = (uintptr_t)update_var.inner;
	if (update_var.is_owned) {
		update_ref |= 1;
	}
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 15, (uint32_t)funding_txo_ref, (uint32_t)update_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneChannelMonitorUpdateErrZ ret_conv = *(LDKCResult_NoneChannelMonitorUpdateErrZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCVec_MonitorEventZ release_pending_monitor_events_LDKWatch_jcall(const void* this_arg) {
	LDKWatch_JCalls *j_calls = (LDKWatch_JCalls*) this_arg;
	uint32_tArray ret = (uint32_tArray)js_invoke_function_0(j_calls->instance_ptr, 16);
	LDKCVec_MonitorEventZ ret_constr;
	ret_constr.datalen = ret->arr_len;
	if (ret_constr.datalen > 0)
		ret_constr.data = MALLOC(ret_constr.datalen * sizeof(LDKMonitorEvent), "LDKCVec_MonitorEventZ Elements");
	else
		ret_constr.data = NULL;
	uint32_t* ret_vals = ret->elems /* XXX ret leaks */;
	for (size_t o = 0; o < ret_constr.datalen; o++) {
		uint32_t ret_conv_14 = ret_vals[o];
		void* ret_conv_14_ptr = (void*)(((uintptr_t)ret_conv_14) & ~1);
		CHECK_ACCESS(ret_conv_14_ptr);
		LDKMonitorEvent ret_conv_14_conv = *(LDKMonitorEvent*)(ret_conv_14_ptr);
		FREE((void*)ret_conv_14);
		ret_constr.data[o] = ret_conv_14_conv;
	}
	return ret_constr;
}
static void LDKWatch_JCalls_cloned(LDKWatch* new_obj) {
	LDKWatch_JCalls *j_calls = (LDKWatch_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKWatch LDKWatch_init (JSValue o) {
	LDKWatch_JCalls *calls = MALLOC(sizeof(LDKWatch_JCalls), "LDKWatch_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKWatch ret = {
		.this_arg = (void*) calls,
		.watch_channel = watch_channel_LDKWatch_jcall,
		.update_channel = update_channel_LDKWatch_jcall,
		.release_pending_monitor_events = release_pending_monitor_events_LDKWatch_jcall,
		.free = LDKWatch_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKWatch_new"))) TS_LDKWatch_new(JSValue o) {
	LDKWatch *res_ptr = MALLOC(sizeof(LDKWatch), "LDKWatch");
	*res_ptr = LDKWatch_init(o);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_Watch_watch_channel"))) TS_Watch_watch_channel(uint32_t this_arg, uint32_t funding_txo, uint32_t monitor) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKWatch* this_arg_conv = (LDKWatch*)this_arg_ptr;
	LDKOutPoint funding_txo_conv;
	funding_txo_conv.inner = (void*)(funding_txo & (~1));
	funding_txo_conv.is_owned = (funding_txo & 1) || (funding_txo == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_conv);
	funding_txo_conv = OutPoint_clone(&funding_txo_conv);
	LDKChannelMonitor monitor_conv;
	monitor_conv.inner = (void*)(monitor & (~1));
	monitor_conv.is_owned = (monitor & 1) || (monitor == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(monitor_conv);
	monitor_conv = ChannelMonitor_clone(&monitor_conv);
	LDKCResult_NoneChannelMonitorUpdateErrZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneChannelMonitorUpdateErrZ), "LDKCResult_NoneChannelMonitorUpdateErrZ");
	*ret_conv = (this_arg_conv->watch_channel)(this_arg_conv->this_arg, funding_txo_conv, monitor_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_Watch_update_channel"))) TS_Watch_update_channel(uint32_t this_arg, uint32_t funding_txo, uint32_t update) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKWatch* this_arg_conv = (LDKWatch*)this_arg_ptr;
	LDKOutPoint funding_txo_conv;
	funding_txo_conv.inner = (void*)(funding_txo & (~1));
	funding_txo_conv.is_owned = (funding_txo & 1) || (funding_txo == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_conv);
	funding_txo_conv = OutPoint_clone(&funding_txo_conv);
	LDKChannelMonitorUpdate update_conv;
	update_conv.inner = (void*)(update & (~1));
	update_conv.is_owned = (update & 1) || (update == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_conv);
	update_conv = ChannelMonitorUpdate_clone(&update_conv);
	LDKCResult_NoneChannelMonitorUpdateErrZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneChannelMonitorUpdateErrZ), "LDKCResult_NoneChannelMonitorUpdateErrZ");
	*ret_conv = (this_arg_conv->update_channel)(this_arg_conv->this_arg, funding_txo_conv, update_conv);
	return (uint32_t)ret_conv;
}

uint32_tArray  __attribute__((export_name("TS_Watch_release_pending_monitor_events"))) TS_Watch_release_pending_monitor_events(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKWatch* this_arg_conv = (LDKWatch*)this_arg_ptr;
	LDKCVec_MonitorEventZ ret_var = (this_arg_conv->release_pending_monitor_events)(this_arg_conv->this_arg);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t o = 0; o < ret_var.datalen; o++) {
		LDKMonitorEvent *ret_conv_14_copy = MALLOC(sizeof(LDKMonitorEvent), "LDKMonitorEvent");
		*ret_conv_14_copy = ret_var.data[o];
		uint32_t ret_conv_14_ref = (uintptr_t)ret_conv_14_copy;
		ret_arr_ptr[o] = ret_conv_14_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

typedef struct LDKBroadcasterInterface_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKBroadcasterInterface_JCalls;
static void LDKBroadcasterInterface_JCalls_free(void* this_arg) {
	LDKBroadcasterInterface_JCalls *j_calls = (LDKBroadcasterInterface_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
void broadcast_transaction_LDKBroadcasterInterface_jcall(const void* this_arg, LDKTransaction tx) {
	LDKBroadcasterInterface_JCalls *j_calls = (LDKBroadcasterInterface_JCalls*) this_arg;
	LDKTransaction tx_var = tx;
	int8_tArray tx_arr = init_int8_tArray(tx_var.datalen, __LINE__);
	memcpy(tx_arr->elems, tx_var.data, tx_var.datalen);
	Transaction_free(tx_var);
	js_invoke_function_1(j_calls->instance_ptr, 17, (uint32_t)tx_arr);
}
static void LDKBroadcasterInterface_JCalls_cloned(LDKBroadcasterInterface* new_obj) {
	LDKBroadcasterInterface_JCalls *j_calls = (LDKBroadcasterInterface_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKBroadcasterInterface LDKBroadcasterInterface_init (JSValue o) {
	LDKBroadcasterInterface_JCalls *calls = MALLOC(sizeof(LDKBroadcasterInterface_JCalls), "LDKBroadcasterInterface_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKBroadcasterInterface ret = {
		.this_arg = (void*) calls,
		.broadcast_transaction = broadcast_transaction_LDKBroadcasterInterface_jcall,
		.free = LDKBroadcasterInterface_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKBroadcasterInterface_new"))) TS_LDKBroadcasterInterface_new(JSValue o) {
	LDKBroadcasterInterface *res_ptr = MALLOC(sizeof(LDKBroadcasterInterface), "LDKBroadcasterInterface");
	*res_ptr = LDKBroadcasterInterface_init(o);
	return (long)res_ptr;
}
void  __attribute__((export_name("TS_BroadcasterInterface_broadcast_transaction"))) TS_BroadcasterInterface_broadcast_transaction(uint32_t this_arg, int8_tArray tx) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKBroadcasterInterface* this_arg_conv = (LDKBroadcasterInterface*)this_arg_ptr;
	LDKTransaction tx_ref;
	tx_ref.datalen = tx->arr_len;
	tx_ref.data = MALLOC(tx_ref.datalen, "LDKTransaction Bytes");
	memcpy(tx_ref.data, tx->elems, tx_ref.datalen); FREE(tx);
	tx_ref.data_is_owned = true;
	(this_arg_conv->broadcast_transaction)(this_arg_conv->this_arg, tx_ref);
}

typedef struct LDKKeysInterface_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKKeysInterface_JCalls;
static void LDKKeysInterface_JCalls_free(void* this_arg) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCResult_SecretKeyNoneZ get_node_secret_LDKKeysInterface_jcall(const void* this_arg, LDKRecipient recipient) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	uint32_t recipient_conv = LDKRecipient_to_js(recipient);
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 18, (uint32_t)recipient_conv);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_SecretKeyNoneZ ret_conv = *(LDKCResult_SecretKeyNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCVec_u8Z get_destination_script_LDKKeysInterface_jcall(const void* this_arg) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_0(j_calls->instance_ptr, 19);
	LDKCVec_u8Z ret_ref;
	ret_ref.datalen = ret->arr_len;
	ret_ref.data = MALLOC(ret_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(ret_ref.data, ret->elems, ret_ref.datalen); FREE(ret);
	return ret_ref;
}
LDKShutdownScript get_shutdown_scriptpubkey_LDKKeysInterface_jcall(const void* this_arg) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	uint32_t ret = js_invoke_function_0(j_calls->instance_ptr, 20);
	LDKShutdownScript ret_conv;
	ret_conv.inner = (void*)(ret & (~1));
	ret_conv.is_owned = (ret & 1) || (ret == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv);
	return ret_conv;
}
LDKSign get_channel_signer_LDKKeysInterface_jcall(const void* this_arg, bool inbound, uint64_t channel_value_satoshis) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 21, (uint32_t)inbound, (uint32_t)channel_value_satoshis);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKSign ret_conv = *(LDKSign*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKThirtyTwoBytes get_secure_random_bytes_LDKKeysInterface_jcall(const void* this_arg) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_0(j_calls->instance_ptr, 22);
	LDKThirtyTwoBytes ret_ref;
	CHECK(ret->arr_len == 32);
	memcpy(ret_ref.data, ret->elems, 32); FREE(ret);
	return ret_ref;
}
LDKCResult_SignDecodeErrorZ read_chan_signer_LDKKeysInterface_jcall(const void* this_arg, LDKu8slice reader) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	LDKu8slice reader_var = reader;
	int8_tArray reader_arr = init_int8_tArray(reader_var.datalen, __LINE__);
	memcpy(reader_arr->elems, reader_var.data, reader_var.datalen);
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 23, (uint32_t)reader_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_SignDecodeErrorZ ret_conv = *(LDKCResult_SignDecodeErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_RecoverableSignatureNoneZ sign_invoice_LDKKeysInterface_jcall(const void* this_arg, LDKu8slice hrp_bytes, LDKCVec_u5Z invoice_data, LDKRecipient receipient) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	LDKu8slice hrp_bytes_var = hrp_bytes;
	int8_tArray hrp_bytes_arr = init_int8_tArray(hrp_bytes_var.datalen, __LINE__);
	memcpy(hrp_bytes_arr->elems, hrp_bytes_var.data, hrp_bytes_var.datalen);
	LDKCVec_u5Z invoice_data_var = invoice_data;
	ptrArray invoice_data_arr = NULL;
	invoice_data_arr = init_ptrArray(invoice_data_var.datalen, __LINE__);
	int8_t *invoice_data_arr_ptr = (int8_t*)(((uint8_t*)invoice_data_arr) + 4);
	for (size_t h = 0; h < invoice_data_var.datalen; h++) {
		uint8_t invoice_data_conv_7_val = invoice_data_var.data[h]._0;
		invoice_data_arr_ptr[h] = invoice_data_conv_7_val;
	}
	
	FREE(invoice_data_var.data);
	uint32_t receipient_conv = LDKRecipient_to_js(receipient);
	uint32_t ret = js_invoke_function_3(j_calls->instance_ptr, 24, (uint32_t)hrp_bytes_arr, (uint32_t)invoice_data_arr, (uint32_t)receipient_conv);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_RecoverableSignatureNoneZ ret_conv = *(LDKCResult_RecoverableSignatureNoneZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKThirtyTwoBytes get_inbound_payment_key_material_LDKKeysInterface_jcall(const void* this_arg) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_0(j_calls->instance_ptr, 25);
	LDKThirtyTwoBytes ret_ref;
	CHECK(ret->arr_len == 32);
	memcpy(ret_ref.data, ret->elems, 32); FREE(ret);
	return ret_ref;
}
static void LDKKeysInterface_JCalls_cloned(LDKKeysInterface* new_obj) {
	LDKKeysInterface_JCalls *j_calls = (LDKKeysInterface_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKKeysInterface LDKKeysInterface_init (JSValue o) {
	LDKKeysInterface_JCalls *calls = MALLOC(sizeof(LDKKeysInterface_JCalls), "LDKKeysInterface_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKKeysInterface ret = {
		.this_arg = (void*) calls,
		.get_node_secret = get_node_secret_LDKKeysInterface_jcall,
		.get_destination_script = get_destination_script_LDKKeysInterface_jcall,
		.get_shutdown_scriptpubkey = get_shutdown_scriptpubkey_LDKKeysInterface_jcall,
		.get_channel_signer = get_channel_signer_LDKKeysInterface_jcall,
		.get_secure_random_bytes = get_secure_random_bytes_LDKKeysInterface_jcall,
		.read_chan_signer = read_chan_signer_LDKKeysInterface_jcall,
		.sign_invoice = sign_invoice_LDKKeysInterface_jcall,
		.get_inbound_payment_key_material = get_inbound_payment_key_material_LDKKeysInterface_jcall,
		.free = LDKKeysInterface_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKKeysInterface_new"))) TS_LDKKeysInterface_new(JSValue o) {
	LDKKeysInterface *res_ptr = MALLOC(sizeof(LDKKeysInterface), "LDKKeysInterface");
	*res_ptr = LDKKeysInterface_init(o);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_KeysInterface_get_node_secret"))) TS_KeysInterface_get_node_secret(uint32_t this_arg, uint32_t recipient) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKKeysInterface* this_arg_conv = (LDKKeysInterface*)this_arg_ptr;
	LDKRecipient recipient_conv = LDKRecipient_from_js(recipient);
	LDKCResult_SecretKeyNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyNoneZ), "LDKCResult_SecretKeyNoneZ");
	*ret_conv = (this_arg_conv->get_node_secret)(this_arg_conv->this_arg, recipient_conv);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_KeysInterface_get_destination_script"))) TS_KeysInterface_get_destination_script(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKKeysInterface* this_arg_conv = (LDKKeysInterface*)this_arg_ptr;
	LDKCVec_u8Z ret_var = (this_arg_conv->get_destination_script)(this_arg_conv->this_arg);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_KeysInterface_get_shutdown_scriptpubkey"))) TS_KeysInterface_get_shutdown_scriptpubkey(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKKeysInterface* this_arg_conv = (LDKKeysInterface*)this_arg_ptr;
	LDKShutdownScript ret_var = (this_arg_conv->get_shutdown_scriptpubkey)(this_arg_conv->this_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_KeysInterface_get_channel_signer"))) TS_KeysInterface_get_channel_signer(uint32_t this_arg, jboolean inbound, int64_t channel_value_satoshis) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKKeysInterface* this_arg_conv = (LDKKeysInterface*)this_arg_ptr;
	LDKSign* ret_ret = MALLOC(sizeof(LDKSign), "LDKSign");
	*ret_ret = (this_arg_conv->get_channel_signer)(this_arg_conv->this_arg, inbound, channel_value_satoshis);
	return (uint32_t)ret_ret;
}

int8_tArray  __attribute__((export_name("TS_KeysInterface_get_secure_random_bytes"))) TS_KeysInterface_get_secure_random_bytes(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKKeysInterface* this_arg_conv = (LDKKeysInterface*)this_arg_ptr;
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, (this_arg_conv->get_secure_random_bytes)(this_arg_conv->this_arg).data, 32);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_KeysInterface_read_chan_signer"))) TS_KeysInterface_read_chan_signer(uint32_t this_arg, int8_tArray reader) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKKeysInterface* this_arg_conv = (LDKKeysInterface*)this_arg_ptr;
	LDKu8slice reader_ref;
	reader_ref.datalen = reader->arr_len;
	reader_ref.data = reader->elems /* XXX reader leaks */;
	LDKCResult_SignDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignDecodeErrorZ), "LDKCResult_SignDecodeErrorZ");
	*ret_conv = (this_arg_conv->read_chan_signer)(this_arg_conv->this_arg, reader_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_KeysInterface_sign_invoice"))) TS_KeysInterface_sign_invoice(uint32_t this_arg, int8_tArray hrp_bytes, ptrArray invoice_data, uint32_t receipient) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKKeysInterface* this_arg_conv = (LDKKeysInterface*)this_arg_ptr;
	LDKu8slice hrp_bytes_ref;
	hrp_bytes_ref.datalen = hrp_bytes->arr_len;
	hrp_bytes_ref.data = hrp_bytes->elems /* XXX hrp_bytes leaks */;
	LDKCVec_u5Z invoice_data_constr;
	invoice_data_constr.datalen = invoice_data->arr_len;
	if (invoice_data_constr.datalen > 0)
		invoice_data_constr.data = MALLOC(invoice_data_constr.datalen * sizeof(LDKu5), "LDKCVec_u5Z Elements");
	else
		invoice_data_constr.data = NULL;
	int8_t* invoice_data_vals = (void*) invoice_data->elems /* XXX invoice_data leaks */;
	for (size_t h = 0; h < invoice_data_constr.datalen; h++) {
		int8_t invoice_data_conv_7 = invoice_data_vals[h];
		
		invoice_data_constr.data[h] = (LDKu5){ ._0 = invoice_data_conv_7 };
	}
	LDKRecipient receipient_conv = LDKRecipient_from_js(receipient);
	LDKCResult_RecoverableSignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_RecoverableSignatureNoneZ), "LDKCResult_RecoverableSignatureNoneZ");
	*ret_conv = (this_arg_conv->sign_invoice)(this_arg_conv->this_arg, hrp_bytes_ref, invoice_data_constr, receipient_conv);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_KeysInterface_get_inbound_payment_key_material"))) TS_KeysInterface_get_inbound_payment_key_material(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKKeysInterface* this_arg_conv = (LDKKeysInterface*)this_arg_ptr;
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, (this_arg_conv->get_inbound_payment_key_material)(this_arg_conv->this_arg).data, 32);
	return ret_arr;
}

typedef struct LDKFeeEstimator_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKFeeEstimator_JCalls;
static void LDKFeeEstimator_JCalls_free(void* this_arg) {
	LDKFeeEstimator_JCalls *j_calls = (LDKFeeEstimator_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
uint32_t get_est_sat_per_1000_weight_LDKFeeEstimator_jcall(const void* this_arg, LDKConfirmationTarget confirmation_target) {
	LDKFeeEstimator_JCalls *j_calls = (LDKFeeEstimator_JCalls*) this_arg;
	uint32_t confirmation_target_conv = LDKConfirmationTarget_to_js(confirmation_target);
	return js_invoke_function_1(j_calls->instance_ptr, 26, (uint32_t)confirmation_target_conv);
}
static void LDKFeeEstimator_JCalls_cloned(LDKFeeEstimator* new_obj) {
	LDKFeeEstimator_JCalls *j_calls = (LDKFeeEstimator_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKFeeEstimator LDKFeeEstimator_init (JSValue o) {
	LDKFeeEstimator_JCalls *calls = MALLOC(sizeof(LDKFeeEstimator_JCalls), "LDKFeeEstimator_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKFeeEstimator ret = {
		.this_arg = (void*) calls,
		.get_est_sat_per_1000_weight = get_est_sat_per_1000_weight_LDKFeeEstimator_jcall,
		.free = LDKFeeEstimator_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKFeeEstimator_new"))) TS_LDKFeeEstimator_new(JSValue o) {
	LDKFeeEstimator *res_ptr = MALLOC(sizeof(LDKFeeEstimator), "LDKFeeEstimator");
	*res_ptr = LDKFeeEstimator_init(o);
	return (long)res_ptr;
}
int32_t  __attribute__((export_name("TS_FeeEstimator_get_est_sat_per_1000_weight"))) TS_FeeEstimator_get_est_sat_per_1000_weight(uint32_t this_arg, uint32_t confirmation_target) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKFeeEstimator* this_arg_conv = (LDKFeeEstimator*)this_arg_ptr;
	LDKConfirmationTarget confirmation_target_conv = LDKConfirmationTarget_from_js(confirmation_target);
	int32_t ret_val = (this_arg_conv->get_est_sat_per_1000_weight)(this_arg_conv->this_arg, confirmation_target_conv);
	return ret_val;
}

typedef struct LDKLogger_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKLogger_JCalls;
static void LDKLogger_JCalls_free(void* this_arg) {
	LDKLogger_JCalls *j_calls = (LDKLogger_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
void log_LDKLogger_jcall(const void* this_arg, const LDKRecord * record) {
	LDKLogger_JCalls *j_calls = (LDKLogger_JCalls*) this_arg;
	LDKRecord record_var = *record;
	uint32_t record_ref = 0;
	record_var = Record_clone(&record_var);
	CHECK((((uintptr_t)record_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&record_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(record_var);
	record_ref = (uintptr_t)record_var.inner;
	if (record_var.is_owned) {
		record_ref |= 1;
	}
	js_invoke_function_1(j_calls->instance_ptr, 27, (uint32_t)record_ref);
}
static void LDKLogger_JCalls_cloned(LDKLogger* new_obj) {
	LDKLogger_JCalls *j_calls = (LDKLogger_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKLogger LDKLogger_init (JSValue o) {
	LDKLogger_JCalls *calls = MALLOC(sizeof(LDKLogger_JCalls), "LDKLogger_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKLogger ret = {
		.this_arg = (void*) calls,
		.log = log_LDKLogger_jcall,
		.free = LDKLogger_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKLogger_new"))) TS_LDKLogger_new(JSValue o) {
	LDKLogger *res_ptr = MALLOC(sizeof(LDKLogger), "LDKLogger");
	*res_ptr = LDKLogger_init(o);
	return (long)res_ptr;
}
static inline struct LDKThirtyTwoBytes C2Tuple_BlockHashChannelManagerZ_get_a(LDKC2Tuple_BlockHashChannelManagerZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->a);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_BlockHashChannelManagerZ_get_a"))) TS_C2Tuple_BlockHashChannelManagerZ_get_a(uint32_t owner) {
	LDKC2Tuple_BlockHashChannelManagerZ* owner_conv = (LDKC2Tuple_BlockHashChannelManagerZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_BlockHashChannelManagerZ_get_a(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKChannelManager *C2Tuple_BlockHashChannelManagerZ_get_b(LDKC2Tuple_BlockHashChannelManagerZ *NONNULL_PTR owner){
	return &owner->b;
}
uint32_t  __attribute__((export_name("TS_C2Tuple_BlockHashChannelManagerZ_get_b"))) TS_C2Tuple_BlockHashChannelManagerZ_get_b(uint32_t owner) {
	LDKC2Tuple_BlockHashChannelManagerZ* owner_conv = (LDKC2Tuple_BlockHashChannelManagerZ*)(owner & ~1);
	LDKChannelManager ret_var = *C2Tuple_BlockHashChannelManagerZ_get_b(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner & ~1;
	return ret_ref;
}

static inline struct LDKC2Tuple_BlockHashChannelManagerZ *CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_get_ok(LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return &*owner->contents.result;
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_get_ok"))) TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ* owner_conv = (LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ*)(owner & ~1);
	uint32_t ret_ret = (uintptr_t)CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_get_ok(owner_conv) | 1;
	return ret_ret;
}

static inline struct LDKDecodeError CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_get_err(LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_get_err"))) TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ* owner_conv = (LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelConfig CResult_ChannelConfigDecodeErrorZ_get_ok(LDKCResult_ChannelConfigDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelConfig_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelConfigDecodeErrorZ_get_ok"))) TS_CResult_ChannelConfigDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelConfigDecodeErrorZ* owner_conv = (LDKCResult_ChannelConfigDecodeErrorZ*)(owner & ~1);
	LDKChannelConfig ret_var = CResult_ChannelConfigDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelConfigDecodeErrorZ_get_err(LDKCResult_ChannelConfigDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelConfigDecodeErrorZ_get_err"))) TS_CResult_ChannelConfigDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelConfigDecodeErrorZ* owner_conv = (LDKCResult_ChannelConfigDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelConfigDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKOutPoint CResult_OutPointDecodeErrorZ_get_ok(LDKCResult_OutPointDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return OutPoint_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_OutPointDecodeErrorZ_get_ok"))) TS_CResult_OutPointDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_OutPointDecodeErrorZ* owner_conv = (LDKCResult_OutPointDecodeErrorZ*)(owner & ~1);
	LDKOutPoint ret_var = CResult_OutPointDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_OutPointDecodeErrorZ_get_err(LDKCResult_OutPointDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_OutPointDecodeErrorZ_get_err"))) TS_CResult_OutPointDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_OutPointDecodeErrorZ* owner_conv = (LDKCResult_OutPointDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_OutPointDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

typedef struct LDKType_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKType_JCalls;
static void LDKType_JCalls_free(void* this_arg) {
	LDKType_JCalls *j_calls = (LDKType_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
uint16_t type_id_LDKType_jcall(const void* this_arg) {
	LDKType_JCalls *j_calls = (LDKType_JCalls*) this_arg;
	return js_invoke_function_0(j_calls->instance_ptr, 28);
}
LDKStr debug_str_LDKType_jcall(const void* this_arg) {
	LDKType_JCalls *j_calls = (LDKType_JCalls*) this_arg;
	jstring ret = (jstring)js_invoke_function_0(j_calls->instance_ptr, 29);
	LDKStr ret_conv = str_ref_to_owned_c(ret);
	return ret_conv;
}
LDKCVec_u8Z write_LDKType_jcall(const void* this_arg) {
	LDKType_JCalls *j_calls = (LDKType_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_0(j_calls->instance_ptr, 30);
	LDKCVec_u8Z ret_ref;
	ret_ref.datalen = ret->arr_len;
	ret_ref.data = MALLOC(ret_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(ret_ref.data, ret->elems, ret_ref.datalen); FREE(ret);
	return ret_ref;
}
static void LDKType_JCalls_cloned(LDKType* new_obj) {
	LDKType_JCalls *j_calls = (LDKType_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKType LDKType_init (JSValue o) {
	LDKType_JCalls *calls = MALLOC(sizeof(LDKType_JCalls), "LDKType_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKType ret = {
		.this_arg = (void*) calls,
		.type_id = type_id_LDKType_jcall,
		.debug_str = debug_str_LDKType_jcall,
		.write = write_LDKType_jcall,
		.cloned = LDKType_JCalls_cloned,
		.free = LDKType_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKType_new"))) TS_LDKType_new(JSValue o) {
	LDKType *res_ptr = MALLOC(sizeof(LDKType), "LDKType");
	*res_ptr = LDKType_init(o);
	return (long)res_ptr;
}
int16_t  __attribute__((export_name("TS_Type_type_id"))) TS_Type_type_id(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKType* this_arg_conv = (LDKType*)this_arg_ptr;
	int16_t ret_val = (this_arg_conv->type_id)(this_arg_conv->this_arg);
	return ret_val;
}

jstring  __attribute__((export_name("TS_Type_debug_str"))) TS_Type_debug_str(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKType* this_arg_conv = (LDKType*)this_arg_ptr;
	LDKStr ret_str = (this_arg_conv->debug_str)(this_arg_conv->this_arg);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

int8_tArray  __attribute__((export_name("TS_Type_write"))) TS_Type_write(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKType* this_arg_conv = (LDKType*)this_arg_ptr;
	LDKCVec_u8Z ret_var = (this_arg_conv->write)(this_arg_conv->this_arg);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t __attribute__((export_name("TS_LDKCOption_TypeZ_ty_from_ptr"))) TS_LDKCOption_TypeZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_TypeZ *obj = (LDKCOption_TypeZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_TypeZ_Some: return 0;
		case LDKCOption_TypeZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_TypeZ_Some_get_some"))) TS_LDKCOption_TypeZ_Some_get_some(uint32_t ptr) {
	LDKCOption_TypeZ *obj = (LDKCOption_TypeZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_TypeZ_Some);
			LDKType* some_ret = MALLOC(sizeof(LDKType), "LDKType");
			*some_ret = Type_clone(&obj->some);
	return (uint32_t)some_ret;
}
static inline struct LDKCOption_TypeZ CResult_COption_TypeZDecodeErrorZ_get_ok(LDKCResult_COption_TypeZDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return COption_TypeZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_TypeZDecodeErrorZ_get_ok"))) TS_CResult_COption_TypeZDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_COption_TypeZDecodeErrorZ* owner_conv = (LDKCResult_COption_TypeZDecodeErrorZ*)(owner & ~1);
	LDKCOption_TypeZ *ret_copy = MALLOC(sizeof(LDKCOption_TypeZ), "LDKCOption_TypeZ");
	*ret_copy = CResult_COption_TypeZDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_COption_TypeZDecodeErrorZ_get_err(LDKCResult_COption_TypeZDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_TypeZDecodeErrorZ_get_err"))) TS_CResult_COption_TypeZDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_COption_TypeZDecodeErrorZ* owner_conv = (LDKCResult_COption_TypeZDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_COption_TypeZDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKPaymentError_ty_from_ptr"))) TS_LDKPaymentError_ty_from_ptr(uint32_t ptr) {
	LDKPaymentError *obj = (LDKPaymentError*)(ptr & ~1);
	switch(obj->tag) {
		case LDKPaymentError_Invoice: return 0;
		case LDKPaymentError_Routing: return 1;
		case LDKPaymentError_Sending: return 2;
		default: abort();
	}
}
jstring __attribute__((export_name("TS_LDKPaymentError_Invoice_get_invoice"))) TS_LDKPaymentError_Invoice_get_invoice(uint32_t ptr) {
	LDKPaymentError *obj = (LDKPaymentError*)(ptr & ~1);
	assert(obj->tag == LDKPaymentError_Invoice);
			LDKStr invoice_str = obj->invoice;
			jstring invoice_conv = str_ref_to_ts(invoice_str.chars, invoice_str.len);
	return invoice_conv;
}
uint32_t __attribute__((export_name("TS_LDKPaymentError_Routing_get_routing"))) TS_LDKPaymentError_Routing_get_routing(uint32_t ptr) {
	LDKPaymentError *obj = (LDKPaymentError*)(ptr & ~1);
	assert(obj->tag == LDKPaymentError_Routing);
			LDKLightningError routing_var = obj->routing;
			uint32_t routing_ref = 0;
			CHECK((((uintptr_t)routing_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&routing_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(routing_var);
			routing_ref = (uintptr_t)routing_var.inner & ~1;
	return routing_ref;
}
uint32_t __attribute__((export_name("TS_LDKPaymentError_Sending_get_sending"))) TS_LDKPaymentError_Sending_get_sending(uint32_t ptr) {
	LDKPaymentError *obj = (LDKPaymentError*)(ptr & ~1);
	assert(obj->tag == LDKPaymentError_Sending);
			uint32_t sending_ref = ((uintptr_t)&obj->sending) | 1;
	return sending_ref;
}
static inline struct LDKThirtyTwoBytes CResult_PaymentIdPaymentErrorZ_get_ok(LDKCResult_PaymentIdPaymentErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ThirtyTwoBytes_clone(&*owner->contents.result);
}
int8_tArray  __attribute__((export_name("TS_CResult_PaymentIdPaymentErrorZ_get_ok"))) TS_CResult_PaymentIdPaymentErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PaymentIdPaymentErrorZ* owner_conv = (LDKCResult_PaymentIdPaymentErrorZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CResult_PaymentIdPaymentErrorZ_get_ok(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKPaymentError CResult_PaymentIdPaymentErrorZ_get_err(LDKCResult_PaymentIdPaymentErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return PaymentError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentErrorZ_get_err"))) TS_CResult_PaymentIdPaymentErrorZ_get_err(uint32_t owner) {
	LDKCResult_PaymentIdPaymentErrorZ* owner_conv = (LDKCResult_PaymentIdPaymentErrorZ*)(owner & ~1);
	LDKPaymentError *ret_copy = MALLOC(sizeof(LDKPaymentError), "LDKPaymentError");
	*ret_copy = CResult_PaymentIdPaymentErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKParseError_ty_from_ptr"))) TS_LDKParseError_ty_from_ptr(uint32_t ptr) {
	LDKParseError *obj = (LDKParseError*)(ptr & ~1);
	switch(obj->tag) {
		case LDKParseError_Bech32Error: return 0;
		case LDKParseError_ParseAmountError: return 1;
		case LDKParseError_MalformedSignature: return 2;
		case LDKParseError_BadPrefix: return 3;
		case LDKParseError_UnknownCurrency: return 4;
		case LDKParseError_UnknownSiPrefix: return 5;
		case LDKParseError_MalformedHRP: return 6;
		case LDKParseError_TooShortDataPart: return 7;
		case LDKParseError_UnexpectedEndOfTaggedFields: return 8;
		case LDKParseError_DescriptionDecodeError: return 9;
		case LDKParseError_PaddingError: return 10;
		case LDKParseError_IntegerOverflowError: return 11;
		case LDKParseError_InvalidSegWitProgramLength: return 12;
		case LDKParseError_InvalidPubKeyHashLength: return 13;
		case LDKParseError_InvalidScriptHashLength: return 14;
		case LDKParseError_InvalidRecoveryId: return 15;
		case LDKParseError_InvalidSliceLength: return 16;
		case LDKParseError_Skip: return 17;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKParseError_Bech32Error_get_bech32_error"))) TS_LDKParseError_Bech32Error_get_bech32_error(uint32_t ptr) {
	LDKParseError *obj = (LDKParseError*)(ptr & ~1);
	assert(obj->tag == LDKParseError_Bech32Error);
			uint32_t bech32_error_ref = ((uintptr_t)&obj->bech32_error) | 1;
	return bech32_error_ref;
}
int32_t __attribute__((export_name("TS_LDKParseError_ParseAmountError_get_parse_amount_error"))) TS_LDKParseError_ParseAmountError_get_parse_amount_error(uint32_t ptr) {
	LDKParseError *obj = (LDKParseError*)(ptr & ~1);
	assert(obj->tag == LDKParseError_ParseAmountError);
			/*obj->parse_amount_error*/
	return 0;
}
uint32_t __attribute__((export_name("TS_LDKParseError_MalformedSignature_get_malformed_signature"))) TS_LDKParseError_MalformedSignature_get_malformed_signature(uint32_t ptr) {
	LDKParseError *obj = (LDKParseError*)(ptr & ~1);
	assert(obj->tag == LDKParseError_MalformedSignature);
			uint32_t malformed_signature_conv = LDKSecp256k1Error_to_js(obj->malformed_signature);
	return malformed_signature_conv;
}
int32_t __attribute__((export_name("TS_LDKParseError_DescriptionDecodeError_get_description_decode_error"))) TS_LDKParseError_DescriptionDecodeError_get_description_decode_error(uint32_t ptr) {
	LDKParseError *obj = (LDKParseError*)(ptr & ~1);
	assert(obj->tag == LDKParseError_DescriptionDecodeError);
			/*obj->description_decode_error*/
	return 0;
}
jstring __attribute__((export_name("TS_LDKParseError_InvalidSliceLength_get_invalid_slice_length"))) TS_LDKParseError_InvalidSliceLength_get_invalid_slice_length(uint32_t ptr) {
	LDKParseError *obj = (LDKParseError*)(ptr & ~1);
	assert(obj->tag == LDKParseError_InvalidSliceLength);
			LDKStr invalid_slice_length_str = obj->invalid_slice_length;
			jstring invalid_slice_length_conv = str_ref_to_ts(invalid_slice_length_str.chars, invalid_slice_length_str.len);
	return invalid_slice_length_conv;
}
static inline enum LDKSiPrefix CResult_SiPrefixParseErrorZ_get_ok(LDKCResult_SiPrefixParseErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return SiPrefix_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_SiPrefixParseErrorZ_get_ok"))) TS_CResult_SiPrefixParseErrorZ_get_ok(uint32_t owner) {
	LDKCResult_SiPrefixParseErrorZ* owner_conv = (LDKCResult_SiPrefixParseErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKSiPrefix_to_js(CResult_SiPrefixParseErrorZ_get_ok(owner_conv));
	return ret_conv;
}

static inline struct LDKParseError CResult_SiPrefixParseErrorZ_get_err(LDKCResult_SiPrefixParseErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return ParseError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_SiPrefixParseErrorZ_get_err"))) TS_CResult_SiPrefixParseErrorZ_get_err(uint32_t owner) {
	LDKCResult_SiPrefixParseErrorZ* owner_conv = (LDKCResult_SiPrefixParseErrorZ*)(owner & ~1);
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = CResult_SiPrefixParseErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKParseOrSemanticError_ty_from_ptr"))) TS_LDKParseOrSemanticError_ty_from_ptr(uint32_t ptr) {
	LDKParseOrSemanticError *obj = (LDKParseOrSemanticError*)(ptr & ~1);
	switch(obj->tag) {
		case LDKParseOrSemanticError_ParseError: return 0;
		case LDKParseOrSemanticError_SemanticError: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKParseOrSemanticError_ParseError_get_parse_error"))) TS_LDKParseOrSemanticError_ParseError_get_parse_error(uint32_t ptr) {
	LDKParseOrSemanticError *obj = (LDKParseOrSemanticError*)(ptr & ~1);
	assert(obj->tag == LDKParseOrSemanticError_ParseError);
			uint32_t parse_error_ref = ((uintptr_t)&obj->parse_error) | 1;
	return parse_error_ref;
}
uint32_t __attribute__((export_name("TS_LDKParseOrSemanticError_SemanticError_get_semantic_error"))) TS_LDKParseOrSemanticError_SemanticError_get_semantic_error(uint32_t ptr) {
	LDKParseOrSemanticError *obj = (LDKParseOrSemanticError*)(ptr & ~1);
	assert(obj->tag == LDKParseOrSemanticError_SemanticError);
			uint32_t semantic_error_conv = LDKSemanticError_to_js(obj->semantic_error);
	return semantic_error_conv;
}
static inline struct LDKInvoice CResult_InvoiceParseOrSemanticErrorZ_get_ok(LDKCResult_InvoiceParseOrSemanticErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Invoice_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceParseOrSemanticErrorZ_get_ok"))) TS_CResult_InvoiceParseOrSemanticErrorZ_get_ok(uint32_t owner) {
	LDKCResult_InvoiceParseOrSemanticErrorZ* owner_conv = (LDKCResult_InvoiceParseOrSemanticErrorZ*)(owner & ~1);
	LDKInvoice ret_var = CResult_InvoiceParseOrSemanticErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKParseOrSemanticError CResult_InvoiceParseOrSemanticErrorZ_get_err(LDKCResult_InvoiceParseOrSemanticErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return ParseOrSemanticError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceParseOrSemanticErrorZ_get_err"))) TS_CResult_InvoiceParseOrSemanticErrorZ_get_err(uint32_t owner) {
	LDKCResult_InvoiceParseOrSemanticErrorZ* owner_conv = (LDKCResult_InvoiceParseOrSemanticErrorZ*)(owner & ~1);
	LDKParseOrSemanticError *ret_copy = MALLOC(sizeof(LDKParseOrSemanticError), "LDKParseOrSemanticError");
	*ret_copy = CResult_InvoiceParseOrSemanticErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKSignedRawInvoice CResult_SignedRawInvoiceParseErrorZ_get_ok(LDKCResult_SignedRawInvoiceParseErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return SignedRawInvoice_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_SignedRawInvoiceParseErrorZ_get_ok"))) TS_CResult_SignedRawInvoiceParseErrorZ_get_ok(uint32_t owner) {
	LDKCResult_SignedRawInvoiceParseErrorZ* owner_conv = (LDKCResult_SignedRawInvoiceParseErrorZ*)(owner & ~1);
	LDKSignedRawInvoice ret_var = CResult_SignedRawInvoiceParseErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKParseError CResult_SignedRawInvoiceParseErrorZ_get_err(LDKCResult_SignedRawInvoiceParseErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return ParseError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_SignedRawInvoiceParseErrorZ_get_err"))) TS_CResult_SignedRawInvoiceParseErrorZ_get_err(uint32_t owner) {
	LDKCResult_SignedRawInvoiceParseErrorZ* owner_conv = (LDKCResult_SignedRawInvoiceParseErrorZ*)(owner & ~1);
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = CResult_SignedRawInvoiceParseErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKRawInvoice C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_a(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ *NONNULL_PTR owner){
	return RawInvoice_clone(&owner->a);
}
uint32_t  __attribute__((export_name("TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_a"))) TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_a(uint32_t owner) {
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* owner_conv = (LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ*)(owner & ~1);
	LDKRawInvoice ret_var = C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_a(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKThirtyTwoBytes C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_b(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->b);
}
int8_tArray  __attribute__((export_name("TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_b"))) TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_b(uint32_t owner) {
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* owner_conv = (LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_b(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKInvoiceSignature C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_c(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ *NONNULL_PTR owner){
	return InvoiceSignature_clone(&owner->c);
}
uint32_t  __attribute__((export_name("TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_c"))) TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_c(uint32_t owner) {
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* owner_conv = (LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ*)(owner & ~1);
	LDKInvoiceSignature ret_var = C3Tuple_RawInvoice_u832InvoiceSignatureZ_get_c(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKPayeePubKey CResult_PayeePubKeyErrorZ_get_ok(LDKCResult_PayeePubKeyErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return PayeePubKey_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_PayeePubKeyErrorZ_get_ok"))) TS_CResult_PayeePubKeyErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PayeePubKeyErrorZ* owner_conv = (LDKCResult_PayeePubKeyErrorZ*)(owner & ~1);
	LDKPayeePubKey ret_var = CResult_PayeePubKeyErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline enum LDKSecp256k1Error CResult_PayeePubKeyErrorZ_get_err(LDKCResult_PayeePubKeyErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
uint32_t  __attribute__((export_name("TS_CResult_PayeePubKeyErrorZ_get_err"))) TS_CResult_PayeePubKeyErrorZ_get_err(uint32_t owner) {
	LDKCResult_PayeePubKeyErrorZ* owner_conv = (LDKCResult_PayeePubKeyErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKSecp256k1Error_to_js(CResult_PayeePubKeyErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline LDKCVec_PrivateRouteZ CVec_PrivateRouteZ_clone(const LDKCVec_PrivateRouteZ *orig) {
	LDKCVec_PrivateRouteZ ret = { .data = MALLOC(sizeof(LDKPrivateRoute) * orig->datalen, "LDKCVec_PrivateRouteZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = PrivateRoute_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKPositiveTimestamp CResult_PositiveTimestampCreationErrorZ_get_ok(LDKCResult_PositiveTimestampCreationErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return PositiveTimestamp_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_PositiveTimestampCreationErrorZ_get_ok"))) TS_CResult_PositiveTimestampCreationErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PositiveTimestampCreationErrorZ* owner_conv = (LDKCResult_PositiveTimestampCreationErrorZ*)(owner & ~1);
	LDKPositiveTimestamp ret_var = CResult_PositiveTimestampCreationErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline enum LDKCreationError CResult_PositiveTimestampCreationErrorZ_get_err(LDKCResult_PositiveTimestampCreationErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return CreationError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PositiveTimestampCreationErrorZ_get_err"))) TS_CResult_PositiveTimestampCreationErrorZ_get_err(uint32_t owner) {
	LDKCResult_PositiveTimestampCreationErrorZ* owner_conv = (LDKCResult_PositiveTimestampCreationErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKCreationError_to_js(CResult_PositiveTimestampCreationErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline void CResult_NoneSemanticErrorZ_get_ok(LDKCResult_NoneSemanticErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
void  __attribute__((export_name("TS_CResult_NoneSemanticErrorZ_get_ok"))) TS_CResult_NoneSemanticErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NoneSemanticErrorZ* owner_conv = (LDKCResult_NoneSemanticErrorZ*)(owner & ~1);
	CResult_NoneSemanticErrorZ_get_ok(owner_conv);
}

static inline enum LDKSemanticError CResult_NoneSemanticErrorZ_get_err(LDKCResult_NoneSemanticErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return SemanticError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NoneSemanticErrorZ_get_err"))) TS_CResult_NoneSemanticErrorZ_get_err(uint32_t owner) {
	LDKCResult_NoneSemanticErrorZ* owner_conv = (LDKCResult_NoneSemanticErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKSemanticError_to_js(CResult_NoneSemanticErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline struct LDKInvoice CResult_InvoiceSemanticErrorZ_get_ok(LDKCResult_InvoiceSemanticErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Invoice_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceSemanticErrorZ_get_ok"))) TS_CResult_InvoiceSemanticErrorZ_get_ok(uint32_t owner) {
	LDKCResult_InvoiceSemanticErrorZ* owner_conv = (LDKCResult_InvoiceSemanticErrorZ*)(owner & ~1);
	LDKInvoice ret_var = CResult_InvoiceSemanticErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline enum LDKSemanticError CResult_InvoiceSemanticErrorZ_get_err(LDKCResult_InvoiceSemanticErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return SemanticError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceSemanticErrorZ_get_err"))) TS_CResult_InvoiceSemanticErrorZ_get_err(uint32_t owner) {
	LDKCResult_InvoiceSemanticErrorZ* owner_conv = (LDKCResult_InvoiceSemanticErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKSemanticError_to_js(CResult_InvoiceSemanticErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline struct LDKDescription CResult_DescriptionCreationErrorZ_get_ok(LDKCResult_DescriptionCreationErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Description_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_DescriptionCreationErrorZ_get_ok"))) TS_CResult_DescriptionCreationErrorZ_get_ok(uint32_t owner) {
	LDKCResult_DescriptionCreationErrorZ* owner_conv = (LDKCResult_DescriptionCreationErrorZ*)(owner & ~1);
	LDKDescription ret_var = CResult_DescriptionCreationErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline enum LDKCreationError CResult_DescriptionCreationErrorZ_get_err(LDKCResult_DescriptionCreationErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return CreationError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_DescriptionCreationErrorZ_get_err"))) TS_CResult_DescriptionCreationErrorZ_get_err(uint32_t owner) {
	LDKCResult_DescriptionCreationErrorZ* owner_conv = (LDKCResult_DescriptionCreationErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKCreationError_to_js(CResult_DescriptionCreationErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline struct LDKPrivateRoute CResult_PrivateRouteCreationErrorZ_get_ok(LDKCResult_PrivateRouteCreationErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return PrivateRoute_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_PrivateRouteCreationErrorZ_get_ok"))) TS_CResult_PrivateRouteCreationErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PrivateRouteCreationErrorZ* owner_conv = (LDKCResult_PrivateRouteCreationErrorZ*)(owner & ~1);
	LDKPrivateRoute ret_var = CResult_PrivateRouteCreationErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline enum LDKCreationError CResult_PrivateRouteCreationErrorZ_get_err(LDKCResult_PrivateRouteCreationErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return CreationError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PrivateRouteCreationErrorZ_get_err"))) TS_CResult_PrivateRouteCreationErrorZ_get_err(uint32_t owner) {
	LDKCResult_PrivateRouteCreationErrorZ* owner_conv = (LDKCResult_PrivateRouteCreationErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKCreationError_to_js(CResult_PrivateRouteCreationErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline struct LDKStr CResult_StringErrorZ_get_ok(LDKCResult_StringErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
jstring  __attribute__((export_name("TS_CResult_StringErrorZ_get_ok"))) TS_CResult_StringErrorZ_get_ok(uint32_t owner) {
	LDKCResult_StringErrorZ* owner_conv = (LDKCResult_StringErrorZ*)(owner & ~1);
	LDKStr ret_str = CResult_StringErrorZ_get_ok(owner_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	return ret_conv;
}

static inline enum LDKSecp256k1Error CResult_StringErrorZ_get_err(LDKCResult_StringErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
uint32_t  __attribute__((export_name("TS_CResult_StringErrorZ_get_err"))) TS_CResult_StringErrorZ_get_err(uint32_t owner) {
	LDKCResult_StringErrorZ* owner_conv = (LDKCResult_StringErrorZ*)(owner & ~1);
	uint32_t ret_conv = LDKSecp256k1Error_to_js(CResult_StringErrorZ_get_err(owner_conv));
	return ret_conv;
}

static inline struct LDKChannelMonitorUpdate CResult_ChannelMonitorUpdateDecodeErrorZ_get_ok(LDKCResult_ChannelMonitorUpdateDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelMonitorUpdate_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelMonitorUpdateDecodeErrorZ_get_ok"))) TS_CResult_ChannelMonitorUpdateDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* owner_conv = (LDKCResult_ChannelMonitorUpdateDecodeErrorZ*)(owner & ~1);
	LDKChannelMonitorUpdate ret_var = CResult_ChannelMonitorUpdateDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelMonitorUpdateDecodeErrorZ_get_err(LDKCResult_ChannelMonitorUpdateDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelMonitorUpdateDecodeErrorZ_get_err"))) TS_CResult_ChannelMonitorUpdateDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* owner_conv = (LDKCResult_ChannelMonitorUpdateDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelMonitorUpdateDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKCOption_MonitorEventZ_ty_from_ptr"))) TS_LDKCOption_MonitorEventZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_MonitorEventZ *obj = (LDKCOption_MonitorEventZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_MonitorEventZ_Some: return 0;
		case LDKCOption_MonitorEventZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_MonitorEventZ_Some_get_some"))) TS_LDKCOption_MonitorEventZ_Some_get_some(uint32_t ptr) {
	LDKCOption_MonitorEventZ *obj = (LDKCOption_MonitorEventZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_MonitorEventZ_Some);
			uint32_t some_ref = ((uintptr_t)&obj->some) | 1;
	return some_ref;
}
static inline struct LDKCOption_MonitorEventZ CResult_COption_MonitorEventZDecodeErrorZ_get_ok(LDKCResult_COption_MonitorEventZDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return COption_MonitorEventZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_MonitorEventZDecodeErrorZ_get_ok"))) TS_CResult_COption_MonitorEventZDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_COption_MonitorEventZDecodeErrorZ* owner_conv = (LDKCResult_COption_MonitorEventZDecodeErrorZ*)(owner & ~1);
	LDKCOption_MonitorEventZ *ret_copy = MALLOC(sizeof(LDKCOption_MonitorEventZ), "LDKCOption_MonitorEventZ");
	*ret_copy = CResult_COption_MonitorEventZDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_COption_MonitorEventZDecodeErrorZ_get_err(LDKCResult_COption_MonitorEventZDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_MonitorEventZDecodeErrorZ_get_err"))) TS_CResult_COption_MonitorEventZDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_COption_MonitorEventZDecodeErrorZ* owner_conv = (LDKCResult_COption_MonitorEventZDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_COption_MonitorEventZDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKHTLCUpdate CResult_HTLCUpdateDecodeErrorZ_get_ok(LDKCResult_HTLCUpdateDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return HTLCUpdate_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_HTLCUpdateDecodeErrorZ_get_ok"))) TS_CResult_HTLCUpdateDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_HTLCUpdateDecodeErrorZ* owner_conv = (LDKCResult_HTLCUpdateDecodeErrorZ*)(owner & ~1);
	LDKHTLCUpdate ret_var = CResult_HTLCUpdateDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_HTLCUpdateDecodeErrorZ_get_err(LDKCResult_HTLCUpdateDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_HTLCUpdateDecodeErrorZ_get_err"))) TS_CResult_HTLCUpdateDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_HTLCUpdateDecodeErrorZ* owner_conv = (LDKCResult_HTLCUpdateDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_HTLCUpdateDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKOutPoint C2Tuple_OutPointScriptZ_get_a(LDKC2Tuple_OutPointScriptZ *NONNULL_PTR owner){
	return OutPoint_clone(&owner->a);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_OutPointScriptZ_get_a"))) TS_C2Tuple_OutPointScriptZ_get_a(uint32_t owner) {
	LDKC2Tuple_OutPointScriptZ* owner_conv = (LDKC2Tuple_OutPointScriptZ*)(owner & ~1);
	LDKOutPoint ret_var = C2Tuple_OutPointScriptZ_get_a(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKCVec_u8Z C2Tuple_OutPointScriptZ_get_b(LDKC2Tuple_OutPointScriptZ *NONNULL_PTR owner){
	return CVec_u8Z_clone(&owner->b);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_OutPointScriptZ_get_b"))) TS_C2Tuple_OutPointScriptZ_get_b(uint32_t owner) {
	LDKC2Tuple_OutPointScriptZ* owner_conv = (LDKC2Tuple_OutPointScriptZ*)(owner & ~1);
	LDKCVec_u8Z ret_var = C2Tuple_OutPointScriptZ_get_b(owner_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

static inline uint32_t C2Tuple_u32ScriptZ_get_a(LDKC2Tuple_u32ScriptZ *NONNULL_PTR owner){
	return owner->a;
}
int32_t  __attribute__((export_name("TS_C2Tuple_u32ScriptZ_get_a"))) TS_C2Tuple_u32ScriptZ_get_a(uint32_t owner) {
	LDKC2Tuple_u32ScriptZ* owner_conv = (LDKC2Tuple_u32ScriptZ*)(owner & ~1);
	int32_t ret_val = C2Tuple_u32ScriptZ_get_a(owner_conv);
	return ret_val;
}

static inline struct LDKCVec_u8Z C2Tuple_u32ScriptZ_get_b(LDKC2Tuple_u32ScriptZ *NONNULL_PTR owner){
	return CVec_u8Z_clone(&owner->b);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_u32ScriptZ_get_b"))) TS_C2Tuple_u32ScriptZ_get_b(uint32_t owner) {
	LDKC2Tuple_u32ScriptZ* owner_conv = (LDKC2Tuple_u32ScriptZ*)(owner & ~1);
	LDKCVec_u8Z ret_var = C2Tuple_u32ScriptZ_get_b(owner_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

static inline LDKCVec_C2Tuple_u32ScriptZZ CVec_C2Tuple_u32ScriptZZ_clone(const LDKCVec_C2Tuple_u32ScriptZZ *orig) {
	LDKCVec_C2Tuple_u32ScriptZZ ret = { .data = MALLOC(sizeof(LDKC2Tuple_u32ScriptZ) * orig->datalen, "LDKCVec_C2Tuple_u32ScriptZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = C2Tuple_u32ScriptZ_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKThirtyTwoBytes C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_get_a(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->a);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_get_a"))) TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_get_a(uint32_t owner) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ* owner_conv = (LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_get_a(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKCVec_C2Tuple_u32ScriptZZ C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_get_b(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ *NONNULL_PTR owner){
	return CVec_C2Tuple_u32ScriptZZ_clone(&owner->b);
}
uint32_tArray  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_get_b"))) TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_get_b(uint32_t owner) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ* owner_conv = (LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ*)(owner & ~1);
	LDKCVec_C2Tuple_u32ScriptZZ ret_var = C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_get_b(owner_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t v = 0; v < ret_var.datalen; v++) {
		LDKC2Tuple_u32ScriptZ* ret_conv_21_conv = MALLOC(sizeof(LDKC2Tuple_u32ScriptZ), "LDKC2Tuple_u32ScriptZ");
		*ret_conv_21_conv = ret_var.data[v];
		ret_arr_ptr[v] = ((uint32_t)ret_conv_21_conv);
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

static inline LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ CVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ_clone(const LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ *orig) {
	LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ ret = { .data = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ) * orig->datalen, "LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone(&orig->data[i]);
	}
	return ret;
}
static inline LDKCVec_EventZ CVec_EventZ_clone(const LDKCVec_EventZ *orig) {
	LDKCVec_EventZ ret = { .data = MALLOC(sizeof(LDKEvent) * orig->datalen, "LDKCVec_EventZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = Event_clone(&orig->data[i]);
	}
	return ret;
}
static inline uint32_t C2Tuple_u32TxOutZ_get_a(LDKC2Tuple_u32TxOutZ *NONNULL_PTR owner){
	return owner->a;
}
int32_t  __attribute__((export_name("TS_C2Tuple_u32TxOutZ_get_a"))) TS_C2Tuple_u32TxOutZ_get_a(uint32_t owner) {
	LDKC2Tuple_u32TxOutZ* owner_conv = (LDKC2Tuple_u32TxOutZ*)(owner & ~1);
	int32_t ret_val = C2Tuple_u32TxOutZ_get_a(owner_conv);
	return ret_val;
}

static inline struct LDKTxOut C2Tuple_u32TxOutZ_get_b(LDKC2Tuple_u32TxOutZ *NONNULL_PTR owner){
	return TxOut_clone(&owner->b);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_u32TxOutZ_get_b"))) TS_C2Tuple_u32TxOutZ_get_b(uint32_t owner) {
	LDKC2Tuple_u32TxOutZ* owner_conv = (LDKC2Tuple_u32TxOutZ*)(owner & ~1);
	LDKTxOut* ret_ref = MALLOC(sizeof(LDKTxOut), "LDKTxOut");
	*ret_ref = C2Tuple_u32TxOutZ_get_b(owner_conv);
	return (uint32_t)ret_ref;
}

static inline LDKCVec_C2Tuple_u32TxOutZZ CVec_C2Tuple_u32TxOutZZ_clone(const LDKCVec_C2Tuple_u32TxOutZZ *orig) {
	LDKCVec_C2Tuple_u32TxOutZZ ret = { .data = MALLOC(sizeof(LDKC2Tuple_u32TxOutZ) * orig->datalen, "LDKCVec_C2Tuple_u32TxOutZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = C2Tuple_u32TxOutZ_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKThirtyTwoBytes C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_get_a(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->a);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_get_a"))) TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_get_a(uint32_t owner) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* owner_conv = (LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_get_a(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKCVec_C2Tuple_u32TxOutZZ C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_get_b(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ *NONNULL_PTR owner){
	return CVec_C2Tuple_u32TxOutZZ_clone(&owner->b);
}
uint32_tArray  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_get_b"))) TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_get_b(uint32_t owner) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* owner_conv = (LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ*)(owner & ~1);
	LDKCVec_C2Tuple_u32TxOutZZ ret_var = C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_get_b(owner_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t u = 0; u < ret_var.datalen; u++) {
		LDKC2Tuple_u32TxOutZ* ret_conv_20_conv = MALLOC(sizeof(LDKC2Tuple_u32TxOutZ), "LDKC2Tuple_u32TxOutZ");
		*ret_conv_20_conv = ret_var.data[u];
		ret_arr_ptr[u] = ((uint32_t)ret_conv_20_conv);
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

static inline LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ CVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ_clone(const LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ *orig) {
	LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ ret = { .data = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ) * orig->datalen, "LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone(&orig->data[i]);
	}
	return ret;
}
uint32_t __attribute__((export_name("TS_LDKBalance_ty_from_ptr"))) TS_LDKBalance_ty_from_ptr(uint32_t ptr) {
	LDKBalance *obj = (LDKBalance*)(ptr & ~1);
	switch(obj->tag) {
		case LDKBalance_ClaimableOnChannelClose: return 0;
		case LDKBalance_ClaimableAwaitingConfirmations: return 1;
		case LDKBalance_ContentiousClaimable: return 2;
		case LDKBalance_MaybeClaimableHTLCAwaitingTimeout: return 3;
		default: abort();
	}
}
int64_t __attribute__((export_name("TS_LDKBalance_ClaimableOnChannelClose_get_claimable_amount_satoshis"))) TS_LDKBalance_ClaimableOnChannelClose_get_claimable_amount_satoshis(uint32_t ptr) {
	LDKBalance *obj = (LDKBalance*)(ptr & ~1);
	assert(obj->tag == LDKBalance_ClaimableOnChannelClose);
	return obj->claimable_on_channel_close.claimable_amount_satoshis;
}
int64_t __attribute__((export_name("TS_LDKBalance_ClaimableAwaitingConfirmations_get_claimable_amount_satoshis"))) TS_LDKBalance_ClaimableAwaitingConfirmations_get_claimable_amount_satoshis(uint32_t ptr) {
	LDKBalance *obj = (LDKBalance*)(ptr & ~1);
	assert(obj->tag == LDKBalance_ClaimableAwaitingConfirmations);
	return obj->claimable_awaiting_confirmations.claimable_amount_satoshis;
}
int32_t __attribute__((export_name("TS_LDKBalance_ClaimableAwaitingConfirmations_get_confirmation_height"))) TS_LDKBalance_ClaimableAwaitingConfirmations_get_confirmation_height(uint32_t ptr) {
	LDKBalance *obj = (LDKBalance*)(ptr & ~1);
	assert(obj->tag == LDKBalance_ClaimableAwaitingConfirmations);
	return obj->claimable_awaiting_confirmations.confirmation_height;
}
int64_t __attribute__((export_name("TS_LDKBalance_ContentiousClaimable_get_claimable_amount_satoshis"))) TS_LDKBalance_ContentiousClaimable_get_claimable_amount_satoshis(uint32_t ptr) {
	LDKBalance *obj = (LDKBalance*)(ptr & ~1);
	assert(obj->tag == LDKBalance_ContentiousClaimable);
	return obj->contentious_claimable.claimable_amount_satoshis;
}
int32_t __attribute__((export_name("TS_LDKBalance_ContentiousClaimable_get_timeout_height"))) TS_LDKBalance_ContentiousClaimable_get_timeout_height(uint32_t ptr) {
	LDKBalance *obj = (LDKBalance*)(ptr & ~1);
	assert(obj->tag == LDKBalance_ContentiousClaimable);
	return obj->contentious_claimable.timeout_height;
}
int64_t __attribute__((export_name("TS_LDKBalance_MaybeClaimableHTLCAwaitingTimeout_get_claimable_amount_satoshis"))) TS_LDKBalance_MaybeClaimableHTLCAwaitingTimeout_get_claimable_amount_satoshis(uint32_t ptr) {
	LDKBalance *obj = (LDKBalance*)(ptr & ~1);
	assert(obj->tag == LDKBalance_MaybeClaimableHTLCAwaitingTimeout);
	return obj->maybe_claimable_htlc_awaiting_timeout.claimable_amount_satoshis;
}
int32_t __attribute__((export_name("TS_LDKBalance_MaybeClaimableHTLCAwaitingTimeout_get_claimable_height"))) TS_LDKBalance_MaybeClaimableHTLCAwaitingTimeout_get_claimable_height(uint32_t ptr) {
	LDKBalance *obj = (LDKBalance*)(ptr & ~1);
	assert(obj->tag == LDKBalance_MaybeClaimableHTLCAwaitingTimeout);
	return obj->maybe_claimable_htlc_awaiting_timeout.claimable_height;
}
static inline LDKCVec_BalanceZ CVec_BalanceZ_clone(const LDKCVec_BalanceZ *orig) {
	LDKCVec_BalanceZ ret = { .data = MALLOC(sizeof(LDKBalance) * orig->datalen, "LDKCVec_BalanceZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = Balance_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKThirtyTwoBytes C2Tuple_BlockHashChannelMonitorZ_get_a(LDKC2Tuple_BlockHashChannelMonitorZ *NONNULL_PTR owner){
	return ThirtyTwoBytes_clone(&owner->a);
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_BlockHashChannelMonitorZ_get_a"))) TS_C2Tuple_BlockHashChannelMonitorZ_get_a(uint32_t owner) {
	LDKC2Tuple_BlockHashChannelMonitorZ* owner_conv = (LDKC2Tuple_BlockHashChannelMonitorZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_BlockHashChannelMonitorZ_get_a(owner_conv).data, 32);
	return ret_arr;
}

static inline struct LDKChannelMonitor C2Tuple_BlockHashChannelMonitorZ_get_b(LDKC2Tuple_BlockHashChannelMonitorZ *NONNULL_PTR owner){
	return ChannelMonitor_clone(&owner->b);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_BlockHashChannelMonitorZ_get_b"))) TS_C2Tuple_BlockHashChannelMonitorZ_get_b(uint32_t owner) {
	LDKC2Tuple_BlockHashChannelMonitorZ* owner_conv = (LDKC2Tuple_BlockHashChannelMonitorZ*)(owner & ~1);
	LDKChannelMonitor ret_var = C2Tuple_BlockHashChannelMonitorZ_get_b(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKC2Tuple_BlockHashChannelMonitorZ CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_get_ok(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return C2Tuple_BlockHashChannelMonitorZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_get_ok"))) TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* owner_conv = (LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ*)(owner & ~1);
	LDKC2Tuple_BlockHashChannelMonitorZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_BlockHashChannelMonitorZ), "LDKC2Tuple_BlockHashChannelMonitorZ");
	*ret_conv = CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_get_ok(owner_conv);
	return ((uint32_t)ret_conv);
}

static inline struct LDKDecodeError CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_get_err(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_get_err"))) TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* owner_conv = (LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline void CResult_NoneLightningErrorZ_get_ok(LDKCResult_NoneLightningErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
void  __attribute__((export_name("TS_CResult_NoneLightningErrorZ_get_ok"))) TS_CResult_NoneLightningErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NoneLightningErrorZ* owner_conv = (LDKCResult_NoneLightningErrorZ*)(owner & ~1);
	CResult_NoneLightningErrorZ_get_ok(owner_conv);
}

static inline struct LDKLightningError CResult_NoneLightningErrorZ_get_err(LDKCResult_NoneLightningErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return LightningError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NoneLightningErrorZ_get_err"))) TS_CResult_NoneLightningErrorZ_get_err(uint32_t owner) {
	LDKCResult_NoneLightningErrorZ* owner_conv = (LDKCResult_NoneLightningErrorZ*)(owner & ~1);
	LDKLightningError ret_var = CResult_NoneLightningErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKPublicKey C2Tuple_PublicKeyTypeZ_get_a(LDKC2Tuple_PublicKeyTypeZ *NONNULL_PTR owner){
	return owner->a;
}
int8_tArray  __attribute__((export_name("TS_C2Tuple_PublicKeyTypeZ_get_a"))) TS_C2Tuple_PublicKeyTypeZ_get_a(uint32_t owner) {
	LDKC2Tuple_PublicKeyTypeZ* owner_conv = (LDKC2Tuple_PublicKeyTypeZ*)(owner & ~1);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, C2Tuple_PublicKeyTypeZ_get_a(owner_conv).compressed_form, 33);
	return ret_arr;
}

static inline struct LDKType C2Tuple_PublicKeyTypeZ_get_b(LDKC2Tuple_PublicKeyTypeZ *NONNULL_PTR owner){
	return Type_clone(&owner->b);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_PublicKeyTypeZ_get_b"))) TS_C2Tuple_PublicKeyTypeZ_get_b(uint32_t owner) {
	LDKC2Tuple_PublicKeyTypeZ* owner_conv = (LDKC2Tuple_PublicKeyTypeZ*)(owner & ~1);
	LDKType* ret_ret = MALLOC(sizeof(LDKType), "LDKType");
	*ret_ret = C2Tuple_PublicKeyTypeZ_get_b(owner_conv);
	return (uint32_t)ret_ret;
}

static inline LDKCVec_C2Tuple_PublicKeyTypeZZ CVec_C2Tuple_PublicKeyTypeZZ_clone(const LDKCVec_C2Tuple_PublicKeyTypeZZ *orig) {
	LDKCVec_C2Tuple_PublicKeyTypeZZ ret = { .data = MALLOC(sizeof(LDKC2Tuple_PublicKeyTypeZ) * orig->datalen, "LDKCVec_C2Tuple_PublicKeyTypeZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = C2Tuple_PublicKeyTypeZ_clone(&orig->data[i]);
	}
	return ret;
}
static inline bool CResult_boolLightningErrorZ_get_ok(LDKCResult_boolLightningErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
jboolean  __attribute__((export_name("TS_CResult_boolLightningErrorZ_get_ok"))) TS_CResult_boolLightningErrorZ_get_ok(uint32_t owner) {
	LDKCResult_boolLightningErrorZ* owner_conv = (LDKCResult_boolLightningErrorZ*)(owner & ~1);
	jboolean ret_val = CResult_boolLightningErrorZ_get_ok(owner_conv);
	return ret_val;
}

static inline struct LDKLightningError CResult_boolLightningErrorZ_get_err(LDKCResult_boolLightningErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return LightningError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_boolLightningErrorZ_get_err"))) TS_CResult_boolLightningErrorZ_get_err(uint32_t owner) {
	LDKCResult_boolLightningErrorZ* owner_conv = (LDKCResult_boolLightningErrorZ*)(owner & ~1);
	LDKLightningError ret_var = CResult_boolLightningErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelAnnouncement C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_a(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ *NONNULL_PTR owner){
	return ChannelAnnouncement_clone(&owner->a);
}
uint32_t  __attribute__((export_name("TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_a"))) TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_a(uint32_t owner) {
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* owner_conv = (LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ*)(owner & ~1);
	LDKChannelAnnouncement ret_var = C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_a(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelUpdate C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_b(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ *NONNULL_PTR owner){
	return ChannelUpdate_clone(&owner->b);
}
uint32_t  __attribute__((export_name("TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_b"))) TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_b(uint32_t owner) {
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* owner_conv = (LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ*)(owner & ~1);
	LDKChannelUpdate ret_var = C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_b(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelUpdate C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_c(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ *NONNULL_PTR owner){
	return ChannelUpdate_clone(&owner->c);
}
uint32_t  __attribute__((export_name("TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_c"))) TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_c(uint32_t owner) {
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* owner_conv = (LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ*)(owner & ~1);
	LDKChannelUpdate ret_var = C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_get_c(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ CVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ_clone(const LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ *orig) {
	LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ ret = { .data = MALLOC(sizeof(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ) * orig->datalen, "LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone(&orig->data[i]);
	}
	return ret;
}
static inline LDKCVec_NodeAnnouncementZ CVec_NodeAnnouncementZ_clone(const LDKCVec_NodeAnnouncementZ *orig) {
	LDKCVec_NodeAnnouncementZ ret = { .data = MALLOC(sizeof(LDKNodeAnnouncement) * orig->datalen, "LDKCVec_NodeAnnouncementZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = NodeAnnouncement_clone(&orig->data[i]);
	}
	return ret;
}
uint32_t __attribute__((export_name("TS_LDKCOption_NetAddressZ_ty_from_ptr"))) TS_LDKCOption_NetAddressZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_NetAddressZ *obj = (LDKCOption_NetAddressZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_NetAddressZ_Some: return 0;
		case LDKCOption_NetAddressZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_NetAddressZ_Some_get_some"))) TS_LDKCOption_NetAddressZ_Some_get_some(uint32_t ptr) {
	LDKCOption_NetAddressZ *obj = (LDKCOption_NetAddressZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_NetAddressZ_Some);
			uint32_t some_ref = ((uintptr_t)&obj->some) | 1;
	return some_ref;
}
static inline struct LDKCVec_u8Z CResult_CVec_u8ZPeerHandleErrorZ_get_ok(LDKCResult_CVec_u8ZPeerHandleErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return CVec_u8Z_clone(&*owner->contents.result);
}
int8_tArray  __attribute__((export_name("TS_CResult_CVec_u8ZPeerHandleErrorZ_get_ok"))) TS_CResult_CVec_u8ZPeerHandleErrorZ_get_ok(uint32_t owner) {
	LDKCResult_CVec_u8ZPeerHandleErrorZ* owner_conv = (LDKCResult_CVec_u8ZPeerHandleErrorZ*)(owner & ~1);
	LDKCVec_u8Z ret_var = CResult_CVec_u8ZPeerHandleErrorZ_get_ok(owner_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

static inline struct LDKPeerHandleError CResult_CVec_u8ZPeerHandleErrorZ_get_err(LDKCResult_CVec_u8ZPeerHandleErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return PeerHandleError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_CVec_u8ZPeerHandleErrorZ_get_err"))) TS_CResult_CVec_u8ZPeerHandleErrorZ_get_err(uint32_t owner) {
	LDKCResult_CVec_u8ZPeerHandleErrorZ* owner_conv = (LDKCResult_CVec_u8ZPeerHandleErrorZ*)(owner & ~1);
	LDKPeerHandleError ret_var = CResult_CVec_u8ZPeerHandleErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline void CResult_NonePeerHandleErrorZ_get_ok(LDKCResult_NonePeerHandleErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
void  __attribute__((export_name("TS_CResult_NonePeerHandleErrorZ_get_ok"))) TS_CResult_NonePeerHandleErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NonePeerHandleErrorZ* owner_conv = (LDKCResult_NonePeerHandleErrorZ*)(owner & ~1);
	CResult_NonePeerHandleErrorZ_get_ok(owner_conv);
}

static inline struct LDKPeerHandleError CResult_NonePeerHandleErrorZ_get_err(LDKCResult_NonePeerHandleErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return PeerHandleError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NonePeerHandleErrorZ_get_err"))) TS_CResult_NonePeerHandleErrorZ_get_err(uint32_t owner) {
	LDKCResult_NonePeerHandleErrorZ* owner_conv = (LDKCResult_NonePeerHandleErrorZ*)(owner & ~1);
	LDKPeerHandleError ret_var = CResult_NonePeerHandleErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline bool CResult_boolPeerHandleErrorZ_get_ok(LDKCResult_boolPeerHandleErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return *owner->contents.result;
}
jboolean  __attribute__((export_name("TS_CResult_boolPeerHandleErrorZ_get_ok"))) TS_CResult_boolPeerHandleErrorZ_get_ok(uint32_t owner) {
	LDKCResult_boolPeerHandleErrorZ* owner_conv = (LDKCResult_boolPeerHandleErrorZ*)(owner & ~1);
	jboolean ret_val = CResult_boolPeerHandleErrorZ_get_ok(owner_conv);
	return ret_val;
}

static inline struct LDKPeerHandleError CResult_boolPeerHandleErrorZ_get_err(LDKCResult_boolPeerHandleErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return PeerHandleError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_boolPeerHandleErrorZ_get_err"))) TS_CResult_boolPeerHandleErrorZ_get_err(uint32_t owner) {
	LDKCResult_boolPeerHandleErrorZ* owner_conv = (LDKCResult_boolPeerHandleErrorZ*)(owner & ~1);
	LDKPeerHandleError ret_var = CResult_boolPeerHandleErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKNodeId CResult_NodeIdDecodeErrorZ_get_ok(LDKCResult_NodeIdDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return NodeId_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeIdDecodeErrorZ_get_ok"))) TS_CResult_NodeIdDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NodeIdDecodeErrorZ* owner_conv = (LDKCResult_NodeIdDecodeErrorZ*)(owner & ~1);
	LDKNodeId ret_var = CResult_NodeIdDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_NodeIdDecodeErrorZ_get_err(LDKCResult_NodeIdDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeIdDecodeErrorZ_get_err"))) TS_CResult_NodeIdDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_NodeIdDecodeErrorZ* owner_conv = (LDKCResult_NodeIdDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_NodeIdDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKCOption_NetworkUpdateZ CResult_COption_NetworkUpdateZDecodeErrorZ_get_ok(LDKCResult_COption_NetworkUpdateZDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return COption_NetworkUpdateZ_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_NetworkUpdateZDecodeErrorZ_get_ok"))) TS_CResult_COption_NetworkUpdateZDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* owner_conv = (LDKCResult_COption_NetworkUpdateZDecodeErrorZ*)(owner & ~1);
	LDKCOption_NetworkUpdateZ *ret_copy = MALLOC(sizeof(LDKCOption_NetworkUpdateZ), "LDKCOption_NetworkUpdateZ");
	*ret_copy = CResult_COption_NetworkUpdateZDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_COption_NetworkUpdateZDecodeErrorZ_get_err(LDKCResult_COption_NetworkUpdateZDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_COption_NetworkUpdateZDecodeErrorZ_get_err"))) TS_CResult_COption_NetworkUpdateZDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* owner_conv = (LDKCResult_COption_NetworkUpdateZDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_COption_NetworkUpdateZDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

typedef struct LDKAccess_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKAccess_JCalls;
static void LDKAccess_JCalls_free(void* this_arg) {
	LDKAccess_JCalls *j_calls = (LDKAccess_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCResult_TxOutAccessErrorZ get_utxo_LDKAccess_jcall(const void* this_arg, const uint8_t (* genesis_hash)[32], uint64_t short_channel_id) {
	LDKAccess_JCalls *j_calls = (LDKAccess_JCalls*) this_arg;
	int8_tArray genesis_hash_arr = init_int8_tArray(32, __LINE__);
	memcpy(genesis_hash_arr->elems, *genesis_hash, 32);
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 31, (uint32_t)genesis_hash_arr, (uint32_t)short_channel_id);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_TxOutAccessErrorZ ret_conv = *(LDKCResult_TxOutAccessErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
static void LDKAccess_JCalls_cloned(LDKAccess* new_obj) {
	LDKAccess_JCalls *j_calls = (LDKAccess_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKAccess LDKAccess_init (JSValue o) {
	LDKAccess_JCalls *calls = MALLOC(sizeof(LDKAccess_JCalls), "LDKAccess_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKAccess ret = {
		.this_arg = (void*) calls,
		.get_utxo = get_utxo_LDKAccess_jcall,
		.free = LDKAccess_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKAccess_new"))) TS_LDKAccess_new(JSValue o) {
	LDKAccess *res_ptr = MALLOC(sizeof(LDKAccess), "LDKAccess");
	*res_ptr = LDKAccess_init(o);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_Access_get_utxo"))) TS_Access_get_utxo(uint32_t this_arg, int8_tArray genesis_hash, int64_t short_channel_id) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKAccess* this_arg_conv = (LDKAccess*)this_arg_ptr;
	unsigned char genesis_hash_arr[32];
	CHECK(genesis_hash->arr_len == 32);
	memcpy(genesis_hash_arr, genesis_hash->elems, 32); FREE(genesis_hash);
	unsigned char (*genesis_hash_ref)[32] = &genesis_hash_arr;
	LDKCResult_TxOutAccessErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxOutAccessErrorZ), "LDKCResult_TxOutAccessErrorZ");
	*ret_conv = (this_arg_conv->get_utxo)(this_arg_conv->this_arg, genesis_hash_ref, short_channel_id);
	return (uint32_t)ret_conv;
}

uint32_t __attribute__((export_name("TS_LDKCOption_AccessZ_ty_from_ptr"))) TS_LDKCOption_AccessZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_AccessZ *obj = (LDKCOption_AccessZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_AccessZ_Some: return 0;
		case LDKCOption_AccessZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_AccessZ_Some_get_some"))) TS_LDKCOption_AccessZ_Some_get_some(uint32_t ptr) {
	LDKCOption_AccessZ *obj = (LDKCOption_AccessZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_AccessZ_Some);
			LDKAccess* some_ret = MALLOC(sizeof(LDKAccess), "LDKAccess");
			*some_ret = obj->some;
			// WARNING: We likely need to clone here, but no clone is available, so we just do it for Java instances
			if ((*some_ret).free == LDKAccess_JCalls_free) {
				// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
				LDKAccess_JCalls_cloned(&(*some_ret));
			}
	return (uint32_t)some_ret;
}
static inline struct LDKChannelUpdateInfo CResult_ChannelUpdateInfoDecodeErrorZ_get_ok(LDKCResult_ChannelUpdateInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelUpdateInfo_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateInfoDecodeErrorZ_get_ok"))) TS_CResult_ChannelUpdateInfoDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* owner_conv = (LDKCResult_ChannelUpdateInfoDecodeErrorZ*)(owner & ~1);
	LDKChannelUpdateInfo ret_var = CResult_ChannelUpdateInfoDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelUpdateInfoDecodeErrorZ_get_err(LDKCResult_ChannelUpdateInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateInfoDecodeErrorZ_get_err"))) TS_CResult_ChannelUpdateInfoDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* owner_conv = (LDKCResult_ChannelUpdateInfoDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelUpdateInfoDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelInfo CResult_ChannelInfoDecodeErrorZ_get_ok(LDKCResult_ChannelInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelInfo_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelInfoDecodeErrorZ_get_ok"))) TS_CResult_ChannelInfoDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelInfoDecodeErrorZ* owner_conv = (LDKCResult_ChannelInfoDecodeErrorZ*)(owner & ~1);
	LDKChannelInfo ret_var = CResult_ChannelInfoDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelInfoDecodeErrorZ_get_err(LDKCResult_ChannelInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelInfoDecodeErrorZ_get_err"))) TS_CResult_ChannelInfoDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelInfoDecodeErrorZ* owner_conv = (LDKCResult_ChannelInfoDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelInfoDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKRoutingFees CResult_RoutingFeesDecodeErrorZ_get_ok(LDKCResult_RoutingFeesDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return RoutingFees_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_RoutingFeesDecodeErrorZ_get_ok"))) TS_CResult_RoutingFeesDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_RoutingFeesDecodeErrorZ* owner_conv = (LDKCResult_RoutingFeesDecodeErrorZ*)(owner & ~1);
	LDKRoutingFees ret_var = CResult_RoutingFeesDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_RoutingFeesDecodeErrorZ_get_err(LDKCResult_RoutingFeesDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_RoutingFeesDecodeErrorZ_get_err"))) TS_CResult_RoutingFeesDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_RoutingFeesDecodeErrorZ* owner_conv = (LDKCResult_RoutingFeesDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_RoutingFeesDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKNodeAnnouncementInfo CResult_NodeAnnouncementInfoDecodeErrorZ_get_ok(LDKCResult_NodeAnnouncementInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return NodeAnnouncementInfo_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementInfoDecodeErrorZ_get_ok"))) TS_CResult_NodeAnnouncementInfoDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* owner_conv = (LDKCResult_NodeAnnouncementInfoDecodeErrorZ*)(owner & ~1);
	LDKNodeAnnouncementInfo ret_var = CResult_NodeAnnouncementInfoDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_NodeAnnouncementInfoDecodeErrorZ_get_err(LDKCResult_NodeAnnouncementInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementInfoDecodeErrorZ_get_err"))) TS_CResult_NodeAnnouncementInfoDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* owner_conv = (LDKCResult_NodeAnnouncementInfoDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_NodeAnnouncementInfoDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_u64Z CVec_u64Z_clone(const LDKCVec_u64Z *orig) {
	LDKCVec_u64Z ret = { .data = MALLOC(sizeof(int64_t) * orig->datalen, "LDKCVec_u64Z clone bytes"), .datalen = orig->datalen };
	memcpy(ret.data, orig->data, sizeof(int64_t) * ret.datalen);
	return ret;
}
static inline struct LDKNodeInfo CResult_NodeInfoDecodeErrorZ_get_ok(LDKCResult_NodeInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return NodeInfo_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeInfoDecodeErrorZ_get_ok"))) TS_CResult_NodeInfoDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NodeInfoDecodeErrorZ* owner_conv = (LDKCResult_NodeInfoDecodeErrorZ*)(owner & ~1);
	LDKNodeInfo ret_var = CResult_NodeInfoDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_NodeInfoDecodeErrorZ_get_err(LDKCResult_NodeInfoDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeInfoDecodeErrorZ_get_err"))) TS_CResult_NodeInfoDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_NodeInfoDecodeErrorZ* owner_conv = (LDKCResult_NodeInfoDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_NodeInfoDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKNetworkGraph CResult_NetworkGraphDecodeErrorZ_get_ok(LDKCResult_NetworkGraphDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return NetworkGraph_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_NetworkGraphDecodeErrorZ_get_ok"))) TS_CResult_NetworkGraphDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NetworkGraphDecodeErrorZ* owner_conv = (LDKCResult_NetworkGraphDecodeErrorZ*)(owner & ~1);
	LDKNetworkGraph ret_var = CResult_NetworkGraphDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_NetworkGraphDecodeErrorZ_get_err(LDKCResult_NetworkGraphDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NetworkGraphDecodeErrorZ_get_err"))) TS_CResult_NetworkGraphDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_NetworkGraphDecodeErrorZ* owner_conv = (LDKCResult_NetworkGraphDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_NetworkGraphDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKCOption_CVec_NetAddressZZ_ty_from_ptr"))) TS_LDKCOption_CVec_NetAddressZZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_CVec_NetAddressZZ *obj = (LDKCOption_CVec_NetAddressZZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_CVec_NetAddressZZ_Some: return 0;
		case LDKCOption_CVec_NetAddressZZ_None: return 1;
		default: abort();
	}
}
uint32_tArray __attribute__((export_name("TS_LDKCOption_CVec_NetAddressZZ_Some_get_some"))) TS_LDKCOption_CVec_NetAddressZZ_Some_get_some(uint32_t ptr) {
	LDKCOption_CVec_NetAddressZZ *obj = (LDKCOption_CVec_NetAddressZZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_CVec_NetAddressZZ_Some);
			LDKCVec_NetAddressZ some_var = obj->some;
			uint32_tArray some_arr = NULL;
			some_arr = init_uint32_tArray(some_var.datalen, __LINE__);
			uint32_t *some_arr_ptr = (uint32_t*)(((uint8_t*)some_arr) + 4);
			for (size_t m = 0; m < some_var.datalen; m++) {
				uint32_t some_conv_12_ref = ((uintptr_t)&some_var.data[m]) | 1;
				some_arr_ptr[m] = some_conv_12_ref;
			}
			
	return some_arr;
}
static inline struct LDKNetAddress CResult_NetAddressDecodeErrorZ_get_ok(LDKCResult_NetAddressDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return NetAddress_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_NetAddressDecodeErrorZ_get_ok"))) TS_CResult_NetAddressDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NetAddressDecodeErrorZ* owner_conv = (LDKCResult_NetAddressDecodeErrorZ*)(owner & ~1);
	LDKNetAddress *ret_copy = MALLOC(sizeof(LDKNetAddress), "LDKNetAddress");
	*ret_copy = CResult_NetAddressDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

static inline struct LDKDecodeError CResult_NetAddressDecodeErrorZ_get_err(LDKCResult_NetAddressDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NetAddressDecodeErrorZ_get_err"))) TS_CResult_NetAddressDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_NetAddressDecodeErrorZ* owner_conv = (LDKCResult_NetAddressDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_NetAddressDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline LDKCVec_UpdateAddHTLCZ CVec_UpdateAddHTLCZ_clone(const LDKCVec_UpdateAddHTLCZ *orig) {
	LDKCVec_UpdateAddHTLCZ ret = { .data = MALLOC(sizeof(LDKUpdateAddHTLC) * orig->datalen, "LDKCVec_UpdateAddHTLCZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = UpdateAddHTLC_clone(&orig->data[i]);
	}
	return ret;
}
static inline LDKCVec_UpdateFulfillHTLCZ CVec_UpdateFulfillHTLCZ_clone(const LDKCVec_UpdateFulfillHTLCZ *orig) {
	LDKCVec_UpdateFulfillHTLCZ ret = { .data = MALLOC(sizeof(LDKUpdateFulfillHTLC) * orig->datalen, "LDKCVec_UpdateFulfillHTLCZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = UpdateFulfillHTLC_clone(&orig->data[i]);
	}
	return ret;
}
static inline LDKCVec_UpdateFailHTLCZ CVec_UpdateFailHTLCZ_clone(const LDKCVec_UpdateFailHTLCZ *orig) {
	LDKCVec_UpdateFailHTLCZ ret = { .data = MALLOC(sizeof(LDKUpdateFailHTLC) * orig->datalen, "LDKCVec_UpdateFailHTLCZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = UpdateFailHTLC_clone(&orig->data[i]);
	}
	return ret;
}
static inline LDKCVec_UpdateFailMalformedHTLCZ CVec_UpdateFailMalformedHTLCZ_clone(const LDKCVec_UpdateFailMalformedHTLCZ *orig) {
	LDKCVec_UpdateFailMalformedHTLCZ ret = { .data = MALLOC(sizeof(LDKUpdateFailMalformedHTLC) * orig->datalen, "LDKCVec_UpdateFailMalformedHTLCZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = UpdateFailMalformedHTLC_clone(&orig->data[i]);
	}
	return ret;
}
static inline struct LDKAcceptChannel CResult_AcceptChannelDecodeErrorZ_get_ok(LDKCResult_AcceptChannelDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return AcceptChannel_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_AcceptChannelDecodeErrorZ_get_ok"))) TS_CResult_AcceptChannelDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_AcceptChannelDecodeErrorZ* owner_conv = (LDKCResult_AcceptChannelDecodeErrorZ*)(owner & ~1);
	LDKAcceptChannel ret_var = CResult_AcceptChannelDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_AcceptChannelDecodeErrorZ_get_err(LDKCResult_AcceptChannelDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_AcceptChannelDecodeErrorZ_get_err"))) TS_CResult_AcceptChannelDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_AcceptChannelDecodeErrorZ* owner_conv = (LDKCResult_AcceptChannelDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_AcceptChannelDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKAnnouncementSignatures CResult_AnnouncementSignaturesDecodeErrorZ_get_ok(LDKCResult_AnnouncementSignaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return AnnouncementSignatures_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_AnnouncementSignaturesDecodeErrorZ_get_ok"))) TS_CResult_AnnouncementSignaturesDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* owner_conv = (LDKCResult_AnnouncementSignaturesDecodeErrorZ*)(owner & ~1);
	LDKAnnouncementSignatures ret_var = CResult_AnnouncementSignaturesDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_AnnouncementSignaturesDecodeErrorZ_get_err(LDKCResult_AnnouncementSignaturesDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_AnnouncementSignaturesDecodeErrorZ_get_err"))) TS_CResult_AnnouncementSignaturesDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* owner_conv = (LDKCResult_AnnouncementSignaturesDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_AnnouncementSignaturesDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelReestablish CResult_ChannelReestablishDecodeErrorZ_get_ok(LDKCResult_ChannelReestablishDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelReestablish_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelReestablishDecodeErrorZ_get_ok"))) TS_CResult_ChannelReestablishDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelReestablishDecodeErrorZ* owner_conv = (LDKCResult_ChannelReestablishDecodeErrorZ*)(owner & ~1);
	LDKChannelReestablish ret_var = CResult_ChannelReestablishDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelReestablishDecodeErrorZ_get_err(LDKCResult_ChannelReestablishDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelReestablishDecodeErrorZ_get_err"))) TS_CResult_ChannelReestablishDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelReestablishDecodeErrorZ* owner_conv = (LDKCResult_ChannelReestablishDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelReestablishDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKClosingSigned CResult_ClosingSignedDecodeErrorZ_get_ok(LDKCResult_ClosingSignedDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ClosingSigned_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedDecodeErrorZ_get_ok"))) TS_CResult_ClosingSignedDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ClosingSignedDecodeErrorZ* owner_conv = (LDKCResult_ClosingSignedDecodeErrorZ*)(owner & ~1);
	LDKClosingSigned ret_var = CResult_ClosingSignedDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ClosingSignedDecodeErrorZ_get_err(LDKCResult_ClosingSignedDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedDecodeErrorZ_get_err"))) TS_CResult_ClosingSignedDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ClosingSignedDecodeErrorZ* owner_conv = (LDKCResult_ClosingSignedDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ClosingSignedDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKClosingSignedFeeRange CResult_ClosingSignedFeeRangeDecodeErrorZ_get_ok(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ClosingSignedFeeRange_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_get_ok"))) TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* owner_conv = (LDKCResult_ClosingSignedFeeRangeDecodeErrorZ*)(owner & ~1);
	LDKClosingSignedFeeRange ret_var = CResult_ClosingSignedFeeRangeDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ClosingSignedFeeRangeDecodeErrorZ_get_err(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_get_err"))) TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* owner_conv = (LDKCResult_ClosingSignedFeeRangeDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ClosingSignedFeeRangeDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKCommitmentSigned CResult_CommitmentSignedDecodeErrorZ_get_ok(LDKCResult_CommitmentSignedDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return CommitmentSigned_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_CommitmentSignedDecodeErrorZ_get_ok"))) TS_CResult_CommitmentSignedDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_CommitmentSignedDecodeErrorZ* owner_conv = (LDKCResult_CommitmentSignedDecodeErrorZ*)(owner & ~1);
	LDKCommitmentSigned ret_var = CResult_CommitmentSignedDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_CommitmentSignedDecodeErrorZ_get_err(LDKCResult_CommitmentSignedDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_CommitmentSignedDecodeErrorZ_get_err"))) TS_CResult_CommitmentSignedDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_CommitmentSignedDecodeErrorZ* owner_conv = (LDKCResult_CommitmentSignedDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_CommitmentSignedDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKFundingCreated CResult_FundingCreatedDecodeErrorZ_get_ok(LDKCResult_FundingCreatedDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return FundingCreated_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_FundingCreatedDecodeErrorZ_get_ok"))) TS_CResult_FundingCreatedDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_FundingCreatedDecodeErrorZ* owner_conv = (LDKCResult_FundingCreatedDecodeErrorZ*)(owner & ~1);
	LDKFundingCreated ret_var = CResult_FundingCreatedDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_FundingCreatedDecodeErrorZ_get_err(LDKCResult_FundingCreatedDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_FundingCreatedDecodeErrorZ_get_err"))) TS_CResult_FundingCreatedDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_FundingCreatedDecodeErrorZ* owner_conv = (LDKCResult_FundingCreatedDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_FundingCreatedDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKFundingSigned CResult_FundingSignedDecodeErrorZ_get_ok(LDKCResult_FundingSignedDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return FundingSigned_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_FundingSignedDecodeErrorZ_get_ok"))) TS_CResult_FundingSignedDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_FundingSignedDecodeErrorZ* owner_conv = (LDKCResult_FundingSignedDecodeErrorZ*)(owner & ~1);
	LDKFundingSigned ret_var = CResult_FundingSignedDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_FundingSignedDecodeErrorZ_get_err(LDKCResult_FundingSignedDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_FundingSignedDecodeErrorZ_get_err"))) TS_CResult_FundingSignedDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_FundingSignedDecodeErrorZ* owner_conv = (LDKCResult_FundingSignedDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_FundingSignedDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKFundingLocked CResult_FundingLockedDecodeErrorZ_get_ok(LDKCResult_FundingLockedDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return FundingLocked_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_FundingLockedDecodeErrorZ_get_ok"))) TS_CResult_FundingLockedDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_FundingLockedDecodeErrorZ* owner_conv = (LDKCResult_FundingLockedDecodeErrorZ*)(owner & ~1);
	LDKFundingLocked ret_var = CResult_FundingLockedDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_FundingLockedDecodeErrorZ_get_err(LDKCResult_FundingLockedDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_FundingLockedDecodeErrorZ_get_err"))) TS_CResult_FundingLockedDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_FundingLockedDecodeErrorZ* owner_conv = (LDKCResult_FundingLockedDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_FundingLockedDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKInit CResult_InitDecodeErrorZ_get_ok(LDKCResult_InitDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Init_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_InitDecodeErrorZ_get_ok"))) TS_CResult_InitDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_InitDecodeErrorZ* owner_conv = (LDKCResult_InitDecodeErrorZ*)(owner & ~1);
	LDKInit ret_var = CResult_InitDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_InitDecodeErrorZ_get_err(LDKCResult_InitDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_InitDecodeErrorZ_get_err"))) TS_CResult_InitDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_InitDecodeErrorZ* owner_conv = (LDKCResult_InitDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_InitDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKOpenChannel CResult_OpenChannelDecodeErrorZ_get_ok(LDKCResult_OpenChannelDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return OpenChannel_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_OpenChannelDecodeErrorZ_get_ok"))) TS_CResult_OpenChannelDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_OpenChannelDecodeErrorZ* owner_conv = (LDKCResult_OpenChannelDecodeErrorZ*)(owner & ~1);
	LDKOpenChannel ret_var = CResult_OpenChannelDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_OpenChannelDecodeErrorZ_get_err(LDKCResult_OpenChannelDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_OpenChannelDecodeErrorZ_get_err"))) TS_CResult_OpenChannelDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_OpenChannelDecodeErrorZ* owner_conv = (LDKCResult_OpenChannelDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_OpenChannelDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKRevokeAndACK CResult_RevokeAndACKDecodeErrorZ_get_ok(LDKCResult_RevokeAndACKDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return RevokeAndACK_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_RevokeAndACKDecodeErrorZ_get_ok"))) TS_CResult_RevokeAndACKDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_RevokeAndACKDecodeErrorZ* owner_conv = (LDKCResult_RevokeAndACKDecodeErrorZ*)(owner & ~1);
	LDKRevokeAndACK ret_var = CResult_RevokeAndACKDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_RevokeAndACKDecodeErrorZ_get_err(LDKCResult_RevokeAndACKDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_RevokeAndACKDecodeErrorZ_get_err"))) TS_CResult_RevokeAndACKDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_RevokeAndACKDecodeErrorZ* owner_conv = (LDKCResult_RevokeAndACKDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_RevokeAndACKDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKShutdown CResult_ShutdownDecodeErrorZ_get_ok(LDKCResult_ShutdownDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Shutdown_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownDecodeErrorZ_get_ok"))) TS_CResult_ShutdownDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ShutdownDecodeErrorZ* owner_conv = (LDKCResult_ShutdownDecodeErrorZ*)(owner & ~1);
	LDKShutdown ret_var = CResult_ShutdownDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ShutdownDecodeErrorZ_get_err(LDKCResult_ShutdownDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownDecodeErrorZ_get_err"))) TS_CResult_ShutdownDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ShutdownDecodeErrorZ* owner_conv = (LDKCResult_ShutdownDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ShutdownDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKUpdateFailHTLC CResult_UpdateFailHTLCDecodeErrorZ_get_ok(LDKCResult_UpdateFailHTLCDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return UpdateFailHTLC_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFailHTLCDecodeErrorZ_get_ok"))) TS_CResult_UpdateFailHTLCDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_UpdateFailHTLCDecodeErrorZ* owner_conv = (LDKCResult_UpdateFailHTLCDecodeErrorZ*)(owner & ~1);
	LDKUpdateFailHTLC ret_var = CResult_UpdateFailHTLCDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_UpdateFailHTLCDecodeErrorZ_get_err(LDKCResult_UpdateFailHTLCDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFailHTLCDecodeErrorZ_get_err"))) TS_CResult_UpdateFailHTLCDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_UpdateFailHTLCDecodeErrorZ* owner_conv = (LDKCResult_UpdateFailHTLCDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_UpdateFailHTLCDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKUpdateFailMalformedHTLC CResult_UpdateFailMalformedHTLCDecodeErrorZ_get_ok(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return UpdateFailMalformedHTLC_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_get_ok"))) TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* owner_conv = (LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ*)(owner & ~1);
	LDKUpdateFailMalformedHTLC ret_var = CResult_UpdateFailMalformedHTLCDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_UpdateFailMalformedHTLCDecodeErrorZ_get_err(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_get_err"))) TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* owner_conv = (LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_UpdateFailMalformedHTLCDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKUpdateFee CResult_UpdateFeeDecodeErrorZ_get_ok(LDKCResult_UpdateFeeDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return UpdateFee_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFeeDecodeErrorZ_get_ok"))) TS_CResult_UpdateFeeDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_UpdateFeeDecodeErrorZ* owner_conv = (LDKCResult_UpdateFeeDecodeErrorZ*)(owner & ~1);
	LDKUpdateFee ret_var = CResult_UpdateFeeDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_UpdateFeeDecodeErrorZ_get_err(LDKCResult_UpdateFeeDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFeeDecodeErrorZ_get_err"))) TS_CResult_UpdateFeeDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_UpdateFeeDecodeErrorZ* owner_conv = (LDKCResult_UpdateFeeDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_UpdateFeeDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKUpdateFulfillHTLC CResult_UpdateFulfillHTLCDecodeErrorZ_get_ok(LDKCResult_UpdateFulfillHTLCDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return UpdateFulfillHTLC_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFulfillHTLCDecodeErrorZ_get_ok"))) TS_CResult_UpdateFulfillHTLCDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* owner_conv = (LDKCResult_UpdateFulfillHTLCDecodeErrorZ*)(owner & ~1);
	LDKUpdateFulfillHTLC ret_var = CResult_UpdateFulfillHTLCDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_UpdateFulfillHTLCDecodeErrorZ_get_err(LDKCResult_UpdateFulfillHTLCDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFulfillHTLCDecodeErrorZ_get_err"))) TS_CResult_UpdateFulfillHTLCDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* owner_conv = (LDKCResult_UpdateFulfillHTLCDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_UpdateFulfillHTLCDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKUpdateAddHTLC CResult_UpdateAddHTLCDecodeErrorZ_get_ok(LDKCResult_UpdateAddHTLCDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return UpdateAddHTLC_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateAddHTLCDecodeErrorZ_get_ok"))) TS_CResult_UpdateAddHTLCDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_UpdateAddHTLCDecodeErrorZ* owner_conv = (LDKCResult_UpdateAddHTLCDecodeErrorZ*)(owner & ~1);
	LDKUpdateAddHTLC ret_var = CResult_UpdateAddHTLCDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_UpdateAddHTLCDecodeErrorZ_get_err(LDKCResult_UpdateAddHTLCDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateAddHTLCDecodeErrorZ_get_err"))) TS_CResult_UpdateAddHTLCDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_UpdateAddHTLCDecodeErrorZ* owner_conv = (LDKCResult_UpdateAddHTLCDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_UpdateAddHTLCDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKPing CResult_PingDecodeErrorZ_get_ok(LDKCResult_PingDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Ping_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_PingDecodeErrorZ_get_ok"))) TS_CResult_PingDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PingDecodeErrorZ* owner_conv = (LDKCResult_PingDecodeErrorZ*)(owner & ~1);
	LDKPing ret_var = CResult_PingDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_PingDecodeErrorZ_get_err(LDKCResult_PingDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PingDecodeErrorZ_get_err"))) TS_CResult_PingDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_PingDecodeErrorZ* owner_conv = (LDKCResult_PingDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_PingDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKPong CResult_PongDecodeErrorZ_get_ok(LDKCResult_PongDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Pong_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_PongDecodeErrorZ_get_ok"))) TS_CResult_PongDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_PongDecodeErrorZ* owner_conv = (LDKCResult_PongDecodeErrorZ*)(owner & ~1);
	LDKPong ret_var = CResult_PongDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_PongDecodeErrorZ_get_err(LDKCResult_PongDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_PongDecodeErrorZ_get_err"))) TS_CResult_PongDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_PongDecodeErrorZ* owner_conv = (LDKCResult_PongDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_PongDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKUnsignedChannelAnnouncement CResult_UnsignedChannelAnnouncementDecodeErrorZ_get_ok(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return UnsignedChannelAnnouncement_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_get_ok"))) TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* owner_conv = (LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ*)(owner & ~1);
	LDKUnsignedChannelAnnouncement ret_var = CResult_UnsignedChannelAnnouncementDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_UnsignedChannelAnnouncementDecodeErrorZ_get_err(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_get_err"))) TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* owner_conv = (LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_UnsignedChannelAnnouncementDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelAnnouncement CResult_ChannelAnnouncementDecodeErrorZ_get_ok(LDKCResult_ChannelAnnouncementDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelAnnouncement_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelAnnouncementDecodeErrorZ_get_ok"))) TS_CResult_ChannelAnnouncementDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelAnnouncementDecodeErrorZ* owner_conv = (LDKCResult_ChannelAnnouncementDecodeErrorZ*)(owner & ~1);
	LDKChannelAnnouncement ret_var = CResult_ChannelAnnouncementDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelAnnouncementDecodeErrorZ_get_err(LDKCResult_ChannelAnnouncementDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelAnnouncementDecodeErrorZ_get_err"))) TS_CResult_ChannelAnnouncementDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelAnnouncementDecodeErrorZ* owner_conv = (LDKCResult_ChannelAnnouncementDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelAnnouncementDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKUnsignedChannelUpdate CResult_UnsignedChannelUpdateDecodeErrorZ_get_ok(LDKCResult_UnsignedChannelUpdateDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return UnsignedChannelUpdate_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelUpdateDecodeErrorZ_get_ok"))) TS_CResult_UnsignedChannelUpdateDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* owner_conv = (LDKCResult_UnsignedChannelUpdateDecodeErrorZ*)(owner & ~1);
	LDKUnsignedChannelUpdate ret_var = CResult_UnsignedChannelUpdateDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_UnsignedChannelUpdateDecodeErrorZ_get_err(LDKCResult_UnsignedChannelUpdateDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelUpdateDecodeErrorZ_get_err"))) TS_CResult_UnsignedChannelUpdateDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* owner_conv = (LDKCResult_UnsignedChannelUpdateDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_UnsignedChannelUpdateDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKChannelUpdate CResult_ChannelUpdateDecodeErrorZ_get_ok(LDKCResult_ChannelUpdateDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ChannelUpdate_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateDecodeErrorZ_get_ok"))) TS_CResult_ChannelUpdateDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ChannelUpdateDecodeErrorZ* owner_conv = (LDKCResult_ChannelUpdateDecodeErrorZ*)(owner & ~1);
	LDKChannelUpdate ret_var = CResult_ChannelUpdateDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ChannelUpdateDecodeErrorZ_get_err(LDKCResult_ChannelUpdateDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateDecodeErrorZ_get_err"))) TS_CResult_ChannelUpdateDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ChannelUpdateDecodeErrorZ* owner_conv = (LDKCResult_ChannelUpdateDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ChannelUpdateDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKErrorMessage CResult_ErrorMessageDecodeErrorZ_get_ok(LDKCResult_ErrorMessageDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ErrorMessage_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ErrorMessageDecodeErrorZ_get_ok"))) TS_CResult_ErrorMessageDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ErrorMessageDecodeErrorZ* owner_conv = (LDKCResult_ErrorMessageDecodeErrorZ*)(owner & ~1);
	LDKErrorMessage ret_var = CResult_ErrorMessageDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ErrorMessageDecodeErrorZ_get_err(LDKCResult_ErrorMessageDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ErrorMessageDecodeErrorZ_get_err"))) TS_CResult_ErrorMessageDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ErrorMessageDecodeErrorZ* owner_conv = (LDKCResult_ErrorMessageDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ErrorMessageDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKWarningMessage CResult_WarningMessageDecodeErrorZ_get_ok(LDKCResult_WarningMessageDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return WarningMessage_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_WarningMessageDecodeErrorZ_get_ok"))) TS_CResult_WarningMessageDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_WarningMessageDecodeErrorZ* owner_conv = (LDKCResult_WarningMessageDecodeErrorZ*)(owner & ~1);
	LDKWarningMessage ret_var = CResult_WarningMessageDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_WarningMessageDecodeErrorZ_get_err(LDKCResult_WarningMessageDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_WarningMessageDecodeErrorZ_get_err"))) TS_CResult_WarningMessageDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_WarningMessageDecodeErrorZ* owner_conv = (LDKCResult_WarningMessageDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_WarningMessageDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKUnsignedNodeAnnouncement CResult_UnsignedNodeAnnouncementDecodeErrorZ_get_ok(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return UnsignedNodeAnnouncement_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_get_ok"))) TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* owner_conv = (LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ*)(owner & ~1);
	LDKUnsignedNodeAnnouncement ret_var = CResult_UnsignedNodeAnnouncementDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_UnsignedNodeAnnouncementDecodeErrorZ_get_err(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_get_err"))) TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* owner_conv = (LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_UnsignedNodeAnnouncementDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKNodeAnnouncement CResult_NodeAnnouncementDecodeErrorZ_get_ok(LDKCResult_NodeAnnouncementDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return NodeAnnouncement_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementDecodeErrorZ_get_ok"))) TS_CResult_NodeAnnouncementDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_NodeAnnouncementDecodeErrorZ* owner_conv = (LDKCResult_NodeAnnouncementDecodeErrorZ*)(owner & ~1);
	LDKNodeAnnouncement ret_var = CResult_NodeAnnouncementDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_NodeAnnouncementDecodeErrorZ_get_err(LDKCResult_NodeAnnouncementDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementDecodeErrorZ_get_err"))) TS_CResult_NodeAnnouncementDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_NodeAnnouncementDecodeErrorZ* owner_conv = (LDKCResult_NodeAnnouncementDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_NodeAnnouncementDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKQueryShortChannelIds CResult_QueryShortChannelIdsDecodeErrorZ_get_ok(LDKCResult_QueryShortChannelIdsDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return QueryShortChannelIds_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_QueryShortChannelIdsDecodeErrorZ_get_ok"))) TS_CResult_QueryShortChannelIdsDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* owner_conv = (LDKCResult_QueryShortChannelIdsDecodeErrorZ*)(owner & ~1);
	LDKQueryShortChannelIds ret_var = CResult_QueryShortChannelIdsDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_QueryShortChannelIdsDecodeErrorZ_get_err(LDKCResult_QueryShortChannelIdsDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_QueryShortChannelIdsDecodeErrorZ_get_err"))) TS_CResult_QueryShortChannelIdsDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* owner_conv = (LDKCResult_QueryShortChannelIdsDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_QueryShortChannelIdsDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKReplyShortChannelIdsEnd CResult_ReplyShortChannelIdsEndDecodeErrorZ_get_ok(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ReplyShortChannelIdsEnd_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_get_ok"))) TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* owner_conv = (LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ*)(owner & ~1);
	LDKReplyShortChannelIdsEnd ret_var = CResult_ReplyShortChannelIdsEndDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ReplyShortChannelIdsEndDecodeErrorZ_get_err(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_get_err"))) TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* owner_conv = (LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ReplyShortChannelIdsEndDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKQueryChannelRange CResult_QueryChannelRangeDecodeErrorZ_get_ok(LDKCResult_QueryChannelRangeDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return QueryChannelRange_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_QueryChannelRangeDecodeErrorZ_get_ok"))) TS_CResult_QueryChannelRangeDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_QueryChannelRangeDecodeErrorZ* owner_conv = (LDKCResult_QueryChannelRangeDecodeErrorZ*)(owner & ~1);
	LDKQueryChannelRange ret_var = CResult_QueryChannelRangeDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_QueryChannelRangeDecodeErrorZ_get_err(LDKCResult_QueryChannelRangeDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_QueryChannelRangeDecodeErrorZ_get_err"))) TS_CResult_QueryChannelRangeDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_QueryChannelRangeDecodeErrorZ* owner_conv = (LDKCResult_QueryChannelRangeDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_QueryChannelRangeDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKReplyChannelRange CResult_ReplyChannelRangeDecodeErrorZ_get_ok(LDKCResult_ReplyChannelRangeDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return ReplyChannelRange_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_ReplyChannelRangeDecodeErrorZ_get_ok"))) TS_CResult_ReplyChannelRangeDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_ReplyChannelRangeDecodeErrorZ* owner_conv = (LDKCResult_ReplyChannelRangeDecodeErrorZ*)(owner & ~1);
	LDKReplyChannelRange ret_var = CResult_ReplyChannelRangeDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_ReplyChannelRangeDecodeErrorZ_get_err(LDKCResult_ReplyChannelRangeDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_ReplyChannelRangeDecodeErrorZ_get_err"))) TS_CResult_ReplyChannelRangeDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_ReplyChannelRangeDecodeErrorZ* owner_conv = (LDKCResult_ReplyChannelRangeDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_ReplyChannelRangeDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKGossipTimestampFilter CResult_GossipTimestampFilterDecodeErrorZ_get_ok(LDKCResult_GossipTimestampFilterDecodeErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return GossipTimestampFilter_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_GossipTimestampFilterDecodeErrorZ_get_ok"))) TS_CResult_GossipTimestampFilterDecodeErrorZ_get_ok(uint32_t owner) {
	LDKCResult_GossipTimestampFilterDecodeErrorZ* owner_conv = (LDKCResult_GossipTimestampFilterDecodeErrorZ*)(owner & ~1);
	LDKGossipTimestampFilter ret_var = CResult_GossipTimestampFilterDecodeErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKDecodeError CResult_GossipTimestampFilterDecodeErrorZ_get_err(LDKCResult_GossipTimestampFilterDecodeErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return DecodeError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_GossipTimestampFilterDecodeErrorZ_get_err"))) TS_CResult_GossipTimestampFilterDecodeErrorZ_get_err(uint32_t owner) {
	LDKCResult_GossipTimestampFilterDecodeErrorZ* owner_conv = (LDKCResult_GossipTimestampFilterDecodeErrorZ*)(owner & ~1);
	LDKDecodeError ret_var = CResult_GossipTimestampFilterDecodeErrorZ_get_err(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKSignOrCreationError_ty_from_ptr"))) TS_LDKSignOrCreationError_ty_from_ptr(uint32_t ptr) {
	LDKSignOrCreationError *obj = (LDKSignOrCreationError*)(ptr & ~1);
	switch(obj->tag) {
		case LDKSignOrCreationError_SignError: return 0;
		case LDKSignOrCreationError_CreationError: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKSignOrCreationError_CreationError_get_creation_error"))) TS_LDKSignOrCreationError_CreationError_get_creation_error(uint32_t ptr) {
	LDKSignOrCreationError *obj = (LDKSignOrCreationError*)(ptr & ~1);
	assert(obj->tag == LDKSignOrCreationError_CreationError);
			uint32_t creation_error_conv = LDKCreationError_to_js(obj->creation_error);
	return creation_error_conv;
}
static inline struct LDKInvoice CResult_InvoiceSignOrCreationErrorZ_get_ok(LDKCResult_InvoiceSignOrCreationErrorZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return Invoice_clone(&*owner->contents.result);
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceSignOrCreationErrorZ_get_ok"))) TS_CResult_InvoiceSignOrCreationErrorZ_get_ok(uint32_t owner) {
	LDKCResult_InvoiceSignOrCreationErrorZ* owner_conv = (LDKCResult_InvoiceSignOrCreationErrorZ*)(owner & ~1);
	LDKInvoice ret_var = CResult_InvoiceSignOrCreationErrorZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline struct LDKSignOrCreationError CResult_InvoiceSignOrCreationErrorZ_get_err(LDKCResult_InvoiceSignOrCreationErrorZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return SignOrCreationError_clone(&*owner->contents.err);
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceSignOrCreationErrorZ_get_err"))) TS_CResult_InvoiceSignOrCreationErrorZ_get_err(uint32_t owner) {
	LDKCResult_InvoiceSignOrCreationErrorZ* owner_conv = (LDKCResult_InvoiceSignOrCreationErrorZ*)(owner & ~1);
	LDKSignOrCreationError *ret_copy = MALLOC(sizeof(LDKSignOrCreationError), "LDKSignOrCreationError");
	*ret_copy = CResult_InvoiceSignOrCreationErrorZ_get_err(owner_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

typedef struct LDKFilter_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKFilter_JCalls;
static void LDKFilter_JCalls_free(void* this_arg) {
	LDKFilter_JCalls *j_calls = (LDKFilter_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
void register_tx_LDKFilter_jcall(const void* this_arg, const uint8_t (* txid)[32], LDKu8slice script_pubkey) {
	LDKFilter_JCalls *j_calls = (LDKFilter_JCalls*) this_arg;
	int8_tArray txid_arr = init_int8_tArray(32, __LINE__);
	memcpy(txid_arr->elems, *txid, 32);
	LDKu8slice script_pubkey_var = script_pubkey;
	int8_tArray script_pubkey_arr = init_int8_tArray(script_pubkey_var.datalen, __LINE__);
	memcpy(script_pubkey_arr->elems, script_pubkey_var.data, script_pubkey_var.datalen);
	js_invoke_function_2(j_calls->instance_ptr, 32, (uint32_t)txid_arr, (uint32_t)script_pubkey_arr);
}
LDKCOption_C2Tuple_usizeTransactionZZ register_output_LDKFilter_jcall(const void* this_arg, LDKWatchedOutput output) {
	LDKFilter_JCalls *j_calls = (LDKFilter_JCalls*) this_arg;
	LDKWatchedOutput output_var = output;
	uint32_t output_ref = 0;
	CHECK((((uintptr_t)output_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&output_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(output_var);
	output_ref = (uintptr_t)output_var.inner;
	if (output_var.is_owned) {
		output_ref |= 1;
	}
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 33, (uint32_t)output_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCOption_C2Tuple_usizeTransactionZZ ret_conv = *(LDKCOption_C2Tuple_usizeTransactionZZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
static void LDKFilter_JCalls_cloned(LDKFilter* new_obj) {
	LDKFilter_JCalls *j_calls = (LDKFilter_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKFilter LDKFilter_init (JSValue o) {
	LDKFilter_JCalls *calls = MALLOC(sizeof(LDKFilter_JCalls), "LDKFilter_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKFilter ret = {
		.this_arg = (void*) calls,
		.register_tx = register_tx_LDKFilter_jcall,
		.register_output = register_output_LDKFilter_jcall,
		.free = LDKFilter_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKFilter_new"))) TS_LDKFilter_new(JSValue o) {
	LDKFilter *res_ptr = MALLOC(sizeof(LDKFilter), "LDKFilter");
	*res_ptr = LDKFilter_init(o);
	return (long)res_ptr;
}
void  __attribute__((export_name("TS_Filter_register_tx"))) TS_Filter_register_tx(uint32_t this_arg, int8_tArray txid, int8_tArray script_pubkey) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKFilter* this_arg_conv = (LDKFilter*)this_arg_ptr;
	unsigned char txid_arr[32];
	CHECK(txid->arr_len == 32);
	memcpy(txid_arr, txid->elems, 32); FREE(txid);
	unsigned char (*txid_ref)[32] = &txid_arr;
	LDKu8slice script_pubkey_ref;
	script_pubkey_ref.datalen = script_pubkey->arr_len;
	script_pubkey_ref.data = script_pubkey->elems /* XXX script_pubkey leaks */;
	(this_arg_conv->register_tx)(this_arg_conv->this_arg, txid_ref, script_pubkey_ref);
}

uint32_t  __attribute__((export_name("TS_Filter_register_output"))) TS_Filter_register_output(uint32_t this_arg, uint32_t output) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKFilter* this_arg_conv = (LDKFilter*)this_arg_ptr;
	LDKWatchedOutput output_conv;
	output_conv.inner = (void*)(output & (~1));
	output_conv.is_owned = (output & 1) || (output == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(output_conv);
	output_conv = WatchedOutput_clone(&output_conv);
	LDKCOption_C2Tuple_usizeTransactionZZ *ret_copy = MALLOC(sizeof(LDKCOption_C2Tuple_usizeTransactionZZ), "LDKCOption_C2Tuple_usizeTransactionZZ");
	*ret_copy = (this_arg_conv->register_output)(this_arg_conv->this_arg, output_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t __attribute__((export_name("TS_LDKCOption_FilterZ_ty_from_ptr"))) TS_LDKCOption_FilterZ_ty_from_ptr(uint32_t ptr) {
	LDKCOption_FilterZ *obj = (LDKCOption_FilterZ*)(ptr & ~1);
	switch(obj->tag) {
		case LDKCOption_FilterZ_Some: return 0;
		case LDKCOption_FilterZ_None: return 1;
		default: abort();
	}
}
uint32_t __attribute__((export_name("TS_LDKCOption_FilterZ_Some_get_some"))) TS_LDKCOption_FilterZ_Some_get_some(uint32_t ptr) {
	LDKCOption_FilterZ *obj = (LDKCOption_FilterZ*)(ptr & ~1);
	assert(obj->tag == LDKCOption_FilterZ_Some);
			LDKFilter* some_ret = MALLOC(sizeof(LDKFilter), "LDKFilter");
			*some_ret = obj->some;
			// WARNING: We likely need to clone here, but no clone is available, so we just do it for Java instances
			if ((*some_ret).free == LDKFilter_JCalls_free) {
				// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
				LDKFilter_JCalls_cloned(&(*some_ret));
			}
	return (uint32_t)some_ret;
}
static inline struct LDKLockedChannelMonitor *CResult_LockedChannelMonitorNoneZ_get_ok(LDKCResult_LockedChannelMonitorNoneZ *NONNULL_PTR owner){
CHECK(owner->result_ok);
	return &*owner->contents.result;
}
uint32_t  __attribute__((export_name("TS_CResult_LockedChannelMonitorNoneZ_get_ok"))) TS_CResult_LockedChannelMonitorNoneZ_get_ok(uint32_t owner) {
	LDKCResult_LockedChannelMonitorNoneZ* owner_conv = (LDKCResult_LockedChannelMonitorNoneZ*)(owner & ~1);
	LDKLockedChannelMonitor ret_var = *CResult_LockedChannelMonitorNoneZ_get_ok(owner_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner & ~1;
	return ret_ref;
}

static inline void CResult_LockedChannelMonitorNoneZ_get_err(LDKCResult_LockedChannelMonitorNoneZ *NONNULL_PTR owner){
CHECK(!owner->result_ok);
	return *owner->contents.err;
}
void  __attribute__((export_name("TS_CResult_LockedChannelMonitorNoneZ_get_err"))) TS_CResult_LockedChannelMonitorNoneZ_get_err(uint32_t owner) {
	LDKCResult_LockedChannelMonitorNoneZ* owner_conv = (LDKCResult_LockedChannelMonitorNoneZ*)(owner & ~1);
	CResult_LockedChannelMonitorNoneZ_get_err(owner_conv);
}

static inline LDKCVec_OutPointZ CVec_OutPointZ_clone(const LDKCVec_OutPointZ *orig) {
	LDKCVec_OutPointZ ret = { .data = MALLOC(sizeof(LDKOutPoint) * orig->datalen, "LDKCVec_OutPointZ clone bytes"), .datalen = orig->datalen };
	for (size_t i = 0; i < ret.datalen; i++) {
		ret.data[i] = OutPoint_clone(&orig->data[i]);
	}
	return ret;
}
typedef struct LDKMessageSendEventsProvider_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKMessageSendEventsProvider_JCalls;
static void LDKMessageSendEventsProvider_JCalls_free(void* this_arg) {
	LDKMessageSendEventsProvider_JCalls *j_calls = (LDKMessageSendEventsProvider_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCVec_MessageSendEventZ get_and_clear_pending_msg_events_LDKMessageSendEventsProvider_jcall(const void* this_arg) {
	LDKMessageSendEventsProvider_JCalls *j_calls = (LDKMessageSendEventsProvider_JCalls*) this_arg;
	uint32_tArray ret = (uint32_tArray)js_invoke_function_0(j_calls->instance_ptr, 34);
	LDKCVec_MessageSendEventZ ret_constr;
	ret_constr.datalen = ret->arr_len;
	if (ret_constr.datalen > 0)
		ret_constr.data = MALLOC(ret_constr.datalen * sizeof(LDKMessageSendEvent), "LDKCVec_MessageSendEventZ Elements");
	else
		ret_constr.data = NULL;
	uint32_t* ret_vals = ret->elems /* XXX ret leaks */;
	for (size_t s = 0; s < ret_constr.datalen; s++) {
		uint32_t ret_conv_18 = ret_vals[s];
		void* ret_conv_18_ptr = (void*)(((uintptr_t)ret_conv_18) & ~1);
		CHECK_ACCESS(ret_conv_18_ptr);
		LDKMessageSendEvent ret_conv_18_conv = *(LDKMessageSendEvent*)(ret_conv_18_ptr);
		FREE((void*)ret_conv_18);
		ret_constr.data[s] = ret_conv_18_conv;
	}
	return ret_constr;
}
static void LDKMessageSendEventsProvider_JCalls_cloned(LDKMessageSendEventsProvider* new_obj) {
	LDKMessageSendEventsProvider_JCalls *j_calls = (LDKMessageSendEventsProvider_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKMessageSendEventsProvider LDKMessageSendEventsProvider_init (JSValue o) {
	LDKMessageSendEventsProvider_JCalls *calls = MALLOC(sizeof(LDKMessageSendEventsProvider_JCalls), "LDKMessageSendEventsProvider_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKMessageSendEventsProvider ret = {
		.this_arg = (void*) calls,
		.get_and_clear_pending_msg_events = get_and_clear_pending_msg_events_LDKMessageSendEventsProvider_jcall,
		.free = LDKMessageSendEventsProvider_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKMessageSendEventsProvider_new"))) TS_LDKMessageSendEventsProvider_new(JSValue o) {
	LDKMessageSendEventsProvider *res_ptr = MALLOC(sizeof(LDKMessageSendEventsProvider), "LDKMessageSendEventsProvider");
	*res_ptr = LDKMessageSendEventsProvider_init(o);
	return (long)res_ptr;
}
uint32_tArray  __attribute__((export_name("TS_MessageSendEventsProvider_get_and_clear_pending_msg_events"))) TS_MessageSendEventsProvider_get_and_clear_pending_msg_events(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKMessageSendEventsProvider* this_arg_conv = (LDKMessageSendEventsProvider*)this_arg_ptr;
	LDKCVec_MessageSendEventZ ret_var = (this_arg_conv->get_and_clear_pending_msg_events)(this_arg_conv->this_arg);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t s = 0; s < ret_var.datalen; s++) {
		LDKMessageSendEvent *ret_conv_18_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
		*ret_conv_18_copy = ret_var.data[s];
		uint32_t ret_conv_18_ref = (uintptr_t)ret_conv_18_copy;
		ret_arr_ptr[s] = ret_conv_18_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

typedef struct LDKEventHandler_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKEventHandler_JCalls;
static void LDKEventHandler_JCalls_free(void* this_arg) {
	LDKEventHandler_JCalls *j_calls = (LDKEventHandler_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
void handle_event_LDKEventHandler_jcall(const void* this_arg, const LDKEvent * event) {
	LDKEventHandler_JCalls *j_calls = (LDKEventHandler_JCalls*) this_arg;
	LDKEvent *ret_event = MALLOC(sizeof(LDKEvent), "LDKEvent ret conversion");
	*ret_event = Event_clone(event);
	js_invoke_function_1(j_calls->instance_ptr, 35, (uint32_t)(uint32_t)ret_event);
}
static void LDKEventHandler_JCalls_cloned(LDKEventHandler* new_obj) {
	LDKEventHandler_JCalls *j_calls = (LDKEventHandler_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKEventHandler LDKEventHandler_init (JSValue o) {
	LDKEventHandler_JCalls *calls = MALLOC(sizeof(LDKEventHandler_JCalls), "LDKEventHandler_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKEventHandler ret = {
		.this_arg = (void*) calls,
		.handle_event = handle_event_LDKEventHandler_jcall,
		.free = LDKEventHandler_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKEventHandler_new"))) TS_LDKEventHandler_new(JSValue o) {
	LDKEventHandler *res_ptr = MALLOC(sizeof(LDKEventHandler), "LDKEventHandler");
	*res_ptr = LDKEventHandler_init(o);
	return (long)res_ptr;
}
void  __attribute__((export_name("TS_EventHandler_handle_event"))) TS_EventHandler_handle_event(uint32_t this_arg, uint32_t event) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKEventHandler* this_arg_conv = (LDKEventHandler*)this_arg_ptr;
	LDKEvent* event_conv = (LDKEvent*)event;
	(this_arg_conv->handle_event)(this_arg_conv->this_arg, event_conv);
}

typedef struct LDKEventsProvider_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKEventsProvider_JCalls;
static void LDKEventsProvider_JCalls_free(void* this_arg) {
	LDKEventsProvider_JCalls *j_calls = (LDKEventsProvider_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
void process_pending_events_LDKEventsProvider_jcall(const void* this_arg, LDKEventHandler handler) {
	LDKEventsProvider_JCalls *j_calls = (LDKEventsProvider_JCalls*) this_arg;
	LDKEventHandler* handler_ret = MALLOC(sizeof(LDKEventHandler), "LDKEventHandler");
	*handler_ret = handler;
	js_invoke_function_1(j_calls->instance_ptr, 36, (uint32_t)(uint32_t)handler_ret);
}
static void LDKEventsProvider_JCalls_cloned(LDKEventsProvider* new_obj) {
	LDKEventsProvider_JCalls *j_calls = (LDKEventsProvider_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKEventsProvider LDKEventsProvider_init (JSValue o) {
	LDKEventsProvider_JCalls *calls = MALLOC(sizeof(LDKEventsProvider_JCalls), "LDKEventsProvider_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKEventsProvider ret = {
		.this_arg = (void*) calls,
		.process_pending_events = process_pending_events_LDKEventsProvider_jcall,
		.free = LDKEventsProvider_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKEventsProvider_new"))) TS_LDKEventsProvider_new(JSValue o) {
	LDKEventsProvider *res_ptr = MALLOC(sizeof(LDKEventsProvider), "LDKEventsProvider");
	*res_ptr = LDKEventsProvider_init(o);
	return (long)res_ptr;
}
void  __attribute__((export_name("TS_EventsProvider_process_pending_events"))) TS_EventsProvider_process_pending_events(uint32_t this_arg, uint32_t handler) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKEventsProvider* this_arg_conv = (LDKEventsProvider*)this_arg_ptr;
	void* handler_ptr = (void*)(((uintptr_t)handler) & ~1);
	CHECK_ACCESS(handler_ptr);
	LDKEventHandler handler_conv = *(LDKEventHandler*)(handler_ptr);
	if (handler_conv.free == LDKEventHandler_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKEventHandler_JCalls_cloned(&handler_conv);
	}
	(this_arg_conv->process_pending_events)(this_arg_conv->this_arg, handler_conv);
}

typedef struct LDKListen_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKListen_JCalls;
static void LDKListen_JCalls_free(void* this_arg) {
	LDKListen_JCalls *j_calls = (LDKListen_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
void block_connected_LDKListen_jcall(const void* this_arg, LDKu8slice block, uint32_t height) {
	LDKListen_JCalls *j_calls = (LDKListen_JCalls*) this_arg;
	LDKu8slice block_var = block;
	int8_tArray block_arr = init_int8_tArray(block_var.datalen, __LINE__);
	memcpy(block_arr->elems, block_var.data, block_var.datalen);
	js_invoke_function_2(j_calls->instance_ptr, 37, (uint32_t)block_arr, (uint32_t)height);
}
void block_disconnected_LDKListen_jcall(const void* this_arg, const uint8_t (* header)[80], uint32_t height) {
	LDKListen_JCalls *j_calls = (LDKListen_JCalls*) this_arg;
	int8_tArray header_arr = init_int8_tArray(80, __LINE__);
	memcpy(header_arr->elems, *header, 80);
	js_invoke_function_2(j_calls->instance_ptr, 38, (uint32_t)header_arr, (uint32_t)height);
}
static void LDKListen_JCalls_cloned(LDKListen* new_obj) {
	LDKListen_JCalls *j_calls = (LDKListen_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKListen LDKListen_init (JSValue o) {
	LDKListen_JCalls *calls = MALLOC(sizeof(LDKListen_JCalls), "LDKListen_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKListen ret = {
		.this_arg = (void*) calls,
		.block_connected = block_connected_LDKListen_jcall,
		.block_disconnected = block_disconnected_LDKListen_jcall,
		.free = LDKListen_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKListen_new"))) TS_LDKListen_new(JSValue o) {
	LDKListen *res_ptr = MALLOC(sizeof(LDKListen), "LDKListen");
	*res_ptr = LDKListen_init(o);
	return (long)res_ptr;
}
void  __attribute__((export_name("TS_Listen_block_connected"))) TS_Listen_block_connected(uint32_t this_arg, int8_tArray block, int32_t height) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKListen* this_arg_conv = (LDKListen*)this_arg_ptr;
	LDKu8slice block_ref;
	block_ref.datalen = block->arr_len;
	block_ref.data = block->elems /* XXX block leaks */;
	(this_arg_conv->block_connected)(this_arg_conv->this_arg, block_ref, height);
}

void  __attribute__((export_name("TS_Listen_block_disconnected"))) TS_Listen_block_disconnected(uint32_t this_arg, int8_tArray header, int32_t height) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKListen* this_arg_conv = (LDKListen*)this_arg_ptr;
	unsigned char header_arr[80];
	CHECK(header->arr_len == 80);
	memcpy(header_arr, header->elems, 80); FREE(header);
	unsigned char (*header_ref)[80] = &header_arr;
	(this_arg_conv->block_disconnected)(this_arg_conv->this_arg, header_ref, height);
}

typedef struct LDKConfirm_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKConfirm_JCalls;
static void LDKConfirm_JCalls_free(void* this_arg) {
	LDKConfirm_JCalls *j_calls = (LDKConfirm_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
void transactions_confirmed_LDKConfirm_jcall(const void* this_arg, const uint8_t (* header)[80], LDKCVec_C2Tuple_usizeTransactionZZ txdata, uint32_t height) {
	LDKConfirm_JCalls *j_calls = (LDKConfirm_JCalls*) this_arg;
	int8_tArray header_arr = init_int8_tArray(80, __LINE__);
	memcpy(header_arr->elems, *header, 80);
	LDKCVec_C2Tuple_usizeTransactionZZ txdata_var = txdata;
	uint32_tArray txdata_arr = NULL;
	txdata_arr = init_uint32_tArray(txdata_var.datalen, __LINE__);
	uint32_t *txdata_arr_ptr = (uint32_t*)(((uint8_t*)txdata_arr) + 4);
	for (size_t c = 0; c < txdata_var.datalen; c++) {
		LDKC2Tuple_usizeTransactionZ* txdata_conv_28_conv = MALLOC(sizeof(LDKC2Tuple_usizeTransactionZ), "LDKC2Tuple_usizeTransactionZ");
		*txdata_conv_28_conv = txdata_var.data[c];
		txdata_arr_ptr[c] = ((uint32_t)txdata_conv_28_conv);
	}
	
	FREE(txdata_var.data);
	js_invoke_function_3(j_calls->instance_ptr, 39, (uint32_t)header_arr, (uint32_t)txdata_arr, (uint32_t)height);
}
void transaction_unconfirmed_LDKConfirm_jcall(const void* this_arg, const uint8_t (* txid)[32]) {
	LDKConfirm_JCalls *j_calls = (LDKConfirm_JCalls*) this_arg;
	int8_tArray txid_arr = init_int8_tArray(32, __LINE__);
	memcpy(txid_arr->elems, *txid, 32);
	js_invoke_function_1(j_calls->instance_ptr, 40, (uint32_t)txid_arr);
}
void best_block_updated_LDKConfirm_jcall(const void* this_arg, const uint8_t (* header)[80], uint32_t height) {
	LDKConfirm_JCalls *j_calls = (LDKConfirm_JCalls*) this_arg;
	int8_tArray header_arr = init_int8_tArray(80, __LINE__);
	memcpy(header_arr->elems, *header, 80);
	js_invoke_function_2(j_calls->instance_ptr, 41, (uint32_t)header_arr, (uint32_t)height);
}
LDKCVec_TxidZ get_relevant_txids_LDKConfirm_jcall(const void* this_arg) {
	LDKConfirm_JCalls *j_calls = (LDKConfirm_JCalls*) this_arg;
	ptrArray ret = (ptrArray)js_invoke_function_0(j_calls->instance_ptr, 42);
	LDKCVec_TxidZ ret_constr;
	ret_constr.datalen = ret->arr_len;
	if (ret_constr.datalen > 0)
		ret_constr.data = MALLOC(ret_constr.datalen * sizeof(LDKThirtyTwoBytes), "LDKCVec_TxidZ Elements");
	else
		ret_constr.data = NULL;
	int8_tArray* ret_vals = (void*) ret->elems /* XXX ret leaks */;
	for (size_t m = 0; m < ret_constr.datalen; m++) {
		int8_tArray ret_conv_12 = ret_vals[m];
		LDKThirtyTwoBytes ret_conv_12_ref;
		CHECK(ret_conv_12->arr_len == 32);
		memcpy(ret_conv_12_ref.data, ret_conv_12->elems, 32); FREE(ret_conv_12);
		ret_constr.data[m] = ret_conv_12_ref;
	}
	return ret_constr;
}
static void LDKConfirm_JCalls_cloned(LDKConfirm* new_obj) {
	LDKConfirm_JCalls *j_calls = (LDKConfirm_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKConfirm LDKConfirm_init (JSValue o) {
	LDKConfirm_JCalls *calls = MALLOC(sizeof(LDKConfirm_JCalls), "LDKConfirm_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKConfirm ret = {
		.this_arg = (void*) calls,
		.transactions_confirmed = transactions_confirmed_LDKConfirm_jcall,
		.transaction_unconfirmed = transaction_unconfirmed_LDKConfirm_jcall,
		.best_block_updated = best_block_updated_LDKConfirm_jcall,
		.get_relevant_txids = get_relevant_txids_LDKConfirm_jcall,
		.free = LDKConfirm_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKConfirm_new"))) TS_LDKConfirm_new(JSValue o) {
	LDKConfirm *res_ptr = MALLOC(sizeof(LDKConfirm), "LDKConfirm");
	*res_ptr = LDKConfirm_init(o);
	return (long)res_ptr;
}
void  __attribute__((export_name("TS_Confirm_transactions_confirmed"))) TS_Confirm_transactions_confirmed(uint32_t this_arg, int8_tArray header, uint32_tArray txdata, int32_t height) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKConfirm* this_arg_conv = (LDKConfirm*)this_arg_ptr;
	unsigned char header_arr[80];
	CHECK(header->arr_len == 80);
	memcpy(header_arr, header->elems, 80); FREE(header);
	unsigned char (*header_ref)[80] = &header_arr;
	LDKCVec_C2Tuple_usizeTransactionZZ txdata_constr;
	txdata_constr.datalen = txdata->arr_len;
	if (txdata_constr.datalen > 0)
		txdata_constr.data = MALLOC(txdata_constr.datalen * sizeof(LDKC2Tuple_usizeTransactionZ), "LDKCVec_C2Tuple_usizeTransactionZZ Elements");
	else
		txdata_constr.data = NULL;
	uint32_t* txdata_vals = txdata->elems /* XXX txdata leaks */;
	for (size_t c = 0; c < txdata_constr.datalen; c++) {
		uint32_t txdata_conv_28 = txdata_vals[c];
		void* txdata_conv_28_ptr = (void*)(((uintptr_t)txdata_conv_28) & ~1);
		CHECK_ACCESS(txdata_conv_28_ptr);
		LDKC2Tuple_usizeTransactionZ txdata_conv_28_conv = *(LDKC2Tuple_usizeTransactionZ*)(txdata_conv_28_ptr);
		txdata_conv_28_conv = C2Tuple_usizeTransactionZ_clone((LDKC2Tuple_usizeTransactionZ*)(((uintptr_t)txdata_conv_28) & ~1));
		txdata_constr.data[c] = txdata_conv_28_conv;
	}
	(this_arg_conv->transactions_confirmed)(this_arg_conv->this_arg, header_ref, txdata_constr, height);
}

void  __attribute__((export_name("TS_Confirm_transaction_unconfirmed"))) TS_Confirm_transaction_unconfirmed(uint32_t this_arg, int8_tArray txid) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKConfirm* this_arg_conv = (LDKConfirm*)this_arg_ptr;
	unsigned char txid_arr[32];
	CHECK(txid->arr_len == 32);
	memcpy(txid_arr, txid->elems, 32); FREE(txid);
	unsigned char (*txid_ref)[32] = &txid_arr;
	(this_arg_conv->transaction_unconfirmed)(this_arg_conv->this_arg, txid_ref);
}

void  __attribute__((export_name("TS_Confirm_best_block_updated"))) TS_Confirm_best_block_updated(uint32_t this_arg, int8_tArray header, int32_t height) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKConfirm* this_arg_conv = (LDKConfirm*)this_arg_ptr;
	unsigned char header_arr[80];
	CHECK(header->arr_len == 80);
	memcpy(header_arr, header->elems, 80); FREE(header);
	unsigned char (*header_ref)[80] = &header_arr;
	(this_arg_conv->best_block_updated)(this_arg_conv->this_arg, header_ref, height);
}

ptrArray  __attribute__((export_name("TS_Confirm_get_relevant_txids"))) TS_Confirm_get_relevant_txids(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKConfirm* this_arg_conv = (LDKConfirm*)this_arg_ptr;
	LDKCVec_TxidZ ret_var = (this_arg_conv->get_relevant_txids)(this_arg_conv->this_arg);
	ptrArray ret_arr = NULL;
	ret_arr = init_ptrArray(ret_var.datalen, __LINE__);
	int8_tArray *ret_arr_ptr = (int8_tArray*)(((uint8_t*)ret_arr) + 4);
	for (size_t m = 0; m < ret_var.datalen; m++) {
		int8_tArray ret_conv_12_arr = init_int8_tArray(32, __LINE__);
		memcpy(ret_conv_12_arr->elems, ret_var.data[m].data, 32);
		ret_arr_ptr[m] = ret_conv_12_arr;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

typedef struct LDKPersist_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKPersist_JCalls;
static void LDKPersist_JCalls_free(void* this_arg) {
	LDKPersist_JCalls *j_calls = (LDKPersist_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCResult_NoneChannelMonitorUpdateErrZ persist_new_channel_LDKPersist_jcall(const void* this_arg, LDKOutPoint channel_id, const LDKChannelMonitor * data, LDKMonitorUpdateId update_id) {
	LDKPersist_JCalls *j_calls = (LDKPersist_JCalls*) this_arg;
	LDKOutPoint channel_id_var = channel_id;
	uint32_t channel_id_ref = 0;
	CHECK((((uintptr_t)channel_id_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&channel_id_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_id_var);
	channel_id_ref = (uintptr_t)channel_id_var.inner;
	if (channel_id_var.is_owned) {
		channel_id_ref |= 1;
	}
	LDKChannelMonitor data_var = *data;
	uint32_t data_ref = 0;
	data_var = ChannelMonitor_clone(&data_var);
	CHECK((((uintptr_t)data_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&data_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(data_var);
	data_ref = (uintptr_t)data_var.inner;
	if (data_var.is_owned) {
		data_ref |= 1;
	}
	LDKMonitorUpdateId update_id_var = update_id;
	uint32_t update_id_ref = 0;
	CHECK((((uintptr_t)update_id_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&update_id_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_id_var);
	update_id_ref = (uintptr_t)update_id_var.inner;
	if (update_id_var.is_owned) {
		update_id_ref |= 1;
	}
	uint32_t ret = js_invoke_function_3(j_calls->instance_ptr, 43, (uint32_t)channel_id_ref, (uint32_t)data_ref, (uint32_t)update_id_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneChannelMonitorUpdateErrZ ret_conv = *(LDKCResult_NoneChannelMonitorUpdateErrZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_NoneChannelMonitorUpdateErrZ update_persisted_channel_LDKPersist_jcall(const void* this_arg, LDKOutPoint channel_id, const LDKChannelMonitorUpdate * update, const LDKChannelMonitor * data, LDKMonitorUpdateId update_id) {
	LDKPersist_JCalls *j_calls = (LDKPersist_JCalls*) this_arg;
	LDKOutPoint channel_id_var = channel_id;
	uint32_t channel_id_ref = 0;
	CHECK((((uintptr_t)channel_id_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&channel_id_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_id_var);
	channel_id_ref = (uintptr_t)channel_id_var.inner;
	if (channel_id_var.is_owned) {
		channel_id_ref |= 1;
	}
	LDKChannelMonitorUpdate update_var = *update;
	uint32_t update_ref = 0;
	if ((uintptr_t)update_var.inner > 4096) {
		update_var = ChannelMonitorUpdate_clone(&update_var);
		CHECK((((uintptr_t)update_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&update_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_var);
		update_ref = (uintptr_t)update_var.inner;
		if (update_var.is_owned) {
			update_ref |= 1;
		}
	}
	LDKChannelMonitor data_var = *data;
	uint32_t data_ref = 0;
	data_var = ChannelMonitor_clone(&data_var);
	CHECK((((uintptr_t)data_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&data_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(data_var);
	data_ref = (uintptr_t)data_var.inner;
	if (data_var.is_owned) {
		data_ref |= 1;
	}
	LDKMonitorUpdateId update_id_var = update_id;
	uint32_t update_id_ref = 0;
	CHECK((((uintptr_t)update_id_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&update_id_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_id_var);
	update_id_ref = (uintptr_t)update_id_var.inner;
	if (update_id_var.is_owned) {
		update_id_ref |= 1;
	}
	uint32_t ret = js_invoke_function_4(j_calls->instance_ptr, 44, (uint32_t)channel_id_ref, (uint32_t)update_ref, (uint32_t)data_ref, (uint32_t)update_id_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneChannelMonitorUpdateErrZ ret_conv = *(LDKCResult_NoneChannelMonitorUpdateErrZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
static void LDKPersist_JCalls_cloned(LDKPersist* new_obj) {
	LDKPersist_JCalls *j_calls = (LDKPersist_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKPersist LDKPersist_init (JSValue o) {
	LDKPersist_JCalls *calls = MALLOC(sizeof(LDKPersist_JCalls), "LDKPersist_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKPersist ret = {
		.this_arg = (void*) calls,
		.persist_new_channel = persist_new_channel_LDKPersist_jcall,
		.update_persisted_channel = update_persisted_channel_LDKPersist_jcall,
		.free = LDKPersist_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKPersist_new"))) TS_LDKPersist_new(JSValue o) {
	LDKPersist *res_ptr = MALLOC(sizeof(LDKPersist), "LDKPersist");
	*res_ptr = LDKPersist_init(o);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_Persist_persist_new_channel"))) TS_Persist_persist_new_channel(uint32_t this_arg, uint32_t channel_id, uint32_t data, uint32_t update_id) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKPersist* this_arg_conv = (LDKPersist*)this_arg_ptr;
	LDKOutPoint channel_id_conv;
	channel_id_conv.inner = (void*)(channel_id & (~1));
	channel_id_conv.is_owned = (channel_id & 1) || (channel_id == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_id_conv);
	channel_id_conv = OutPoint_clone(&channel_id_conv);
	LDKChannelMonitor data_conv;
	data_conv.inner = (void*)(data & (~1));
	data_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(data_conv);
	LDKMonitorUpdateId update_id_conv;
	update_id_conv.inner = (void*)(update_id & (~1));
	update_id_conv.is_owned = (update_id & 1) || (update_id == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_id_conv);
	update_id_conv = MonitorUpdateId_clone(&update_id_conv);
	LDKCResult_NoneChannelMonitorUpdateErrZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneChannelMonitorUpdateErrZ), "LDKCResult_NoneChannelMonitorUpdateErrZ");
	*ret_conv = (this_arg_conv->persist_new_channel)(this_arg_conv->this_arg, channel_id_conv, &data_conv, update_id_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_Persist_update_persisted_channel"))) TS_Persist_update_persisted_channel(uint32_t this_arg, uint32_t channel_id, uint32_t update, uint32_t data, uint32_t update_id) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKPersist* this_arg_conv = (LDKPersist*)this_arg_ptr;
	LDKOutPoint channel_id_conv;
	channel_id_conv.inner = (void*)(channel_id & (~1));
	channel_id_conv.is_owned = (channel_id & 1) || (channel_id == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_id_conv);
	channel_id_conv = OutPoint_clone(&channel_id_conv);
	LDKChannelMonitorUpdate update_conv;
	update_conv.inner = (void*)(update & (~1));
	update_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_conv);
	LDKChannelMonitor data_conv;
	data_conv.inner = (void*)(data & (~1));
	data_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(data_conv);
	LDKMonitorUpdateId update_id_conv;
	update_id_conv.inner = (void*)(update_id & (~1));
	update_id_conv.is_owned = (update_id & 1) || (update_id == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_id_conv);
	update_id_conv = MonitorUpdateId_clone(&update_id_conv);
	LDKCResult_NoneChannelMonitorUpdateErrZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneChannelMonitorUpdateErrZ), "LDKCResult_NoneChannelMonitorUpdateErrZ");
	*ret_conv = (this_arg_conv->update_persisted_channel)(this_arg_conv->this_arg, channel_id_conv, &update_conv, &data_conv, update_id_conv);
	return (uint32_t)ret_conv;
}

typedef struct LDKChannelMessageHandler_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
	LDKMessageSendEventsProvider_JCalls* MessageSendEventsProvider;
} LDKChannelMessageHandler_JCalls;
static void LDKChannelMessageHandler_JCalls_free(void* this_arg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
void handle_open_channel_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, LDKInitFeatures their_features, const LDKOpenChannel * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKInitFeatures their_features_var = their_features;
	uint32_t their_features_ref = 0;
	CHECK((((uintptr_t)their_features_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&their_features_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(their_features_var);
	their_features_ref = (uintptr_t)their_features_var.inner;
	if (their_features_var.is_owned) {
		their_features_ref |= 1;
	}
	LDKOpenChannel msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = OpenChannel_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_3(j_calls->instance_ptr, 45, (uint32_t)their_node_id_arr, (uint32_t)their_features_ref, (uint32_t)msg_ref);
}
void handle_accept_channel_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, LDKInitFeatures their_features, const LDKAcceptChannel * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKInitFeatures their_features_var = their_features;
	uint32_t their_features_ref = 0;
	CHECK((((uintptr_t)their_features_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&their_features_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(their_features_var);
	their_features_ref = (uintptr_t)their_features_var.inner;
	if (their_features_var.is_owned) {
		their_features_ref |= 1;
	}
	LDKAcceptChannel msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = AcceptChannel_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_3(j_calls->instance_ptr, 46, (uint32_t)their_node_id_arr, (uint32_t)their_features_ref, (uint32_t)msg_ref);
}
void handle_funding_created_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKFundingCreated * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKFundingCreated msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = FundingCreated_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 47, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_funding_signed_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKFundingSigned * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKFundingSigned msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = FundingSigned_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 48, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_funding_locked_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKFundingLocked * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKFundingLocked msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = FundingLocked_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 49, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_shutdown_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKInitFeatures * their_features, const LDKShutdown * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKInitFeatures their_features_var = *their_features;
	uint32_t their_features_ref = 0;
	their_features_var = InitFeatures_clone(&their_features_var);
	CHECK((((uintptr_t)their_features_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&their_features_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(their_features_var);
	their_features_ref = (uintptr_t)their_features_var.inner;
	if (their_features_var.is_owned) {
		their_features_ref |= 1;
	}
	LDKShutdown msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = Shutdown_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_3(j_calls->instance_ptr, 50, (uint32_t)their_node_id_arr, (uint32_t)their_features_ref, (uint32_t)msg_ref);
}
void handle_closing_signed_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKClosingSigned * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKClosingSigned msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = ClosingSigned_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 51, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_update_add_htlc_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKUpdateAddHTLC * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKUpdateAddHTLC msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = UpdateAddHTLC_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 52, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_update_fulfill_htlc_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKUpdateFulfillHTLC * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKUpdateFulfillHTLC msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = UpdateFulfillHTLC_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 53, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_update_fail_htlc_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKUpdateFailHTLC * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKUpdateFailHTLC msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = UpdateFailHTLC_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 54, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_update_fail_malformed_htlc_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKUpdateFailMalformedHTLC * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKUpdateFailMalformedHTLC msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = UpdateFailMalformedHTLC_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 55, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_commitment_signed_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKCommitmentSigned * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKCommitmentSigned msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = CommitmentSigned_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 56, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_revoke_and_ack_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKRevokeAndACK * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKRevokeAndACK msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = RevokeAndACK_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 57, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_update_fee_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKUpdateFee * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKUpdateFee msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = UpdateFee_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 58, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_announcement_signatures_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKAnnouncementSignatures * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKAnnouncementSignatures msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = AnnouncementSignatures_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 59, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void peer_disconnected_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, bool no_connection_possible) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	js_invoke_function_2(j_calls->instance_ptr, 60, (uint32_t)their_node_id_arr, (uint32_t)no_connection_possible);
}
void peer_connected_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKInit * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKInit msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = Init_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 61, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_channel_reestablish_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKChannelReestablish * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKChannelReestablish msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = ChannelReestablish_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 62, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_channel_update_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKChannelUpdate * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKChannelUpdate msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = ChannelUpdate_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 63, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
void handle_error_LDKChannelMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKErrorMessage * msg) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKErrorMessage msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = ErrorMessage_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 64, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
}
static void LDKChannelMessageHandler_JCalls_cloned(LDKChannelMessageHandler* new_obj) {
	LDKChannelMessageHandler_JCalls *j_calls = (LDKChannelMessageHandler_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
	atomic_fetch_add_explicit(&j_calls->MessageSendEventsProvider->refcnt, 1, memory_order_release);
}
static inline LDKChannelMessageHandler LDKChannelMessageHandler_init (JSValue o, JSValue MessageSendEventsProvider) {
	LDKChannelMessageHandler_JCalls *calls = MALLOC(sizeof(LDKChannelMessageHandler_JCalls), "LDKChannelMessageHandler_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKChannelMessageHandler ret = {
		.this_arg = (void*) calls,
		.handle_open_channel = handle_open_channel_LDKChannelMessageHandler_jcall,
		.handle_accept_channel = handle_accept_channel_LDKChannelMessageHandler_jcall,
		.handle_funding_created = handle_funding_created_LDKChannelMessageHandler_jcall,
		.handle_funding_signed = handle_funding_signed_LDKChannelMessageHandler_jcall,
		.handle_funding_locked = handle_funding_locked_LDKChannelMessageHandler_jcall,
		.handle_shutdown = handle_shutdown_LDKChannelMessageHandler_jcall,
		.handle_closing_signed = handle_closing_signed_LDKChannelMessageHandler_jcall,
		.handle_update_add_htlc = handle_update_add_htlc_LDKChannelMessageHandler_jcall,
		.handle_update_fulfill_htlc = handle_update_fulfill_htlc_LDKChannelMessageHandler_jcall,
		.handle_update_fail_htlc = handle_update_fail_htlc_LDKChannelMessageHandler_jcall,
		.handle_update_fail_malformed_htlc = handle_update_fail_malformed_htlc_LDKChannelMessageHandler_jcall,
		.handle_commitment_signed = handle_commitment_signed_LDKChannelMessageHandler_jcall,
		.handle_revoke_and_ack = handle_revoke_and_ack_LDKChannelMessageHandler_jcall,
		.handle_update_fee = handle_update_fee_LDKChannelMessageHandler_jcall,
		.handle_announcement_signatures = handle_announcement_signatures_LDKChannelMessageHandler_jcall,
		.peer_disconnected = peer_disconnected_LDKChannelMessageHandler_jcall,
		.peer_connected = peer_connected_LDKChannelMessageHandler_jcall,
		.handle_channel_reestablish = handle_channel_reestablish_LDKChannelMessageHandler_jcall,
		.handle_channel_update = handle_channel_update_LDKChannelMessageHandler_jcall,
		.handle_error = handle_error_LDKChannelMessageHandler_jcall,
		.free = LDKChannelMessageHandler_JCalls_free,
		.MessageSendEventsProvider = LDKMessageSendEventsProvider_init(MessageSendEventsProvider),
	};
	calls->MessageSendEventsProvider = ret.MessageSendEventsProvider.this_arg;
	return ret;
}
long  __attribute__((export_name("TS_LDKChannelMessageHandler_new"))) TS_LDKChannelMessageHandler_new(JSValue o, JSValue MessageSendEventsProvider) {
	LDKChannelMessageHandler *res_ptr = MALLOC(sizeof(LDKChannelMessageHandler), "LDKChannelMessageHandler");
	*res_ptr = LDKChannelMessageHandler_init(o, MessageSendEventsProvider);
	return (long)res_ptr;
}
void  __attribute__((export_name("TS_ChannelMessageHandler_handle_open_channel"))) TS_ChannelMessageHandler_handle_open_channel(uint32_t this_arg, int8_tArray their_node_id, uint32_t their_features, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKInitFeatures their_features_conv;
	their_features_conv.inner = (void*)(their_features & (~1));
	their_features_conv.is_owned = (their_features & 1) || (their_features == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(their_features_conv);
	their_features_conv = InitFeatures_clone(&their_features_conv);
	LDKOpenChannel msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_open_channel)(this_arg_conv->this_arg, their_node_id_ref, their_features_conv, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_accept_channel"))) TS_ChannelMessageHandler_handle_accept_channel(uint32_t this_arg, int8_tArray their_node_id, uint32_t their_features, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKInitFeatures their_features_conv;
	their_features_conv.inner = (void*)(their_features & (~1));
	their_features_conv.is_owned = (their_features & 1) || (their_features == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(their_features_conv);
	their_features_conv = InitFeatures_clone(&their_features_conv);
	LDKAcceptChannel msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_accept_channel)(this_arg_conv->this_arg, their_node_id_ref, their_features_conv, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_funding_created"))) TS_ChannelMessageHandler_handle_funding_created(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKFundingCreated msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_funding_created)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_funding_signed"))) TS_ChannelMessageHandler_handle_funding_signed(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKFundingSigned msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_funding_signed)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_funding_locked"))) TS_ChannelMessageHandler_handle_funding_locked(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKFundingLocked msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_funding_locked)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_shutdown"))) TS_ChannelMessageHandler_handle_shutdown(uint32_t this_arg, int8_tArray their_node_id, uint32_t their_features, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKInitFeatures their_features_conv;
	their_features_conv.inner = (void*)(their_features & (~1));
	their_features_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(their_features_conv);
	LDKShutdown msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_shutdown)(this_arg_conv->this_arg, their_node_id_ref, &their_features_conv, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_closing_signed"))) TS_ChannelMessageHandler_handle_closing_signed(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKClosingSigned msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_closing_signed)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_update_add_htlc"))) TS_ChannelMessageHandler_handle_update_add_htlc(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKUpdateAddHTLC msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_update_add_htlc)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_update_fulfill_htlc"))) TS_ChannelMessageHandler_handle_update_fulfill_htlc(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKUpdateFulfillHTLC msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_update_fulfill_htlc)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_update_fail_htlc"))) TS_ChannelMessageHandler_handle_update_fail_htlc(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKUpdateFailHTLC msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_update_fail_htlc)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_update_fail_malformed_htlc"))) TS_ChannelMessageHandler_handle_update_fail_malformed_htlc(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKUpdateFailMalformedHTLC msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_update_fail_malformed_htlc)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_commitment_signed"))) TS_ChannelMessageHandler_handle_commitment_signed(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKCommitmentSigned msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_commitment_signed)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_revoke_and_ack"))) TS_ChannelMessageHandler_handle_revoke_and_ack(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKRevokeAndACK msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_revoke_and_ack)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_update_fee"))) TS_ChannelMessageHandler_handle_update_fee(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKUpdateFee msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_update_fee)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_announcement_signatures"))) TS_ChannelMessageHandler_handle_announcement_signatures(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKAnnouncementSignatures msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_announcement_signatures)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_peer_disconnected"))) TS_ChannelMessageHandler_peer_disconnected(uint32_t this_arg, int8_tArray their_node_id, jboolean no_connection_possible) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	(this_arg_conv->peer_disconnected)(this_arg_conv->this_arg, their_node_id_ref, no_connection_possible);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_peer_connected"))) TS_ChannelMessageHandler_peer_connected(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKInit msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->peer_connected)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_channel_reestablish"))) TS_ChannelMessageHandler_handle_channel_reestablish(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKChannelReestablish msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_channel_reestablish)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_channel_update"))) TS_ChannelMessageHandler_handle_channel_update(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKChannelUpdate msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_channel_update)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

void  __attribute__((export_name("TS_ChannelMessageHandler_handle_error"))) TS_ChannelMessageHandler_handle_error(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKChannelMessageHandler* this_arg_conv = (LDKChannelMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKErrorMessage msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	(this_arg_conv->handle_error)(this_arg_conv->this_arg, their_node_id_ref, &msg_conv);
}

typedef struct LDKRoutingMessageHandler_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
	LDKMessageSendEventsProvider_JCalls* MessageSendEventsProvider;
} LDKRoutingMessageHandler_JCalls;
static void LDKRoutingMessageHandler_JCalls_free(void* this_arg) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCResult_boolLightningErrorZ handle_node_announcement_LDKRoutingMessageHandler_jcall(const void* this_arg, const LDKNodeAnnouncement * msg) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	LDKNodeAnnouncement msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = NodeAnnouncement_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 65, (uint32_t)msg_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_boolLightningErrorZ ret_conv = *(LDKCResult_boolLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_boolLightningErrorZ handle_channel_announcement_LDKRoutingMessageHandler_jcall(const void* this_arg, const LDKChannelAnnouncement * msg) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	LDKChannelAnnouncement msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = ChannelAnnouncement_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 66, (uint32_t)msg_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_boolLightningErrorZ ret_conv = *(LDKCResult_boolLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_boolLightningErrorZ handle_channel_update_LDKRoutingMessageHandler_jcall(const void* this_arg, const LDKChannelUpdate * msg) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	LDKChannelUpdate msg_var = *msg;
	uint32_t msg_ref = 0;
	msg_var = ChannelUpdate_clone(&msg_var);
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	uint32_t ret = js_invoke_function_1(j_calls->instance_ptr, 67, (uint32_t)msg_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_boolLightningErrorZ ret_conv = *(LDKCResult_boolLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ get_next_channel_announcements_LDKRoutingMessageHandler_jcall(const void* this_arg, uint64_t starting_point, uint8_t batch_amount) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	uint32_tArray ret = (uint32_tArray)js_invoke_function_2(j_calls->instance_ptr, 68, (uint32_t)starting_point, (uint32_t)batch_amount);
	LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ ret_constr;
	ret_constr.datalen = ret->arr_len;
	if (ret_constr.datalen > 0)
		ret_constr.data = MALLOC(ret_constr.datalen * sizeof(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ), "LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ Elements");
	else
		ret_constr.data = NULL;
	uint32_t* ret_vals = ret->elems /* XXX ret leaks */;
	for (size_t h = 0; h < ret_constr.datalen; h++) {
		uint32_t ret_conv_59 = ret_vals[h];
		void* ret_conv_59_ptr = (void*)(((uintptr_t)ret_conv_59) & ~1);
		CHECK_ACCESS(ret_conv_59_ptr);
		LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ ret_conv_59_conv = *(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ*)(ret_conv_59_ptr);
		FREE((void*)ret_conv_59);
		ret_constr.data[h] = ret_conv_59_conv;
	}
	return ret_constr;
}
LDKCVec_NodeAnnouncementZ get_next_node_announcements_LDKRoutingMessageHandler_jcall(const void* this_arg, LDKPublicKey starting_point, uint8_t batch_amount) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	int8_tArray starting_point_arr = init_int8_tArray(33, __LINE__);
	memcpy(starting_point_arr->elems, starting_point.compressed_form, 33);
	uint32_tArray ret = (uint32_tArray)js_invoke_function_2(j_calls->instance_ptr, 69, (uint32_t)starting_point_arr, (uint32_t)batch_amount);
	LDKCVec_NodeAnnouncementZ ret_constr;
	ret_constr.datalen = ret->arr_len;
	if (ret_constr.datalen > 0)
		ret_constr.data = MALLOC(ret_constr.datalen * sizeof(LDKNodeAnnouncement), "LDKCVec_NodeAnnouncementZ Elements");
	else
		ret_constr.data = NULL;
	uint32_t* ret_vals = ret->elems /* XXX ret leaks */;
	for (size_t s = 0; s < ret_constr.datalen; s++) {
		uint32_t ret_conv_18 = ret_vals[s];
		LDKNodeAnnouncement ret_conv_18_conv;
		ret_conv_18_conv.inner = (void*)(ret_conv_18 & (~1));
		ret_conv_18_conv.is_owned = (ret_conv_18 & 1) || (ret_conv_18 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_18_conv);
		ret_constr.data[s] = ret_conv_18_conv;
	}
	return ret_constr;
}
void peer_connected_LDKRoutingMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, const LDKInit * init) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKInit init_var = *init;
	uint32_t init_ref = 0;
	init_var = Init_clone(&init_var);
	CHECK((((uintptr_t)init_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&init_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(init_var);
	init_ref = (uintptr_t)init_var.inner;
	if (init_var.is_owned) {
		init_ref |= 1;
	}
	js_invoke_function_2(j_calls->instance_ptr, 70, (uint32_t)their_node_id_arr, (uint32_t)init_ref);
}
LDKCResult_NoneLightningErrorZ handle_reply_channel_range_LDKRoutingMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, LDKReplyChannelRange msg) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKReplyChannelRange msg_var = msg;
	uint32_t msg_ref = 0;
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 71, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneLightningErrorZ ret_conv = *(LDKCResult_NoneLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_NoneLightningErrorZ handle_reply_short_channel_ids_end_LDKRoutingMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, LDKReplyShortChannelIdsEnd msg) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKReplyShortChannelIdsEnd msg_var = msg;
	uint32_t msg_ref = 0;
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 72, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneLightningErrorZ ret_conv = *(LDKCResult_NoneLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_NoneLightningErrorZ handle_query_channel_range_LDKRoutingMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, LDKQueryChannelRange msg) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKQueryChannelRange msg_var = msg;
	uint32_t msg_ref = 0;
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 73, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneLightningErrorZ ret_conv = *(LDKCResult_NoneLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_NoneLightningErrorZ handle_query_short_channel_ids_LDKRoutingMessageHandler_jcall(const void* this_arg, LDKPublicKey their_node_id, LDKQueryShortChannelIds msg) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) this_arg;
	int8_tArray their_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(their_node_id_arr->elems, their_node_id.compressed_form, 33);
	LDKQueryShortChannelIds msg_var = msg;
	uint32_t msg_ref = 0;
	CHECK((((uintptr_t)msg_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&msg_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_var);
	msg_ref = (uintptr_t)msg_var.inner;
	if (msg_var.is_owned) {
		msg_ref |= 1;
	}
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 74, (uint32_t)their_node_id_arr, (uint32_t)msg_ref);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneLightningErrorZ ret_conv = *(LDKCResult_NoneLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
static void LDKRoutingMessageHandler_JCalls_cloned(LDKRoutingMessageHandler* new_obj) {
	LDKRoutingMessageHandler_JCalls *j_calls = (LDKRoutingMessageHandler_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
	atomic_fetch_add_explicit(&j_calls->MessageSendEventsProvider->refcnt, 1, memory_order_release);
}
static inline LDKRoutingMessageHandler LDKRoutingMessageHandler_init (JSValue o, JSValue MessageSendEventsProvider) {
	LDKRoutingMessageHandler_JCalls *calls = MALLOC(sizeof(LDKRoutingMessageHandler_JCalls), "LDKRoutingMessageHandler_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKRoutingMessageHandler ret = {
		.this_arg = (void*) calls,
		.handle_node_announcement = handle_node_announcement_LDKRoutingMessageHandler_jcall,
		.handle_channel_announcement = handle_channel_announcement_LDKRoutingMessageHandler_jcall,
		.handle_channel_update = handle_channel_update_LDKRoutingMessageHandler_jcall,
		.get_next_channel_announcements = get_next_channel_announcements_LDKRoutingMessageHandler_jcall,
		.get_next_node_announcements = get_next_node_announcements_LDKRoutingMessageHandler_jcall,
		.peer_connected = peer_connected_LDKRoutingMessageHandler_jcall,
		.handle_reply_channel_range = handle_reply_channel_range_LDKRoutingMessageHandler_jcall,
		.handle_reply_short_channel_ids_end = handle_reply_short_channel_ids_end_LDKRoutingMessageHandler_jcall,
		.handle_query_channel_range = handle_query_channel_range_LDKRoutingMessageHandler_jcall,
		.handle_query_short_channel_ids = handle_query_short_channel_ids_LDKRoutingMessageHandler_jcall,
		.free = LDKRoutingMessageHandler_JCalls_free,
		.MessageSendEventsProvider = LDKMessageSendEventsProvider_init(MessageSendEventsProvider),
	};
	calls->MessageSendEventsProvider = ret.MessageSendEventsProvider.this_arg;
	return ret;
}
long  __attribute__((export_name("TS_LDKRoutingMessageHandler_new"))) TS_LDKRoutingMessageHandler_new(JSValue o, JSValue MessageSendEventsProvider) {
	LDKRoutingMessageHandler *res_ptr = MALLOC(sizeof(LDKRoutingMessageHandler), "LDKRoutingMessageHandler");
	*res_ptr = LDKRoutingMessageHandler_init(o, MessageSendEventsProvider);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_RoutingMessageHandler_handle_node_announcement"))) TS_RoutingMessageHandler_handle_node_announcement(uint32_t this_arg, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKNodeAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	LDKCResult_boolLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolLightningErrorZ), "LDKCResult_boolLightningErrorZ");
	*ret_conv = (this_arg_conv->handle_node_announcement)(this_arg_conv->this_arg, &msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_RoutingMessageHandler_handle_channel_announcement"))) TS_RoutingMessageHandler_handle_channel_announcement(uint32_t this_arg, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKChannelAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	LDKCResult_boolLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolLightningErrorZ), "LDKCResult_boolLightningErrorZ");
	*ret_conv = (this_arg_conv->handle_channel_announcement)(this_arg_conv->this_arg, &msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_RoutingMessageHandler_handle_channel_update"))) TS_RoutingMessageHandler_handle_channel_update(uint32_t this_arg, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKChannelUpdate msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	LDKCResult_boolLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolLightningErrorZ), "LDKCResult_boolLightningErrorZ");
	*ret_conv = (this_arg_conv->handle_channel_update)(this_arg_conv->this_arg, &msg_conv);
	return (uint32_t)ret_conv;
}

uint32_tArray  __attribute__((export_name("TS_RoutingMessageHandler_get_next_channel_announcements"))) TS_RoutingMessageHandler_get_next_channel_announcements(uint32_t this_arg, int64_t starting_point, int8_t batch_amount) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ ret_var = (this_arg_conv->get_next_channel_announcements)(this_arg_conv->this_arg, starting_point, batch_amount);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t h = 0; h < ret_var.datalen; h++) {
		LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* ret_conv_59_conv = MALLOC(sizeof(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ), "LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ");
		*ret_conv_59_conv = ret_var.data[h];
		ret_arr_ptr[h] = ((uint32_t)ret_conv_59_conv);
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_tArray  __attribute__((export_name("TS_RoutingMessageHandler_get_next_node_announcements"))) TS_RoutingMessageHandler_get_next_node_announcements(uint32_t this_arg, int8_tArray starting_point, int8_t batch_amount) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKPublicKey starting_point_ref;
	CHECK(starting_point->arr_len == 33);
	memcpy(starting_point_ref.compressed_form, starting_point->elems, 33); FREE(starting_point);
	LDKCVec_NodeAnnouncementZ ret_var = (this_arg_conv->get_next_node_announcements)(this_arg_conv->this_arg, starting_point_ref, batch_amount);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t s = 0; s < ret_var.datalen; s++) {
		LDKNodeAnnouncement ret_conv_18_var = ret_var.data[s];
		uint32_t ret_conv_18_ref = 0;
		CHECK((((uintptr_t)ret_conv_18_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_18_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_18_var);
		ret_conv_18_ref = (uintptr_t)ret_conv_18_var.inner;
		if (ret_conv_18_var.is_owned) {
			ret_conv_18_ref |= 1;
		}
		ret_arr_ptr[s] = ret_conv_18_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_RoutingMessageHandler_peer_connected"))) TS_RoutingMessageHandler_peer_connected(uint32_t this_arg, int8_tArray their_node_id, uint32_t init) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKInit init_conv;
	init_conv.inner = (void*)(init & (~1));
	init_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(init_conv);
	(this_arg_conv->peer_connected)(this_arg_conv->this_arg, their_node_id_ref, &init_conv);
}

uint32_t  __attribute__((export_name("TS_RoutingMessageHandler_handle_reply_channel_range"))) TS_RoutingMessageHandler_handle_reply_channel_range(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKReplyChannelRange msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ReplyChannelRange_clone(&msg_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = (this_arg_conv->handle_reply_channel_range)(this_arg_conv->this_arg, their_node_id_ref, msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_RoutingMessageHandler_handle_reply_short_channel_ids_end"))) TS_RoutingMessageHandler_handle_reply_short_channel_ids_end(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKReplyShortChannelIdsEnd msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ReplyShortChannelIdsEnd_clone(&msg_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = (this_arg_conv->handle_reply_short_channel_ids_end)(this_arg_conv->this_arg, their_node_id_ref, msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_RoutingMessageHandler_handle_query_channel_range"))) TS_RoutingMessageHandler_handle_query_channel_range(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKQueryChannelRange msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = QueryChannelRange_clone(&msg_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = (this_arg_conv->handle_query_channel_range)(this_arg_conv->this_arg, their_node_id_ref, msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_RoutingMessageHandler_handle_query_short_channel_ids"))) TS_RoutingMessageHandler_handle_query_short_channel_ids(uint32_t this_arg, int8_tArray their_node_id, uint32_t msg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRoutingMessageHandler* this_arg_conv = (LDKRoutingMessageHandler*)this_arg_ptr;
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	LDKQueryShortChannelIds msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = QueryShortChannelIds_clone(&msg_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = (this_arg_conv->handle_query_short_channel_ids)(this_arg_conv->this_arg, their_node_id_ref, msg_conv);
	return (uint32_t)ret_conv;
}

typedef struct LDKCustomMessageReader_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKCustomMessageReader_JCalls;
static void LDKCustomMessageReader_JCalls_free(void* this_arg) {
	LDKCustomMessageReader_JCalls *j_calls = (LDKCustomMessageReader_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCResult_COption_TypeZDecodeErrorZ read_LDKCustomMessageReader_jcall(const void* this_arg, uint16_t message_type, LDKu8slice buffer) {
	LDKCustomMessageReader_JCalls *j_calls = (LDKCustomMessageReader_JCalls*) this_arg;
	LDKu8slice buffer_var = buffer;
	int8_tArray buffer_arr = init_int8_tArray(buffer_var.datalen, __LINE__);
	memcpy(buffer_arr->elems, buffer_var.data, buffer_var.datalen);
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 75, (uint32_t)message_type, (uint32_t)buffer_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_COption_TypeZDecodeErrorZ ret_conv = *(LDKCResult_COption_TypeZDecodeErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
static void LDKCustomMessageReader_JCalls_cloned(LDKCustomMessageReader* new_obj) {
	LDKCustomMessageReader_JCalls *j_calls = (LDKCustomMessageReader_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKCustomMessageReader LDKCustomMessageReader_init (JSValue o) {
	LDKCustomMessageReader_JCalls *calls = MALLOC(sizeof(LDKCustomMessageReader_JCalls), "LDKCustomMessageReader_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKCustomMessageReader ret = {
		.this_arg = (void*) calls,
		.read = read_LDKCustomMessageReader_jcall,
		.free = LDKCustomMessageReader_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKCustomMessageReader_new"))) TS_LDKCustomMessageReader_new(JSValue o) {
	LDKCustomMessageReader *res_ptr = MALLOC(sizeof(LDKCustomMessageReader), "LDKCustomMessageReader");
	*res_ptr = LDKCustomMessageReader_init(o);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_CustomMessageReader_read"))) TS_CustomMessageReader_read(uint32_t this_arg, int16_t message_type, int8_tArray buffer) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKCustomMessageReader* this_arg_conv = (LDKCustomMessageReader*)this_arg_ptr;
	LDKu8slice buffer_ref;
	buffer_ref.datalen = buffer->arr_len;
	buffer_ref.data = buffer->elems /* XXX buffer leaks */;
	LDKCResult_COption_TypeZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_TypeZDecodeErrorZ), "LDKCResult_COption_TypeZDecodeErrorZ");
	*ret_conv = (this_arg_conv->read)(this_arg_conv->this_arg, message_type, buffer_ref);
	return (uint32_t)ret_conv;
}

typedef struct LDKCustomMessageHandler_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
	LDKCustomMessageReader_JCalls* CustomMessageReader;
} LDKCustomMessageHandler_JCalls;
static void LDKCustomMessageHandler_JCalls_free(void* this_arg) {
	LDKCustomMessageHandler_JCalls *j_calls = (LDKCustomMessageHandler_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCResult_NoneLightningErrorZ handle_custom_message_LDKCustomMessageHandler_jcall(const void* this_arg, LDKType msg, LDKPublicKey sender_node_id) {
	LDKCustomMessageHandler_JCalls *j_calls = (LDKCustomMessageHandler_JCalls*) this_arg;
	LDKType* msg_ret = MALLOC(sizeof(LDKType), "LDKType");
	*msg_ret = msg;
	int8_tArray sender_node_id_arr = init_int8_tArray(33, __LINE__);
	memcpy(sender_node_id_arr->elems, sender_node_id.compressed_form, 33);
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 76, (uint32_t)(uint32_t)msg_ret, (uint32_t)sender_node_id_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NoneLightningErrorZ ret_conv = *(LDKCResult_NoneLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCVec_C2Tuple_PublicKeyTypeZZ get_and_clear_pending_msg_LDKCustomMessageHandler_jcall(const void* this_arg) {
	LDKCustomMessageHandler_JCalls *j_calls = (LDKCustomMessageHandler_JCalls*) this_arg;
	uint32_tArray ret = (uint32_tArray)js_invoke_function_0(j_calls->instance_ptr, 77);
	LDKCVec_C2Tuple_PublicKeyTypeZZ ret_constr;
	ret_constr.datalen = ret->arr_len;
	if (ret_constr.datalen > 0)
		ret_constr.data = MALLOC(ret_constr.datalen * sizeof(LDKC2Tuple_PublicKeyTypeZ), "LDKCVec_C2Tuple_PublicKeyTypeZZ Elements");
	else
		ret_constr.data = NULL;
	uint32_t* ret_vals = ret->elems /* XXX ret leaks */;
	for (size_t z = 0; z < ret_constr.datalen; z++) {
		uint32_t ret_conv_25 = ret_vals[z];
		void* ret_conv_25_ptr = (void*)(((uintptr_t)ret_conv_25) & ~1);
		CHECK_ACCESS(ret_conv_25_ptr);
		LDKC2Tuple_PublicKeyTypeZ ret_conv_25_conv = *(LDKC2Tuple_PublicKeyTypeZ*)(ret_conv_25_ptr);
		FREE((void*)ret_conv_25);
		ret_constr.data[z] = ret_conv_25_conv;
	}
	return ret_constr;
}
static void LDKCustomMessageHandler_JCalls_cloned(LDKCustomMessageHandler* new_obj) {
	LDKCustomMessageHandler_JCalls *j_calls = (LDKCustomMessageHandler_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
	atomic_fetch_add_explicit(&j_calls->CustomMessageReader->refcnt, 1, memory_order_release);
}
static inline LDKCustomMessageHandler LDKCustomMessageHandler_init (JSValue o, JSValue CustomMessageReader) {
	LDKCustomMessageHandler_JCalls *calls = MALLOC(sizeof(LDKCustomMessageHandler_JCalls), "LDKCustomMessageHandler_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKCustomMessageHandler ret = {
		.this_arg = (void*) calls,
		.handle_custom_message = handle_custom_message_LDKCustomMessageHandler_jcall,
		.get_and_clear_pending_msg = get_and_clear_pending_msg_LDKCustomMessageHandler_jcall,
		.free = LDKCustomMessageHandler_JCalls_free,
		.CustomMessageReader = LDKCustomMessageReader_init(CustomMessageReader),
	};
	calls->CustomMessageReader = ret.CustomMessageReader.this_arg;
	return ret;
}
long  __attribute__((export_name("TS_LDKCustomMessageHandler_new"))) TS_LDKCustomMessageHandler_new(JSValue o, JSValue CustomMessageReader) {
	LDKCustomMessageHandler *res_ptr = MALLOC(sizeof(LDKCustomMessageHandler), "LDKCustomMessageHandler");
	*res_ptr = LDKCustomMessageHandler_init(o, CustomMessageReader);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_CustomMessageHandler_handle_custom_message"))) TS_CustomMessageHandler_handle_custom_message(uint32_t this_arg, uint32_t msg, int8_tArray sender_node_id) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKCustomMessageHandler* this_arg_conv = (LDKCustomMessageHandler*)this_arg_ptr;
	void* msg_ptr = (void*)(((uintptr_t)msg) & ~1);
	CHECK_ACCESS(msg_ptr);
	LDKType msg_conv = *(LDKType*)(msg_ptr);
	if (msg_conv.free == LDKType_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKType_JCalls_cloned(&msg_conv);
	}
	LDKPublicKey sender_node_id_ref;
	CHECK(sender_node_id->arr_len == 33);
	memcpy(sender_node_id_ref.compressed_form, sender_node_id->elems, 33); FREE(sender_node_id);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = (this_arg_conv->handle_custom_message)(this_arg_conv->this_arg, msg_conv, sender_node_id_ref);
	return (uint32_t)ret_conv;
}

uint32_tArray  __attribute__((export_name("TS_CustomMessageHandler_get_and_clear_pending_msg"))) TS_CustomMessageHandler_get_and_clear_pending_msg(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKCustomMessageHandler* this_arg_conv = (LDKCustomMessageHandler*)this_arg_ptr;
	LDKCVec_C2Tuple_PublicKeyTypeZZ ret_var = (this_arg_conv->get_and_clear_pending_msg)(this_arg_conv->this_arg);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t z = 0; z < ret_var.datalen; z++) {
		LDKC2Tuple_PublicKeyTypeZ* ret_conv_25_conv = MALLOC(sizeof(LDKC2Tuple_PublicKeyTypeZ), "LDKC2Tuple_PublicKeyTypeZ");
		*ret_conv_25_conv = ret_var.data[z];
		ret_arr_ptr[z] = ((uint32_t)ret_conv_25_conv);
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

typedef struct LDKSocketDescriptor_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKSocketDescriptor_JCalls;
static void LDKSocketDescriptor_JCalls_free(void* this_arg) {
	LDKSocketDescriptor_JCalls *j_calls = (LDKSocketDescriptor_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
uintptr_t send_data_LDKSocketDescriptor_jcall(void* this_arg, LDKu8slice data, bool resume_read) {
	LDKSocketDescriptor_JCalls *j_calls = (LDKSocketDescriptor_JCalls*) this_arg;
	LDKu8slice data_var = data;
	int8_tArray data_arr = init_int8_tArray(data_var.datalen, __LINE__);
	memcpy(data_arr->elems, data_var.data, data_var.datalen);
	return js_invoke_function_2(j_calls->instance_ptr, 78, (uint32_t)data_arr, (uint32_t)resume_read);
}
void disconnect_socket_LDKSocketDescriptor_jcall(void* this_arg) {
	LDKSocketDescriptor_JCalls *j_calls = (LDKSocketDescriptor_JCalls*) this_arg;
	js_invoke_function_0(j_calls->instance_ptr, 79);
}
bool eq_LDKSocketDescriptor_jcall(const void* this_arg, const LDKSocketDescriptor * other_arg) {
	LDKSocketDescriptor_JCalls *j_calls = (LDKSocketDescriptor_JCalls*) this_arg;
	LDKSocketDescriptor *other_arg_clone = MALLOC(sizeof(LDKSocketDescriptor), "LDKSocketDescriptor");
	*other_arg_clone = SocketDescriptor_clone(other_arg);
	return js_invoke_function_1(j_calls->instance_ptr, 80, (uint32_t)(uint32_t)other_arg_clone);
}
uint64_t hash_LDKSocketDescriptor_jcall(const void* this_arg) {
	LDKSocketDescriptor_JCalls *j_calls = (LDKSocketDescriptor_JCalls*) this_arg;
	return js_invoke_function_0(j_calls->instance_ptr, 81);
}
static void LDKSocketDescriptor_JCalls_cloned(LDKSocketDescriptor* new_obj) {
	LDKSocketDescriptor_JCalls *j_calls = (LDKSocketDescriptor_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKSocketDescriptor LDKSocketDescriptor_init (JSValue o) {
	LDKSocketDescriptor_JCalls *calls = MALLOC(sizeof(LDKSocketDescriptor_JCalls), "LDKSocketDescriptor_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKSocketDescriptor ret = {
		.this_arg = (void*) calls,
		.send_data = send_data_LDKSocketDescriptor_jcall,
		.disconnect_socket = disconnect_socket_LDKSocketDescriptor_jcall,
		.eq = eq_LDKSocketDescriptor_jcall,
		.hash = hash_LDKSocketDescriptor_jcall,
		.cloned = LDKSocketDescriptor_JCalls_cloned,
		.free = LDKSocketDescriptor_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKSocketDescriptor_new"))) TS_LDKSocketDescriptor_new(JSValue o) {
	LDKSocketDescriptor *res_ptr = MALLOC(sizeof(LDKSocketDescriptor), "LDKSocketDescriptor");
	*res_ptr = LDKSocketDescriptor_init(o);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_SocketDescriptor_send_data"))) TS_SocketDescriptor_send_data(uint32_t this_arg, int8_tArray data, jboolean resume_read) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKSocketDescriptor* this_arg_conv = (LDKSocketDescriptor*)this_arg_ptr;
	LDKu8slice data_ref;
	data_ref.datalen = data->arr_len;
	data_ref.data = data->elems /* XXX data leaks */;
	uint32_t ret_val = (this_arg_conv->send_data)(this_arg_conv->this_arg, data_ref, resume_read);
	return ret_val;
}

void  __attribute__((export_name("TS_SocketDescriptor_disconnect_socket"))) TS_SocketDescriptor_disconnect_socket(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKSocketDescriptor* this_arg_conv = (LDKSocketDescriptor*)this_arg_ptr;
	(this_arg_conv->disconnect_socket)(this_arg_conv->this_arg);
}

int64_t  __attribute__((export_name("TS_SocketDescriptor_hash"))) TS_SocketDescriptor_hash(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKSocketDescriptor* this_arg_conv = (LDKSocketDescriptor*)this_arg_ptr;
	int64_t ret_val = (this_arg_conv->hash)(this_arg_conv->this_arg);
	return ret_val;
}

uint32_t __attribute__((export_name("TS_LDKEffectiveCapacity_ty_from_ptr"))) TS_LDKEffectiveCapacity_ty_from_ptr(uint32_t ptr) {
	LDKEffectiveCapacity *obj = (LDKEffectiveCapacity*)(ptr & ~1);
	switch(obj->tag) {
		case LDKEffectiveCapacity_ExactLiquidity: return 0;
		case LDKEffectiveCapacity_MaximumHTLC: return 1;
		case LDKEffectiveCapacity_Total: return 2;
		case LDKEffectiveCapacity_Infinite: return 3;
		case LDKEffectiveCapacity_Unknown: return 4;
		default: abort();
	}
}
int64_t __attribute__((export_name("TS_LDKEffectiveCapacity_ExactLiquidity_get_liquidity_msat"))) TS_LDKEffectiveCapacity_ExactLiquidity_get_liquidity_msat(uint32_t ptr) {
	LDKEffectiveCapacity *obj = (LDKEffectiveCapacity*)(ptr & ~1);
	assert(obj->tag == LDKEffectiveCapacity_ExactLiquidity);
	return obj->exact_liquidity.liquidity_msat;
}
int64_t __attribute__((export_name("TS_LDKEffectiveCapacity_MaximumHTLC_get_amount_msat"))) TS_LDKEffectiveCapacity_MaximumHTLC_get_amount_msat(uint32_t ptr) {
	LDKEffectiveCapacity *obj = (LDKEffectiveCapacity*)(ptr & ~1);
	assert(obj->tag == LDKEffectiveCapacity_MaximumHTLC);
	return obj->maximum_htlc.amount_msat;
}
int64_t __attribute__((export_name("TS_LDKEffectiveCapacity_Total_get_capacity_msat"))) TS_LDKEffectiveCapacity_Total_get_capacity_msat(uint32_t ptr) {
	LDKEffectiveCapacity *obj = (LDKEffectiveCapacity*)(ptr & ~1);
	assert(obj->tag == LDKEffectiveCapacity_Total);
	return obj->total.capacity_msat;
}
typedef struct LDKScore_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKScore_JCalls;
static void LDKScore_JCalls_free(void* this_arg) {
	LDKScore_JCalls *j_calls = (LDKScore_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
uint64_t channel_penalty_msat_LDKScore_jcall(const void* this_arg, uint64_t short_channel_id, uint64_t send_amt_msat, uint64_t capacity_msat, const LDKNodeId * source, const LDKNodeId * target) {
	LDKScore_JCalls *j_calls = (LDKScore_JCalls*) this_arg;
	LDKNodeId source_var = *source;
	uint32_t source_ref = 0;
	source_var = NodeId_clone(&source_var);
	CHECK((((uintptr_t)source_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&source_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(source_var);
	source_ref = (uintptr_t)source_var.inner;
	if (source_var.is_owned) {
		source_ref |= 1;
	}
	LDKNodeId target_var = *target;
	uint32_t target_ref = 0;
	target_var = NodeId_clone(&target_var);
	CHECK((((uintptr_t)target_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&target_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(target_var);
	target_ref = (uintptr_t)target_var.inner;
	if (target_var.is_owned) {
		target_ref |= 1;
	}
	return js_invoke_function_5(j_calls->instance_ptr, 82, (uint32_t)short_channel_id, (uint32_t)send_amt_msat, (uint32_t)capacity_msat, (uint32_t)source_ref, (uint32_t)target_ref);
}
void payment_path_failed_LDKScore_jcall(void* this_arg, LDKCVec_RouteHopZ path, uint64_t short_channel_id) {
	LDKScore_JCalls *j_calls = (LDKScore_JCalls*) this_arg;
	LDKCVec_RouteHopZ path_var = path;
	uint32_tArray path_arr = NULL;
	path_arr = init_uint32_tArray(path_var.datalen, __LINE__);
	uint32_t *path_arr_ptr = (uint32_t*)(((uint8_t*)path_arr) + 4);
	for (size_t k = 0; k < path_var.datalen; k++) {
		LDKRouteHop path_conv_10_var = path_var.data[k];
		uint32_t path_conv_10_ref = 0;
		CHECK((((uintptr_t)path_conv_10_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&path_conv_10_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(path_conv_10_var);
		path_conv_10_ref = (uintptr_t)path_conv_10_var.inner;
		if (path_conv_10_var.is_owned) {
			path_conv_10_ref |= 1;
		}
		path_arr_ptr[k] = path_conv_10_ref;
	}
	
	FREE(path_var.data);
	js_invoke_function_2(j_calls->instance_ptr, 83, (uint32_t)path_arr, (uint32_t)short_channel_id);
}
void payment_path_successful_LDKScore_jcall(void* this_arg, LDKCVec_RouteHopZ path) {
	LDKScore_JCalls *j_calls = (LDKScore_JCalls*) this_arg;
	LDKCVec_RouteHopZ path_var = path;
	uint32_tArray path_arr = NULL;
	path_arr = init_uint32_tArray(path_var.datalen, __LINE__);
	uint32_t *path_arr_ptr = (uint32_t*)(((uint8_t*)path_arr) + 4);
	for (size_t k = 0; k < path_var.datalen; k++) {
		LDKRouteHop path_conv_10_var = path_var.data[k];
		uint32_t path_conv_10_ref = 0;
		CHECK((((uintptr_t)path_conv_10_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&path_conv_10_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(path_conv_10_var);
		path_conv_10_ref = (uintptr_t)path_conv_10_var.inner;
		if (path_conv_10_var.is_owned) {
			path_conv_10_ref |= 1;
		}
		path_arr_ptr[k] = path_conv_10_ref;
	}
	
	FREE(path_var.data);
	js_invoke_function_1(j_calls->instance_ptr, 84, (uint32_t)path_arr);
}
LDKCVec_u8Z write_LDKScore_jcall(const void* this_arg) {
	LDKScore_JCalls *j_calls = (LDKScore_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_0(j_calls->instance_ptr, 85);
	LDKCVec_u8Z ret_ref;
	ret_ref.datalen = ret->arr_len;
	ret_ref.data = MALLOC(ret_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(ret_ref.data, ret->elems, ret_ref.datalen); FREE(ret);
	return ret_ref;
}
static void LDKScore_JCalls_cloned(LDKScore* new_obj) {
	LDKScore_JCalls *j_calls = (LDKScore_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKScore LDKScore_init (JSValue o) {
	LDKScore_JCalls *calls = MALLOC(sizeof(LDKScore_JCalls), "LDKScore_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKScore ret = {
		.this_arg = (void*) calls,
		.channel_penalty_msat = channel_penalty_msat_LDKScore_jcall,
		.payment_path_failed = payment_path_failed_LDKScore_jcall,
		.payment_path_successful = payment_path_successful_LDKScore_jcall,
		.write = write_LDKScore_jcall,
		.free = LDKScore_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKScore_new"))) TS_LDKScore_new(JSValue o) {
	LDKScore *res_ptr = MALLOC(sizeof(LDKScore), "LDKScore");
	*res_ptr = LDKScore_init(o);
	return (long)res_ptr;
}
int64_t  __attribute__((export_name("TS_Score_channel_penalty_msat"))) TS_Score_channel_penalty_msat(uint32_t this_arg, int64_t short_channel_id, int64_t send_amt_msat, int64_t capacity_msat, uint32_t source, uint32_t target) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKScore* this_arg_conv = (LDKScore*)this_arg_ptr;
	LDKNodeId source_conv;
	source_conv.inner = (void*)(source & (~1));
	source_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(source_conv);
	LDKNodeId target_conv;
	target_conv.inner = (void*)(target & (~1));
	target_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(target_conv);
	int64_t ret_val = (this_arg_conv->channel_penalty_msat)(this_arg_conv->this_arg, short_channel_id, send_amt_msat, capacity_msat, &source_conv, &target_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Score_payment_path_failed"))) TS_Score_payment_path_failed(uint32_t this_arg, uint32_tArray path, int64_t short_channel_id) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKScore* this_arg_conv = (LDKScore*)this_arg_ptr;
	LDKCVec_RouteHopZ path_constr;
	path_constr.datalen = path->arr_len;
	if (path_constr.datalen > 0)
		path_constr.data = MALLOC(path_constr.datalen * sizeof(LDKRouteHop), "LDKCVec_RouteHopZ Elements");
	else
		path_constr.data = NULL;
	uint32_t* path_vals = path->elems /* XXX path leaks */;
	for (size_t k = 0; k < path_constr.datalen; k++) {
		uint32_t path_conv_10 = path_vals[k];
		LDKRouteHop path_conv_10_conv;
		path_conv_10_conv.inner = (void*)(path_conv_10 & (~1));
		path_conv_10_conv.is_owned = (path_conv_10 & 1) || (path_conv_10 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(path_conv_10_conv);
		path_conv_10_conv = RouteHop_clone(&path_conv_10_conv);
		path_constr.data[k] = path_conv_10_conv;
	}
	(this_arg_conv->payment_path_failed)(this_arg_conv->this_arg, path_constr, short_channel_id);
}

void  __attribute__((export_name("TS_Score_payment_path_successful"))) TS_Score_payment_path_successful(uint32_t this_arg, uint32_tArray path) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKScore* this_arg_conv = (LDKScore*)this_arg_ptr;
	LDKCVec_RouteHopZ path_constr;
	path_constr.datalen = path->arr_len;
	if (path_constr.datalen > 0)
		path_constr.data = MALLOC(path_constr.datalen * sizeof(LDKRouteHop), "LDKCVec_RouteHopZ Elements");
	else
		path_constr.data = NULL;
	uint32_t* path_vals = path->elems /* XXX path leaks */;
	for (size_t k = 0; k < path_constr.datalen; k++) {
		uint32_t path_conv_10 = path_vals[k];
		LDKRouteHop path_conv_10_conv;
		path_conv_10_conv.inner = (void*)(path_conv_10 & (~1));
		path_conv_10_conv.is_owned = (path_conv_10 & 1) || (path_conv_10 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(path_conv_10_conv);
		path_conv_10_conv = RouteHop_clone(&path_conv_10_conv);
		path_constr.data[k] = path_conv_10_conv;
	}
	(this_arg_conv->payment_path_successful)(this_arg_conv->this_arg, path_constr);
}

int8_tArray  __attribute__((export_name("TS_Score_write"))) TS_Score_write(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKScore* this_arg_conv = (LDKScore*)this_arg_ptr;
	LDKCVec_u8Z ret_var = (this_arg_conv->write)(this_arg_conv->this_arg);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

typedef struct LDKLockableScore_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKLockableScore_JCalls;
static void LDKLockableScore_JCalls_free(void* this_arg) {
	LDKLockableScore_JCalls *j_calls = (LDKLockableScore_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKScore lock_LDKLockableScore_jcall(const void* this_arg) {
	LDKLockableScore_JCalls *j_calls = (LDKLockableScore_JCalls*) this_arg;
	uint32_t ret = js_invoke_function_0(j_calls->instance_ptr, 86);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKScore ret_conv = *(LDKScore*)(ret_ptr);
	if (ret_conv.free == LDKScore_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKScore_JCalls_cloned(&ret_conv);
	}// WARNING: we may need a move here but no clone is available for LDKScore
	
	return ret_conv;
}
static void LDKLockableScore_JCalls_cloned(LDKLockableScore* new_obj) {
	LDKLockableScore_JCalls *j_calls = (LDKLockableScore_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKLockableScore LDKLockableScore_init (JSValue o) {
	LDKLockableScore_JCalls *calls = MALLOC(sizeof(LDKLockableScore_JCalls), "LDKLockableScore_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKLockableScore ret = {
		.this_arg = (void*) calls,
		.lock = lock_LDKLockableScore_jcall,
		.free = LDKLockableScore_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKLockableScore_new"))) TS_LDKLockableScore_new(JSValue o) {
	LDKLockableScore *res_ptr = MALLOC(sizeof(LDKLockableScore), "LDKLockableScore");
	*res_ptr = LDKLockableScore_init(o);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_LockableScore_lock"))) TS_LockableScore_lock(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKLockableScore* this_arg_conv = (LDKLockableScore*)this_arg_ptr;
	LDKScore* ret_ret = MALLOC(sizeof(LDKScore), "LDKScore");
	*ret_ret = (this_arg_conv->lock)(this_arg_conv->this_arg);
	return (uint32_t)ret_ret;
}

uint32_t __attribute__((export_name("TS_LDKFallback_ty_from_ptr"))) TS_LDKFallback_ty_from_ptr(uint32_t ptr) {
	LDKFallback *obj = (LDKFallback*)(ptr & ~1);
	switch(obj->tag) {
		case LDKFallback_SegWitProgram: return 0;
		case LDKFallback_PubKeyHash: return 1;
		case LDKFallback_ScriptHash: return 2;
		default: abort();
	}
}
int8_t __attribute__((export_name("TS_LDKFallback_SegWitProgram_get_version"))) TS_LDKFallback_SegWitProgram_get_version(uint32_t ptr) {
	LDKFallback *obj = (LDKFallback*)(ptr & ~1);
	assert(obj->tag == LDKFallback_SegWitProgram);
			uint8_t version_val = obj->seg_wit_program.version._0;
	return version_val;
}
int8_tArray __attribute__((export_name("TS_LDKFallback_SegWitProgram_get_program"))) TS_LDKFallback_SegWitProgram_get_program(uint32_t ptr) {
	LDKFallback *obj = (LDKFallback*)(ptr & ~1);
	assert(obj->tag == LDKFallback_SegWitProgram);
			LDKCVec_u8Z program_var = obj->seg_wit_program.program;
			int8_tArray program_arr = init_int8_tArray(program_var.datalen, __LINE__);
			memcpy(program_arr->elems, program_var.data, program_var.datalen);
	return program_arr;
}
int8_tArray __attribute__((export_name("TS_LDKFallback_PubKeyHash_get_pub_key_hash"))) TS_LDKFallback_PubKeyHash_get_pub_key_hash(uint32_t ptr) {
	LDKFallback *obj = (LDKFallback*)(ptr & ~1);
	assert(obj->tag == LDKFallback_PubKeyHash);
			int8_tArray pub_key_hash_arr = init_int8_tArray(20, __LINE__);
			memcpy(pub_key_hash_arr->elems, obj->pub_key_hash.data, 20);
	return pub_key_hash_arr;
}
int8_tArray __attribute__((export_name("TS_LDKFallback_ScriptHash_get_script_hash"))) TS_LDKFallback_ScriptHash_get_script_hash(uint32_t ptr) {
	LDKFallback *obj = (LDKFallback*)(ptr & ~1);
	assert(obj->tag == LDKFallback_ScriptHash);
			int8_tArray script_hash_arr = init_int8_tArray(20, __LINE__);
			memcpy(script_hash_arr->elems, obj->script_hash.data, 20);
	return script_hash_arr;
}
typedef struct LDKPayer_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKPayer_JCalls;
static void LDKPayer_JCalls_free(void* this_arg) {
	LDKPayer_JCalls *j_calls = (LDKPayer_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKPublicKey node_id_LDKPayer_jcall(const void* this_arg) {
	LDKPayer_JCalls *j_calls = (LDKPayer_JCalls*) this_arg;
	int8_tArray ret = (int8_tArray)js_invoke_function_0(j_calls->instance_ptr, 87);
	LDKPublicKey ret_ref;
	CHECK(ret->arr_len == 33);
	memcpy(ret_ref.compressed_form, ret->elems, 33); FREE(ret);
	return ret_ref;
}
LDKCVec_ChannelDetailsZ first_hops_LDKPayer_jcall(const void* this_arg) {
	LDKPayer_JCalls *j_calls = (LDKPayer_JCalls*) this_arg;
	uint32_tArray ret = (uint32_tArray)js_invoke_function_0(j_calls->instance_ptr, 88);
	LDKCVec_ChannelDetailsZ ret_constr;
	ret_constr.datalen = ret->arr_len;
	if (ret_constr.datalen > 0)
		ret_constr.data = MALLOC(ret_constr.datalen * sizeof(LDKChannelDetails), "LDKCVec_ChannelDetailsZ Elements");
	else
		ret_constr.data = NULL;
	uint32_t* ret_vals = ret->elems /* XXX ret leaks */;
	for (size_t q = 0; q < ret_constr.datalen; q++) {
		uint32_t ret_conv_16 = ret_vals[q];
		LDKChannelDetails ret_conv_16_conv;
		ret_conv_16_conv.inner = (void*)(ret_conv_16 & (~1));
		ret_conv_16_conv.is_owned = (ret_conv_16 & 1) || (ret_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_16_conv);
		ret_constr.data[q] = ret_conv_16_conv;
	}
	return ret_constr;
}
LDKCResult_PaymentIdPaymentSendFailureZ send_payment_LDKPayer_jcall(const void* this_arg, const LDKRoute * route, LDKThirtyTwoBytes payment_hash, LDKThirtyTwoBytes payment_secret) {
	LDKPayer_JCalls *j_calls = (LDKPayer_JCalls*) this_arg;
	LDKRoute route_var = *route;
	uint32_t route_ref = 0;
	route_var = Route_clone(&route_var);
	CHECK((((uintptr_t)route_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&route_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_var);
	route_ref = (uintptr_t)route_var.inner;
	if (route_var.is_owned) {
		route_ref |= 1;
	}
	int8_tArray payment_hash_arr = init_int8_tArray(32, __LINE__);
	memcpy(payment_hash_arr->elems, payment_hash.data, 32);
	int8_tArray payment_secret_arr = init_int8_tArray(32, __LINE__);
	memcpy(payment_secret_arr->elems, payment_secret.data, 32);
	uint32_t ret = js_invoke_function_3(j_calls->instance_ptr, 89, (uint32_t)route_ref, (uint32_t)payment_hash_arr, (uint32_t)payment_secret_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_PaymentIdPaymentSendFailureZ ret_conv = *(LDKCResult_PaymentIdPaymentSendFailureZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_PaymentIdPaymentSendFailureZ send_spontaneous_payment_LDKPayer_jcall(const void* this_arg, const LDKRoute * route, LDKThirtyTwoBytes payment_preimage) {
	LDKPayer_JCalls *j_calls = (LDKPayer_JCalls*) this_arg;
	LDKRoute route_var = *route;
	uint32_t route_ref = 0;
	route_var = Route_clone(&route_var);
	CHECK((((uintptr_t)route_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&route_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_var);
	route_ref = (uintptr_t)route_var.inner;
	if (route_var.is_owned) {
		route_ref |= 1;
	}
	int8_tArray payment_preimage_arr = init_int8_tArray(32, __LINE__);
	memcpy(payment_preimage_arr->elems, payment_preimage.data, 32);
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 90, (uint32_t)route_ref, (uint32_t)payment_preimage_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_PaymentIdPaymentSendFailureZ ret_conv = *(LDKCResult_PaymentIdPaymentSendFailureZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
LDKCResult_NonePaymentSendFailureZ retry_payment_LDKPayer_jcall(const void* this_arg, const LDKRoute * route, LDKThirtyTwoBytes payment_id) {
	LDKPayer_JCalls *j_calls = (LDKPayer_JCalls*) this_arg;
	LDKRoute route_var = *route;
	uint32_t route_ref = 0;
	route_var = Route_clone(&route_var);
	CHECK((((uintptr_t)route_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&route_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_var);
	route_ref = (uintptr_t)route_var.inner;
	if (route_var.is_owned) {
		route_ref |= 1;
	}
	int8_tArray payment_id_arr = init_int8_tArray(32, __LINE__);
	memcpy(payment_id_arr->elems, payment_id.data, 32);
	uint32_t ret = js_invoke_function_2(j_calls->instance_ptr, 91, (uint32_t)route_ref, (uint32_t)payment_id_arr);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_NonePaymentSendFailureZ ret_conv = *(LDKCResult_NonePaymentSendFailureZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
void abandon_payment_LDKPayer_jcall(const void* this_arg, LDKThirtyTwoBytes payment_id) {
	LDKPayer_JCalls *j_calls = (LDKPayer_JCalls*) this_arg;
	int8_tArray payment_id_arr = init_int8_tArray(32, __LINE__);
	memcpy(payment_id_arr->elems, payment_id.data, 32);
	js_invoke_function_1(j_calls->instance_ptr, 92, (uint32_t)payment_id_arr);
}
static void LDKPayer_JCalls_cloned(LDKPayer* new_obj) {
	LDKPayer_JCalls *j_calls = (LDKPayer_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKPayer LDKPayer_init (JSValue o) {
	LDKPayer_JCalls *calls = MALLOC(sizeof(LDKPayer_JCalls), "LDKPayer_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKPayer ret = {
		.this_arg = (void*) calls,
		.node_id = node_id_LDKPayer_jcall,
		.first_hops = first_hops_LDKPayer_jcall,
		.send_payment = send_payment_LDKPayer_jcall,
		.send_spontaneous_payment = send_spontaneous_payment_LDKPayer_jcall,
		.retry_payment = retry_payment_LDKPayer_jcall,
		.abandon_payment = abandon_payment_LDKPayer_jcall,
		.free = LDKPayer_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKPayer_new"))) TS_LDKPayer_new(JSValue o) {
	LDKPayer *res_ptr = MALLOC(sizeof(LDKPayer), "LDKPayer");
	*res_ptr = LDKPayer_init(o);
	return (long)res_ptr;
}
int8_tArray  __attribute__((export_name("TS_Payer_node_id"))) TS_Payer_node_id(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKPayer* this_arg_conv = (LDKPayer*)this_arg_ptr;
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, (this_arg_conv->node_id)(this_arg_conv->this_arg).compressed_form, 33);
	return ret_arr;
}

uint32_tArray  __attribute__((export_name("TS_Payer_first_hops"))) TS_Payer_first_hops(uint32_t this_arg) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKPayer* this_arg_conv = (LDKPayer*)this_arg_ptr;
	LDKCVec_ChannelDetailsZ ret_var = (this_arg_conv->first_hops)(this_arg_conv->this_arg);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t q = 0; q < ret_var.datalen; q++) {
		LDKChannelDetails ret_conv_16_var = ret_var.data[q];
		uint32_t ret_conv_16_ref = 0;
		CHECK((((uintptr_t)ret_conv_16_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_16_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_16_var);
		ret_conv_16_ref = (uintptr_t)ret_conv_16_var.inner;
		if (ret_conv_16_var.is_owned) {
			ret_conv_16_ref |= 1;
		}
		ret_arr_ptr[q] = ret_conv_16_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Payer_send_payment"))) TS_Payer_send_payment(uint32_t this_arg, uint32_t route, int8_tArray payment_hash, int8_tArray payment_secret) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKPayer* this_arg_conv = (LDKPayer*)this_arg_ptr;
	LDKRoute route_conv;
	route_conv.inner = (void*)(route & (~1));
	route_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_conv);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	LDKThirtyTwoBytes payment_secret_ref;
	CHECK(payment_secret->arr_len == 32);
	memcpy(payment_secret_ref.data, payment_secret->elems, 32); FREE(payment_secret);
	LDKCResult_PaymentIdPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentSendFailureZ), "LDKCResult_PaymentIdPaymentSendFailureZ");
	*ret_conv = (this_arg_conv->send_payment)(this_arg_conv->this_arg, &route_conv, payment_hash_ref, payment_secret_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_Payer_send_spontaneous_payment"))) TS_Payer_send_spontaneous_payment(uint32_t this_arg, uint32_t route, int8_tArray payment_preimage) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKPayer* this_arg_conv = (LDKPayer*)this_arg_ptr;
	LDKRoute route_conv;
	route_conv.inner = (void*)(route & (~1));
	route_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_conv);
	LDKThirtyTwoBytes payment_preimage_ref;
	CHECK(payment_preimage->arr_len == 32);
	memcpy(payment_preimage_ref.data, payment_preimage->elems, 32); FREE(payment_preimage);
	LDKCResult_PaymentIdPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentSendFailureZ), "LDKCResult_PaymentIdPaymentSendFailureZ");
	*ret_conv = (this_arg_conv->send_spontaneous_payment)(this_arg_conv->this_arg, &route_conv, payment_preimage_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_Payer_retry_payment"))) TS_Payer_retry_payment(uint32_t this_arg, uint32_t route, int8_tArray payment_id) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKPayer* this_arg_conv = (LDKPayer*)this_arg_ptr;
	LDKRoute route_conv;
	route_conv.inner = (void*)(route & (~1));
	route_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_conv);
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	LDKCResult_NonePaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePaymentSendFailureZ), "LDKCResult_NonePaymentSendFailureZ");
	*ret_conv = (this_arg_conv->retry_payment)(this_arg_conv->this_arg, &route_conv, payment_id_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_Payer_abandon_payment"))) TS_Payer_abandon_payment(uint32_t this_arg, int8_tArray payment_id) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKPayer* this_arg_conv = (LDKPayer*)this_arg_ptr;
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	(this_arg_conv->abandon_payment)(this_arg_conv->this_arg, payment_id_ref);
}

typedef struct LDKRouter_JCalls {
	atomic_size_t refcnt;
	uint32_t instance_ptr;
} LDKRouter_JCalls;
static void LDKRouter_JCalls_free(void* this_arg) {
	LDKRouter_JCalls *j_calls = (LDKRouter_JCalls*) this_arg;
	if (atomic_fetch_sub_explicit(&j_calls->refcnt, 1, memory_order_acquire) == 1) {
		FREE(j_calls);
	}
}
LDKCResult_RouteLightningErrorZ find_route_LDKRouter_jcall(const void* this_arg, LDKPublicKey payer, const LDKRouteParameters * route_params, const uint8_t (* payment_hash)[32], LDKCVec_ChannelDetailsZ * first_hops, const LDKScore * scorer) {
	LDKRouter_JCalls *j_calls = (LDKRouter_JCalls*) this_arg;
	int8_tArray payer_arr = init_int8_tArray(33, __LINE__);
	memcpy(payer_arr->elems, payer.compressed_form, 33);
	LDKRouteParameters route_params_var = *route_params;
	uint32_t route_params_ref = 0;
	route_params_var = RouteParameters_clone(&route_params_var);
	CHECK((((uintptr_t)route_params_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&route_params_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_params_var);
	route_params_ref = (uintptr_t)route_params_var.inner;
	if (route_params_var.is_owned) {
		route_params_ref |= 1;
	}
	int8_tArray payment_hash_arr = init_int8_tArray(32, __LINE__);
	memcpy(payment_hash_arr->elems, *payment_hash, 32);
	LDKCVec_ChannelDetailsZ *first_hops_var_ptr = first_hops;
	uint32_tArray first_hops_arr = NULL;
	if (first_hops != NULL) {
		LDKCVec_ChannelDetailsZ first_hops_var = *first_hops_var_ptr;
		first_hops_arr = init_uint32_tArray(first_hops_var.datalen, __LINE__);
		uint32_t *first_hops_arr_ptr = (uint32_t*)(((uint8_t*)first_hops_arr) + 4);
		for (size_t q = 0; q < first_hops_var.datalen; q++) {
			LDKChannelDetails first_hops_conv_16_var = 	first_hops_var.data[q];
			uint32_t first_hops_conv_16_ref = 0;
			CHECK((((uintptr_t)first_hops_conv_16_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&first_hops_conv_16_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(first_hops_conv_16_var);
			first_hops_conv_16_ref = (uintptr_t)first_hops_conv_16_var.inner;
			if (first_hops_conv_16_var.is_owned) {
				first_hops_conv_16_ref |= 1;
			}
			first_hops_arr_ptr[q] = first_hops_conv_16_ref;
		}
	
	}
	// WARNING: This object doesn't live past this scope, needs clone!
	uint32_t ret_scorer = ((uintptr_t)scorer) | 1;
	uint32_t ret = js_invoke_function_5(j_calls->instance_ptr, 93, (uint32_t)payer_arr, (uint32_t)route_params_ref, (uint32_t)payment_hash_arr, (uint32_t)first_hops_arr, (uint32_t)ret_scorer);
	void* ret_ptr = (void*)(((uintptr_t)ret) & ~1);
	CHECK_ACCESS(ret_ptr);
	LDKCResult_RouteLightningErrorZ ret_conv = *(LDKCResult_RouteLightningErrorZ*)(ret_ptr);
	FREE((void*)ret);
	return ret_conv;
}
static void LDKRouter_JCalls_cloned(LDKRouter* new_obj) {
	LDKRouter_JCalls *j_calls = (LDKRouter_JCalls*) new_obj->this_arg;
	atomic_fetch_add_explicit(&j_calls->refcnt, 1, memory_order_release);
}
static inline LDKRouter LDKRouter_init (JSValue o) {
	LDKRouter_JCalls *calls = MALLOC(sizeof(LDKRouter_JCalls), "LDKRouter_JCalls");
	atomic_init(&calls->refcnt, 1);
	calls->instance_ptr = o;

	LDKRouter ret = {
		.this_arg = (void*) calls,
		.find_route = find_route_LDKRouter_jcall,
		.free = LDKRouter_JCalls_free,
	};
	return ret;
}
long  __attribute__((export_name("TS_LDKRouter_new"))) TS_LDKRouter_new(JSValue o) {
	LDKRouter *res_ptr = MALLOC(sizeof(LDKRouter), "LDKRouter");
	*res_ptr = LDKRouter_init(o);
	return (long)res_ptr;
}
uint32_t  __attribute__((export_name("TS_Router_find_route"))) TS_Router_find_route(uint32_t this_arg, int8_tArray payer, uint32_t route_params, int8_tArray payment_hash, uint32_tArray first_hops, uint32_t scorer) {
	void* this_arg_ptr = (void*)(((uintptr_t)this_arg) & ~1);
	if (!(this_arg & 1)) { CHECK_ACCESS(this_arg_ptr); }
	LDKRouter* this_arg_conv = (LDKRouter*)this_arg_ptr;
	LDKPublicKey payer_ref;
	CHECK(payer->arr_len == 33);
	memcpy(payer_ref.compressed_form, payer->elems, 33); FREE(payer);
	LDKRouteParameters route_params_conv;
	route_params_conv.inner = (void*)(route_params & (~1));
	route_params_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_params_conv);
	unsigned char payment_hash_arr[32];
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_arr, payment_hash->elems, 32); FREE(payment_hash);
	unsigned char (*payment_hash_ref)[32] = &payment_hash_arr;
	LDKCVec_ChannelDetailsZ first_hops_constr;
	LDKCVec_ChannelDetailsZ *first_hops_ptr = NULL;
	if (first_hops != 0) {
		first_hops_constr.datalen = first_hops->arr_len;
		if (first_hops_constr.datalen > 0)
			first_hops_constr.data = MALLOC(first_hops_constr.datalen * sizeof(LDKChannelDetails), "LDKCVec_ChannelDetailsZ Elements");
		else
			first_hops_constr.data = NULL;
		uint32_t* first_hops_vals = first_hops->elems /* XXX first_hops leaks */;
		for (size_t q = 0; q < first_hops_constr.datalen; q++) {
			uint32_t first_hops_conv_16 = first_hops_vals[q];
			LDKChannelDetails first_hops_conv_16_conv;
			first_hops_conv_16_conv.inner = (void*)(first_hops_conv_16 & (~1));
			first_hops_conv_16_conv.is_owned = (first_hops_conv_16 & 1) || (first_hops_conv_16 == 0);
			CHECK_INNER_FIELD_ACCESS_OR_NULL(first_hops_conv_16_conv);
			first_hops_constr.data[q] = first_hops_conv_16_conv;
		}
		first_hops_ptr = &first_hops_constr;
	}
	void* scorer_ptr = (void*)(((uintptr_t)scorer) & ~1);
	if (!(scorer & 1)) { CHECK_ACCESS(scorer_ptr); }
	LDKScore* scorer_conv = (LDKScore*)scorer_ptr;
	LDKCResult_RouteLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteLightningErrorZ), "LDKCResult_RouteLightningErrorZ");
	*ret_conv = (this_arg_conv->find_route)(this_arg_conv->this_arg, payer_ref, &route_params_conv, payment_hash_ref, first_hops_ptr, scorer_conv);
	if (first_hops_ptr != NULL) { FREE(first_hops_constr.data); }
	return (uint32_t)ret_conv;
}

jstring  __attribute__((export_name("TS__ldk_get_compiled_version"))) TS__ldk_get_compiled_version() {
	LDKStr ret_str = _ldk_get_compiled_version();
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

jstring  __attribute__((export_name("TS__ldk_c_bindings_get_compiled_version"))) TS__ldk_c_bindings_get_compiled_version() {
	LDKStr ret_str = _ldk_c_bindings_get_compiled_version();
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

static inline uintptr_t Bech32Error_clone_ptr(LDKBech32Error *NONNULL_PTR arg) {
	LDKBech32Error *ret_copy = MALLOC(sizeof(LDKBech32Error), "LDKBech32Error");
	*ret_copy = Bech32Error_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Bech32Error_clone_ptr"))) TS_Bech32Error_clone_ptr(uint32_t arg) {
	LDKBech32Error* arg_conv = (LDKBech32Error*)arg;
	uint32_t ret_val = Bech32Error_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Bech32Error_clone"))) TS_Bech32Error_clone(uint32_t orig) {
	LDKBech32Error* orig_conv = (LDKBech32Error*)orig;
	LDKBech32Error *ret_copy = MALLOC(sizeof(LDKBech32Error), "LDKBech32Error");
	*ret_copy = Bech32Error_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_Bech32Error_free"))) TS_Bech32Error_free(uint32_t o) {
	if ((o & 1) != 0) return;
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKBech32Error o_conv = *(LDKBech32Error*)(o_ptr);
	FREE((void*)o);
	Bech32Error_free(o_conv);
}

void  __attribute__((export_name("TS_Transaction_free"))) TS_Transaction_free(int8_tArray _res) {
	LDKTransaction _res_ref;
	_res_ref.datalen = _res->arr_len;
	_res_ref.data = MALLOC(_res_ref.datalen, "LDKTransaction Bytes");
	memcpy(_res_ref.data, _res->elems, _res_ref.datalen); FREE(_res);
	_res_ref.data_is_owned = true;
	Transaction_free(_res_ref);
}

uint32_t  __attribute__((export_name("TS_TxOut_new"))) TS_TxOut_new(int8_tArray script_pubkey, int64_t value) {
	LDKCVec_u8Z script_pubkey_ref;
	script_pubkey_ref.datalen = script_pubkey->arr_len;
	script_pubkey_ref.data = MALLOC(script_pubkey_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(script_pubkey_ref.data, script_pubkey->elems, script_pubkey_ref.datalen); FREE(script_pubkey);
	LDKTxOut* ret_ref = MALLOC(sizeof(LDKTxOut), "LDKTxOut");
	*ret_ref = TxOut_new(script_pubkey_ref, value);
	return (uint32_t)ret_ref;
}

void  __attribute__((export_name("TS_TxOut_free"))) TS_TxOut_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKTxOut _res_conv = *(LDKTxOut*)(_res_ptr);
	FREE((void*)_res);
	TxOut_free(_res_conv);
}

static inline uintptr_t TxOut_clone_ptr(LDKTxOut *NONNULL_PTR arg) {
	LDKTxOut* ret_ref = MALLOC(sizeof(LDKTxOut), "LDKTxOut");
	*ret_ref = TxOut_clone(arg);
	return (uint32_t)ret_ref;
}
uint32_t  __attribute__((export_name("TS_TxOut_clone_ptr"))) TS_TxOut_clone_ptr(uint32_t arg) {
	LDKTxOut* arg_conv = (LDKTxOut*)(arg & ~1);
	uint32_t ret_val = TxOut_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_TxOut_clone"))) TS_TxOut_clone(uint32_t orig) {
	LDKTxOut* orig_conv = (LDKTxOut*)(orig & ~1);
	LDKTxOut* ret_ref = MALLOC(sizeof(LDKTxOut), "LDKTxOut");
	*ret_ref = TxOut_clone(orig_conv);
	return (uint32_t)ret_ref;
}

void  __attribute__((export_name("TS_Str_free"))) TS_Str_free(jstring _res) {
	LDKStr dummy = { .chars = NULL, .len = 0, .chars_is_owned = false };
	Str_free(dummy);
}

uint32_t  __attribute__((export_name("TS_CResult_NoneNoneZ_ok"))) TS_CResult_NoneNoneZ_ok() {
	LDKCResult_NoneNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneNoneZ), "LDKCResult_NoneNoneZ");
	*ret_conv = CResult_NoneNoneZ_ok();
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneNoneZ_err"))) TS_CResult_NoneNoneZ_err() {
	LDKCResult_NoneNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneNoneZ), "LDKCResult_NoneNoneZ");
	*ret_conv = CResult_NoneNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NoneNoneZ_is_ok"))) TS_CResult_NoneNoneZ_is_ok(uint32_t o) {
	LDKCResult_NoneNoneZ* o_conv = (LDKCResult_NoneNoneZ*)(o & ~1);
	jboolean ret_val = CResult_NoneNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NoneNoneZ_free"))) TS_CResult_NoneNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NoneNoneZ _res_conv = *(LDKCResult_NoneNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NoneNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_NoneNoneZ_clone_ptr(LDKCResult_NoneNoneZ *NONNULL_PTR arg) {
	LDKCResult_NoneNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneNoneZ), "LDKCResult_NoneNoneZ");
	*ret_conv = CResult_NoneNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NoneNoneZ_clone_ptr"))) TS_CResult_NoneNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_NoneNoneZ* arg_conv = (LDKCResult_NoneNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_NoneNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneNoneZ_clone"))) TS_CResult_NoneNoneZ_clone(uint32_t orig) {
	LDKCResult_NoneNoneZ* orig_conv = (LDKCResult_NoneNoneZ*)(orig & ~1);
	LDKCResult_NoneNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneNoneZ), "LDKCResult_NoneNoneZ");
	*ret_conv = CResult_NoneNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_ok"))) TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_ok(uint32_t o) {
	LDKCounterpartyCommitmentSecrets o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = CounterpartyCommitmentSecrets_clone(&o_conv);
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ), "LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ");
	*ret_conv = CResult_CounterpartyCommitmentSecretsDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_err"))) TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ), "LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ");
	*ret_conv = CResult_CounterpartyCommitmentSecretsDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_is_ok"))) TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* o_conv = (LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_CounterpartyCommitmentSecretsDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_free"))) TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ _res_conv = *(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_CounterpartyCommitmentSecretsDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_CounterpartyCommitmentSecretsDecodeErrorZ_clone_ptr(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ), "LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ");
	*ret_conv = CResult_CounterpartyCommitmentSecretsDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_clone_ptr"))) TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* arg_conv = (LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_CounterpartyCommitmentSecretsDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_clone"))) TS_CResult_CounterpartyCommitmentSecretsDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* orig_conv = (LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ*)(orig & ~1);
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ), "LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ");
	*ret_conv = CResult_CounterpartyCommitmentSecretsDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SecretKeyErrorZ_ok"))) TS_CResult_SecretKeyErrorZ_ok(int8_tArray o) {
	LDKSecretKey o_ref;
	CHECK(o->arr_len == 32);
	memcpy(o_ref.bytes, o->elems, 32); FREE(o);
	LDKCResult_SecretKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyErrorZ), "LDKCResult_SecretKeyErrorZ");
	*ret_conv = CResult_SecretKeyErrorZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SecretKeyErrorZ_err"))) TS_CResult_SecretKeyErrorZ_err(uint32_t e) {
	LDKSecp256k1Error e_conv = LDKSecp256k1Error_from_js(e);
	LDKCResult_SecretKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyErrorZ), "LDKCResult_SecretKeyErrorZ");
	*ret_conv = CResult_SecretKeyErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_SecretKeyErrorZ_is_ok"))) TS_CResult_SecretKeyErrorZ_is_ok(uint32_t o) {
	LDKCResult_SecretKeyErrorZ* o_conv = (LDKCResult_SecretKeyErrorZ*)(o & ~1);
	jboolean ret_val = CResult_SecretKeyErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_SecretKeyErrorZ_free"))) TS_CResult_SecretKeyErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_SecretKeyErrorZ _res_conv = *(LDKCResult_SecretKeyErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_SecretKeyErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_SecretKeyErrorZ_clone_ptr(LDKCResult_SecretKeyErrorZ *NONNULL_PTR arg) {
	LDKCResult_SecretKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyErrorZ), "LDKCResult_SecretKeyErrorZ");
	*ret_conv = CResult_SecretKeyErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_SecretKeyErrorZ_clone_ptr"))) TS_CResult_SecretKeyErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_SecretKeyErrorZ* arg_conv = (LDKCResult_SecretKeyErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_SecretKeyErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_SecretKeyErrorZ_clone"))) TS_CResult_SecretKeyErrorZ_clone(uint32_t orig) {
	LDKCResult_SecretKeyErrorZ* orig_conv = (LDKCResult_SecretKeyErrorZ*)(orig & ~1);
	LDKCResult_SecretKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyErrorZ), "LDKCResult_SecretKeyErrorZ");
	*ret_conv = CResult_SecretKeyErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PublicKeyErrorZ_ok"))) TS_CResult_PublicKeyErrorZ_ok(int8_tArray o) {
	LDKPublicKey o_ref;
	CHECK(o->arr_len == 33);
	memcpy(o_ref.compressed_form, o->elems, 33); FREE(o);
	LDKCResult_PublicKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PublicKeyErrorZ), "LDKCResult_PublicKeyErrorZ");
	*ret_conv = CResult_PublicKeyErrorZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PublicKeyErrorZ_err"))) TS_CResult_PublicKeyErrorZ_err(uint32_t e) {
	LDKSecp256k1Error e_conv = LDKSecp256k1Error_from_js(e);
	LDKCResult_PublicKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PublicKeyErrorZ), "LDKCResult_PublicKeyErrorZ");
	*ret_conv = CResult_PublicKeyErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PublicKeyErrorZ_is_ok"))) TS_CResult_PublicKeyErrorZ_is_ok(uint32_t o) {
	LDKCResult_PublicKeyErrorZ* o_conv = (LDKCResult_PublicKeyErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PublicKeyErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PublicKeyErrorZ_free"))) TS_CResult_PublicKeyErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PublicKeyErrorZ _res_conv = *(LDKCResult_PublicKeyErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PublicKeyErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PublicKeyErrorZ_clone_ptr(LDKCResult_PublicKeyErrorZ *NONNULL_PTR arg) {
	LDKCResult_PublicKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PublicKeyErrorZ), "LDKCResult_PublicKeyErrorZ");
	*ret_conv = CResult_PublicKeyErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PublicKeyErrorZ_clone_ptr"))) TS_CResult_PublicKeyErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PublicKeyErrorZ* arg_conv = (LDKCResult_PublicKeyErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PublicKeyErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PublicKeyErrorZ_clone"))) TS_CResult_PublicKeyErrorZ_clone(uint32_t orig) {
	LDKCResult_PublicKeyErrorZ* orig_conv = (LDKCResult_PublicKeyErrorZ*)(orig & ~1);
	LDKCResult_PublicKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PublicKeyErrorZ), "LDKCResult_PublicKeyErrorZ");
	*ret_conv = CResult_PublicKeyErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysDecodeErrorZ_ok"))) TS_CResult_TxCreationKeysDecodeErrorZ_ok(uint32_t o) {
	LDKTxCreationKeys o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = TxCreationKeys_clone(&o_conv);
	LDKCResult_TxCreationKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysDecodeErrorZ), "LDKCResult_TxCreationKeysDecodeErrorZ");
	*ret_conv = CResult_TxCreationKeysDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysDecodeErrorZ_err"))) TS_CResult_TxCreationKeysDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_TxCreationKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysDecodeErrorZ), "LDKCResult_TxCreationKeysDecodeErrorZ");
	*ret_conv = CResult_TxCreationKeysDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_TxCreationKeysDecodeErrorZ_is_ok"))) TS_CResult_TxCreationKeysDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_TxCreationKeysDecodeErrorZ* o_conv = (LDKCResult_TxCreationKeysDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_TxCreationKeysDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_TxCreationKeysDecodeErrorZ_free"))) TS_CResult_TxCreationKeysDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_TxCreationKeysDecodeErrorZ _res_conv = *(LDKCResult_TxCreationKeysDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_TxCreationKeysDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_TxCreationKeysDecodeErrorZ_clone_ptr(LDKCResult_TxCreationKeysDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_TxCreationKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysDecodeErrorZ), "LDKCResult_TxCreationKeysDecodeErrorZ");
	*ret_conv = CResult_TxCreationKeysDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysDecodeErrorZ_clone_ptr"))) TS_CResult_TxCreationKeysDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_TxCreationKeysDecodeErrorZ* arg_conv = (LDKCResult_TxCreationKeysDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_TxCreationKeysDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysDecodeErrorZ_clone"))) TS_CResult_TxCreationKeysDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_TxCreationKeysDecodeErrorZ* orig_conv = (LDKCResult_TxCreationKeysDecodeErrorZ*)(orig & ~1);
	LDKCResult_TxCreationKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysDecodeErrorZ), "LDKCResult_TxCreationKeysDecodeErrorZ");
	*ret_conv = CResult_TxCreationKeysDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelPublicKeysDecodeErrorZ_ok"))) TS_CResult_ChannelPublicKeysDecodeErrorZ_ok(uint32_t o) {
	LDKChannelPublicKeys o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelPublicKeys_clone(&o_conv);
	LDKCResult_ChannelPublicKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelPublicKeysDecodeErrorZ), "LDKCResult_ChannelPublicKeysDecodeErrorZ");
	*ret_conv = CResult_ChannelPublicKeysDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelPublicKeysDecodeErrorZ_err"))) TS_CResult_ChannelPublicKeysDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelPublicKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelPublicKeysDecodeErrorZ), "LDKCResult_ChannelPublicKeysDecodeErrorZ");
	*ret_conv = CResult_ChannelPublicKeysDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelPublicKeysDecodeErrorZ_is_ok"))) TS_CResult_ChannelPublicKeysDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelPublicKeysDecodeErrorZ* o_conv = (LDKCResult_ChannelPublicKeysDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelPublicKeysDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelPublicKeysDecodeErrorZ_free"))) TS_CResult_ChannelPublicKeysDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelPublicKeysDecodeErrorZ _res_conv = *(LDKCResult_ChannelPublicKeysDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelPublicKeysDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelPublicKeysDecodeErrorZ_clone_ptr(LDKCResult_ChannelPublicKeysDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelPublicKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelPublicKeysDecodeErrorZ), "LDKCResult_ChannelPublicKeysDecodeErrorZ");
	*ret_conv = CResult_ChannelPublicKeysDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelPublicKeysDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelPublicKeysDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelPublicKeysDecodeErrorZ* arg_conv = (LDKCResult_ChannelPublicKeysDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelPublicKeysDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelPublicKeysDecodeErrorZ_clone"))) TS_CResult_ChannelPublicKeysDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelPublicKeysDecodeErrorZ* orig_conv = (LDKCResult_ChannelPublicKeysDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelPublicKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelPublicKeysDecodeErrorZ), "LDKCResult_ChannelPublicKeysDecodeErrorZ");
	*ret_conv = CResult_ChannelPublicKeysDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysErrorZ_ok"))) TS_CResult_TxCreationKeysErrorZ_ok(uint32_t o) {
	LDKTxCreationKeys o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = TxCreationKeys_clone(&o_conv);
	LDKCResult_TxCreationKeysErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysErrorZ), "LDKCResult_TxCreationKeysErrorZ");
	*ret_conv = CResult_TxCreationKeysErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysErrorZ_err"))) TS_CResult_TxCreationKeysErrorZ_err(uint32_t e) {
	LDKSecp256k1Error e_conv = LDKSecp256k1Error_from_js(e);
	LDKCResult_TxCreationKeysErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysErrorZ), "LDKCResult_TxCreationKeysErrorZ");
	*ret_conv = CResult_TxCreationKeysErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_TxCreationKeysErrorZ_is_ok"))) TS_CResult_TxCreationKeysErrorZ_is_ok(uint32_t o) {
	LDKCResult_TxCreationKeysErrorZ* o_conv = (LDKCResult_TxCreationKeysErrorZ*)(o & ~1);
	jboolean ret_val = CResult_TxCreationKeysErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_TxCreationKeysErrorZ_free"))) TS_CResult_TxCreationKeysErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_TxCreationKeysErrorZ _res_conv = *(LDKCResult_TxCreationKeysErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_TxCreationKeysErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_TxCreationKeysErrorZ_clone_ptr(LDKCResult_TxCreationKeysErrorZ *NONNULL_PTR arg) {
	LDKCResult_TxCreationKeysErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysErrorZ), "LDKCResult_TxCreationKeysErrorZ");
	*ret_conv = CResult_TxCreationKeysErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysErrorZ_clone_ptr"))) TS_CResult_TxCreationKeysErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_TxCreationKeysErrorZ* arg_conv = (LDKCResult_TxCreationKeysErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_TxCreationKeysErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_TxCreationKeysErrorZ_clone"))) TS_CResult_TxCreationKeysErrorZ_clone(uint32_t orig) {
	LDKCResult_TxCreationKeysErrorZ* orig_conv = (LDKCResult_TxCreationKeysErrorZ*)(orig & ~1);
	LDKCResult_TxCreationKeysErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysErrorZ), "LDKCResult_TxCreationKeysErrorZ");
	*ret_conv = CResult_TxCreationKeysErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_u32Z_some"))) TS_COption_u32Z_some(int32_t o) {
	LDKCOption_u32Z *ret_copy = MALLOC(sizeof(LDKCOption_u32Z), "LDKCOption_u32Z");
	*ret_copy = COption_u32Z_some(o);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_u32Z_none"))) TS_COption_u32Z_none() {
	LDKCOption_u32Z *ret_copy = MALLOC(sizeof(LDKCOption_u32Z), "LDKCOption_u32Z");
	*ret_copy = COption_u32Z_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_u32Z_free"))) TS_COption_u32Z_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_u32Z _res_conv = *(LDKCOption_u32Z*)(_res_ptr);
	FREE((void*)_res);
	COption_u32Z_free(_res_conv);
}

static inline uintptr_t COption_u32Z_clone_ptr(LDKCOption_u32Z *NONNULL_PTR arg) {
	LDKCOption_u32Z *ret_copy = MALLOC(sizeof(LDKCOption_u32Z), "LDKCOption_u32Z");
	*ret_copy = COption_u32Z_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_u32Z_clone_ptr"))) TS_COption_u32Z_clone_ptr(uint32_t arg) {
	LDKCOption_u32Z* arg_conv = (LDKCOption_u32Z*)arg;
	uint32_t ret_val = COption_u32Z_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_u32Z_clone"))) TS_COption_u32Z_clone(uint32_t orig) {
	LDKCOption_u32Z* orig_conv = (LDKCOption_u32Z*)orig;
	LDKCOption_u32Z *ret_copy = MALLOC(sizeof(LDKCOption_u32Z), "LDKCOption_u32Z");
	*ret_copy = COption_u32Z_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_ok"))) TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_ok(uint32_t o) {
	LDKHTLCOutputInCommitment o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = HTLCOutputInCommitment_clone(&o_conv);
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ), "LDKCResult_HTLCOutputInCommitmentDecodeErrorZ");
	*ret_conv = CResult_HTLCOutputInCommitmentDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_err"))) TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ), "LDKCResult_HTLCOutputInCommitmentDecodeErrorZ");
	*ret_conv = CResult_HTLCOutputInCommitmentDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_is_ok"))) TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* o_conv = (LDKCResult_HTLCOutputInCommitmentDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_HTLCOutputInCommitmentDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_free"))) TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ _res_conv = *(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_HTLCOutputInCommitmentDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_HTLCOutputInCommitmentDecodeErrorZ_clone_ptr(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ), "LDKCResult_HTLCOutputInCommitmentDecodeErrorZ");
	*ret_conv = CResult_HTLCOutputInCommitmentDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_clone_ptr"))) TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* arg_conv = (LDKCResult_HTLCOutputInCommitmentDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_HTLCOutputInCommitmentDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_clone"))) TS_CResult_HTLCOutputInCommitmentDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* orig_conv = (LDKCResult_HTLCOutputInCommitmentDecodeErrorZ*)(orig & ~1);
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ), "LDKCResult_HTLCOutputInCommitmentDecodeErrorZ");
	*ret_conv = CResult_HTLCOutputInCommitmentDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_NoneZ_some"))) TS_COption_NoneZ_some() {
	uint32_t ret_conv = LDKCOption_NoneZ_to_js(COption_NoneZ_some());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_NoneZ_none"))) TS_COption_NoneZ_none() {
	uint32_t ret_conv = LDKCOption_NoneZ_to_js(COption_NoneZ_none());
	return ret_conv;
}

void  __attribute__((export_name("TS_COption_NoneZ_free"))) TS_COption_NoneZ_free(uint32_t _res) {
	LDKCOption_NoneZ _res_conv = LDKCOption_NoneZ_from_js(_res);
	COption_NoneZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_ok"))) TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_ok(uint32_t o) {
	LDKCounterpartyChannelTransactionParameters o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = CounterpartyChannelTransactionParameters_clone(&o_conv);
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ), "LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_err"))) TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ), "LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_is_ok"))) TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* o_conv = (LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_free"))) TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ _res_conv = *(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_clone_ptr(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ), "LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_clone_ptr"))) TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* arg_conv = (LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_clone"))) TS_CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* orig_conv = (LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ*)(orig & ~1);
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ), "LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CResult_CounterpartyChannelTransactionParametersDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelTransactionParametersDecodeErrorZ_ok"))) TS_CResult_ChannelTransactionParametersDecodeErrorZ_ok(uint32_t o) {
	LDKChannelTransactionParameters o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelTransactionParameters_clone(&o_conv);
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelTransactionParametersDecodeErrorZ), "LDKCResult_ChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CResult_ChannelTransactionParametersDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelTransactionParametersDecodeErrorZ_err"))) TS_CResult_ChannelTransactionParametersDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelTransactionParametersDecodeErrorZ), "LDKCResult_ChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CResult_ChannelTransactionParametersDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelTransactionParametersDecodeErrorZ_is_ok"))) TS_CResult_ChannelTransactionParametersDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* o_conv = (LDKCResult_ChannelTransactionParametersDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelTransactionParametersDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelTransactionParametersDecodeErrorZ_free"))) TS_CResult_ChannelTransactionParametersDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelTransactionParametersDecodeErrorZ _res_conv = *(LDKCResult_ChannelTransactionParametersDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelTransactionParametersDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelTransactionParametersDecodeErrorZ_clone_ptr(LDKCResult_ChannelTransactionParametersDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelTransactionParametersDecodeErrorZ), "LDKCResult_ChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CResult_ChannelTransactionParametersDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelTransactionParametersDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelTransactionParametersDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* arg_conv = (LDKCResult_ChannelTransactionParametersDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelTransactionParametersDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelTransactionParametersDecodeErrorZ_clone"))) TS_CResult_ChannelTransactionParametersDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* orig_conv = (LDKCResult_ChannelTransactionParametersDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelTransactionParametersDecodeErrorZ), "LDKCResult_ChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CResult_ChannelTransactionParametersDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_SignatureZ_free"))) TS_CVec_SignatureZ_free(ptrArray _res) {
	LDKCVec_SignatureZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKSignature), "LDKCVec_SignatureZ Elements");
	else
		_res_constr.data = NULL;
	int8_tArray* _res_vals = (void*) _res->elems /* XXX _res leaks */;
	for (size_t m = 0; m < _res_constr.datalen; m++) {
		int8_tArray _res_conv_12 = _res_vals[m];
		LDKSignature _res_conv_12_ref;
		CHECK(_res_conv_12->arr_len == 64);
		memcpy(_res_conv_12_ref.compact_form, _res_conv_12->elems, 64); FREE(_res_conv_12);
		_res_constr.data[m] = _res_conv_12_ref;
	}
	CVec_SignatureZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_HolderCommitmentTransactionDecodeErrorZ_ok"))) TS_CResult_HolderCommitmentTransactionDecodeErrorZ_ok(uint32_t o) {
	LDKHolderCommitmentTransaction o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = HolderCommitmentTransaction_clone(&o_conv);
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HolderCommitmentTransactionDecodeErrorZ), "LDKCResult_HolderCommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_HolderCommitmentTransactionDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_HolderCommitmentTransactionDecodeErrorZ_err"))) TS_CResult_HolderCommitmentTransactionDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HolderCommitmentTransactionDecodeErrorZ), "LDKCResult_HolderCommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_HolderCommitmentTransactionDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_HolderCommitmentTransactionDecodeErrorZ_is_ok"))) TS_CResult_HolderCommitmentTransactionDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* o_conv = (LDKCResult_HolderCommitmentTransactionDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_HolderCommitmentTransactionDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_HolderCommitmentTransactionDecodeErrorZ_free"))) TS_CResult_HolderCommitmentTransactionDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ _res_conv = *(LDKCResult_HolderCommitmentTransactionDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_HolderCommitmentTransactionDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_HolderCommitmentTransactionDecodeErrorZ_clone_ptr(LDKCResult_HolderCommitmentTransactionDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HolderCommitmentTransactionDecodeErrorZ), "LDKCResult_HolderCommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_HolderCommitmentTransactionDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_HolderCommitmentTransactionDecodeErrorZ_clone_ptr"))) TS_CResult_HolderCommitmentTransactionDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* arg_conv = (LDKCResult_HolderCommitmentTransactionDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_HolderCommitmentTransactionDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_HolderCommitmentTransactionDecodeErrorZ_clone"))) TS_CResult_HolderCommitmentTransactionDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* orig_conv = (LDKCResult_HolderCommitmentTransactionDecodeErrorZ*)(orig & ~1);
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HolderCommitmentTransactionDecodeErrorZ), "LDKCResult_HolderCommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_HolderCommitmentTransactionDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_ok"))) TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_ok(uint32_t o) {
	LDKBuiltCommitmentTransaction o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = BuiltCommitmentTransaction_clone(&o_conv);
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ), "LDKCResult_BuiltCommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_BuiltCommitmentTransactionDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_err"))) TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ), "LDKCResult_BuiltCommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_BuiltCommitmentTransactionDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_is_ok"))) TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* o_conv = (LDKCResult_BuiltCommitmentTransactionDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_BuiltCommitmentTransactionDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_free"))) TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ _res_conv = *(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_BuiltCommitmentTransactionDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_BuiltCommitmentTransactionDecodeErrorZ_clone_ptr(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ), "LDKCResult_BuiltCommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_BuiltCommitmentTransactionDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_clone_ptr"))) TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* arg_conv = (LDKCResult_BuiltCommitmentTransactionDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_BuiltCommitmentTransactionDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_clone"))) TS_CResult_BuiltCommitmentTransactionDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* orig_conv = (LDKCResult_BuiltCommitmentTransactionDecodeErrorZ*)(orig & ~1);
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ), "LDKCResult_BuiltCommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_BuiltCommitmentTransactionDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TrustedClosingTransactionNoneZ_ok"))) TS_CResult_TrustedClosingTransactionNoneZ_ok(uint32_t o) {
	LDKTrustedClosingTransaction o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	// WARNING: we need a move here but no clone is available for LDKTrustedClosingTransaction
	LDKCResult_TrustedClosingTransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TrustedClosingTransactionNoneZ), "LDKCResult_TrustedClosingTransactionNoneZ");
	*ret_conv = CResult_TrustedClosingTransactionNoneZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TrustedClosingTransactionNoneZ_err"))) TS_CResult_TrustedClosingTransactionNoneZ_err() {
	LDKCResult_TrustedClosingTransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TrustedClosingTransactionNoneZ), "LDKCResult_TrustedClosingTransactionNoneZ");
	*ret_conv = CResult_TrustedClosingTransactionNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_TrustedClosingTransactionNoneZ_is_ok"))) TS_CResult_TrustedClosingTransactionNoneZ_is_ok(uint32_t o) {
	LDKCResult_TrustedClosingTransactionNoneZ* o_conv = (LDKCResult_TrustedClosingTransactionNoneZ*)(o & ~1);
	jboolean ret_val = CResult_TrustedClosingTransactionNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_TrustedClosingTransactionNoneZ_free"))) TS_CResult_TrustedClosingTransactionNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_TrustedClosingTransactionNoneZ _res_conv = *(LDKCResult_TrustedClosingTransactionNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_TrustedClosingTransactionNoneZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_CommitmentTransactionDecodeErrorZ_ok"))) TS_CResult_CommitmentTransactionDecodeErrorZ_ok(uint32_t o) {
	LDKCommitmentTransaction o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = CommitmentTransaction_clone(&o_conv);
	LDKCResult_CommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentTransactionDecodeErrorZ), "LDKCResult_CommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_CommitmentTransactionDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CommitmentTransactionDecodeErrorZ_err"))) TS_CResult_CommitmentTransactionDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_CommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentTransactionDecodeErrorZ), "LDKCResult_CommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_CommitmentTransactionDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_CommitmentTransactionDecodeErrorZ_is_ok"))) TS_CResult_CommitmentTransactionDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_CommitmentTransactionDecodeErrorZ* o_conv = (LDKCResult_CommitmentTransactionDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_CommitmentTransactionDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_CommitmentTransactionDecodeErrorZ_free"))) TS_CResult_CommitmentTransactionDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_CommitmentTransactionDecodeErrorZ _res_conv = *(LDKCResult_CommitmentTransactionDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_CommitmentTransactionDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_CommitmentTransactionDecodeErrorZ_clone_ptr(LDKCResult_CommitmentTransactionDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_CommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentTransactionDecodeErrorZ), "LDKCResult_CommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_CommitmentTransactionDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_CommitmentTransactionDecodeErrorZ_clone_ptr"))) TS_CResult_CommitmentTransactionDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_CommitmentTransactionDecodeErrorZ* arg_conv = (LDKCResult_CommitmentTransactionDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_CommitmentTransactionDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_CommitmentTransactionDecodeErrorZ_clone"))) TS_CResult_CommitmentTransactionDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_CommitmentTransactionDecodeErrorZ* orig_conv = (LDKCResult_CommitmentTransactionDecodeErrorZ*)(orig & ~1);
	LDKCResult_CommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentTransactionDecodeErrorZ), "LDKCResult_CommitmentTransactionDecodeErrorZ");
	*ret_conv = CResult_CommitmentTransactionDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TrustedCommitmentTransactionNoneZ_ok"))) TS_CResult_TrustedCommitmentTransactionNoneZ_ok(uint32_t o) {
	LDKTrustedCommitmentTransaction o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	// WARNING: we need a move here but no clone is available for LDKTrustedCommitmentTransaction
	LDKCResult_TrustedCommitmentTransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TrustedCommitmentTransactionNoneZ), "LDKCResult_TrustedCommitmentTransactionNoneZ");
	*ret_conv = CResult_TrustedCommitmentTransactionNoneZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TrustedCommitmentTransactionNoneZ_err"))) TS_CResult_TrustedCommitmentTransactionNoneZ_err() {
	LDKCResult_TrustedCommitmentTransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TrustedCommitmentTransactionNoneZ), "LDKCResult_TrustedCommitmentTransactionNoneZ");
	*ret_conv = CResult_TrustedCommitmentTransactionNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_TrustedCommitmentTransactionNoneZ_is_ok"))) TS_CResult_TrustedCommitmentTransactionNoneZ_is_ok(uint32_t o) {
	LDKCResult_TrustedCommitmentTransactionNoneZ* o_conv = (LDKCResult_TrustedCommitmentTransactionNoneZ*)(o & ~1);
	jboolean ret_val = CResult_TrustedCommitmentTransactionNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_TrustedCommitmentTransactionNoneZ_free"))) TS_CResult_TrustedCommitmentTransactionNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_TrustedCommitmentTransactionNoneZ _res_conv = *(LDKCResult_TrustedCommitmentTransactionNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_TrustedCommitmentTransactionNoneZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_SignatureZNoneZ_ok"))) TS_CResult_CVec_SignatureZNoneZ_ok(ptrArray o) {
	LDKCVec_SignatureZ o_constr;
	o_constr.datalen = o->arr_len;
	if (o_constr.datalen > 0)
		o_constr.data = MALLOC(o_constr.datalen * sizeof(LDKSignature), "LDKCVec_SignatureZ Elements");
	else
		o_constr.data = NULL;
	int8_tArray* o_vals = (void*) o->elems /* XXX o leaks */;
	for (size_t m = 0; m < o_constr.datalen; m++) {
		int8_tArray o_conv_12 = o_vals[m];
		LDKSignature o_conv_12_ref;
		CHECK(o_conv_12->arr_len == 64);
		memcpy(o_conv_12_ref.compact_form, o_conv_12->elems, 64); FREE(o_conv_12);
		o_constr.data[m] = o_conv_12_ref;
	}
	LDKCResult_CVec_SignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_SignatureZNoneZ), "LDKCResult_CVec_SignatureZNoneZ");
	*ret_conv = CResult_CVec_SignatureZNoneZ_ok(o_constr);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_SignatureZNoneZ_err"))) TS_CResult_CVec_SignatureZNoneZ_err() {
	LDKCResult_CVec_SignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_SignatureZNoneZ), "LDKCResult_CVec_SignatureZNoneZ");
	*ret_conv = CResult_CVec_SignatureZNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_CVec_SignatureZNoneZ_is_ok"))) TS_CResult_CVec_SignatureZNoneZ_is_ok(uint32_t o) {
	LDKCResult_CVec_SignatureZNoneZ* o_conv = (LDKCResult_CVec_SignatureZNoneZ*)(o & ~1);
	jboolean ret_val = CResult_CVec_SignatureZNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_CVec_SignatureZNoneZ_free"))) TS_CResult_CVec_SignatureZNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_CVec_SignatureZNoneZ _res_conv = *(LDKCResult_CVec_SignatureZNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_CVec_SignatureZNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_CVec_SignatureZNoneZ_clone_ptr(LDKCResult_CVec_SignatureZNoneZ *NONNULL_PTR arg) {
	LDKCResult_CVec_SignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_SignatureZNoneZ), "LDKCResult_CVec_SignatureZNoneZ");
	*ret_conv = CResult_CVec_SignatureZNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_CVec_SignatureZNoneZ_clone_ptr"))) TS_CResult_CVec_SignatureZNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_CVec_SignatureZNoneZ* arg_conv = (LDKCResult_CVec_SignatureZNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_CVec_SignatureZNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_SignatureZNoneZ_clone"))) TS_CResult_CVec_SignatureZNoneZ_clone(uint32_t orig) {
	LDKCResult_CVec_SignatureZNoneZ* orig_conv = (LDKCResult_CVec_SignatureZNoneZ*)(orig & ~1);
	LDKCResult_CVec_SignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_SignatureZNoneZ), "LDKCResult_CVec_SignatureZNoneZ");
	*ret_conv = CResult_CVec_SignatureZNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptDecodeErrorZ_ok"))) TS_CResult_ShutdownScriptDecodeErrorZ_ok(uint32_t o) {
	LDKShutdownScript o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ShutdownScript_clone(&o_conv);
	LDKCResult_ShutdownScriptDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptDecodeErrorZ), "LDKCResult_ShutdownScriptDecodeErrorZ");
	*ret_conv = CResult_ShutdownScriptDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptDecodeErrorZ_err"))) TS_CResult_ShutdownScriptDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ShutdownScriptDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptDecodeErrorZ), "LDKCResult_ShutdownScriptDecodeErrorZ");
	*ret_conv = CResult_ShutdownScriptDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ShutdownScriptDecodeErrorZ_is_ok"))) TS_CResult_ShutdownScriptDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ShutdownScriptDecodeErrorZ* o_conv = (LDKCResult_ShutdownScriptDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ShutdownScriptDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ShutdownScriptDecodeErrorZ_free"))) TS_CResult_ShutdownScriptDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ShutdownScriptDecodeErrorZ _res_conv = *(LDKCResult_ShutdownScriptDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ShutdownScriptDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ShutdownScriptDecodeErrorZ_clone_ptr(LDKCResult_ShutdownScriptDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ShutdownScriptDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptDecodeErrorZ), "LDKCResult_ShutdownScriptDecodeErrorZ");
	*ret_conv = CResult_ShutdownScriptDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptDecodeErrorZ_clone_ptr"))) TS_CResult_ShutdownScriptDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ShutdownScriptDecodeErrorZ* arg_conv = (LDKCResult_ShutdownScriptDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ShutdownScriptDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptDecodeErrorZ_clone"))) TS_CResult_ShutdownScriptDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ShutdownScriptDecodeErrorZ* orig_conv = (LDKCResult_ShutdownScriptDecodeErrorZ*)(orig & ~1);
	LDKCResult_ShutdownScriptDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptDecodeErrorZ), "LDKCResult_ShutdownScriptDecodeErrorZ");
	*ret_conv = CResult_ShutdownScriptDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptInvalidShutdownScriptZ_ok"))) TS_CResult_ShutdownScriptInvalidShutdownScriptZ_ok(uint32_t o) {
	LDKShutdownScript o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ShutdownScript_clone(&o_conv);
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptInvalidShutdownScriptZ), "LDKCResult_ShutdownScriptInvalidShutdownScriptZ");
	*ret_conv = CResult_ShutdownScriptInvalidShutdownScriptZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptInvalidShutdownScriptZ_err"))) TS_CResult_ShutdownScriptInvalidShutdownScriptZ_err(uint32_t e) {
	LDKInvalidShutdownScript e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = InvalidShutdownScript_clone(&e_conv);
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptInvalidShutdownScriptZ), "LDKCResult_ShutdownScriptInvalidShutdownScriptZ");
	*ret_conv = CResult_ShutdownScriptInvalidShutdownScriptZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ShutdownScriptInvalidShutdownScriptZ_is_ok"))) TS_CResult_ShutdownScriptInvalidShutdownScriptZ_is_ok(uint32_t o) {
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* o_conv = (LDKCResult_ShutdownScriptInvalidShutdownScriptZ*)(o & ~1);
	jboolean ret_val = CResult_ShutdownScriptInvalidShutdownScriptZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ShutdownScriptInvalidShutdownScriptZ_free"))) TS_CResult_ShutdownScriptInvalidShutdownScriptZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ _res_conv = *(LDKCResult_ShutdownScriptInvalidShutdownScriptZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ShutdownScriptInvalidShutdownScriptZ_free(_res_conv);
}

static inline uintptr_t CResult_ShutdownScriptInvalidShutdownScriptZ_clone_ptr(LDKCResult_ShutdownScriptInvalidShutdownScriptZ *NONNULL_PTR arg) {
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptInvalidShutdownScriptZ), "LDKCResult_ShutdownScriptInvalidShutdownScriptZ");
	*ret_conv = CResult_ShutdownScriptInvalidShutdownScriptZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptInvalidShutdownScriptZ_clone_ptr"))) TS_CResult_ShutdownScriptInvalidShutdownScriptZ_clone_ptr(uint32_t arg) {
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* arg_conv = (LDKCResult_ShutdownScriptInvalidShutdownScriptZ*)(arg & ~1);
	uint32_t ret_val = CResult_ShutdownScriptInvalidShutdownScriptZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownScriptInvalidShutdownScriptZ_clone"))) TS_CResult_ShutdownScriptInvalidShutdownScriptZ_clone(uint32_t orig) {
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* orig_conv = (LDKCResult_ShutdownScriptInvalidShutdownScriptZ*)(orig & ~1);
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptInvalidShutdownScriptZ), "LDKCResult_ShutdownScriptInvalidShutdownScriptZ");
	*ret_conv = CResult_ShutdownScriptInvalidShutdownScriptZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHopDecodeErrorZ_ok"))) TS_CResult_RouteHopDecodeErrorZ_ok(uint32_t o) {
	LDKRouteHop o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = RouteHop_clone(&o_conv);
	LDKCResult_RouteHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHopDecodeErrorZ), "LDKCResult_RouteHopDecodeErrorZ");
	*ret_conv = CResult_RouteHopDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHopDecodeErrorZ_err"))) TS_CResult_RouteHopDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_RouteHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHopDecodeErrorZ), "LDKCResult_RouteHopDecodeErrorZ");
	*ret_conv = CResult_RouteHopDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RouteHopDecodeErrorZ_is_ok"))) TS_CResult_RouteHopDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_RouteHopDecodeErrorZ* o_conv = (LDKCResult_RouteHopDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_RouteHopDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RouteHopDecodeErrorZ_free"))) TS_CResult_RouteHopDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RouteHopDecodeErrorZ _res_conv = *(LDKCResult_RouteHopDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RouteHopDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_RouteHopDecodeErrorZ_clone_ptr(LDKCResult_RouteHopDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_RouteHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHopDecodeErrorZ), "LDKCResult_RouteHopDecodeErrorZ");
	*ret_conv = CResult_RouteHopDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHopDecodeErrorZ_clone_ptr"))) TS_CResult_RouteHopDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_RouteHopDecodeErrorZ* arg_conv = (LDKCResult_RouteHopDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_RouteHopDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHopDecodeErrorZ_clone"))) TS_CResult_RouteHopDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_RouteHopDecodeErrorZ* orig_conv = (LDKCResult_RouteHopDecodeErrorZ*)(orig & ~1);
	LDKCResult_RouteHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHopDecodeErrorZ), "LDKCResult_RouteHopDecodeErrorZ");
	*ret_conv = CResult_RouteHopDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_RouteHopZ_free"))) TS_CVec_RouteHopZ_free(uint32_tArray _res) {
	LDKCVec_RouteHopZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKRouteHop), "LDKCVec_RouteHopZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t k = 0; k < _res_constr.datalen; k++) {
		uint32_t _res_conv_10 = _res_vals[k];
		LDKRouteHop _res_conv_10_conv;
		_res_conv_10_conv.inner = (void*)(_res_conv_10 & (~1));
		_res_conv_10_conv.is_owned = (_res_conv_10 & 1) || (_res_conv_10 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_10_conv);
		_res_constr.data[k] = _res_conv_10_conv;
	}
	CVec_RouteHopZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_CVec_RouteHopZZ_free"))) TS_CVec_CVec_RouteHopZZ_free(ptrArray _res) {
	LDKCVec_CVec_RouteHopZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKCVec_RouteHopZ), "LDKCVec_CVec_RouteHopZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_tArray* _res_vals = (void*) _res->elems /* XXX _res leaks */;
	for (size_t m = 0; m < _res_constr.datalen; m++) {
		uint32_tArray _res_conv_12 = _res_vals[m];
		LDKCVec_RouteHopZ _res_conv_12_constr;
		_res_conv_12_constr.datalen = _res_conv_12->arr_len;
		if (_res_conv_12_constr.datalen > 0)
			_res_conv_12_constr.data = MALLOC(_res_conv_12_constr.datalen * sizeof(LDKRouteHop), "LDKCVec_RouteHopZ Elements");
		else
			_res_conv_12_constr.data = NULL;
		uint32_t* _res_conv_12_vals = _res_conv_12->elems /* XXX _res_conv_12 leaks */;
		for (size_t k = 0; k < _res_conv_12_constr.datalen; k++) {
			uint32_t _res_conv_12_conv_10 = _res_conv_12_vals[k];
			LDKRouteHop _res_conv_12_conv_10_conv;
			_res_conv_12_conv_10_conv.inner = (void*)(_res_conv_12_conv_10 & (~1));
			_res_conv_12_conv_10_conv.is_owned = (_res_conv_12_conv_10 & 1) || (_res_conv_12_conv_10 == 0);
			CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_12_conv_10_conv);
			_res_conv_12_constr.data[k] = _res_conv_12_conv_10_conv;
		}
		_res_constr.data[m] = _res_conv_12_constr;
	}
	CVec_CVec_RouteHopZZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_RouteDecodeErrorZ_ok"))) TS_CResult_RouteDecodeErrorZ_ok(uint32_t o) {
	LDKRoute o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Route_clone(&o_conv);
	LDKCResult_RouteDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteDecodeErrorZ), "LDKCResult_RouteDecodeErrorZ");
	*ret_conv = CResult_RouteDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteDecodeErrorZ_err"))) TS_CResult_RouteDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_RouteDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteDecodeErrorZ), "LDKCResult_RouteDecodeErrorZ");
	*ret_conv = CResult_RouteDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RouteDecodeErrorZ_is_ok"))) TS_CResult_RouteDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_RouteDecodeErrorZ* o_conv = (LDKCResult_RouteDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_RouteDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RouteDecodeErrorZ_free"))) TS_CResult_RouteDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RouteDecodeErrorZ _res_conv = *(LDKCResult_RouteDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RouteDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_RouteDecodeErrorZ_clone_ptr(LDKCResult_RouteDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_RouteDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteDecodeErrorZ), "LDKCResult_RouteDecodeErrorZ");
	*ret_conv = CResult_RouteDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RouteDecodeErrorZ_clone_ptr"))) TS_CResult_RouteDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_RouteDecodeErrorZ* arg_conv = (LDKCResult_RouteDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_RouteDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteDecodeErrorZ_clone"))) TS_CResult_RouteDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_RouteDecodeErrorZ* orig_conv = (LDKCResult_RouteDecodeErrorZ*)(orig & ~1);
	LDKCResult_RouteDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteDecodeErrorZ), "LDKCResult_RouteDecodeErrorZ");
	*ret_conv = CResult_RouteDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteParametersDecodeErrorZ_ok"))) TS_CResult_RouteParametersDecodeErrorZ_ok(uint32_t o) {
	LDKRouteParameters o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = RouteParameters_clone(&o_conv);
	LDKCResult_RouteParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteParametersDecodeErrorZ), "LDKCResult_RouteParametersDecodeErrorZ");
	*ret_conv = CResult_RouteParametersDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteParametersDecodeErrorZ_err"))) TS_CResult_RouteParametersDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_RouteParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteParametersDecodeErrorZ), "LDKCResult_RouteParametersDecodeErrorZ");
	*ret_conv = CResult_RouteParametersDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RouteParametersDecodeErrorZ_is_ok"))) TS_CResult_RouteParametersDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_RouteParametersDecodeErrorZ* o_conv = (LDKCResult_RouteParametersDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_RouteParametersDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RouteParametersDecodeErrorZ_free"))) TS_CResult_RouteParametersDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RouteParametersDecodeErrorZ _res_conv = *(LDKCResult_RouteParametersDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RouteParametersDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_RouteParametersDecodeErrorZ_clone_ptr(LDKCResult_RouteParametersDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_RouteParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteParametersDecodeErrorZ), "LDKCResult_RouteParametersDecodeErrorZ");
	*ret_conv = CResult_RouteParametersDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RouteParametersDecodeErrorZ_clone_ptr"))) TS_CResult_RouteParametersDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_RouteParametersDecodeErrorZ* arg_conv = (LDKCResult_RouteParametersDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_RouteParametersDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteParametersDecodeErrorZ_clone"))) TS_CResult_RouteParametersDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_RouteParametersDecodeErrorZ* orig_conv = (LDKCResult_RouteParametersDecodeErrorZ*)(orig & ~1);
	LDKCResult_RouteParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteParametersDecodeErrorZ), "LDKCResult_RouteParametersDecodeErrorZ");
	*ret_conv = CResult_RouteParametersDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_RouteHintZ_free"))) TS_CVec_RouteHintZ_free(uint32_tArray _res) {
	LDKCVec_RouteHintZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKRouteHint), "LDKCVec_RouteHintZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t l = 0; l < _res_constr.datalen; l++) {
		uint32_t _res_conv_11 = _res_vals[l];
		LDKRouteHint _res_conv_11_conv;
		_res_conv_11_conv.inner = (void*)(_res_conv_11 & (~1));
		_res_conv_11_conv.is_owned = (_res_conv_11 & 1) || (_res_conv_11 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_11_conv);
		_res_constr.data[l] = _res_conv_11_conv;
	}
	CVec_RouteHintZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_COption_u64Z_some"))) TS_COption_u64Z_some(int64_t o) {
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = COption_u64Z_some(o);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_u64Z_none"))) TS_COption_u64Z_none() {
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = COption_u64Z_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_u64Z_free"))) TS_COption_u64Z_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_u64Z _res_conv = *(LDKCOption_u64Z*)(_res_ptr);
	FREE((void*)_res);
	COption_u64Z_free(_res_conv);
}

static inline uintptr_t COption_u64Z_clone_ptr(LDKCOption_u64Z *NONNULL_PTR arg) {
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = COption_u64Z_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_u64Z_clone_ptr"))) TS_COption_u64Z_clone_ptr(uint32_t arg) {
	LDKCOption_u64Z* arg_conv = (LDKCOption_u64Z*)arg;
	uint32_t ret_val = COption_u64Z_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_u64Z_clone"))) TS_COption_u64Z_clone(uint32_t orig) {
	LDKCOption_u64Z* orig_conv = (LDKCOption_u64Z*)orig;
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = COption_u64Z_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentParametersDecodeErrorZ_ok"))) TS_CResult_PaymentParametersDecodeErrorZ_ok(uint32_t o) {
	LDKPaymentParameters o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = PaymentParameters_clone(&o_conv);
	LDKCResult_PaymentParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentParametersDecodeErrorZ), "LDKCResult_PaymentParametersDecodeErrorZ");
	*ret_conv = CResult_PaymentParametersDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentParametersDecodeErrorZ_err"))) TS_CResult_PaymentParametersDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_PaymentParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentParametersDecodeErrorZ), "LDKCResult_PaymentParametersDecodeErrorZ");
	*ret_conv = CResult_PaymentParametersDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PaymentParametersDecodeErrorZ_is_ok"))) TS_CResult_PaymentParametersDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_PaymentParametersDecodeErrorZ* o_conv = (LDKCResult_PaymentParametersDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PaymentParametersDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PaymentParametersDecodeErrorZ_free"))) TS_CResult_PaymentParametersDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PaymentParametersDecodeErrorZ _res_conv = *(LDKCResult_PaymentParametersDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PaymentParametersDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PaymentParametersDecodeErrorZ_clone_ptr(LDKCResult_PaymentParametersDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_PaymentParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentParametersDecodeErrorZ), "LDKCResult_PaymentParametersDecodeErrorZ");
	*ret_conv = CResult_PaymentParametersDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentParametersDecodeErrorZ_clone_ptr"))) TS_CResult_PaymentParametersDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PaymentParametersDecodeErrorZ* arg_conv = (LDKCResult_PaymentParametersDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PaymentParametersDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentParametersDecodeErrorZ_clone"))) TS_CResult_PaymentParametersDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_PaymentParametersDecodeErrorZ* orig_conv = (LDKCResult_PaymentParametersDecodeErrorZ*)(orig & ~1);
	LDKCResult_PaymentParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentParametersDecodeErrorZ), "LDKCResult_PaymentParametersDecodeErrorZ");
	*ret_conv = CResult_PaymentParametersDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_RouteHintHopZ_free"))) TS_CVec_RouteHintHopZ_free(uint32_tArray _res) {
	LDKCVec_RouteHintHopZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKRouteHintHop), "LDKCVec_RouteHintHopZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t o = 0; o < _res_constr.datalen; o++) {
		uint32_t _res_conv_14 = _res_vals[o];
		LDKRouteHintHop _res_conv_14_conv;
		_res_conv_14_conv.inner = (void*)(_res_conv_14 & (~1));
		_res_conv_14_conv.is_owned = (_res_conv_14 & 1) || (_res_conv_14 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_14_conv);
		_res_constr.data[o] = _res_conv_14_conv;
	}
	CVec_RouteHintHopZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHintDecodeErrorZ_ok"))) TS_CResult_RouteHintDecodeErrorZ_ok(uint32_t o) {
	LDKRouteHint o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = RouteHint_clone(&o_conv);
	LDKCResult_RouteHintDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintDecodeErrorZ), "LDKCResult_RouteHintDecodeErrorZ");
	*ret_conv = CResult_RouteHintDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHintDecodeErrorZ_err"))) TS_CResult_RouteHintDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_RouteHintDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintDecodeErrorZ), "LDKCResult_RouteHintDecodeErrorZ");
	*ret_conv = CResult_RouteHintDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RouteHintDecodeErrorZ_is_ok"))) TS_CResult_RouteHintDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_RouteHintDecodeErrorZ* o_conv = (LDKCResult_RouteHintDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_RouteHintDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RouteHintDecodeErrorZ_free"))) TS_CResult_RouteHintDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RouteHintDecodeErrorZ _res_conv = *(LDKCResult_RouteHintDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RouteHintDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_RouteHintDecodeErrorZ_clone_ptr(LDKCResult_RouteHintDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_RouteHintDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintDecodeErrorZ), "LDKCResult_RouteHintDecodeErrorZ");
	*ret_conv = CResult_RouteHintDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHintDecodeErrorZ_clone_ptr"))) TS_CResult_RouteHintDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_RouteHintDecodeErrorZ* arg_conv = (LDKCResult_RouteHintDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_RouteHintDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHintDecodeErrorZ_clone"))) TS_CResult_RouteHintDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_RouteHintDecodeErrorZ* orig_conv = (LDKCResult_RouteHintDecodeErrorZ*)(orig & ~1);
	LDKCResult_RouteHintDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintDecodeErrorZ), "LDKCResult_RouteHintDecodeErrorZ");
	*ret_conv = CResult_RouteHintDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHintHopDecodeErrorZ_ok"))) TS_CResult_RouteHintHopDecodeErrorZ_ok(uint32_t o) {
	LDKRouteHintHop o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = RouteHintHop_clone(&o_conv);
	LDKCResult_RouteHintHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintHopDecodeErrorZ), "LDKCResult_RouteHintHopDecodeErrorZ");
	*ret_conv = CResult_RouteHintHopDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHintHopDecodeErrorZ_err"))) TS_CResult_RouteHintHopDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_RouteHintHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintHopDecodeErrorZ), "LDKCResult_RouteHintHopDecodeErrorZ");
	*ret_conv = CResult_RouteHintHopDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RouteHintHopDecodeErrorZ_is_ok"))) TS_CResult_RouteHintHopDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_RouteHintHopDecodeErrorZ* o_conv = (LDKCResult_RouteHintHopDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_RouteHintHopDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RouteHintHopDecodeErrorZ_free"))) TS_CResult_RouteHintHopDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RouteHintHopDecodeErrorZ _res_conv = *(LDKCResult_RouteHintHopDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RouteHintHopDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_RouteHintHopDecodeErrorZ_clone_ptr(LDKCResult_RouteHintHopDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_RouteHintHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintHopDecodeErrorZ), "LDKCResult_RouteHintHopDecodeErrorZ");
	*ret_conv = CResult_RouteHintHopDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RouteHintHopDecodeErrorZ_clone_ptr"))) TS_CResult_RouteHintHopDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_RouteHintHopDecodeErrorZ* arg_conv = (LDKCResult_RouteHintHopDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_RouteHintHopDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteHintHopDecodeErrorZ_clone"))) TS_CResult_RouteHintHopDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_RouteHintHopDecodeErrorZ* orig_conv = (LDKCResult_RouteHintHopDecodeErrorZ*)(orig & ~1);
	LDKCResult_RouteHintHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintHopDecodeErrorZ), "LDKCResult_RouteHintHopDecodeErrorZ");
	*ret_conv = CResult_RouteHintHopDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_ChannelDetailsZ_free"))) TS_CVec_ChannelDetailsZ_free(uint32_tArray _res) {
	LDKCVec_ChannelDetailsZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKChannelDetails), "LDKCVec_ChannelDetailsZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t q = 0; q < _res_constr.datalen; q++) {
		uint32_t _res_conv_16 = _res_vals[q];
		LDKChannelDetails _res_conv_16_conv;
		_res_conv_16_conv.inner = (void*)(_res_conv_16 & (~1));
		_res_conv_16_conv.is_owned = (_res_conv_16 & 1) || (_res_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_16_conv);
		_res_constr.data[q] = _res_conv_16_conv;
	}
	CVec_ChannelDetailsZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_RouteLightningErrorZ_ok"))) TS_CResult_RouteLightningErrorZ_ok(uint32_t o) {
	LDKRoute o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Route_clone(&o_conv);
	LDKCResult_RouteLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteLightningErrorZ), "LDKCResult_RouteLightningErrorZ");
	*ret_conv = CResult_RouteLightningErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteLightningErrorZ_err"))) TS_CResult_RouteLightningErrorZ_err(uint32_t e) {
	LDKLightningError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = LightningError_clone(&e_conv);
	LDKCResult_RouteLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteLightningErrorZ), "LDKCResult_RouteLightningErrorZ");
	*ret_conv = CResult_RouteLightningErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RouteLightningErrorZ_is_ok"))) TS_CResult_RouteLightningErrorZ_is_ok(uint32_t o) {
	LDKCResult_RouteLightningErrorZ* o_conv = (LDKCResult_RouteLightningErrorZ*)(o & ~1);
	jboolean ret_val = CResult_RouteLightningErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RouteLightningErrorZ_free"))) TS_CResult_RouteLightningErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RouteLightningErrorZ _res_conv = *(LDKCResult_RouteLightningErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RouteLightningErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_RouteLightningErrorZ_clone_ptr(LDKCResult_RouteLightningErrorZ *NONNULL_PTR arg) {
	LDKCResult_RouteLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteLightningErrorZ), "LDKCResult_RouteLightningErrorZ");
	*ret_conv = CResult_RouteLightningErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RouteLightningErrorZ_clone_ptr"))) TS_CResult_RouteLightningErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_RouteLightningErrorZ* arg_conv = (LDKCResult_RouteLightningErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_RouteLightningErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RouteLightningErrorZ_clone"))) TS_CResult_RouteLightningErrorZ_clone(uint32_t orig) {
	LDKCResult_RouteLightningErrorZ* orig_conv = (LDKCResult_RouteLightningErrorZ*)(orig & ~1);
	LDKCResult_RouteLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteLightningErrorZ), "LDKCResult_RouteLightningErrorZ");
	*ret_conv = CResult_RouteLightningErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TxOutAccessErrorZ_ok"))) TS_CResult_TxOutAccessErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKTxOut o_conv = *(LDKTxOut*)(o_ptr);
	o_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)o) & ~1));
	LDKCResult_TxOutAccessErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxOutAccessErrorZ), "LDKCResult_TxOutAccessErrorZ");
	*ret_conv = CResult_TxOutAccessErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TxOutAccessErrorZ_err"))) TS_CResult_TxOutAccessErrorZ_err(uint32_t e) {
	LDKAccessError e_conv = LDKAccessError_from_js(e);
	LDKCResult_TxOutAccessErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxOutAccessErrorZ), "LDKCResult_TxOutAccessErrorZ");
	*ret_conv = CResult_TxOutAccessErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_TxOutAccessErrorZ_is_ok"))) TS_CResult_TxOutAccessErrorZ_is_ok(uint32_t o) {
	LDKCResult_TxOutAccessErrorZ* o_conv = (LDKCResult_TxOutAccessErrorZ*)(o & ~1);
	jboolean ret_val = CResult_TxOutAccessErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_TxOutAccessErrorZ_free"))) TS_CResult_TxOutAccessErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_TxOutAccessErrorZ _res_conv = *(LDKCResult_TxOutAccessErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_TxOutAccessErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_TxOutAccessErrorZ_clone_ptr(LDKCResult_TxOutAccessErrorZ *NONNULL_PTR arg) {
	LDKCResult_TxOutAccessErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxOutAccessErrorZ), "LDKCResult_TxOutAccessErrorZ");
	*ret_conv = CResult_TxOutAccessErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_TxOutAccessErrorZ_clone_ptr"))) TS_CResult_TxOutAccessErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_TxOutAccessErrorZ* arg_conv = (LDKCResult_TxOutAccessErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_TxOutAccessErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_TxOutAccessErrorZ_clone"))) TS_CResult_TxOutAccessErrorZ_clone(uint32_t orig) {
	LDKCResult_TxOutAccessErrorZ* orig_conv = (LDKCResult_TxOutAccessErrorZ*)(orig & ~1);
	LDKCResult_TxOutAccessErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxOutAccessErrorZ), "LDKCResult_TxOutAccessErrorZ");
	*ret_conv = CResult_TxOutAccessErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

static inline uintptr_t C2Tuple_usizeTransactionZ_clone_ptr(LDKC2Tuple_usizeTransactionZ *NONNULL_PTR arg) {
	LDKC2Tuple_usizeTransactionZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_usizeTransactionZ), "LDKC2Tuple_usizeTransactionZ");
	*ret_conv = C2Tuple_usizeTransactionZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_usizeTransactionZ_clone_ptr"))) TS_C2Tuple_usizeTransactionZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_usizeTransactionZ* arg_conv = (LDKC2Tuple_usizeTransactionZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_usizeTransactionZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_usizeTransactionZ_clone"))) TS_C2Tuple_usizeTransactionZ_clone(uint32_t orig) {
	LDKC2Tuple_usizeTransactionZ* orig_conv = (LDKC2Tuple_usizeTransactionZ*)(orig & ~1);
	LDKC2Tuple_usizeTransactionZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_usizeTransactionZ), "LDKC2Tuple_usizeTransactionZ");
	*ret_conv = C2Tuple_usizeTransactionZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_usizeTransactionZ_new"))) TS_C2Tuple_usizeTransactionZ_new(uint32_t a, int8_tArray b) {
	LDKTransaction b_ref;
	b_ref.datalen = b->arr_len;
	b_ref.data = MALLOC(b_ref.datalen, "LDKTransaction Bytes");
	memcpy(b_ref.data, b->elems, b_ref.datalen); FREE(b);
	b_ref.data_is_owned = true;
	LDKC2Tuple_usizeTransactionZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_usizeTransactionZ), "LDKC2Tuple_usizeTransactionZ");
	*ret_conv = C2Tuple_usizeTransactionZ_new(a, b_ref);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_usizeTransactionZ_free"))) TS_C2Tuple_usizeTransactionZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_usizeTransactionZ _res_conv = *(LDKC2Tuple_usizeTransactionZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_usizeTransactionZ_free(_res_conv);
}

void  __attribute__((export_name("TS_CVec_C2Tuple_usizeTransactionZZ_free"))) TS_CVec_C2Tuple_usizeTransactionZZ_free(uint32_tArray _res) {
	LDKCVec_C2Tuple_usizeTransactionZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKC2Tuple_usizeTransactionZ), "LDKCVec_C2Tuple_usizeTransactionZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t c = 0; c < _res_constr.datalen; c++) {
		uint32_t _res_conv_28 = _res_vals[c];
		void* _res_conv_28_ptr = (void*)(((uintptr_t)_res_conv_28) & ~1);
		CHECK_ACCESS(_res_conv_28_ptr);
		LDKC2Tuple_usizeTransactionZ _res_conv_28_conv = *(LDKC2Tuple_usizeTransactionZ*)(_res_conv_28_ptr);
		FREE((void*)_res_conv_28);
		_res_constr.data[c] = _res_conv_28_conv;
	}
	CVec_C2Tuple_usizeTransactionZZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_TxidZ_free"))) TS_CVec_TxidZ_free(ptrArray _res) {
	LDKCVec_TxidZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKThirtyTwoBytes), "LDKCVec_TxidZ Elements");
	else
		_res_constr.data = NULL;
	int8_tArray* _res_vals = (void*) _res->elems /* XXX _res leaks */;
	for (size_t m = 0; m < _res_constr.datalen; m++) {
		int8_tArray _res_conv_12 = _res_vals[m];
		LDKThirtyTwoBytes _res_conv_12_ref;
		CHECK(_res_conv_12->arr_len == 32);
		memcpy(_res_conv_12_ref.data, _res_conv_12->elems, 32); FREE(_res_conv_12);
		_res_constr.data[m] = _res_conv_12_ref;
	}
	CVec_TxidZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_NoneChannelMonitorUpdateErrZ_ok"))) TS_CResult_NoneChannelMonitorUpdateErrZ_ok() {
	LDKCResult_NoneChannelMonitorUpdateErrZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneChannelMonitorUpdateErrZ), "LDKCResult_NoneChannelMonitorUpdateErrZ");
	*ret_conv = CResult_NoneChannelMonitorUpdateErrZ_ok();
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneChannelMonitorUpdateErrZ_err"))) TS_CResult_NoneChannelMonitorUpdateErrZ_err(uint32_t e) {
	LDKChannelMonitorUpdateErr e_conv = LDKChannelMonitorUpdateErr_from_js(e);
	LDKCResult_NoneChannelMonitorUpdateErrZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneChannelMonitorUpdateErrZ), "LDKCResult_NoneChannelMonitorUpdateErrZ");
	*ret_conv = CResult_NoneChannelMonitorUpdateErrZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NoneChannelMonitorUpdateErrZ_is_ok"))) TS_CResult_NoneChannelMonitorUpdateErrZ_is_ok(uint32_t o) {
	LDKCResult_NoneChannelMonitorUpdateErrZ* o_conv = (LDKCResult_NoneChannelMonitorUpdateErrZ*)(o & ~1);
	jboolean ret_val = CResult_NoneChannelMonitorUpdateErrZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NoneChannelMonitorUpdateErrZ_free"))) TS_CResult_NoneChannelMonitorUpdateErrZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NoneChannelMonitorUpdateErrZ _res_conv = *(LDKCResult_NoneChannelMonitorUpdateErrZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NoneChannelMonitorUpdateErrZ_free(_res_conv);
}

static inline uintptr_t CResult_NoneChannelMonitorUpdateErrZ_clone_ptr(LDKCResult_NoneChannelMonitorUpdateErrZ *NONNULL_PTR arg) {
	LDKCResult_NoneChannelMonitorUpdateErrZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneChannelMonitorUpdateErrZ), "LDKCResult_NoneChannelMonitorUpdateErrZ");
	*ret_conv = CResult_NoneChannelMonitorUpdateErrZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NoneChannelMonitorUpdateErrZ_clone_ptr"))) TS_CResult_NoneChannelMonitorUpdateErrZ_clone_ptr(uint32_t arg) {
	LDKCResult_NoneChannelMonitorUpdateErrZ* arg_conv = (LDKCResult_NoneChannelMonitorUpdateErrZ*)(arg & ~1);
	uint32_t ret_val = CResult_NoneChannelMonitorUpdateErrZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneChannelMonitorUpdateErrZ_clone"))) TS_CResult_NoneChannelMonitorUpdateErrZ_clone(uint32_t orig) {
	LDKCResult_NoneChannelMonitorUpdateErrZ* orig_conv = (LDKCResult_NoneChannelMonitorUpdateErrZ*)(orig & ~1);
	LDKCResult_NoneChannelMonitorUpdateErrZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneChannelMonitorUpdateErrZ), "LDKCResult_NoneChannelMonitorUpdateErrZ");
	*ret_conv = CResult_NoneChannelMonitorUpdateErrZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_MonitorEventZ_free"))) TS_CVec_MonitorEventZ_free(uint32_tArray _res) {
	LDKCVec_MonitorEventZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKMonitorEvent), "LDKCVec_MonitorEventZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t o = 0; o < _res_constr.datalen; o++) {
		uint32_t _res_conv_14 = _res_vals[o];
		void* _res_conv_14_ptr = (void*)(((uintptr_t)_res_conv_14) & ~1);
		CHECK_ACCESS(_res_conv_14_ptr);
		LDKMonitorEvent _res_conv_14_conv = *(LDKMonitorEvent*)(_res_conv_14_ptr);
		FREE((void*)_res_conv_14);
		_res_constr.data[o] = _res_conv_14_conv;
	}
	CVec_MonitorEventZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_COption_C2Tuple_usizeTransactionZZ_some"))) TS_COption_C2Tuple_usizeTransactionZZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKC2Tuple_usizeTransactionZ o_conv = *(LDKC2Tuple_usizeTransactionZ*)(o_ptr);
	o_conv = C2Tuple_usizeTransactionZ_clone((LDKC2Tuple_usizeTransactionZ*)(((uintptr_t)o) & ~1));
	LDKCOption_C2Tuple_usizeTransactionZZ *ret_copy = MALLOC(sizeof(LDKCOption_C2Tuple_usizeTransactionZZ), "LDKCOption_C2Tuple_usizeTransactionZZ");
	*ret_copy = COption_C2Tuple_usizeTransactionZZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_C2Tuple_usizeTransactionZZ_none"))) TS_COption_C2Tuple_usizeTransactionZZ_none() {
	LDKCOption_C2Tuple_usizeTransactionZZ *ret_copy = MALLOC(sizeof(LDKCOption_C2Tuple_usizeTransactionZZ), "LDKCOption_C2Tuple_usizeTransactionZZ");
	*ret_copy = COption_C2Tuple_usizeTransactionZZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_C2Tuple_usizeTransactionZZ_free"))) TS_COption_C2Tuple_usizeTransactionZZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_C2Tuple_usizeTransactionZZ _res_conv = *(LDKCOption_C2Tuple_usizeTransactionZZ*)(_res_ptr);
	FREE((void*)_res);
	COption_C2Tuple_usizeTransactionZZ_free(_res_conv);
}

static inline uintptr_t COption_C2Tuple_usizeTransactionZZ_clone_ptr(LDKCOption_C2Tuple_usizeTransactionZZ *NONNULL_PTR arg) {
	LDKCOption_C2Tuple_usizeTransactionZZ *ret_copy = MALLOC(sizeof(LDKCOption_C2Tuple_usizeTransactionZZ), "LDKCOption_C2Tuple_usizeTransactionZZ");
	*ret_copy = COption_C2Tuple_usizeTransactionZZ_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_C2Tuple_usizeTransactionZZ_clone_ptr"))) TS_COption_C2Tuple_usizeTransactionZZ_clone_ptr(uint32_t arg) {
	LDKCOption_C2Tuple_usizeTransactionZZ* arg_conv = (LDKCOption_C2Tuple_usizeTransactionZZ*)arg;
	uint32_t ret_val = COption_C2Tuple_usizeTransactionZZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_C2Tuple_usizeTransactionZZ_clone"))) TS_COption_C2Tuple_usizeTransactionZZ_clone(uint32_t orig) {
	LDKCOption_C2Tuple_usizeTransactionZZ* orig_conv = (LDKCOption_C2Tuple_usizeTransactionZZ*)orig;
	LDKCOption_C2Tuple_usizeTransactionZZ *ret_copy = MALLOC(sizeof(LDKCOption_C2Tuple_usizeTransactionZZ), "LDKCOption_C2Tuple_usizeTransactionZZ");
	*ret_copy = COption_C2Tuple_usizeTransactionZZ_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_ClosureReasonZ_some"))) TS_COption_ClosureReasonZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKClosureReason o_conv = *(LDKClosureReason*)(o_ptr);
	o_conv = ClosureReason_clone((LDKClosureReason*)(((uintptr_t)o) & ~1));
	LDKCOption_ClosureReasonZ *ret_copy = MALLOC(sizeof(LDKCOption_ClosureReasonZ), "LDKCOption_ClosureReasonZ");
	*ret_copy = COption_ClosureReasonZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_ClosureReasonZ_none"))) TS_COption_ClosureReasonZ_none() {
	LDKCOption_ClosureReasonZ *ret_copy = MALLOC(sizeof(LDKCOption_ClosureReasonZ), "LDKCOption_ClosureReasonZ");
	*ret_copy = COption_ClosureReasonZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_ClosureReasonZ_free"))) TS_COption_ClosureReasonZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_ClosureReasonZ _res_conv = *(LDKCOption_ClosureReasonZ*)(_res_ptr);
	FREE((void*)_res);
	COption_ClosureReasonZ_free(_res_conv);
}

static inline uintptr_t COption_ClosureReasonZ_clone_ptr(LDKCOption_ClosureReasonZ *NONNULL_PTR arg) {
	LDKCOption_ClosureReasonZ *ret_copy = MALLOC(sizeof(LDKCOption_ClosureReasonZ), "LDKCOption_ClosureReasonZ");
	*ret_copy = COption_ClosureReasonZ_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_ClosureReasonZ_clone_ptr"))) TS_COption_ClosureReasonZ_clone_ptr(uint32_t arg) {
	LDKCOption_ClosureReasonZ* arg_conv = (LDKCOption_ClosureReasonZ*)arg;
	uint32_t ret_val = COption_ClosureReasonZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_ClosureReasonZ_clone"))) TS_COption_ClosureReasonZ_clone(uint32_t orig) {
	LDKCOption_ClosureReasonZ* orig_conv = (LDKCOption_ClosureReasonZ*)orig;
	LDKCOption_ClosureReasonZ *ret_copy = MALLOC(sizeof(LDKCOption_ClosureReasonZ), "LDKCOption_ClosureReasonZ");
	*ret_copy = COption_ClosureReasonZ_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_ClosureReasonZDecodeErrorZ_ok"))) TS_CResult_COption_ClosureReasonZDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKCOption_ClosureReasonZ o_conv = *(LDKCOption_ClosureReasonZ*)(o_ptr);
	o_conv = COption_ClosureReasonZ_clone((LDKCOption_ClosureReasonZ*)(((uintptr_t)o) & ~1));
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_ClosureReasonZDecodeErrorZ), "LDKCResult_COption_ClosureReasonZDecodeErrorZ");
	*ret_conv = CResult_COption_ClosureReasonZDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_ClosureReasonZDecodeErrorZ_err"))) TS_CResult_COption_ClosureReasonZDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_ClosureReasonZDecodeErrorZ), "LDKCResult_COption_ClosureReasonZDecodeErrorZ");
	*ret_conv = CResult_COption_ClosureReasonZDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_COption_ClosureReasonZDecodeErrorZ_is_ok"))) TS_CResult_COption_ClosureReasonZDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* o_conv = (LDKCResult_COption_ClosureReasonZDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_COption_ClosureReasonZDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_COption_ClosureReasonZDecodeErrorZ_free"))) TS_CResult_COption_ClosureReasonZDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_COption_ClosureReasonZDecodeErrorZ _res_conv = *(LDKCResult_COption_ClosureReasonZDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_COption_ClosureReasonZDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_COption_ClosureReasonZDecodeErrorZ_clone_ptr(LDKCResult_COption_ClosureReasonZDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_ClosureReasonZDecodeErrorZ), "LDKCResult_COption_ClosureReasonZDecodeErrorZ");
	*ret_conv = CResult_COption_ClosureReasonZDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_COption_ClosureReasonZDecodeErrorZ_clone_ptr"))) TS_CResult_COption_ClosureReasonZDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* arg_conv = (LDKCResult_COption_ClosureReasonZDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_COption_ClosureReasonZDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_ClosureReasonZDecodeErrorZ_clone"))) TS_CResult_COption_ClosureReasonZDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* orig_conv = (LDKCResult_COption_ClosureReasonZDecodeErrorZ*)(orig & ~1);
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_ClosureReasonZDecodeErrorZ), "LDKCResult_COption_ClosureReasonZDecodeErrorZ");
	*ret_conv = CResult_COption_ClosureReasonZDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_NetworkUpdateZ_some"))) TS_COption_NetworkUpdateZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKNetworkUpdate o_conv = *(LDKNetworkUpdate*)(o_ptr);
	o_conv = NetworkUpdate_clone((LDKNetworkUpdate*)(((uintptr_t)o) & ~1));
	LDKCOption_NetworkUpdateZ *ret_copy = MALLOC(sizeof(LDKCOption_NetworkUpdateZ), "LDKCOption_NetworkUpdateZ");
	*ret_copy = COption_NetworkUpdateZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_NetworkUpdateZ_none"))) TS_COption_NetworkUpdateZ_none() {
	LDKCOption_NetworkUpdateZ *ret_copy = MALLOC(sizeof(LDKCOption_NetworkUpdateZ), "LDKCOption_NetworkUpdateZ");
	*ret_copy = COption_NetworkUpdateZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_NetworkUpdateZ_free"))) TS_COption_NetworkUpdateZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_NetworkUpdateZ _res_conv = *(LDKCOption_NetworkUpdateZ*)(_res_ptr);
	FREE((void*)_res);
	COption_NetworkUpdateZ_free(_res_conv);
}

static inline uintptr_t COption_NetworkUpdateZ_clone_ptr(LDKCOption_NetworkUpdateZ *NONNULL_PTR arg) {
	LDKCOption_NetworkUpdateZ *ret_copy = MALLOC(sizeof(LDKCOption_NetworkUpdateZ), "LDKCOption_NetworkUpdateZ");
	*ret_copy = COption_NetworkUpdateZ_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_NetworkUpdateZ_clone_ptr"))) TS_COption_NetworkUpdateZ_clone_ptr(uint32_t arg) {
	LDKCOption_NetworkUpdateZ* arg_conv = (LDKCOption_NetworkUpdateZ*)arg;
	uint32_t ret_val = COption_NetworkUpdateZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_NetworkUpdateZ_clone"))) TS_COption_NetworkUpdateZ_clone(uint32_t orig) {
	LDKCOption_NetworkUpdateZ* orig_conv = (LDKCOption_NetworkUpdateZ*)orig;
	LDKCOption_NetworkUpdateZ *ret_copy = MALLOC(sizeof(LDKCOption_NetworkUpdateZ), "LDKCOption_NetworkUpdateZ");
	*ret_copy = COption_NetworkUpdateZ_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_CVec_SpendableOutputDescriptorZ_free"))) TS_CVec_SpendableOutputDescriptorZ_free(uint32_tArray _res) {
	LDKCVec_SpendableOutputDescriptorZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKSpendableOutputDescriptor), "LDKCVec_SpendableOutputDescriptorZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t b = 0; b < _res_constr.datalen; b++) {
		uint32_t _res_conv_27 = _res_vals[b];
		void* _res_conv_27_ptr = (void*)(((uintptr_t)_res_conv_27) & ~1);
		CHECK_ACCESS(_res_conv_27_ptr);
		LDKSpendableOutputDescriptor _res_conv_27_conv = *(LDKSpendableOutputDescriptor*)(_res_conv_27_ptr);
		FREE((void*)_res_conv_27);
		_res_constr.data[b] = _res_conv_27_conv;
	}
	CVec_SpendableOutputDescriptorZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_COption_EventZ_some"))) TS_COption_EventZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKEvent o_conv = *(LDKEvent*)(o_ptr);
	o_conv = Event_clone((LDKEvent*)(((uintptr_t)o) & ~1));
	LDKCOption_EventZ *ret_copy = MALLOC(sizeof(LDKCOption_EventZ), "LDKCOption_EventZ");
	*ret_copy = COption_EventZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_EventZ_none"))) TS_COption_EventZ_none() {
	LDKCOption_EventZ *ret_copy = MALLOC(sizeof(LDKCOption_EventZ), "LDKCOption_EventZ");
	*ret_copy = COption_EventZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_EventZ_free"))) TS_COption_EventZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_EventZ _res_conv = *(LDKCOption_EventZ*)(_res_ptr);
	FREE((void*)_res);
	COption_EventZ_free(_res_conv);
}

static inline uintptr_t COption_EventZ_clone_ptr(LDKCOption_EventZ *NONNULL_PTR arg) {
	LDKCOption_EventZ *ret_copy = MALLOC(sizeof(LDKCOption_EventZ), "LDKCOption_EventZ");
	*ret_copy = COption_EventZ_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_EventZ_clone_ptr"))) TS_COption_EventZ_clone_ptr(uint32_t arg) {
	LDKCOption_EventZ* arg_conv = (LDKCOption_EventZ*)arg;
	uint32_t ret_val = COption_EventZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_EventZ_clone"))) TS_COption_EventZ_clone(uint32_t orig) {
	LDKCOption_EventZ* orig_conv = (LDKCOption_EventZ*)orig;
	LDKCOption_EventZ *ret_copy = MALLOC(sizeof(LDKCOption_EventZ), "LDKCOption_EventZ");
	*ret_copy = COption_EventZ_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_EventZDecodeErrorZ_ok"))) TS_CResult_COption_EventZDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKCOption_EventZ o_conv = *(LDKCOption_EventZ*)(o_ptr);
	o_conv = COption_EventZ_clone((LDKCOption_EventZ*)(((uintptr_t)o) & ~1));
	LDKCResult_COption_EventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_EventZDecodeErrorZ), "LDKCResult_COption_EventZDecodeErrorZ");
	*ret_conv = CResult_COption_EventZDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_EventZDecodeErrorZ_err"))) TS_CResult_COption_EventZDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_COption_EventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_EventZDecodeErrorZ), "LDKCResult_COption_EventZDecodeErrorZ");
	*ret_conv = CResult_COption_EventZDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_COption_EventZDecodeErrorZ_is_ok"))) TS_CResult_COption_EventZDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_COption_EventZDecodeErrorZ* o_conv = (LDKCResult_COption_EventZDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_COption_EventZDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_COption_EventZDecodeErrorZ_free"))) TS_CResult_COption_EventZDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_COption_EventZDecodeErrorZ _res_conv = *(LDKCResult_COption_EventZDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_COption_EventZDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_COption_EventZDecodeErrorZ_clone_ptr(LDKCResult_COption_EventZDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_COption_EventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_EventZDecodeErrorZ), "LDKCResult_COption_EventZDecodeErrorZ");
	*ret_conv = CResult_COption_EventZDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_COption_EventZDecodeErrorZ_clone_ptr"))) TS_CResult_COption_EventZDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_COption_EventZDecodeErrorZ* arg_conv = (LDKCResult_COption_EventZDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_COption_EventZDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_EventZDecodeErrorZ_clone"))) TS_CResult_COption_EventZDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_COption_EventZDecodeErrorZ* orig_conv = (LDKCResult_COption_EventZDecodeErrorZ*)(orig & ~1);
	LDKCResult_COption_EventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_EventZDecodeErrorZ), "LDKCResult_COption_EventZDecodeErrorZ");
	*ret_conv = CResult_COption_EventZDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_MessageSendEventZ_free"))) TS_CVec_MessageSendEventZ_free(uint32_tArray _res) {
	LDKCVec_MessageSendEventZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKMessageSendEvent), "LDKCVec_MessageSendEventZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t s = 0; s < _res_constr.datalen; s++) {
		uint32_t _res_conv_18 = _res_vals[s];
		void* _res_conv_18_ptr = (void*)(((uintptr_t)_res_conv_18) & ~1);
		CHECK_ACCESS(_res_conv_18_ptr);
		LDKMessageSendEvent _res_conv_18_conv = *(LDKMessageSendEvent*)(_res_conv_18_ptr);
		FREE((void*)_res_conv_18);
		_res_constr.data[s] = _res_conv_18_conv;
	}
	CVec_MessageSendEventZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_FixedPenaltyScorerDecodeErrorZ_ok"))) TS_CResult_FixedPenaltyScorerDecodeErrorZ_ok(uint32_t o) {
	LDKFixedPenaltyScorer o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = FixedPenaltyScorer_clone(&o_conv);
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FixedPenaltyScorerDecodeErrorZ), "LDKCResult_FixedPenaltyScorerDecodeErrorZ");
	*ret_conv = CResult_FixedPenaltyScorerDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_FixedPenaltyScorerDecodeErrorZ_err"))) TS_CResult_FixedPenaltyScorerDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FixedPenaltyScorerDecodeErrorZ), "LDKCResult_FixedPenaltyScorerDecodeErrorZ");
	*ret_conv = CResult_FixedPenaltyScorerDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_FixedPenaltyScorerDecodeErrorZ_is_ok"))) TS_CResult_FixedPenaltyScorerDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* o_conv = (LDKCResult_FixedPenaltyScorerDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_FixedPenaltyScorerDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_FixedPenaltyScorerDecodeErrorZ_free"))) TS_CResult_FixedPenaltyScorerDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_FixedPenaltyScorerDecodeErrorZ _res_conv = *(LDKCResult_FixedPenaltyScorerDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_FixedPenaltyScorerDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_FixedPenaltyScorerDecodeErrorZ_clone_ptr(LDKCResult_FixedPenaltyScorerDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FixedPenaltyScorerDecodeErrorZ), "LDKCResult_FixedPenaltyScorerDecodeErrorZ");
	*ret_conv = CResult_FixedPenaltyScorerDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_FixedPenaltyScorerDecodeErrorZ_clone_ptr"))) TS_CResult_FixedPenaltyScorerDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* arg_conv = (LDKCResult_FixedPenaltyScorerDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_FixedPenaltyScorerDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_FixedPenaltyScorerDecodeErrorZ_clone"))) TS_CResult_FixedPenaltyScorerDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* orig_conv = (LDKCResult_FixedPenaltyScorerDecodeErrorZ*)(orig & ~1);
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FixedPenaltyScorerDecodeErrorZ), "LDKCResult_FixedPenaltyScorerDecodeErrorZ");
	*ret_conv = CResult_FixedPenaltyScorerDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ScoringParametersDecodeErrorZ_ok"))) TS_CResult_ScoringParametersDecodeErrorZ_ok(uint32_t o) {
	LDKScoringParameters o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ScoringParameters_clone(&o_conv);
	LDKCResult_ScoringParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ScoringParametersDecodeErrorZ), "LDKCResult_ScoringParametersDecodeErrorZ");
	*ret_conv = CResult_ScoringParametersDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ScoringParametersDecodeErrorZ_err"))) TS_CResult_ScoringParametersDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ScoringParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ScoringParametersDecodeErrorZ), "LDKCResult_ScoringParametersDecodeErrorZ");
	*ret_conv = CResult_ScoringParametersDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ScoringParametersDecodeErrorZ_is_ok"))) TS_CResult_ScoringParametersDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ScoringParametersDecodeErrorZ* o_conv = (LDKCResult_ScoringParametersDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ScoringParametersDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ScoringParametersDecodeErrorZ_free"))) TS_CResult_ScoringParametersDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ScoringParametersDecodeErrorZ _res_conv = *(LDKCResult_ScoringParametersDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ScoringParametersDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ScoringParametersDecodeErrorZ_clone_ptr(LDKCResult_ScoringParametersDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ScoringParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ScoringParametersDecodeErrorZ), "LDKCResult_ScoringParametersDecodeErrorZ");
	*ret_conv = CResult_ScoringParametersDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ScoringParametersDecodeErrorZ_clone_ptr"))) TS_CResult_ScoringParametersDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ScoringParametersDecodeErrorZ* arg_conv = (LDKCResult_ScoringParametersDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ScoringParametersDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ScoringParametersDecodeErrorZ_clone"))) TS_CResult_ScoringParametersDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ScoringParametersDecodeErrorZ* orig_conv = (LDKCResult_ScoringParametersDecodeErrorZ*)(orig & ~1);
	LDKCResult_ScoringParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ScoringParametersDecodeErrorZ), "LDKCResult_ScoringParametersDecodeErrorZ");
	*ret_conv = CResult_ScoringParametersDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ScorerDecodeErrorZ_ok"))) TS_CResult_ScorerDecodeErrorZ_ok(uint32_t o) {
	LDKScorer o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	// WARNING: we need a move here but no clone is available for LDKScorer
	LDKCResult_ScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ScorerDecodeErrorZ), "LDKCResult_ScorerDecodeErrorZ");
	*ret_conv = CResult_ScorerDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ScorerDecodeErrorZ_err"))) TS_CResult_ScorerDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ScorerDecodeErrorZ), "LDKCResult_ScorerDecodeErrorZ");
	*ret_conv = CResult_ScorerDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ScorerDecodeErrorZ_is_ok"))) TS_CResult_ScorerDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ScorerDecodeErrorZ* o_conv = (LDKCResult_ScorerDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ScorerDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ScorerDecodeErrorZ_free"))) TS_CResult_ScorerDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ScorerDecodeErrorZ _res_conv = *(LDKCResult_ScorerDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ScorerDecodeErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_ProbabilisticScorerDecodeErrorZ_ok"))) TS_CResult_ProbabilisticScorerDecodeErrorZ_ok(uint32_t o) {
	LDKProbabilisticScorer o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	// WARNING: we need a move here but no clone is available for LDKProbabilisticScorer
	LDKCResult_ProbabilisticScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ProbabilisticScorerDecodeErrorZ), "LDKCResult_ProbabilisticScorerDecodeErrorZ");
	*ret_conv = CResult_ProbabilisticScorerDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ProbabilisticScorerDecodeErrorZ_err"))) TS_CResult_ProbabilisticScorerDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ProbabilisticScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ProbabilisticScorerDecodeErrorZ), "LDKCResult_ProbabilisticScorerDecodeErrorZ");
	*ret_conv = CResult_ProbabilisticScorerDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ProbabilisticScorerDecodeErrorZ_is_ok"))) TS_CResult_ProbabilisticScorerDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ProbabilisticScorerDecodeErrorZ* o_conv = (LDKCResult_ProbabilisticScorerDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ProbabilisticScorerDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ProbabilisticScorerDecodeErrorZ_free"))) TS_CResult_ProbabilisticScorerDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ProbabilisticScorerDecodeErrorZ _res_conv = *(LDKCResult_ProbabilisticScorerDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ProbabilisticScorerDecodeErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_InitFeaturesDecodeErrorZ_ok"))) TS_CResult_InitFeaturesDecodeErrorZ_ok(uint32_t o) {
	LDKInitFeatures o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = InitFeatures_clone(&o_conv);
	LDKCResult_InitFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InitFeaturesDecodeErrorZ), "LDKCResult_InitFeaturesDecodeErrorZ");
	*ret_conv = CResult_InitFeaturesDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InitFeaturesDecodeErrorZ_err"))) TS_CResult_InitFeaturesDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_InitFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InitFeaturesDecodeErrorZ), "LDKCResult_InitFeaturesDecodeErrorZ");
	*ret_conv = CResult_InitFeaturesDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_InitFeaturesDecodeErrorZ_is_ok"))) TS_CResult_InitFeaturesDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_InitFeaturesDecodeErrorZ* o_conv = (LDKCResult_InitFeaturesDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_InitFeaturesDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_InitFeaturesDecodeErrorZ_free"))) TS_CResult_InitFeaturesDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_InitFeaturesDecodeErrorZ _res_conv = *(LDKCResult_InitFeaturesDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_InitFeaturesDecodeErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelFeaturesDecodeErrorZ_ok"))) TS_CResult_ChannelFeaturesDecodeErrorZ_ok(uint32_t o) {
	LDKChannelFeatures o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelFeatures_clone(&o_conv);
	LDKCResult_ChannelFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelFeaturesDecodeErrorZ), "LDKCResult_ChannelFeaturesDecodeErrorZ");
	*ret_conv = CResult_ChannelFeaturesDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelFeaturesDecodeErrorZ_err"))) TS_CResult_ChannelFeaturesDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelFeaturesDecodeErrorZ), "LDKCResult_ChannelFeaturesDecodeErrorZ");
	*ret_conv = CResult_ChannelFeaturesDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelFeaturesDecodeErrorZ_is_ok"))) TS_CResult_ChannelFeaturesDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelFeaturesDecodeErrorZ* o_conv = (LDKCResult_ChannelFeaturesDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelFeaturesDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelFeaturesDecodeErrorZ_free"))) TS_CResult_ChannelFeaturesDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelFeaturesDecodeErrorZ _res_conv = *(LDKCResult_ChannelFeaturesDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelFeaturesDecodeErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_NodeFeaturesDecodeErrorZ_ok"))) TS_CResult_NodeFeaturesDecodeErrorZ_ok(uint32_t o) {
	LDKNodeFeatures o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = NodeFeatures_clone(&o_conv);
	LDKCResult_NodeFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeFeaturesDecodeErrorZ), "LDKCResult_NodeFeaturesDecodeErrorZ");
	*ret_conv = CResult_NodeFeaturesDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeFeaturesDecodeErrorZ_err"))) TS_CResult_NodeFeaturesDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_NodeFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeFeaturesDecodeErrorZ), "LDKCResult_NodeFeaturesDecodeErrorZ");
	*ret_conv = CResult_NodeFeaturesDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NodeFeaturesDecodeErrorZ_is_ok"))) TS_CResult_NodeFeaturesDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_NodeFeaturesDecodeErrorZ* o_conv = (LDKCResult_NodeFeaturesDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NodeFeaturesDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NodeFeaturesDecodeErrorZ_free"))) TS_CResult_NodeFeaturesDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NodeFeaturesDecodeErrorZ _res_conv = *(LDKCResult_NodeFeaturesDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NodeFeaturesDecodeErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceFeaturesDecodeErrorZ_ok"))) TS_CResult_InvoiceFeaturesDecodeErrorZ_ok(uint32_t o) {
	LDKInvoiceFeatures o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = InvoiceFeatures_clone(&o_conv);
	LDKCResult_InvoiceFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceFeaturesDecodeErrorZ), "LDKCResult_InvoiceFeaturesDecodeErrorZ");
	*ret_conv = CResult_InvoiceFeaturesDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceFeaturesDecodeErrorZ_err"))) TS_CResult_InvoiceFeaturesDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_InvoiceFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceFeaturesDecodeErrorZ), "LDKCResult_InvoiceFeaturesDecodeErrorZ");
	*ret_conv = CResult_InvoiceFeaturesDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_InvoiceFeaturesDecodeErrorZ_is_ok"))) TS_CResult_InvoiceFeaturesDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_InvoiceFeaturesDecodeErrorZ* o_conv = (LDKCResult_InvoiceFeaturesDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_InvoiceFeaturesDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_InvoiceFeaturesDecodeErrorZ_free"))) TS_CResult_InvoiceFeaturesDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_InvoiceFeaturesDecodeErrorZ _res_conv = *(LDKCResult_InvoiceFeaturesDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_InvoiceFeaturesDecodeErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelTypeFeaturesDecodeErrorZ_ok"))) TS_CResult_ChannelTypeFeaturesDecodeErrorZ_ok(uint32_t o) {
	LDKChannelTypeFeatures o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelTypeFeatures_clone(&o_conv);
	LDKCResult_ChannelTypeFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelTypeFeaturesDecodeErrorZ), "LDKCResult_ChannelTypeFeaturesDecodeErrorZ");
	*ret_conv = CResult_ChannelTypeFeaturesDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelTypeFeaturesDecodeErrorZ_err"))) TS_CResult_ChannelTypeFeaturesDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelTypeFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelTypeFeaturesDecodeErrorZ), "LDKCResult_ChannelTypeFeaturesDecodeErrorZ");
	*ret_conv = CResult_ChannelTypeFeaturesDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelTypeFeaturesDecodeErrorZ_is_ok"))) TS_CResult_ChannelTypeFeaturesDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelTypeFeaturesDecodeErrorZ* o_conv = (LDKCResult_ChannelTypeFeaturesDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelTypeFeaturesDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelTypeFeaturesDecodeErrorZ_free"))) TS_CResult_ChannelTypeFeaturesDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelTypeFeaturesDecodeErrorZ _res_conv = *(LDKCResult_ChannelTypeFeaturesDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelTypeFeaturesDecodeErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_ok"))) TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_ok(uint32_t o) {
	LDKDelayedPaymentOutputDescriptor o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = DelayedPaymentOutputDescriptor_clone(&o_conv);
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_err"))) TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_is_ok"))) TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* o_conv = (LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_free"))) TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ _res_conv = *(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_clone_ptr(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_clone_ptr"))) TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* arg_conv = (LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_clone"))) TS_CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* orig_conv = (LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ*)(orig & ~1);
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_DelayedPaymentOutputDescriptorDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_ok"))) TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_ok(uint32_t o) {
	LDKStaticPaymentOutputDescriptor o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = StaticPaymentOutputDescriptor_clone(&o_conv);
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_StaticPaymentOutputDescriptorDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_err"))) TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_StaticPaymentOutputDescriptorDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_is_ok"))) TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* o_conv = (LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_StaticPaymentOutputDescriptorDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_free"))) TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ _res_conv = *(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_StaticPaymentOutputDescriptorDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_StaticPaymentOutputDescriptorDecodeErrorZ_clone_ptr(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_StaticPaymentOutputDescriptorDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_clone_ptr"))) TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* arg_conv = (LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_StaticPaymentOutputDescriptorDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_clone"))) TS_CResult_StaticPaymentOutputDescriptorDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* orig_conv = (LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ*)(orig & ~1);
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_StaticPaymentOutputDescriptorDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SpendableOutputDescriptorDecodeErrorZ_ok"))) TS_CResult_SpendableOutputDescriptorDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKSpendableOutputDescriptor o_conv = *(LDKSpendableOutputDescriptor*)(o_ptr);
	o_conv = SpendableOutputDescriptor_clone((LDKSpendableOutputDescriptor*)(((uintptr_t)o) & ~1));
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SpendableOutputDescriptorDecodeErrorZ), "LDKCResult_SpendableOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_SpendableOutputDescriptorDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SpendableOutputDescriptorDecodeErrorZ_err"))) TS_CResult_SpendableOutputDescriptorDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SpendableOutputDescriptorDecodeErrorZ), "LDKCResult_SpendableOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_SpendableOutputDescriptorDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_SpendableOutputDescriptorDecodeErrorZ_is_ok"))) TS_CResult_SpendableOutputDescriptorDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* o_conv = (LDKCResult_SpendableOutputDescriptorDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_SpendableOutputDescriptorDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_SpendableOutputDescriptorDecodeErrorZ_free"))) TS_CResult_SpendableOutputDescriptorDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ _res_conv = *(LDKCResult_SpendableOutputDescriptorDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_SpendableOutputDescriptorDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_SpendableOutputDescriptorDecodeErrorZ_clone_ptr(LDKCResult_SpendableOutputDescriptorDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SpendableOutputDescriptorDecodeErrorZ), "LDKCResult_SpendableOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_SpendableOutputDescriptorDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_SpendableOutputDescriptorDecodeErrorZ_clone_ptr"))) TS_CResult_SpendableOutputDescriptorDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* arg_conv = (LDKCResult_SpendableOutputDescriptorDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_SpendableOutputDescriptorDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_SpendableOutputDescriptorDecodeErrorZ_clone"))) TS_CResult_SpendableOutputDescriptorDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* orig_conv = (LDKCResult_SpendableOutputDescriptorDecodeErrorZ*)(orig & ~1);
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SpendableOutputDescriptorDecodeErrorZ), "LDKCResult_SpendableOutputDescriptorDecodeErrorZ");
	*ret_conv = CResult_SpendableOutputDescriptorDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_PaymentPreimageZ_free"))) TS_CVec_PaymentPreimageZ_free(ptrArray _res) {
	LDKCVec_PaymentPreimageZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKThirtyTwoBytes), "LDKCVec_PaymentPreimageZ Elements");
	else
		_res_constr.data = NULL;
	int8_tArray* _res_vals = (void*) _res->elems /* XXX _res leaks */;
	for (size_t m = 0; m < _res_constr.datalen; m++) {
		int8_tArray _res_conv_12 = _res_vals[m];
		LDKThirtyTwoBytes _res_conv_12_ref;
		CHECK(_res_conv_12->arr_len == 32);
		memcpy(_res_conv_12_ref.data, _res_conv_12->elems, 32); FREE(_res_conv_12);
		_res_constr.data[m] = _res_conv_12_ref;
	}
	CVec_PaymentPreimageZ_free(_res_constr);
}

static inline uintptr_t C2Tuple_SignatureCVec_SignatureZZ_clone_ptr(LDKC2Tuple_SignatureCVec_SignatureZZ *NONNULL_PTR arg) {
	LDKC2Tuple_SignatureCVec_SignatureZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_SignatureCVec_SignatureZZ), "LDKC2Tuple_SignatureCVec_SignatureZZ");
	*ret_conv = C2Tuple_SignatureCVec_SignatureZZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_SignatureCVec_SignatureZZ_clone_ptr"))) TS_C2Tuple_SignatureCVec_SignatureZZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_SignatureCVec_SignatureZZ* arg_conv = (LDKC2Tuple_SignatureCVec_SignatureZZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_SignatureCVec_SignatureZZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_SignatureCVec_SignatureZZ_clone"))) TS_C2Tuple_SignatureCVec_SignatureZZ_clone(uint32_t orig) {
	LDKC2Tuple_SignatureCVec_SignatureZZ* orig_conv = (LDKC2Tuple_SignatureCVec_SignatureZZ*)(orig & ~1);
	LDKC2Tuple_SignatureCVec_SignatureZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_SignatureCVec_SignatureZZ), "LDKC2Tuple_SignatureCVec_SignatureZZ");
	*ret_conv = C2Tuple_SignatureCVec_SignatureZZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_SignatureCVec_SignatureZZ_new"))) TS_C2Tuple_SignatureCVec_SignatureZZ_new(int8_tArray a, ptrArray b) {
	LDKSignature a_ref;
	CHECK(a->arr_len == 64);
	memcpy(a_ref.compact_form, a->elems, 64); FREE(a);
	LDKCVec_SignatureZ b_constr;
	b_constr.datalen = b->arr_len;
	if (b_constr.datalen > 0)
		b_constr.data = MALLOC(b_constr.datalen * sizeof(LDKSignature), "LDKCVec_SignatureZ Elements");
	else
		b_constr.data = NULL;
	int8_tArray* b_vals = (void*) b->elems /* XXX b leaks */;
	for (size_t m = 0; m < b_constr.datalen; m++) {
		int8_tArray b_conv_12 = b_vals[m];
		LDKSignature b_conv_12_ref;
		CHECK(b_conv_12->arr_len == 64);
		memcpy(b_conv_12_ref.compact_form, b_conv_12->elems, 64); FREE(b_conv_12);
		b_constr.data[m] = b_conv_12_ref;
	}
	LDKC2Tuple_SignatureCVec_SignatureZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_SignatureCVec_SignatureZZ), "LDKC2Tuple_SignatureCVec_SignatureZZ");
	*ret_conv = C2Tuple_SignatureCVec_SignatureZZ_new(a_ref, b_constr);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_SignatureCVec_SignatureZZ_free"))) TS_C2Tuple_SignatureCVec_SignatureZZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_SignatureCVec_SignatureZZ _res_conv = *(LDKC2Tuple_SignatureCVec_SignatureZZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_SignatureCVec_SignatureZZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_ok"))) TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKC2Tuple_SignatureCVec_SignatureZZ o_conv = *(LDKC2Tuple_SignatureCVec_SignatureZZ*)(o_ptr);
	o_conv = C2Tuple_SignatureCVec_SignatureZZ_clone((LDKC2Tuple_SignatureCVec_SignatureZZ*)(((uintptr_t)o) & ~1));
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ), "LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ");
	*ret_conv = CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_err"))) TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_err() {
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ), "LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ");
	*ret_conv = CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_is_ok"))) TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_is_ok(uint32_t o) {
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* o_conv = (LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ*)(o & ~1);
	jboolean ret_val = CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_free"))) TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ _res_conv = *(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_clone_ptr(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ *NONNULL_PTR arg) {
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ), "LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ");
	*ret_conv = CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_clone_ptr"))) TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* arg_conv = (LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_clone"))) TS_CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_clone(uint32_t orig) {
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* orig_conv = (LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ*)(orig & ~1);
	LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ), "LDKCResult_C2Tuple_SignatureCVec_SignatureZZNoneZ");
	*ret_conv = CResult_C2Tuple_SignatureCVec_SignatureZZNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SignatureNoneZ_ok"))) TS_CResult_SignatureNoneZ_ok(int8_tArray o) {
	LDKSignature o_ref;
	CHECK(o->arr_len == 64);
	memcpy(o_ref.compact_form, o->elems, 64); FREE(o);
	LDKCResult_SignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SignatureNoneZ), "LDKCResult_SignatureNoneZ");
	*ret_conv = CResult_SignatureNoneZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SignatureNoneZ_err"))) TS_CResult_SignatureNoneZ_err() {
	LDKCResult_SignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SignatureNoneZ), "LDKCResult_SignatureNoneZ");
	*ret_conv = CResult_SignatureNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_SignatureNoneZ_is_ok"))) TS_CResult_SignatureNoneZ_is_ok(uint32_t o) {
	LDKCResult_SignatureNoneZ* o_conv = (LDKCResult_SignatureNoneZ*)(o & ~1);
	jboolean ret_val = CResult_SignatureNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_SignatureNoneZ_free"))) TS_CResult_SignatureNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_SignatureNoneZ _res_conv = *(LDKCResult_SignatureNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_SignatureNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_SignatureNoneZ_clone_ptr(LDKCResult_SignatureNoneZ *NONNULL_PTR arg) {
	LDKCResult_SignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SignatureNoneZ), "LDKCResult_SignatureNoneZ");
	*ret_conv = CResult_SignatureNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_SignatureNoneZ_clone_ptr"))) TS_CResult_SignatureNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_SignatureNoneZ* arg_conv = (LDKCResult_SignatureNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_SignatureNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_SignatureNoneZ_clone"))) TS_CResult_SignatureNoneZ_clone(uint32_t orig) {
	LDKCResult_SignatureNoneZ* orig_conv = (LDKCResult_SignatureNoneZ*)(orig & ~1);
	LDKCResult_SignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SignatureNoneZ), "LDKCResult_SignatureNoneZ");
	*ret_conv = CResult_SignatureNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

static inline uintptr_t C2Tuple_SignatureSignatureZ_clone_ptr(LDKC2Tuple_SignatureSignatureZ *NONNULL_PTR arg) {
	LDKC2Tuple_SignatureSignatureZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_SignatureSignatureZ), "LDKC2Tuple_SignatureSignatureZ");
	*ret_conv = C2Tuple_SignatureSignatureZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_SignatureSignatureZ_clone_ptr"))) TS_C2Tuple_SignatureSignatureZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_SignatureSignatureZ* arg_conv = (LDKC2Tuple_SignatureSignatureZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_SignatureSignatureZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_SignatureSignatureZ_clone"))) TS_C2Tuple_SignatureSignatureZ_clone(uint32_t orig) {
	LDKC2Tuple_SignatureSignatureZ* orig_conv = (LDKC2Tuple_SignatureSignatureZ*)(orig & ~1);
	LDKC2Tuple_SignatureSignatureZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_SignatureSignatureZ), "LDKC2Tuple_SignatureSignatureZ");
	*ret_conv = C2Tuple_SignatureSignatureZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_SignatureSignatureZ_new"))) TS_C2Tuple_SignatureSignatureZ_new(int8_tArray a, int8_tArray b) {
	LDKSignature a_ref;
	CHECK(a->arr_len == 64);
	memcpy(a_ref.compact_form, a->elems, 64); FREE(a);
	LDKSignature b_ref;
	CHECK(b->arr_len == 64);
	memcpy(b_ref.compact_form, b->elems, 64); FREE(b);
	LDKC2Tuple_SignatureSignatureZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_SignatureSignatureZ), "LDKC2Tuple_SignatureSignatureZ");
	*ret_conv = C2Tuple_SignatureSignatureZ_new(a_ref, b_ref);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_SignatureSignatureZ_free"))) TS_C2Tuple_SignatureSignatureZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_SignatureSignatureZ _res_conv = *(LDKC2Tuple_SignatureSignatureZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_SignatureSignatureZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureSignatureZNoneZ_ok"))) TS_CResult_C2Tuple_SignatureSignatureZNoneZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKC2Tuple_SignatureSignatureZ o_conv = *(LDKC2Tuple_SignatureSignatureZ*)(o_ptr);
	o_conv = C2Tuple_SignatureSignatureZ_clone((LDKC2Tuple_SignatureSignatureZ*)(((uintptr_t)o) & ~1));
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureSignatureZNoneZ), "LDKCResult_C2Tuple_SignatureSignatureZNoneZ");
	*ret_conv = CResult_C2Tuple_SignatureSignatureZNoneZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureSignatureZNoneZ_err"))) TS_CResult_C2Tuple_SignatureSignatureZNoneZ_err() {
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureSignatureZNoneZ), "LDKCResult_C2Tuple_SignatureSignatureZNoneZ");
	*ret_conv = CResult_C2Tuple_SignatureSignatureZNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_C2Tuple_SignatureSignatureZNoneZ_is_ok"))) TS_CResult_C2Tuple_SignatureSignatureZNoneZ_is_ok(uint32_t o) {
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* o_conv = (LDKCResult_C2Tuple_SignatureSignatureZNoneZ*)(o & ~1);
	jboolean ret_val = CResult_C2Tuple_SignatureSignatureZNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_C2Tuple_SignatureSignatureZNoneZ_free"))) TS_CResult_C2Tuple_SignatureSignatureZNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ _res_conv = *(LDKCResult_C2Tuple_SignatureSignatureZNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_C2Tuple_SignatureSignatureZNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_C2Tuple_SignatureSignatureZNoneZ_clone_ptr(LDKCResult_C2Tuple_SignatureSignatureZNoneZ *NONNULL_PTR arg) {
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureSignatureZNoneZ), "LDKCResult_C2Tuple_SignatureSignatureZNoneZ");
	*ret_conv = CResult_C2Tuple_SignatureSignatureZNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureSignatureZNoneZ_clone_ptr"))) TS_CResult_C2Tuple_SignatureSignatureZNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* arg_conv = (LDKCResult_C2Tuple_SignatureSignatureZNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_C2Tuple_SignatureSignatureZNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_SignatureSignatureZNoneZ_clone"))) TS_CResult_C2Tuple_SignatureSignatureZNoneZ_clone(uint32_t orig) {
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* orig_conv = (LDKCResult_C2Tuple_SignatureSignatureZNoneZ*)(orig & ~1);
	LDKCResult_C2Tuple_SignatureSignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_SignatureSignatureZNoneZ), "LDKCResult_C2Tuple_SignatureSignatureZNoneZ");
	*ret_conv = CResult_C2Tuple_SignatureSignatureZNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SecretKeyNoneZ_ok"))) TS_CResult_SecretKeyNoneZ_ok(int8_tArray o) {
	LDKSecretKey o_ref;
	CHECK(o->arr_len == 32);
	memcpy(o_ref.bytes, o->elems, 32); FREE(o);
	LDKCResult_SecretKeyNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyNoneZ), "LDKCResult_SecretKeyNoneZ");
	*ret_conv = CResult_SecretKeyNoneZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SecretKeyNoneZ_err"))) TS_CResult_SecretKeyNoneZ_err() {
	LDKCResult_SecretKeyNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyNoneZ), "LDKCResult_SecretKeyNoneZ");
	*ret_conv = CResult_SecretKeyNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_SecretKeyNoneZ_is_ok"))) TS_CResult_SecretKeyNoneZ_is_ok(uint32_t o) {
	LDKCResult_SecretKeyNoneZ* o_conv = (LDKCResult_SecretKeyNoneZ*)(o & ~1);
	jboolean ret_val = CResult_SecretKeyNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_SecretKeyNoneZ_free"))) TS_CResult_SecretKeyNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_SecretKeyNoneZ _res_conv = *(LDKCResult_SecretKeyNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_SecretKeyNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_SecretKeyNoneZ_clone_ptr(LDKCResult_SecretKeyNoneZ *NONNULL_PTR arg) {
	LDKCResult_SecretKeyNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyNoneZ), "LDKCResult_SecretKeyNoneZ");
	*ret_conv = CResult_SecretKeyNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_SecretKeyNoneZ_clone_ptr"))) TS_CResult_SecretKeyNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_SecretKeyNoneZ* arg_conv = (LDKCResult_SecretKeyNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_SecretKeyNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_SecretKeyNoneZ_clone"))) TS_CResult_SecretKeyNoneZ_clone(uint32_t orig) {
	LDKCResult_SecretKeyNoneZ* orig_conv = (LDKCResult_SecretKeyNoneZ*)(orig & ~1);
	LDKCResult_SecretKeyNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyNoneZ), "LDKCResult_SecretKeyNoneZ");
	*ret_conv = CResult_SecretKeyNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SignDecodeErrorZ_ok"))) TS_CResult_SignDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKSign o_conv = *(LDKSign*)(o_ptr);
	if (o_conv.free == LDKSign_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKSign_JCalls_cloned(&o_conv);
	}
	LDKCResult_SignDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignDecodeErrorZ), "LDKCResult_SignDecodeErrorZ");
	*ret_conv = CResult_SignDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SignDecodeErrorZ_err"))) TS_CResult_SignDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_SignDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignDecodeErrorZ), "LDKCResult_SignDecodeErrorZ");
	*ret_conv = CResult_SignDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_SignDecodeErrorZ_is_ok"))) TS_CResult_SignDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_SignDecodeErrorZ* o_conv = (LDKCResult_SignDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_SignDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_SignDecodeErrorZ_free"))) TS_CResult_SignDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_SignDecodeErrorZ _res_conv = *(LDKCResult_SignDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_SignDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_SignDecodeErrorZ_clone_ptr(LDKCResult_SignDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_SignDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignDecodeErrorZ), "LDKCResult_SignDecodeErrorZ");
	*ret_conv = CResult_SignDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_SignDecodeErrorZ_clone_ptr"))) TS_CResult_SignDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_SignDecodeErrorZ* arg_conv = (LDKCResult_SignDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_SignDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_SignDecodeErrorZ_clone"))) TS_CResult_SignDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_SignDecodeErrorZ* orig_conv = (LDKCResult_SignDecodeErrorZ*)(orig & ~1);
	LDKCResult_SignDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignDecodeErrorZ), "LDKCResult_SignDecodeErrorZ");
	*ret_conv = CResult_SignDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_u5Z_free"))) TS_CVec_u5Z_free(ptrArray _res) {
	LDKCVec_u5Z _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKu5), "LDKCVec_u5Z Elements");
	else
		_res_constr.data = NULL;
	int8_t* _res_vals = (void*) _res->elems /* XXX _res leaks */;
	for (size_t h = 0; h < _res_constr.datalen; h++) {
		int8_t _res_conv_7 = _res_vals[h];
		
		_res_constr.data[h] = (LDKu5){ ._0 = _res_conv_7 };
	}
	CVec_u5Z_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_RecoverableSignatureNoneZ_ok"))) TS_CResult_RecoverableSignatureNoneZ_ok(int8_tArray o) {
	LDKRecoverableSignature o_ref;
	CHECK(o->arr_len == 68);
	memcpy(o_ref.serialized_form, o->elems, 68); FREE(o);
	LDKCResult_RecoverableSignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_RecoverableSignatureNoneZ), "LDKCResult_RecoverableSignatureNoneZ");
	*ret_conv = CResult_RecoverableSignatureNoneZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RecoverableSignatureNoneZ_err"))) TS_CResult_RecoverableSignatureNoneZ_err() {
	LDKCResult_RecoverableSignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_RecoverableSignatureNoneZ), "LDKCResult_RecoverableSignatureNoneZ");
	*ret_conv = CResult_RecoverableSignatureNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RecoverableSignatureNoneZ_is_ok"))) TS_CResult_RecoverableSignatureNoneZ_is_ok(uint32_t o) {
	LDKCResult_RecoverableSignatureNoneZ* o_conv = (LDKCResult_RecoverableSignatureNoneZ*)(o & ~1);
	jboolean ret_val = CResult_RecoverableSignatureNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RecoverableSignatureNoneZ_free"))) TS_CResult_RecoverableSignatureNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RecoverableSignatureNoneZ _res_conv = *(LDKCResult_RecoverableSignatureNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RecoverableSignatureNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_RecoverableSignatureNoneZ_clone_ptr(LDKCResult_RecoverableSignatureNoneZ *NONNULL_PTR arg) {
	LDKCResult_RecoverableSignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_RecoverableSignatureNoneZ), "LDKCResult_RecoverableSignatureNoneZ");
	*ret_conv = CResult_RecoverableSignatureNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RecoverableSignatureNoneZ_clone_ptr"))) TS_CResult_RecoverableSignatureNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_RecoverableSignatureNoneZ* arg_conv = (LDKCResult_RecoverableSignatureNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_RecoverableSignatureNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RecoverableSignatureNoneZ_clone"))) TS_CResult_RecoverableSignatureNoneZ_clone(uint32_t orig) {
	LDKCResult_RecoverableSignatureNoneZ* orig_conv = (LDKCResult_RecoverableSignatureNoneZ*)(orig & ~1);
	LDKCResult_RecoverableSignatureNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_RecoverableSignatureNoneZ), "LDKCResult_RecoverableSignatureNoneZ");
	*ret_conv = CResult_RecoverableSignatureNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_u8Z_free"))) TS_CVec_u8Z_free(int8_tArray _res) {
	LDKCVec_u8Z _res_ref;
	_res_ref.datalen = _res->arr_len;
	_res_ref.data = MALLOC(_res_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(_res_ref.data, _res->elems, _res_ref.datalen); FREE(_res);
	CVec_u8Z_free(_res_ref);
}

void  __attribute__((export_name("TS_CVec_CVec_u8ZZ_free"))) TS_CVec_CVec_u8ZZ_free(ptrArray _res) {
	LDKCVec_CVec_u8ZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKCVec_u8Z), "LDKCVec_CVec_u8ZZ Elements");
	else
		_res_constr.data = NULL;
	int8_tArray* _res_vals = (void*) _res->elems /* XXX _res leaks */;
	for (size_t m = 0; m < _res_constr.datalen; m++) {
		int8_tArray _res_conv_12 = _res_vals[m];
		LDKCVec_u8Z _res_conv_12_ref;
		_res_conv_12_ref.datalen = _res_conv_12->arr_len;
		_res_conv_12_ref.data = MALLOC(_res_conv_12_ref.datalen, "LDKCVec_u8Z Bytes");
		memcpy(_res_conv_12_ref.data, _res_conv_12->elems, _res_conv_12_ref.datalen); FREE(_res_conv_12);
		_res_constr.data[m] = _res_conv_12_ref;
	}
	CVec_CVec_u8ZZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_CVec_u8ZZNoneZ_ok"))) TS_CResult_CVec_CVec_u8ZZNoneZ_ok(ptrArray o) {
	LDKCVec_CVec_u8ZZ o_constr;
	o_constr.datalen = o->arr_len;
	if (o_constr.datalen > 0)
		o_constr.data = MALLOC(o_constr.datalen * sizeof(LDKCVec_u8Z), "LDKCVec_CVec_u8ZZ Elements");
	else
		o_constr.data = NULL;
	int8_tArray* o_vals = (void*) o->elems /* XXX o leaks */;
	for (size_t m = 0; m < o_constr.datalen; m++) {
		int8_tArray o_conv_12 = o_vals[m];
		LDKCVec_u8Z o_conv_12_ref;
		o_conv_12_ref.datalen = o_conv_12->arr_len;
		o_conv_12_ref.data = MALLOC(o_conv_12_ref.datalen, "LDKCVec_u8Z Bytes");
		memcpy(o_conv_12_ref.data, o_conv_12->elems, o_conv_12_ref.datalen); FREE(o_conv_12);
		o_constr.data[m] = o_conv_12_ref;
	}
	LDKCResult_CVec_CVec_u8ZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_CVec_u8ZZNoneZ), "LDKCResult_CVec_CVec_u8ZZNoneZ");
	*ret_conv = CResult_CVec_CVec_u8ZZNoneZ_ok(o_constr);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_CVec_u8ZZNoneZ_err"))) TS_CResult_CVec_CVec_u8ZZNoneZ_err() {
	LDKCResult_CVec_CVec_u8ZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_CVec_u8ZZNoneZ), "LDKCResult_CVec_CVec_u8ZZNoneZ");
	*ret_conv = CResult_CVec_CVec_u8ZZNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_CVec_CVec_u8ZZNoneZ_is_ok"))) TS_CResult_CVec_CVec_u8ZZNoneZ_is_ok(uint32_t o) {
	LDKCResult_CVec_CVec_u8ZZNoneZ* o_conv = (LDKCResult_CVec_CVec_u8ZZNoneZ*)(o & ~1);
	jboolean ret_val = CResult_CVec_CVec_u8ZZNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_CVec_CVec_u8ZZNoneZ_free"))) TS_CResult_CVec_CVec_u8ZZNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_CVec_CVec_u8ZZNoneZ _res_conv = *(LDKCResult_CVec_CVec_u8ZZNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_CVec_CVec_u8ZZNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_CVec_CVec_u8ZZNoneZ_clone_ptr(LDKCResult_CVec_CVec_u8ZZNoneZ *NONNULL_PTR arg) {
	LDKCResult_CVec_CVec_u8ZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_CVec_u8ZZNoneZ), "LDKCResult_CVec_CVec_u8ZZNoneZ");
	*ret_conv = CResult_CVec_CVec_u8ZZNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_CVec_CVec_u8ZZNoneZ_clone_ptr"))) TS_CResult_CVec_CVec_u8ZZNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_CVec_CVec_u8ZZNoneZ* arg_conv = (LDKCResult_CVec_CVec_u8ZZNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_CVec_CVec_u8ZZNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_CVec_u8ZZNoneZ_clone"))) TS_CResult_CVec_CVec_u8ZZNoneZ_clone(uint32_t orig) {
	LDKCResult_CVec_CVec_u8ZZNoneZ* orig_conv = (LDKCResult_CVec_CVec_u8ZZNoneZ*)(orig & ~1);
	LDKCResult_CVec_CVec_u8ZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_CVec_u8ZZNoneZ), "LDKCResult_CVec_CVec_u8ZZNoneZ");
	*ret_conv = CResult_CVec_CVec_u8ZZNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InMemorySignerDecodeErrorZ_ok"))) TS_CResult_InMemorySignerDecodeErrorZ_ok(uint32_t o) {
	LDKInMemorySigner o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = InMemorySigner_clone(&o_conv);
	LDKCResult_InMemorySignerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InMemorySignerDecodeErrorZ), "LDKCResult_InMemorySignerDecodeErrorZ");
	*ret_conv = CResult_InMemorySignerDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InMemorySignerDecodeErrorZ_err"))) TS_CResult_InMemorySignerDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_InMemorySignerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InMemorySignerDecodeErrorZ), "LDKCResult_InMemorySignerDecodeErrorZ");
	*ret_conv = CResult_InMemorySignerDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_InMemorySignerDecodeErrorZ_is_ok"))) TS_CResult_InMemorySignerDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_InMemorySignerDecodeErrorZ* o_conv = (LDKCResult_InMemorySignerDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_InMemorySignerDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_InMemorySignerDecodeErrorZ_free"))) TS_CResult_InMemorySignerDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_InMemorySignerDecodeErrorZ _res_conv = *(LDKCResult_InMemorySignerDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_InMemorySignerDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_InMemorySignerDecodeErrorZ_clone_ptr(LDKCResult_InMemorySignerDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_InMemorySignerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InMemorySignerDecodeErrorZ), "LDKCResult_InMemorySignerDecodeErrorZ");
	*ret_conv = CResult_InMemorySignerDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_InMemorySignerDecodeErrorZ_clone_ptr"))) TS_CResult_InMemorySignerDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_InMemorySignerDecodeErrorZ* arg_conv = (LDKCResult_InMemorySignerDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_InMemorySignerDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_InMemorySignerDecodeErrorZ_clone"))) TS_CResult_InMemorySignerDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_InMemorySignerDecodeErrorZ* orig_conv = (LDKCResult_InMemorySignerDecodeErrorZ*)(orig & ~1);
	LDKCResult_InMemorySignerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InMemorySignerDecodeErrorZ), "LDKCResult_InMemorySignerDecodeErrorZ");
	*ret_conv = CResult_InMemorySignerDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_TxOutZ_free"))) TS_CVec_TxOutZ_free(uint32_tArray _res) {
	LDKCVec_TxOutZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKTxOut), "LDKCVec_TxOutZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t h = 0; h < _res_constr.datalen; h++) {
		uint32_t _res_conv_7 = _res_vals[h];
		void* _res_conv_7_ptr = (void*)(((uintptr_t)_res_conv_7) & ~1);
		CHECK_ACCESS(_res_conv_7_ptr);
		LDKTxOut _res_conv_7_conv = *(LDKTxOut*)(_res_conv_7_ptr);
		FREE((void*)_res_conv_7);
		_res_constr.data[h] = _res_conv_7_conv;
	}
	CVec_TxOutZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_TransactionNoneZ_ok"))) TS_CResult_TransactionNoneZ_ok(int8_tArray o) {
	LDKTransaction o_ref;
	o_ref.datalen = o->arr_len;
	o_ref.data = MALLOC(o_ref.datalen, "LDKTransaction Bytes");
	memcpy(o_ref.data, o->elems, o_ref.datalen); FREE(o);
	o_ref.data_is_owned = true;
	LDKCResult_TransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TransactionNoneZ), "LDKCResult_TransactionNoneZ");
	*ret_conv = CResult_TransactionNoneZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_TransactionNoneZ_err"))) TS_CResult_TransactionNoneZ_err() {
	LDKCResult_TransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TransactionNoneZ), "LDKCResult_TransactionNoneZ");
	*ret_conv = CResult_TransactionNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_TransactionNoneZ_is_ok"))) TS_CResult_TransactionNoneZ_is_ok(uint32_t o) {
	LDKCResult_TransactionNoneZ* o_conv = (LDKCResult_TransactionNoneZ*)(o & ~1);
	jboolean ret_val = CResult_TransactionNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_TransactionNoneZ_free"))) TS_CResult_TransactionNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_TransactionNoneZ _res_conv = *(LDKCResult_TransactionNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_TransactionNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_TransactionNoneZ_clone_ptr(LDKCResult_TransactionNoneZ *NONNULL_PTR arg) {
	LDKCResult_TransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TransactionNoneZ), "LDKCResult_TransactionNoneZ");
	*ret_conv = CResult_TransactionNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_TransactionNoneZ_clone_ptr"))) TS_CResult_TransactionNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_TransactionNoneZ* arg_conv = (LDKCResult_TransactionNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_TransactionNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_TransactionNoneZ_clone"))) TS_CResult_TransactionNoneZ_clone(uint32_t orig) {
	LDKCResult_TransactionNoneZ* orig_conv = (LDKCResult_TransactionNoneZ*)(orig & ~1);
	LDKCResult_TransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TransactionNoneZ), "LDKCResult_TransactionNoneZ");
	*ret_conv = CResult_TransactionNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_u16Z_some"))) TS_COption_u16Z_some(int16_t o) {
	LDKCOption_u16Z *ret_copy = MALLOC(sizeof(LDKCOption_u16Z), "LDKCOption_u16Z");
	*ret_copy = COption_u16Z_some(o);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_u16Z_none"))) TS_COption_u16Z_none() {
	LDKCOption_u16Z *ret_copy = MALLOC(sizeof(LDKCOption_u16Z), "LDKCOption_u16Z");
	*ret_copy = COption_u16Z_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_u16Z_free"))) TS_COption_u16Z_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_u16Z _res_conv = *(LDKCOption_u16Z*)(_res_ptr);
	FREE((void*)_res);
	COption_u16Z_free(_res_conv);
}

static inline uintptr_t COption_u16Z_clone_ptr(LDKCOption_u16Z *NONNULL_PTR arg) {
	LDKCOption_u16Z *ret_copy = MALLOC(sizeof(LDKCOption_u16Z), "LDKCOption_u16Z");
	*ret_copy = COption_u16Z_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_u16Z_clone_ptr"))) TS_COption_u16Z_clone_ptr(uint32_t arg) {
	LDKCOption_u16Z* arg_conv = (LDKCOption_u16Z*)arg;
	uint32_t ret_val = COption_u16Z_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_u16Z_clone"))) TS_COption_u16Z_clone(uint32_t orig) {
	LDKCOption_u16Z* orig_conv = (LDKCOption_u16Z*)orig;
	LDKCOption_u16Z *ret_copy = MALLOC(sizeof(LDKCOption_u16Z), "LDKCOption_u16Z");
	*ret_copy = COption_u16Z_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneAPIErrorZ_ok"))) TS_CResult_NoneAPIErrorZ_ok() {
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = CResult_NoneAPIErrorZ_ok();
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneAPIErrorZ_err"))) TS_CResult_NoneAPIErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKAPIError e_conv = *(LDKAPIError*)(e_ptr);
	e_conv = APIError_clone((LDKAPIError*)(((uintptr_t)e) & ~1));
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = CResult_NoneAPIErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NoneAPIErrorZ_is_ok"))) TS_CResult_NoneAPIErrorZ_is_ok(uint32_t o) {
	LDKCResult_NoneAPIErrorZ* o_conv = (LDKCResult_NoneAPIErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NoneAPIErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NoneAPIErrorZ_free"))) TS_CResult_NoneAPIErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NoneAPIErrorZ _res_conv = *(LDKCResult_NoneAPIErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NoneAPIErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NoneAPIErrorZ_clone_ptr(LDKCResult_NoneAPIErrorZ *NONNULL_PTR arg) {
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = CResult_NoneAPIErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NoneAPIErrorZ_clone_ptr"))) TS_CResult_NoneAPIErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NoneAPIErrorZ* arg_conv = (LDKCResult_NoneAPIErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NoneAPIErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneAPIErrorZ_clone"))) TS_CResult_NoneAPIErrorZ_clone(uint32_t orig) {
	LDKCResult_NoneAPIErrorZ* orig_conv = (LDKCResult_NoneAPIErrorZ*)(orig & ~1);
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = CResult_NoneAPIErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_CResult_NoneAPIErrorZZ_free"))) TS_CVec_CResult_NoneAPIErrorZZ_free(uint32_tArray _res) {
	LDKCVec_CResult_NoneAPIErrorZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKCResult_NoneAPIErrorZ), "LDKCVec_CResult_NoneAPIErrorZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t w = 0; w < _res_constr.datalen; w++) {
		uint32_t _res_conv_22 = _res_vals[w];
		void* _res_conv_22_ptr = (void*)(((uintptr_t)_res_conv_22) & ~1);
		CHECK_ACCESS(_res_conv_22_ptr);
		LDKCResult_NoneAPIErrorZ _res_conv_22_conv = *(LDKCResult_NoneAPIErrorZ*)(_res_conv_22_ptr);
		FREE((void*)_res_conv_22);
		_res_constr.data[w] = _res_conv_22_conv;
	}
	CVec_CResult_NoneAPIErrorZZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_APIErrorZ_free"))) TS_CVec_APIErrorZ_free(uint32_tArray _res) {
	LDKCVec_APIErrorZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKAPIError), "LDKCVec_APIErrorZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t k = 0; k < _res_constr.datalen; k++) {
		uint32_t _res_conv_10 = _res_vals[k];
		void* _res_conv_10_ptr = (void*)(((uintptr_t)_res_conv_10) & ~1);
		CHECK_ACCESS(_res_conv_10_ptr);
		LDKAPIError _res_conv_10_conv = *(LDKAPIError*)(_res_conv_10_ptr);
		FREE((void*)_res_conv_10);
		_res_constr.data[k] = _res_conv_10_conv;
	}
	CVec_APIErrorZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult__u832APIErrorZ_ok"))) TS_CResult__u832APIErrorZ_ok(int8_tArray o) {
	LDKThirtyTwoBytes o_ref;
	CHECK(o->arr_len == 32);
	memcpy(o_ref.data, o->elems, 32); FREE(o);
	LDKCResult__u832APIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult__u832APIErrorZ), "LDKCResult__u832APIErrorZ");
	*ret_conv = CResult__u832APIErrorZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult__u832APIErrorZ_err"))) TS_CResult__u832APIErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKAPIError e_conv = *(LDKAPIError*)(e_ptr);
	e_conv = APIError_clone((LDKAPIError*)(((uintptr_t)e) & ~1));
	LDKCResult__u832APIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult__u832APIErrorZ), "LDKCResult__u832APIErrorZ");
	*ret_conv = CResult__u832APIErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult__u832APIErrorZ_is_ok"))) TS_CResult__u832APIErrorZ_is_ok(uint32_t o) {
	LDKCResult__u832APIErrorZ* o_conv = (LDKCResult__u832APIErrorZ*)(o & ~1);
	jboolean ret_val = CResult__u832APIErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult__u832APIErrorZ_free"))) TS_CResult__u832APIErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult__u832APIErrorZ _res_conv = *(LDKCResult__u832APIErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult__u832APIErrorZ_free(_res_conv);
}

static inline uintptr_t CResult__u832APIErrorZ_clone_ptr(LDKCResult__u832APIErrorZ *NONNULL_PTR arg) {
	LDKCResult__u832APIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult__u832APIErrorZ), "LDKCResult__u832APIErrorZ");
	*ret_conv = CResult__u832APIErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult__u832APIErrorZ_clone_ptr"))) TS_CResult__u832APIErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult__u832APIErrorZ* arg_conv = (LDKCResult__u832APIErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult__u832APIErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult__u832APIErrorZ_clone"))) TS_CResult__u832APIErrorZ_clone(uint32_t orig) {
	LDKCResult__u832APIErrorZ* orig_conv = (LDKCResult__u832APIErrorZ*)(orig & ~1);
	LDKCResult__u832APIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult__u832APIErrorZ), "LDKCResult__u832APIErrorZ");
	*ret_conv = CResult__u832APIErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentSendFailureZ_ok"))) TS_CResult_PaymentIdPaymentSendFailureZ_ok(int8_tArray o) {
	LDKThirtyTwoBytes o_ref;
	CHECK(o->arr_len == 32);
	memcpy(o_ref.data, o->elems, 32); FREE(o);
	LDKCResult_PaymentIdPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentSendFailureZ), "LDKCResult_PaymentIdPaymentSendFailureZ");
	*ret_conv = CResult_PaymentIdPaymentSendFailureZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentSendFailureZ_err"))) TS_CResult_PaymentIdPaymentSendFailureZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKPaymentSendFailure e_conv = *(LDKPaymentSendFailure*)(e_ptr);
	e_conv = PaymentSendFailure_clone((LDKPaymentSendFailure*)(((uintptr_t)e) & ~1));
	LDKCResult_PaymentIdPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentSendFailureZ), "LDKCResult_PaymentIdPaymentSendFailureZ");
	*ret_conv = CResult_PaymentIdPaymentSendFailureZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PaymentIdPaymentSendFailureZ_is_ok"))) TS_CResult_PaymentIdPaymentSendFailureZ_is_ok(uint32_t o) {
	LDKCResult_PaymentIdPaymentSendFailureZ* o_conv = (LDKCResult_PaymentIdPaymentSendFailureZ*)(o & ~1);
	jboolean ret_val = CResult_PaymentIdPaymentSendFailureZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PaymentIdPaymentSendFailureZ_free"))) TS_CResult_PaymentIdPaymentSendFailureZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PaymentIdPaymentSendFailureZ _res_conv = *(LDKCResult_PaymentIdPaymentSendFailureZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PaymentIdPaymentSendFailureZ_free(_res_conv);
}

static inline uintptr_t CResult_PaymentIdPaymentSendFailureZ_clone_ptr(LDKCResult_PaymentIdPaymentSendFailureZ *NONNULL_PTR arg) {
	LDKCResult_PaymentIdPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentSendFailureZ), "LDKCResult_PaymentIdPaymentSendFailureZ");
	*ret_conv = CResult_PaymentIdPaymentSendFailureZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentSendFailureZ_clone_ptr"))) TS_CResult_PaymentIdPaymentSendFailureZ_clone_ptr(uint32_t arg) {
	LDKCResult_PaymentIdPaymentSendFailureZ* arg_conv = (LDKCResult_PaymentIdPaymentSendFailureZ*)(arg & ~1);
	uint32_t ret_val = CResult_PaymentIdPaymentSendFailureZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentSendFailureZ_clone"))) TS_CResult_PaymentIdPaymentSendFailureZ_clone(uint32_t orig) {
	LDKCResult_PaymentIdPaymentSendFailureZ* orig_conv = (LDKCResult_PaymentIdPaymentSendFailureZ*)(orig & ~1);
	LDKCResult_PaymentIdPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentSendFailureZ), "LDKCResult_PaymentIdPaymentSendFailureZ");
	*ret_conv = CResult_PaymentIdPaymentSendFailureZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NonePaymentSendFailureZ_ok"))) TS_CResult_NonePaymentSendFailureZ_ok() {
	LDKCResult_NonePaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePaymentSendFailureZ), "LDKCResult_NonePaymentSendFailureZ");
	*ret_conv = CResult_NonePaymentSendFailureZ_ok();
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NonePaymentSendFailureZ_err"))) TS_CResult_NonePaymentSendFailureZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKPaymentSendFailure e_conv = *(LDKPaymentSendFailure*)(e_ptr);
	e_conv = PaymentSendFailure_clone((LDKPaymentSendFailure*)(((uintptr_t)e) & ~1));
	LDKCResult_NonePaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePaymentSendFailureZ), "LDKCResult_NonePaymentSendFailureZ");
	*ret_conv = CResult_NonePaymentSendFailureZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NonePaymentSendFailureZ_is_ok"))) TS_CResult_NonePaymentSendFailureZ_is_ok(uint32_t o) {
	LDKCResult_NonePaymentSendFailureZ* o_conv = (LDKCResult_NonePaymentSendFailureZ*)(o & ~1);
	jboolean ret_val = CResult_NonePaymentSendFailureZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NonePaymentSendFailureZ_free"))) TS_CResult_NonePaymentSendFailureZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NonePaymentSendFailureZ _res_conv = *(LDKCResult_NonePaymentSendFailureZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NonePaymentSendFailureZ_free(_res_conv);
}

static inline uintptr_t CResult_NonePaymentSendFailureZ_clone_ptr(LDKCResult_NonePaymentSendFailureZ *NONNULL_PTR arg) {
	LDKCResult_NonePaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePaymentSendFailureZ), "LDKCResult_NonePaymentSendFailureZ");
	*ret_conv = CResult_NonePaymentSendFailureZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NonePaymentSendFailureZ_clone_ptr"))) TS_CResult_NonePaymentSendFailureZ_clone_ptr(uint32_t arg) {
	LDKCResult_NonePaymentSendFailureZ* arg_conv = (LDKCResult_NonePaymentSendFailureZ*)(arg & ~1);
	uint32_t ret_val = CResult_NonePaymentSendFailureZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NonePaymentSendFailureZ_clone"))) TS_CResult_NonePaymentSendFailureZ_clone(uint32_t orig) {
	LDKCResult_NonePaymentSendFailureZ* orig_conv = (LDKCResult_NonePaymentSendFailureZ*)(orig & ~1);
	LDKCResult_NonePaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePaymentSendFailureZ), "LDKCResult_NonePaymentSendFailureZ");
	*ret_conv = CResult_NonePaymentSendFailureZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

static inline uintptr_t C2Tuple_PaymentHashPaymentIdZ_clone_ptr(LDKC2Tuple_PaymentHashPaymentIdZ *NONNULL_PTR arg) {
	LDKC2Tuple_PaymentHashPaymentIdZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentIdZ), "LDKC2Tuple_PaymentHashPaymentIdZ");
	*ret_conv = C2Tuple_PaymentHashPaymentIdZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentIdZ_clone_ptr"))) TS_C2Tuple_PaymentHashPaymentIdZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_PaymentHashPaymentIdZ* arg_conv = (LDKC2Tuple_PaymentHashPaymentIdZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_PaymentHashPaymentIdZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentIdZ_clone"))) TS_C2Tuple_PaymentHashPaymentIdZ_clone(uint32_t orig) {
	LDKC2Tuple_PaymentHashPaymentIdZ* orig_conv = (LDKC2Tuple_PaymentHashPaymentIdZ*)(orig & ~1);
	LDKC2Tuple_PaymentHashPaymentIdZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentIdZ), "LDKC2Tuple_PaymentHashPaymentIdZ");
	*ret_conv = C2Tuple_PaymentHashPaymentIdZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentIdZ_new"))) TS_C2Tuple_PaymentHashPaymentIdZ_new(int8_tArray a, int8_tArray b) {
	LDKThirtyTwoBytes a_ref;
	CHECK(a->arr_len == 32);
	memcpy(a_ref.data, a->elems, 32); FREE(a);
	LDKThirtyTwoBytes b_ref;
	CHECK(b->arr_len == 32);
	memcpy(b_ref.data, b->elems, 32); FREE(b);
	LDKC2Tuple_PaymentHashPaymentIdZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentIdZ), "LDKC2Tuple_PaymentHashPaymentIdZ");
	*ret_conv = C2Tuple_PaymentHashPaymentIdZ_new(a_ref, b_ref);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentIdZ_free"))) TS_C2Tuple_PaymentHashPaymentIdZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_PaymentHashPaymentIdZ _res_conv = *(LDKC2Tuple_PaymentHashPaymentIdZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_PaymentHashPaymentIdZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKC2Tuple_PaymentHashPaymentIdZ o_conv = *(LDKC2Tuple_PaymentHashPaymentIdZ*)(o_ptr);
	o_conv = C2Tuple_PaymentHashPaymentIdZ_clone((LDKC2Tuple_PaymentHashPaymentIdZ*)(((uintptr_t)o) & ~1));
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ), "LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_err"))) TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKPaymentSendFailure e_conv = *(LDKPaymentSendFailure*)(e_ptr);
	e_conv = PaymentSendFailure_clone((LDKPaymentSendFailure*)(((uintptr_t)e) & ~1));
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ), "LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_is_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_is_ok(uint32_t o) {
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* o_conv = (LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ*)(o & ~1);
	jboolean ret_val = CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_free"))) TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ _res_conv = *(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_free(_res_conv);
}

static inline uintptr_t CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_clone_ptr(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ *NONNULL_PTR arg) {
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ), "LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_clone_ptr"))) TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_clone_ptr(uint32_t arg) {
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* arg_conv = (LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ*)(arg & ~1);
	uint32_t ret_val = CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_clone"))) TS_CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_clone(uint32_t orig) {
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* orig_conv = (LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ*)(orig & ~1);
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ), "LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_NetAddressZ_free"))) TS_CVec_NetAddressZ_free(uint32_tArray _res) {
	LDKCVec_NetAddressZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKNetAddress), "LDKCVec_NetAddressZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t m = 0; m < _res_constr.datalen; m++) {
		uint32_t _res_conv_12 = _res_vals[m];
		void* _res_conv_12_ptr = (void*)(((uintptr_t)_res_conv_12) & ~1);
		CHECK_ACCESS(_res_conv_12_ptr);
		LDKNetAddress _res_conv_12_conv = *(LDKNetAddress*)(_res_conv_12_ptr);
		FREE((void*)_res_conv_12);
		_res_constr.data[m] = _res_conv_12_conv;
	}
	CVec_NetAddressZ_free(_res_constr);
}

static inline uintptr_t C2Tuple_PaymentHashPaymentSecretZ_clone_ptr(LDKC2Tuple_PaymentHashPaymentSecretZ *NONNULL_PTR arg) {
	LDKC2Tuple_PaymentHashPaymentSecretZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentSecretZ), "LDKC2Tuple_PaymentHashPaymentSecretZ");
	*ret_conv = C2Tuple_PaymentHashPaymentSecretZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentSecretZ_clone_ptr"))) TS_C2Tuple_PaymentHashPaymentSecretZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_PaymentHashPaymentSecretZ* arg_conv = (LDKC2Tuple_PaymentHashPaymentSecretZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_PaymentHashPaymentSecretZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentSecretZ_clone"))) TS_C2Tuple_PaymentHashPaymentSecretZ_clone(uint32_t orig) {
	LDKC2Tuple_PaymentHashPaymentSecretZ* orig_conv = (LDKC2Tuple_PaymentHashPaymentSecretZ*)(orig & ~1);
	LDKC2Tuple_PaymentHashPaymentSecretZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentSecretZ), "LDKC2Tuple_PaymentHashPaymentSecretZ");
	*ret_conv = C2Tuple_PaymentHashPaymentSecretZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentSecretZ_new"))) TS_C2Tuple_PaymentHashPaymentSecretZ_new(int8_tArray a, int8_tArray b) {
	LDKThirtyTwoBytes a_ref;
	CHECK(a->arr_len == 32);
	memcpy(a_ref.data, a->elems, 32); FREE(a);
	LDKThirtyTwoBytes b_ref;
	CHECK(b->arr_len == 32);
	memcpy(b_ref.data, b->elems, 32); FREE(b);
	LDKC2Tuple_PaymentHashPaymentSecretZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PaymentHashPaymentSecretZ), "LDKC2Tuple_PaymentHashPaymentSecretZ");
	*ret_conv = C2Tuple_PaymentHashPaymentSecretZ_new(a_ref, b_ref);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_PaymentHashPaymentSecretZ_free"))) TS_C2Tuple_PaymentHashPaymentSecretZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_PaymentHashPaymentSecretZ _res_conv = *(LDKC2Tuple_PaymentHashPaymentSecretZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_PaymentHashPaymentSecretZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKC2Tuple_PaymentHashPaymentSecretZ o_conv = *(LDKC2Tuple_PaymentHashPaymentSecretZ*)(o_ptr);
	o_conv = C2Tuple_PaymentHashPaymentSecretZ_clone((LDKC2Tuple_PaymentHashPaymentSecretZ*)(((uintptr_t)o) & ~1));
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_err"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_err() {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_is_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_is_ok(uint32_t o) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* o_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ*)(o & ~1);
	jboolean ret_val = CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_free"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ _res_conv = *(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_clone_ptr(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ *NONNULL_PTR arg) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_clone_ptr"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* arg_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_clone"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_clone(uint32_t orig) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* orig_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ*)(orig & ~1);
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKC2Tuple_PaymentHashPaymentSecretZ o_conv = *(LDKC2Tuple_PaymentHashPaymentSecretZ*)(o_ptr);
	o_conv = C2Tuple_PaymentHashPaymentSecretZ_clone((LDKC2Tuple_PaymentHashPaymentSecretZ*)(((uintptr_t)o) & ~1));
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_err"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKAPIError e_conv = *(LDKAPIError*)(e_ptr);
	e_conv = APIError_clone((LDKAPIError*)(((uintptr_t)e) & ~1));
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_is_ok"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_is_ok(uint32_t o) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* o_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ*)(o & ~1);
	jboolean ret_val = CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_free"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ _res_conv = *(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_clone_ptr(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ *NONNULL_PTR arg) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_clone_ptr"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* arg_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_clone"))) TS_CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_clone(uint32_t orig) {
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* orig_conv = (LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ*)(orig & ~1);
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ");
	*ret_conv = CResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretNoneZ_ok"))) TS_CResult_PaymentSecretNoneZ_ok(int8_tArray o) {
	LDKThirtyTwoBytes o_ref;
	CHECK(o->arr_len == 32);
	memcpy(o_ref.data, o->elems, 32); FREE(o);
	LDKCResult_PaymentSecretNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretNoneZ), "LDKCResult_PaymentSecretNoneZ");
	*ret_conv = CResult_PaymentSecretNoneZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretNoneZ_err"))) TS_CResult_PaymentSecretNoneZ_err() {
	LDKCResult_PaymentSecretNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretNoneZ), "LDKCResult_PaymentSecretNoneZ");
	*ret_conv = CResult_PaymentSecretNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PaymentSecretNoneZ_is_ok"))) TS_CResult_PaymentSecretNoneZ_is_ok(uint32_t o) {
	LDKCResult_PaymentSecretNoneZ* o_conv = (LDKCResult_PaymentSecretNoneZ*)(o & ~1);
	jboolean ret_val = CResult_PaymentSecretNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PaymentSecretNoneZ_free"))) TS_CResult_PaymentSecretNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PaymentSecretNoneZ _res_conv = *(LDKCResult_PaymentSecretNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PaymentSecretNoneZ_free(_res_conv);
}

static inline uintptr_t CResult_PaymentSecretNoneZ_clone_ptr(LDKCResult_PaymentSecretNoneZ *NONNULL_PTR arg) {
	LDKCResult_PaymentSecretNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretNoneZ), "LDKCResult_PaymentSecretNoneZ");
	*ret_conv = CResult_PaymentSecretNoneZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretNoneZ_clone_ptr"))) TS_CResult_PaymentSecretNoneZ_clone_ptr(uint32_t arg) {
	LDKCResult_PaymentSecretNoneZ* arg_conv = (LDKCResult_PaymentSecretNoneZ*)(arg & ~1);
	uint32_t ret_val = CResult_PaymentSecretNoneZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretNoneZ_clone"))) TS_CResult_PaymentSecretNoneZ_clone(uint32_t orig) {
	LDKCResult_PaymentSecretNoneZ* orig_conv = (LDKCResult_PaymentSecretNoneZ*)(orig & ~1);
	LDKCResult_PaymentSecretNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretNoneZ), "LDKCResult_PaymentSecretNoneZ");
	*ret_conv = CResult_PaymentSecretNoneZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretAPIErrorZ_ok"))) TS_CResult_PaymentSecretAPIErrorZ_ok(int8_tArray o) {
	LDKThirtyTwoBytes o_ref;
	CHECK(o->arr_len == 32);
	memcpy(o_ref.data, o->elems, 32); FREE(o);
	LDKCResult_PaymentSecretAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretAPIErrorZ), "LDKCResult_PaymentSecretAPIErrorZ");
	*ret_conv = CResult_PaymentSecretAPIErrorZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretAPIErrorZ_err"))) TS_CResult_PaymentSecretAPIErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKAPIError e_conv = *(LDKAPIError*)(e_ptr);
	e_conv = APIError_clone((LDKAPIError*)(((uintptr_t)e) & ~1));
	LDKCResult_PaymentSecretAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretAPIErrorZ), "LDKCResult_PaymentSecretAPIErrorZ");
	*ret_conv = CResult_PaymentSecretAPIErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PaymentSecretAPIErrorZ_is_ok"))) TS_CResult_PaymentSecretAPIErrorZ_is_ok(uint32_t o) {
	LDKCResult_PaymentSecretAPIErrorZ* o_conv = (LDKCResult_PaymentSecretAPIErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PaymentSecretAPIErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PaymentSecretAPIErrorZ_free"))) TS_CResult_PaymentSecretAPIErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PaymentSecretAPIErrorZ _res_conv = *(LDKCResult_PaymentSecretAPIErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PaymentSecretAPIErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PaymentSecretAPIErrorZ_clone_ptr(LDKCResult_PaymentSecretAPIErrorZ *NONNULL_PTR arg) {
	LDKCResult_PaymentSecretAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretAPIErrorZ), "LDKCResult_PaymentSecretAPIErrorZ");
	*ret_conv = CResult_PaymentSecretAPIErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretAPIErrorZ_clone_ptr"))) TS_CResult_PaymentSecretAPIErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PaymentSecretAPIErrorZ* arg_conv = (LDKCResult_PaymentSecretAPIErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PaymentSecretAPIErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentSecretAPIErrorZ_clone"))) TS_CResult_PaymentSecretAPIErrorZ_clone(uint32_t orig) {
	LDKCResult_PaymentSecretAPIErrorZ* orig_conv = (LDKCResult_PaymentSecretAPIErrorZ*)(orig & ~1);
	LDKCResult_PaymentSecretAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretAPIErrorZ), "LDKCResult_PaymentSecretAPIErrorZ");
	*ret_conv = CResult_PaymentSecretAPIErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentPreimageAPIErrorZ_ok"))) TS_CResult_PaymentPreimageAPIErrorZ_ok(int8_tArray o) {
	LDKThirtyTwoBytes o_ref;
	CHECK(o->arr_len == 32);
	memcpy(o_ref.data, o->elems, 32); FREE(o);
	LDKCResult_PaymentPreimageAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentPreimageAPIErrorZ), "LDKCResult_PaymentPreimageAPIErrorZ");
	*ret_conv = CResult_PaymentPreimageAPIErrorZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentPreimageAPIErrorZ_err"))) TS_CResult_PaymentPreimageAPIErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKAPIError e_conv = *(LDKAPIError*)(e_ptr);
	e_conv = APIError_clone((LDKAPIError*)(((uintptr_t)e) & ~1));
	LDKCResult_PaymentPreimageAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentPreimageAPIErrorZ), "LDKCResult_PaymentPreimageAPIErrorZ");
	*ret_conv = CResult_PaymentPreimageAPIErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PaymentPreimageAPIErrorZ_is_ok"))) TS_CResult_PaymentPreimageAPIErrorZ_is_ok(uint32_t o) {
	LDKCResult_PaymentPreimageAPIErrorZ* o_conv = (LDKCResult_PaymentPreimageAPIErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PaymentPreimageAPIErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PaymentPreimageAPIErrorZ_free"))) TS_CResult_PaymentPreimageAPIErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PaymentPreimageAPIErrorZ _res_conv = *(LDKCResult_PaymentPreimageAPIErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PaymentPreimageAPIErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PaymentPreimageAPIErrorZ_clone_ptr(LDKCResult_PaymentPreimageAPIErrorZ *NONNULL_PTR arg) {
	LDKCResult_PaymentPreimageAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentPreimageAPIErrorZ), "LDKCResult_PaymentPreimageAPIErrorZ");
	*ret_conv = CResult_PaymentPreimageAPIErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentPreimageAPIErrorZ_clone_ptr"))) TS_CResult_PaymentPreimageAPIErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PaymentPreimageAPIErrorZ* arg_conv = (LDKCResult_PaymentPreimageAPIErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PaymentPreimageAPIErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentPreimageAPIErrorZ_clone"))) TS_CResult_PaymentPreimageAPIErrorZ_clone(uint32_t orig) {
	LDKCResult_PaymentPreimageAPIErrorZ* orig_conv = (LDKCResult_PaymentPreimageAPIErrorZ*)(orig & ~1);
	LDKCResult_PaymentPreimageAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentPreimageAPIErrorZ), "LDKCResult_PaymentPreimageAPIErrorZ");
	*ret_conv = CResult_PaymentPreimageAPIErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_ok"))) TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_ok(uint32_t o) {
	LDKCounterpartyForwardingInfo o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = CounterpartyForwardingInfo_clone(&o_conv);
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ), "LDKCResult_CounterpartyForwardingInfoDecodeErrorZ");
	*ret_conv = CResult_CounterpartyForwardingInfoDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_err"))) TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ), "LDKCResult_CounterpartyForwardingInfoDecodeErrorZ");
	*ret_conv = CResult_CounterpartyForwardingInfoDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_is_ok"))) TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* o_conv = (LDKCResult_CounterpartyForwardingInfoDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_CounterpartyForwardingInfoDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_free"))) TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ _res_conv = *(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_CounterpartyForwardingInfoDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_CounterpartyForwardingInfoDecodeErrorZ_clone_ptr(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ), "LDKCResult_CounterpartyForwardingInfoDecodeErrorZ");
	*ret_conv = CResult_CounterpartyForwardingInfoDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_clone_ptr"))) TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* arg_conv = (LDKCResult_CounterpartyForwardingInfoDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_CounterpartyForwardingInfoDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_clone"))) TS_CResult_CounterpartyForwardingInfoDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* orig_conv = (LDKCResult_CounterpartyForwardingInfoDecodeErrorZ*)(orig & ~1);
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ), "LDKCResult_CounterpartyForwardingInfoDecodeErrorZ");
	*ret_conv = CResult_CounterpartyForwardingInfoDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelCounterpartyDecodeErrorZ_ok"))) TS_CResult_ChannelCounterpartyDecodeErrorZ_ok(uint32_t o) {
	LDKChannelCounterparty o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelCounterparty_clone(&o_conv);
	LDKCResult_ChannelCounterpartyDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelCounterpartyDecodeErrorZ), "LDKCResult_ChannelCounterpartyDecodeErrorZ");
	*ret_conv = CResult_ChannelCounterpartyDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelCounterpartyDecodeErrorZ_err"))) TS_CResult_ChannelCounterpartyDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelCounterpartyDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelCounterpartyDecodeErrorZ), "LDKCResult_ChannelCounterpartyDecodeErrorZ");
	*ret_conv = CResult_ChannelCounterpartyDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelCounterpartyDecodeErrorZ_is_ok"))) TS_CResult_ChannelCounterpartyDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelCounterpartyDecodeErrorZ* o_conv = (LDKCResult_ChannelCounterpartyDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelCounterpartyDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelCounterpartyDecodeErrorZ_free"))) TS_CResult_ChannelCounterpartyDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelCounterpartyDecodeErrorZ _res_conv = *(LDKCResult_ChannelCounterpartyDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelCounterpartyDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelCounterpartyDecodeErrorZ_clone_ptr(LDKCResult_ChannelCounterpartyDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelCounterpartyDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelCounterpartyDecodeErrorZ), "LDKCResult_ChannelCounterpartyDecodeErrorZ");
	*ret_conv = CResult_ChannelCounterpartyDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelCounterpartyDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelCounterpartyDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelCounterpartyDecodeErrorZ* arg_conv = (LDKCResult_ChannelCounterpartyDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelCounterpartyDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelCounterpartyDecodeErrorZ_clone"))) TS_CResult_ChannelCounterpartyDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelCounterpartyDecodeErrorZ* orig_conv = (LDKCResult_ChannelCounterpartyDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelCounterpartyDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelCounterpartyDecodeErrorZ), "LDKCResult_ChannelCounterpartyDecodeErrorZ");
	*ret_conv = CResult_ChannelCounterpartyDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelDetailsDecodeErrorZ_ok"))) TS_CResult_ChannelDetailsDecodeErrorZ_ok(uint32_t o) {
	LDKChannelDetails o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelDetails_clone(&o_conv);
	LDKCResult_ChannelDetailsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelDetailsDecodeErrorZ), "LDKCResult_ChannelDetailsDecodeErrorZ");
	*ret_conv = CResult_ChannelDetailsDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelDetailsDecodeErrorZ_err"))) TS_CResult_ChannelDetailsDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelDetailsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelDetailsDecodeErrorZ), "LDKCResult_ChannelDetailsDecodeErrorZ");
	*ret_conv = CResult_ChannelDetailsDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelDetailsDecodeErrorZ_is_ok"))) TS_CResult_ChannelDetailsDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelDetailsDecodeErrorZ* o_conv = (LDKCResult_ChannelDetailsDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelDetailsDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelDetailsDecodeErrorZ_free"))) TS_CResult_ChannelDetailsDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelDetailsDecodeErrorZ _res_conv = *(LDKCResult_ChannelDetailsDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelDetailsDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelDetailsDecodeErrorZ_clone_ptr(LDKCResult_ChannelDetailsDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelDetailsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelDetailsDecodeErrorZ), "LDKCResult_ChannelDetailsDecodeErrorZ");
	*ret_conv = CResult_ChannelDetailsDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelDetailsDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelDetailsDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelDetailsDecodeErrorZ* arg_conv = (LDKCResult_ChannelDetailsDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelDetailsDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelDetailsDecodeErrorZ_clone"))) TS_CResult_ChannelDetailsDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelDetailsDecodeErrorZ* orig_conv = (LDKCResult_ChannelDetailsDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelDetailsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelDetailsDecodeErrorZ), "LDKCResult_ChannelDetailsDecodeErrorZ");
	*ret_conv = CResult_ChannelDetailsDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PhantomRouteHintsDecodeErrorZ_ok"))) TS_CResult_PhantomRouteHintsDecodeErrorZ_ok(uint32_t o) {
	LDKPhantomRouteHints o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = PhantomRouteHints_clone(&o_conv);
	LDKCResult_PhantomRouteHintsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PhantomRouteHintsDecodeErrorZ), "LDKCResult_PhantomRouteHintsDecodeErrorZ");
	*ret_conv = CResult_PhantomRouteHintsDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PhantomRouteHintsDecodeErrorZ_err"))) TS_CResult_PhantomRouteHintsDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_PhantomRouteHintsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PhantomRouteHintsDecodeErrorZ), "LDKCResult_PhantomRouteHintsDecodeErrorZ");
	*ret_conv = CResult_PhantomRouteHintsDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PhantomRouteHintsDecodeErrorZ_is_ok"))) TS_CResult_PhantomRouteHintsDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_PhantomRouteHintsDecodeErrorZ* o_conv = (LDKCResult_PhantomRouteHintsDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PhantomRouteHintsDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PhantomRouteHintsDecodeErrorZ_free"))) TS_CResult_PhantomRouteHintsDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PhantomRouteHintsDecodeErrorZ _res_conv = *(LDKCResult_PhantomRouteHintsDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PhantomRouteHintsDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PhantomRouteHintsDecodeErrorZ_clone_ptr(LDKCResult_PhantomRouteHintsDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_PhantomRouteHintsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PhantomRouteHintsDecodeErrorZ), "LDKCResult_PhantomRouteHintsDecodeErrorZ");
	*ret_conv = CResult_PhantomRouteHintsDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PhantomRouteHintsDecodeErrorZ_clone_ptr"))) TS_CResult_PhantomRouteHintsDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PhantomRouteHintsDecodeErrorZ* arg_conv = (LDKCResult_PhantomRouteHintsDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PhantomRouteHintsDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PhantomRouteHintsDecodeErrorZ_clone"))) TS_CResult_PhantomRouteHintsDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_PhantomRouteHintsDecodeErrorZ* orig_conv = (LDKCResult_PhantomRouteHintsDecodeErrorZ*)(orig & ~1);
	LDKCResult_PhantomRouteHintsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PhantomRouteHintsDecodeErrorZ), "LDKCResult_PhantomRouteHintsDecodeErrorZ");
	*ret_conv = CResult_PhantomRouteHintsDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_ChannelMonitorZ_free"))) TS_CVec_ChannelMonitorZ_free(uint32_tArray _res) {
	LDKCVec_ChannelMonitorZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKChannelMonitor), "LDKCVec_ChannelMonitorZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t q = 0; q < _res_constr.datalen; q++) {
		uint32_t _res_conv_16 = _res_vals[q];
		LDKChannelMonitor _res_conv_16_conv;
		_res_conv_16_conv.inner = (void*)(_res_conv_16 & (~1));
		_res_conv_16_conv.is_owned = (_res_conv_16 & 1) || (_res_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_16_conv);
		_res_constr.data[q] = _res_conv_16_conv;
	}
	CVec_ChannelMonitorZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_BlockHashChannelManagerZ_new"))) TS_C2Tuple_BlockHashChannelManagerZ_new(int8_tArray a, uint32_t b) {
	LDKThirtyTwoBytes a_ref;
	CHECK(a->arr_len == 32);
	memcpy(a_ref.data, a->elems, 32); FREE(a);
	LDKChannelManager b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = (b & 1) || (b == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	// WARNING: we need a move here but no clone is available for LDKChannelManager
	LDKC2Tuple_BlockHashChannelManagerZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_BlockHashChannelManagerZ), "LDKC2Tuple_BlockHashChannelManagerZ");
	*ret_conv = C2Tuple_BlockHashChannelManagerZ_new(a_ref, b_conv);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_BlockHashChannelManagerZ_free"))) TS_C2Tuple_BlockHashChannelManagerZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_BlockHashChannelManagerZ _res_conv = *(LDKC2Tuple_BlockHashChannelManagerZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_BlockHashChannelManagerZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_ok"))) TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKC2Tuple_BlockHashChannelManagerZ o_conv = *(LDKC2Tuple_BlockHashChannelManagerZ*)(o_ptr);
	// WARNING: we may need a move here but no clone is available for LDKC2Tuple_BlockHashChannelManagerZ
	LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ), "LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ");
	*ret_conv = CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_err"))) TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ), "LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ");
	*ret_conv = CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_is_ok"))) TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ* o_conv = (LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_free"))) TS_CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ _res_conv = *(LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelConfigDecodeErrorZ_ok"))) TS_CResult_ChannelConfigDecodeErrorZ_ok(uint32_t o) {
	LDKChannelConfig o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelConfig_clone(&o_conv);
	LDKCResult_ChannelConfigDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelConfigDecodeErrorZ), "LDKCResult_ChannelConfigDecodeErrorZ");
	*ret_conv = CResult_ChannelConfigDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelConfigDecodeErrorZ_err"))) TS_CResult_ChannelConfigDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelConfigDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelConfigDecodeErrorZ), "LDKCResult_ChannelConfigDecodeErrorZ");
	*ret_conv = CResult_ChannelConfigDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelConfigDecodeErrorZ_is_ok"))) TS_CResult_ChannelConfigDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelConfigDecodeErrorZ* o_conv = (LDKCResult_ChannelConfigDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelConfigDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelConfigDecodeErrorZ_free"))) TS_CResult_ChannelConfigDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelConfigDecodeErrorZ _res_conv = *(LDKCResult_ChannelConfigDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelConfigDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelConfigDecodeErrorZ_clone_ptr(LDKCResult_ChannelConfigDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelConfigDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelConfigDecodeErrorZ), "LDKCResult_ChannelConfigDecodeErrorZ");
	*ret_conv = CResult_ChannelConfigDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelConfigDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelConfigDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelConfigDecodeErrorZ* arg_conv = (LDKCResult_ChannelConfigDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelConfigDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelConfigDecodeErrorZ_clone"))) TS_CResult_ChannelConfigDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelConfigDecodeErrorZ* orig_conv = (LDKCResult_ChannelConfigDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelConfigDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelConfigDecodeErrorZ), "LDKCResult_ChannelConfigDecodeErrorZ");
	*ret_conv = CResult_ChannelConfigDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_OutPointDecodeErrorZ_ok"))) TS_CResult_OutPointDecodeErrorZ_ok(uint32_t o) {
	LDKOutPoint o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = OutPoint_clone(&o_conv);
	LDKCResult_OutPointDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OutPointDecodeErrorZ), "LDKCResult_OutPointDecodeErrorZ");
	*ret_conv = CResult_OutPointDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_OutPointDecodeErrorZ_err"))) TS_CResult_OutPointDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_OutPointDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OutPointDecodeErrorZ), "LDKCResult_OutPointDecodeErrorZ");
	*ret_conv = CResult_OutPointDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_OutPointDecodeErrorZ_is_ok"))) TS_CResult_OutPointDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_OutPointDecodeErrorZ* o_conv = (LDKCResult_OutPointDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_OutPointDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_OutPointDecodeErrorZ_free"))) TS_CResult_OutPointDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_OutPointDecodeErrorZ _res_conv = *(LDKCResult_OutPointDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_OutPointDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_OutPointDecodeErrorZ_clone_ptr(LDKCResult_OutPointDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_OutPointDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OutPointDecodeErrorZ), "LDKCResult_OutPointDecodeErrorZ");
	*ret_conv = CResult_OutPointDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_OutPointDecodeErrorZ_clone_ptr"))) TS_CResult_OutPointDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_OutPointDecodeErrorZ* arg_conv = (LDKCResult_OutPointDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_OutPointDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_OutPointDecodeErrorZ_clone"))) TS_CResult_OutPointDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_OutPointDecodeErrorZ* orig_conv = (LDKCResult_OutPointDecodeErrorZ*)(orig & ~1);
	LDKCResult_OutPointDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OutPointDecodeErrorZ), "LDKCResult_OutPointDecodeErrorZ");
	*ret_conv = CResult_OutPointDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_TypeZ_some"))) TS_COption_TypeZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKType o_conv = *(LDKType*)(o_ptr);
	if (o_conv.free == LDKType_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKType_JCalls_cloned(&o_conv);
	}
	LDKCOption_TypeZ *ret_copy = MALLOC(sizeof(LDKCOption_TypeZ), "LDKCOption_TypeZ");
	*ret_copy = COption_TypeZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_TypeZ_none"))) TS_COption_TypeZ_none() {
	LDKCOption_TypeZ *ret_copy = MALLOC(sizeof(LDKCOption_TypeZ), "LDKCOption_TypeZ");
	*ret_copy = COption_TypeZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_TypeZ_free"))) TS_COption_TypeZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_TypeZ _res_conv = *(LDKCOption_TypeZ*)(_res_ptr);
	FREE((void*)_res);
	COption_TypeZ_free(_res_conv);
}

static inline uintptr_t COption_TypeZ_clone_ptr(LDKCOption_TypeZ *NONNULL_PTR arg) {
	LDKCOption_TypeZ *ret_copy = MALLOC(sizeof(LDKCOption_TypeZ), "LDKCOption_TypeZ");
	*ret_copy = COption_TypeZ_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_TypeZ_clone_ptr"))) TS_COption_TypeZ_clone_ptr(uint32_t arg) {
	LDKCOption_TypeZ* arg_conv = (LDKCOption_TypeZ*)arg;
	uint32_t ret_val = COption_TypeZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_TypeZ_clone"))) TS_COption_TypeZ_clone(uint32_t orig) {
	LDKCOption_TypeZ* orig_conv = (LDKCOption_TypeZ*)orig;
	LDKCOption_TypeZ *ret_copy = MALLOC(sizeof(LDKCOption_TypeZ), "LDKCOption_TypeZ");
	*ret_copy = COption_TypeZ_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_TypeZDecodeErrorZ_ok"))) TS_CResult_COption_TypeZDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKCOption_TypeZ o_conv = *(LDKCOption_TypeZ*)(o_ptr);
	o_conv = COption_TypeZ_clone((LDKCOption_TypeZ*)(((uintptr_t)o) & ~1));
	LDKCResult_COption_TypeZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_TypeZDecodeErrorZ), "LDKCResult_COption_TypeZDecodeErrorZ");
	*ret_conv = CResult_COption_TypeZDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_TypeZDecodeErrorZ_err"))) TS_CResult_COption_TypeZDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_COption_TypeZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_TypeZDecodeErrorZ), "LDKCResult_COption_TypeZDecodeErrorZ");
	*ret_conv = CResult_COption_TypeZDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_COption_TypeZDecodeErrorZ_is_ok"))) TS_CResult_COption_TypeZDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_COption_TypeZDecodeErrorZ* o_conv = (LDKCResult_COption_TypeZDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_COption_TypeZDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_COption_TypeZDecodeErrorZ_free"))) TS_CResult_COption_TypeZDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_COption_TypeZDecodeErrorZ _res_conv = *(LDKCResult_COption_TypeZDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_COption_TypeZDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_COption_TypeZDecodeErrorZ_clone_ptr(LDKCResult_COption_TypeZDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_COption_TypeZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_TypeZDecodeErrorZ), "LDKCResult_COption_TypeZDecodeErrorZ");
	*ret_conv = CResult_COption_TypeZDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_COption_TypeZDecodeErrorZ_clone_ptr"))) TS_CResult_COption_TypeZDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_COption_TypeZDecodeErrorZ* arg_conv = (LDKCResult_COption_TypeZDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_COption_TypeZDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_TypeZDecodeErrorZ_clone"))) TS_CResult_COption_TypeZDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_COption_TypeZDecodeErrorZ* orig_conv = (LDKCResult_COption_TypeZDecodeErrorZ*)(orig & ~1);
	LDKCResult_COption_TypeZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_TypeZDecodeErrorZ), "LDKCResult_COption_TypeZDecodeErrorZ");
	*ret_conv = CResult_COption_TypeZDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentErrorZ_ok"))) TS_CResult_PaymentIdPaymentErrorZ_ok(int8_tArray o) {
	LDKThirtyTwoBytes o_ref;
	CHECK(o->arr_len == 32);
	memcpy(o_ref.data, o->elems, 32); FREE(o);
	LDKCResult_PaymentIdPaymentErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentErrorZ), "LDKCResult_PaymentIdPaymentErrorZ");
	*ret_conv = CResult_PaymentIdPaymentErrorZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentErrorZ_err"))) TS_CResult_PaymentIdPaymentErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKPaymentError e_conv = *(LDKPaymentError*)(e_ptr);
	e_conv = PaymentError_clone((LDKPaymentError*)(((uintptr_t)e) & ~1));
	LDKCResult_PaymentIdPaymentErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentErrorZ), "LDKCResult_PaymentIdPaymentErrorZ");
	*ret_conv = CResult_PaymentIdPaymentErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PaymentIdPaymentErrorZ_is_ok"))) TS_CResult_PaymentIdPaymentErrorZ_is_ok(uint32_t o) {
	LDKCResult_PaymentIdPaymentErrorZ* o_conv = (LDKCResult_PaymentIdPaymentErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PaymentIdPaymentErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PaymentIdPaymentErrorZ_free"))) TS_CResult_PaymentIdPaymentErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PaymentIdPaymentErrorZ _res_conv = *(LDKCResult_PaymentIdPaymentErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PaymentIdPaymentErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PaymentIdPaymentErrorZ_clone_ptr(LDKCResult_PaymentIdPaymentErrorZ *NONNULL_PTR arg) {
	LDKCResult_PaymentIdPaymentErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentErrorZ), "LDKCResult_PaymentIdPaymentErrorZ");
	*ret_conv = CResult_PaymentIdPaymentErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentErrorZ_clone_ptr"))) TS_CResult_PaymentIdPaymentErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PaymentIdPaymentErrorZ* arg_conv = (LDKCResult_PaymentIdPaymentErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PaymentIdPaymentErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PaymentIdPaymentErrorZ_clone"))) TS_CResult_PaymentIdPaymentErrorZ_clone(uint32_t orig) {
	LDKCResult_PaymentIdPaymentErrorZ* orig_conv = (LDKCResult_PaymentIdPaymentErrorZ*)(orig & ~1);
	LDKCResult_PaymentIdPaymentErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentErrorZ), "LDKCResult_PaymentIdPaymentErrorZ");
	*ret_conv = CResult_PaymentIdPaymentErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SiPrefixParseErrorZ_ok"))) TS_CResult_SiPrefixParseErrorZ_ok(uint32_t o) {
	LDKSiPrefix o_conv = LDKSiPrefix_from_js(o);
	LDKCResult_SiPrefixParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SiPrefixParseErrorZ), "LDKCResult_SiPrefixParseErrorZ");
	*ret_conv = CResult_SiPrefixParseErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SiPrefixParseErrorZ_err"))) TS_CResult_SiPrefixParseErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKParseError e_conv = *(LDKParseError*)(e_ptr);
	e_conv = ParseError_clone((LDKParseError*)(((uintptr_t)e) & ~1));
	LDKCResult_SiPrefixParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SiPrefixParseErrorZ), "LDKCResult_SiPrefixParseErrorZ");
	*ret_conv = CResult_SiPrefixParseErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_SiPrefixParseErrorZ_is_ok"))) TS_CResult_SiPrefixParseErrorZ_is_ok(uint32_t o) {
	LDKCResult_SiPrefixParseErrorZ* o_conv = (LDKCResult_SiPrefixParseErrorZ*)(o & ~1);
	jboolean ret_val = CResult_SiPrefixParseErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_SiPrefixParseErrorZ_free"))) TS_CResult_SiPrefixParseErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_SiPrefixParseErrorZ _res_conv = *(LDKCResult_SiPrefixParseErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_SiPrefixParseErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_SiPrefixParseErrorZ_clone_ptr(LDKCResult_SiPrefixParseErrorZ *NONNULL_PTR arg) {
	LDKCResult_SiPrefixParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SiPrefixParseErrorZ), "LDKCResult_SiPrefixParseErrorZ");
	*ret_conv = CResult_SiPrefixParseErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_SiPrefixParseErrorZ_clone_ptr"))) TS_CResult_SiPrefixParseErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_SiPrefixParseErrorZ* arg_conv = (LDKCResult_SiPrefixParseErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_SiPrefixParseErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_SiPrefixParseErrorZ_clone"))) TS_CResult_SiPrefixParseErrorZ_clone(uint32_t orig) {
	LDKCResult_SiPrefixParseErrorZ* orig_conv = (LDKCResult_SiPrefixParseErrorZ*)(orig & ~1);
	LDKCResult_SiPrefixParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SiPrefixParseErrorZ), "LDKCResult_SiPrefixParseErrorZ");
	*ret_conv = CResult_SiPrefixParseErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceParseOrSemanticErrorZ_ok"))) TS_CResult_InvoiceParseOrSemanticErrorZ_ok(uint32_t o) {
	LDKInvoice o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Invoice_clone(&o_conv);
	LDKCResult_InvoiceParseOrSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceParseOrSemanticErrorZ), "LDKCResult_InvoiceParseOrSemanticErrorZ");
	*ret_conv = CResult_InvoiceParseOrSemanticErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceParseOrSemanticErrorZ_err"))) TS_CResult_InvoiceParseOrSemanticErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKParseOrSemanticError e_conv = *(LDKParseOrSemanticError*)(e_ptr);
	e_conv = ParseOrSemanticError_clone((LDKParseOrSemanticError*)(((uintptr_t)e) & ~1));
	LDKCResult_InvoiceParseOrSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceParseOrSemanticErrorZ), "LDKCResult_InvoiceParseOrSemanticErrorZ");
	*ret_conv = CResult_InvoiceParseOrSemanticErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_InvoiceParseOrSemanticErrorZ_is_ok"))) TS_CResult_InvoiceParseOrSemanticErrorZ_is_ok(uint32_t o) {
	LDKCResult_InvoiceParseOrSemanticErrorZ* o_conv = (LDKCResult_InvoiceParseOrSemanticErrorZ*)(o & ~1);
	jboolean ret_val = CResult_InvoiceParseOrSemanticErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_InvoiceParseOrSemanticErrorZ_free"))) TS_CResult_InvoiceParseOrSemanticErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_InvoiceParseOrSemanticErrorZ _res_conv = *(LDKCResult_InvoiceParseOrSemanticErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_InvoiceParseOrSemanticErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_InvoiceParseOrSemanticErrorZ_clone_ptr(LDKCResult_InvoiceParseOrSemanticErrorZ *NONNULL_PTR arg) {
	LDKCResult_InvoiceParseOrSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceParseOrSemanticErrorZ), "LDKCResult_InvoiceParseOrSemanticErrorZ");
	*ret_conv = CResult_InvoiceParseOrSemanticErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceParseOrSemanticErrorZ_clone_ptr"))) TS_CResult_InvoiceParseOrSemanticErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_InvoiceParseOrSemanticErrorZ* arg_conv = (LDKCResult_InvoiceParseOrSemanticErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_InvoiceParseOrSemanticErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceParseOrSemanticErrorZ_clone"))) TS_CResult_InvoiceParseOrSemanticErrorZ_clone(uint32_t orig) {
	LDKCResult_InvoiceParseOrSemanticErrorZ* orig_conv = (LDKCResult_InvoiceParseOrSemanticErrorZ*)(orig & ~1);
	LDKCResult_InvoiceParseOrSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceParseOrSemanticErrorZ), "LDKCResult_InvoiceParseOrSemanticErrorZ");
	*ret_conv = CResult_InvoiceParseOrSemanticErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SignedRawInvoiceParseErrorZ_ok"))) TS_CResult_SignedRawInvoiceParseErrorZ_ok(uint32_t o) {
	LDKSignedRawInvoice o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = SignedRawInvoice_clone(&o_conv);
	LDKCResult_SignedRawInvoiceParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignedRawInvoiceParseErrorZ), "LDKCResult_SignedRawInvoiceParseErrorZ");
	*ret_conv = CResult_SignedRawInvoiceParseErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_SignedRawInvoiceParseErrorZ_err"))) TS_CResult_SignedRawInvoiceParseErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKParseError e_conv = *(LDKParseError*)(e_ptr);
	e_conv = ParseError_clone((LDKParseError*)(((uintptr_t)e) & ~1));
	LDKCResult_SignedRawInvoiceParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignedRawInvoiceParseErrorZ), "LDKCResult_SignedRawInvoiceParseErrorZ");
	*ret_conv = CResult_SignedRawInvoiceParseErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_SignedRawInvoiceParseErrorZ_is_ok"))) TS_CResult_SignedRawInvoiceParseErrorZ_is_ok(uint32_t o) {
	LDKCResult_SignedRawInvoiceParseErrorZ* o_conv = (LDKCResult_SignedRawInvoiceParseErrorZ*)(o & ~1);
	jboolean ret_val = CResult_SignedRawInvoiceParseErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_SignedRawInvoiceParseErrorZ_free"))) TS_CResult_SignedRawInvoiceParseErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_SignedRawInvoiceParseErrorZ _res_conv = *(LDKCResult_SignedRawInvoiceParseErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_SignedRawInvoiceParseErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_SignedRawInvoiceParseErrorZ_clone_ptr(LDKCResult_SignedRawInvoiceParseErrorZ *NONNULL_PTR arg) {
	LDKCResult_SignedRawInvoiceParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignedRawInvoiceParseErrorZ), "LDKCResult_SignedRawInvoiceParseErrorZ");
	*ret_conv = CResult_SignedRawInvoiceParseErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_SignedRawInvoiceParseErrorZ_clone_ptr"))) TS_CResult_SignedRawInvoiceParseErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_SignedRawInvoiceParseErrorZ* arg_conv = (LDKCResult_SignedRawInvoiceParseErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_SignedRawInvoiceParseErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_SignedRawInvoiceParseErrorZ_clone"))) TS_CResult_SignedRawInvoiceParseErrorZ_clone(uint32_t orig) {
	LDKCResult_SignedRawInvoiceParseErrorZ* orig_conv = (LDKCResult_SignedRawInvoiceParseErrorZ*)(orig & ~1);
	LDKCResult_SignedRawInvoiceParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignedRawInvoiceParseErrorZ), "LDKCResult_SignedRawInvoiceParseErrorZ");
	*ret_conv = CResult_SignedRawInvoiceParseErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

static inline uintptr_t C3Tuple_RawInvoice_u832InvoiceSignatureZ_clone_ptr(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ *NONNULL_PTR arg) {
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* ret_conv = MALLOC(sizeof(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ), "LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ");
	*ret_conv = C3Tuple_RawInvoice_u832InvoiceSignatureZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_clone_ptr"))) TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_clone_ptr(uint32_t arg) {
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* arg_conv = (LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ*)(arg & ~1);
	uint32_t ret_val = C3Tuple_RawInvoice_u832InvoiceSignatureZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_clone"))) TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_clone(uint32_t orig) {
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* orig_conv = (LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ*)(orig & ~1);
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* ret_conv = MALLOC(sizeof(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ), "LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ");
	*ret_conv = C3Tuple_RawInvoice_u832InvoiceSignatureZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_new"))) TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_new(uint32_t a, int8_tArray b, uint32_t c) {
	LDKRawInvoice a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = RawInvoice_clone(&a_conv);
	LDKThirtyTwoBytes b_ref;
	CHECK(b->arr_len == 32);
	memcpy(b_ref.data, b->elems, 32); FREE(b);
	LDKInvoiceSignature c_conv;
	c_conv.inner = (void*)(c & (~1));
	c_conv.is_owned = (c & 1) || (c == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(c_conv);
	c_conv = InvoiceSignature_clone(&c_conv);
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* ret_conv = MALLOC(sizeof(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ), "LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ");
	*ret_conv = C3Tuple_RawInvoice_u832InvoiceSignatureZ_new(a_conv, b_ref, c_conv);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_free"))) TS_C3Tuple_RawInvoice_u832InvoiceSignatureZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ _res_conv = *(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ*)(_res_ptr);
	FREE((void*)_res);
	C3Tuple_RawInvoice_u832InvoiceSignatureZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_PayeePubKeyErrorZ_ok"))) TS_CResult_PayeePubKeyErrorZ_ok(uint32_t o) {
	LDKPayeePubKey o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = PayeePubKey_clone(&o_conv);
	LDKCResult_PayeePubKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PayeePubKeyErrorZ), "LDKCResult_PayeePubKeyErrorZ");
	*ret_conv = CResult_PayeePubKeyErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PayeePubKeyErrorZ_err"))) TS_CResult_PayeePubKeyErrorZ_err(uint32_t e) {
	LDKSecp256k1Error e_conv = LDKSecp256k1Error_from_js(e);
	LDKCResult_PayeePubKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PayeePubKeyErrorZ), "LDKCResult_PayeePubKeyErrorZ");
	*ret_conv = CResult_PayeePubKeyErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PayeePubKeyErrorZ_is_ok"))) TS_CResult_PayeePubKeyErrorZ_is_ok(uint32_t o) {
	LDKCResult_PayeePubKeyErrorZ* o_conv = (LDKCResult_PayeePubKeyErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PayeePubKeyErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PayeePubKeyErrorZ_free"))) TS_CResult_PayeePubKeyErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PayeePubKeyErrorZ _res_conv = *(LDKCResult_PayeePubKeyErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PayeePubKeyErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PayeePubKeyErrorZ_clone_ptr(LDKCResult_PayeePubKeyErrorZ *NONNULL_PTR arg) {
	LDKCResult_PayeePubKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PayeePubKeyErrorZ), "LDKCResult_PayeePubKeyErrorZ");
	*ret_conv = CResult_PayeePubKeyErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PayeePubKeyErrorZ_clone_ptr"))) TS_CResult_PayeePubKeyErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PayeePubKeyErrorZ* arg_conv = (LDKCResult_PayeePubKeyErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PayeePubKeyErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PayeePubKeyErrorZ_clone"))) TS_CResult_PayeePubKeyErrorZ_clone(uint32_t orig) {
	LDKCResult_PayeePubKeyErrorZ* orig_conv = (LDKCResult_PayeePubKeyErrorZ*)(orig & ~1);
	LDKCResult_PayeePubKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PayeePubKeyErrorZ), "LDKCResult_PayeePubKeyErrorZ");
	*ret_conv = CResult_PayeePubKeyErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_PrivateRouteZ_free"))) TS_CVec_PrivateRouteZ_free(uint32_tArray _res) {
	LDKCVec_PrivateRouteZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKPrivateRoute), "LDKCVec_PrivateRouteZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t o = 0; o < _res_constr.datalen; o++) {
		uint32_t _res_conv_14 = _res_vals[o];
		LDKPrivateRoute _res_conv_14_conv;
		_res_conv_14_conv.inner = (void*)(_res_conv_14 & (~1));
		_res_conv_14_conv.is_owned = (_res_conv_14 & 1) || (_res_conv_14 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_14_conv);
		_res_constr.data[o] = _res_conv_14_conv;
	}
	CVec_PrivateRouteZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_PositiveTimestampCreationErrorZ_ok"))) TS_CResult_PositiveTimestampCreationErrorZ_ok(uint32_t o) {
	LDKPositiveTimestamp o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = PositiveTimestamp_clone(&o_conv);
	LDKCResult_PositiveTimestampCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PositiveTimestampCreationErrorZ), "LDKCResult_PositiveTimestampCreationErrorZ");
	*ret_conv = CResult_PositiveTimestampCreationErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PositiveTimestampCreationErrorZ_err"))) TS_CResult_PositiveTimestampCreationErrorZ_err(uint32_t e) {
	LDKCreationError e_conv = LDKCreationError_from_js(e);
	LDKCResult_PositiveTimestampCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PositiveTimestampCreationErrorZ), "LDKCResult_PositiveTimestampCreationErrorZ");
	*ret_conv = CResult_PositiveTimestampCreationErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PositiveTimestampCreationErrorZ_is_ok"))) TS_CResult_PositiveTimestampCreationErrorZ_is_ok(uint32_t o) {
	LDKCResult_PositiveTimestampCreationErrorZ* o_conv = (LDKCResult_PositiveTimestampCreationErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PositiveTimestampCreationErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PositiveTimestampCreationErrorZ_free"))) TS_CResult_PositiveTimestampCreationErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PositiveTimestampCreationErrorZ _res_conv = *(LDKCResult_PositiveTimestampCreationErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PositiveTimestampCreationErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PositiveTimestampCreationErrorZ_clone_ptr(LDKCResult_PositiveTimestampCreationErrorZ *NONNULL_PTR arg) {
	LDKCResult_PositiveTimestampCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PositiveTimestampCreationErrorZ), "LDKCResult_PositiveTimestampCreationErrorZ");
	*ret_conv = CResult_PositiveTimestampCreationErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PositiveTimestampCreationErrorZ_clone_ptr"))) TS_CResult_PositiveTimestampCreationErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PositiveTimestampCreationErrorZ* arg_conv = (LDKCResult_PositiveTimestampCreationErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PositiveTimestampCreationErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PositiveTimestampCreationErrorZ_clone"))) TS_CResult_PositiveTimestampCreationErrorZ_clone(uint32_t orig) {
	LDKCResult_PositiveTimestampCreationErrorZ* orig_conv = (LDKCResult_PositiveTimestampCreationErrorZ*)(orig & ~1);
	LDKCResult_PositiveTimestampCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PositiveTimestampCreationErrorZ), "LDKCResult_PositiveTimestampCreationErrorZ");
	*ret_conv = CResult_PositiveTimestampCreationErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneSemanticErrorZ_ok"))) TS_CResult_NoneSemanticErrorZ_ok() {
	LDKCResult_NoneSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneSemanticErrorZ), "LDKCResult_NoneSemanticErrorZ");
	*ret_conv = CResult_NoneSemanticErrorZ_ok();
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneSemanticErrorZ_err"))) TS_CResult_NoneSemanticErrorZ_err(uint32_t e) {
	LDKSemanticError e_conv = LDKSemanticError_from_js(e);
	LDKCResult_NoneSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneSemanticErrorZ), "LDKCResult_NoneSemanticErrorZ");
	*ret_conv = CResult_NoneSemanticErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NoneSemanticErrorZ_is_ok"))) TS_CResult_NoneSemanticErrorZ_is_ok(uint32_t o) {
	LDKCResult_NoneSemanticErrorZ* o_conv = (LDKCResult_NoneSemanticErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NoneSemanticErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NoneSemanticErrorZ_free"))) TS_CResult_NoneSemanticErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NoneSemanticErrorZ _res_conv = *(LDKCResult_NoneSemanticErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NoneSemanticErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NoneSemanticErrorZ_clone_ptr(LDKCResult_NoneSemanticErrorZ *NONNULL_PTR arg) {
	LDKCResult_NoneSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneSemanticErrorZ), "LDKCResult_NoneSemanticErrorZ");
	*ret_conv = CResult_NoneSemanticErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NoneSemanticErrorZ_clone_ptr"))) TS_CResult_NoneSemanticErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NoneSemanticErrorZ* arg_conv = (LDKCResult_NoneSemanticErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NoneSemanticErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneSemanticErrorZ_clone"))) TS_CResult_NoneSemanticErrorZ_clone(uint32_t orig) {
	LDKCResult_NoneSemanticErrorZ* orig_conv = (LDKCResult_NoneSemanticErrorZ*)(orig & ~1);
	LDKCResult_NoneSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneSemanticErrorZ), "LDKCResult_NoneSemanticErrorZ");
	*ret_conv = CResult_NoneSemanticErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceSemanticErrorZ_ok"))) TS_CResult_InvoiceSemanticErrorZ_ok(uint32_t o) {
	LDKInvoice o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Invoice_clone(&o_conv);
	LDKCResult_InvoiceSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSemanticErrorZ), "LDKCResult_InvoiceSemanticErrorZ");
	*ret_conv = CResult_InvoiceSemanticErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceSemanticErrorZ_err"))) TS_CResult_InvoiceSemanticErrorZ_err(uint32_t e) {
	LDKSemanticError e_conv = LDKSemanticError_from_js(e);
	LDKCResult_InvoiceSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSemanticErrorZ), "LDKCResult_InvoiceSemanticErrorZ");
	*ret_conv = CResult_InvoiceSemanticErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_InvoiceSemanticErrorZ_is_ok"))) TS_CResult_InvoiceSemanticErrorZ_is_ok(uint32_t o) {
	LDKCResult_InvoiceSemanticErrorZ* o_conv = (LDKCResult_InvoiceSemanticErrorZ*)(o & ~1);
	jboolean ret_val = CResult_InvoiceSemanticErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_InvoiceSemanticErrorZ_free"))) TS_CResult_InvoiceSemanticErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_InvoiceSemanticErrorZ _res_conv = *(LDKCResult_InvoiceSemanticErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_InvoiceSemanticErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_InvoiceSemanticErrorZ_clone_ptr(LDKCResult_InvoiceSemanticErrorZ *NONNULL_PTR arg) {
	LDKCResult_InvoiceSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSemanticErrorZ), "LDKCResult_InvoiceSemanticErrorZ");
	*ret_conv = CResult_InvoiceSemanticErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceSemanticErrorZ_clone_ptr"))) TS_CResult_InvoiceSemanticErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_InvoiceSemanticErrorZ* arg_conv = (LDKCResult_InvoiceSemanticErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_InvoiceSemanticErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceSemanticErrorZ_clone"))) TS_CResult_InvoiceSemanticErrorZ_clone(uint32_t orig) {
	LDKCResult_InvoiceSemanticErrorZ* orig_conv = (LDKCResult_InvoiceSemanticErrorZ*)(orig & ~1);
	LDKCResult_InvoiceSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSemanticErrorZ), "LDKCResult_InvoiceSemanticErrorZ");
	*ret_conv = CResult_InvoiceSemanticErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_DescriptionCreationErrorZ_ok"))) TS_CResult_DescriptionCreationErrorZ_ok(uint32_t o) {
	LDKDescription o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Description_clone(&o_conv);
	LDKCResult_DescriptionCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DescriptionCreationErrorZ), "LDKCResult_DescriptionCreationErrorZ");
	*ret_conv = CResult_DescriptionCreationErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_DescriptionCreationErrorZ_err"))) TS_CResult_DescriptionCreationErrorZ_err(uint32_t e) {
	LDKCreationError e_conv = LDKCreationError_from_js(e);
	LDKCResult_DescriptionCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DescriptionCreationErrorZ), "LDKCResult_DescriptionCreationErrorZ");
	*ret_conv = CResult_DescriptionCreationErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_DescriptionCreationErrorZ_is_ok"))) TS_CResult_DescriptionCreationErrorZ_is_ok(uint32_t o) {
	LDKCResult_DescriptionCreationErrorZ* o_conv = (LDKCResult_DescriptionCreationErrorZ*)(o & ~1);
	jboolean ret_val = CResult_DescriptionCreationErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_DescriptionCreationErrorZ_free"))) TS_CResult_DescriptionCreationErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_DescriptionCreationErrorZ _res_conv = *(LDKCResult_DescriptionCreationErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_DescriptionCreationErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_DescriptionCreationErrorZ_clone_ptr(LDKCResult_DescriptionCreationErrorZ *NONNULL_PTR arg) {
	LDKCResult_DescriptionCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DescriptionCreationErrorZ), "LDKCResult_DescriptionCreationErrorZ");
	*ret_conv = CResult_DescriptionCreationErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_DescriptionCreationErrorZ_clone_ptr"))) TS_CResult_DescriptionCreationErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_DescriptionCreationErrorZ* arg_conv = (LDKCResult_DescriptionCreationErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_DescriptionCreationErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_DescriptionCreationErrorZ_clone"))) TS_CResult_DescriptionCreationErrorZ_clone(uint32_t orig) {
	LDKCResult_DescriptionCreationErrorZ* orig_conv = (LDKCResult_DescriptionCreationErrorZ*)(orig & ~1);
	LDKCResult_DescriptionCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DescriptionCreationErrorZ), "LDKCResult_DescriptionCreationErrorZ");
	*ret_conv = CResult_DescriptionCreationErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PrivateRouteCreationErrorZ_ok"))) TS_CResult_PrivateRouteCreationErrorZ_ok(uint32_t o) {
	LDKPrivateRoute o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = PrivateRoute_clone(&o_conv);
	LDKCResult_PrivateRouteCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PrivateRouteCreationErrorZ), "LDKCResult_PrivateRouteCreationErrorZ");
	*ret_conv = CResult_PrivateRouteCreationErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PrivateRouteCreationErrorZ_err"))) TS_CResult_PrivateRouteCreationErrorZ_err(uint32_t e) {
	LDKCreationError e_conv = LDKCreationError_from_js(e);
	LDKCResult_PrivateRouteCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PrivateRouteCreationErrorZ), "LDKCResult_PrivateRouteCreationErrorZ");
	*ret_conv = CResult_PrivateRouteCreationErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PrivateRouteCreationErrorZ_is_ok"))) TS_CResult_PrivateRouteCreationErrorZ_is_ok(uint32_t o) {
	LDKCResult_PrivateRouteCreationErrorZ* o_conv = (LDKCResult_PrivateRouteCreationErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PrivateRouteCreationErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PrivateRouteCreationErrorZ_free"))) TS_CResult_PrivateRouteCreationErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PrivateRouteCreationErrorZ _res_conv = *(LDKCResult_PrivateRouteCreationErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PrivateRouteCreationErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PrivateRouteCreationErrorZ_clone_ptr(LDKCResult_PrivateRouteCreationErrorZ *NONNULL_PTR arg) {
	LDKCResult_PrivateRouteCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PrivateRouteCreationErrorZ), "LDKCResult_PrivateRouteCreationErrorZ");
	*ret_conv = CResult_PrivateRouteCreationErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PrivateRouteCreationErrorZ_clone_ptr"))) TS_CResult_PrivateRouteCreationErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PrivateRouteCreationErrorZ* arg_conv = (LDKCResult_PrivateRouteCreationErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PrivateRouteCreationErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PrivateRouteCreationErrorZ_clone"))) TS_CResult_PrivateRouteCreationErrorZ_clone(uint32_t orig) {
	LDKCResult_PrivateRouteCreationErrorZ* orig_conv = (LDKCResult_PrivateRouteCreationErrorZ*)(orig & ~1);
	LDKCResult_PrivateRouteCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PrivateRouteCreationErrorZ), "LDKCResult_PrivateRouteCreationErrorZ");
	*ret_conv = CResult_PrivateRouteCreationErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_StringErrorZ_ok"))) TS_CResult_StringErrorZ_ok(jstring o) {
	LDKStr o_conv = str_ref_to_owned_c(o);
	LDKCResult_StringErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_StringErrorZ), "LDKCResult_StringErrorZ");
	*ret_conv = CResult_StringErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_StringErrorZ_err"))) TS_CResult_StringErrorZ_err(uint32_t e) {
	LDKSecp256k1Error e_conv = LDKSecp256k1Error_from_js(e);
	LDKCResult_StringErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_StringErrorZ), "LDKCResult_StringErrorZ");
	*ret_conv = CResult_StringErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_StringErrorZ_is_ok"))) TS_CResult_StringErrorZ_is_ok(uint32_t o) {
	LDKCResult_StringErrorZ* o_conv = (LDKCResult_StringErrorZ*)(o & ~1);
	jboolean ret_val = CResult_StringErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_StringErrorZ_free"))) TS_CResult_StringErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_StringErrorZ _res_conv = *(LDKCResult_StringErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_StringErrorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelMonitorUpdateDecodeErrorZ_ok"))) TS_CResult_ChannelMonitorUpdateDecodeErrorZ_ok(uint32_t o) {
	LDKChannelMonitorUpdate o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelMonitorUpdate_clone(&o_conv);
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelMonitorUpdateDecodeErrorZ), "LDKCResult_ChannelMonitorUpdateDecodeErrorZ");
	*ret_conv = CResult_ChannelMonitorUpdateDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelMonitorUpdateDecodeErrorZ_err"))) TS_CResult_ChannelMonitorUpdateDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelMonitorUpdateDecodeErrorZ), "LDKCResult_ChannelMonitorUpdateDecodeErrorZ");
	*ret_conv = CResult_ChannelMonitorUpdateDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelMonitorUpdateDecodeErrorZ_is_ok"))) TS_CResult_ChannelMonitorUpdateDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* o_conv = (LDKCResult_ChannelMonitorUpdateDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelMonitorUpdateDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelMonitorUpdateDecodeErrorZ_free"))) TS_CResult_ChannelMonitorUpdateDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ _res_conv = *(LDKCResult_ChannelMonitorUpdateDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelMonitorUpdateDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelMonitorUpdateDecodeErrorZ_clone_ptr(LDKCResult_ChannelMonitorUpdateDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelMonitorUpdateDecodeErrorZ), "LDKCResult_ChannelMonitorUpdateDecodeErrorZ");
	*ret_conv = CResult_ChannelMonitorUpdateDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelMonitorUpdateDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelMonitorUpdateDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* arg_conv = (LDKCResult_ChannelMonitorUpdateDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelMonitorUpdateDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelMonitorUpdateDecodeErrorZ_clone"))) TS_CResult_ChannelMonitorUpdateDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* orig_conv = (LDKCResult_ChannelMonitorUpdateDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelMonitorUpdateDecodeErrorZ), "LDKCResult_ChannelMonitorUpdateDecodeErrorZ");
	*ret_conv = CResult_ChannelMonitorUpdateDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_MonitorEventZ_some"))) TS_COption_MonitorEventZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKMonitorEvent o_conv = *(LDKMonitorEvent*)(o_ptr);
	o_conv = MonitorEvent_clone((LDKMonitorEvent*)(((uintptr_t)o) & ~1));
	LDKCOption_MonitorEventZ *ret_copy = MALLOC(sizeof(LDKCOption_MonitorEventZ), "LDKCOption_MonitorEventZ");
	*ret_copy = COption_MonitorEventZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_MonitorEventZ_none"))) TS_COption_MonitorEventZ_none() {
	LDKCOption_MonitorEventZ *ret_copy = MALLOC(sizeof(LDKCOption_MonitorEventZ), "LDKCOption_MonitorEventZ");
	*ret_copy = COption_MonitorEventZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_MonitorEventZ_free"))) TS_COption_MonitorEventZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_MonitorEventZ _res_conv = *(LDKCOption_MonitorEventZ*)(_res_ptr);
	FREE((void*)_res);
	COption_MonitorEventZ_free(_res_conv);
}

static inline uintptr_t COption_MonitorEventZ_clone_ptr(LDKCOption_MonitorEventZ *NONNULL_PTR arg) {
	LDKCOption_MonitorEventZ *ret_copy = MALLOC(sizeof(LDKCOption_MonitorEventZ), "LDKCOption_MonitorEventZ");
	*ret_copy = COption_MonitorEventZ_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_MonitorEventZ_clone_ptr"))) TS_COption_MonitorEventZ_clone_ptr(uint32_t arg) {
	LDKCOption_MonitorEventZ* arg_conv = (LDKCOption_MonitorEventZ*)arg;
	uint32_t ret_val = COption_MonitorEventZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_MonitorEventZ_clone"))) TS_COption_MonitorEventZ_clone(uint32_t orig) {
	LDKCOption_MonitorEventZ* orig_conv = (LDKCOption_MonitorEventZ*)orig;
	LDKCOption_MonitorEventZ *ret_copy = MALLOC(sizeof(LDKCOption_MonitorEventZ), "LDKCOption_MonitorEventZ");
	*ret_copy = COption_MonitorEventZ_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_MonitorEventZDecodeErrorZ_ok"))) TS_CResult_COption_MonitorEventZDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKCOption_MonitorEventZ o_conv = *(LDKCOption_MonitorEventZ*)(o_ptr);
	o_conv = COption_MonitorEventZ_clone((LDKCOption_MonitorEventZ*)(((uintptr_t)o) & ~1));
	LDKCResult_COption_MonitorEventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_MonitorEventZDecodeErrorZ), "LDKCResult_COption_MonitorEventZDecodeErrorZ");
	*ret_conv = CResult_COption_MonitorEventZDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_MonitorEventZDecodeErrorZ_err"))) TS_CResult_COption_MonitorEventZDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_COption_MonitorEventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_MonitorEventZDecodeErrorZ), "LDKCResult_COption_MonitorEventZDecodeErrorZ");
	*ret_conv = CResult_COption_MonitorEventZDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_COption_MonitorEventZDecodeErrorZ_is_ok"))) TS_CResult_COption_MonitorEventZDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_COption_MonitorEventZDecodeErrorZ* o_conv = (LDKCResult_COption_MonitorEventZDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_COption_MonitorEventZDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_COption_MonitorEventZDecodeErrorZ_free"))) TS_CResult_COption_MonitorEventZDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_COption_MonitorEventZDecodeErrorZ _res_conv = *(LDKCResult_COption_MonitorEventZDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_COption_MonitorEventZDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_COption_MonitorEventZDecodeErrorZ_clone_ptr(LDKCResult_COption_MonitorEventZDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_COption_MonitorEventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_MonitorEventZDecodeErrorZ), "LDKCResult_COption_MonitorEventZDecodeErrorZ");
	*ret_conv = CResult_COption_MonitorEventZDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_COption_MonitorEventZDecodeErrorZ_clone_ptr"))) TS_CResult_COption_MonitorEventZDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_COption_MonitorEventZDecodeErrorZ* arg_conv = (LDKCResult_COption_MonitorEventZDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_COption_MonitorEventZDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_MonitorEventZDecodeErrorZ_clone"))) TS_CResult_COption_MonitorEventZDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_COption_MonitorEventZDecodeErrorZ* orig_conv = (LDKCResult_COption_MonitorEventZDecodeErrorZ*)(orig & ~1);
	LDKCResult_COption_MonitorEventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_MonitorEventZDecodeErrorZ), "LDKCResult_COption_MonitorEventZDecodeErrorZ");
	*ret_conv = CResult_COption_MonitorEventZDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_HTLCUpdateDecodeErrorZ_ok"))) TS_CResult_HTLCUpdateDecodeErrorZ_ok(uint32_t o) {
	LDKHTLCUpdate o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = HTLCUpdate_clone(&o_conv);
	LDKCResult_HTLCUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCUpdateDecodeErrorZ), "LDKCResult_HTLCUpdateDecodeErrorZ");
	*ret_conv = CResult_HTLCUpdateDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_HTLCUpdateDecodeErrorZ_err"))) TS_CResult_HTLCUpdateDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_HTLCUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCUpdateDecodeErrorZ), "LDKCResult_HTLCUpdateDecodeErrorZ");
	*ret_conv = CResult_HTLCUpdateDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_HTLCUpdateDecodeErrorZ_is_ok"))) TS_CResult_HTLCUpdateDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_HTLCUpdateDecodeErrorZ* o_conv = (LDKCResult_HTLCUpdateDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_HTLCUpdateDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_HTLCUpdateDecodeErrorZ_free"))) TS_CResult_HTLCUpdateDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_HTLCUpdateDecodeErrorZ _res_conv = *(LDKCResult_HTLCUpdateDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_HTLCUpdateDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_HTLCUpdateDecodeErrorZ_clone_ptr(LDKCResult_HTLCUpdateDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_HTLCUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCUpdateDecodeErrorZ), "LDKCResult_HTLCUpdateDecodeErrorZ");
	*ret_conv = CResult_HTLCUpdateDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_HTLCUpdateDecodeErrorZ_clone_ptr"))) TS_CResult_HTLCUpdateDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_HTLCUpdateDecodeErrorZ* arg_conv = (LDKCResult_HTLCUpdateDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_HTLCUpdateDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_HTLCUpdateDecodeErrorZ_clone"))) TS_CResult_HTLCUpdateDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_HTLCUpdateDecodeErrorZ* orig_conv = (LDKCResult_HTLCUpdateDecodeErrorZ*)(orig & ~1);
	LDKCResult_HTLCUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCUpdateDecodeErrorZ), "LDKCResult_HTLCUpdateDecodeErrorZ");
	*ret_conv = CResult_HTLCUpdateDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

static inline uintptr_t C2Tuple_OutPointScriptZ_clone_ptr(LDKC2Tuple_OutPointScriptZ *NONNULL_PTR arg) {
	LDKC2Tuple_OutPointScriptZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_OutPointScriptZ), "LDKC2Tuple_OutPointScriptZ");
	*ret_conv = C2Tuple_OutPointScriptZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_OutPointScriptZ_clone_ptr"))) TS_C2Tuple_OutPointScriptZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_OutPointScriptZ* arg_conv = (LDKC2Tuple_OutPointScriptZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_OutPointScriptZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_OutPointScriptZ_clone"))) TS_C2Tuple_OutPointScriptZ_clone(uint32_t orig) {
	LDKC2Tuple_OutPointScriptZ* orig_conv = (LDKC2Tuple_OutPointScriptZ*)(orig & ~1);
	LDKC2Tuple_OutPointScriptZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_OutPointScriptZ), "LDKC2Tuple_OutPointScriptZ");
	*ret_conv = C2Tuple_OutPointScriptZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_OutPointScriptZ_new"))) TS_C2Tuple_OutPointScriptZ_new(uint32_t a, int8_tArray b) {
	LDKOutPoint a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = OutPoint_clone(&a_conv);
	LDKCVec_u8Z b_ref;
	b_ref.datalen = b->arr_len;
	b_ref.data = MALLOC(b_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(b_ref.data, b->elems, b_ref.datalen); FREE(b);
	LDKC2Tuple_OutPointScriptZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_OutPointScriptZ), "LDKC2Tuple_OutPointScriptZ");
	*ret_conv = C2Tuple_OutPointScriptZ_new(a_conv, b_ref);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_OutPointScriptZ_free"))) TS_C2Tuple_OutPointScriptZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_OutPointScriptZ _res_conv = *(LDKC2Tuple_OutPointScriptZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_OutPointScriptZ_free(_res_conv);
}

static inline uintptr_t C2Tuple_u32ScriptZ_clone_ptr(LDKC2Tuple_u32ScriptZ *NONNULL_PTR arg) {
	LDKC2Tuple_u32ScriptZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_u32ScriptZ), "LDKC2Tuple_u32ScriptZ");
	*ret_conv = C2Tuple_u32ScriptZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_u32ScriptZ_clone_ptr"))) TS_C2Tuple_u32ScriptZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_u32ScriptZ* arg_conv = (LDKC2Tuple_u32ScriptZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_u32ScriptZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_u32ScriptZ_clone"))) TS_C2Tuple_u32ScriptZ_clone(uint32_t orig) {
	LDKC2Tuple_u32ScriptZ* orig_conv = (LDKC2Tuple_u32ScriptZ*)(orig & ~1);
	LDKC2Tuple_u32ScriptZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_u32ScriptZ), "LDKC2Tuple_u32ScriptZ");
	*ret_conv = C2Tuple_u32ScriptZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_u32ScriptZ_new"))) TS_C2Tuple_u32ScriptZ_new(int32_t a, int8_tArray b) {
	LDKCVec_u8Z b_ref;
	b_ref.datalen = b->arr_len;
	b_ref.data = MALLOC(b_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(b_ref.data, b->elems, b_ref.datalen); FREE(b);
	LDKC2Tuple_u32ScriptZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_u32ScriptZ), "LDKC2Tuple_u32ScriptZ");
	*ret_conv = C2Tuple_u32ScriptZ_new(a, b_ref);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_u32ScriptZ_free"))) TS_C2Tuple_u32ScriptZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_u32ScriptZ _res_conv = *(LDKC2Tuple_u32ScriptZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_u32ScriptZ_free(_res_conv);
}

void  __attribute__((export_name("TS_CVec_C2Tuple_u32ScriptZZ_free"))) TS_CVec_C2Tuple_u32ScriptZZ_free(uint32_tArray _res) {
	LDKCVec_C2Tuple_u32ScriptZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKC2Tuple_u32ScriptZ), "LDKCVec_C2Tuple_u32ScriptZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t v = 0; v < _res_constr.datalen; v++) {
		uint32_t _res_conv_21 = _res_vals[v];
		void* _res_conv_21_ptr = (void*)(((uintptr_t)_res_conv_21) & ~1);
		CHECK_ACCESS(_res_conv_21_ptr);
		LDKC2Tuple_u32ScriptZ _res_conv_21_conv = *(LDKC2Tuple_u32ScriptZ*)(_res_conv_21_ptr);
		FREE((void*)_res_conv_21);
		_res_constr.data[v] = _res_conv_21_conv;
	}
	CVec_C2Tuple_u32ScriptZZ_free(_res_constr);
}

static inline uintptr_t C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone_ptr(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ *NONNULL_PTR arg) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ");
	*ret_conv = C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone_ptr"))) TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ* arg_conv = (LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone"))) TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone(uint32_t orig) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ* orig_conv = (LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ*)(orig & ~1);
	LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ");
	*ret_conv = C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_new"))) TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_new(int8_tArray a, uint32_tArray b) {
	LDKThirtyTwoBytes a_ref;
	CHECK(a->arr_len == 32);
	memcpy(a_ref.data, a->elems, 32); FREE(a);
	LDKCVec_C2Tuple_u32ScriptZZ b_constr;
	b_constr.datalen = b->arr_len;
	if (b_constr.datalen > 0)
		b_constr.data = MALLOC(b_constr.datalen * sizeof(LDKC2Tuple_u32ScriptZ), "LDKCVec_C2Tuple_u32ScriptZZ Elements");
	else
		b_constr.data = NULL;
	uint32_t* b_vals = b->elems /* XXX b leaks */;
	for (size_t v = 0; v < b_constr.datalen; v++) {
		uint32_t b_conv_21 = b_vals[v];
		void* b_conv_21_ptr = (void*)(((uintptr_t)b_conv_21) & ~1);
		CHECK_ACCESS(b_conv_21_ptr);
		LDKC2Tuple_u32ScriptZ b_conv_21_conv = *(LDKC2Tuple_u32ScriptZ*)(b_conv_21_ptr);
		b_conv_21_conv = C2Tuple_u32ScriptZ_clone((LDKC2Tuple_u32ScriptZ*)(((uintptr_t)b_conv_21) & ~1));
		b_constr.data[v] = b_conv_21_conv;
	}
	LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ");
	*ret_conv = C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_new(a_ref, b_constr);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_free"))) TS_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ _res_conv = *(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ_free(_res_conv);
}

void  __attribute__((export_name("TS_CVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ_free"))) TS_CVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ_free(uint32_tArray _res) {
	LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ), "LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t o = 0; o < _res_constr.datalen; o++) {
		uint32_t _res_conv_40 = _res_vals[o];
		void* _res_conv_40_ptr = (void*)(((uintptr_t)_res_conv_40) & ~1);
		CHECK_ACCESS(_res_conv_40_ptr);
		LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ _res_conv_40_conv = *(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ*)(_res_conv_40_ptr);
		FREE((void*)_res_conv_40);
		_res_constr.data[o] = _res_conv_40_conv;
	}
	CVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_EventZ_free"))) TS_CVec_EventZ_free(uint32_tArray _res) {
	LDKCVec_EventZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKEvent), "LDKCVec_EventZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t h = 0; h < _res_constr.datalen; h++) {
		uint32_t _res_conv_7 = _res_vals[h];
		void* _res_conv_7_ptr = (void*)(((uintptr_t)_res_conv_7) & ~1);
		CHECK_ACCESS(_res_conv_7_ptr);
		LDKEvent _res_conv_7_conv = *(LDKEvent*)(_res_conv_7_ptr);
		FREE((void*)_res_conv_7);
		_res_constr.data[h] = _res_conv_7_conv;
	}
	CVec_EventZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_TransactionZ_free"))) TS_CVec_TransactionZ_free(ptrArray _res) {
	LDKCVec_TransactionZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKTransaction), "LDKCVec_TransactionZ Elements");
	else
		_res_constr.data = NULL;
	int8_tArray* _res_vals = (void*) _res->elems /* XXX _res leaks */;
	for (size_t m = 0; m < _res_constr.datalen; m++) {
		int8_tArray _res_conv_12 = _res_vals[m];
		LDKTransaction _res_conv_12_ref;
		_res_conv_12_ref.datalen = _res_conv_12->arr_len;
		_res_conv_12_ref.data = MALLOC(_res_conv_12_ref.datalen, "LDKTransaction Bytes");
		memcpy(_res_conv_12_ref.data, _res_conv_12->elems, _res_conv_12_ref.datalen); FREE(_res_conv_12);
		_res_conv_12_ref.data_is_owned = true;
		_res_constr.data[m] = _res_conv_12_ref;
	}
	CVec_TransactionZ_free(_res_constr);
}

static inline uintptr_t C2Tuple_u32TxOutZ_clone_ptr(LDKC2Tuple_u32TxOutZ *NONNULL_PTR arg) {
	LDKC2Tuple_u32TxOutZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_u32TxOutZ), "LDKC2Tuple_u32TxOutZ");
	*ret_conv = C2Tuple_u32TxOutZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_u32TxOutZ_clone_ptr"))) TS_C2Tuple_u32TxOutZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_u32TxOutZ* arg_conv = (LDKC2Tuple_u32TxOutZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_u32TxOutZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_u32TxOutZ_clone"))) TS_C2Tuple_u32TxOutZ_clone(uint32_t orig) {
	LDKC2Tuple_u32TxOutZ* orig_conv = (LDKC2Tuple_u32TxOutZ*)(orig & ~1);
	LDKC2Tuple_u32TxOutZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_u32TxOutZ), "LDKC2Tuple_u32TxOutZ");
	*ret_conv = C2Tuple_u32TxOutZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_u32TxOutZ_new"))) TS_C2Tuple_u32TxOutZ_new(int32_t a, uint32_t b) {
	void* b_ptr = (void*)(((uintptr_t)b) & ~1);
	CHECK_ACCESS(b_ptr);
	LDKTxOut b_conv = *(LDKTxOut*)(b_ptr);
	b_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)b) & ~1));
	LDKC2Tuple_u32TxOutZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_u32TxOutZ), "LDKC2Tuple_u32TxOutZ");
	*ret_conv = C2Tuple_u32TxOutZ_new(a, b_conv);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_u32TxOutZ_free"))) TS_C2Tuple_u32TxOutZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_u32TxOutZ _res_conv = *(LDKC2Tuple_u32TxOutZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_u32TxOutZ_free(_res_conv);
}

void  __attribute__((export_name("TS_CVec_C2Tuple_u32TxOutZZ_free"))) TS_CVec_C2Tuple_u32TxOutZZ_free(uint32_tArray _res) {
	LDKCVec_C2Tuple_u32TxOutZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKC2Tuple_u32TxOutZ), "LDKCVec_C2Tuple_u32TxOutZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t u = 0; u < _res_constr.datalen; u++) {
		uint32_t _res_conv_20 = _res_vals[u];
		void* _res_conv_20_ptr = (void*)(((uintptr_t)_res_conv_20) & ~1);
		CHECK_ACCESS(_res_conv_20_ptr);
		LDKC2Tuple_u32TxOutZ _res_conv_20_conv = *(LDKC2Tuple_u32TxOutZ*)(_res_conv_20_ptr);
		FREE((void*)_res_conv_20);
		_res_constr.data[u] = _res_conv_20_conv;
	}
	CVec_C2Tuple_u32TxOutZZ_free(_res_constr);
}

static inline uintptr_t C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone_ptr(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ *NONNULL_PTR arg) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ");
	*ret_conv = C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone_ptr"))) TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* arg_conv = (LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone"))) TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone(uint32_t orig) {
	LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* orig_conv = (LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ*)(orig & ~1);
	LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ");
	*ret_conv = C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_new"))) TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_new(int8_tArray a, uint32_tArray b) {
	LDKThirtyTwoBytes a_ref;
	CHECK(a->arr_len == 32);
	memcpy(a_ref.data, a->elems, 32); FREE(a);
	LDKCVec_C2Tuple_u32TxOutZZ b_constr;
	b_constr.datalen = b->arr_len;
	if (b_constr.datalen > 0)
		b_constr.data = MALLOC(b_constr.datalen * sizeof(LDKC2Tuple_u32TxOutZ), "LDKCVec_C2Tuple_u32TxOutZZ Elements");
	else
		b_constr.data = NULL;
	uint32_t* b_vals = b->elems /* XXX b leaks */;
	for (size_t u = 0; u < b_constr.datalen; u++) {
		uint32_t b_conv_20 = b_vals[u];
		void* b_conv_20_ptr = (void*)(((uintptr_t)b_conv_20) & ~1);
		CHECK_ACCESS(b_conv_20_ptr);
		LDKC2Tuple_u32TxOutZ b_conv_20_conv = *(LDKC2Tuple_u32TxOutZ*)(b_conv_20_ptr);
		b_conv_20_conv = C2Tuple_u32TxOutZ_clone((LDKC2Tuple_u32TxOutZ*)(((uintptr_t)b_conv_20) & ~1));
		b_constr.data[u] = b_conv_20_conv;
	}
	LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ");
	*ret_conv = C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_new(a_ref, b_constr);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_free"))) TS_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ _res_conv = *(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ_free(_res_conv);
}

void  __attribute__((export_name("TS_CVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ_free"))) TS_CVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ_free(uint32_tArray _res) {
	LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ), "LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t n = 0; n < _res_constr.datalen; n++) {
		uint32_t _res_conv_39 = _res_vals[n];
		void* _res_conv_39_ptr = (void*)(((uintptr_t)_res_conv_39) & ~1);
		CHECK_ACCESS(_res_conv_39_ptr);
		LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ _res_conv_39_conv = *(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ*)(_res_conv_39_ptr);
		FREE((void*)_res_conv_39);
		_res_constr.data[n] = _res_conv_39_conv;
	}
	CVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_BalanceZ_free"))) TS_CVec_BalanceZ_free(uint32_tArray _res) {
	LDKCVec_BalanceZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKBalance), "LDKCVec_BalanceZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t j = 0; j < _res_constr.datalen; j++) {
		uint32_t _res_conv_9 = _res_vals[j];
		void* _res_conv_9_ptr = (void*)(((uintptr_t)_res_conv_9) & ~1);
		CHECK_ACCESS(_res_conv_9_ptr);
		LDKBalance _res_conv_9_conv = *(LDKBalance*)(_res_conv_9_ptr);
		FREE((void*)_res_conv_9);
		_res_constr.data[j] = _res_conv_9_conv;
	}
	CVec_BalanceZ_free(_res_constr);
}

static inline uintptr_t C2Tuple_BlockHashChannelMonitorZ_clone_ptr(LDKC2Tuple_BlockHashChannelMonitorZ *NONNULL_PTR arg) {
	LDKC2Tuple_BlockHashChannelMonitorZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_BlockHashChannelMonitorZ), "LDKC2Tuple_BlockHashChannelMonitorZ");
	*ret_conv = C2Tuple_BlockHashChannelMonitorZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_BlockHashChannelMonitorZ_clone_ptr"))) TS_C2Tuple_BlockHashChannelMonitorZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_BlockHashChannelMonitorZ* arg_conv = (LDKC2Tuple_BlockHashChannelMonitorZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_BlockHashChannelMonitorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_BlockHashChannelMonitorZ_clone"))) TS_C2Tuple_BlockHashChannelMonitorZ_clone(uint32_t orig) {
	LDKC2Tuple_BlockHashChannelMonitorZ* orig_conv = (LDKC2Tuple_BlockHashChannelMonitorZ*)(orig & ~1);
	LDKC2Tuple_BlockHashChannelMonitorZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_BlockHashChannelMonitorZ), "LDKC2Tuple_BlockHashChannelMonitorZ");
	*ret_conv = C2Tuple_BlockHashChannelMonitorZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_BlockHashChannelMonitorZ_new"))) TS_C2Tuple_BlockHashChannelMonitorZ_new(int8_tArray a, uint32_t b) {
	LDKThirtyTwoBytes a_ref;
	CHECK(a->arr_len == 32);
	memcpy(a_ref.data, a->elems, 32); FREE(a);
	LDKChannelMonitor b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = (b & 1) || (b == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	b_conv = ChannelMonitor_clone(&b_conv);
	LDKC2Tuple_BlockHashChannelMonitorZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_BlockHashChannelMonitorZ), "LDKC2Tuple_BlockHashChannelMonitorZ");
	*ret_conv = C2Tuple_BlockHashChannelMonitorZ_new(a_ref, b_conv);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_BlockHashChannelMonitorZ_free"))) TS_C2Tuple_BlockHashChannelMonitorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_BlockHashChannelMonitorZ _res_conv = *(LDKC2Tuple_BlockHashChannelMonitorZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_BlockHashChannelMonitorZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_ok"))) TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKC2Tuple_BlockHashChannelMonitorZ o_conv = *(LDKC2Tuple_BlockHashChannelMonitorZ*)(o_ptr);
	o_conv = C2Tuple_BlockHashChannelMonitorZ_clone((LDKC2Tuple_BlockHashChannelMonitorZ*)(((uintptr_t)o) & ~1));
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ), "LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ");
	*ret_conv = CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_err"))) TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ), "LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ");
	*ret_conv = CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_is_ok"))) TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* o_conv = (LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_free"))) TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ _res_conv = *(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_clone_ptr(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ), "LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ");
	*ret_conv = CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_clone_ptr"))) TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* arg_conv = (LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_clone"))) TS_CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* orig_conv = (LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ*)(orig & ~1);
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ), "LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ");
	*ret_conv = CResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneLightningErrorZ_ok"))) TS_CResult_NoneLightningErrorZ_ok() {
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = CResult_NoneLightningErrorZ_ok();
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneLightningErrorZ_err"))) TS_CResult_NoneLightningErrorZ_err(uint32_t e) {
	LDKLightningError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = LightningError_clone(&e_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = CResult_NoneLightningErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NoneLightningErrorZ_is_ok"))) TS_CResult_NoneLightningErrorZ_is_ok(uint32_t o) {
	LDKCResult_NoneLightningErrorZ* o_conv = (LDKCResult_NoneLightningErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NoneLightningErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NoneLightningErrorZ_free"))) TS_CResult_NoneLightningErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NoneLightningErrorZ _res_conv = *(LDKCResult_NoneLightningErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NoneLightningErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NoneLightningErrorZ_clone_ptr(LDKCResult_NoneLightningErrorZ *NONNULL_PTR arg) {
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = CResult_NoneLightningErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NoneLightningErrorZ_clone_ptr"))) TS_CResult_NoneLightningErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NoneLightningErrorZ* arg_conv = (LDKCResult_NoneLightningErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NoneLightningErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NoneLightningErrorZ_clone"))) TS_CResult_NoneLightningErrorZ_clone(uint32_t orig) {
	LDKCResult_NoneLightningErrorZ* orig_conv = (LDKCResult_NoneLightningErrorZ*)(orig & ~1);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = CResult_NoneLightningErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

static inline uintptr_t C2Tuple_PublicKeyTypeZ_clone_ptr(LDKC2Tuple_PublicKeyTypeZ *NONNULL_PTR arg) {
	LDKC2Tuple_PublicKeyTypeZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PublicKeyTypeZ), "LDKC2Tuple_PublicKeyTypeZ");
	*ret_conv = C2Tuple_PublicKeyTypeZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C2Tuple_PublicKeyTypeZ_clone_ptr"))) TS_C2Tuple_PublicKeyTypeZ_clone_ptr(uint32_t arg) {
	LDKC2Tuple_PublicKeyTypeZ* arg_conv = (LDKC2Tuple_PublicKeyTypeZ*)(arg & ~1);
	uint32_t ret_val = C2Tuple_PublicKeyTypeZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_PublicKeyTypeZ_clone"))) TS_C2Tuple_PublicKeyTypeZ_clone(uint32_t orig) {
	LDKC2Tuple_PublicKeyTypeZ* orig_conv = (LDKC2Tuple_PublicKeyTypeZ*)(orig & ~1);
	LDKC2Tuple_PublicKeyTypeZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PublicKeyTypeZ), "LDKC2Tuple_PublicKeyTypeZ");
	*ret_conv = C2Tuple_PublicKeyTypeZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C2Tuple_PublicKeyTypeZ_new"))) TS_C2Tuple_PublicKeyTypeZ_new(int8_tArray a, uint32_t b) {
	LDKPublicKey a_ref;
	CHECK(a->arr_len == 33);
	memcpy(a_ref.compressed_form, a->elems, 33); FREE(a);
	void* b_ptr = (void*)(((uintptr_t)b) & ~1);
	CHECK_ACCESS(b_ptr);
	LDKType b_conv = *(LDKType*)(b_ptr);
	if (b_conv.free == LDKType_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKType_JCalls_cloned(&b_conv);
	}
	LDKC2Tuple_PublicKeyTypeZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_PublicKeyTypeZ), "LDKC2Tuple_PublicKeyTypeZ");
	*ret_conv = C2Tuple_PublicKeyTypeZ_new(a_ref, b_conv);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C2Tuple_PublicKeyTypeZ_free"))) TS_C2Tuple_PublicKeyTypeZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC2Tuple_PublicKeyTypeZ _res_conv = *(LDKC2Tuple_PublicKeyTypeZ*)(_res_ptr);
	FREE((void*)_res);
	C2Tuple_PublicKeyTypeZ_free(_res_conv);
}

void  __attribute__((export_name("TS_CVec_C2Tuple_PublicKeyTypeZZ_free"))) TS_CVec_C2Tuple_PublicKeyTypeZZ_free(uint32_tArray _res) {
	LDKCVec_C2Tuple_PublicKeyTypeZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKC2Tuple_PublicKeyTypeZ), "LDKCVec_C2Tuple_PublicKeyTypeZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t z = 0; z < _res_constr.datalen; z++) {
		uint32_t _res_conv_25 = _res_vals[z];
		void* _res_conv_25_ptr = (void*)(((uintptr_t)_res_conv_25) & ~1);
		CHECK_ACCESS(_res_conv_25_ptr);
		LDKC2Tuple_PublicKeyTypeZ _res_conv_25_conv = *(LDKC2Tuple_PublicKeyTypeZ*)(_res_conv_25_ptr);
		FREE((void*)_res_conv_25);
		_res_constr.data[z] = _res_conv_25_conv;
	}
	CVec_C2Tuple_PublicKeyTypeZZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_boolLightningErrorZ_ok"))) TS_CResult_boolLightningErrorZ_ok(jboolean o) {
	LDKCResult_boolLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolLightningErrorZ), "LDKCResult_boolLightningErrorZ");
	*ret_conv = CResult_boolLightningErrorZ_ok(o);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_boolLightningErrorZ_err"))) TS_CResult_boolLightningErrorZ_err(uint32_t e) {
	LDKLightningError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = LightningError_clone(&e_conv);
	LDKCResult_boolLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolLightningErrorZ), "LDKCResult_boolLightningErrorZ");
	*ret_conv = CResult_boolLightningErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_boolLightningErrorZ_is_ok"))) TS_CResult_boolLightningErrorZ_is_ok(uint32_t o) {
	LDKCResult_boolLightningErrorZ* o_conv = (LDKCResult_boolLightningErrorZ*)(o & ~1);
	jboolean ret_val = CResult_boolLightningErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_boolLightningErrorZ_free"))) TS_CResult_boolLightningErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_boolLightningErrorZ _res_conv = *(LDKCResult_boolLightningErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_boolLightningErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_boolLightningErrorZ_clone_ptr(LDKCResult_boolLightningErrorZ *NONNULL_PTR arg) {
	LDKCResult_boolLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolLightningErrorZ), "LDKCResult_boolLightningErrorZ");
	*ret_conv = CResult_boolLightningErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_boolLightningErrorZ_clone_ptr"))) TS_CResult_boolLightningErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_boolLightningErrorZ* arg_conv = (LDKCResult_boolLightningErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_boolLightningErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_boolLightningErrorZ_clone"))) TS_CResult_boolLightningErrorZ_clone(uint32_t orig) {
	LDKCResult_boolLightningErrorZ* orig_conv = (LDKCResult_boolLightningErrorZ*)(orig & ~1);
	LDKCResult_boolLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolLightningErrorZ), "LDKCResult_boolLightningErrorZ");
	*ret_conv = CResult_boolLightningErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

static inline uintptr_t C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone_ptr(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ *NONNULL_PTR arg) {
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* ret_conv = MALLOC(sizeof(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ), "LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ");
	*ret_conv = C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone(arg);
	return ((uint32_t)ret_conv);
}
uint32_t  __attribute__((export_name("TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone_ptr"))) TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone_ptr(uint32_t arg) {
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* arg_conv = (LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ*)(arg & ~1);
	uint32_t ret_val = C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone"))) TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone(uint32_t orig) {
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* orig_conv = (LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ*)(orig & ~1);
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* ret_conv = MALLOC(sizeof(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ), "LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ");
	*ret_conv = C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_clone(orig_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_new"))) TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_new(uint32_t a, uint32_t b, uint32_t c) {
	LDKChannelAnnouncement a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = ChannelAnnouncement_clone(&a_conv);
	LDKChannelUpdate b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = (b & 1) || (b == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	b_conv = ChannelUpdate_clone(&b_conv);
	LDKChannelUpdate c_conv;
	c_conv.inner = (void*)(c & (~1));
	c_conv.is_owned = (c & 1) || (c == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(c_conv);
	c_conv = ChannelUpdate_clone(&c_conv);
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ* ret_conv = MALLOC(sizeof(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ), "LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ");
	*ret_conv = C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_new(a_conv, b_conv, c_conv);
	return ((uint32_t)ret_conv);
}

void  __attribute__((export_name("TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_free"))) TS_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ _res_conv = *(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ*)(_res_ptr);
	FREE((void*)_res);
	C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ_free(_res_conv);
}

void  __attribute__((export_name("TS_CVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ_free"))) TS_CVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ_free(uint32_tArray _res) {
	LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ), "LDKCVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t h = 0; h < _res_constr.datalen; h++) {
		uint32_t _res_conv_59 = _res_vals[h];
		void* _res_conv_59_ptr = (void*)(((uintptr_t)_res_conv_59) & ~1);
		CHECK_ACCESS(_res_conv_59_ptr);
		LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ _res_conv_59_conv = *(LDKC3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZ*)(_res_conv_59_ptr);
		FREE((void*)_res_conv_59);
		_res_constr.data[h] = _res_conv_59_conv;
	}
	CVec_C3Tuple_ChannelAnnouncementChannelUpdateChannelUpdateZZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_NodeAnnouncementZ_free"))) TS_CVec_NodeAnnouncementZ_free(uint32_tArray _res) {
	LDKCVec_NodeAnnouncementZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKNodeAnnouncement), "LDKCVec_NodeAnnouncementZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t s = 0; s < _res_constr.datalen; s++) {
		uint32_t _res_conv_18 = _res_vals[s];
		LDKNodeAnnouncement _res_conv_18_conv;
		_res_conv_18_conv.inner = (void*)(_res_conv_18 & (~1));
		_res_conv_18_conv.is_owned = (_res_conv_18 & 1) || (_res_conv_18 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_18_conv);
		_res_constr.data[s] = _res_conv_18_conv;
	}
	CVec_NodeAnnouncementZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_PublicKeyZ_free"))) TS_CVec_PublicKeyZ_free(ptrArray _res) {
	LDKCVec_PublicKeyZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKPublicKey), "LDKCVec_PublicKeyZ Elements");
	else
		_res_constr.data = NULL;
	int8_tArray* _res_vals = (void*) _res->elems /* XXX _res leaks */;
	for (size_t m = 0; m < _res_constr.datalen; m++) {
		int8_tArray _res_conv_12 = _res_vals[m];
		LDKPublicKey _res_conv_12_ref;
		CHECK(_res_conv_12->arr_len == 33);
		memcpy(_res_conv_12_ref.compressed_form, _res_conv_12->elems, 33); FREE(_res_conv_12);
		_res_constr.data[m] = _res_conv_12_ref;
	}
	CVec_PublicKeyZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_COption_NetAddressZ_some"))) TS_COption_NetAddressZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKNetAddress o_conv = *(LDKNetAddress*)(o_ptr);
	o_conv = NetAddress_clone((LDKNetAddress*)(((uintptr_t)o) & ~1));
	LDKCOption_NetAddressZ *ret_copy = MALLOC(sizeof(LDKCOption_NetAddressZ), "LDKCOption_NetAddressZ");
	*ret_copy = COption_NetAddressZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_NetAddressZ_none"))) TS_COption_NetAddressZ_none() {
	LDKCOption_NetAddressZ *ret_copy = MALLOC(sizeof(LDKCOption_NetAddressZ), "LDKCOption_NetAddressZ");
	*ret_copy = COption_NetAddressZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_NetAddressZ_free"))) TS_COption_NetAddressZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_NetAddressZ _res_conv = *(LDKCOption_NetAddressZ*)(_res_ptr);
	FREE((void*)_res);
	COption_NetAddressZ_free(_res_conv);
}

static inline uintptr_t COption_NetAddressZ_clone_ptr(LDKCOption_NetAddressZ *NONNULL_PTR arg) {
	LDKCOption_NetAddressZ *ret_copy = MALLOC(sizeof(LDKCOption_NetAddressZ), "LDKCOption_NetAddressZ");
	*ret_copy = COption_NetAddressZ_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_NetAddressZ_clone_ptr"))) TS_COption_NetAddressZ_clone_ptr(uint32_t arg) {
	LDKCOption_NetAddressZ* arg_conv = (LDKCOption_NetAddressZ*)arg;
	uint32_t ret_val = COption_NetAddressZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_NetAddressZ_clone"))) TS_COption_NetAddressZ_clone(uint32_t orig) {
	LDKCOption_NetAddressZ* orig_conv = (LDKCOption_NetAddressZ*)orig;
	LDKCOption_NetAddressZ *ret_copy = MALLOC(sizeof(LDKCOption_NetAddressZ), "LDKCOption_NetAddressZ");
	*ret_copy = COption_NetAddressZ_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_u8ZPeerHandleErrorZ_ok"))) TS_CResult_CVec_u8ZPeerHandleErrorZ_ok(int8_tArray o) {
	LDKCVec_u8Z o_ref;
	o_ref.datalen = o->arr_len;
	o_ref.data = MALLOC(o_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(o_ref.data, o->elems, o_ref.datalen); FREE(o);
	LDKCResult_CVec_u8ZPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_u8ZPeerHandleErrorZ), "LDKCResult_CVec_u8ZPeerHandleErrorZ");
	*ret_conv = CResult_CVec_u8ZPeerHandleErrorZ_ok(o_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_u8ZPeerHandleErrorZ_err"))) TS_CResult_CVec_u8ZPeerHandleErrorZ_err(uint32_t e) {
	LDKPeerHandleError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = PeerHandleError_clone(&e_conv);
	LDKCResult_CVec_u8ZPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_u8ZPeerHandleErrorZ), "LDKCResult_CVec_u8ZPeerHandleErrorZ");
	*ret_conv = CResult_CVec_u8ZPeerHandleErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_CVec_u8ZPeerHandleErrorZ_is_ok"))) TS_CResult_CVec_u8ZPeerHandleErrorZ_is_ok(uint32_t o) {
	LDKCResult_CVec_u8ZPeerHandleErrorZ* o_conv = (LDKCResult_CVec_u8ZPeerHandleErrorZ*)(o & ~1);
	jboolean ret_val = CResult_CVec_u8ZPeerHandleErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_CVec_u8ZPeerHandleErrorZ_free"))) TS_CResult_CVec_u8ZPeerHandleErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_CVec_u8ZPeerHandleErrorZ _res_conv = *(LDKCResult_CVec_u8ZPeerHandleErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_CVec_u8ZPeerHandleErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_CVec_u8ZPeerHandleErrorZ_clone_ptr(LDKCResult_CVec_u8ZPeerHandleErrorZ *NONNULL_PTR arg) {
	LDKCResult_CVec_u8ZPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_u8ZPeerHandleErrorZ), "LDKCResult_CVec_u8ZPeerHandleErrorZ");
	*ret_conv = CResult_CVec_u8ZPeerHandleErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_CVec_u8ZPeerHandleErrorZ_clone_ptr"))) TS_CResult_CVec_u8ZPeerHandleErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_CVec_u8ZPeerHandleErrorZ* arg_conv = (LDKCResult_CVec_u8ZPeerHandleErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_CVec_u8ZPeerHandleErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_CVec_u8ZPeerHandleErrorZ_clone"))) TS_CResult_CVec_u8ZPeerHandleErrorZ_clone(uint32_t orig) {
	LDKCResult_CVec_u8ZPeerHandleErrorZ* orig_conv = (LDKCResult_CVec_u8ZPeerHandleErrorZ*)(orig & ~1);
	LDKCResult_CVec_u8ZPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_u8ZPeerHandleErrorZ), "LDKCResult_CVec_u8ZPeerHandleErrorZ");
	*ret_conv = CResult_CVec_u8ZPeerHandleErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NonePeerHandleErrorZ_ok"))) TS_CResult_NonePeerHandleErrorZ_ok() {
	LDKCResult_NonePeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePeerHandleErrorZ), "LDKCResult_NonePeerHandleErrorZ");
	*ret_conv = CResult_NonePeerHandleErrorZ_ok();
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NonePeerHandleErrorZ_err"))) TS_CResult_NonePeerHandleErrorZ_err(uint32_t e) {
	LDKPeerHandleError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = PeerHandleError_clone(&e_conv);
	LDKCResult_NonePeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePeerHandleErrorZ), "LDKCResult_NonePeerHandleErrorZ");
	*ret_conv = CResult_NonePeerHandleErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NonePeerHandleErrorZ_is_ok"))) TS_CResult_NonePeerHandleErrorZ_is_ok(uint32_t o) {
	LDKCResult_NonePeerHandleErrorZ* o_conv = (LDKCResult_NonePeerHandleErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NonePeerHandleErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NonePeerHandleErrorZ_free"))) TS_CResult_NonePeerHandleErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NonePeerHandleErrorZ _res_conv = *(LDKCResult_NonePeerHandleErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NonePeerHandleErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NonePeerHandleErrorZ_clone_ptr(LDKCResult_NonePeerHandleErrorZ *NONNULL_PTR arg) {
	LDKCResult_NonePeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePeerHandleErrorZ), "LDKCResult_NonePeerHandleErrorZ");
	*ret_conv = CResult_NonePeerHandleErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NonePeerHandleErrorZ_clone_ptr"))) TS_CResult_NonePeerHandleErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NonePeerHandleErrorZ* arg_conv = (LDKCResult_NonePeerHandleErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NonePeerHandleErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NonePeerHandleErrorZ_clone"))) TS_CResult_NonePeerHandleErrorZ_clone(uint32_t orig) {
	LDKCResult_NonePeerHandleErrorZ* orig_conv = (LDKCResult_NonePeerHandleErrorZ*)(orig & ~1);
	LDKCResult_NonePeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePeerHandleErrorZ), "LDKCResult_NonePeerHandleErrorZ");
	*ret_conv = CResult_NonePeerHandleErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_boolPeerHandleErrorZ_ok"))) TS_CResult_boolPeerHandleErrorZ_ok(jboolean o) {
	LDKCResult_boolPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolPeerHandleErrorZ), "LDKCResult_boolPeerHandleErrorZ");
	*ret_conv = CResult_boolPeerHandleErrorZ_ok(o);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_boolPeerHandleErrorZ_err"))) TS_CResult_boolPeerHandleErrorZ_err(uint32_t e) {
	LDKPeerHandleError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = PeerHandleError_clone(&e_conv);
	LDKCResult_boolPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolPeerHandleErrorZ), "LDKCResult_boolPeerHandleErrorZ");
	*ret_conv = CResult_boolPeerHandleErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_boolPeerHandleErrorZ_is_ok"))) TS_CResult_boolPeerHandleErrorZ_is_ok(uint32_t o) {
	LDKCResult_boolPeerHandleErrorZ* o_conv = (LDKCResult_boolPeerHandleErrorZ*)(o & ~1);
	jboolean ret_val = CResult_boolPeerHandleErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_boolPeerHandleErrorZ_free"))) TS_CResult_boolPeerHandleErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_boolPeerHandleErrorZ _res_conv = *(LDKCResult_boolPeerHandleErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_boolPeerHandleErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_boolPeerHandleErrorZ_clone_ptr(LDKCResult_boolPeerHandleErrorZ *NONNULL_PTR arg) {
	LDKCResult_boolPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolPeerHandleErrorZ), "LDKCResult_boolPeerHandleErrorZ");
	*ret_conv = CResult_boolPeerHandleErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_boolPeerHandleErrorZ_clone_ptr"))) TS_CResult_boolPeerHandleErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_boolPeerHandleErrorZ* arg_conv = (LDKCResult_boolPeerHandleErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_boolPeerHandleErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_boolPeerHandleErrorZ_clone"))) TS_CResult_boolPeerHandleErrorZ_clone(uint32_t orig) {
	LDKCResult_boolPeerHandleErrorZ* orig_conv = (LDKCResult_boolPeerHandleErrorZ*)(orig & ~1);
	LDKCResult_boolPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolPeerHandleErrorZ), "LDKCResult_boolPeerHandleErrorZ");
	*ret_conv = CResult_boolPeerHandleErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeIdDecodeErrorZ_ok"))) TS_CResult_NodeIdDecodeErrorZ_ok(uint32_t o) {
	LDKNodeId o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = NodeId_clone(&o_conv);
	LDKCResult_NodeIdDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeIdDecodeErrorZ), "LDKCResult_NodeIdDecodeErrorZ");
	*ret_conv = CResult_NodeIdDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeIdDecodeErrorZ_err"))) TS_CResult_NodeIdDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_NodeIdDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeIdDecodeErrorZ), "LDKCResult_NodeIdDecodeErrorZ");
	*ret_conv = CResult_NodeIdDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NodeIdDecodeErrorZ_is_ok"))) TS_CResult_NodeIdDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_NodeIdDecodeErrorZ* o_conv = (LDKCResult_NodeIdDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NodeIdDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NodeIdDecodeErrorZ_free"))) TS_CResult_NodeIdDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NodeIdDecodeErrorZ _res_conv = *(LDKCResult_NodeIdDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NodeIdDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NodeIdDecodeErrorZ_clone_ptr(LDKCResult_NodeIdDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_NodeIdDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeIdDecodeErrorZ), "LDKCResult_NodeIdDecodeErrorZ");
	*ret_conv = CResult_NodeIdDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NodeIdDecodeErrorZ_clone_ptr"))) TS_CResult_NodeIdDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NodeIdDecodeErrorZ* arg_conv = (LDKCResult_NodeIdDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NodeIdDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeIdDecodeErrorZ_clone"))) TS_CResult_NodeIdDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_NodeIdDecodeErrorZ* orig_conv = (LDKCResult_NodeIdDecodeErrorZ*)(orig & ~1);
	LDKCResult_NodeIdDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeIdDecodeErrorZ), "LDKCResult_NodeIdDecodeErrorZ");
	*ret_conv = CResult_NodeIdDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_NetworkUpdateZDecodeErrorZ_ok"))) TS_CResult_COption_NetworkUpdateZDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKCOption_NetworkUpdateZ o_conv = *(LDKCOption_NetworkUpdateZ*)(o_ptr);
	o_conv = COption_NetworkUpdateZ_clone((LDKCOption_NetworkUpdateZ*)(((uintptr_t)o) & ~1));
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_NetworkUpdateZDecodeErrorZ), "LDKCResult_COption_NetworkUpdateZDecodeErrorZ");
	*ret_conv = CResult_COption_NetworkUpdateZDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_NetworkUpdateZDecodeErrorZ_err"))) TS_CResult_COption_NetworkUpdateZDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_NetworkUpdateZDecodeErrorZ), "LDKCResult_COption_NetworkUpdateZDecodeErrorZ");
	*ret_conv = CResult_COption_NetworkUpdateZDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_COption_NetworkUpdateZDecodeErrorZ_is_ok"))) TS_CResult_COption_NetworkUpdateZDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* o_conv = (LDKCResult_COption_NetworkUpdateZDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_COption_NetworkUpdateZDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_COption_NetworkUpdateZDecodeErrorZ_free"))) TS_CResult_COption_NetworkUpdateZDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ _res_conv = *(LDKCResult_COption_NetworkUpdateZDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_COption_NetworkUpdateZDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_COption_NetworkUpdateZDecodeErrorZ_clone_ptr(LDKCResult_COption_NetworkUpdateZDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_NetworkUpdateZDecodeErrorZ), "LDKCResult_COption_NetworkUpdateZDecodeErrorZ");
	*ret_conv = CResult_COption_NetworkUpdateZDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_COption_NetworkUpdateZDecodeErrorZ_clone_ptr"))) TS_CResult_COption_NetworkUpdateZDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* arg_conv = (LDKCResult_COption_NetworkUpdateZDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_COption_NetworkUpdateZDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_COption_NetworkUpdateZDecodeErrorZ_clone"))) TS_CResult_COption_NetworkUpdateZDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* orig_conv = (LDKCResult_COption_NetworkUpdateZDecodeErrorZ*)(orig & ~1);
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_NetworkUpdateZDecodeErrorZ), "LDKCResult_COption_NetworkUpdateZDecodeErrorZ");
	*ret_conv = CResult_COption_NetworkUpdateZDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_AccessZ_some"))) TS_COption_AccessZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKAccess o_conv = *(LDKAccess*)(o_ptr);
	if (o_conv.free == LDKAccess_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKAccess_JCalls_cloned(&o_conv);
	}
	LDKCOption_AccessZ *ret_copy = MALLOC(sizeof(LDKCOption_AccessZ), "LDKCOption_AccessZ");
	*ret_copy = COption_AccessZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_AccessZ_none"))) TS_COption_AccessZ_none() {
	LDKCOption_AccessZ *ret_copy = MALLOC(sizeof(LDKCOption_AccessZ), "LDKCOption_AccessZ");
	*ret_copy = COption_AccessZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_AccessZ_free"))) TS_COption_AccessZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_AccessZ _res_conv = *(LDKCOption_AccessZ*)(_res_ptr);
	FREE((void*)_res);
	COption_AccessZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateInfoDecodeErrorZ_ok"))) TS_CResult_ChannelUpdateInfoDecodeErrorZ_ok(uint32_t o) {
	LDKChannelUpdateInfo o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelUpdateInfo_clone(&o_conv);
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateInfoDecodeErrorZ), "LDKCResult_ChannelUpdateInfoDecodeErrorZ");
	*ret_conv = CResult_ChannelUpdateInfoDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateInfoDecodeErrorZ_err"))) TS_CResult_ChannelUpdateInfoDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateInfoDecodeErrorZ), "LDKCResult_ChannelUpdateInfoDecodeErrorZ");
	*ret_conv = CResult_ChannelUpdateInfoDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelUpdateInfoDecodeErrorZ_is_ok"))) TS_CResult_ChannelUpdateInfoDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* o_conv = (LDKCResult_ChannelUpdateInfoDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelUpdateInfoDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelUpdateInfoDecodeErrorZ_free"))) TS_CResult_ChannelUpdateInfoDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelUpdateInfoDecodeErrorZ _res_conv = *(LDKCResult_ChannelUpdateInfoDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelUpdateInfoDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelUpdateInfoDecodeErrorZ_clone_ptr(LDKCResult_ChannelUpdateInfoDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateInfoDecodeErrorZ), "LDKCResult_ChannelUpdateInfoDecodeErrorZ");
	*ret_conv = CResult_ChannelUpdateInfoDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateInfoDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelUpdateInfoDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* arg_conv = (LDKCResult_ChannelUpdateInfoDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelUpdateInfoDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateInfoDecodeErrorZ_clone"))) TS_CResult_ChannelUpdateInfoDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* orig_conv = (LDKCResult_ChannelUpdateInfoDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateInfoDecodeErrorZ), "LDKCResult_ChannelUpdateInfoDecodeErrorZ");
	*ret_conv = CResult_ChannelUpdateInfoDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelInfoDecodeErrorZ_ok"))) TS_CResult_ChannelInfoDecodeErrorZ_ok(uint32_t o) {
	LDKChannelInfo o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelInfo_clone(&o_conv);
	LDKCResult_ChannelInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelInfoDecodeErrorZ), "LDKCResult_ChannelInfoDecodeErrorZ");
	*ret_conv = CResult_ChannelInfoDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelInfoDecodeErrorZ_err"))) TS_CResult_ChannelInfoDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelInfoDecodeErrorZ), "LDKCResult_ChannelInfoDecodeErrorZ");
	*ret_conv = CResult_ChannelInfoDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelInfoDecodeErrorZ_is_ok"))) TS_CResult_ChannelInfoDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelInfoDecodeErrorZ* o_conv = (LDKCResult_ChannelInfoDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelInfoDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelInfoDecodeErrorZ_free"))) TS_CResult_ChannelInfoDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelInfoDecodeErrorZ _res_conv = *(LDKCResult_ChannelInfoDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelInfoDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelInfoDecodeErrorZ_clone_ptr(LDKCResult_ChannelInfoDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelInfoDecodeErrorZ), "LDKCResult_ChannelInfoDecodeErrorZ");
	*ret_conv = CResult_ChannelInfoDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelInfoDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelInfoDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelInfoDecodeErrorZ* arg_conv = (LDKCResult_ChannelInfoDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelInfoDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelInfoDecodeErrorZ_clone"))) TS_CResult_ChannelInfoDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelInfoDecodeErrorZ* orig_conv = (LDKCResult_ChannelInfoDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelInfoDecodeErrorZ), "LDKCResult_ChannelInfoDecodeErrorZ");
	*ret_conv = CResult_ChannelInfoDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RoutingFeesDecodeErrorZ_ok"))) TS_CResult_RoutingFeesDecodeErrorZ_ok(uint32_t o) {
	LDKRoutingFees o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = RoutingFees_clone(&o_conv);
	LDKCResult_RoutingFeesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RoutingFeesDecodeErrorZ), "LDKCResult_RoutingFeesDecodeErrorZ");
	*ret_conv = CResult_RoutingFeesDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RoutingFeesDecodeErrorZ_err"))) TS_CResult_RoutingFeesDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_RoutingFeesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RoutingFeesDecodeErrorZ), "LDKCResult_RoutingFeesDecodeErrorZ");
	*ret_conv = CResult_RoutingFeesDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RoutingFeesDecodeErrorZ_is_ok"))) TS_CResult_RoutingFeesDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_RoutingFeesDecodeErrorZ* o_conv = (LDKCResult_RoutingFeesDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_RoutingFeesDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RoutingFeesDecodeErrorZ_free"))) TS_CResult_RoutingFeesDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RoutingFeesDecodeErrorZ _res_conv = *(LDKCResult_RoutingFeesDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RoutingFeesDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_RoutingFeesDecodeErrorZ_clone_ptr(LDKCResult_RoutingFeesDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_RoutingFeesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RoutingFeesDecodeErrorZ), "LDKCResult_RoutingFeesDecodeErrorZ");
	*ret_conv = CResult_RoutingFeesDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RoutingFeesDecodeErrorZ_clone_ptr"))) TS_CResult_RoutingFeesDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_RoutingFeesDecodeErrorZ* arg_conv = (LDKCResult_RoutingFeesDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_RoutingFeesDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RoutingFeesDecodeErrorZ_clone"))) TS_CResult_RoutingFeesDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_RoutingFeesDecodeErrorZ* orig_conv = (LDKCResult_RoutingFeesDecodeErrorZ*)(orig & ~1);
	LDKCResult_RoutingFeesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RoutingFeesDecodeErrorZ), "LDKCResult_RoutingFeesDecodeErrorZ");
	*ret_conv = CResult_RoutingFeesDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementInfoDecodeErrorZ_ok"))) TS_CResult_NodeAnnouncementInfoDecodeErrorZ_ok(uint32_t o) {
	LDKNodeAnnouncementInfo o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = NodeAnnouncementInfo_clone(&o_conv);
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementInfoDecodeErrorZ), "LDKCResult_NodeAnnouncementInfoDecodeErrorZ");
	*ret_conv = CResult_NodeAnnouncementInfoDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementInfoDecodeErrorZ_err"))) TS_CResult_NodeAnnouncementInfoDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementInfoDecodeErrorZ), "LDKCResult_NodeAnnouncementInfoDecodeErrorZ");
	*ret_conv = CResult_NodeAnnouncementInfoDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NodeAnnouncementInfoDecodeErrorZ_is_ok"))) TS_CResult_NodeAnnouncementInfoDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* o_conv = (LDKCResult_NodeAnnouncementInfoDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NodeAnnouncementInfoDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NodeAnnouncementInfoDecodeErrorZ_free"))) TS_CResult_NodeAnnouncementInfoDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ _res_conv = *(LDKCResult_NodeAnnouncementInfoDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NodeAnnouncementInfoDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NodeAnnouncementInfoDecodeErrorZ_clone_ptr(LDKCResult_NodeAnnouncementInfoDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementInfoDecodeErrorZ), "LDKCResult_NodeAnnouncementInfoDecodeErrorZ");
	*ret_conv = CResult_NodeAnnouncementInfoDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementInfoDecodeErrorZ_clone_ptr"))) TS_CResult_NodeAnnouncementInfoDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* arg_conv = (LDKCResult_NodeAnnouncementInfoDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NodeAnnouncementInfoDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementInfoDecodeErrorZ_clone"))) TS_CResult_NodeAnnouncementInfoDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* orig_conv = (LDKCResult_NodeAnnouncementInfoDecodeErrorZ*)(orig & ~1);
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementInfoDecodeErrorZ), "LDKCResult_NodeAnnouncementInfoDecodeErrorZ");
	*ret_conv = CResult_NodeAnnouncementInfoDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_u64Z_free"))) TS_CVec_u64Z_free(int64_tArray _res) {
	LDKCVec_u64Z _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(int64_t), "LDKCVec_u64Z Elements");
	else
		_res_constr.data = NULL;
	int64_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t i = 0; i < _res_constr.datalen; i++) {
		int64_t _res_conv_8 = _res_vals[i];
		_res_constr.data[i] = _res_conv_8;
	}
	CVec_u64Z_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_NodeInfoDecodeErrorZ_ok"))) TS_CResult_NodeInfoDecodeErrorZ_ok(uint32_t o) {
	LDKNodeInfo o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = NodeInfo_clone(&o_conv);
	LDKCResult_NodeInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeInfoDecodeErrorZ), "LDKCResult_NodeInfoDecodeErrorZ");
	*ret_conv = CResult_NodeInfoDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeInfoDecodeErrorZ_err"))) TS_CResult_NodeInfoDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_NodeInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeInfoDecodeErrorZ), "LDKCResult_NodeInfoDecodeErrorZ");
	*ret_conv = CResult_NodeInfoDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NodeInfoDecodeErrorZ_is_ok"))) TS_CResult_NodeInfoDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_NodeInfoDecodeErrorZ* o_conv = (LDKCResult_NodeInfoDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NodeInfoDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NodeInfoDecodeErrorZ_free"))) TS_CResult_NodeInfoDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NodeInfoDecodeErrorZ _res_conv = *(LDKCResult_NodeInfoDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NodeInfoDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NodeInfoDecodeErrorZ_clone_ptr(LDKCResult_NodeInfoDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_NodeInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeInfoDecodeErrorZ), "LDKCResult_NodeInfoDecodeErrorZ");
	*ret_conv = CResult_NodeInfoDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NodeInfoDecodeErrorZ_clone_ptr"))) TS_CResult_NodeInfoDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NodeInfoDecodeErrorZ* arg_conv = (LDKCResult_NodeInfoDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NodeInfoDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeInfoDecodeErrorZ_clone"))) TS_CResult_NodeInfoDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_NodeInfoDecodeErrorZ* orig_conv = (LDKCResult_NodeInfoDecodeErrorZ*)(orig & ~1);
	LDKCResult_NodeInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeInfoDecodeErrorZ), "LDKCResult_NodeInfoDecodeErrorZ");
	*ret_conv = CResult_NodeInfoDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NetworkGraphDecodeErrorZ_ok"))) TS_CResult_NetworkGraphDecodeErrorZ_ok(uint32_t o) {
	LDKNetworkGraph o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = NetworkGraph_clone(&o_conv);
	LDKCResult_NetworkGraphDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetworkGraphDecodeErrorZ), "LDKCResult_NetworkGraphDecodeErrorZ");
	*ret_conv = CResult_NetworkGraphDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NetworkGraphDecodeErrorZ_err"))) TS_CResult_NetworkGraphDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_NetworkGraphDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetworkGraphDecodeErrorZ), "LDKCResult_NetworkGraphDecodeErrorZ");
	*ret_conv = CResult_NetworkGraphDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NetworkGraphDecodeErrorZ_is_ok"))) TS_CResult_NetworkGraphDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_NetworkGraphDecodeErrorZ* o_conv = (LDKCResult_NetworkGraphDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NetworkGraphDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NetworkGraphDecodeErrorZ_free"))) TS_CResult_NetworkGraphDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NetworkGraphDecodeErrorZ _res_conv = *(LDKCResult_NetworkGraphDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NetworkGraphDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NetworkGraphDecodeErrorZ_clone_ptr(LDKCResult_NetworkGraphDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_NetworkGraphDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetworkGraphDecodeErrorZ), "LDKCResult_NetworkGraphDecodeErrorZ");
	*ret_conv = CResult_NetworkGraphDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NetworkGraphDecodeErrorZ_clone_ptr"))) TS_CResult_NetworkGraphDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NetworkGraphDecodeErrorZ* arg_conv = (LDKCResult_NetworkGraphDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NetworkGraphDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NetworkGraphDecodeErrorZ_clone"))) TS_CResult_NetworkGraphDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_NetworkGraphDecodeErrorZ* orig_conv = (LDKCResult_NetworkGraphDecodeErrorZ*)(orig & ~1);
	LDKCResult_NetworkGraphDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetworkGraphDecodeErrorZ), "LDKCResult_NetworkGraphDecodeErrorZ");
	*ret_conv = CResult_NetworkGraphDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_CVec_NetAddressZZ_some"))) TS_COption_CVec_NetAddressZZ_some(uint32_tArray o) {
	LDKCVec_NetAddressZ o_constr;
	o_constr.datalen = o->arr_len;
	if (o_constr.datalen > 0)
		o_constr.data = MALLOC(o_constr.datalen * sizeof(LDKNetAddress), "LDKCVec_NetAddressZ Elements");
	else
		o_constr.data = NULL;
	uint32_t* o_vals = o->elems /* XXX o leaks */;
	for (size_t m = 0; m < o_constr.datalen; m++) {
		uint32_t o_conv_12 = o_vals[m];
		void* o_conv_12_ptr = (void*)(((uintptr_t)o_conv_12) & ~1);
		CHECK_ACCESS(o_conv_12_ptr);
		LDKNetAddress o_conv_12_conv = *(LDKNetAddress*)(o_conv_12_ptr);
		o_conv_12_conv = NetAddress_clone((LDKNetAddress*)(((uintptr_t)o_conv_12) & ~1));
		o_constr.data[m] = o_conv_12_conv;
	}
	LDKCOption_CVec_NetAddressZZ *ret_copy = MALLOC(sizeof(LDKCOption_CVec_NetAddressZZ), "LDKCOption_CVec_NetAddressZZ");
	*ret_copy = COption_CVec_NetAddressZZ_some(o_constr);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_CVec_NetAddressZZ_none"))) TS_COption_CVec_NetAddressZZ_none() {
	LDKCOption_CVec_NetAddressZZ *ret_copy = MALLOC(sizeof(LDKCOption_CVec_NetAddressZZ), "LDKCOption_CVec_NetAddressZZ");
	*ret_copy = COption_CVec_NetAddressZZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_CVec_NetAddressZZ_free"))) TS_COption_CVec_NetAddressZZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_CVec_NetAddressZZ _res_conv = *(LDKCOption_CVec_NetAddressZZ*)(_res_ptr);
	FREE((void*)_res);
	COption_CVec_NetAddressZZ_free(_res_conv);
}

static inline uintptr_t COption_CVec_NetAddressZZ_clone_ptr(LDKCOption_CVec_NetAddressZZ *NONNULL_PTR arg) {
	LDKCOption_CVec_NetAddressZZ *ret_copy = MALLOC(sizeof(LDKCOption_CVec_NetAddressZZ), "LDKCOption_CVec_NetAddressZZ");
	*ret_copy = COption_CVec_NetAddressZZ_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_COption_CVec_NetAddressZZ_clone_ptr"))) TS_COption_CVec_NetAddressZZ_clone_ptr(uint32_t arg) {
	LDKCOption_CVec_NetAddressZZ* arg_conv = (LDKCOption_CVec_NetAddressZZ*)arg;
	uint32_t ret_val = COption_CVec_NetAddressZZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_COption_CVec_NetAddressZZ_clone"))) TS_COption_CVec_NetAddressZZ_clone(uint32_t orig) {
	LDKCOption_CVec_NetAddressZZ* orig_conv = (LDKCOption_CVec_NetAddressZZ*)orig;
	LDKCOption_CVec_NetAddressZZ *ret_copy = MALLOC(sizeof(LDKCOption_CVec_NetAddressZZ), "LDKCOption_CVec_NetAddressZZ");
	*ret_copy = COption_CVec_NetAddressZZ_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CResult_NetAddressDecodeErrorZ_ok"))) TS_CResult_NetAddressDecodeErrorZ_ok(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKNetAddress o_conv = *(LDKNetAddress*)(o_ptr);
	o_conv = NetAddress_clone((LDKNetAddress*)(((uintptr_t)o) & ~1));
	LDKCResult_NetAddressDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetAddressDecodeErrorZ), "LDKCResult_NetAddressDecodeErrorZ");
	*ret_conv = CResult_NetAddressDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NetAddressDecodeErrorZ_err"))) TS_CResult_NetAddressDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_NetAddressDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetAddressDecodeErrorZ), "LDKCResult_NetAddressDecodeErrorZ");
	*ret_conv = CResult_NetAddressDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NetAddressDecodeErrorZ_is_ok"))) TS_CResult_NetAddressDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_NetAddressDecodeErrorZ* o_conv = (LDKCResult_NetAddressDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NetAddressDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NetAddressDecodeErrorZ_free"))) TS_CResult_NetAddressDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NetAddressDecodeErrorZ _res_conv = *(LDKCResult_NetAddressDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NetAddressDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NetAddressDecodeErrorZ_clone_ptr(LDKCResult_NetAddressDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_NetAddressDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetAddressDecodeErrorZ), "LDKCResult_NetAddressDecodeErrorZ");
	*ret_conv = CResult_NetAddressDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NetAddressDecodeErrorZ_clone_ptr"))) TS_CResult_NetAddressDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NetAddressDecodeErrorZ* arg_conv = (LDKCResult_NetAddressDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NetAddressDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NetAddressDecodeErrorZ_clone"))) TS_CResult_NetAddressDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_NetAddressDecodeErrorZ* orig_conv = (LDKCResult_NetAddressDecodeErrorZ*)(orig & ~1);
	LDKCResult_NetAddressDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetAddressDecodeErrorZ), "LDKCResult_NetAddressDecodeErrorZ");
	*ret_conv = CResult_NetAddressDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CVec_UpdateAddHTLCZ_free"))) TS_CVec_UpdateAddHTLCZ_free(uint32_tArray _res) {
	LDKCVec_UpdateAddHTLCZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKUpdateAddHTLC), "LDKCVec_UpdateAddHTLCZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t p = 0; p < _res_constr.datalen; p++) {
		uint32_t _res_conv_15 = _res_vals[p];
		LDKUpdateAddHTLC _res_conv_15_conv;
		_res_conv_15_conv.inner = (void*)(_res_conv_15 & (~1));
		_res_conv_15_conv.is_owned = (_res_conv_15 & 1) || (_res_conv_15 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_15_conv);
		_res_constr.data[p] = _res_conv_15_conv;
	}
	CVec_UpdateAddHTLCZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_UpdateFulfillHTLCZ_free"))) TS_CVec_UpdateFulfillHTLCZ_free(uint32_tArray _res) {
	LDKCVec_UpdateFulfillHTLCZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKUpdateFulfillHTLC), "LDKCVec_UpdateFulfillHTLCZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t t = 0; t < _res_constr.datalen; t++) {
		uint32_t _res_conv_19 = _res_vals[t];
		LDKUpdateFulfillHTLC _res_conv_19_conv;
		_res_conv_19_conv.inner = (void*)(_res_conv_19 & (~1));
		_res_conv_19_conv.is_owned = (_res_conv_19 & 1) || (_res_conv_19 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_19_conv);
		_res_constr.data[t] = _res_conv_19_conv;
	}
	CVec_UpdateFulfillHTLCZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_UpdateFailHTLCZ_free"))) TS_CVec_UpdateFailHTLCZ_free(uint32_tArray _res) {
	LDKCVec_UpdateFailHTLCZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKUpdateFailHTLC), "LDKCVec_UpdateFailHTLCZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t q = 0; q < _res_constr.datalen; q++) {
		uint32_t _res_conv_16 = _res_vals[q];
		LDKUpdateFailHTLC _res_conv_16_conv;
		_res_conv_16_conv.inner = (void*)(_res_conv_16 & (~1));
		_res_conv_16_conv.is_owned = (_res_conv_16 & 1) || (_res_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_16_conv);
		_res_constr.data[q] = _res_conv_16_conv;
	}
	CVec_UpdateFailHTLCZ_free(_res_constr);
}

void  __attribute__((export_name("TS_CVec_UpdateFailMalformedHTLCZ_free"))) TS_CVec_UpdateFailMalformedHTLCZ_free(uint32_tArray _res) {
	LDKCVec_UpdateFailMalformedHTLCZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKUpdateFailMalformedHTLC), "LDKCVec_UpdateFailMalformedHTLCZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t z = 0; z < _res_constr.datalen; z++) {
		uint32_t _res_conv_25 = _res_vals[z];
		LDKUpdateFailMalformedHTLC _res_conv_25_conv;
		_res_conv_25_conv.inner = (void*)(_res_conv_25 & (~1));
		_res_conv_25_conv.is_owned = (_res_conv_25 & 1) || (_res_conv_25 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_25_conv);
		_res_constr.data[z] = _res_conv_25_conv;
	}
	CVec_UpdateFailMalformedHTLCZ_free(_res_constr);
}

uint32_t  __attribute__((export_name("TS_CResult_AcceptChannelDecodeErrorZ_ok"))) TS_CResult_AcceptChannelDecodeErrorZ_ok(uint32_t o) {
	LDKAcceptChannel o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = AcceptChannel_clone(&o_conv);
	LDKCResult_AcceptChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AcceptChannelDecodeErrorZ), "LDKCResult_AcceptChannelDecodeErrorZ");
	*ret_conv = CResult_AcceptChannelDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_AcceptChannelDecodeErrorZ_err"))) TS_CResult_AcceptChannelDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_AcceptChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AcceptChannelDecodeErrorZ), "LDKCResult_AcceptChannelDecodeErrorZ");
	*ret_conv = CResult_AcceptChannelDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_AcceptChannelDecodeErrorZ_is_ok"))) TS_CResult_AcceptChannelDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_AcceptChannelDecodeErrorZ* o_conv = (LDKCResult_AcceptChannelDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_AcceptChannelDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_AcceptChannelDecodeErrorZ_free"))) TS_CResult_AcceptChannelDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_AcceptChannelDecodeErrorZ _res_conv = *(LDKCResult_AcceptChannelDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_AcceptChannelDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_AcceptChannelDecodeErrorZ_clone_ptr(LDKCResult_AcceptChannelDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_AcceptChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AcceptChannelDecodeErrorZ), "LDKCResult_AcceptChannelDecodeErrorZ");
	*ret_conv = CResult_AcceptChannelDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_AcceptChannelDecodeErrorZ_clone_ptr"))) TS_CResult_AcceptChannelDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_AcceptChannelDecodeErrorZ* arg_conv = (LDKCResult_AcceptChannelDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_AcceptChannelDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_AcceptChannelDecodeErrorZ_clone"))) TS_CResult_AcceptChannelDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_AcceptChannelDecodeErrorZ* orig_conv = (LDKCResult_AcceptChannelDecodeErrorZ*)(orig & ~1);
	LDKCResult_AcceptChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AcceptChannelDecodeErrorZ), "LDKCResult_AcceptChannelDecodeErrorZ");
	*ret_conv = CResult_AcceptChannelDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_AnnouncementSignaturesDecodeErrorZ_ok"))) TS_CResult_AnnouncementSignaturesDecodeErrorZ_ok(uint32_t o) {
	LDKAnnouncementSignatures o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = AnnouncementSignatures_clone(&o_conv);
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AnnouncementSignaturesDecodeErrorZ), "LDKCResult_AnnouncementSignaturesDecodeErrorZ");
	*ret_conv = CResult_AnnouncementSignaturesDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_AnnouncementSignaturesDecodeErrorZ_err"))) TS_CResult_AnnouncementSignaturesDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AnnouncementSignaturesDecodeErrorZ), "LDKCResult_AnnouncementSignaturesDecodeErrorZ");
	*ret_conv = CResult_AnnouncementSignaturesDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_AnnouncementSignaturesDecodeErrorZ_is_ok"))) TS_CResult_AnnouncementSignaturesDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* o_conv = (LDKCResult_AnnouncementSignaturesDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_AnnouncementSignaturesDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_AnnouncementSignaturesDecodeErrorZ_free"))) TS_CResult_AnnouncementSignaturesDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_AnnouncementSignaturesDecodeErrorZ _res_conv = *(LDKCResult_AnnouncementSignaturesDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_AnnouncementSignaturesDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_AnnouncementSignaturesDecodeErrorZ_clone_ptr(LDKCResult_AnnouncementSignaturesDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AnnouncementSignaturesDecodeErrorZ), "LDKCResult_AnnouncementSignaturesDecodeErrorZ");
	*ret_conv = CResult_AnnouncementSignaturesDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_AnnouncementSignaturesDecodeErrorZ_clone_ptr"))) TS_CResult_AnnouncementSignaturesDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* arg_conv = (LDKCResult_AnnouncementSignaturesDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_AnnouncementSignaturesDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_AnnouncementSignaturesDecodeErrorZ_clone"))) TS_CResult_AnnouncementSignaturesDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* orig_conv = (LDKCResult_AnnouncementSignaturesDecodeErrorZ*)(orig & ~1);
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AnnouncementSignaturesDecodeErrorZ), "LDKCResult_AnnouncementSignaturesDecodeErrorZ");
	*ret_conv = CResult_AnnouncementSignaturesDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelReestablishDecodeErrorZ_ok"))) TS_CResult_ChannelReestablishDecodeErrorZ_ok(uint32_t o) {
	LDKChannelReestablish o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelReestablish_clone(&o_conv);
	LDKCResult_ChannelReestablishDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelReestablishDecodeErrorZ), "LDKCResult_ChannelReestablishDecodeErrorZ");
	*ret_conv = CResult_ChannelReestablishDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelReestablishDecodeErrorZ_err"))) TS_CResult_ChannelReestablishDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelReestablishDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelReestablishDecodeErrorZ), "LDKCResult_ChannelReestablishDecodeErrorZ");
	*ret_conv = CResult_ChannelReestablishDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelReestablishDecodeErrorZ_is_ok"))) TS_CResult_ChannelReestablishDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelReestablishDecodeErrorZ* o_conv = (LDKCResult_ChannelReestablishDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelReestablishDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelReestablishDecodeErrorZ_free"))) TS_CResult_ChannelReestablishDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelReestablishDecodeErrorZ _res_conv = *(LDKCResult_ChannelReestablishDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelReestablishDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelReestablishDecodeErrorZ_clone_ptr(LDKCResult_ChannelReestablishDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelReestablishDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelReestablishDecodeErrorZ), "LDKCResult_ChannelReestablishDecodeErrorZ");
	*ret_conv = CResult_ChannelReestablishDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelReestablishDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelReestablishDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelReestablishDecodeErrorZ* arg_conv = (LDKCResult_ChannelReestablishDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelReestablishDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelReestablishDecodeErrorZ_clone"))) TS_CResult_ChannelReestablishDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelReestablishDecodeErrorZ* orig_conv = (LDKCResult_ChannelReestablishDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelReestablishDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelReestablishDecodeErrorZ), "LDKCResult_ChannelReestablishDecodeErrorZ");
	*ret_conv = CResult_ChannelReestablishDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedDecodeErrorZ_ok"))) TS_CResult_ClosingSignedDecodeErrorZ_ok(uint32_t o) {
	LDKClosingSigned o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ClosingSigned_clone(&o_conv);
	LDKCResult_ClosingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedDecodeErrorZ), "LDKCResult_ClosingSignedDecodeErrorZ");
	*ret_conv = CResult_ClosingSignedDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedDecodeErrorZ_err"))) TS_CResult_ClosingSignedDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ClosingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedDecodeErrorZ), "LDKCResult_ClosingSignedDecodeErrorZ");
	*ret_conv = CResult_ClosingSignedDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ClosingSignedDecodeErrorZ_is_ok"))) TS_CResult_ClosingSignedDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ClosingSignedDecodeErrorZ* o_conv = (LDKCResult_ClosingSignedDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ClosingSignedDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ClosingSignedDecodeErrorZ_free"))) TS_CResult_ClosingSignedDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ClosingSignedDecodeErrorZ _res_conv = *(LDKCResult_ClosingSignedDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ClosingSignedDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ClosingSignedDecodeErrorZ_clone_ptr(LDKCResult_ClosingSignedDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ClosingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedDecodeErrorZ), "LDKCResult_ClosingSignedDecodeErrorZ");
	*ret_conv = CResult_ClosingSignedDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedDecodeErrorZ_clone_ptr"))) TS_CResult_ClosingSignedDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ClosingSignedDecodeErrorZ* arg_conv = (LDKCResult_ClosingSignedDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ClosingSignedDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedDecodeErrorZ_clone"))) TS_CResult_ClosingSignedDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ClosingSignedDecodeErrorZ* orig_conv = (LDKCResult_ClosingSignedDecodeErrorZ*)(orig & ~1);
	LDKCResult_ClosingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedDecodeErrorZ), "LDKCResult_ClosingSignedDecodeErrorZ");
	*ret_conv = CResult_ClosingSignedDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_ok"))) TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_ok(uint32_t o) {
	LDKClosingSignedFeeRange o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ClosingSignedFeeRange_clone(&o_conv);
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ), "LDKCResult_ClosingSignedFeeRangeDecodeErrorZ");
	*ret_conv = CResult_ClosingSignedFeeRangeDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_err"))) TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ), "LDKCResult_ClosingSignedFeeRangeDecodeErrorZ");
	*ret_conv = CResult_ClosingSignedFeeRangeDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_is_ok"))) TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* o_conv = (LDKCResult_ClosingSignedFeeRangeDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ClosingSignedFeeRangeDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_free"))) TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ _res_conv = *(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ClosingSignedFeeRangeDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ClosingSignedFeeRangeDecodeErrorZ_clone_ptr(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ), "LDKCResult_ClosingSignedFeeRangeDecodeErrorZ");
	*ret_conv = CResult_ClosingSignedFeeRangeDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_clone_ptr"))) TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* arg_conv = (LDKCResult_ClosingSignedFeeRangeDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ClosingSignedFeeRangeDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_clone"))) TS_CResult_ClosingSignedFeeRangeDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* orig_conv = (LDKCResult_ClosingSignedFeeRangeDecodeErrorZ*)(orig & ~1);
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ), "LDKCResult_ClosingSignedFeeRangeDecodeErrorZ");
	*ret_conv = CResult_ClosingSignedFeeRangeDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CommitmentSignedDecodeErrorZ_ok"))) TS_CResult_CommitmentSignedDecodeErrorZ_ok(uint32_t o) {
	LDKCommitmentSigned o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = CommitmentSigned_clone(&o_conv);
	LDKCResult_CommitmentSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentSignedDecodeErrorZ), "LDKCResult_CommitmentSignedDecodeErrorZ");
	*ret_conv = CResult_CommitmentSignedDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_CommitmentSignedDecodeErrorZ_err"))) TS_CResult_CommitmentSignedDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_CommitmentSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentSignedDecodeErrorZ), "LDKCResult_CommitmentSignedDecodeErrorZ");
	*ret_conv = CResult_CommitmentSignedDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_CommitmentSignedDecodeErrorZ_is_ok"))) TS_CResult_CommitmentSignedDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_CommitmentSignedDecodeErrorZ* o_conv = (LDKCResult_CommitmentSignedDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_CommitmentSignedDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_CommitmentSignedDecodeErrorZ_free"))) TS_CResult_CommitmentSignedDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_CommitmentSignedDecodeErrorZ _res_conv = *(LDKCResult_CommitmentSignedDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_CommitmentSignedDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_CommitmentSignedDecodeErrorZ_clone_ptr(LDKCResult_CommitmentSignedDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_CommitmentSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentSignedDecodeErrorZ), "LDKCResult_CommitmentSignedDecodeErrorZ");
	*ret_conv = CResult_CommitmentSignedDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_CommitmentSignedDecodeErrorZ_clone_ptr"))) TS_CResult_CommitmentSignedDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_CommitmentSignedDecodeErrorZ* arg_conv = (LDKCResult_CommitmentSignedDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_CommitmentSignedDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_CommitmentSignedDecodeErrorZ_clone"))) TS_CResult_CommitmentSignedDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_CommitmentSignedDecodeErrorZ* orig_conv = (LDKCResult_CommitmentSignedDecodeErrorZ*)(orig & ~1);
	LDKCResult_CommitmentSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentSignedDecodeErrorZ), "LDKCResult_CommitmentSignedDecodeErrorZ");
	*ret_conv = CResult_CommitmentSignedDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingCreatedDecodeErrorZ_ok"))) TS_CResult_FundingCreatedDecodeErrorZ_ok(uint32_t o) {
	LDKFundingCreated o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = FundingCreated_clone(&o_conv);
	LDKCResult_FundingCreatedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingCreatedDecodeErrorZ), "LDKCResult_FundingCreatedDecodeErrorZ");
	*ret_conv = CResult_FundingCreatedDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingCreatedDecodeErrorZ_err"))) TS_CResult_FundingCreatedDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_FundingCreatedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingCreatedDecodeErrorZ), "LDKCResult_FundingCreatedDecodeErrorZ");
	*ret_conv = CResult_FundingCreatedDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_FundingCreatedDecodeErrorZ_is_ok"))) TS_CResult_FundingCreatedDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_FundingCreatedDecodeErrorZ* o_conv = (LDKCResult_FundingCreatedDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_FundingCreatedDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_FundingCreatedDecodeErrorZ_free"))) TS_CResult_FundingCreatedDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_FundingCreatedDecodeErrorZ _res_conv = *(LDKCResult_FundingCreatedDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_FundingCreatedDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_FundingCreatedDecodeErrorZ_clone_ptr(LDKCResult_FundingCreatedDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_FundingCreatedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingCreatedDecodeErrorZ), "LDKCResult_FundingCreatedDecodeErrorZ");
	*ret_conv = CResult_FundingCreatedDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_FundingCreatedDecodeErrorZ_clone_ptr"))) TS_CResult_FundingCreatedDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_FundingCreatedDecodeErrorZ* arg_conv = (LDKCResult_FundingCreatedDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_FundingCreatedDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingCreatedDecodeErrorZ_clone"))) TS_CResult_FundingCreatedDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_FundingCreatedDecodeErrorZ* orig_conv = (LDKCResult_FundingCreatedDecodeErrorZ*)(orig & ~1);
	LDKCResult_FundingCreatedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingCreatedDecodeErrorZ), "LDKCResult_FundingCreatedDecodeErrorZ");
	*ret_conv = CResult_FundingCreatedDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingSignedDecodeErrorZ_ok"))) TS_CResult_FundingSignedDecodeErrorZ_ok(uint32_t o) {
	LDKFundingSigned o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = FundingSigned_clone(&o_conv);
	LDKCResult_FundingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingSignedDecodeErrorZ), "LDKCResult_FundingSignedDecodeErrorZ");
	*ret_conv = CResult_FundingSignedDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingSignedDecodeErrorZ_err"))) TS_CResult_FundingSignedDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_FundingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingSignedDecodeErrorZ), "LDKCResult_FundingSignedDecodeErrorZ");
	*ret_conv = CResult_FundingSignedDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_FundingSignedDecodeErrorZ_is_ok"))) TS_CResult_FundingSignedDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_FundingSignedDecodeErrorZ* o_conv = (LDKCResult_FundingSignedDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_FundingSignedDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_FundingSignedDecodeErrorZ_free"))) TS_CResult_FundingSignedDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_FundingSignedDecodeErrorZ _res_conv = *(LDKCResult_FundingSignedDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_FundingSignedDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_FundingSignedDecodeErrorZ_clone_ptr(LDKCResult_FundingSignedDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_FundingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingSignedDecodeErrorZ), "LDKCResult_FundingSignedDecodeErrorZ");
	*ret_conv = CResult_FundingSignedDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_FundingSignedDecodeErrorZ_clone_ptr"))) TS_CResult_FundingSignedDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_FundingSignedDecodeErrorZ* arg_conv = (LDKCResult_FundingSignedDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_FundingSignedDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingSignedDecodeErrorZ_clone"))) TS_CResult_FundingSignedDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_FundingSignedDecodeErrorZ* orig_conv = (LDKCResult_FundingSignedDecodeErrorZ*)(orig & ~1);
	LDKCResult_FundingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingSignedDecodeErrorZ), "LDKCResult_FundingSignedDecodeErrorZ");
	*ret_conv = CResult_FundingSignedDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingLockedDecodeErrorZ_ok"))) TS_CResult_FundingLockedDecodeErrorZ_ok(uint32_t o) {
	LDKFundingLocked o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = FundingLocked_clone(&o_conv);
	LDKCResult_FundingLockedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingLockedDecodeErrorZ), "LDKCResult_FundingLockedDecodeErrorZ");
	*ret_conv = CResult_FundingLockedDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingLockedDecodeErrorZ_err"))) TS_CResult_FundingLockedDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_FundingLockedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingLockedDecodeErrorZ), "LDKCResult_FundingLockedDecodeErrorZ");
	*ret_conv = CResult_FundingLockedDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_FundingLockedDecodeErrorZ_is_ok"))) TS_CResult_FundingLockedDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_FundingLockedDecodeErrorZ* o_conv = (LDKCResult_FundingLockedDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_FundingLockedDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_FundingLockedDecodeErrorZ_free"))) TS_CResult_FundingLockedDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_FundingLockedDecodeErrorZ _res_conv = *(LDKCResult_FundingLockedDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_FundingLockedDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_FundingLockedDecodeErrorZ_clone_ptr(LDKCResult_FundingLockedDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_FundingLockedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingLockedDecodeErrorZ), "LDKCResult_FundingLockedDecodeErrorZ");
	*ret_conv = CResult_FundingLockedDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_FundingLockedDecodeErrorZ_clone_ptr"))) TS_CResult_FundingLockedDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_FundingLockedDecodeErrorZ* arg_conv = (LDKCResult_FundingLockedDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_FundingLockedDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_FundingLockedDecodeErrorZ_clone"))) TS_CResult_FundingLockedDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_FundingLockedDecodeErrorZ* orig_conv = (LDKCResult_FundingLockedDecodeErrorZ*)(orig & ~1);
	LDKCResult_FundingLockedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingLockedDecodeErrorZ), "LDKCResult_FundingLockedDecodeErrorZ");
	*ret_conv = CResult_FundingLockedDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InitDecodeErrorZ_ok"))) TS_CResult_InitDecodeErrorZ_ok(uint32_t o) {
	LDKInit o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Init_clone(&o_conv);
	LDKCResult_InitDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InitDecodeErrorZ), "LDKCResult_InitDecodeErrorZ");
	*ret_conv = CResult_InitDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InitDecodeErrorZ_err"))) TS_CResult_InitDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_InitDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InitDecodeErrorZ), "LDKCResult_InitDecodeErrorZ");
	*ret_conv = CResult_InitDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_InitDecodeErrorZ_is_ok"))) TS_CResult_InitDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_InitDecodeErrorZ* o_conv = (LDKCResult_InitDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_InitDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_InitDecodeErrorZ_free"))) TS_CResult_InitDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_InitDecodeErrorZ _res_conv = *(LDKCResult_InitDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_InitDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_InitDecodeErrorZ_clone_ptr(LDKCResult_InitDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_InitDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InitDecodeErrorZ), "LDKCResult_InitDecodeErrorZ");
	*ret_conv = CResult_InitDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_InitDecodeErrorZ_clone_ptr"))) TS_CResult_InitDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_InitDecodeErrorZ* arg_conv = (LDKCResult_InitDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_InitDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_InitDecodeErrorZ_clone"))) TS_CResult_InitDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_InitDecodeErrorZ* orig_conv = (LDKCResult_InitDecodeErrorZ*)(orig & ~1);
	LDKCResult_InitDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InitDecodeErrorZ), "LDKCResult_InitDecodeErrorZ");
	*ret_conv = CResult_InitDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_OpenChannelDecodeErrorZ_ok"))) TS_CResult_OpenChannelDecodeErrorZ_ok(uint32_t o) {
	LDKOpenChannel o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = OpenChannel_clone(&o_conv);
	LDKCResult_OpenChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OpenChannelDecodeErrorZ), "LDKCResult_OpenChannelDecodeErrorZ");
	*ret_conv = CResult_OpenChannelDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_OpenChannelDecodeErrorZ_err"))) TS_CResult_OpenChannelDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_OpenChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OpenChannelDecodeErrorZ), "LDKCResult_OpenChannelDecodeErrorZ");
	*ret_conv = CResult_OpenChannelDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_OpenChannelDecodeErrorZ_is_ok"))) TS_CResult_OpenChannelDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_OpenChannelDecodeErrorZ* o_conv = (LDKCResult_OpenChannelDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_OpenChannelDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_OpenChannelDecodeErrorZ_free"))) TS_CResult_OpenChannelDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_OpenChannelDecodeErrorZ _res_conv = *(LDKCResult_OpenChannelDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_OpenChannelDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_OpenChannelDecodeErrorZ_clone_ptr(LDKCResult_OpenChannelDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_OpenChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OpenChannelDecodeErrorZ), "LDKCResult_OpenChannelDecodeErrorZ");
	*ret_conv = CResult_OpenChannelDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_OpenChannelDecodeErrorZ_clone_ptr"))) TS_CResult_OpenChannelDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_OpenChannelDecodeErrorZ* arg_conv = (LDKCResult_OpenChannelDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_OpenChannelDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_OpenChannelDecodeErrorZ_clone"))) TS_CResult_OpenChannelDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_OpenChannelDecodeErrorZ* orig_conv = (LDKCResult_OpenChannelDecodeErrorZ*)(orig & ~1);
	LDKCResult_OpenChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OpenChannelDecodeErrorZ), "LDKCResult_OpenChannelDecodeErrorZ");
	*ret_conv = CResult_OpenChannelDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RevokeAndACKDecodeErrorZ_ok"))) TS_CResult_RevokeAndACKDecodeErrorZ_ok(uint32_t o) {
	LDKRevokeAndACK o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = RevokeAndACK_clone(&o_conv);
	LDKCResult_RevokeAndACKDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RevokeAndACKDecodeErrorZ), "LDKCResult_RevokeAndACKDecodeErrorZ");
	*ret_conv = CResult_RevokeAndACKDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_RevokeAndACKDecodeErrorZ_err"))) TS_CResult_RevokeAndACKDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_RevokeAndACKDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RevokeAndACKDecodeErrorZ), "LDKCResult_RevokeAndACKDecodeErrorZ");
	*ret_conv = CResult_RevokeAndACKDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_RevokeAndACKDecodeErrorZ_is_ok"))) TS_CResult_RevokeAndACKDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_RevokeAndACKDecodeErrorZ* o_conv = (LDKCResult_RevokeAndACKDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_RevokeAndACKDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_RevokeAndACKDecodeErrorZ_free"))) TS_CResult_RevokeAndACKDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_RevokeAndACKDecodeErrorZ _res_conv = *(LDKCResult_RevokeAndACKDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_RevokeAndACKDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_RevokeAndACKDecodeErrorZ_clone_ptr(LDKCResult_RevokeAndACKDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_RevokeAndACKDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RevokeAndACKDecodeErrorZ), "LDKCResult_RevokeAndACKDecodeErrorZ");
	*ret_conv = CResult_RevokeAndACKDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_RevokeAndACKDecodeErrorZ_clone_ptr"))) TS_CResult_RevokeAndACKDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_RevokeAndACKDecodeErrorZ* arg_conv = (LDKCResult_RevokeAndACKDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_RevokeAndACKDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_RevokeAndACKDecodeErrorZ_clone"))) TS_CResult_RevokeAndACKDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_RevokeAndACKDecodeErrorZ* orig_conv = (LDKCResult_RevokeAndACKDecodeErrorZ*)(orig & ~1);
	LDKCResult_RevokeAndACKDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RevokeAndACKDecodeErrorZ), "LDKCResult_RevokeAndACKDecodeErrorZ");
	*ret_conv = CResult_RevokeAndACKDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownDecodeErrorZ_ok"))) TS_CResult_ShutdownDecodeErrorZ_ok(uint32_t o) {
	LDKShutdown o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Shutdown_clone(&o_conv);
	LDKCResult_ShutdownDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownDecodeErrorZ), "LDKCResult_ShutdownDecodeErrorZ");
	*ret_conv = CResult_ShutdownDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownDecodeErrorZ_err"))) TS_CResult_ShutdownDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ShutdownDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownDecodeErrorZ), "LDKCResult_ShutdownDecodeErrorZ");
	*ret_conv = CResult_ShutdownDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ShutdownDecodeErrorZ_is_ok"))) TS_CResult_ShutdownDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ShutdownDecodeErrorZ* o_conv = (LDKCResult_ShutdownDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ShutdownDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ShutdownDecodeErrorZ_free"))) TS_CResult_ShutdownDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ShutdownDecodeErrorZ _res_conv = *(LDKCResult_ShutdownDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ShutdownDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ShutdownDecodeErrorZ_clone_ptr(LDKCResult_ShutdownDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ShutdownDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownDecodeErrorZ), "LDKCResult_ShutdownDecodeErrorZ");
	*ret_conv = CResult_ShutdownDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ShutdownDecodeErrorZ_clone_ptr"))) TS_CResult_ShutdownDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ShutdownDecodeErrorZ* arg_conv = (LDKCResult_ShutdownDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ShutdownDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ShutdownDecodeErrorZ_clone"))) TS_CResult_ShutdownDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ShutdownDecodeErrorZ* orig_conv = (LDKCResult_ShutdownDecodeErrorZ*)(orig & ~1);
	LDKCResult_ShutdownDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownDecodeErrorZ), "LDKCResult_ShutdownDecodeErrorZ");
	*ret_conv = CResult_ShutdownDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFailHTLCDecodeErrorZ_ok"))) TS_CResult_UpdateFailHTLCDecodeErrorZ_ok(uint32_t o) {
	LDKUpdateFailHTLC o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = UpdateFailHTLC_clone(&o_conv);
	LDKCResult_UpdateFailHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailHTLCDecodeErrorZ), "LDKCResult_UpdateFailHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFailHTLCDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFailHTLCDecodeErrorZ_err"))) TS_CResult_UpdateFailHTLCDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_UpdateFailHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailHTLCDecodeErrorZ), "LDKCResult_UpdateFailHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFailHTLCDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_UpdateFailHTLCDecodeErrorZ_is_ok"))) TS_CResult_UpdateFailHTLCDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_UpdateFailHTLCDecodeErrorZ* o_conv = (LDKCResult_UpdateFailHTLCDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_UpdateFailHTLCDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_UpdateFailHTLCDecodeErrorZ_free"))) TS_CResult_UpdateFailHTLCDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_UpdateFailHTLCDecodeErrorZ _res_conv = *(LDKCResult_UpdateFailHTLCDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_UpdateFailHTLCDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_UpdateFailHTLCDecodeErrorZ_clone_ptr(LDKCResult_UpdateFailHTLCDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_UpdateFailHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailHTLCDecodeErrorZ), "LDKCResult_UpdateFailHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFailHTLCDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFailHTLCDecodeErrorZ_clone_ptr"))) TS_CResult_UpdateFailHTLCDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_UpdateFailHTLCDecodeErrorZ* arg_conv = (LDKCResult_UpdateFailHTLCDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_UpdateFailHTLCDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFailHTLCDecodeErrorZ_clone"))) TS_CResult_UpdateFailHTLCDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_UpdateFailHTLCDecodeErrorZ* orig_conv = (LDKCResult_UpdateFailHTLCDecodeErrorZ*)(orig & ~1);
	LDKCResult_UpdateFailHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailHTLCDecodeErrorZ), "LDKCResult_UpdateFailHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFailHTLCDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_ok"))) TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_ok(uint32_t o) {
	LDKUpdateFailMalformedHTLC o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = UpdateFailMalformedHTLC_clone(&o_conv);
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ), "LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFailMalformedHTLCDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_err"))) TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ), "LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFailMalformedHTLCDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_is_ok"))) TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* o_conv = (LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_UpdateFailMalformedHTLCDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_free"))) TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ _res_conv = *(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_UpdateFailMalformedHTLCDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_UpdateFailMalformedHTLCDecodeErrorZ_clone_ptr(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ), "LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFailMalformedHTLCDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_clone_ptr"))) TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* arg_conv = (LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_UpdateFailMalformedHTLCDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_clone"))) TS_CResult_UpdateFailMalformedHTLCDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* orig_conv = (LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ*)(orig & ~1);
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ), "LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFailMalformedHTLCDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFeeDecodeErrorZ_ok"))) TS_CResult_UpdateFeeDecodeErrorZ_ok(uint32_t o) {
	LDKUpdateFee o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = UpdateFee_clone(&o_conv);
	LDKCResult_UpdateFeeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFeeDecodeErrorZ), "LDKCResult_UpdateFeeDecodeErrorZ");
	*ret_conv = CResult_UpdateFeeDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFeeDecodeErrorZ_err"))) TS_CResult_UpdateFeeDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_UpdateFeeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFeeDecodeErrorZ), "LDKCResult_UpdateFeeDecodeErrorZ");
	*ret_conv = CResult_UpdateFeeDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_UpdateFeeDecodeErrorZ_is_ok"))) TS_CResult_UpdateFeeDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_UpdateFeeDecodeErrorZ* o_conv = (LDKCResult_UpdateFeeDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_UpdateFeeDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_UpdateFeeDecodeErrorZ_free"))) TS_CResult_UpdateFeeDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_UpdateFeeDecodeErrorZ _res_conv = *(LDKCResult_UpdateFeeDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_UpdateFeeDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_UpdateFeeDecodeErrorZ_clone_ptr(LDKCResult_UpdateFeeDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_UpdateFeeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFeeDecodeErrorZ), "LDKCResult_UpdateFeeDecodeErrorZ");
	*ret_conv = CResult_UpdateFeeDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFeeDecodeErrorZ_clone_ptr"))) TS_CResult_UpdateFeeDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_UpdateFeeDecodeErrorZ* arg_conv = (LDKCResult_UpdateFeeDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_UpdateFeeDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFeeDecodeErrorZ_clone"))) TS_CResult_UpdateFeeDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_UpdateFeeDecodeErrorZ* orig_conv = (LDKCResult_UpdateFeeDecodeErrorZ*)(orig & ~1);
	LDKCResult_UpdateFeeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFeeDecodeErrorZ), "LDKCResult_UpdateFeeDecodeErrorZ");
	*ret_conv = CResult_UpdateFeeDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFulfillHTLCDecodeErrorZ_ok"))) TS_CResult_UpdateFulfillHTLCDecodeErrorZ_ok(uint32_t o) {
	LDKUpdateFulfillHTLC o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = UpdateFulfillHTLC_clone(&o_conv);
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFulfillHTLCDecodeErrorZ), "LDKCResult_UpdateFulfillHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFulfillHTLCDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFulfillHTLCDecodeErrorZ_err"))) TS_CResult_UpdateFulfillHTLCDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFulfillHTLCDecodeErrorZ), "LDKCResult_UpdateFulfillHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFulfillHTLCDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_UpdateFulfillHTLCDecodeErrorZ_is_ok"))) TS_CResult_UpdateFulfillHTLCDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* o_conv = (LDKCResult_UpdateFulfillHTLCDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_UpdateFulfillHTLCDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_UpdateFulfillHTLCDecodeErrorZ_free"))) TS_CResult_UpdateFulfillHTLCDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ _res_conv = *(LDKCResult_UpdateFulfillHTLCDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_UpdateFulfillHTLCDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_UpdateFulfillHTLCDecodeErrorZ_clone_ptr(LDKCResult_UpdateFulfillHTLCDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFulfillHTLCDecodeErrorZ), "LDKCResult_UpdateFulfillHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFulfillHTLCDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateFulfillHTLCDecodeErrorZ_clone_ptr"))) TS_CResult_UpdateFulfillHTLCDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* arg_conv = (LDKCResult_UpdateFulfillHTLCDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_UpdateFulfillHTLCDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateFulfillHTLCDecodeErrorZ_clone"))) TS_CResult_UpdateFulfillHTLCDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* orig_conv = (LDKCResult_UpdateFulfillHTLCDecodeErrorZ*)(orig & ~1);
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFulfillHTLCDecodeErrorZ), "LDKCResult_UpdateFulfillHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateFulfillHTLCDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateAddHTLCDecodeErrorZ_ok"))) TS_CResult_UpdateAddHTLCDecodeErrorZ_ok(uint32_t o) {
	LDKUpdateAddHTLC o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = UpdateAddHTLC_clone(&o_conv);
	LDKCResult_UpdateAddHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateAddHTLCDecodeErrorZ), "LDKCResult_UpdateAddHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateAddHTLCDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateAddHTLCDecodeErrorZ_err"))) TS_CResult_UpdateAddHTLCDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_UpdateAddHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateAddHTLCDecodeErrorZ), "LDKCResult_UpdateAddHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateAddHTLCDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_UpdateAddHTLCDecodeErrorZ_is_ok"))) TS_CResult_UpdateAddHTLCDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_UpdateAddHTLCDecodeErrorZ* o_conv = (LDKCResult_UpdateAddHTLCDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_UpdateAddHTLCDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_UpdateAddHTLCDecodeErrorZ_free"))) TS_CResult_UpdateAddHTLCDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_UpdateAddHTLCDecodeErrorZ _res_conv = *(LDKCResult_UpdateAddHTLCDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_UpdateAddHTLCDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_UpdateAddHTLCDecodeErrorZ_clone_ptr(LDKCResult_UpdateAddHTLCDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_UpdateAddHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateAddHTLCDecodeErrorZ), "LDKCResult_UpdateAddHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateAddHTLCDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_UpdateAddHTLCDecodeErrorZ_clone_ptr"))) TS_CResult_UpdateAddHTLCDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_UpdateAddHTLCDecodeErrorZ* arg_conv = (LDKCResult_UpdateAddHTLCDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_UpdateAddHTLCDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_UpdateAddHTLCDecodeErrorZ_clone"))) TS_CResult_UpdateAddHTLCDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_UpdateAddHTLCDecodeErrorZ* orig_conv = (LDKCResult_UpdateAddHTLCDecodeErrorZ*)(orig & ~1);
	LDKCResult_UpdateAddHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateAddHTLCDecodeErrorZ), "LDKCResult_UpdateAddHTLCDecodeErrorZ");
	*ret_conv = CResult_UpdateAddHTLCDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PingDecodeErrorZ_ok"))) TS_CResult_PingDecodeErrorZ_ok(uint32_t o) {
	LDKPing o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Ping_clone(&o_conv);
	LDKCResult_PingDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PingDecodeErrorZ), "LDKCResult_PingDecodeErrorZ");
	*ret_conv = CResult_PingDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PingDecodeErrorZ_err"))) TS_CResult_PingDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_PingDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PingDecodeErrorZ), "LDKCResult_PingDecodeErrorZ");
	*ret_conv = CResult_PingDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PingDecodeErrorZ_is_ok"))) TS_CResult_PingDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_PingDecodeErrorZ* o_conv = (LDKCResult_PingDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PingDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PingDecodeErrorZ_free"))) TS_CResult_PingDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PingDecodeErrorZ _res_conv = *(LDKCResult_PingDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PingDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PingDecodeErrorZ_clone_ptr(LDKCResult_PingDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_PingDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PingDecodeErrorZ), "LDKCResult_PingDecodeErrorZ");
	*ret_conv = CResult_PingDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PingDecodeErrorZ_clone_ptr"))) TS_CResult_PingDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PingDecodeErrorZ* arg_conv = (LDKCResult_PingDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PingDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PingDecodeErrorZ_clone"))) TS_CResult_PingDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_PingDecodeErrorZ* orig_conv = (LDKCResult_PingDecodeErrorZ*)(orig & ~1);
	LDKCResult_PingDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PingDecodeErrorZ), "LDKCResult_PingDecodeErrorZ");
	*ret_conv = CResult_PingDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PongDecodeErrorZ_ok"))) TS_CResult_PongDecodeErrorZ_ok(uint32_t o) {
	LDKPong o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Pong_clone(&o_conv);
	LDKCResult_PongDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PongDecodeErrorZ), "LDKCResult_PongDecodeErrorZ");
	*ret_conv = CResult_PongDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_PongDecodeErrorZ_err"))) TS_CResult_PongDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_PongDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PongDecodeErrorZ), "LDKCResult_PongDecodeErrorZ");
	*ret_conv = CResult_PongDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_PongDecodeErrorZ_is_ok"))) TS_CResult_PongDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_PongDecodeErrorZ* o_conv = (LDKCResult_PongDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_PongDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_PongDecodeErrorZ_free"))) TS_CResult_PongDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_PongDecodeErrorZ _res_conv = *(LDKCResult_PongDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_PongDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_PongDecodeErrorZ_clone_ptr(LDKCResult_PongDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_PongDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PongDecodeErrorZ), "LDKCResult_PongDecodeErrorZ");
	*ret_conv = CResult_PongDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_PongDecodeErrorZ_clone_ptr"))) TS_CResult_PongDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_PongDecodeErrorZ* arg_conv = (LDKCResult_PongDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_PongDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_PongDecodeErrorZ_clone"))) TS_CResult_PongDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_PongDecodeErrorZ* orig_conv = (LDKCResult_PongDecodeErrorZ*)(orig & ~1);
	LDKCResult_PongDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PongDecodeErrorZ), "LDKCResult_PongDecodeErrorZ");
	*ret_conv = CResult_PongDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_ok"))) TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_ok(uint32_t o) {
	LDKUnsignedChannelAnnouncement o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = UnsignedChannelAnnouncement_clone(&o_conv);
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ), "LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ");
	*ret_conv = CResult_UnsignedChannelAnnouncementDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_err"))) TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ), "LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ");
	*ret_conv = CResult_UnsignedChannelAnnouncementDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_is_ok"))) TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* o_conv = (LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_UnsignedChannelAnnouncementDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_free"))) TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ _res_conv = *(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_UnsignedChannelAnnouncementDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_UnsignedChannelAnnouncementDecodeErrorZ_clone_ptr(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ), "LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ");
	*ret_conv = CResult_UnsignedChannelAnnouncementDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_clone_ptr"))) TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* arg_conv = (LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_UnsignedChannelAnnouncementDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_clone"))) TS_CResult_UnsignedChannelAnnouncementDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* orig_conv = (LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ*)(orig & ~1);
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ), "LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ");
	*ret_conv = CResult_UnsignedChannelAnnouncementDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelAnnouncementDecodeErrorZ_ok"))) TS_CResult_ChannelAnnouncementDecodeErrorZ_ok(uint32_t o) {
	LDKChannelAnnouncement o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelAnnouncement_clone(&o_conv);
	LDKCResult_ChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelAnnouncementDecodeErrorZ), "LDKCResult_ChannelAnnouncementDecodeErrorZ");
	*ret_conv = CResult_ChannelAnnouncementDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelAnnouncementDecodeErrorZ_err"))) TS_CResult_ChannelAnnouncementDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelAnnouncementDecodeErrorZ), "LDKCResult_ChannelAnnouncementDecodeErrorZ");
	*ret_conv = CResult_ChannelAnnouncementDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelAnnouncementDecodeErrorZ_is_ok"))) TS_CResult_ChannelAnnouncementDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelAnnouncementDecodeErrorZ* o_conv = (LDKCResult_ChannelAnnouncementDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelAnnouncementDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelAnnouncementDecodeErrorZ_free"))) TS_CResult_ChannelAnnouncementDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelAnnouncementDecodeErrorZ _res_conv = *(LDKCResult_ChannelAnnouncementDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelAnnouncementDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelAnnouncementDecodeErrorZ_clone_ptr(LDKCResult_ChannelAnnouncementDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelAnnouncementDecodeErrorZ), "LDKCResult_ChannelAnnouncementDecodeErrorZ");
	*ret_conv = CResult_ChannelAnnouncementDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelAnnouncementDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelAnnouncementDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelAnnouncementDecodeErrorZ* arg_conv = (LDKCResult_ChannelAnnouncementDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelAnnouncementDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelAnnouncementDecodeErrorZ_clone"))) TS_CResult_ChannelAnnouncementDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelAnnouncementDecodeErrorZ* orig_conv = (LDKCResult_ChannelAnnouncementDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelAnnouncementDecodeErrorZ), "LDKCResult_ChannelAnnouncementDecodeErrorZ");
	*ret_conv = CResult_ChannelAnnouncementDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelUpdateDecodeErrorZ_ok"))) TS_CResult_UnsignedChannelUpdateDecodeErrorZ_ok(uint32_t o) {
	LDKUnsignedChannelUpdate o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = UnsignedChannelUpdate_clone(&o_conv);
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelUpdateDecodeErrorZ), "LDKCResult_UnsignedChannelUpdateDecodeErrorZ");
	*ret_conv = CResult_UnsignedChannelUpdateDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelUpdateDecodeErrorZ_err"))) TS_CResult_UnsignedChannelUpdateDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelUpdateDecodeErrorZ), "LDKCResult_UnsignedChannelUpdateDecodeErrorZ");
	*ret_conv = CResult_UnsignedChannelUpdateDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_UnsignedChannelUpdateDecodeErrorZ_is_ok"))) TS_CResult_UnsignedChannelUpdateDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* o_conv = (LDKCResult_UnsignedChannelUpdateDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_UnsignedChannelUpdateDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_UnsignedChannelUpdateDecodeErrorZ_free"))) TS_CResult_UnsignedChannelUpdateDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ _res_conv = *(LDKCResult_UnsignedChannelUpdateDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_UnsignedChannelUpdateDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_UnsignedChannelUpdateDecodeErrorZ_clone_ptr(LDKCResult_UnsignedChannelUpdateDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelUpdateDecodeErrorZ), "LDKCResult_UnsignedChannelUpdateDecodeErrorZ");
	*ret_conv = CResult_UnsignedChannelUpdateDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelUpdateDecodeErrorZ_clone_ptr"))) TS_CResult_UnsignedChannelUpdateDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* arg_conv = (LDKCResult_UnsignedChannelUpdateDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_UnsignedChannelUpdateDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedChannelUpdateDecodeErrorZ_clone"))) TS_CResult_UnsignedChannelUpdateDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* orig_conv = (LDKCResult_UnsignedChannelUpdateDecodeErrorZ*)(orig & ~1);
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelUpdateDecodeErrorZ), "LDKCResult_UnsignedChannelUpdateDecodeErrorZ");
	*ret_conv = CResult_UnsignedChannelUpdateDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateDecodeErrorZ_ok"))) TS_CResult_ChannelUpdateDecodeErrorZ_ok(uint32_t o) {
	LDKChannelUpdate o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ChannelUpdate_clone(&o_conv);
	LDKCResult_ChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateDecodeErrorZ), "LDKCResult_ChannelUpdateDecodeErrorZ");
	*ret_conv = CResult_ChannelUpdateDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateDecodeErrorZ_err"))) TS_CResult_ChannelUpdateDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateDecodeErrorZ), "LDKCResult_ChannelUpdateDecodeErrorZ");
	*ret_conv = CResult_ChannelUpdateDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ChannelUpdateDecodeErrorZ_is_ok"))) TS_CResult_ChannelUpdateDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ChannelUpdateDecodeErrorZ* o_conv = (LDKCResult_ChannelUpdateDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ChannelUpdateDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ChannelUpdateDecodeErrorZ_free"))) TS_CResult_ChannelUpdateDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ChannelUpdateDecodeErrorZ _res_conv = *(LDKCResult_ChannelUpdateDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ChannelUpdateDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ChannelUpdateDecodeErrorZ_clone_ptr(LDKCResult_ChannelUpdateDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateDecodeErrorZ), "LDKCResult_ChannelUpdateDecodeErrorZ");
	*ret_conv = CResult_ChannelUpdateDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateDecodeErrorZ_clone_ptr"))) TS_CResult_ChannelUpdateDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ChannelUpdateDecodeErrorZ* arg_conv = (LDKCResult_ChannelUpdateDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ChannelUpdateDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ChannelUpdateDecodeErrorZ_clone"))) TS_CResult_ChannelUpdateDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ChannelUpdateDecodeErrorZ* orig_conv = (LDKCResult_ChannelUpdateDecodeErrorZ*)(orig & ~1);
	LDKCResult_ChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateDecodeErrorZ), "LDKCResult_ChannelUpdateDecodeErrorZ");
	*ret_conv = CResult_ChannelUpdateDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ErrorMessageDecodeErrorZ_ok"))) TS_CResult_ErrorMessageDecodeErrorZ_ok(uint32_t o) {
	LDKErrorMessage o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ErrorMessage_clone(&o_conv);
	LDKCResult_ErrorMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ErrorMessageDecodeErrorZ), "LDKCResult_ErrorMessageDecodeErrorZ");
	*ret_conv = CResult_ErrorMessageDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ErrorMessageDecodeErrorZ_err"))) TS_CResult_ErrorMessageDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ErrorMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ErrorMessageDecodeErrorZ), "LDKCResult_ErrorMessageDecodeErrorZ");
	*ret_conv = CResult_ErrorMessageDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ErrorMessageDecodeErrorZ_is_ok"))) TS_CResult_ErrorMessageDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ErrorMessageDecodeErrorZ* o_conv = (LDKCResult_ErrorMessageDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ErrorMessageDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ErrorMessageDecodeErrorZ_free"))) TS_CResult_ErrorMessageDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ErrorMessageDecodeErrorZ _res_conv = *(LDKCResult_ErrorMessageDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ErrorMessageDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ErrorMessageDecodeErrorZ_clone_ptr(LDKCResult_ErrorMessageDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ErrorMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ErrorMessageDecodeErrorZ), "LDKCResult_ErrorMessageDecodeErrorZ");
	*ret_conv = CResult_ErrorMessageDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ErrorMessageDecodeErrorZ_clone_ptr"))) TS_CResult_ErrorMessageDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ErrorMessageDecodeErrorZ* arg_conv = (LDKCResult_ErrorMessageDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ErrorMessageDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ErrorMessageDecodeErrorZ_clone"))) TS_CResult_ErrorMessageDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ErrorMessageDecodeErrorZ* orig_conv = (LDKCResult_ErrorMessageDecodeErrorZ*)(orig & ~1);
	LDKCResult_ErrorMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ErrorMessageDecodeErrorZ), "LDKCResult_ErrorMessageDecodeErrorZ");
	*ret_conv = CResult_ErrorMessageDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_WarningMessageDecodeErrorZ_ok"))) TS_CResult_WarningMessageDecodeErrorZ_ok(uint32_t o) {
	LDKWarningMessage o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = WarningMessage_clone(&o_conv);
	LDKCResult_WarningMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_WarningMessageDecodeErrorZ), "LDKCResult_WarningMessageDecodeErrorZ");
	*ret_conv = CResult_WarningMessageDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_WarningMessageDecodeErrorZ_err"))) TS_CResult_WarningMessageDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_WarningMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_WarningMessageDecodeErrorZ), "LDKCResult_WarningMessageDecodeErrorZ");
	*ret_conv = CResult_WarningMessageDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_WarningMessageDecodeErrorZ_is_ok"))) TS_CResult_WarningMessageDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_WarningMessageDecodeErrorZ* o_conv = (LDKCResult_WarningMessageDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_WarningMessageDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_WarningMessageDecodeErrorZ_free"))) TS_CResult_WarningMessageDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_WarningMessageDecodeErrorZ _res_conv = *(LDKCResult_WarningMessageDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_WarningMessageDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_WarningMessageDecodeErrorZ_clone_ptr(LDKCResult_WarningMessageDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_WarningMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_WarningMessageDecodeErrorZ), "LDKCResult_WarningMessageDecodeErrorZ");
	*ret_conv = CResult_WarningMessageDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_WarningMessageDecodeErrorZ_clone_ptr"))) TS_CResult_WarningMessageDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_WarningMessageDecodeErrorZ* arg_conv = (LDKCResult_WarningMessageDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_WarningMessageDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_WarningMessageDecodeErrorZ_clone"))) TS_CResult_WarningMessageDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_WarningMessageDecodeErrorZ* orig_conv = (LDKCResult_WarningMessageDecodeErrorZ*)(orig & ~1);
	LDKCResult_WarningMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_WarningMessageDecodeErrorZ), "LDKCResult_WarningMessageDecodeErrorZ");
	*ret_conv = CResult_WarningMessageDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_ok"))) TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_ok(uint32_t o) {
	LDKUnsignedNodeAnnouncement o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = UnsignedNodeAnnouncement_clone(&o_conv);
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ), "LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ");
	*ret_conv = CResult_UnsignedNodeAnnouncementDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_err"))) TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ), "LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ");
	*ret_conv = CResult_UnsignedNodeAnnouncementDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_is_ok"))) TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* o_conv = (LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_UnsignedNodeAnnouncementDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_free"))) TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ _res_conv = *(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_UnsignedNodeAnnouncementDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_UnsignedNodeAnnouncementDecodeErrorZ_clone_ptr(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ), "LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ");
	*ret_conv = CResult_UnsignedNodeAnnouncementDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_clone_ptr"))) TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* arg_conv = (LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_UnsignedNodeAnnouncementDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_clone"))) TS_CResult_UnsignedNodeAnnouncementDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* orig_conv = (LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ*)(orig & ~1);
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ), "LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ");
	*ret_conv = CResult_UnsignedNodeAnnouncementDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementDecodeErrorZ_ok"))) TS_CResult_NodeAnnouncementDecodeErrorZ_ok(uint32_t o) {
	LDKNodeAnnouncement o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = NodeAnnouncement_clone(&o_conv);
	LDKCResult_NodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementDecodeErrorZ), "LDKCResult_NodeAnnouncementDecodeErrorZ");
	*ret_conv = CResult_NodeAnnouncementDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementDecodeErrorZ_err"))) TS_CResult_NodeAnnouncementDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_NodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementDecodeErrorZ), "LDKCResult_NodeAnnouncementDecodeErrorZ");
	*ret_conv = CResult_NodeAnnouncementDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_NodeAnnouncementDecodeErrorZ_is_ok"))) TS_CResult_NodeAnnouncementDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_NodeAnnouncementDecodeErrorZ* o_conv = (LDKCResult_NodeAnnouncementDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_NodeAnnouncementDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_NodeAnnouncementDecodeErrorZ_free"))) TS_CResult_NodeAnnouncementDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_NodeAnnouncementDecodeErrorZ _res_conv = *(LDKCResult_NodeAnnouncementDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_NodeAnnouncementDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_NodeAnnouncementDecodeErrorZ_clone_ptr(LDKCResult_NodeAnnouncementDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_NodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementDecodeErrorZ), "LDKCResult_NodeAnnouncementDecodeErrorZ");
	*ret_conv = CResult_NodeAnnouncementDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementDecodeErrorZ_clone_ptr"))) TS_CResult_NodeAnnouncementDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_NodeAnnouncementDecodeErrorZ* arg_conv = (LDKCResult_NodeAnnouncementDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_NodeAnnouncementDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_NodeAnnouncementDecodeErrorZ_clone"))) TS_CResult_NodeAnnouncementDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_NodeAnnouncementDecodeErrorZ* orig_conv = (LDKCResult_NodeAnnouncementDecodeErrorZ*)(orig & ~1);
	LDKCResult_NodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementDecodeErrorZ), "LDKCResult_NodeAnnouncementDecodeErrorZ");
	*ret_conv = CResult_NodeAnnouncementDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_QueryShortChannelIdsDecodeErrorZ_ok"))) TS_CResult_QueryShortChannelIdsDecodeErrorZ_ok(uint32_t o) {
	LDKQueryShortChannelIds o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = QueryShortChannelIds_clone(&o_conv);
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryShortChannelIdsDecodeErrorZ), "LDKCResult_QueryShortChannelIdsDecodeErrorZ");
	*ret_conv = CResult_QueryShortChannelIdsDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_QueryShortChannelIdsDecodeErrorZ_err"))) TS_CResult_QueryShortChannelIdsDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryShortChannelIdsDecodeErrorZ), "LDKCResult_QueryShortChannelIdsDecodeErrorZ");
	*ret_conv = CResult_QueryShortChannelIdsDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_QueryShortChannelIdsDecodeErrorZ_is_ok"))) TS_CResult_QueryShortChannelIdsDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* o_conv = (LDKCResult_QueryShortChannelIdsDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_QueryShortChannelIdsDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_QueryShortChannelIdsDecodeErrorZ_free"))) TS_CResult_QueryShortChannelIdsDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_QueryShortChannelIdsDecodeErrorZ _res_conv = *(LDKCResult_QueryShortChannelIdsDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_QueryShortChannelIdsDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_QueryShortChannelIdsDecodeErrorZ_clone_ptr(LDKCResult_QueryShortChannelIdsDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryShortChannelIdsDecodeErrorZ), "LDKCResult_QueryShortChannelIdsDecodeErrorZ");
	*ret_conv = CResult_QueryShortChannelIdsDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_QueryShortChannelIdsDecodeErrorZ_clone_ptr"))) TS_CResult_QueryShortChannelIdsDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* arg_conv = (LDKCResult_QueryShortChannelIdsDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_QueryShortChannelIdsDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_QueryShortChannelIdsDecodeErrorZ_clone"))) TS_CResult_QueryShortChannelIdsDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* orig_conv = (LDKCResult_QueryShortChannelIdsDecodeErrorZ*)(orig & ~1);
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryShortChannelIdsDecodeErrorZ), "LDKCResult_QueryShortChannelIdsDecodeErrorZ");
	*ret_conv = CResult_QueryShortChannelIdsDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_ok"))) TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_ok(uint32_t o) {
	LDKReplyShortChannelIdsEnd o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ReplyShortChannelIdsEnd_clone(&o_conv);
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ), "LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ");
	*ret_conv = CResult_ReplyShortChannelIdsEndDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_err"))) TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ), "LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ");
	*ret_conv = CResult_ReplyShortChannelIdsEndDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_is_ok"))) TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* o_conv = (LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ReplyShortChannelIdsEndDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_free"))) TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ _res_conv = *(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ReplyShortChannelIdsEndDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ReplyShortChannelIdsEndDecodeErrorZ_clone_ptr(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ), "LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ");
	*ret_conv = CResult_ReplyShortChannelIdsEndDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_clone_ptr"))) TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* arg_conv = (LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ReplyShortChannelIdsEndDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_clone"))) TS_CResult_ReplyShortChannelIdsEndDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* orig_conv = (LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ*)(orig & ~1);
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ), "LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ");
	*ret_conv = CResult_ReplyShortChannelIdsEndDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_QueryChannelRangeDecodeErrorZ_ok"))) TS_CResult_QueryChannelRangeDecodeErrorZ_ok(uint32_t o) {
	LDKQueryChannelRange o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = QueryChannelRange_clone(&o_conv);
	LDKCResult_QueryChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryChannelRangeDecodeErrorZ), "LDKCResult_QueryChannelRangeDecodeErrorZ");
	*ret_conv = CResult_QueryChannelRangeDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_QueryChannelRangeDecodeErrorZ_err"))) TS_CResult_QueryChannelRangeDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_QueryChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryChannelRangeDecodeErrorZ), "LDKCResult_QueryChannelRangeDecodeErrorZ");
	*ret_conv = CResult_QueryChannelRangeDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_QueryChannelRangeDecodeErrorZ_is_ok"))) TS_CResult_QueryChannelRangeDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_QueryChannelRangeDecodeErrorZ* o_conv = (LDKCResult_QueryChannelRangeDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_QueryChannelRangeDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_QueryChannelRangeDecodeErrorZ_free"))) TS_CResult_QueryChannelRangeDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_QueryChannelRangeDecodeErrorZ _res_conv = *(LDKCResult_QueryChannelRangeDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_QueryChannelRangeDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_QueryChannelRangeDecodeErrorZ_clone_ptr(LDKCResult_QueryChannelRangeDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_QueryChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryChannelRangeDecodeErrorZ), "LDKCResult_QueryChannelRangeDecodeErrorZ");
	*ret_conv = CResult_QueryChannelRangeDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_QueryChannelRangeDecodeErrorZ_clone_ptr"))) TS_CResult_QueryChannelRangeDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_QueryChannelRangeDecodeErrorZ* arg_conv = (LDKCResult_QueryChannelRangeDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_QueryChannelRangeDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_QueryChannelRangeDecodeErrorZ_clone"))) TS_CResult_QueryChannelRangeDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_QueryChannelRangeDecodeErrorZ* orig_conv = (LDKCResult_QueryChannelRangeDecodeErrorZ*)(orig & ~1);
	LDKCResult_QueryChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryChannelRangeDecodeErrorZ), "LDKCResult_QueryChannelRangeDecodeErrorZ");
	*ret_conv = CResult_QueryChannelRangeDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ReplyChannelRangeDecodeErrorZ_ok"))) TS_CResult_ReplyChannelRangeDecodeErrorZ_ok(uint32_t o) {
	LDKReplyChannelRange o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = ReplyChannelRange_clone(&o_conv);
	LDKCResult_ReplyChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyChannelRangeDecodeErrorZ), "LDKCResult_ReplyChannelRangeDecodeErrorZ");
	*ret_conv = CResult_ReplyChannelRangeDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_ReplyChannelRangeDecodeErrorZ_err"))) TS_CResult_ReplyChannelRangeDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_ReplyChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyChannelRangeDecodeErrorZ), "LDKCResult_ReplyChannelRangeDecodeErrorZ");
	*ret_conv = CResult_ReplyChannelRangeDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_ReplyChannelRangeDecodeErrorZ_is_ok"))) TS_CResult_ReplyChannelRangeDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_ReplyChannelRangeDecodeErrorZ* o_conv = (LDKCResult_ReplyChannelRangeDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_ReplyChannelRangeDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_ReplyChannelRangeDecodeErrorZ_free"))) TS_CResult_ReplyChannelRangeDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_ReplyChannelRangeDecodeErrorZ _res_conv = *(LDKCResult_ReplyChannelRangeDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_ReplyChannelRangeDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_ReplyChannelRangeDecodeErrorZ_clone_ptr(LDKCResult_ReplyChannelRangeDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_ReplyChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyChannelRangeDecodeErrorZ), "LDKCResult_ReplyChannelRangeDecodeErrorZ");
	*ret_conv = CResult_ReplyChannelRangeDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_ReplyChannelRangeDecodeErrorZ_clone_ptr"))) TS_CResult_ReplyChannelRangeDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_ReplyChannelRangeDecodeErrorZ* arg_conv = (LDKCResult_ReplyChannelRangeDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_ReplyChannelRangeDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_ReplyChannelRangeDecodeErrorZ_clone"))) TS_CResult_ReplyChannelRangeDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_ReplyChannelRangeDecodeErrorZ* orig_conv = (LDKCResult_ReplyChannelRangeDecodeErrorZ*)(orig & ~1);
	LDKCResult_ReplyChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyChannelRangeDecodeErrorZ), "LDKCResult_ReplyChannelRangeDecodeErrorZ");
	*ret_conv = CResult_ReplyChannelRangeDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_GossipTimestampFilterDecodeErrorZ_ok"))) TS_CResult_GossipTimestampFilterDecodeErrorZ_ok(uint32_t o) {
	LDKGossipTimestampFilter o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = GossipTimestampFilter_clone(&o_conv);
	LDKCResult_GossipTimestampFilterDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_GossipTimestampFilterDecodeErrorZ), "LDKCResult_GossipTimestampFilterDecodeErrorZ");
	*ret_conv = CResult_GossipTimestampFilterDecodeErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_GossipTimestampFilterDecodeErrorZ_err"))) TS_CResult_GossipTimestampFilterDecodeErrorZ_err(uint32_t e) {
	LDKDecodeError e_conv;
	e_conv.inner = (void*)(e & (~1));
	e_conv.is_owned = (e & 1) || (e == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(e_conv);
	e_conv = DecodeError_clone(&e_conv);
	LDKCResult_GossipTimestampFilterDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_GossipTimestampFilterDecodeErrorZ), "LDKCResult_GossipTimestampFilterDecodeErrorZ");
	*ret_conv = CResult_GossipTimestampFilterDecodeErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_GossipTimestampFilterDecodeErrorZ_is_ok"))) TS_CResult_GossipTimestampFilterDecodeErrorZ_is_ok(uint32_t o) {
	LDKCResult_GossipTimestampFilterDecodeErrorZ* o_conv = (LDKCResult_GossipTimestampFilterDecodeErrorZ*)(o & ~1);
	jboolean ret_val = CResult_GossipTimestampFilterDecodeErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_GossipTimestampFilterDecodeErrorZ_free"))) TS_CResult_GossipTimestampFilterDecodeErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_GossipTimestampFilterDecodeErrorZ _res_conv = *(LDKCResult_GossipTimestampFilterDecodeErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_GossipTimestampFilterDecodeErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_GossipTimestampFilterDecodeErrorZ_clone_ptr(LDKCResult_GossipTimestampFilterDecodeErrorZ *NONNULL_PTR arg) {
	LDKCResult_GossipTimestampFilterDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_GossipTimestampFilterDecodeErrorZ), "LDKCResult_GossipTimestampFilterDecodeErrorZ");
	*ret_conv = CResult_GossipTimestampFilterDecodeErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_GossipTimestampFilterDecodeErrorZ_clone_ptr"))) TS_CResult_GossipTimestampFilterDecodeErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_GossipTimestampFilterDecodeErrorZ* arg_conv = (LDKCResult_GossipTimestampFilterDecodeErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_GossipTimestampFilterDecodeErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_GossipTimestampFilterDecodeErrorZ_clone"))) TS_CResult_GossipTimestampFilterDecodeErrorZ_clone(uint32_t orig) {
	LDKCResult_GossipTimestampFilterDecodeErrorZ* orig_conv = (LDKCResult_GossipTimestampFilterDecodeErrorZ*)(orig & ~1);
	LDKCResult_GossipTimestampFilterDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_GossipTimestampFilterDecodeErrorZ), "LDKCResult_GossipTimestampFilterDecodeErrorZ");
	*ret_conv = CResult_GossipTimestampFilterDecodeErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceSignOrCreationErrorZ_ok"))) TS_CResult_InvoiceSignOrCreationErrorZ_ok(uint32_t o) {
	LDKInvoice o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	o_conv = Invoice_clone(&o_conv);
	LDKCResult_InvoiceSignOrCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSignOrCreationErrorZ), "LDKCResult_InvoiceSignOrCreationErrorZ");
	*ret_conv = CResult_InvoiceSignOrCreationErrorZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceSignOrCreationErrorZ_err"))) TS_CResult_InvoiceSignOrCreationErrorZ_err(uint32_t e) {
	void* e_ptr = (void*)(((uintptr_t)e) & ~1);
	CHECK_ACCESS(e_ptr);
	LDKSignOrCreationError e_conv = *(LDKSignOrCreationError*)(e_ptr);
	e_conv = SignOrCreationError_clone((LDKSignOrCreationError*)(((uintptr_t)e) & ~1));
	LDKCResult_InvoiceSignOrCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSignOrCreationErrorZ), "LDKCResult_InvoiceSignOrCreationErrorZ");
	*ret_conv = CResult_InvoiceSignOrCreationErrorZ_err(e_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_InvoiceSignOrCreationErrorZ_is_ok"))) TS_CResult_InvoiceSignOrCreationErrorZ_is_ok(uint32_t o) {
	LDKCResult_InvoiceSignOrCreationErrorZ* o_conv = (LDKCResult_InvoiceSignOrCreationErrorZ*)(o & ~1);
	jboolean ret_val = CResult_InvoiceSignOrCreationErrorZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_InvoiceSignOrCreationErrorZ_free"))) TS_CResult_InvoiceSignOrCreationErrorZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_InvoiceSignOrCreationErrorZ _res_conv = *(LDKCResult_InvoiceSignOrCreationErrorZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_InvoiceSignOrCreationErrorZ_free(_res_conv);
}

static inline uintptr_t CResult_InvoiceSignOrCreationErrorZ_clone_ptr(LDKCResult_InvoiceSignOrCreationErrorZ *NONNULL_PTR arg) {
	LDKCResult_InvoiceSignOrCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSignOrCreationErrorZ), "LDKCResult_InvoiceSignOrCreationErrorZ");
	*ret_conv = CResult_InvoiceSignOrCreationErrorZ_clone(arg);
	return (uint32_t)ret_conv;
}
uint32_t  __attribute__((export_name("TS_CResult_InvoiceSignOrCreationErrorZ_clone_ptr"))) TS_CResult_InvoiceSignOrCreationErrorZ_clone_ptr(uint32_t arg) {
	LDKCResult_InvoiceSignOrCreationErrorZ* arg_conv = (LDKCResult_InvoiceSignOrCreationErrorZ*)(arg & ~1);
	uint32_t ret_val = CResult_InvoiceSignOrCreationErrorZ_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CResult_InvoiceSignOrCreationErrorZ_clone"))) TS_CResult_InvoiceSignOrCreationErrorZ_clone(uint32_t orig) {
	LDKCResult_InvoiceSignOrCreationErrorZ* orig_conv = (LDKCResult_InvoiceSignOrCreationErrorZ*)(orig & ~1);
	LDKCResult_InvoiceSignOrCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSignOrCreationErrorZ), "LDKCResult_InvoiceSignOrCreationErrorZ");
	*ret_conv = CResult_InvoiceSignOrCreationErrorZ_clone(orig_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_COption_FilterZ_some"))) TS_COption_FilterZ_some(uint32_t o) {
	void* o_ptr = (void*)(((uintptr_t)o) & ~1);
	CHECK_ACCESS(o_ptr);
	LDKFilter o_conv = *(LDKFilter*)(o_ptr);
	if (o_conv.free == LDKFilter_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFilter_JCalls_cloned(&o_conv);
	}
	LDKCOption_FilterZ *ret_copy = MALLOC(sizeof(LDKCOption_FilterZ), "LDKCOption_FilterZ");
	*ret_copy = COption_FilterZ_some(o_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_COption_FilterZ_none"))) TS_COption_FilterZ_none() {
	LDKCOption_FilterZ *ret_copy = MALLOC(sizeof(LDKCOption_FilterZ), "LDKCOption_FilterZ");
	*ret_copy = COption_FilterZ_none();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_COption_FilterZ_free"))) TS_COption_FilterZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCOption_FilterZ _res_conv = *(LDKCOption_FilterZ*)(_res_ptr);
	FREE((void*)_res);
	COption_FilterZ_free(_res_conv);
}

uint32_t  __attribute__((export_name("TS_CResult_LockedChannelMonitorNoneZ_ok"))) TS_CResult_LockedChannelMonitorNoneZ_ok(uint32_t o) {
	LDKLockedChannelMonitor o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = (o & 1) || (o == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	// WARNING: we need a move here but no clone is available for LDKLockedChannelMonitor
	LDKCResult_LockedChannelMonitorNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_LockedChannelMonitorNoneZ), "LDKCResult_LockedChannelMonitorNoneZ");
	*ret_conv = CResult_LockedChannelMonitorNoneZ_ok(o_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_CResult_LockedChannelMonitorNoneZ_err"))) TS_CResult_LockedChannelMonitorNoneZ_err() {
	LDKCResult_LockedChannelMonitorNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_LockedChannelMonitorNoneZ), "LDKCResult_LockedChannelMonitorNoneZ");
	*ret_conv = CResult_LockedChannelMonitorNoneZ_err();
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_CResult_LockedChannelMonitorNoneZ_is_ok"))) TS_CResult_LockedChannelMonitorNoneZ_is_ok(uint32_t o) {
	LDKCResult_LockedChannelMonitorNoneZ* o_conv = (LDKCResult_LockedChannelMonitorNoneZ*)(o & ~1);
	jboolean ret_val = CResult_LockedChannelMonitorNoneZ_is_ok(o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CResult_LockedChannelMonitorNoneZ_free"))) TS_CResult_LockedChannelMonitorNoneZ_free(uint32_t _res) {
	if ((_res & 1) != 0) return;
	void* _res_ptr = (void*)(((uintptr_t)_res) & ~1);
	CHECK_ACCESS(_res_ptr);
	LDKCResult_LockedChannelMonitorNoneZ _res_conv = *(LDKCResult_LockedChannelMonitorNoneZ*)(_res_ptr);
	FREE((void*)_res);
	CResult_LockedChannelMonitorNoneZ_free(_res_conv);
}

void  __attribute__((export_name("TS_CVec_OutPointZ_free"))) TS_CVec_OutPointZ_free(uint32_tArray _res) {
	LDKCVec_OutPointZ _res_constr;
	_res_constr.datalen = _res->arr_len;
	if (_res_constr.datalen > 0)
		_res_constr.data = MALLOC(_res_constr.datalen * sizeof(LDKOutPoint), "LDKCVec_OutPointZ Elements");
	else
		_res_constr.data = NULL;
	uint32_t* _res_vals = _res->elems /* XXX _res leaks */;
	for (size_t k = 0; k < _res_constr.datalen; k++) {
		uint32_t _res_conv_10 = _res_vals[k];
		LDKOutPoint _res_conv_10_conv;
		_res_conv_10_conv.inner = (void*)(_res_conv_10 & (~1));
		_res_conv_10_conv.is_owned = (_res_conv_10 & 1) || (_res_conv_10 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(_res_conv_10_conv);
		_res_constr.data[k] = _res_conv_10_conv;
	}
	CVec_OutPointZ_free(_res_constr);
}

void  __attribute__((export_name("TS_PaymentPurpose_free"))) TS_PaymentPurpose_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKPaymentPurpose this_ptr_conv = *(LDKPaymentPurpose*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	PaymentPurpose_free(this_ptr_conv);
}

static inline uintptr_t PaymentPurpose_clone_ptr(LDKPaymentPurpose *NONNULL_PTR arg) {
	LDKPaymentPurpose *ret_copy = MALLOC(sizeof(LDKPaymentPurpose), "LDKPaymentPurpose");
	*ret_copy = PaymentPurpose_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PaymentPurpose_clone_ptr"))) TS_PaymentPurpose_clone_ptr(uint32_t arg) {
	LDKPaymentPurpose* arg_conv = (LDKPaymentPurpose*)arg;
	uint32_t ret_val = PaymentPurpose_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PaymentPurpose_clone"))) TS_PaymentPurpose_clone(uint32_t orig) {
	LDKPaymentPurpose* orig_conv = (LDKPaymentPurpose*)orig;
	LDKPaymentPurpose *ret_copy = MALLOC(sizeof(LDKPaymentPurpose), "LDKPaymentPurpose");
	*ret_copy = PaymentPurpose_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentPurpose_invoice_payment"))) TS_PaymentPurpose_invoice_payment(int8_tArray payment_preimage, int8_tArray payment_secret) {
	LDKThirtyTwoBytes payment_preimage_ref;
	CHECK(payment_preimage->arr_len == 32);
	memcpy(payment_preimage_ref.data, payment_preimage->elems, 32); FREE(payment_preimage);
	LDKThirtyTwoBytes payment_secret_ref;
	CHECK(payment_secret->arr_len == 32);
	memcpy(payment_secret_ref.data, payment_secret->elems, 32); FREE(payment_secret);
	LDKPaymentPurpose *ret_copy = MALLOC(sizeof(LDKPaymentPurpose), "LDKPaymentPurpose");
	*ret_copy = PaymentPurpose_invoice_payment(payment_preimage_ref, payment_secret_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentPurpose_spontaneous_payment"))) TS_PaymentPurpose_spontaneous_payment(int8_tArray a) {
	LDKThirtyTwoBytes a_ref;
	CHECK(a->arr_len == 32);
	memcpy(a_ref.data, a->elems, 32); FREE(a);
	LDKPaymentPurpose *ret_copy = MALLOC(sizeof(LDKPaymentPurpose), "LDKPaymentPurpose");
	*ret_copy = PaymentPurpose_spontaneous_payment(a_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ClosureReason_free"))) TS_ClosureReason_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKClosureReason this_ptr_conv = *(LDKClosureReason*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	ClosureReason_free(this_ptr_conv);
}

static inline uintptr_t ClosureReason_clone_ptr(LDKClosureReason *NONNULL_PTR arg) {
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ClosureReason_clone_ptr"))) TS_ClosureReason_clone_ptr(uint32_t arg) {
	LDKClosureReason* arg_conv = (LDKClosureReason*)arg;
	uint32_t ret_val = ClosureReason_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_clone"))) TS_ClosureReason_clone(uint32_t orig) {
	LDKClosureReason* orig_conv = (LDKClosureReason*)orig;
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_counterparty_force_closed"))) TS_ClosureReason_counterparty_force_closed(jstring peer_msg) {
	LDKStr peer_msg_conv = str_ref_to_owned_c(peer_msg);
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_counterparty_force_closed(peer_msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_holder_force_closed"))) TS_ClosureReason_holder_force_closed() {
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_holder_force_closed();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_cooperative_closure"))) TS_ClosureReason_cooperative_closure() {
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_cooperative_closure();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_commitment_tx_confirmed"))) TS_ClosureReason_commitment_tx_confirmed() {
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_commitment_tx_confirmed();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_funding_timed_out"))) TS_ClosureReason_funding_timed_out() {
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_funding_timed_out();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_processing_error"))) TS_ClosureReason_processing_error(jstring err) {
	LDKStr err_conv = str_ref_to_owned_c(err);
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_processing_error(err_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_disconnected_peer"))) TS_ClosureReason_disconnected_peer() {
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_disconnected_peer();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_outdated_channel_manager"))) TS_ClosureReason_outdated_channel_manager() {
	LDKClosureReason *ret_copy = MALLOC(sizeof(LDKClosureReason), "LDKClosureReason");
	*ret_copy = ClosureReason_outdated_channel_manager();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ClosureReason_write"))) TS_ClosureReason_write(uint32_t obj) {
	LDKClosureReason* obj_conv = (LDKClosureReason*)obj;
	LDKCVec_u8Z ret_var = ClosureReason_write(obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ClosureReason_read"))) TS_ClosureReason_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_COption_ClosureReasonZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_ClosureReasonZDecodeErrorZ), "LDKCResult_COption_ClosureReasonZDecodeErrorZ");
	*ret_conv = ClosureReason_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_Event_free"))) TS_Event_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKEvent this_ptr_conv = *(LDKEvent*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Event_free(this_ptr_conv);
}

static inline uintptr_t Event_clone_ptr(LDKEvent *NONNULL_PTR arg) {
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Event_clone_ptr"))) TS_Event_clone_ptr(uint32_t arg) {
	LDKEvent* arg_conv = (LDKEvent*)arg;
	uint32_t ret_val = Event_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Event_clone"))) TS_Event_clone(uint32_t orig) {
	LDKEvent* orig_conv = (LDKEvent*)orig;
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_funding_generation_ready"))) TS_Event_funding_generation_ready(int8_tArray temporary_channel_id, int64_t channel_value_satoshis, int8_tArray output_script, int64_t user_channel_id) {
	LDKThirtyTwoBytes temporary_channel_id_ref;
	CHECK(temporary_channel_id->arr_len == 32);
	memcpy(temporary_channel_id_ref.data, temporary_channel_id->elems, 32); FREE(temporary_channel_id);
	LDKCVec_u8Z output_script_ref;
	output_script_ref.datalen = output_script->arr_len;
	output_script_ref.data = MALLOC(output_script_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(output_script_ref.data, output_script->elems, output_script_ref.datalen); FREE(output_script);
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_funding_generation_ready(temporary_channel_id_ref, channel_value_satoshis, output_script_ref, user_channel_id);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_payment_received"))) TS_Event_payment_received(int8_tArray payment_hash, int64_t amt, uint32_t purpose) {
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	void* purpose_ptr = (void*)(((uintptr_t)purpose) & ~1);
	CHECK_ACCESS(purpose_ptr);
	LDKPaymentPurpose purpose_conv = *(LDKPaymentPurpose*)(purpose_ptr);
	purpose_conv = PaymentPurpose_clone((LDKPaymentPurpose*)(((uintptr_t)purpose) & ~1));
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_payment_received(payment_hash_ref, amt, purpose_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_payment_sent"))) TS_Event_payment_sent(int8_tArray payment_id, int8_tArray payment_preimage, int8_tArray payment_hash, uint32_t fee_paid_msat) {
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	LDKThirtyTwoBytes payment_preimage_ref;
	CHECK(payment_preimage->arr_len == 32);
	memcpy(payment_preimage_ref.data, payment_preimage->elems, 32); FREE(payment_preimage);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	void* fee_paid_msat_ptr = (void*)(((uintptr_t)fee_paid_msat) & ~1);
	CHECK_ACCESS(fee_paid_msat_ptr);
	LDKCOption_u64Z fee_paid_msat_conv = *(LDKCOption_u64Z*)(fee_paid_msat_ptr);
	fee_paid_msat_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)fee_paid_msat) & ~1));
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_payment_sent(payment_id_ref, payment_preimage_ref, payment_hash_ref, fee_paid_msat_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_payment_path_failed"))) TS_Event_payment_path_failed(int8_tArray payment_id, int8_tArray payment_hash, jboolean rejected_by_dest, uint32_t network_update, jboolean all_paths_failed, uint32_tArray path, uint32_t short_channel_id, uint32_t retry) {
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	void* network_update_ptr = (void*)(((uintptr_t)network_update) & ~1);
	CHECK_ACCESS(network_update_ptr);
	LDKCOption_NetworkUpdateZ network_update_conv = *(LDKCOption_NetworkUpdateZ*)(network_update_ptr);
	network_update_conv = COption_NetworkUpdateZ_clone((LDKCOption_NetworkUpdateZ*)(((uintptr_t)network_update) & ~1));
	LDKCVec_RouteHopZ path_constr;
	path_constr.datalen = path->arr_len;
	if (path_constr.datalen > 0)
		path_constr.data = MALLOC(path_constr.datalen * sizeof(LDKRouteHop), "LDKCVec_RouteHopZ Elements");
	else
		path_constr.data = NULL;
	uint32_t* path_vals = path->elems /* XXX path leaks */;
	for (size_t k = 0; k < path_constr.datalen; k++) {
		uint32_t path_conv_10 = path_vals[k];
		LDKRouteHop path_conv_10_conv;
		path_conv_10_conv.inner = (void*)(path_conv_10 & (~1));
		path_conv_10_conv.is_owned = (path_conv_10 & 1) || (path_conv_10 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(path_conv_10_conv);
		path_conv_10_conv = RouteHop_clone(&path_conv_10_conv);
		path_constr.data[k] = path_conv_10_conv;
	}
	void* short_channel_id_ptr = (void*)(((uintptr_t)short_channel_id) & ~1);
	CHECK_ACCESS(short_channel_id_ptr);
	LDKCOption_u64Z short_channel_id_conv = *(LDKCOption_u64Z*)(short_channel_id_ptr);
	short_channel_id_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)short_channel_id) & ~1));
	LDKRouteParameters retry_conv;
	retry_conv.inner = (void*)(retry & (~1));
	retry_conv.is_owned = (retry & 1) || (retry == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(retry_conv);
	retry_conv = RouteParameters_clone(&retry_conv);
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_payment_path_failed(payment_id_ref, payment_hash_ref, rejected_by_dest, network_update_conv, all_paths_failed, path_constr, short_channel_id_conv, retry_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_payment_failed"))) TS_Event_payment_failed(int8_tArray payment_id, int8_tArray payment_hash) {
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_payment_failed(payment_id_ref, payment_hash_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_pending_htlcs_forwardable"))) TS_Event_pending_htlcs_forwardable(int64_t time_forwardable) {
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_pending_htlcs_forwardable(time_forwardable);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_spendable_outputs"))) TS_Event_spendable_outputs(uint32_tArray outputs) {
	LDKCVec_SpendableOutputDescriptorZ outputs_constr;
	outputs_constr.datalen = outputs->arr_len;
	if (outputs_constr.datalen > 0)
		outputs_constr.data = MALLOC(outputs_constr.datalen * sizeof(LDKSpendableOutputDescriptor), "LDKCVec_SpendableOutputDescriptorZ Elements");
	else
		outputs_constr.data = NULL;
	uint32_t* outputs_vals = outputs->elems /* XXX outputs leaks */;
	for (size_t b = 0; b < outputs_constr.datalen; b++) {
		uint32_t outputs_conv_27 = outputs_vals[b];
		void* outputs_conv_27_ptr = (void*)(((uintptr_t)outputs_conv_27) & ~1);
		CHECK_ACCESS(outputs_conv_27_ptr);
		LDKSpendableOutputDescriptor outputs_conv_27_conv = *(LDKSpendableOutputDescriptor*)(outputs_conv_27_ptr);
		outputs_conv_27_conv = SpendableOutputDescriptor_clone((LDKSpendableOutputDescriptor*)(((uintptr_t)outputs_conv_27) & ~1));
		outputs_constr.data[b] = outputs_conv_27_conv;
	}
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_spendable_outputs(outputs_constr);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_payment_forwarded"))) TS_Event_payment_forwarded(uint32_t fee_earned_msat, jboolean claim_from_onchain_tx) {
	void* fee_earned_msat_ptr = (void*)(((uintptr_t)fee_earned_msat) & ~1);
	CHECK_ACCESS(fee_earned_msat_ptr);
	LDKCOption_u64Z fee_earned_msat_conv = *(LDKCOption_u64Z*)(fee_earned_msat_ptr);
	fee_earned_msat_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)fee_earned_msat) & ~1));
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_payment_forwarded(fee_earned_msat_conv, claim_from_onchain_tx);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_channel_closed"))) TS_Event_channel_closed(int8_tArray channel_id, int64_t user_channel_id, uint32_t reason) {
	LDKThirtyTwoBytes channel_id_ref;
	CHECK(channel_id->arr_len == 32);
	memcpy(channel_id_ref.data, channel_id->elems, 32); FREE(channel_id);
	void* reason_ptr = (void*)(((uintptr_t)reason) & ~1);
	CHECK_ACCESS(reason_ptr);
	LDKClosureReason reason_conv = *(LDKClosureReason*)(reason_ptr);
	reason_conv = ClosureReason_clone((LDKClosureReason*)(((uintptr_t)reason) & ~1));
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_channel_closed(channel_id_ref, user_channel_id, reason_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_discard_funding"))) TS_Event_discard_funding(int8_tArray channel_id, int8_tArray transaction) {
	LDKThirtyTwoBytes channel_id_ref;
	CHECK(channel_id->arr_len == 32);
	memcpy(channel_id_ref.data, channel_id->elems, 32); FREE(channel_id);
	LDKTransaction transaction_ref;
	transaction_ref.datalen = transaction->arr_len;
	transaction_ref.data = MALLOC(transaction_ref.datalen, "LDKTransaction Bytes");
	memcpy(transaction_ref.data, transaction->elems, transaction_ref.datalen); FREE(transaction);
	transaction_ref.data_is_owned = true;
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_discard_funding(channel_id_ref, transaction_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_payment_path_successful"))) TS_Event_payment_path_successful(int8_tArray payment_id, int8_tArray payment_hash, uint32_tArray path) {
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	LDKCVec_RouteHopZ path_constr;
	path_constr.datalen = path->arr_len;
	if (path_constr.datalen > 0)
		path_constr.data = MALLOC(path_constr.datalen * sizeof(LDKRouteHop), "LDKCVec_RouteHopZ Elements");
	else
		path_constr.data = NULL;
	uint32_t* path_vals = path->elems /* XXX path leaks */;
	for (size_t k = 0; k < path_constr.datalen; k++) {
		uint32_t path_conv_10 = path_vals[k];
		LDKRouteHop path_conv_10_conv;
		path_conv_10_conv.inner = (void*)(path_conv_10 & (~1));
		path_conv_10_conv.is_owned = (path_conv_10 & 1) || (path_conv_10 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(path_conv_10_conv);
		path_conv_10_conv = RouteHop_clone(&path_conv_10_conv);
		path_constr.data[k] = path_conv_10_conv;
	}
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_payment_path_successful(payment_id_ref, payment_hash_ref, path_constr);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Event_open_channel_request"))) TS_Event_open_channel_request(int8_tArray temporary_channel_id, int8_tArray counterparty_node_id, int64_t funding_satoshis, int64_t push_msat, uint32_t channel_type) {
	LDKThirtyTwoBytes temporary_channel_id_ref;
	CHECK(temporary_channel_id->arr_len == 32);
	memcpy(temporary_channel_id_ref.data, temporary_channel_id->elems, 32); FREE(temporary_channel_id);
	LDKPublicKey counterparty_node_id_ref;
	CHECK(counterparty_node_id->arr_len == 33);
	memcpy(counterparty_node_id_ref.compressed_form, counterparty_node_id->elems, 33); FREE(counterparty_node_id);
	LDKChannelTypeFeatures channel_type_conv;
	channel_type_conv.inner = (void*)(channel_type & (~1));
	channel_type_conv.is_owned = (channel_type & 1) || (channel_type == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_type_conv);
	channel_type_conv = ChannelTypeFeatures_clone(&channel_type_conv);
	LDKEvent *ret_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
	*ret_copy = Event_open_channel_request(temporary_channel_id_ref, counterparty_node_id_ref, funding_satoshis, push_msat, channel_type_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_Event_write"))) TS_Event_write(uint32_t obj) {
	LDKEvent* obj_conv = (LDKEvent*)obj;
	LDKCVec_u8Z ret_var = Event_write(obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Event_read"))) TS_Event_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_COption_EventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_EventZDecodeErrorZ), "LDKCResult_COption_EventZDecodeErrorZ");
	*ret_conv = Event_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_MessageSendEvent_free"))) TS_MessageSendEvent_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKMessageSendEvent this_ptr_conv = *(LDKMessageSendEvent*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	MessageSendEvent_free(this_ptr_conv);
}

static inline uintptr_t MessageSendEvent_clone_ptr(LDKMessageSendEvent *NONNULL_PTR arg) {
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_MessageSendEvent_clone_ptr"))) TS_MessageSendEvent_clone_ptr(uint32_t arg) {
	LDKMessageSendEvent* arg_conv = (LDKMessageSendEvent*)arg;
	uint32_t ret_val = MessageSendEvent_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_clone"))) TS_MessageSendEvent_clone(uint32_t orig) {
	LDKMessageSendEvent* orig_conv = (LDKMessageSendEvent*)orig;
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_accept_channel"))) TS_MessageSendEvent_send_accept_channel(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKAcceptChannel msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = AcceptChannel_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_accept_channel(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_open_channel"))) TS_MessageSendEvent_send_open_channel(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKOpenChannel msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = OpenChannel_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_open_channel(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_funding_created"))) TS_MessageSendEvent_send_funding_created(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKFundingCreated msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = FundingCreated_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_funding_created(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_funding_signed"))) TS_MessageSendEvent_send_funding_signed(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKFundingSigned msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = FundingSigned_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_funding_signed(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_funding_locked"))) TS_MessageSendEvent_send_funding_locked(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKFundingLocked msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = FundingLocked_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_funding_locked(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_announcement_signatures"))) TS_MessageSendEvent_send_announcement_signatures(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKAnnouncementSignatures msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = AnnouncementSignatures_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_announcement_signatures(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_update_htlcs"))) TS_MessageSendEvent_update_htlcs(int8_tArray node_id, uint32_t updates) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKCommitmentUpdate updates_conv;
	updates_conv.inner = (void*)(updates & (~1));
	updates_conv.is_owned = (updates & 1) || (updates == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(updates_conv);
	updates_conv = CommitmentUpdate_clone(&updates_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_update_htlcs(node_id_ref, updates_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_revoke_and_ack"))) TS_MessageSendEvent_send_revoke_and_ack(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKRevokeAndACK msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = RevokeAndACK_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_revoke_and_ack(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_closing_signed"))) TS_MessageSendEvent_send_closing_signed(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKClosingSigned msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ClosingSigned_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_closing_signed(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_shutdown"))) TS_MessageSendEvent_send_shutdown(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKShutdown msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = Shutdown_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_shutdown(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_channel_reestablish"))) TS_MessageSendEvent_send_channel_reestablish(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKChannelReestablish msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ChannelReestablish_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_channel_reestablish(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_broadcast_channel_announcement"))) TS_MessageSendEvent_broadcast_channel_announcement(uint32_t msg, uint32_t update_msg) {
	LDKChannelAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ChannelAnnouncement_clone(&msg_conv);
	LDKChannelUpdate update_msg_conv;
	update_msg_conv.inner = (void*)(update_msg & (~1));
	update_msg_conv.is_owned = (update_msg & 1) || (update_msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_msg_conv);
	update_msg_conv = ChannelUpdate_clone(&update_msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_broadcast_channel_announcement(msg_conv, update_msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_broadcast_node_announcement"))) TS_MessageSendEvent_broadcast_node_announcement(uint32_t msg) {
	LDKNodeAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = NodeAnnouncement_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_broadcast_node_announcement(msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_broadcast_channel_update"))) TS_MessageSendEvent_broadcast_channel_update(uint32_t msg) {
	LDKChannelUpdate msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ChannelUpdate_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_broadcast_channel_update(msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_channel_update"))) TS_MessageSendEvent_send_channel_update(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKChannelUpdate msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ChannelUpdate_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_channel_update(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_handle_error"))) TS_MessageSendEvent_handle_error(int8_tArray node_id, uint32_t action) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	void* action_ptr = (void*)(((uintptr_t)action) & ~1);
	CHECK_ACCESS(action_ptr);
	LDKErrorAction action_conv = *(LDKErrorAction*)(action_ptr);
	action_conv = ErrorAction_clone((LDKErrorAction*)(((uintptr_t)action) & ~1));
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_handle_error(node_id_ref, action_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_channel_range_query"))) TS_MessageSendEvent_send_channel_range_query(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKQueryChannelRange msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = QueryChannelRange_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_channel_range_query(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_short_ids_query"))) TS_MessageSendEvent_send_short_ids_query(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKQueryShortChannelIds msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = QueryShortChannelIds_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_short_ids_query(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_reply_channel_range"))) TS_MessageSendEvent_send_reply_channel_range(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKReplyChannelRange msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ReplyChannelRange_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_reply_channel_range(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MessageSendEvent_send_gossip_timestamp_filter"))) TS_MessageSendEvent_send_gossip_timestamp_filter(int8_tArray node_id, uint32_t msg) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKGossipTimestampFilter msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = GossipTimestampFilter_clone(&msg_conv);
	LDKMessageSendEvent *ret_copy = MALLOC(sizeof(LDKMessageSendEvent), "LDKMessageSendEvent");
	*ret_copy = MessageSendEvent_send_gossip_timestamp_filter(node_id_ref, msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_MessageSendEventsProvider_free"))) TS_MessageSendEventsProvider_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKMessageSendEventsProvider this_ptr_conv = *(LDKMessageSendEventsProvider*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	MessageSendEventsProvider_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_EventsProvider_free"))) TS_EventsProvider_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKEventsProvider this_ptr_conv = *(LDKEventsProvider*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	EventsProvider_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_EventHandler_free"))) TS_EventHandler_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKEventHandler this_ptr_conv = *(LDKEventHandler*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	EventHandler_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_APIError_free"))) TS_APIError_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKAPIError this_ptr_conv = *(LDKAPIError*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	APIError_free(this_ptr_conv);
}

static inline uintptr_t APIError_clone_ptr(LDKAPIError *NONNULL_PTR arg) {
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = APIError_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_APIError_clone_ptr"))) TS_APIError_clone_ptr(uint32_t arg) {
	LDKAPIError* arg_conv = (LDKAPIError*)arg;
	uint32_t ret_val = APIError_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_APIError_clone"))) TS_APIError_clone(uint32_t orig) {
	LDKAPIError* orig_conv = (LDKAPIError*)orig;
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = APIError_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_APIError_apimisuse_error"))) TS_APIError_apimisuse_error(jstring err) {
	LDKStr err_conv = str_ref_to_owned_c(err);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = APIError_apimisuse_error(err_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_APIError_fee_rate_too_high"))) TS_APIError_fee_rate_too_high(jstring err, int32_t feerate) {
	LDKStr err_conv = str_ref_to_owned_c(err);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = APIError_fee_rate_too_high(err_conv, feerate);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_APIError_route_error"))) TS_APIError_route_error(jstring err) {
	LDKStr err_conv = str_ref_to_owned_c(err);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = APIError_route_error(err_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_APIError_channel_unavailable"))) TS_APIError_channel_unavailable(jstring err) {
	LDKStr err_conv = str_ref_to_owned_c(err);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = APIError_channel_unavailable(err_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_APIError_monitor_update_failed"))) TS_APIError_monitor_update_failed() {
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = APIError_monitor_update_failed();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_APIError_incompatible_shutdown_script"))) TS_APIError_incompatible_shutdown_script(uint32_t script) {
	LDKShutdownScript script_conv;
	script_conv.inner = (void*)(script & (~1));
	script_conv.is_owned = (script & 1) || (script == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(script_conv);
	script_conv = ShutdownScript_clone(&script_conv);
	LDKAPIError *ret_copy = MALLOC(sizeof(LDKAPIError), "LDKAPIError");
	*ret_copy = APIError_incompatible_shutdown_script(script_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_sign"))) TS_sign(int8_tArray msg, int8_tArray sk) {
	LDKu8slice msg_ref;
	msg_ref.datalen = msg->arr_len;
	msg_ref.data = msg->elems /* XXX msg leaks */;
	unsigned char sk_arr[32];
	CHECK(sk->arr_len == 32);
	memcpy(sk_arr, sk->elems, 32); FREE(sk);
	unsigned char (*sk_ref)[32] = &sk_arr;
	LDKCResult_StringErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_StringErrorZ), "LDKCResult_StringErrorZ");
	*ret_conv = sign(msg_ref, sk_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_recover_pk"))) TS_recover_pk(int8_tArray msg, jstring sig) {
	LDKu8slice msg_ref;
	msg_ref.datalen = msg->arr_len;
	msg_ref.data = msg->elems /* XXX msg leaks */;
	LDKStr sig_conv = str_ref_to_owned_c(sig);
	LDKCResult_PublicKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PublicKeyErrorZ), "LDKCResult_PublicKeyErrorZ");
	*ret_conv = recover_pk(msg_ref, sig_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_verify"))) TS_verify(int8_tArray msg, jstring sig, int8_tArray pk) {
	LDKu8slice msg_ref;
	msg_ref.datalen = msg->arr_len;
	msg_ref.data = msg->elems /* XXX msg leaks */;
	LDKStr sig_conv = str_ref_to_owned_c(sig);
	LDKPublicKey pk_ref;
	CHECK(pk->arr_len == 33);
	memcpy(pk_ref.compressed_form, pk->elems, 33); FREE(pk);
	jboolean ret_val = verify(msg_ref, sig_conv, pk_ref);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_construct_invoice_preimage"))) TS_construct_invoice_preimage(int8_tArray hrp_bytes, ptrArray data_without_signature) {
	LDKu8slice hrp_bytes_ref;
	hrp_bytes_ref.datalen = hrp_bytes->arr_len;
	hrp_bytes_ref.data = hrp_bytes->elems /* XXX hrp_bytes leaks */;
	LDKCVec_u5Z data_without_signature_constr;
	data_without_signature_constr.datalen = data_without_signature->arr_len;
	if (data_without_signature_constr.datalen > 0)
		data_without_signature_constr.data = MALLOC(data_without_signature_constr.datalen * sizeof(LDKu5), "LDKCVec_u5Z Elements");
	else
		data_without_signature_constr.data = NULL;
	int8_t* data_without_signature_vals = (void*) data_without_signature->elems /* XXX data_without_signature leaks */;
	for (size_t h = 0; h < data_without_signature_constr.datalen; h++) {
		int8_t data_without_signature_conv_7 = data_without_signature_vals[h];
		
		data_without_signature_constr.data[h] = (LDKu5){ ._0 = data_without_signature_conv_7 };
	}
	LDKCVec_u8Z ret_var = construct_invoice_preimage(hrp_bytes_ref, data_without_signature_constr);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Level_clone"))) TS_Level_clone(uint32_t orig) {
	LDKLevel* orig_conv = (LDKLevel*)(orig & ~1);
	uint32_t ret_conv = LDKLevel_to_js(Level_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Level_gossip"))) TS_Level_gossip() {
	uint32_t ret_conv = LDKLevel_to_js(Level_gossip());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Level_trace"))) TS_Level_trace() {
	uint32_t ret_conv = LDKLevel_to_js(Level_trace());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Level_debug"))) TS_Level_debug() {
	uint32_t ret_conv = LDKLevel_to_js(Level_debug());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Level_info"))) TS_Level_info() {
	uint32_t ret_conv = LDKLevel_to_js(Level_info());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Level_warn"))) TS_Level_warn() {
	uint32_t ret_conv = LDKLevel_to_js(Level_warn());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Level_error"))) TS_Level_error() {
	uint32_t ret_conv = LDKLevel_to_js(Level_error());
	return ret_conv;
}

jboolean  __attribute__((export_name("TS_Level_eq"))) TS_Level_eq(uint32_t a, uint32_t b) {
	LDKLevel* a_conv = (LDKLevel*)(a & ~1);
	LDKLevel* b_conv = (LDKLevel*)(b & ~1);
	jboolean ret_val = Level_eq(a_conv, b_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_Level_hash"))) TS_Level_hash(uint32_t o) {
	LDKLevel* o_conv = (LDKLevel*)(o & ~1);
	int64_t ret_val = Level_hash(o_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Level_max"))) TS_Level_max() {
	uint32_t ret_conv = LDKLevel_to_js(Level_max());
	return ret_conv;
}

void  __attribute__((export_name("TS_Record_free"))) TS_Record_free(uint32_t this_obj) {
	LDKRecord this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Record_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_Record_get_level"))) TS_Record_get_level(uint32_t this_ptr) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	uint32_t ret_conv = LDKLevel_to_js(Record_get_level(&this_ptr_conv));
	return ret_conv;
}

void  __attribute__((export_name("TS_Record_set_level"))) TS_Record_set_level(uint32_t this_ptr, uint32_t val) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKLevel val_conv = LDKLevel_from_js(val);
	Record_set_level(&this_ptr_conv, val_conv);
}

jstring  __attribute__((export_name("TS_Record_get_args"))) TS_Record_get_args(uint32_t this_ptr) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr ret_str = Record_get_args(&this_ptr_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

void  __attribute__((export_name("TS_Record_set_args"))) TS_Record_set_args(uint32_t this_ptr, jstring val) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr val_conv = str_ref_to_owned_c(val);
	Record_set_args(&this_ptr_conv, val_conv);
}

jstring  __attribute__((export_name("TS_Record_get_module_path"))) TS_Record_get_module_path(uint32_t this_ptr) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr ret_str = Record_get_module_path(&this_ptr_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

void  __attribute__((export_name("TS_Record_set_module_path"))) TS_Record_set_module_path(uint32_t this_ptr, jstring val) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr val_conv = str_ref_to_owned_c(val);
	Record_set_module_path(&this_ptr_conv, val_conv);
}

jstring  __attribute__((export_name("TS_Record_get_file"))) TS_Record_get_file(uint32_t this_ptr) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr ret_str = Record_get_file(&this_ptr_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

void  __attribute__((export_name("TS_Record_set_file"))) TS_Record_set_file(uint32_t this_ptr, jstring val) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr val_conv = str_ref_to_owned_c(val);
	Record_set_file(&this_ptr_conv, val_conv);
}

int32_t  __attribute__((export_name("TS_Record_get_line"))) TS_Record_get_line(uint32_t this_ptr) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = Record_get_line(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Record_set_line"))) TS_Record_set_line(uint32_t this_ptr, int32_t val) {
	LDKRecord this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	Record_set_line(&this_ptr_conv, val);
}

static inline uintptr_t Record_clone_ptr(LDKRecord *NONNULL_PTR arg) {
	LDKRecord ret_var = Record_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Record_clone_ptr"))) TS_Record_clone_ptr(uint32_t arg) {
	LDKRecord arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Record_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Record_clone"))) TS_Record_clone(uint32_t orig) {
	LDKRecord orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRecord ret_var = Record_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_Logger_free"))) TS_Logger_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKLogger this_ptr_conv = *(LDKLogger*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Logger_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_ChannelHandshakeConfig_free"))) TS_ChannelHandshakeConfig_free(uint32_t this_obj) {
	LDKChannelHandshakeConfig this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelHandshakeConfig_free(this_obj_conv);
}

int32_t  __attribute__((export_name("TS_ChannelHandshakeConfig_get_minimum_depth"))) TS_ChannelHandshakeConfig_get_minimum_depth(uint32_t this_ptr) {
	LDKChannelHandshakeConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = ChannelHandshakeConfig_get_minimum_depth(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeConfig_set_minimum_depth"))) TS_ChannelHandshakeConfig_set_minimum_depth(uint32_t this_ptr, int32_t val) {
	LDKChannelHandshakeConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeConfig_set_minimum_depth(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_ChannelHandshakeConfig_get_our_to_self_delay"))) TS_ChannelHandshakeConfig_get_our_to_self_delay(uint32_t this_ptr) {
	LDKChannelHandshakeConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = ChannelHandshakeConfig_get_our_to_self_delay(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeConfig_set_our_to_self_delay"))) TS_ChannelHandshakeConfig_set_our_to_self_delay(uint32_t this_ptr, int16_t val) {
	LDKChannelHandshakeConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeConfig_set_our_to_self_delay(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelHandshakeConfig_get_our_htlc_minimum_msat"))) TS_ChannelHandshakeConfig_get_our_htlc_minimum_msat(uint32_t this_ptr) {
	LDKChannelHandshakeConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelHandshakeConfig_get_our_htlc_minimum_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeConfig_set_our_htlc_minimum_msat"))) TS_ChannelHandshakeConfig_set_our_htlc_minimum_msat(uint32_t this_ptr, int64_t val) {
	LDKChannelHandshakeConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeConfig_set_our_htlc_minimum_msat(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelHandshakeConfig_get_negotiate_scid_privacy"))) TS_ChannelHandshakeConfig_get_negotiate_scid_privacy(uint32_t this_ptr) {
	LDKChannelHandshakeConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelHandshakeConfig_get_negotiate_scid_privacy(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeConfig_set_negotiate_scid_privacy"))) TS_ChannelHandshakeConfig_set_negotiate_scid_privacy(uint32_t this_ptr, jboolean val) {
	LDKChannelHandshakeConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeConfig_set_negotiate_scid_privacy(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelHandshakeConfig_new"))) TS_ChannelHandshakeConfig_new(int32_t minimum_depth_arg, int16_t our_to_self_delay_arg, int64_t our_htlc_minimum_msat_arg, jboolean negotiate_scid_privacy_arg) {
	LDKChannelHandshakeConfig ret_var = ChannelHandshakeConfig_new(minimum_depth_arg, our_to_self_delay_arg, our_htlc_minimum_msat_arg, negotiate_scid_privacy_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelHandshakeConfig_clone_ptr(LDKChannelHandshakeConfig *NONNULL_PTR arg) {
	LDKChannelHandshakeConfig ret_var = ChannelHandshakeConfig_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelHandshakeConfig_clone_ptr"))) TS_ChannelHandshakeConfig_clone_ptr(uint32_t arg) {
	LDKChannelHandshakeConfig arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelHandshakeConfig_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelHandshakeConfig_clone"))) TS_ChannelHandshakeConfig_clone(uint32_t orig) {
	LDKChannelHandshakeConfig orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelHandshakeConfig ret_var = ChannelHandshakeConfig_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelHandshakeConfig_default"))) TS_ChannelHandshakeConfig_default() {
	LDKChannelHandshakeConfig ret_var = ChannelHandshakeConfig_default();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_free"))) TS_ChannelHandshakeLimits_free(uint32_t this_obj) {
	LDKChannelHandshakeLimits this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelHandshakeLimits_free(this_obj_conv);
}

int64_t  __attribute__((export_name("TS_ChannelHandshakeLimits_get_min_funding_satoshis"))) TS_ChannelHandshakeLimits_get_min_funding_satoshis(uint32_t this_ptr) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelHandshakeLimits_get_min_funding_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_set_min_funding_satoshis"))) TS_ChannelHandshakeLimits_set_min_funding_satoshis(uint32_t this_ptr, int64_t val) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeLimits_set_min_funding_satoshis(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelHandshakeLimits_get_max_htlc_minimum_msat"))) TS_ChannelHandshakeLimits_get_max_htlc_minimum_msat(uint32_t this_ptr) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelHandshakeLimits_get_max_htlc_minimum_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_set_max_htlc_minimum_msat"))) TS_ChannelHandshakeLimits_set_max_htlc_minimum_msat(uint32_t this_ptr, int64_t val) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeLimits_set_max_htlc_minimum_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelHandshakeLimits_get_min_max_htlc_value_in_flight_msat"))) TS_ChannelHandshakeLimits_get_min_max_htlc_value_in_flight_msat(uint32_t this_ptr) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelHandshakeLimits_get_min_max_htlc_value_in_flight_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_set_min_max_htlc_value_in_flight_msat"))) TS_ChannelHandshakeLimits_set_min_max_htlc_value_in_flight_msat(uint32_t this_ptr, int64_t val) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeLimits_set_min_max_htlc_value_in_flight_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelHandshakeLimits_get_max_channel_reserve_satoshis"))) TS_ChannelHandshakeLimits_get_max_channel_reserve_satoshis(uint32_t this_ptr) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelHandshakeLimits_get_max_channel_reserve_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_set_max_channel_reserve_satoshis"))) TS_ChannelHandshakeLimits_set_max_channel_reserve_satoshis(uint32_t this_ptr, int64_t val) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeLimits_set_max_channel_reserve_satoshis(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_ChannelHandshakeLimits_get_min_max_accepted_htlcs"))) TS_ChannelHandshakeLimits_get_min_max_accepted_htlcs(uint32_t this_ptr) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = ChannelHandshakeLimits_get_min_max_accepted_htlcs(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_set_min_max_accepted_htlcs"))) TS_ChannelHandshakeLimits_set_min_max_accepted_htlcs(uint32_t this_ptr, int16_t val) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeLimits_set_min_max_accepted_htlcs(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_ChannelHandshakeLimits_get_max_minimum_depth"))) TS_ChannelHandshakeLimits_get_max_minimum_depth(uint32_t this_ptr) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = ChannelHandshakeLimits_get_max_minimum_depth(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_set_max_minimum_depth"))) TS_ChannelHandshakeLimits_set_max_minimum_depth(uint32_t this_ptr, int32_t val) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeLimits_set_max_minimum_depth(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelHandshakeLimits_get_force_announced_channel_preference"))) TS_ChannelHandshakeLimits_get_force_announced_channel_preference(uint32_t this_ptr) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelHandshakeLimits_get_force_announced_channel_preference(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_set_force_announced_channel_preference"))) TS_ChannelHandshakeLimits_set_force_announced_channel_preference(uint32_t this_ptr, jboolean val) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeLimits_set_force_announced_channel_preference(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_ChannelHandshakeLimits_get_their_to_self_delay"))) TS_ChannelHandshakeLimits_get_their_to_self_delay(uint32_t this_ptr) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = ChannelHandshakeLimits_get_their_to_self_delay(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelHandshakeLimits_set_their_to_self_delay"))) TS_ChannelHandshakeLimits_set_their_to_self_delay(uint32_t this_ptr, int16_t val) {
	LDKChannelHandshakeLimits this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelHandshakeLimits_set_their_to_self_delay(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelHandshakeLimits_new"))) TS_ChannelHandshakeLimits_new(int64_t min_funding_satoshis_arg, int64_t max_htlc_minimum_msat_arg, int64_t min_max_htlc_value_in_flight_msat_arg, int64_t max_channel_reserve_satoshis_arg, int16_t min_max_accepted_htlcs_arg, int32_t max_minimum_depth_arg, jboolean force_announced_channel_preference_arg, int16_t their_to_self_delay_arg) {
	LDKChannelHandshakeLimits ret_var = ChannelHandshakeLimits_new(min_funding_satoshis_arg, max_htlc_minimum_msat_arg, min_max_htlc_value_in_flight_msat_arg, max_channel_reserve_satoshis_arg, min_max_accepted_htlcs_arg, max_minimum_depth_arg, force_announced_channel_preference_arg, their_to_self_delay_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelHandshakeLimits_clone_ptr(LDKChannelHandshakeLimits *NONNULL_PTR arg) {
	LDKChannelHandshakeLimits ret_var = ChannelHandshakeLimits_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelHandshakeLimits_clone_ptr"))) TS_ChannelHandshakeLimits_clone_ptr(uint32_t arg) {
	LDKChannelHandshakeLimits arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelHandshakeLimits_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelHandshakeLimits_clone"))) TS_ChannelHandshakeLimits_clone(uint32_t orig) {
	LDKChannelHandshakeLimits orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelHandshakeLimits ret_var = ChannelHandshakeLimits_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelHandshakeLimits_default"))) TS_ChannelHandshakeLimits_default() {
	LDKChannelHandshakeLimits ret_var = ChannelHandshakeLimits_default();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelConfig_free"))) TS_ChannelConfig_free(uint32_t this_obj) {
	LDKChannelConfig this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelConfig_free(this_obj_conv);
}

int32_t  __attribute__((export_name("TS_ChannelConfig_get_forwarding_fee_proportional_millionths"))) TS_ChannelConfig_get_forwarding_fee_proportional_millionths(uint32_t this_ptr) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = ChannelConfig_get_forwarding_fee_proportional_millionths(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelConfig_set_forwarding_fee_proportional_millionths"))) TS_ChannelConfig_set_forwarding_fee_proportional_millionths(uint32_t this_ptr, int32_t val) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelConfig_set_forwarding_fee_proportional_millionths(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_ChannelConfig_get_forwarding_fee_base_msat"))) TS_ChannelConfig_get_forwarding_fee_base_msat(uint32_t this_ptr) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = ChannelConfig_get_forwarding_fee_base_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelConfig_set_forwarding_fee_base_msat"))) TS_ChannelConfig_set_forwarding_fee_base_msat(uint32_t this_ptr, int32_t val) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelConfig_set_forwarding_fee_base_msat(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_ChannelConfig_get_cltv_expiry_delta"))) TS_ChannelConfig_get_cltv_expiry_delta(uint32_t this_ptr) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = ChannelConfig_get_cltv_expiry_delta(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelConfig_set_cltv_expiry_delta"))) TS_ChannelConfig_set_cltv_expiry_delta(uint32_t this_ptr, int16_t val) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelConfig_set_cltv_expiry_delta(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelConfig_get_announced_channel"))) TS_ChannelConfig_get_announced_channel(uint32_t this_ptr) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelConfig_get_announced_channel(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelConfig_set_announced_channel"))) TS_ChannelConfig_set_announced_channel(uint32_t this_ptr, jboolean val) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelConfig_set_announced_channel(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelConfig_get_commit_upfront_shutdown_pubkey"))) TS_ChannelConfig_get_commit_upfront_shutdown_pubkey(uint32_t this_ptr) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelConfig_get_commit_upfront_shutdown_pubkey(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelConfig_set_commit_upfront_shutdown_pubkey"))) TS_ChannelConfig_set_commit_upfront_shutdown_pubkey(uint32_t this_ptr, jboolean val) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelConfig_set_commit_upfront_shutdown_pubkey(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelConfig_get_max_dust_htlc_exposure_msat"))) TS_ChannelConfig_get_max_dust_htlc_exposure_msat(uint32_t this_ptr) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelConfig_get_max_dust_htlc_exposure_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelConfig_set_max_dust_htlc_exposure_msat"))) TS_ChannelConfig_set_max_dust_htlc_exposure_msat(uint32_t this_ptr, int64_t val) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelConfig_set_max_dust_htlc_exposure_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelConfig_get_force_close_avoidance_max_fee_satoshis"))) TS_ChannelConfig_get_force_close_avoidance_max_fee_satoshis(uint32_t this_ptr) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelConfig_get_force_close_avoidance_max_fee_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelConfig_set_force_close_avoidance_max_fee_satoshis"))) TS_ChannelConfig_set_force_close_avoidance_max_fee_satoshis(uint32_t this_ptr, int64_t val) {
	LDKChannelConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelConfig_set_force_close_avoidance_max_fee_satoshis(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelConfig_new"))) TS_ChannelConfig_new(int32_t forwarding_fee_proportional_millionths_arg, int32_t forwarding_fee_base_msat_arg, int16_t cltv_expiry_delta_arg, jboolean announced_channel_arg, jboolean commit_upfront_shutdown_pubkey_arg, int64_t max_dust_htlc_exposure_msat_arg, int64_t force_close_avoidance_max_fee_satoshis_arg) {
	LDKChannelConfig ret_var = ChannelConfig_new(forwarding_fee_proportional_millionths_arg, forwarding_fee_base_msat_arg, cltv_expiry_delta_arg, announced_channel_arg, commit_upfront_shutdown_pubkey_arg, max_dust_htlc_exposure_msat_arg, force_close_avoidance_max_fee_satoshis_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelConfig_clone_ptr(LDKChannelConfig *NONNULL_PTR arg) {
	LDKChannelConfig ret_var = ChannelConfig_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelConfig_clone_ptr"))) TS_ChannelConfig_clone_ptr(uint32_t arg) {
	LDKChannelConfig arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelConfig_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelConfig_clone"))) TS_ChannelConfig_clone(uint32_t orig) {
	LDKChannelConfig orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelConfig ret_var = ChannelConfig_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelConfig_default"))) TS_ChannelConfig_default() {
	LDKChannelConfig ret_var = ChannelConfig_default();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ChannelConfig_write"))) TS_ChannelConfig_write(uint32_t obj) {
	LDKChannelConfig obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelConfig_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelConfig_read"))) TS_ChannelConfig_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelConfigDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelConfigDecodeErrorZ), "LDKCResult_ChannelConfigDecodeErrorZ");
	*ret_conv = ChannelConfig_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_UserConfig_free"))) TS_UserConfig_free(uint32_t this_obj) {
	LDKUserConfig this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UserConfig_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_UserConfig_get_own_channel_config"))) TS_UserConfig_get_own_channel_config(uint32_t this_ptr) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelHandshakeConfig ret_var = UserConfig_get_own_channel_config(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UserConfig_set_own_channel_config"))) TS_UserConfig_set_own_channel_config(uint32_t this_ptr, uint32_t val) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelHandshakeConfig val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelHandshakeConfig_clone(&val_conv);
	UserConfig_set_own_channel_config(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_UserConfig_get_peer_channel_config_limits"))) TS_UserConfig_get_peer_channel_config_limits(uint32_t this_ptr) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelHandshakeLimits ret_var = UserConfig_get_peer_channel_config_limits(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UserConfig_set_peer_channel_config_limits"))) TS_UserConfig_set_peer_channel_config_limits(uint32_t this_ptr, uint32_t val) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelHandshakeLimits val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelHandshakeLimits_clone(&val_conv);
	UserConfig_set_peer_channel_config_limits(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_UserConfig_get_channel_options"))) TS_UserConfig_get_channel_options(uint32_t this_ptr) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelConfig ret_var = UserConfig_get_channel_options(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UserConfig_set_channel_options"))) TS_UserConfig_set_channel_options(uint32_t this_ptr, uint32_t val) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelConfig val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelConfig_clone(&val_conv);
	UserConfig_set_channel_options(&this_ptr_conv, val_conv);
}

jboolean  __attribute__((export_name("TS_UserConfig_get_accept_forwards_to_priv_channels"))) TS_UserConfig_get_accept_forwards_to_priv_channels(uint32_t this_ptr) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = UserConfig_get_accept_forwards_to_priv_channels(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UserConfig_set_accept_forwards_to_priv_channels"))) TS_UserConfig_set_accept_forwards_to_priv_channels(uint32_t this_ptr, jboolean val) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UserConfig_set_accept_forwards_to_priv_channels(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_UserConfig_get_accept_inbound_channels"))) TS_UserConfig_get_accept_inbound_channels(uint32_t this_ptr) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = UserConfig_get_accept_inbound_channels(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UserConfig_set_accept_inbound_channels"))) TS_UserConfig_set_accept_inbound_channels(uint32_t this_ptr, jboolean val) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UserConfig_set_accept_inbound_channels(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_UserConfig_get_manually_accept_inbound_channels"))) TS_UserConfig_get_manually_accept_inbound_channels(uint32_t this_ptr) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = UserConfig_get_manually_accept_inbound_channels(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UserConfig_set_manually_accept_inbound_channels"))) TS_UserConfig_set_manually_accept_inbound_channels(uint32_t this_ptr, jboolean val) {
	LDKUserConfig this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UserConfig_set_manually_accept_inbound_channels(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_UserConfig_new"))) TS_UserConfig_new(uint32_t own_channel_config_arg, uint32_t peer_channel_config_limits_arg, uint32_t channel_options_arg, jboolean accept_forwards_to_priv_channels_arg, jboolean accept_inbound_channels_arg, jboolean manually_accept_inbound_channels_arg) {
	LDKChannelHandshakeConfig own_channel_config_arg_conv;
	own_channel_config_arg_conv.inner = (void*)(own_channel_config_arg & (~1));
	own_channel_config_arg_conv.is_owned = (own_channel_config_arg & 1) || (own_channel_config_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(own_channel_config_arg_conv);
	own_channel_config_arg_conv = ChannelHandshakeConfig_clone(&own_channel_config_arg_conv);
	LDKChannelHandshakeLimits peer_channel_config_limits_arg_conv;
	peer_channel_config_limits_arg_conv.inner = (void*)(peer_channel_config_limits_arg & (~1));
	peer_channel_config_limits_arg_conv.is_owned = (peer_channel_config_limits_arg & 1) || (peer_channel_config_limits_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(peer_channel_config_limits_arg_conv);
	peer_channel_config_limits_arg_conv = ChannelHandshakeLimits_clone(&peer_channel_config_limits_arg_conv);
	LDKChannelConfig channel_options_arg_conv;
	channel_options_arg_conv.inner = (void*)(channel_options_arg & (~1));
	channel_options_arg_conv.is_owned = (channel_options_arg & 1) || (channel_options_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_options_arg_conv);
	channel_options_arg_conv = ChannelConfig_clone(&channel_options_arg_conv);
	LDKUserConfig ret_var = UserConfig_new(own_channel_config_arg_conv, peer_channel_config_limits_arg_conv, channel_options_arg_conv, accept_forwards_to_priv_channels_arg, accept_inbound_channels_arg, manually_accept_inbound_channels_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t UserConfig_clone_ptr(LDKUserConfig *NONNULL_PTR arg) {
	LDKUserConfig ret_var = UserConfig_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UserConfig_clone_ptr"))) TS_UserConfig_clone_ptr(uint32_t arg) {
	LDKUserConfig arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UserConfig_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UserConfig_clone"))) TS_UserConfig_clone(uint32_t orig) {
	LDKUserConfig orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUserConfig ret_var = UserConfig_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_UserConfig_default"))) TS_UserConfig_default() {
	LDKUserConfig ret_var = UserConfig_default();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_BestBlock_free"))) TS_BestBlock_free(uint32_t this_obj) {
	LDKBestBlock this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	BestBlock_free(this_obj_conv);
}

static inline uintptr_t BestBlock_clone_ptr(LDKBestBlock *NONNULL_PTR arg) {
	LDKBestBlock ret_var = BestBlock_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_BestBlock_clone_ptr"))) TS_BestBlock_clone_ptr(uint32_t arg) {
	LDKBestBlock arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = BestBlock_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_BestBlock_clone"))) TS_BestBlock_clone(uint32_t orig) {
	LDKBestBlock orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKBestBlock ret_var = BestBlock_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_BestBlock_from_genesis"))) TS_BestBlock_from_genesis(uint32_t network) {
	LDKNetwork network_conv = LDKNetwork_from_js(network);
	LDKBestBlock ret_var = BestBlock_from_genesis(network_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_BestBlock_new"))) TS_BestBlock_new(int8_tArray block_hash, int32_t height) {
	LDKThirtyTwoBytes block_hash_ref;
	CHECK(block_hash->arr_len == 32);
	memcpy(block_hash_ref.data, block_hash->elems, 32); FREE(block_hash);
	LDKBestBlock ret_var = BestBlock_new(block_hash_ref, height);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_BestBlock_block_hash"))) TS_BestBlock_block_hash(uint32_t this_arg) {
	LDKBestBlock this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, BestBlock_block_hash(&this_arg_conv).data, 32);
	return ret_arr;
}

int32_t  __attribute__((export_name("TS_BestBlock_height"))) TS_BestBlock_height(uint32_t this_arg) {
	LDKBestBlock this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int32_t ret_val = BestBlock_height(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_AccessError_clone"))) TS_AccessError_clone(uint32_t orig) {
	LDKAccessError* orig_conv = (LDKAccessError*)(orig & ~1);
	uint32_t ret_conv = LDKAccessError_to_js(AccessError_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_AccessError_unknown_chain"))) TS_AccessError_unknown_chain() {
	uint32_t ret_conv = LDKAccessError_to_js(AccessError_unknown_chain());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_AccessError_unknown_tx"))) TS_AccessError_unknown_tx() {
	uint32_t ret_conv = LDKAccessError_to_js(AccessError_unknown_tx());
	return ret_conv;
}

void  __attribute__((export_name("TS_Access_free"))) TS_Access_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKAccess this_ptr_conv = *(LDKAccess*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Access_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_Listen_free"))) TS_Listen_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKListen this_ptr_conv = *(LDKListen*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Listen_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_Confirm_free"))) TS_Confirm_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKConfirm this_ptr_conv = *(LDKConfirm*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Confirm_free(this_ptr_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelMonitorUpdateErr_clone"))) TS_ChannelMonitorUpdateErr_clone(uint32_t orig) {
	LDKChannelMonitorUpdateErr* orig_conv = (LDKChannelMonitorUpdateErr*)(orig & ~1);
	uint32_t ret_conv = LDKChannelMonitorUpdateErr_to_js(ChannelMonitorUpdateErr_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelMonitorUpdateErr_temporary_failure"))) TS_ChannelMonitorUpdateErr_temporary_failure() {
	uint32_t ret_conv = LDKChannelMonitorUpdateErr_to_js(ChannelMonitorUpdateErr_temporary_failure());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelMonitorUpdateErr_permanent_failure"))) TS_ChannelMonitorUpdateErr_permanent_failure() {
	uint32_t ret_conv = LDKChannelMonitorUpdateErr_to_js(ChannelMonitorUpdateErr_permanent_failure());
	return ret_conv;
}

void  __attribute__((export_name("TS_Watch_free"))) TS_Watch_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKWatch this_ptr_conv = *(LDKWatch*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Watch_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_Filter_free"))) TS_Filter_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKFilter this_ptr_conv = *(LDKFilter*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Filter_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_WatchedOutput_free"))) TS_WatchedOutput_free(uint32_t this_obj) {
	LDKWatchedOutput this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	WatchedOutput_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_WatchedOutput_get_block_hash"))) TS_WatchedOutput_get_block_hash(uint32_t this_ptr) {
	LDKWatchedOutput this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, WatchedOutput_get_block_hash(&this_ptr_conv).data, 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_WatchedOutput_set_block_hash"))) TS_WatchedOutput_set_block_hash(uint32_t this_ptr, int8_tArray val) {
	LDKWatchedOutput this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	WatchedOutput_set_block_hash(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_WatchedOutput_get_outpoint"))) TS_WatchedOutput_get_outpoint(uint32_t this_ptr) {
	LDKWatchedOutput this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint ret_var = WatchedOutput_get_outpoint(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_WatchedOutput_set_outpoint"))) TS_WatchedOutput_set_outpoint(uint32_t this_ptr, uint32_t val) {
	LDKWatchedOutput this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = OutPoint_clone(&val_conv);
	WatchedOutput_set_outpoint(&this_ptr_conv, val_conv);
}

int8_tArray  __attribute__((export_name("TS_WatchedOutput_get_script_pubkey"))) TS_WatchedOutput_get_script_pubkey(uint32_t this_ptr) {
	LDKWatchedOutput this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKu8slice ret_var = WatchedOutput_get_script_pubkey(&this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	return ret_arr;
}

void  __attribute__((export_name("TS_WatchedOutput_set_script_pubkey"))) TS_WatchedOutput_set_script_pubkey(uint32_t this_ptr, int8_tArray val) {
	LDKWatchedOutput this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_u8Z val_ref;
	val_ref.datalen = val->arr_len;
	val_ref.data = MALLOC(val_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(val_ref.data, val->elems, val_ref.datalen); FREE(val);
	WatchedOutput_set_script_pubkey(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_WatchedOutput_new"))) TS_WatchedOutput_new(int8_tArray block_hash_arg, uint32_t outpoint_arg, int8_tArray script_pubkey_arg) {
	LDKThirtyTwoBytes block_hash_arg_ref;
	CHECK(block_hash_arg->arr_len == 32);
	memcpy(block_hash_arg_ref.data, block_hash_arg->elems, 32); FREE(block_hash_arg);
	LDKOutPoint outpoint_arg_conv;
	outpoint_arg_conv.inner = (void*)(outpoint_arg & (~1));
	outpoint_arg_conv.is_owned = (outpoint_arg & 1) || (outpoint_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(outpoint_arg_conv);
	outpoint_arg_conv = OutPoint_clone(&outpoint_arg_conv);
	LDKCVec_u8Z script_pubkey_arg_ref;
	script_pubkey_arg_ref.datalen = script_pubkey_arg->arr_len;
	script_pubkey_arg_ref.data = MALLOC(script_pubkey_arg_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(script_pubkey_arg_ref.data, script_pubkey_arg->elems, script_pubkey_arg_ref.datalen); FREE(script_pubkey_arg);
	LDKWatchedOutput ret_var = WatchedOutput_new(block_hash_arg_ref, outpoint_arg_conv, script_pubkey_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t WatchedOutput_clone_ptr(LDKWatchedOutput *NONNULL_PTR arg) {
	LDKWatchedOutput ret_var = WatchedOutput_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_WatchedOutput_clone_ptr"))) TS_WatchedOutput_clone_ptr(uint32_t arg) {
	LDKWatchedOutput arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = WatchedOutput_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_WatchedOutput_clone"))) TS_WatchedOutput_clone(uint32_t orig) {
	LDKWatchedOutput orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKWatchedOutput ret_var = WatchedOutput_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_WatchedOutput_hash"))) TS_WatchedOutput_hash(uint32_t o) {
	LDKWatchedOutput o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = WatchedOutput_hash(&o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_BroadcasterInterface_free"))) TS_BroadcasterInterface_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKBroadcasterInterface this_ptr_conv = *(LDKBroadcasterInterface*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	BroadcasterInterface_free(this_ptr_conv);
}

uint32_t  __attribute__((export_name("TS_ConfirmationTarget_clone"))) TS_ConfirmationTarget_clone(uint32_t orig) {
	LDKConfirmationTarget* orig_conv = (LDKConfirmationTarget*)(orig & ~1);
	uint32_t ret_conv = LDKConfirmationTarget_to_js(ConfirmationTarget_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_ConfirmationTarget_background"))) TS_ConfirmationTarget_background() {
	uint32_t ret_conv = LDKConfirmationTarget_to_js(ConfirmationTarget_background());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_ConfirmationTarget_normal"))) TS_ConfirmationTarget_normal() {
	uint32_t ret_conv = LDKConfirmationTarget_to_js(ConfirmationTarget_normal());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_ConfirmationTarget_high_priority"))) TS_ConfirmationTarget_high_priority() {
	uint32_t ret_conv = LDKConfirmationTarget_to_js(ConfirmationTarget_high_priority());
	return ret_conv;
}

jboolean  __attribute__((export_name("TS_ConfirmationTarget_eq"))) TS_ConfirmationTarget_eq(uint32_t a, uint32_t b) {
	LDKConfirmationTarget* a_conv = (LDKConfirmationTarget*)(a & ~1);
	LDKConfirmationTarget* b_conv = (LDKConfirmationTarget*)(b & ~1);
	jboolean ret_val = ConfirmationTarget_eq(a_conv, b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_FeeEstimator_free"))) TS_FeeEstimator_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKFeeEstimator this_ptr_conv = *(LDKFeeEstimator*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	FeeEstimator_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_MonitorUpdateId_free"))) TS_MonitorUpdateId_free(uint32_t this_obj) {
	LDKMonitorUpdateId this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	MonitorUpdateId_free(this_obj_conv);
}

static inline uintptr_t MonitorUpdateId_clone_ptr(LDKMonitorUpdateId *NONNULL_PTR arg) {
	LDKMonitorUpdateId ret_var = MonitorUpdateId_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_MonitorUpdateId_clone_ptr"))) TS_MonitorUpdateId_clone_ptr(uint32_t arg) {
	LDKMonitorUpdateId arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = MonitorUpdateId_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_MonitorUpdateId_clone"))) TS_MonitorUpdateId_clone(uint32_t orig) {
	LDKMonitorUpdateId orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKMonitorUpdateId ret_var = MonitorUpdateId_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_MonitorUpdateId_hash"))) TS_MonitorUpdateId_hash(uint32_t o) {
	LDKMonitorUpdateId o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = MonitorUpdateId_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_MonitorUpdateId_eq"))) TS_MonitorUpdateId_eq(uint32_t a, uint32_t b) {
	LDKMonitorUpdateId a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKMonitorUpdateId b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = MonitorUpdateId_eq(&a_conv, &b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Persist_free"))) TS_Persist_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKPersist this_ptr_conv = *(LDKPersist*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Persist_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_LockedChannelMonitor_free"))) TS_LockedChannelMonitor_free(uint32_t this_obj) {
	LDKLockedChannelMonitor this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	LockedChannelMonitor_free(this_obj_conv);
}

void  __attribute__((export_name("TS_ChainMonitor_free"))) TS_ChainMonitor_free(uint32_t this_obj) {
	LDKChainMonitor this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChainMonitor_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_ChainMonitor_new"))) TS_ChainMonitor_new(uint32_t chain_source, uint32_t broadcaster, uint32_t logger, uint32_t feeest, uint32_t persister) {
	void* chain_source_ptr = (void*)(((uintptr_t)chain_source) & ~1);
	CHECK_ACCESS(chain_source_ptr);
	LDKCOption_FilterZ chain_source_conv = *(LDKCOption_FilterZ*)(chain_source_ptr);
	// WARNING: we may need a move here but no clone is available for LDKCOption_FilterZ
	if (chain_source_conv.tag == LDKCOption_FilterZ_Some) {
		// Manually implement clone for Java trait instances
		if (chain_source_conv.some.free == LDKFilter_JCalls_free) {
			// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
			LDKFilter_JCalls_cloned(&chain_source_conv.some);
		}
	}
	void* broadcaster_ptr = (void*)(((uintptr_t)broadcaster) & ~1);
	CHECK_ACCESS(broadcaster_ptr);
	LDKBroadcasterInterface broadcaster_conv = *(LDKBroadcasterInterface*)(broadcaster_ptr);
	if (broadcaster_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&broadcaster_conv);
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	void* feeest_ptr = (void*)(((uintptr_t)feeest) & ~1);
	CHECK_ACCESS(feeest_ptr);
	LDKFeeEstimator feeest_conv = *(LDKFeeEstimator*)(feeest_ptr);
	if (feeest_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&feeest_conv);
	}
	void* persister_ptr = (void*)(((uintptr_t)persister) & ~1);
	CHECK_ACCESS(persister_ptr);
	LDKPersist persister_conv = *(LDKPersist*)(persister_ptr);
	if (persister_conv.free == LDKPersist_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKPersist_JCalls_cloned(&persister_conv);
	}
	LDKChainMonitor ret_var = ChainMonitor_new(chain_source_conv, broadcaster_conv, logger_conv, feeest_conv, persister_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_tArray  __attribute__((export_name("TS_ChainMonitor_get_claimable_balances"))) TS_ChainMonitor_get_claimable_balances(uint32_t this_arg, uint32_tArray ignored_channels) {
	LDKChainMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_ChannelDetailsZ ignored_channels_constr;
	ignored_channels_constr.datalen = ignored_channels->arr_len;
	if (ignored_channels_constr.datalen > 0)
		ignored_channels_constr.data = MALLOC(ignored_channels_constr.datalen * sizeof(LDKChannelDetails), "LDKCVec_ChannelDetailsZ Elements");
	else
		ignored_channels_constr.data = NULL;
	uint32_t* ignored_channels_vals = ignored_channels->elems /* XXX ignored_channels leaks */;
	for (size_t q = 0; q < ignored_channels_constr.datalen; q++) {
		uint32_t ignored_channels_conv_16 = ignored_channels_vals[q];
		LDKChannelDetails ignored_channels_conv_16_conv;
		ignored_channels_conv_16_conv.inner = (void*)(ignored_channels_conv_16 & (~1));
		ignored_channels_conv_16_conv.is_owned = (ignored_channels_conv_16 & 1) || (ignored_channels_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ignored_channels_conv_16_conv);
		ignored_channels_conv_16_conv = ChannelDetails_clone(&ignored_channels_conv_16_conv);
		ignored_channels_constr.data[q] = ignored_channels_conv_16_conv;
	}
	LDKCVec_BalanceZ ret_var = ChainMonitor_get_claimable_balances(&this_arg_conv, ignored_channels_constr);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t j = 0; j < ret_var.datalen; j++) {
		LDKBalance *ret_conv_9_copy = MALLOC(sizeof(LDKBalance), "LDKBalance");
		*ret_conv_9_copy = ret_var.data[j];
		uint32_t ret_conv_9_ref = (uintptr_t)ret_conv_9_copy;
		ret_arr_ptr[j] = ret_conv_9_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChainMonitor_get_monitor"))) TS_ChainMonitor_get_monitor(uint32_t this_arg, uint32_t funding_txo) {
	LDKChainMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKOutPoint funding_txo_conv;
	funding_txo_conv.inner = (void*)(funding_txo & (~1));
	funding_txo_conv.is_owned = (funding_txo & 1) || (funding_txo == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_conv);
	funding_txo_conv = OutPoint_clone(&funding_txo_conv);
	LDKCResult_LockedChannelMonitorNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_LockedChannelMonitorNoneZ), "LDKCResult_LockedChannelMonitorNoneZ");
	*ret_conv = ChainMonitor_get_monitor(&this_arg_conv, funding_txo_conv);
	return (uint32_t)ret_conv;
}

uint32_tArray  __attribute__((export_name("TS_ChainMonitor_list_monitors"))) TS_ChainMonitor_list_monitors(uint32_t this_arg) {
	LDKChainMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_OutPointZ ret_var = ChainMonitor_list_monitors(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t k = 0; k < ret_var.datalen; k++) {
		LDKOutPoint ret_conv_10_var = ret_var.data[k];
		uint32_t ret_conv_10_ref = 0;
		CHECK((((uintptr_t)ret_conv_10_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_10_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_10_var);
		ret_conv_10_ref = (uintptr_t)ret_conv_10_var.inner;
		if (ret_conv_10_var.is_owned) {
			ret_conv_10_ref |= 1;
		}
		ret_arr_ptr[k] = ret_conv_10_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChainMonitor_channel_monitor_updated"))) TS_ChainMonitor_channel_monitor_updated(uint32_t this_arg, uint32_t funding_txo, uint32_t completed_update_id) {
	LDKChainMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKOutPoint funding_txo_conv;
	funding_txo_conv.inner = (void*)(funding_txo & (~1));
	funding_txo_conv.is_owned = (funding_txo & 1) || (funding_txo == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_conv);
	funding_txo_conv = OutPoint_clone(&funding_txo_conv);
	LDKMonitorUpdateId completed_update_id_conv;
	completed_update_id_conv.inner = (void*)(completed_update_id & (~1));
	completed_update_id_conv.is_owned = (completed_update_id & 1) || (completed_update_id == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(completed_update_id_conv);
	completed_update_id_conv = MonitorUpdateId_clone(&completed_update_id_conv);
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = ChainMonitor_channel_monitor_updated(&this_arg_conv, funding_txo_conv, completed_update_id_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChainMonitor_as_Listen"))) TS_ChainMonitor_as_Listen(uint32_t this_arg) {
	LDKChainMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKListen* ret_ret = MALLOC(sizeof(LDKListen), "LDKListen");
	*ret_ret = ChainMonitor_as_Listen(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_ChainMonitor_as_Confirm"))) TS_ChainMonitor_as_Confirm(uint32_t this_arg) {
	LDKChainMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKConfirm* ret_ret = MALLOC(sizeof(LDKConfirm), "LDKConfirm");
	*ret_ret = ChainMonitor_as_Confirm(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_ChainMonitor_as_Watch"))) TS_ChainMonitor_as_Watch(uint32_t this_arg) {
	LDKChainMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKWatch* ret_ret = MALLOC(sizeof(LDKWatch), "LDKWatch");
	*ret_ret = ChainMonitor_as_Watch(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_ChainMonitor_as_EventsProvider"))) TS_ChainMonitor_as_EventsProvider(uint32_t this_arg) {
	LDKChainMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKEventsProvider* ret_ret = MALLOC(sizeof(LDKEventsProvider), "LDKEventsProvider");
	*ret_ret = ChainMonitor_as_EventsProvider(&this_arg_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_ChannelMonitorUpdate_free"))) TS_ChannelMonitorUpdate_free(uint32_t this_obj) {
	LDKChannelMonitorUpdate this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelMonitorUpdate_free(this_obj_conv);
}

int64_t  __attribute__((export_name("TS_ChannelMonitorUpdate_get_update_id"))) TS_ChannelMonitorUpdate_get_update_id(uint32_t this_ptr) {
	LDKChannelMonitorUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelMonitorUpdate_get_update_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelMonitorUpdate_set_update_id"))) TS_ChannelMonitorUpdate_set_update_id(uint32_t this_ptr, int64_t val) {
	LDKChannelMonitorUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelMonitorUpdate_set_update_id(&this_ptr_conv, val);
}

static inline uintptr_t ChannelMonitorUpdate_clone_ptr(LDKChannelMonitorUpdate *NONNULL_PTR arg) {
	LDKChannelMonitorUpdate ret_var = ChannelMonitorUpdate_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelMonitorUpdate_clone_ptr"))) TS_ChannelMonitorUpdate_clone_ptr(uint32_t arg) {
	LDKChannelMonitorUpdate arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelMonitorUpdate_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelMonitorUpdate_clone"))) TS_ChannelMonitorUpdate_clone(uint32_t orig) {
	LDKChannelMonitorUpdate orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelMonitorUpdate ret_var = ChannelMonitorUpdate_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ChannelMonitorUpdate_write"))) TS_ChannelMonitorUpdate_write(uint32_t obj) {
	LDKChannelMonitorUpdate obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelMonitorUpdate_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelMonitorUpdate_read"))) TS_ChannelMonitorUpdate_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelMonitorUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelMonitorUpdateDecodeErrorZ), "LDKCResult_ChannelMonitorUpdateDecodeErrorZ");
	*ret_conv = ChannelMonitorUpdate_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_MonitorEvent_free"))) TS_MonitorEvent_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKMonitorEvent this_ptr_conv = *(LDKMonitorEvent*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	MonitorEvent_free(this_ptr_conv);
}

static inline uintptr_t MonitorEvent_clone_ptr(LDKMonitorEvent *NONNULL_PTR arg) {
	LDKMonitorEvent *ret_copy = MALLOC(sizeof(LDKMonitorEvent), "LDKMonitorEvent");
	*ret_copy = MonitorEvent_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_MonitorEvent_clone_ptr"))) TS_MonitorEvent_clone_ptr(uint32_t arg) {
	LDKMonitorEvent* arg_conv = (LDKMonitorEvent*)arg;
	uint32_t ret_val = MonitorEvent_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_MonitorEvent_clone"))) TS_MonitorEvent_clone(uint32_t orig) {
	LDKMonitorEvent* orig_conv = (LDKMonitorEvent*)orig;
	LDKMonitorEvent *ret_copy = MALLOC(sizeof(LDKMonitorEvent), "LDKMonitorEvent");
	*ret_copy = MonitorEvent_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MonitorEvent_htlcevent"))) TS_MonitorEvent_htlcevent(uint32_t a) {
	LDKHTLCUpdate a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = HTLCUpdate_clone(&a_conv);
	LDKMonitorEvent *ret_copy = MALLOC(sizeof(LDKMonitorEvent), "LDKMonitorEvent");
	*ret_copy = MonitorEvent_htlcevent(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MonitorEvent_commitment_tx_confirmed"))) TS_MonitorEvent_commitment_tx_confirmed(uint32_t a) {
	LDKOutPoint a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = OutPoint_clone(&a_conv);
	LDKMonitorEvent *ret_copy = MALLOC(sizeof(LDKMonitorEvent), "LDKMonitorEvent");
	*ret_copy = MonitorEvent_commitment_tx_confirmed(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MonitorEvent_update_completed"))) TS_MonitorEvent_update_completed(uint32_t funding_txo, int64_t monitor_update_id) {
	LDKOutPoint funding_txo_conv;
	funding_txo_conv.inner = (void*)(funding_txo & (~1));
	funding_txo_conv.is_owned = (funding_txo & 1) || (funding_txo == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_conv);
	funding_txo_conv = OutPoint_clone(&funding_txo_conv);
	LDKMonitorEvent *ret_copy = MALLOC(sizeof(LDKMonitorEvent), "LDKMonitorEvent");
	*ret_copy = MonitorEvent_update_completed(funding_txo_conv, monitor_update_id);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_MonitorEvent_update_failed"))) TS_MonitorEvent_update_failed(uint32_t a) {
	LDKOutPoint a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = OutPoint_clone(&a_conv);
	LDKMonitorEvent *ret_copy = MALLOC(sizeof(LDKMonitorEvent), "LDKMonitorEvent");
	*ret_copy = MonitorEvent_update_failed(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_MonitorEvent_write"))) TS_MonitorEvent_write(uint32_t obj) {
	LDKMonitorEvent* obj_conv = (LDKMonitorEvent*)obj;
	LDKCVec_u8Z ret_var = MonitorEvent_write(obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_MonitorEvent_read"))) TS_MonitorEvent_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_COption_MonitorEventZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_MonitorEventZDecodeErrorZ), "LDKCResult_COption_MonitorEventZDecodeErrorZ");
	*ret_conv = MonitorEvent_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_HTLCUpdate_free"))) TS_HTLCUpdate_free(uint32_t this_obj) {
	LDKHTLCUpdate this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	HTLCUpdate_free(this_obj_conv);
}

static inline uintptr_t HTLCUpdate_clone_ptr(LDKHTLCUpdate *NONNULL_PTR arg) {
	LDKHTLCUpdate ret_var = HTLCUpdate_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_HTLCUpdate_clone_ptr"))) TS_HTLCUpdate_clone_ptr(uint32_t arg) {
	LDKHTLCUpdate arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = HTLCUpdate_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_HTLCUpdate_clone"))) TS_HTLCUpdate_clone(uint32_t orig) {
	LDKHTLCUpdate orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKHTLCUpdate ret_var = HTLCUpdate_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_HTLCUpdate_write"))) TS_HTLCUpdate_write(uint32_t obj) {
	LDKHTLCUpdate obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = HTLCUpdate_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_HTLCUpdate_read"))) TS_HTLCUpdate_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_HTLCUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCUpdateDecodeErrorZ), "LDKCResult_HTLCUpdateDecodeErrorZ");
	*ret_conv = HTLCUpdate_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_Balance_free"))) TS_Balance_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKBalance this_ptr_conv = *(LDKBalance*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Balance_free(this_ptr_conv);
}

static inline uintptr_t Balance_clone_ptr(LDKBalance *NONNULL_PTR arg) {
	LDKBalance *ret_copy = MALLOC(sizeof(LDKBalance), "LDKBalance");
	*ret_copy = Balance_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Balance_clone_ptr"))) TS_Balance_clone_ptr(uint32_t arg) {
	LDKBalance* arg_conv = (LDKBalance*)arg;
	uint32_t ret_val = Balance_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Balance_clone"))) TS_Balance_clone(uint32_t orig) {
	LDKBalance* orig_conv = (LDKBalance*)orig;
	LDKBalance *ret_copy = MALLOC(sizeof(LDKBalance), "LDKBalance");
	*ret_copy = Balance_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Balance_claimable_on_channel_close"))) TS_Balance_claimable_on_channel_close(int64_t claimable_amount_satoshis) {
	LDKBalance *ret_copy = MALLOC(sizeof(LDKBalance), "LDKBalance");
	*ret_copy = Balance_claimable_on_channel_close(claimable_amount_satoshis);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Balance_claimable_awaiting_confirmations"))) TS_Balance_claimable_awaiting_confirmations(int64_t claimable_amount_satoshis, int32_t confirmation_height) {
	LDKBalance *ret_copy = MALLOC(sizeof(LDKBalance), "LDKBalance");
	*ret_copy = Balance_claimable_awaiting_confirmations(claimable_amount_satoshis, confirmation_height);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Balance_contentious_claimable"))) TS_Balance_contentious_claimable(int64_t claimable_amount_satoshis, int32_t timeout_height) {
	LDKBalance *ret_copy = MALLOC(sizeof(LDKBalance), "LDKBalance");
	*ret_copy = Balance_contentious_claimable(claimable_amount_satoshis, timeout_height);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Balance_maybe_claimable_htlcawaiting_timeout"))) TS_Balance_maybe_claimable_htlcawaiting_timeout(int64_t claimable_amount_satoshis, int32_t claimable_height) {
	LDKBalance *ret_copy = MALLOC(sizeof(LDKBalance), "LDKBalance");
	*ret_copy = Balance_maybe_claimable_htlcawaiting_timeout(claimable_amount_satoshis, claimable_height);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_Balance_eq"))) TS_Balance_eq(uint32_t a, uint32_t b) {
	LDKBalance* a_conv = (LDKBalance*)a;
	LDKBalance* b_conv = (LDKBalance*)b;
	jboolean ret_val = Balance_eq(a_conv, b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelMonitor_free"))) TS_ChannelMonitor_free(uint32_t this_obj) {
	LDKChannelMonitor this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelMonitor_free(this_obj_conv);
}

static inline uintptr_t ChannelMonitor_clone_ptr(LDKChannelMonitor *NONNULL_PTR arg) {
	LDKChannelMonitor ret_var = ChannelMonitor_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelMonitor_clone_ptr"))) TS_ChannelMonitor_clone_ptr(uint32_t arg) {
	LDKChannelMonitor arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelMonitor_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelMonitor_clone"))) TS_ChannelMonitor_clone(uint32_t orig) {
	LDKChannelMonitor orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelMonitor ret_var = ChannelMonitor_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ChannelMonitor_write"))) TS_ChannelMonitor_write(uint32_t obj) {
	LDKChannelMonitor obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelMonitor_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelMonitor_update_monitor"))) TS_ChannelMonitor_update_monitor(uint32_t this_arg, uint32_t updates, uint32_t broadcaster, uint32_t fee_estimator, uint32_t logger) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelMonitorUpdate updates_conv;
	updates_conv.inner = (void*)(updates & (~1));
	updates_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(updates_conv);
	void* broadcaster_ptr = (void*)(((uintptr_t)broadcaster) & ~1);
	if (!(broadcaster & 1)) { CHECK_ACCESS(broadcaster_ptr); }
	LDKBroadcasterInterface* broadcaster_conv = (LDKBroadcasterInterface*)broadcaster_ptr;
	void* fee_estimator_ptr = (void*)(((uintptr_t)fee_estimator) & ~1);
	if (!(fee_estimator & 1)) { CHECK_ACCESS(fee_estimator_ptr); }
	LDKFeeEstimator* fee_estimator_conv = (LDKFeeEstimator*)fee_estimator_ptr;
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	if (!(logger & 1)) { CHECK_ACCESS(logger_ptr); }
	LDKLogger* logger_conv = (LDKLogger*)logger_ptr;
	LDKCResult_NoneNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneNoneZ), "LDKCResult_NoneNoneZ");
	*ret_conv = ChannelMonitor_update_monitor(&this_arg_conv, &updates_conv, broadcaster_conv, fee_estimator_conv, logger_conv);
	return (uint32_t)ret_conv;
}

int64_t  __attribute__((export_name("TS_ChannelMonitor_get_latest_update_id"))) TS_ChannelMonitor_get_latest_update_id(uint32_t this_arg) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = ChannelMonitor_get_latest_update_id(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelMonitor_get_funding_txo"))) TS_ChannelMonitor_get_funding_txo(uint32_t this_arg) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKC2Tuple_OutPointScriptZ* ret_conv = MALLOC(sizeof(LDKC2Tuple_OutPointScriptZ), "LDKC2Tuple_OutPointScriptZ");
	*ret_conv = ChannelMonitor_get_funding_txo(&this_arg_conv);
	return ((uint32_t)ret_conv);
}

uint32_tArray  __attribute__((export_name("TS_ChannelMonitor_get_outputs_to_watch"))) TS_ChannelMonitor_get_outputs_to_watch(uint32_t this_arg) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32ScriptZZZZ ret_var = ChannelMonitor_get_outputs_to_watch(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t o = 0; o < ret_var.datalen; o++) {
		LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ* ret_conv_40_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32ScriptZZZ");
		*ret_conv_40_conv = ret_var.data[o];
		ret_arr_ptr[o] = ((uint32_t)ret_conv_40_conv);
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelMonitor_load_outputs_to_watch"))) TS_ChannelMonitor_load_outputs_to_watch(uint32_t this_arg, uint32_t filter) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* filter_ptr = (void*)(((uintptr_t)filter) & ~1);
	if (!(filter & 1)) { CHECK_ACCESS(filter_ptr); }
	LDKFilter* filter_conv = (LDKFilter*)filter_ptr;
	ChannelMonitor_load_outputs_to_watch(&this_arg_conv, filter_conv);
}

uint32_tArray  __attribute__((export_name("TS_ChannelMonitor_get_and_clear_pending_monitor_events"))) TS_ChannelMonitor_get_and_clear_pending_monitor_events(uint32_t this_arg) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_MonitorEventZ ret_var = ChannelMonitor_get_and_clear_pending_monitor_events(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t o = 0; o < ret_var.datalen; o++) {
		LDKMonitorEvent *ret_conv_14_copy = MALLOC(sizeof(LDKMonitorEvent), "LDKMonitorEvent");
		*ret_conv_14_copy = ret_var.data[o];
		uint32_t ret_conv_14_ref = (uintptr_t)ret_conv_14_copy;
		ret_arr_ptr[o] = ret_conv_14_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_tArray  __attribute__((export_name("TS_ChannelMonitor_get_and_clear_pending_events"))) TS_ChannelMonitor_get_and_clear_pending_events(uint32_t this_arg) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_EventZ ret_var = ChannelMonitor_get_and_clear_pending_events(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t h = 0; h < ret_var.datalen; h++) {
		LDKEvent *ret_conv_7_copy = MALLOC(sizeof(LDKEvent), "LDKEvent");
		*ret_conv_7_copy = ret_var.data[h];
		uint32_t ret_conv_7_ref = (uintptr_t)ret_conv_7_copy;
		ret_arr_ptr[h] = ret_conv_7_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

ptrArray  __attribute__((export_name("TS_ChannelMonitor_get_latest_holder_commitment_txn"))) TS_ChannelMonitor_get_latest_holder_commitment_txn(uint32_t this_arg, uint32_t logger) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	if (!(logger & 1)) { CHECK_ACCESS(logger_ptr); }
	LDKLogger* logger_conv = (LDKLogger*)logger_ptr;
	LDKCVec_TransactionZ ret_var = ChannelMonitor_get_latest_holder_commitment_txn(&this_arg_conv, logger_conv);
	ptrArray ret_arr = NULL;
	ret_arr = init_ptrArray(ret_var.datalen, __LINE__);
	int8_tArray *ret_arr_ptr = (int8_tArray*)(((uint8_t*)ret_arr) + 4);
	for (size_t m = 0; m < ret_var.datalen; m++) {
		LDKTransaction ret_conv_12_var = ret_var.data[m];
		int8_tArray ret_conv_12_arr = init_int8_tArray(ret_conv_12_var.datalen, __LINE__);
		memcpy(ret_conv_12_arr->elems, ret_conv_12_var.data, ret_conv_12_var.datalen);
		Transaction_free(ret_conv_12_var);
		ret_arr_ptr[m] = ret_conv_12_arr;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_tArray  __attribute__((export_name("TS_ChannelMonitor_block_connected"))) TS_ChannelMonitor_block_connected(uint32_t this_arg, int8_tArray header, uint32_tArray txdata, int32_t height, uint32_t broadcaster, uint32_t fee_estimator, uint32_t logger) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char header_arr[80];
	CHECK(header->arr_len == 80);
	memcpy(header_arr, header->elems, 80); FREE(header);
	unsigned char (*header_ref)[80] = &header_arr;
	LDKCVec_C2Tuple_usizeTransactionZZ txdata_constr;
	txdata_constr.datalen = txdata->arr_len;
	if (txdata_constr.datalen > 0)
		txdata_constr.data = MALLOC(txdata_constr.datalen * sizeof(LDKC2Tuple_usizeTransactionZ), "LDKCVec_C2Tuple_usizeTransactionZZ Elements");
	else
		txdata_constr.data = NULL;
	uint32_t* txdata_vals = txdata->elems /* XXX txdata leaks */;
	for (size_t c = 0; c < txdata_constr.datalen; c++) {
		uint32_t txdata_conv_28 = txdata_vals[c];
		void* txdata_conv_28_ptr = (void*)(((uintptr_t)txdata_conv_28) & ~1);
		CHECK_ACCESS(txdata_conv_28_ptr);
		LDKC2Tuple_usizeTransactionZ txdata_conv_28_conv = *(LDKC2Tuple_usizeTransactionZ*)(txdata_conv_28_ptr);
		txdata_conv_28_conv = C2Tuple_usizeTransactionZ_clone((LDKC2Tuple_usizeTransactionZ*)(((uintptr_t)txdata_conv_28) & ~1));
		txdata_constr.data[c] = txdata_conv_28_conv;
	}
	void* broadcaster_ptr = (void*)(((uintptr_t)broadcaster) & ~1);
	CHECK_ACCESS(broadcaster_ptr);
	LDKBroadcasterInterface broadcaster_conv = *(LDKBroadcasterInterface*)(broadcaster_ptr);
	if (broadcaster_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&broadcaster_conv);
	}
	void* fee_estimator_ptr = (void*)(((uintptr_t)fee_estimator) & ~1);
	CHECK_ACCESS(fee_estimator_ptr);
	LDKFeeEstimator fee_estimator_conv = *(LDKFeeEstimator*)(fee_estimator_ptr);
	if (fee_estimator_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&fee_estimator_conv);
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ ret_var = ChannelMonitor_block_connected(&this_arg_conv, header_ref, txdata_constr, height, broadcaster_conv, fee_estimator_conv, logger_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t n = 0; n < ret_var.datalen; n++) {
		LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* ret_conv_39_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ");
		*ret_conv_39_conv = ret_var.data[n];
		ret_arr_ptr[n] = ((uint32_t)ret_conv_39_conv);
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelMonitor_block_disconnected"))) TS_ChannelMonitor_block_disconnected(uint32_t this_arg, int8_tArray header, int32_t height, uint32_t broadcaster, uint32_t fee_estimator, uint32_t logger) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char header_arr[80];
	CHECK(header->arr_len == 80);
	memcpy(header_arr, header->elems, 80); FREE(header);
	unsigned char (*header_ref)[80] = &header_arr;
	void* broadcaster_ptr = (void*)(((uintptr_t)broadcaster) & ~1);
	CHECK_ACCESS(broadcaster_ptr);
	LDKBroadcasterInterface broadcaster_conv = *(LDKBroadcasterInterface*)(broadcaster_ptr);
	if (broadcaster_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&broadcaster_conv);
	}
	void* fee_estimator_ptr = (void*)(((uintptr_t)fee_estimator) & ~1);
	CHECK_ACCESS(fee_estimator_ptr);
	LDKFeeEstimator fee_estimator_conv = *(LDKFeeEstimator*)(fee_estimator_ptr);
	if (fee_estimator_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&fee_estimator_conv);
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	ChannelMonitor_block_disconnected(&this_arg_conv, header_ref, height, broadcaster_conv, fee_estimator_conv, logger_conv);
}

uint32_tArray  __attribute__((export_name("TS_ChannelMonitor_transactions_confirmed"))) TS_ChannelMonitor_transactions_confirmed(uint32_t this_arg, int8_tArray header, uint32_tArray txdata, int32_t height, uint32_t broadcaster, uint32_t fee_estimator, uint32_t logger) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char header_arr[80];
	CHECK(header->arr_len == 80);
	memcpy(header_arr, header->elems, 80); FREE(header);
	unsigned char (*header_ref)[80] = &header_arr;
	LDKCVec_C2Tuple_usizeTransactionZZ txdata_constr;
	txdata_constr.datalen = txdata->arr_len;
	if (txdata_constr.datalen > 0)
		txdata_constr.data = MALLOC(txdata_constr.datalen * sizeof(LDKC2Tuple_usizeTransactionZ), "LDKCVec_C2Tuple_usizeTransactionZZ Elements");
	else
		txdata_constr.data = NULL;
	uint32_t* txdata_vals = txdata->elems /* XXX txdata leaks */;
	for (size_t c = 0; c < txdata_constr.datalen; c++) {
		uint32_t txdata_conv_28 = txdata_vals[c];
		void* txdata_conv_28_ptr = (void*)(((uintptr_t)txdata_conv_28) & ~1);
		CHECK_ACCESS(txdata_conv_28_ptr);
		LDKC2Tuple_usizeTransactionZ txdata_conv_28_conv = *(LDKC2Tuple_usizeTransactionZ*)(txdata_conv_28_ptr);
		txdata_conv_28_conv = C2Tuple_usizeTransactionZ_clone((LDKC2Tuple_usizeTransactionZ*)(((uintptr_t)txdata_conv_28) & ~1));
		txdata_constr.data[c] = txdata_conv_28_conv;
	}
	void* broadcaster_ptr = (void*)(((uintptr_t)broadcaster) & ~1);
	CHECK_ACCESS(broadcaster_ptr);
	LDKBroadcasterInterface broadcaster_conv = *(LDKBroadcasterInterface*)(broadcaster_ptr);
	if (broadcaster_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&broadcaster_conv);
	}
	void* fee_estimator_ptr = (void*)(((uintptr_t)fee_estimator) & ~1);
	CHECK_ACCESS(fee_estimator_ptr);
	LDKFeeEstimator fee_estimator_conv = *(LDKFeeEstimator*)(fee_estimator_ptr);
	if (fee_estimator_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&fee_estimator_conv);
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ ret_var = ChannelMonitor_transactions_confirmed(&this_arg_conv, header_ref, txdata_constr, height, broadcaster_conv, fee_estimator_conv, logger_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t n = 0; n < ret_var.datalen; n++) {
		LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* ret_conv_39_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ");
		*ret_conv_39_conv = ret_var.data[n];
		ret_arr_ptr[n] = ((uint32_t)ret_conv_39_conv);
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelMonitor_transaction_unconfirmed"))) TS_ChannelMonitor_transaction_unconfirmed(uint32_t this_arg, int8_tArray txid, uint32_t broadcaster, uint32_t fee_estimator, uint32_t logger) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char txid_arr[32];
	CHECK(txid->arr_len == 32);
	memcpy(txid_arr, txid->elems, 32); FREE(txid);
	unsigned char (*txid_ref)[32] = &txid_arr;
	void* broadcaster_ptr = (void*)(((uintptr_t)broadcaster) & ~1);
	CHECK_ACCESS(broadcaster_ptr);
	LDKBroadcasterInterface broadcaster_conv = *(LDKBroadcasterInterface*)(broadcaster_ptr);
	if (broadcaster_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&broadcaster_conv);
	}
	void* fee_estimator_ptr = (void*)(((uintptr_t)fee_estimator) & ~1);
	CHECK_ACCESS(fee_estimator_ptr);
	LDKFeeEstimator fee_estimator_conv = *(LDKFeeEstimator*)(fee_estimator_ptr);
	if (fee_estimator_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&fee_estimator_conv);
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	ChannelMonitor_transaction_unconfirmed(&this_arg_conv, txid_ref, broadcaster_conv, fee_estimator_conv, logger_conv);
}

uint32_tArray  __attribute__((export_name("TS_ChannelMonitor_best_block_updated"))) TS_ChannelMonitor_best_block_updated(uint32_t this_arg, int8_tArray header, int32_t height, uint32_t broadcaster, uint32_t fee_estimator, uint32_t logger) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char header_arr[80];
	CHECK(header->arr_len == 80);
	memcpy(header_arr, header->elems, 80); FREE(header);
	unsigned char (*header_ref)[80] = &header_arr;
	void* broadcaster_ptr = (void*)(((uintptr_t)broadcaster) & ~1);
	CHECK_ACCESS(broadcaster_ptr);
	LDKBroadcasterInterface broadcaster_conv = *(LDKBroadcasterInterface*)(broadcaster_ptr);
	if (broadcaster_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&broadcaster_conv);
	}
	void* fee_estimator_ptr = (void*)(((uintptr_t)fee_estimator) & ~1);
	CHECK_ACCESS(fee_estimator_ptr);
	LDKFeeEstimator fee_estimator_conv = *(LDKFeeEstimator*)(fee_estimator_ptr);
	if (fee_estimator_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&fee_estimator_conv);
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	LDKCVec_C2Tuple_TxidCVec_C2Tuple_u32TxOutZZZZ ret_var = ChannelMonitor_best_block_updated(&this_arg_conv, header_ref, height, broadcaster_conv, fee_estimator_conv, logger_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t n = 0; n < ret_var.datalen; n++) {
		LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ* ret_conv_39_conv = MALLOC(sizeof(LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ), "LDKC2Tuple_TxidCVec_C2Tuple_u32TxOutZZZ");
		*ret_conv_39_conv = ret_var.data[n];
		ret_arr_ptr[n] = ((uint32_t)ret_conv_39_conv);
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

ptrArray  __attribute__((export_name("TS_ChannelMonitor_get_relevant_txids"))) TS_ChannelMonitor_get_relevant_txids(uint32_t this_arg) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_TxidZ ret_var = ChannelMonitor_get_relevant_txids(&this_arg_conv);
	ptrArray ret_arr = NULL;
	ret_arr = init_ptrArray(ret_var.datalen, __LINE__);
	int8_tArray *ret_arr_ptr = (int8_tArray*)(((uint8_t*)ret_arr) + 4);
	for (size_t m = 0; m < ret_var.datalen; m++) {
		int8_tArray ret_conv_12_arr = init_int8_tArray(32, __LINE__);
		memcpy(ret_conv_12_arr->elems, ret_var.data[m].data, 32);
		ret_arr_ptr[m] = ret_conv_12_arr;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelMonitor_current_best_block"))) TS_ChannelMonitor_current_best_block(uint32_t this_arg) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKBestBlock ret_var = ChannelMonitor_current_best_block(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_tArray  __attribute__((export_name("TS_ChannelMonitor_get_claimable_balances"))) TS_ChannelMonitor_get_claimable_balances(uint32_t this_arg) {
	LDKChannelMonitor this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_BalanceZ ret_var = ChannelMonitor_get_claimable_balances(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t j = 0; j < ret_var.datalen; j++) {
		LDKBalance *ret_conv_9_copy = MALLOC(sizeof(LDKBalance), "LDKBalance");
		*ret_conv_9_copy = ret_var.data[j];
		uint32_t ret_conv_9_ref = (uintptr_t)ret_conv_9_copy;
		ret_arr_ptr[j] = ret_conv_9_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_BlockHashChannelMonitorZ_read"))) TS_C2Tuple_BlockHashChannelMonitorZ_read(int8_tArray ser, uint32_t arg) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	void* arg_ptr = (void*)(((uintptr_t)arg) & ~1);
	if (!(arg & 1)) { CHECK_ACCESS(arg_ptr); }
	LDKKeysInterface* arg_conv = (LDKKeysInterface*)arg_ptr;
	LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ), "LDKCResult_C2Tuple_BlockHashChannelMonitorZDecodeErrorZ");
	*ret_conv = C2Tuple_BlockHashChannelMonitorZ_read(ser_ref, arg_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_OutPoint_free"))) TS_OutPoint_free(uint32_t this_obj) {
	LDKOutPoint this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	OutPoint_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_OutPoint_get_txid"))) TS_OutPoint_get_txid(uint32_t this_ptr) {
	LDKOutPoint this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *OutPoint_get_txid(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_OutPoint_set_txid"))) TS_OutPoint_set_txid(uint32_t this_ptr, int8_tArray val) {
	LDKOutPoint this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	OutPoint_set_txid(&this_ptr_conv, val_ref);
}

int16_t  __attribute__((export_name("TS_OutPoint_get_index"))) TS_OutPoint_get_index(uint32_t this_ptr) {
	LDKOutPoint this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = OutPoint_get_index(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OutPoint_set_index"))) TS_OutPoint_set_index(uint32_t this_ptr, int16_t val) {
	LDKOutPoint this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OutPoint_set_index(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_OutPoint_new"))) TS_OutPoint_new(int8_tArray txid_arg, int16_t index_arg) {
	LDKThirtyTwoBytes txid_arg_ref;
	CHECK(txid_arg->arr_len == 32);
	memcpy(txid_arg_ref.data, txid_arg->elems, 32); FREE(txid_arg);
	LDKOutPoint ret_var = OutPoint_new(txid_arg_ref, index_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t OutPoint_clone_ptr(LDKOutPoint *NONNULL_PTR arg) {
	LDKOutPoint ret_var = OutPoint_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_OutPoint_clone_ptr"))) TS_OutPoint_clone_ptr(uint32_t arg) {
	LDKOutPoint arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = OutPoint_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_OutPoint_clone"))) TS_OutPoint_clone(uint32_t orig) {
	LDKOutPoint orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKOutPoint ret_var = OutPoint_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_OutPoint_eq"))) TS_OutPoint_eq(uint32_t a, uint32_t b) {
	LDKOutPoint a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKOutPoint b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = OutPoint_eq(&a_conv, &b_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_OutPoint_hash"))) TS_OutPoint_hash(uint32_t o) {
	LDKOutPoint o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = OutPoint_hash(&o_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_OutPoint_to_channel_id"))) TS_OutPoint_to_channel_id(uint32_t this_arg) {
	LDKOutPoint this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, OutPoint_to_channel_id(&this_arg_conv).data, 32);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_OutPoint_write"))) TS_OutPoint_write(uint32_t obj) {
	LDKOutPoint obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = OutPoint_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_OutPoint_read"))) TS_OutPoint_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_OutPointDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OutPointDecodeErrorZ), "LDKCResult_OutPointDecodeErrorZ");
	*ret_conv = OutPoint_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_free"))) TS_DelayedPaymentOutputDescriptor_free(uint32_t this_obj) {
	LDKDelayedPaymentOutputDescriptor this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	DelayedPaymentOutputDescriptor_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_get_outpoint"))) TS_DelayedPaymentOutputDescriptor_get_outpoint(uint32_t this_ptr) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint ret_var = DelayedPaymentOutputDescriptor_get_outpoint(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_set_outpoint"))) TS_DelayedPaymentOutputDescriptor_set_outpoint(uint32_t this_ptr, uint32_t val) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = OutPoint_clone(&val_conv);
	DelayedPaymentOutputDescriptor_set_outpoint(&this_ptr_conv, val_conv);
}

int8_tArray  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_get_per_commitment_point"))) TS_DelayedPaymentOutputDescriptor_get_per_commitment_point(uint32_t this_ptr) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, DelayedPaymentOutputDescriptor_get_per_commitment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_set_per_commitment_point"))) TS_DelayedPaymentOutputDescriptor_set_per_commitment_point(uint32_t this_ptr, int8_tArray val) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	DelayedPaymentOutputDescriptor_set_per_commitment_point(&this_ptr_conv, val_ref);
}

int16_t  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_get_to_self_delay"))) TS_DelayedPaymentOutputDescriptor_get_to_self_delay(uint32_t this_ptr) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = DelayedPaymentOutputDescriptor_get_to_self_delay(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_set_to_self_delay"))) TS_DelayedPaymentOutputDescriptor_set_to_self_delay(uint32_t this_ptr, int16_t val) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	DelayedPaymentOutputDescriptor_set_to_self_delay(&this_ptr_conv, val);
}

void  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_set_output"))) TS_DelayedPaymentOutputDescriptor_set_output(uint32_t this_ptr, uint32_t val) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKTxOut val_conv = *(LDKTxOut*)(val_ptr);
	val_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)val) & ~1));
	DelayedPaymentOutputDescriptor_set_output(&this_ptr_conv, val_conv);
}

int8_tArray  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_get_revocation_pubkey"))) TS_DelayedPaymentOutputDescriptor_get_revocation_pubkey(uint32_t this_ptr) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, DelayedPaymentOutputDescriptor_get_revocation_pubkey(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_set_revocation_pubkey"))) TS_DelayedPaymentOutputDescriptor_set_revocation_pubkey(uint32_t this_ptr, int8_tArray val) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	DelayedPaymentOutputDescriptor_set_revocation_pubkey(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_get_channel_keys_id"))) TS_DelayedPaymentOutputDescriptor_get_channel_keys_id(uint32_t this_ptr) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *DelayedPaymentOutputDescriptor_get_channel_keys_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_set_channel_keys_id"))) TS_DelayedPaymentOutputDescriptor_set_channel_keys_id(uint32_t this_ptr, int8_tArray val) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	DelayedPaymentOutputDescriptor_set_channel_keys_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_get_channel_value_satoshis"))) TS_DelayedPaymentOutputDescriptor_get_channel_value_satoshis(uint32_t this_ptr) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = DelayedPaymentOutputDescriptor_get_channel_value_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_set_channel_value_satoshis"))) TS_DelayedPaymentOutputDescriptor_set_channel_value_satoshis(uint32_t this_ptr, int64_t val) {
	LDKDelayedPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	DelayedPaymentOutputDescriptor_set_channel_value_satoshis(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_new"))) TS_DelayedPaymentOutputDescriptor_new(uint32_t outpoint_arg, int8_tArray per_commitment_point_arg, int16_t to_self_delay_arg, uint32_t output_arg, int8_tArray revocation_pubkey_arg, int8_tArray channel_keys_id_arg, int64_t channel_value_satoshis_arg) {
	LDKOutPoint outpoint_arg_conv;
	outpoint_arg_conv.inner = (void*)(outpoint_arg & (~1));
	outpoint_arg_conv.is_owned = (outpoint_arg & 1) || (outpoint_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(outpoint_arg_conv);
	outpoint_arg_conv = OutPoint_clone(&outpoint_arg_conv);
	LDKPublicKey per_commitment_point_arg_ref;
	CHECK(per_commitment_point_arg->arr_len == 33);
	memcpy(per_commitment_point_arg_ref.compressed_form, per_commitment_point_arg->elems, 33); FREE(per_commitment_point_arg);
	void* output_arg_ptr = (void*)(((uintptr_t)output_arg) & ~1);
	CHECK_ACCESS(output_arg_ptr);
	LDKTxOut output_arg_conv = *(LDKTxOut*)(output_arg_ptr);
	output_arg_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)output_arg) & ~1));
	LDKPublicKey revocation_pubkey_arg_ref;
	CHECK(revocation_pubkey_arg->arr_len == 33);
	memcpy(revocation_pubkey_arg_ref.compressed_form, revocation_pubkey_arg->elems, 33); FREE(revocation_pubkey_arg);
	LDKThirtyTwoBytes channel_keys_id_arg_ref;
	CHECK(channel_keys_id_arg->arr_len == 32);
	memcpy(channel_keys_id_arg_ref.data, channel_keys_id_arg->elems, 32); FREE(channel_keys_id_arg);
	LDKDelayedPaymentOutputDescriptor ret_var = DelayedPaymentOutputDescriptor_new(outpoint_arg_conv, per_commitment_point_arg_ref, to_self_delay_arg, output_arg_conv, revocation_pubkey_arg_ref, channel_keys_id_arg_ref, channel_value_satoshis_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t DelayedPaymentOutputDescriptor_clone_ptr(LDKDelayedPaymentOutputDescriptor *NONNULL_PTR arg) {
	LDKDelayedPaymentOutputDescriptor ret_var = DelayedPaymentOutputDescriptor_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_clone_ptr"))) TS_DelayedPaymentOutputDescriptor_clone_ptr(uint32_t arg) {
	LDKDelayedPaymentOutputDescriptor arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = DelayedPaymentOutputDescriptor_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_clone"))) TS_DelayedPaymentOutputDescriptor_clone(uint32_t orig) {
	LDKDelayedPaymentOutputDescriptor orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKDelayedPaymentOutputDescriptor ret_var = DelayedPaymentOutputDescriptor_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_write"))) TS_DelayedPaymentOutputDescriptor_write(uint32_t obj) {
	LDKDelayedPaymentOutputDescriptor obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = DelayedPaymentOutputDescriptor_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_DelayedPaymentOutputDescriptor_read"))) TS_DelayedPaymentOutputDescriptor_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_DelayedPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = DelayedPaymentOutputDescriptor_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_free"))) TS_StaticPaymentOutputDescriptor_free(uint32_t this_obj) {
	LDKStaticPaymentOutputDescriptor this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	StaticPaymentOutputDescriptor_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_get_outpoint"))) TS_StaticPaymentOutputDescriptor_get_outpoint(uint32_t this_ptr) {
	LDKStaticPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint ret_var = StaticPaymentOutputDescriptor_get_outpoint(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_set_outpoint"))) TS_StaticPaymentOutputDescriptor_set_outpoint(uint32_t this_ptr, uint32_t val) {
	LDKStaticPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = OutPoint_clone(&val_conv);
	StaticPaymentOutputDescriptor_set_outpoint(&this_ptr_conv, val_conv);
}

void  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_set_output"))) TS_StaticPaymentOutputDescriptor_set_output(uint32_t this_ptr, uint32_t val) {
	LDKStaticPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKTxOut val_conv = *(LDKTxOut*)(val_ptr);
	val_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)val) & ~1));
	StaticPaymentOutputDescriptor_set_output(&this_ptr_conv, val_conv);
}

int8_tArray  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_get_channel_keys_id"))) TS_StaticPaymentOutputDescriptor_get_channel_keys_id(uint32_t this_ptr) {
	LDKStaticPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *StaticPaymentOutputDescriptor_get_channel_keys_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_set_channel_keys_id"))) TS_StaticPaymentOutputDescriptor_set_channel_keys_id(uint32_t this_ptr, int8_tArray val) {
	LDKStaticPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	StaticPaymentOutputDescriptor_set_channel_keys_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_get_channel_value_satoshis"))) TS_StaticPaymentOutputDescriptor_get_channel_value_satoshis(uint32_t this_ptr) {
	LDKStaticPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = StaticPaymentOutputDescriptor_get_channel_value_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_set_channel_value_satoshis"))) TS_StaticPaymentOutputDescriptor_set_channel_value_satoshis(uint32_t this_ptr, int64_t val) {
	LDKStaticPaymentOutputDescriptor this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	StaticPaymentOutputDescriptor_set_channel_value_satoshis(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_new"))) TS_StaticPaymentOutputDescriptor_new(uint32_t outpoint_arg, uint32_t output_arg, int8_tArray channel_keys_id_arg, int64_t channel_value_satoshis_arg) {
	LDKOutPoint outpoint_arg_conv;
	outpoint_arg_conv.inner = (void*)(outpoint_arg & (~1));
	outpoint_arg_conv.is_owned = (outpoint_arg & 1) || (outpoint_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(outpoint_arg_conv);
	outpoint_arg_conv = OutPoint_clone(&outpoint_arg_conv);
	void* output_arg_ptr = (void*)(((uintptr_t)output_arg) & ~1);
	CHECK_ACCESS(output_arg_ptr);
	LDKTxOut output_arg_conv = *(LDKTxOut*)(output_arg_ptr);
	output_arg_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)output_arg) & ~1));
	LDKThirtyTwoBytes channel_keys_id_arg_ref;
	CHECK(channel_keys_id_arg->arr_len == 32);
	memcpy(channel_keys_id_arg_ref.data, channel_keys_id_arg->elems, 32); FREE(channel_keys_id_arg);
	LDKStaticPaymentOutputDescriptor ret_var = StaticPaymentOutputDescriptor_new(outpoint_arg_conv, output_arg_conv, channel_keys_id_arg_ref, channel_value_satoshis_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t StaticPaymentOutputDescriptor_clone_ptr(LDKStaticPaymentOutputDescriptor *NONNULL_PTR arg) {
	LDKStaticPaymentOutputDescriptor ret_var = StaticPaymentOutputDescriptor_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_clone_ptr"))) TS_StaticPaymentOutputDescriptor_clone_ptr(uint32_t arg) {
	LDKStaticPaymentOutputDescriptor arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = StaticPaymentOutputDescriptor_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_clone"))) TS_StaticPaymentOutputDescriptor_clone(uint32_t orig) {
	LDKStaticPaymentOutputDescriptor orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKStaticPaymentOutputDescriptor ret_var = StaticPaymentOutputDescriptor_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_write"))) TS_StaticPaymentOutputDescriptor_write(uint32_t obj) {
	LDKStaticPaymentOutputDescriptor obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = StaticPaymentOutputDescriptor_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_StaticPaymentOutputDescriptor_read"))) TS_StaticPaymentOutputDescriptor_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ), "LDKCResult_StaticPaymentOutputDescriptorDecodeErrorZ");
	*ret_conv = StaticPaymentOutputDescriptor_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_SpendableOutputDescriptor_free"))) TS_SpendableOutputDescriptor_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKSpendableOutputDescriptor this_ptr_conv = *(LDKSpendableOutputDescriptor*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	SpendableOutputDescriptor_free(this_ptr_conv);
}

static inline uintptr_t SpendableOutputDescriptor_clone_ptr(LDKSpendableOutputDescriptor *NONNULL_PTR arg) {
	LDKSpendableOutputDescriptor *ret_copy = MALLOC(sizeof(LDKSpendableOutputDescriptor), "LDKSpendableOutputDescriptor");
	*ret_copy = SpendableOutputDescriptor_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_SpendableOutputDescriptor_clone_ptr"))) TS_SpendableOutputDescriptor_clone_ptr(uint32_t arg) {
	LDKSpendableOutputDescriptor* arg_conv = (LDKSpendableOutputDescriptor*)arg;
	uint32_t ret_val = SpendableOutputDescriptor_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_SpendableOutputDescriptor_clone"))) TS_SpendableOutputDescriptor_clone(uint32_t orig) {
	LDKSpendableOutputDescriptor* orig_conv = (LDKSpendableOutputDescriptor*)orig;
	LDKSpendableOutputDescriptor *ret_copy = MALLOC(sizeof(LDKSpendableOutputDescriptor), "LDKSpendableOutputDescriptor");
	*ret_copy = SpendableOutputDescriptor_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_SpendableOutputDescriptor_static_output"))) TS_SpendableOutputDescriptor_static_output(uint32_t outpoint, uint32_t output) {
	LDKOutPoint outpoint_conv;
	outpoint_conv.inner = (void*)(outpoint & (~1));
	outpoint_conv.is_owned = (outpoint & 1) || (outpoint == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(outpoint_conv);
	outpoint_conv = OutPoint_clone(&outpoint_conv);
	void* output_ptr = (void*)(((uintptr_t)output) & ~1);
	CHECK_ACCESS(output_ptr);
	LDKTxOut output_conv = *(LDKTxOut*)(output_ptr);
	output_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)output) & ~1));
	LDKSpendableOutputDescriptor *ret_copy = MALLOC(sizeof(LDKSpendableOutputDescriptor), "LDKSpendableOutputDescriptor");
	*ret_copy = SpendableOutputDescriptor_static_output(outpoint_conv, output_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_SpendableOutputDescriptor_delayed_payment_output"))) TS_SpendableOutputDescriptor_delayed_payment_output(uint32_t a) {
	LDKDelayedPaymentOutputDescriptor a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = DelayedPaymentOutputDescriptor_clone(&a_conv);
	LDKSpendableOutputDescriptor *ret_copy = MALLOC(sizeof(LDKSpendableOutputDescriptor), "LDKSpendableOutputDescriptor");
	*ret_copy = SpendableOutputDescriptor_delayed_payment_output(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_SpendableOutputDescriptor_static_payment_output"))) TS_SpendableOutputDescriptor_static_payment_output(uint32_t a) {
	LDKStaticPaymentOutputDescriptor a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = StaticPaymentOutputDescriptor_clone(&a_conv);
	LDKSpendableOutputDescriptor *ret_copy = MALLOC(sizeof(LDKSpendableOutputDescriptor), "LDKSpendableOutputDescriptor");
	*ret_copy = SpendableOutputDescriptor_static_payment_output(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_SpendableOutputDescriptor_write"))) TS_SpendableOutputDescriptor_write(uint32_t obj) {
	LDKSpendableOutputDescriptor* obj_conv = (LDKSpendableOutputDescriptor*)obj;
	LDKCVec_u8Z ret_var = SpendableOutputDescriptor_write(obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_SpendableOutputDescriptor_read"))) TS_SpendableOutputDescriptor_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_SpendableOutputDescriptorDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SpendableOutputDescriptorDecodeErrorZ), "LDKCResult_SpendableOutputDescriptorDecodeErrorZ");
	*ret_conv = SpendableOutputDescriptor_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_BaseSign_free"))) TS_BaseSign_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKBaseSign this_ptr_conv = *(LDKBaseSign*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	BaseSign_free(this_ptr_conv);
}

static inline uintptr_t Sign_clone_ptr(LDKSign *NONNULL_PTR arg) {
	LDKSign* ret_ret = MALLOC(sizeof(LDKSign), "LDKSign");
	*ret_ret = Sign_clone(arg);
	return (uint32_t)ret_ret;
}
uint32_t  __attribute__((export_name("TS_Sign_clone_ptr"))) TS_Sign_clone_ptr(uint32_t arg) {
	void* arg_ptr = (void*)(((uintptr_t)arg) & ~1);
	if (!(arg & 1)) { CHECK_ACCESS(arg_ptr); }
	LDKSign* arg_conv = (LDKSign*)arg_ptr;
	uint32_t ret_val = Sign_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Sign_clone"))) TS_Sign_clone(uint32_t orig) {
	void* orig_ptr = (void*)(((uintptr_t)orig) & ~1);
	if (!(orig & 1)) { CHECK_ACCESS(orig_ptr); }
	LDKSign* orig_conv = (LDKSign*)orig_ptr;
	LDKSign* ret_ret = MALLOC(sizeof(LDKSign), "LDKSign");
	*ret_ret = Sign_clone(orig_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_Sign_free"))) TS_Sign_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKSign this_ptr_conv = *(LDKSign*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Sign_free(this_ptr_conv);
}

uint32_t  __attribute__((export_name("TS_Recipient_clone"))) TS_Recipient_clone(uint32_t orig) {
	LDKRecipient* orig_conv = (LDKRecipient*)(orig & ~1);
	uint32_t ret_conv = LDKRecipient_to_js(Recipient_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Recipient_node"))) TS_Recipient_node() {
	uint32_t ret_conv = LDKRecipient_to_js(Recipient_node());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Recipient_phantom_node"))) TS_Recipient_phantom_node() {
	uint32_t ret_conv = LDKRecipient_to_js(Recipient_phantom_node());
	return ret_conv;
}

void  __attribute__((export_name("TS_KeysInterface_free"))) TS_KeysInterface_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKKeysInterface this_ptr_conv = *(LDKKeysInterface*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	KeysInterface_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_InMemorySigner_free"))) TS_InMemorySigner_free(uint32_t this_obj) {
	LDKInMemorySigner this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	InMemorySigner_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_InMemorySigner_get_funding_key"))) TS_InMemorySigner_get_funding_key(uint32_t this_ptr) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *InMemorySigner_get_funding_key(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_InMemorySigner_set_funding_key"))) TS_InMemorySigner_set_funding_key(uint32_t this_ptr, int8_tArray val) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSecretKey val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.bytes, val->elems, 32); FREE(val);
	InMemorySigner_set_funding_key(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_InMemorySigner_get_revocation_base_key"))) TS_InMemorySigner_get_revocation_base_key(uint32_t this_ptr) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *InMemorySigner_get_revocation_base_key(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_InMemorySigner_set_revocation_base_key"))) TS_InMemorySigner_set_revocation_base_key(uint32_t this_ptr, int8_tArray val) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSecretKey val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.bytes, val->elems, 32); FREE(val);
	InMemorySigner_set_revocation_base_key(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_InMemorySigner_get_payment_key"))) TS_InMemorySigner_get_payment_key(uint32_t this_ptr) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *InMemorySigner_get_payment_key(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_InMemorySigner_set_payment_key"))) TS_InMemorySigner_set_payment_key(uint32_t this_ptr, int8_tArray val) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSecretKey val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.bytes, val->elems, 32); FREE(val);
	InMemorySigner_set_payment_key(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_InMemorySigner_get_delayed_payment_base_key"))) TS_InMemorySigner_get_delayed_payment_base_key(uint32_t this_ptr) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *InMemorySigner_get_delayed_payment_base_key(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_InMemorySigner_set_delayed_payment_base_key"))) TS_InMemorySigner_set_delayed_payment_base_key(uint32_t this_ptr, int8_tArray val) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSecretKey val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.bytes, val->elems, 32); FREE(val);
	InMemorySigner_set_delayed_payment_base_key(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_InMemorySigner_get_htlc_base_key"))) TS_InMemorySigner_get_htlc_base_key(uint32_t this_ptr) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *InMemorySigner_get_htlc_base_key(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_InMemorySigner_set_htlc_base_key"))) TS_InMemorySigner_set_htlc_base_key(uint32_t this_ptr, int8_tArray val) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSecretKey val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.bytes, val->elems, 32); FREE(val);
	InMemorySigner_set_htlc_base_key(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_InMemorySigner_get_commitment_seed"))) TS_InMemorySigner_get_commitment_seed(uint32_t this_ptr) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *InMemorySigner_get_commitment_seed(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_InMemorySigner_set_commitment_seed"))) TS_InMemorySigner_set_commitment_seed(uint32_t this_ptr, int8_tArray val) {
	LDKInMemorySigner this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	InMemorySigner_set_commitment_seed(&this_ptr_conv, val_ref);
}

static inline uintptr_t InMemorySigner_clone_ptr(LDKInMemorySigner *NONNULL_PTR arg) {
	LDKInMemorySigner ret_var = InMemorySigner_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_InMemorySigner_clone_ptr"))) TS_InMemorySigner_clone_ptr(uint32_t arg) {
	LDKInMemorySigner arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = InMemorySigner_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_clone"))) TS_InMemorySigner_clone(uint32_t orig) {
	LDKInMemorySigner orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKInMemorySigner ret_var = InMemorySigner_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_new"))) TS_InMemorySigner_new(int8_tArray node_secret, int8_tArray funding_key, int8_tArray revocation_base_key, int8_tArray payment_key, int8_tArray delayed_payment_base_key, int8_tArray htlc_base_key, int8_tArray commitment_seed, int64_t channel_value_satoshis, int8_tArray channel_keys_id) {
	LDKSecretKey node_secret_ref;
	CHECK(node_secret->arr_len == 32);
	memcpy(node_secret_ref.bytes, node_secret->elems, 32); FREE(node_secret);
	LDKSecretKey funding_key_ref;
	CHECK(funding_key->arr_len == 32);
	memcpy(funding_key_ref.bytes, funding_key->elems, 32); FREE(funding_key);
	LDKSecretKey revocation_base_key_ref;
	CHECK(revocation_base_key->arr_len == 32);
	memcpy(revocation_base_key_ref.bytes, revocation_base_key->elems, 32); FREE(revocation_base_key);
	LDKSecretKey payment_key_ref;
	CHECK(payment_key->arr_len == 32);
	memcpy(payment_key_ref.bytes, payment_key->elems, 32); FREE(payment_key);
	LDKSecretKey delayed_payment_base_key_ref;
	CHECK(delayed_payment_base_key->arr_len == 32);
	memcpy(delayed_payment_base_key_ref.bytes, delayed_payment_base_key->elems, 32); FREE(delayed_payment_base_key);
	LDKSecretKey htlc_base_key_ref;
	CHECK(htlc_base_key->arr_len == 32);
	memcpy(htlc_base_key_ref.bytes, htlc_base_key->elems, 32); FREE(htlc_base_key);
	LDKThirtyTwoBytes commitment_seed_ref;
	CHECK(commitment_seed->arr_len == 32);
	memcpy(commitment_seed_ref.data, commitment_seed->elems, 32); FREE(commitment_seed);
	LDKThirtyTwoBytes channel_keys_id_ref;
	CHECK(channel_keys_id->arr_len == 32);
	memcpy(channel_keys_id_ref.data, channel_keys_id->elems, 32); FREE(channel_keys_id);
	LDKInMemorySigner ret_var = InMemorySigner_new(node_secret_ref, funding_key_ref, revocation_base_key_ref, payment_key_ref, delayed_payment_base_key_ref, htlc_base_key_ref, commitment_seed_ref, channel_value_satoshis, channel_keys_id_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_counterparty_pubkeys"))) TS_InMemorySigner_counterparty_pubkeys(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelPublicKeys ret_var = InMemorySigner_counterparty_pubkeys(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int16_t  __attribute__((export_name("TS_InMemorySigner_counterparty_selected_contest_delay"))) TS_InMemorySigner_counterparty_selected_contest_delay(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int16_t ret_val = InMemorySigner_counterparty_selected_contest_delay(&this_arg_conv);
	return ret_val;
}

int16_t  __attribute__((export_name("TS_InMemorySigner_holder_selected_contest_delay"))) TS_InMemorySigner_holder_selected_contest_delay(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int16_t ret_val = InMemorySigner_holder_selected_contest_delay(&this_arg_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_InMemorySigner_is_outbound"))) TS_InMemorySigner_is_outbound(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = InMemorySigner_is_outbound(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_funding_outpoint"))) TS_InMemorySigner_funding_outpoint(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKOutPoint ret_var = InMemorySigner_funding_outpoint(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_get_channel_parameters"))) TS_InMemorySigner_get_channel_parameters(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelTransactionParameters ret_var = InMemorySigner_get_channel_parameters(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_InMemorySigner_opt_anchors"))) TS_InMemorySigner_opt_anchors(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = InMemorySigner_opt_anchors(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_sign_counterparty_payment_input"))) TS_InMemorySigner_sign_counterparty_payment_input(uint32_t this_arg, int8_tArray spend_tx, uint32_t input_idx, uint32_t descriptor) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKTransaction spend_tx_ref;
	spend_tx_ref.datalen = spend_tx->arr_len;
	spend_tx_ref.data = MALLOC(spend_tx_ref.datalen, "LDKTransaction Bytes");
	memcpy(spend_tx_ref.data, spend_tx->elems, spend_tx_ref.datalen); FREE(spend_tx);
	spend_tx_ref.data_is_owned = true;
	LDKStaticPaymentOutputDescriptor descriptor_conv;
	descriptor_conv.inner = (void*)(descriptor & (~1));
	descriptor_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(descriptor_conv);
	LDKCResult_CVec_CVec_u8ZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_CVec_u8ZZNoneZ), "LDKCResult_CVec_CVec_u8ZZNoneZ");
	*ret_conv = InMemorySigner_sign_counterparty_payment_input(&this_arg_conv, spend_tx_ref, input_idx, &descriptor_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_sign_dynamic_p2wsh_input"))) TS_InMemorySigner_sign_dynamic_p2wsh_input(uint32_t this_arg, int8_tArray spend_tx, uint32_t input_idx, uint32_t descriptor) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKTransaction spend_tx_ref;
	spend_tx_ref.datalen = spend_tx->arr_len;
	spend_tx_ref.data = MALLOC(spend_tx_ref.datalen, "LDKTransaction Bytes");
	memcpy(spend_tx_ref.data, spend_tx->elems, spend_tx_ref.datalen); FREE(spend_tx);
	spend_tx_ref.data_is_owned = true;
	LDKDelayedPaymentOutputDescriptor descriptor_conv;
	descriptor_conv.inner = (void*)(descriptor & (~1));
	descriptor_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(descriptor_conv);
	LDKCResult_CVec_CVec_u8ZZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_CVec_u8ZZNoneZ), "LDKCResult_CVec_CVec_u8ZZNoneZ");
	*ret_conv = InMemorySigner_sign_dynamic_p2wsh_input(&this_arg_conv, spend_tx_ref, input_idx, &descriptor_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_as_BaseSign"))) TS_InMemorySigner_as_BaseSign(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKBaseSign* ret_ret = MALLOC(sizeof(LDKBaseSign), "LDKBaseSign");
	*ret_ret = InMemorySigner_as_BaseSign(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_as_Sign"))) TS_InMemorySigner_as_Sign(uint32_t this_arg) {
	LDKInMemorySigner this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKSign* ret_ret = MALLOC(sizeof(LDKSign), "LDKSign");
	*ret_ret = InMemorySigner_as_Sign(&this_arg_conv);
	return (uint32_t)ret_ret;
}

int8_tArray  __attribute__((export_name("TS_InMemorySigner_write"))) TS_InMemorySigner_write(uint32_t obj) {
	LDKInMemorySigner obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = InMemorySigner_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_InMemorySigner_read"))) TS_InMemorySigner_read(int8_tArray ser, int8_tArray arg) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKSecretKey arg_ref;
	CHECK(arg->arr_len == 32);
	memcpy(arg_ref.bytes, arg->elems, 32); FREE(arg);
	LDKCResult_InMemorySignerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InMemorySignerDecodeErrorZ), "LDKCResult_InMemorySignerDecodeErrorZ");
	*ret_conv = InMemorySigner_read(ser_ref, arg_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_KeysManager_free"))) TS_KeysManager_free(uint32_t this_obj) {
	LDKKeysManager this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	KeysManager_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_KeysManager_new"))) TS_KeysManager_new(int8_tArray seed, int64_t starting_time_secs, int32_t starting_time_nanos) {
	unsigned char seed_arr[32];
	CHECK(seed->arr_len == 32);
	memcpy(seed_arr, seed->elems, 32); FREE(seed);
	unsigned char (*seed_ref)[32] = &seed_arr;
	LDKKeysManager ret_var = KeysManager_new(seed_ref, starting_time_secs, starting_time_nanos);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_KeysManager_derive_channel_keys"))) TS_KeysManager_derive_channel_keys(uint32_t this_arg, int64_t channel_value_satoshis, int8_tArray params) {
	LDKKeysManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char params_arr[32];
	CHECK(params->arr_len == 32);
	memcpy(params_arr, params->elems, 32); FREE(params);
	unsigned char (*params_ref)[32] = &params_arr;
	LDKInMemorySigner ret_var = KeysManager_derive_channel_keys(&this_arg_conv, channel_value_satoshis, params_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_KeysManager_spend_spendable_outputs"))) TS_KeysManager_spend_spendable_outputs(uint32_t this_arg, uint32_tArray descriptors, uint32_tArray outputs, int8_tArray change_destination_script, int32_t feerate_sat_per_1000_weight) {
	LDKKeysManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_SpendableOutputDescriptorZ descriptors_constr;
	descriptors_constr.datalen = descriptors->arr_len;
	if (descriptors_constr.datalen > 0)
		descriptors_constr.data = MALLOC(descriptors_constr.datalen * sizeof(LDKSpendableOutputDescriptor), "LDKCVec_SpendableOutputDescriptorZ Elements");
	else
		descriptors_constr.data = NULL;
	uint32_t* descriptors_vals = descriptors->elems /* XXX descriptors leaks */;
	for (size_t b = 0; b < descriptors_constr.datalen; b++) {
		uint32_t descriptors_conv_27 = descriptors_vals[b];
		void* descriptors_conv_27_ptr = (void*)(((uintptr_t)descriptors_conv_27) & ~1);
		CHECK_ACCESS(descriptors_conv_27_ptr);
		LDKSpendableOutputDescriptor descriptors_conv_27_conv = *(LDKSpendableOutputDescriptor*)(descriptors_conv_27_ptr);
		descriptors_conv_27_conv = SpendableOutputDescriptor_clone((LDKSpendableOutputDescriptor*)(((uintptr_t)descriptors_conv_27) & ~1));
		descriptors_constr.data[b] = descriptors_conv_27_conv;
	}
	LDKCVec_TxOutZ outputs_constr;
	outputs_constr.datalen = outputs->arr_len;
	if (outputs_constr.datalen > 0)
		outputs_constr.data = MALLOC(outputs_constr.datalen * sizeof(LDKTxOut), "LDKCVec_TxOutZ Elements");
	else
		outputs_constr.data = NULL;
	uint32_t* outputs_vals = outputs->elems /* XXX outputs leaks */;
	for (size_t h = 0; h < outputs_constr.datalen; h++) {
		uint32_t outputs_conv_7 = outputs_vals[h];
		void* outputs_conv_7_ptr = (void*)(((uintptr_t)outputs_conv_7) & ~1);
		CHECK_ACCESS(outputs_conv_7_ptr);
		LDKTxOut outputs_conv_7_conv = *(LDKTxOut*)(outputs_conv_7_ptr);
		outputs_conv_7_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)outputs_conv_7) & ~1));
		outputs_constr.data[h] = outputs_conv_7_conv;
	}
	LDKCVec_u8Z change_destination_script_ref;
	change_destination_script_ref.datalen = change_destination_script->arr_len;
	change_destination_script_ref.data = MALLOC(change_destination_script_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(change_destination_script_ref.data, change_destination_script->elems, change_destination_script_ref.datalen); FREE(change_destination_script);
	LDKCResult_TransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TransactionNoneZ), "LDKCResult_TransactionNoneZ");
	*ret_conv = KeysManager_spend_spendable_outputs(&this_arg_conv, descriptors_constr, outputs_constr, change_destination_script_ref, feerate_sat_per_1000_weight);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_KeysManager_as_KeysInterface"))) TS_KeysManager_as_KeysInterface(uint32_t this_arg) {
	LDKKeysManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKKeysInterface* ret_ret = MALLOC(sizeof(LDKKeysInterface), "LDKKeysInterface");
	*ret_ret = KeysManager_as_KeysInterface(&this_arg_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_PhantomKeysManager_free"))) TS_PhantomKeysManager_free(uint32_t this_obj) {
	LDKPhantomKeysManager this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	PhantomKeysManager_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_PhantomKeysManager_as_KeysInterface"))) TS_PhantomKeysManager_as_KeysInterface(uint32_t this_arg) {
	LDKPhantomKeysManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKKeysInterface* ret_ret = MALLOC(sizeof(LDKKeysInterface), "LDKKeysInterface");
	*ret_ret = PhantomKeysManager_as_KeysInterface(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_PhantomKeysManager_new"))) TS_PhantomKeysManager_new(int8_tArray seed, int64_t starting_time_secs, int32_t starting_time_nanos, int8_tArray cross_node_seed) {
	unsigned char seed_arr[32];
	CHECK(seed->arr_len == 32);
	memcpy(seed_arr, seed->elems, 32); FREE(seed);
	unsigned char (*seed_ref)[32] = &seed_arr;
	unsigned char cross_node_seed_arr[32];
	CHECK(cross_node_seed->arr_len == 32);
	memcpy(cross_node_seed_arr, cross_node_seed->elems, 32); FREE(cross_node_seed);
	unsigned char (*cross_node_seed_ref)[32] = &cross_node_seed_arr;
	LDKPhantomKeysManager ret_var = PhantomKeysManager_new(seed_ref, starting_time_secs, starting_time_nanos, cross_node_seed_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PhantomKeysManager_spend_spendable_outputs"))) TS_PhantomKeysManager_spend_spendable_outputs(uint32_t this_arg, uint32_tArray descriptors, uint32_tArray outputs, int8_tArray change_destination_script, int32_t feerate_sat_per_1000_weight) {
	LDKPhantomKeysManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_SpendableOutputDescriptorZ descriptors_constr;
	descriptors_constr.datalen = descriptors->arr_len;
	if (descriptors_constr.datalen > 0)
		descriptors_constr.data = MALLOC(descriptors_constr.datalen * sizeof(LDKSpendableOutputDescriptor), "LDKCVec_SpendableOutputDescriptorZ Elements");
	else
		descriptors_constr.data = NULL;
	uint32_t* descriptors_vals = descriptors->elems /* XXX descriptors leaks */;
	for (size_t b = 0; b < descriptors_constr.datalen; b++) {
		uint32_t descriptors_conv_27 = descriptors_vals[b];
		void* descriptors_conv_27_ptr = (void*)(((uintptr_t)descriptors_conv_27) & ~1);
		CHECK_ACCESS(descriptors_conv_27_ptr);
		LDKSpendableOutputDescriptor descriptors_conv_27_conv = *(LDKSpendableOutputDescriptor*)(descriptors_conv_27_ptr);
		descriptors_conv_27_conv = SpendableOutputDescriptor_clone((LDKSpendableOutputDescriptor*)(((uintptr_t)descriptors_conv_27) & ~1));
		descriptors_constr.data[b] = descriptors_conv_27_conv;
	}
	LDKCVec_TxOutZ outputs_constr;
	outputs_constr.datalen = outputs->arr_len;
	if (outputs_constr.datalen > 0)
		outputs_constr.data = MALLOC(outputs_constr.datalen * sizeof(LDKTxOut), "LDKCVec_TxOutZ Elements");
	else
		outputs_constr.data = NULL;
	uint32_t* outputs_vals = outputs->elems /* XXX outputs leaks */;
	for (size_t h = 0; h < outputs_constr.datalen; h++) {
		uint32_t outputs_conv_7 = outputs_vals[h];
		void* outputs_conv_7_ptr = (void*)(((uintptr_t)outputs_conv_7) & ~1);
		CHECK_ACCESS(outputs_conv_7_ptr);
		LDKTxOut outputs_conv_7_conv = *(LDKTxOut*)(outputs_conv_7_ptr);
		outputs_conv_7_conv = TxOut_clone((LDKTxOut*)(((uintptr_t)outputs_conv_7) & ~1));
		outputs_constr.data[h] = outputs_conv_7_conv;
	}
	LDKCVec_u8Z change_destination_script_ref;
	change_destination_script_ref.datalen = change_destination_script->arr_len;
	change_destination_script_ref.data = MALLOC(change_destination_script_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(change_destination_script_ref.data, change_destination_script->elems, change_destination_script_ref.datalen); FREE(change_destination_script);
	LDKCResult_TransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TransactionNoneZ), "LDKCResult_TransactionNoneZ");
	*ret_conv = PhantomKeysManager_spend_spendable_outputs(&this_arg_conv, descriptors_constr, outputs_constr, change_destination_script_ref, feerate_sat_per_1000_weight);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_PhantomKeysManager_derive_channel_keys"))) TS_PhantomKeysManager_derive_channel_keys(uint32_t this_arg, int64_t channel_value_satoshis, int8_tArray params) {
	LDKPhantomKeysManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char params_arr[32];
	CHECK(params->arr_len == 32);
	memcpy(params_arr, params->elems, 32); FREE(params);
	unsigned char (*params_ref)[32] = &params_arr;
	LDKInMemorySigner ret_var = PhantomKeysManager_derive_channel_keys(&this_arg_conv, channel_value_satoshis, params_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelManager_free"))) TS_ChannelManager_free(uint32_t this_obj) {
	LDKChannelManager this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelManager_free(this_obj_conv);
}

void  __attribute__((export_name("TS_ChainParameters_free"))) TS_ChainParameters_free(uint32_t this_obj) {
	LDKChainParameters this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChainParameters_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_ChainParameters_get_network"))) TS_ChainParameters_get_network(uint32_t this_ptr) {
	LDKChainParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	uint32_t ret_conv = LDKNetwork_to_js(ChainParameters_get_network(&this_ptr_conv));
	return ret_conv;
}

void  __attribute__((export_name("TS_ChainParameters_set_network"))) TS_ChainParameters_set_network(uint32_t this_ptr, uint32_t val) {
	LDKChainParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNetwork val_conv = LDKNetwork_from_js(val);
	ChainParameters_set_network(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChainParameters_get_best_block"))) TS_ChainParameters_get_best_block(uint32_t this_ptr) {
	LDKChainParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKBestBlock ret_var = ChainParameters_get_best_block(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChainParameters_set_best_block"))) TS_ChainParameters_set_best_block(uint32_t this_ptr, uint32_t val) {
	LDKChainParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKBestBlock val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = BestBlock_clone(&val_conv);
	ChainParameters_set_best_block(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChainParameters_new"))) TS_ChainParameters_new(uint32_t network_arg, uint32_t best_block_arg) {
	LDKNetwork network_arg_conv = LDKNetwork_from_js(network_arg);
	LDKBestBlock best_block_arg_conv;
	best_block_arg_conv.inner = (void*)(best_block_arg & (~1));
	best_block_arg_conv.is_owned = (best_block_arg & 1) || (best_block_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(best_block_arg_conv);
	best_block_arg_conv = BestBlock_clone(&best_block_arg_conv);
	LDKChainParameters ret_var = ChainParameters_new(network_arg_conv, best_block_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChainParameters_clone_ptr(LDKChainParameters *NONNULL_PTR arg) {
	LDKChainParameters ret_var = ChainParameters_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChainParameters_clone_ptr"))) TS_ChainParameters_clone_ptr(uint32_t arg) {
	LDKChainParameters arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChainParameters_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChainParameters_clone"))) TS_ChainParameters_clone(uint32_t orig) {
	LDKChainParameters orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChainParameters ret_var = ChainParameters_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_CounterpartyForwardingInfo_free"))) TS_CounterpartyForwardingInfo_free(uint32_t this_obj) {
	LDKCounterpartyForwardingInfo this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	CounterpartyForwardingInfo_free(this_obj_conv);
}

int32_t  __attribute__((export_name("TS_CounterpartyForwardingInfo_get_fee_base_msat"))) TS_CounterpartyForwardingInfo_get_fee_base_msat(uint32_t this_ptr) {
	LDKCounterpartyForwardingInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = CounterpartyForwardingInfo_get_fee_base_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CounterpartyForwardingInfo_set_fee_base_msat"))) TS_CounterpartyForwardingInfo_set_fee_base_msat(uint32_t this_ptr, int32_t val) {
	LDKCounterpartyForwardingInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	CounterpartyForwardingInfo_set_fee_base_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_CounterpartyForwardingInfo_get_fee_proportional_millionths"))) TS_CounterpartyForwardingInfo_get_fee_proportional_millionths(uint32_t this_ptr) {
	LDKCounterpartyForwardingInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = CounterpartyForwardingInfo_get_fee_proportional_millionths(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CounterpartyForwardingInfo_set_fee_proportional_millionths"))) TS_CounterpartyForwardingInfo_set_fee_proportional_millionths(uint32_t this_ptr, int32_t val) {
	LDKCounterpartyForwardingInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	CounterpartyForwardingInfo_set_fee_proportional_millionths(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_CounterpartyForwardingInfo_get_cltv_expiry_delta"))) TS_CounterpartyForwardingInfo_get_cltv_expiry_delta(uint32_t this_ptr) {
	LDKCounterpartyForwardingInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = CounterpartyForwardingInfo_get_cltv_expiry_delta(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CounterpartyForwardingInfo_set_cltv_expiry_delta"))) TS_CounterpartyForwardingInfo_set_cltv_expiry_delta(uint32_t this_ptr, int16_t val) {
	LDKCounterpartyForwardingInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	CounterpartyForwardingInfo_set_cltv_expiry_delta(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_CounterpartyForwardingInfo_new"))) TS_CounterpartyForwardingInfo_new(int32_t fee_base_msat_arg, int32_t fee_proportional_millionths_arg, int16_t cltv_expiry_delta_arg) {
	LDKCounterpartyForwardingInfo ret_var = CounterpartyForwardingInfo_new(fee_base_msat_arg, fee_proportional_millionths_arg, cltv_expiry_delta_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t CounterpartyForwardingInfo_clone_ptr(LDKCounterpartyForwardingInfo *NONNULL_PTR arg) {
	LDKCounterpartyForwardingInfo ret_var = CounterpartyForwardingInfo_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_CounterpartyForwardingInfo_clone_ptr"))) TS_CounterpartyForwardingInfo_clone_ptr(uint32_t arg) {
	LDKCounterpartyForwardingInfo arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = CounterpartyForwardingInfo_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CounterpartyForwardingInfo_clone"))) TS_CounterpartyForwardingInfo_clone(uint32_t orig) {
	LDKCounterpartyForwardingInfo orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKCounterpartyForwardingInfo ret_var = CounterpartyForwardingInfo_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelCounterparty_free"))) TS_ChannelCounterparty_free(uint32_t this_obj) {
	LDKChannelCounterparty this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelCounterparty_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ChannelCounterparty_get_node_id"))) TS_ChannelCounterparty_get_node_id(uint32_t this_ptr) {
	LDKChannelCounterparty this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, ChannelCounterparty_get_node_id(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelCounterparty_set_node_id"))) TS_ChannelCounterparty_set_node_id(uint32_t this_ptr, int8_tArray val) {
	LDKChannelCounterparty this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	ChannelCounterparty_set_node_id(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_ChannelCounterparty_get_features"))) TS_ChannelCounterparty_get_features(uint32_t this_ptr) {
	LDKChannelCounterparty this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKInitFeatures ret_var = ChannelCounterparty_get_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelCounterparty_set_features"))) TS_ChannelCounterparty_set_features(uint32_t this_ptr, uint32_t val) {
	LDKChannelCounterparty this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKInitFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = InitFeatures_clone(&val_conv);
	ChannelCounterparty_set_features(&this_ptr_conv, val_conv);
}

int64_t  __attribute__((export_name("TS_ChannelCounterparty_get_unspendable_punishment_reserve"))) TS_ChannelCounterparty_get_unspendable_punishment_reserve(uint32_t this_ptr) {
	LDKChannelCounterparty this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelCounterparty_get_unspendable_punishment_reserve(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelCounterparty_set_unspendable_punishment_reserve"))) TS_ChannelCounterparty_set_unspendable_punishment_reserve(uint32_t this_ptr, int64_t val) {
	LDKChannelCounterparty this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelCounterparty_set_unspendable_punishment_reserve(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelCounterparty_get_forwarding_info"))) TS_ChannelCounterparty_get_forwarding_info(uint32_t this_ptr) {
	LDKChannelCounterparty this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCounterpartyForwardingInfo ret_var = ChannelCounterparty_get_forwarding_info(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelCounterparty_set_forwarding_info"))) TS_ChannelCounterparty_set_forwarding_info(uint32_t this_ptr, uint32_t val) {
	LDKChannelCounterparty this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCounterpartyForwardingInfo val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = CounterpartyForwardingInfo_clone(&val_conv);
	ChannelCounterparty_set_forwarding_info(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelCounterparty_new"))) TS_ChannelCounterparty_new(int8_tArray node_id_arg, uint32_t features_arg, int64_t unspendable_punishment_reserve_arg, uint32_t forwarding_info_arg) {
	LDKPublicKey node_id_arg_ref;
	CHECK(node_id_arg->arr_len == 33);
	memcpy(node_id_arg_ref.compressed_form, node_id_arg->elems, 33); FREE(node_id_arg);
	LDKInitFeatures features_arg_conv;
	features_arg_conv.inner = (void*)(features_arg & (~1));
	features_arg_conv.is_owned = (features_arg & 1) || (features_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(features_arg_conv);
	features_arg_conv = InitFeatures_clone(&features_arg_conv);
	LDKCounterpartyForwardingInfo forwarding_info_arg_conv;
	forwarding_info_arg_conv.inner = (void*)(forwarding_info_arg & (~1));
	forwarding_info_arg_conv.is_owned = (forwarding_info_arg & 1) || (forwarding_info_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(forwarding_info_arg_conv);
	forwarding_info_arg_conv = CounterpartyForwardingInfo_clone(&forwarding_info_arg_conv);
	LDKChannelCounterparty ret_var = ChannelCounterparty_new(node_id_arg_ref, features_arg_conv, unspendable_punishment_reserve_arg, forwarding_info_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelCounterparty_clone_ptr(LDKChannelCounterparty *NONNULL_PTR arg) {
	LDKChannelCounterparty ret_var = ChannelCounterparty_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelCounterparty_clone_ptr"))) TS_ChannelCounterparty_clone_ptr(uint32_t arg) {
	LDKChannelCounterparty arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelCounterparty_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelCounterparty_clone"))) TS_ChannelCounterparty_clone(uint32_t orig) {
	LDKChannelCounterparty orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelCounterparty ret_var = ChannelCounterparty_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_free"))) TS_ChannelDetails_free(uint32_t this_obj) {
	LDKChannelDetails this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelDetails_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ChannelDetails_get_channel_id"))) TS_ChannelDetails_get_channel_id(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *ChannelDetails_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelDetails_set_channel_id"))) TS_ChannelDetails_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	ChannelDetails_set_channel_id(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_counterparty"))) TS_ChannelDetails_get_counterparty(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelCounterparty ret_var = ChannelDetails_get_counterparty(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_set_counterparty"))) TS_ChannelDetails_set_counterparty(uint32_t this_ptr, uint32_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelCounterparty val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelCounterparty_clone(&val_conv);
	ChannelDetails_set_counterparty(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_funding_txo"))) TS_ChannelDetails_get_funding_txo(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint ret_var = ChannelDetails_get_funding_txo(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_set_funding_txo"))) TS_ChannelDetails_set_funding_txo(uint32_t this_ptr, uint32_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = OutPoint_clone(&val_conv);
	ChannelDetails_set_funding_txo(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_channel_type"))) TS_ChannelDetails_get_channel_type(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelTypeFeatures ret_var = ChannelDetails_get_channel_type(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_set_channel_type"))) TS_ChannelDetails_set_channel_type(uint32_t this_ptr, uint32_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelTypeFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelTypeFeatures_clone(&val_conv);
	ChannelDetails_set_channel_type(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_short_channel_id"))) TS_ChannelDetails_get_short_channel_id(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = ChannelDetails_get_short_channel_id(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_set_short_channel_id"))) TS_ChannelDetails_set_short_channel_id(uint32_t this_ptr, uint32_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	ChannelDetails_set_short_channel_id(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_inbound_scid_alias"))) TS_ChannelDetails_get_inbound_scid_alias(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = ChannelDetails_get_inbound_scid_alias(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_set_inbound_scid_alias"))) TS_ChannelDetails_set_inbound_scid_alias(uint32_t this_ptr, uint32_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	ChannelDetails_set_inbound_scid_alias(&this_ptr_conv, val_conv);
}

int64_t  __attribute__((export_name("TS_ChannelDetails_get_channel_value_satoshis"))) TS_ChannelDetails_get_channel_value_satoshis(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelDetails_get_channel_value_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_channel_value_satoshis"))) TS_ChannelDetails_set_channel_value_satoshis(uint32_t this_ptr, int64_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_channel_value_satoshis(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_unspendable_punishment_reserve"))) TS_ChannelDetails_get_unspendable_punishment_reserve(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = ChannelDetails_get_unspendable_punishment_reserve(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_set_unspendable_punishment_reserve"))) TS_ChannelDetails_set_unspendable_punishment_reserve(uint32_t this_ptr, uint32_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	ChannelDetails_set_unspendable_punishment_reserve(&this_ptr_conv, val_conv);
}

int64_t  __attribute__((export_name("TS_ChannelDetails_get_user_channel_id"))) TS_ChannelDetails_get_user_channel_id(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelDetails_get_user_channel_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_user_channel_id"))) TS_ChannelDetails_set_user_channel_id(uint32_t this_ptr, int64_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_user_channel_id(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelDetails_get_balance_msat"))) TS_ChannelDetails_get_balance_msat(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelDetails_get_balance_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_balance_msat"))) TS_ChannelDetails_set_balance_msat(uint32_t this_ptr, int64_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_balance_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelDetails_get_outbound_capacity_msat"))) TS_ChannelDetails_get_outbound_capacity_msat(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelDetails_get_outbound_capacity_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_outbound_capacity_msat"))) TS_ChannelDetails_set_outbound_capacity_msat(uint32_t this_ptr, int64_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_outbound_capacity_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelDetails_get_inbound_capacity_msat"))) TS_ChannelDetails_get_inbound_capacity_msat(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelDetails_get_inbound_capacity_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_inbound_capacity_msat"))) TS_ChannelDetails_set_inbound_capacity_msat(uint32_t this_ptr, int64_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_inbound_capacity_msat(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_confirmations_required"))) TS_ChannelDetails_get_confirmations_required(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u32Z *ret_copy = MALLOC(sizeof(LDKCOption_u32Z), "LDKCOption_u32Z");
	*ret_copy = ChannelDetails_get_confirmations_required(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_set_confirmations_required"))) TS_ChannelDetails_set_confirmations_required(uint32_t this_ptr, uint32_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u32Z val_conv = *(LDKCOption_u32Z*)(val_ptr);
	val_conv = COption_u32Z_clone((LDKCOption_u32Z*)(((uintptr_t)val) & ~1));
	ChannelDetails_set_confirmations_required(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_force_close_spend_delay"))) TS_ChannelDetails_get_force_close_spend_delay(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u16Z *ret_copy = MALLOC(sizeof(LDKCOption_u16Z), "LDKCOption_u16Z");
	*ret_copy = ChannelDetails_get_force_close_spend_delay(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelDetails_set_force_close_spend_delay"))) TS_ChannelDetails_set_force_close_spend_delay(uint32_t this_ptr, uint32_t val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u16Z val_conv = *(LDKCOption_u16Z*)(val_ptr);
	val_conv = COption_u16Z_clone((LDKCOption_u16Z*)(((uintptr_t)val) & ~1));
	ChannelDetails_set_force_close_spend_delay(&this_ptr_conv, val_conv);
}

jboolean  __attribute__((export_name("TS_ChannelDetails_get_is_outbound"))) TS_ChannelDetails_get_is_outbound(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelDetails_get_is_outbound(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_is_outbound"))) TS_ChannelDetails_set_is_outbound(uint32_t this_ptr, jboolean val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_is_outbound(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelDetails_get_is_funding_locked"))) TS_ChannelDetails_get_is_funding_locked(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelDetails_get_is_funding_locked(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_is_funding_locked"))) TS_ChannelDetails_set_is_funding_locked(uint32_t this_ptr, jboolean val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_is_funding_locked(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelDetails_get_is_usable"))) TS_ChannelDetails_get_is_usable(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelDetails_get_is_usable(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_is_usable"))) TS_ChannelDetails_set_is_usable(uint32_t this_ptr, jboolean val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_is_usable(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelDetails_get_is_public"))) TS_ChannelDetails_get_is_public(uint32_t this_ptr) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelDetails_get_is_public(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelDetails_set_is_public"))) TS_ChannelDetails_set_is_public(uint32_t this_ptr, jboolean val) {
	LDKChannelDetails this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelDetails_set_is_public(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_new"))) TS_ChannelDetails_new(int8_tArray channel_id_arg, uint32_t counterparty_arg, uint32_t funding_txo_arg, uint32_t channel_type_arg, uint32_t short_channel_id_arg, uint32_t inbound_scid_alias_arg, int64_t channel_value_satoshis_arg, uint32_t unspendable_punishment_reserve_arg, int64_t user_channel_id_arg, int64_t balance_msat_arg, int64_t outbound_capacity_msat_arg, int64_t inbound_capacity_msat_arg, uint32_t confirmations_required_arg, uint32_t force_close_spend_delay_arg, jboolean is_outbound_arg, jboolean is_funding_locked_arg, jboolean is_usable_arg, jboolean is_public_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKChannelCounterparty counterparty_arg_conv;
	counterparty_arg_conv.inner = (void*)(counterparty_arg & (~1));
	counterparty_arg_conv.is_owned = (counterparty_arg & 1) || (counterparty_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(counterparty_arg_conv);
	counterparty_arg_conv = ChannelCounterparty_clone(&counterparty_arg_conv);
	LDKOutPoint funding_txo_arg_conv;
	funding_txo_arg_conv.inner = (void*)(funding_txo_arg & (~1));
	funding_txo_arg_conv.is_owned = (funding_txo_arg & 1) || (funding_txo_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_txo_arg_conv);
	funding_txo_arg_conv = OutPoint_clone(&funding_txo_arg_conv);
	LDKChannelTypeFeatures channel_type_arg_conv;
	channel_type_arg_conv.inner = (void*)(channel_type_arg & (~1));
	channel_type_arg_conv.is_owned = (channel_type_arg & 1) || (channel_type_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_type_arg_conv);
	channel_type_arg_conv = ChannelTypeFeatures_clone(&channel_type_arg_conv);
	void* short_channel_id_arg_ptr = (void*)(((uintptr_t)short_channel_id_arg) & ~1);
	CHECK_ACCESS(short_channel_id_arg_ptr);
	LDKCOption_u64Z short_channel_id_arg_conv = *(LDKCOption_u64Z*)(short_channel_id_arg_ptr);
	short_channel_id_arg_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)short_channel_id_arg) & ~1));
	void* inbound_scid_alias_arg_ptr = (void*)(((uintptr_t)inbound_scid_alias_arg) & ~1);
	CHECK_ACCESS(inbound_scid_alias_arg_ptr);
	LDKCOption_u64Z inbound_scid_alias_arg_conv = *(LDKCOption_u64Z*)(inbound_scid_alias_arg_ptr);
	inbound_scid_alias_arg_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)inbound_scid_alias_arg) & ~1));
	void* unspendable_punishment_reserve_arg_ptr = (void*)(((uintptr_t)unspendable_punishment_reserve_arg) & ~1);
	CHECK_ACCESS(unspendable_punishment_reserve_arg_ptr);
	LDKCOption_u64Z unspendable_punishment_reserve_arg_conv = *(LDKCOption_u64Z*)(unspendable_punishment_reserve_arg_ptr);
	void* confirmations_required_arg_ptr = (void*)(((uintptr_t)confirmations_required_arg) & ~1);
	CHECK_ACCESS(confirmations_required_arg_ptr);
	LDKCOption_u32Z confirmations_required_arg_conv = *(LDKCOption_u32Z*)(confirmations_required_arg_ptr);
	confirmations_required_arg_conv = COption_u32Z_clone((LDKCOption_u32Z*)(((uintptr_t)confirmations_required_arg) & ~1));
	void* force_close_spend_delay_arg_ptr = (void*)(((uintptr_t)force_close_spend_delay_arg) & ~1);
	CHECK_ACCESS(force_close_spend_delay_arg_ptr);
	LDKCOption_u16Z force_close_spend_delay_arg_conv = *(LDKCOption_u16Z*)(force_close_spend_delay_arg_ptr);
	force_close_spend_delay_arg_conv = COption_u16Z_clone((LDKCOption_u16Z*)(((uintptr_t)force_close_spend_delay_arg) & ~1));
	LDKChannelDetails ret_var = ChannelDetails_new(channel_id_arg_ref, counterparty_arg_conv, funding_txo_arg_conv, channel_type_arg_conv, short_channel_id_arg_conv, inbound_scid_alias_arg_conv, channel_value_satoshis_arg, unspendable_punishment_reserve_arg_conv, user_channel_id_arg, balance_msat_arg, outbound_capacity_msat_arg, inbound_capacity_msat_arg, confirmations_required_arg_conv, force_close_spend_delay_arg_conv, is_outbound_arg, is_funding_locked_arg, is_usable_arg, is_public_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelDetails_clone_ptr(LDKChannelDetails *NONNULL_PTR arg) {
	LDKChannelDetails ret_var = ChannelDetails_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelDetails_clone_ptr"))) TS_ChannelDetails_clone_ptr(uint32_t arg) {
	LDKChannelDetails arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelDetails_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_clone"))) TS_ChannelDetails_clone(uint32_t orig) {
	LDKChannelDetails orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelDetails ret_var = ChannelDetails_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_get_inbound_payment_scid"))) TS_ChannelDetails_get_inbound_payment_scid(uint32_t this_arg) {
	LDKChannelDetails this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = ChannelDetails_get_inbound_payment_scid(&this_arg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_PaymentSendFailure_free"))) TS_PaymentSendFailure_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKPaymentSendFailure this_ptr_conv = *(LDKPaymentSendFailure*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	PaymentSendFailure_free(this_ptr_conv);
}

static inline uintptr_t PaymentSendFailure_clone_ptr(LDKPaymentSendFailure *NONNULL_PTR arg) {
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = PaymentSendFailure_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PaymentSendFailure_clone_ptr"))) TS_PaymentSendFailure_clone_ptr(uint32_t arg) {
	LDKPaymentSendFailure* arg_conv = (LDKPaymentSendFailure*)arg;
	uint32_t ret_val = PaymentSendFailure_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PaymentSendFailure_clone"))) TS_PaymentSendFailure_clone(uint32_t orig) {
	LDKPaymentSendFailure* orig_conv = (LDKPaymentSendFailure*)orig;
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = PaymentSendFailure_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentSendFailure_parameter_error"))) TS_PaymentSendFailure_parameter_error(uint32_t a) {
	void* a_ptr = (void*)(((uintptr_t)a) & ~1);
	CHECK_ACCESS(a_ptr);
	LDKAPIError a_conv = *(LDKAPIError*)(a_ptr);
	a_conv = APIError_clone((LDKAPIError*)(((uintptr_t)a) & ~1));
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = PaymentSendFailure_parameter_error(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentSendFailure_path_parameter_error"))) TS_PaymentSendFailure_path_parameter_error(uint32_tArray a) {
	LDKCVec_CResult_NoneAPIErrorZZ a_constr;
	a_constr.datalen = a->arr_len;
	if (a_constr.datalen > 0)
		a_constr.data = MALLOC(a_constr.datalen * sizeof(LDKCResult_NoneAPIErrorZ), "LDKCVec_CResult_NoneAPIErrorZZ Elements");
	else
		a_constr.data = NULL;
	uint32_t* a_vals = a->elems /* XXX a leaks */;
	for (size_t w = 0; w < a_constr.datalen; w++) {
		uint32_t a_conv_22 = a_vals[w];
		void* a_conv_22_ptr = (void*)(((uintptr_t)a_conv_22) & ~1);
		CHECK_ACCESS(a_conv_22_ptr);
		LDKCResult_NoneAPIErrorZ a_conv_22_conv = *(LDKCResult_NoneAPIErrorZ*)(a_conv_22_ptr);
		a_conv_22_conv = CResult_NoneAPIErrorZ_clone((LDKCResult_NoneAPIErrorZ*)(((uintptr_t)a_conv_22) & ~1));
		a_constr.data[w] = a_conv_22_conv;
	}
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = PaymentSendFailure_path_parameter_error(a_constr);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentSendFailure_all_failed_retry_safe"))) TS_PaymentSendFailure_all_failed_retry_safe(uint32_tArray a) {
	LDKCVec_APIErrorZ a_constr;
	a_constr.datalen = a->arr_len;
	if (a_constr.datalen > 0)
		a_constr.data = MALLOC(a_constr.datalen * sizeof(LDKAPIError), "LDKCVec_APIErrorZ Elements");
	else
		a_constr.data = NULL;
	uint32_t* a_vals = a->elems /* XXX a leaks */;
	for (size_t k = 0; k < a_constr.datalen; k++) {
		uint32_t a_conv_10 = a_vals[k];
		void* a_conv_10_ptr = (void*)(((uintptr_t)a_conv_10) & ~1);
		CHECK_ACCESS(a_conv_10_ptr);
		LDKAPIError a_conv_10_conv = *(LDKAPIError*)(a_conv_10_ptr);
		a_conv_10_conv = APIError_clone((LDKAPIError*)(((uintptr_t)a_conv_10) & ~1));
		a_constr.data[k] = a_conv_10_conv;
	}
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = PaymentSendFailure_all_failed_retry_safe(a_constr);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentSendFailure_partial_failure"))) TS_PaymentSendFailure_partial_failure(uint32_tArray results, uint32_t failed_paths_retry, int8_tArray payment_id) {
	LDKCVec_CResult_NoneAPIErrorZZ results_constr;
	results_constr.datalen = results->arr_len;
	if (results_constr.datalen > 0)
		results_constr.data = MALLOC(results_constr.datalen * sizeof(LDKCResult_NoneAPIErrorZ), "LDKCVec_CResult_NoneAPIErrorZZ Elements");
	else
		results_constr.data = NULL;
	uint32_t* results_vals = results->elems /* XXX results leaks */;
	for (size_t w = 0; w < results_constr.datalen; w++) {
		uint32_t results_conv_22 = results_vals[w];
		void* results_conv_22_ptr = (void*)(((uintptr_t)results_conv_22) & ~1);
		CHECK_ACCESS(results_conv_22_ptr);
		LDKCResult_NoneAPIErrorZ results_conv_22_conv = *(LDKCResult_NoneAPIErrorZ*)(results_conv_22_ptr);
		results_constr.data[w] = results_conv_22_conv;
	}
	LDKRouteParameters failed_paths_retry_conv;
	failed_paths_retry_conv.inner = (void*)(failed_paths_retry & (~1));
	failed_paths_retry_conv.is_owned = (failed_paths_retry & 1) || (failed_paths_retry == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(failed_paths_retry_conv);
	failed_paths_retry_conv = RouteParameters_clone(&failed_paths_retry_conv);
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	LDKPaymentSendFailure *ret_copy = MALLOC(sizeof(LDKPaymentSendFailure), "LDKPaymentSendFailure");
	*ret_copy = PaymentSendFailure_partial_failure(results_constr, failed_paths_retry_conv, payment_id_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_PhantomRouteHints_free"))) TS_PhantomRouteHints_free(uint32_t this_obj) {
	LDKPhantomRouteHints this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	PhantomRouteHints_free(this_obj_conv);
}

uint32_tArray  __attribute__((export_name("TS_PhantomRouteHints_get_channels"))) TS_PhantomRouteHints_get_channels(uint32_t this_ptr) {
	LDKPhantomRouteHints this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_ChannelDetailsZ ret_var = PhantomRouteHints_get_channels(&this_ptr_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t q = 0; q < ret_var.datalen; q++) {
		LDKChannelDetails ret_conv_16_var = ret_var.data[q];
		uint32_t ret_conv_16_ref = 0;
		CHECK((((uintptr_t)ret_conv_16_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_16_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_16_var);
		ret_conv_16_ref = (uintptr_t)ret_conv_16_var.inner;
		if (ret_conv_16_var.is_owned) {
			ret_conv_16_ref |= 1;
		}
		ret_arr_ptr[q] = ret_conv_16_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_PhantomRouteHints_set_channels"))) TS_PhantomRouteHints_set_channels(uint32_t this_ptr, uint32_tArray val) {
	LDKPhantomRouteHints this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_ChannelDetailsZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKChannelDetails), "LDKCVec_ChannelDetailsZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t q = 0; q < val_constr.datalen; q++) {
		uint32_t val_conv_16 = val_vals[q];
		LDKChannelDetails val_conv_16_conv;
		val_conv_16_conv.inner = (void*)(val_conv_16 & (~1));
		val_conv_16_conv.is_owned = (val_conv_16 & 1) || (val_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv_16_conv);
		val_conv_16_conv = ChannelDetails_clone(&val_conv_16_conv);
		val_constr.data[q] = val_conv_16_conv;
	}
	PhantomRouteHints_set_channels(&this_ptr_conv, val_constr);
}

int64_t  __attribute__((export_name("TS_PhantomRouteHints_get_phantom_scid"))) TS_PhantomRouteHints_get_phantom_scid(uint32_t this_ptr) {
	LDKPhantomRouteHints this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = PhantomRouteHints_get_phantom_scid(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_PhantomRouteHints_set_phantom_scid"))) TS_PhantomRouteHints_set_phantom_scid(uint32_t this_ptr, int64_t val) {
	LDKPhantomRouteHints this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	PhantomRouteHints_set_phantom_scid(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_PhantomRouteHints_get_real_node_pubkey"))) TS_PhantomRouteHints_get_real_node_pubkey(uint32_t this_ptr) {
	LDKPhantomRouteHints this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, PhantomRouteHints_get_real_node_pubkey(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_PhantomRouteHints_set_real_node_pubkey"))) TS_PhantomRouteHints_set_real_node_pubkey(uint32_t this_ptr, int8_tArray val) {
	LDKPhantomRouteHints this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	PhantomRouteHints_set_real_node_pubkey(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_PhantomRouteHints_new"))) TS_PhantomRouteHints_new(uint32_tArray channels_arg, int64_t phantom_scid_arg, int8_tArray real_node_pubkey_arg) {
	LDKCVec_ChannelDetailsZ channels_arg_constr;
	channels_arg_constr.datalen = channels_arg->arr_len;
	if (channels_arg_constr.datalen > 0)
		channels_arg_constr.data = MALLOC(channels_arg_constr.datalen * sizeof(LDKChannelDetails), "LDKCVec_ChannelDetailsZ Elements");
	else
		channels_arg_constr.data = NULL;
	uint32_t* channels_arg_vals = channels_arg->elems /* XXX channels_arg leaks */;
	for (size_t q = 0; q < channels_arg_constr.datalen; q++) {
		uint32_t channels_arg_conv_16 = channels_arg_vals[q];
		LDKChannelDetails channels_arg_conv_16_conv;
		channels_arg_conv_16_conv.inner = (void*)(channels_arg_conv_16 & (~1));
		channels_arg_conv_16_conv.is_owned = (channels_arg_conv_16 & 1) || (channels_arg_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(channels_arg_conv_16_conv);
		channels_arg_conv_16_conv = ChannelDetails_clone(&channels_arg_conv_16_conv);
		channels_arg_constr.data[q] = channels_arg_conv_16_conv;
	}
	LDKPublicKey real_node_pubkey_arg_ref;
	CHECK(real_node_pubkey_arg->arr_len == 33);
	memcpy(real_node_pubkey_arg_ref.compressed_form, real_node_pubkey_arg->elems, 33); FREE(real_node_pubkey_arg);
	LDKPhantomRouteHints ret_var = PhantomRouteHints_new(channels_arg_constr, phantom_scid_arg, real_node_pubkey_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t PhantomRouteHints_clone_ptr(LDKPhantomRouteHints *NONNULL_PTR arg) {
	LDKPhantomRouteHints ret_var = PhantomRouteHints_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PhantomRouteHints_clone_ptr"))) TS_PhantomRouteHints_clone_ptr(uint32_t arg) {
	LDKPhantomRouteHints arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = PhantomRouteHints_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PhantomRouteHints_clone"))) TS_PhantomRouteHints_clone(uint32_t orig) {
	LDKPhantomRouteHints orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKPhantomRouteHints ret_var = PhantomRouteHints_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_new"))) TS_ChannelManager_new(uint32_t fee_est, uint32_t chain_monitor, uint32_t tx_broadcaster, uint32_t logger, uint32_t keys_manager, uint32_t config, uint32_t params) {
	void* fee_est_ptr = (void*)(((uintptr_t)fee_est) & ~1);
	CHECK_ACCESS(fee_est_ptr);
	LDKFeeEstimator fee_est_conv = *(LDKFeeEstimator*)(fee_est_ptr);
	if (fee_est_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&fee_est_conv);
	}
	void* chain_monitor_ptr = (void*)(((uintptr_t)chain_monitor) & ~1);
	CHECK_ACCESS(chain_monitor_ptr);
	LDKWatch chain_monitor_conv = *(LDKWatch*)(chain_monitor_ptr);
	if (chain_monitor_conv.free == LDKWatch_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKWatch_JCalls_cloned(&chain_monitor_conv);
	}
	void* tx_broadcaster_ptr = (void*)(((uintptr_t)tx_broadcaster) & ~1);
	CHECK_ACCESS(tx_broadcaster_ptr);
	LDKBroadcasterInterface tx_broadcaster_conv = *(LDKBroadcasterInterface*)(tx_broadcaster_ptr);
	if (tx_broadcaster_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&tx_broadcaster_conv);
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	void* keys_manager_ptr = (void*)(((uintptr_t)keys_manager) & ~1);
	CHECK_ACCESS(keys_manager_ptr);
	LDKKeysInterface keys_manager_conv = *(LDKKeysInterface*)(keys_manager_ptr);
	if (keys_manager_conv.free == LDKKeysInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKKeysInterface_JCalls_cloned(&keys_manager_conv);
	}
	LDKUserConfig config_conv;
	config_conv.inner = (void*)(config & (~1));
	config_conv.is_owned = (config & 1) || (config == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(config_conv);
	config_conv = UserConfig_clone(&config_conv);
	LDKChainParameters params_conv;
	params_conv.inner = (void*)(params & (~1));
	params_conv.is_owned = (params & 1) || (params == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(params_conv);
	params_conv = ChainParameters_clone(&params_conv);
	LDKChannelManager ret_var = ChannelManager_new(fee_est_conv, chain_monitor_conv, tx_broadcaster_conv, logger_conv, keys_manager_conv, config_conv, params_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_get_current_default_configuration"))) TS_ChannelManager_get_current_default_configuration(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKUserConfig ret_var = ChannelManager_get_current_default_configuration(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_create_channel"))) TS_ChannelManager_create_channel(uint32_t this_arg, int8_tArray their_network_key, int64_t channel_value_satoshis, int64_t push_msat, int64_t user_channel_id, uint32_t override_config) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPublicKey their_network_key_ref;
	CHECK(their_network_key->arr_len == 33);
	memcpy(their_network_key_ref.compressed_form, their_network_key->elems, 33); FREE(their_network_key);
	LDKUserConfig override_config_conv;
	override_config_conv.inner = (void*)(override_config & (~1));
	override_config_conv.is_owned = (override_config & 1) || (override_config == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(override_config_conv);
	override_config_conv = UserConfig_clone(&override_config_conv);
	LDKCResult__u832APIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult__u832APIErrorZ), "LDKCResult__u832APIErrorZ");
	*ret_conv = ChannelManager_create_channel(&this_arg_conv, their_network_key_ref, channel_value_satoshis, push_msat, user_channel_id, override_config_conv);
	return (uint32_t)ret_conv;
}

uint32_tArray  __attribute__((export_name("TS_ChannelManager_list_channels"))) TS_ChannelManager_list_channels(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_ChannelDetailsZ ret_var = ChannelManager_list_channels(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t q = 0; q < ret_var.datalen; q++) {
		LDKChannelDetails ret_conv_16_var = ret_var.data[q];
		uint32_t ret_conv_16_ref = 0;
		CHECK((((uintptr_t)ret_conv_16_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_16_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_16_var);
		ret_conv_16_ref = (uintptr_t)ret_conv_16_var.inner;
		if (ret_conv_16_var.is_owned) {
			ret_conv_16_ref |= 1;
		}
		ret_arr_ptr[q] = ret_conv_16_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_tArray  __attribute__((export_name("TS_ChannelManager_list_usable_channels"))) TS_ChannelManager_list_usable_channels(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_ChannelDetailsZ ret_var = ChannelManager_list_usable_channels(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t q = 0; q < ret_var.datalen; q++) {
		LDKChannelDetails ret_conv_16_var = ret_var.data[q];
		uint32_t ret_conv_16_ref = 0;
		CHECK((((uintptr_t)ret_conv_16_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_16_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_16_var);
		ret_conv_16_ref = (uintptr_t)ret_conv_16_var.inner;
		if (ret_conv_16_var.is_owned) {
			ret_conv_16_ref |= 1;
		}
		ret_arr_ptr[q] = ret_conv_16_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_close_channel"))) TS_ChannelManager_close_channel(uint32_t this_arg, int8_tArray channel_id) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char channel_id_arr[32];
	CHECK(channel_id->arr_len == 32);
	memcpy(channel_id_arr, channel_id->elems, 32); FREE(channel_id);
	unsigned char (*channel_id_ref)[32] = &channel_id_arr;
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = ChannelManager_close_channel(&this_arg_conv, channel_id_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_close_channel_with_target_feerate"))) TS_ChannelManager_close_channel_with_target_feerate(uint32_t this_arg, int8_tArray channel_id, int32_t target_feerate_sats_per_1000_weight) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char channel_id_arr[32];
	CHECK(channel_id->arr_len == 32);
	memcpy(channel_id_arr, channel_id->elems, 32); FREE(channel_id);
	unsigned char (*channel_id_ref)[32] = &channel_id_arr;
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = ChannelManager_close_channel_with_target_feerate(&this_arg_conv, channel_id_ref, target_feerate_sats_per_1000_weight);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_force_close_channel"))) TS_ChannelManager_force_close_channel(uint32_t this_arg, int8_tArray channel_id) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char channel_id_arr[32];
	CHECK(channel_id->arr_len == 32);
	memcpy(channel_id_arr, channel_id->elems, 32); FREE(channel_id);
	unsigned char (*channel_id_ref)[32] = &channel_id_arr;
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = ChannelManager_force_close_channel(&this_arg_conv, channel_id_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_ChannelManager_force_close_all_channels"))) TS_ChannelManager_force_close_all_channels(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	ChannelManager_force_close_all_channels(&this_arg_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManager_send_payment"))) TS_ChannelManager_send_payment(uint32_t this_arg, uint32_t route, int8_tArray payment_hash, int8_tArray payment_secret) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKRoute route_conv;
	route_conv.inner = (void*)(route & (~1));
	route_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_conv);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	LDKThirtyTwoBytes payment_secret_ref;
	CHECK(payment_secret->arr_len == 32);
	memcpy(payment_secret_ref.data, payment_secret->elems, 32); FREE(payment_secret);
	LDKCResult_PaymentIdPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentSendFailureZ), "LDKCResult_PaymentIdPaymentSendFailureZ");
	*ret_conv = ChannelManager_send_payment(&this_arg_conv, &route_conv, payment_hash_ref, payment_secret_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_retry_payment"))) TS_ChannelManager_retry_payment(uint32_t this_arg, uint32_t route, int8_tArray payment_id) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKRoute route_conv;
	route_conv.inner = (void*)(route & (~1));
	route_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_conv);
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	LDKCResult_NonePaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePaymentSendFailureZ), "LDKCResult_NonePaymentSendFailureZ");
	*ret_conv = ChannelManager_retry_payment(&this_arg_conv, &route_conv, payment_id_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_ChannelManager_abandon_payment"))) TS_ChannelManager_abandon_payment(uint32_t this_arg, int8_tArray payment_id) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKThirtyTwoBytes payment_id_ref;
	CHECK(payment_id->arr_len == 32);
	memcpy(payment_id_ref.data, payment_id->elems, 32); FREE(payment_id);
	ChannelManager_abandon_payment(&this_arg_conv, payment_id_ref);
}

uint32_t  __attribute__((export_name("TS_ChannelManager_send_spontaneous_payment"))) TS_ChannelManager_send_spontaneous_payment(uint32_t this_arg, uint32_t route, int8_tArray payment_preimage) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKRoute route_conv;
	route_conv.inner = (void*)(route & (~1));
	route_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_conv);
	LDKThirtyTwoBytes payment_preimage_ref;
	CHECK(payment_preimage->arr_len == 32);
	memcpy(payment_preimage_ref.data, payment_preimage->elems, 32); FREE(payment_preimage);
	LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ), "LDKCResult_C2Tuple_PaymentHashPaymentIdZPaymentSendFailureZ");
	*ret_conv = ChannelManager_send_spontaneous_payment(&this_arg_conv, &route_conv, payment_preimage_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_funding_transaction_generated"))) TS_ChannelManager_funding_transaction_generated(uint32_t this_arg, int8_tArray temporary_channel_id, int8_tArray funding_transaction) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char temporary_channel_id_arr[32];
	CHECK(temporary_channel_id->arr_len == 32);
	memcpy(temporary_channel_id_arr, temporary_channel_id->elems, 32); FREE(temporary_channel_id);
	unsigned char (*temporary_channel_id_ref)[32] = &temporary_channel_id_arr;
	LDKTransaction funding_transaction_ref;
	funding_transaction_ref.datalen = funding_transaction->arr_len;
	funding_transaction_ref.data = MALLOC(funding_transaction_ref.datalen, "LDKTransaction Bytes");
	memcpy(funding_transaction_ref.data, funding_transaction->elems, funding_transaction_ref.datalen); FREE(funding_transaction);
	funding_transaction_ref.data_is_owned = true;
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = ChannelManager_funding_transaction_generated(&this_arg_conv, temporary_channel_id_ref, funding_transaction_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_ChannelManager_broadcast_node_announcement"))) TS_ChannelManager_broadcast_node_announcement(uint32_t this_arg, int8_tArray rgb, int8_tArray alias, uint32_tArray addresses) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKThreeBytes rgb_ref;
	CHECK(rgb->arr_len == 3);
	memcpy(rgb_ref.data, rgb->elems, 3); FREE(rgb);
	LDKThirtyTwoBytes alias_ref;
	CHECK(alias->arr_len == 32);
	memcpy(alias_ref.data, alias->elems, 32); FREE(alias);
	LDKCVec_NetAddressZ addresses_constr;
	addresses_constr.datalen = addresses->arr_len;
	if (addresses_constr.datalen > 0)
		addresses_constr.data = MALLOC(addresses_constr.datalen * sizeof(LDKNetAddress), "LDKCVec_NetAddressZ Elements");
	else
		addresses_constr.data = NULL;
	uint32_t* addresses_vals = addresses->elems /* XXX addresses leaks */;
	for (size_t m = 0; m < addresses_constr.datalen; m++) {
		uint32_t addresses_conv_12 = addresses_vals[m];
		void* addresses_conv_12_ptr = (void*)(((uintptr_t)addresses_conv_12) & ~1);
		CHECK_ACCESS(addresses_conv_12_ptr);
		LDKNetAddress addresses_conv_12_conv = *(LDKNetAddress*)(addresses_conv_12_ptr);
		addresses_constr.data[m] = addresses_conv_12_conv;
	}
	ChannelManager_broadcast_node_announcement(&this_arg_conv, rgb_ref, alias_ref, addresses_constr);
}

void  __attribute__((export_name("TS_ChannelManager_process_pending_htlc_forwards"))) TS_ChannelManager_process_pending_htlc_forwards(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	ChannelManager_process_pending_htlc_forwards(&this_arg_conv);
}

void  __attribute__((export_name("TS_ChannelManager_timer_tick_occurred"))) TS_ChannelManager_timer_tick_occurred(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	ChannelManager_timer_tick_occurred(&this_arg_conv);
}

jboolean  __attribute__((export_name("TS_ChannelManager_fail_htlc_backwards"))) TS_ChannelManager_fail_htlc_backwards(uint32_t this_arg, int8_tArray payment_hash) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char payment_hash_arr[32];
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_arr, payment_hash->elems, 32); FREE(payment_hash);
	unsigned char (*payment_hash_ref)[32] = &payment_hash_arr;
	jboolean ret_val = ChannelManager_fail_htlc_backwards(&this_arg_conv, payment_hash_ref);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_ChannelManager_claim_funds"))) TS_ChannelManager_claim_funds(uint32_t this_arg, int8_tArray payment_preimage) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKThirtyTwoBytes payment_preimage_ref;
	CHECK(payment_preimage->arr_len == 32);
	memcpy(payment_preimage_ref.data, payment_preimage->elems, 32); FREE(payment_preimage);
	jboolean ret_val = ChannelManager_claim_funds(&this_arg_conv, payment_preimage_ref);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_ChannelManager_get_our_node_id"))) TS_ChannelManager_get_our_node_id(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, ChannelManager_get_our_node_id(&this_arg_conv).compressed_form, 33);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_accept_inbound_channel"))) TS_ChannelManager_accept_inbound_channel(uint32_t this_arg, int8_tArray temporary_channel_id, int64_t user_channel_id) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char temporary_channel_id_arr[32];
	CHECK(temporary_channel_id->arr_len == 32);
	memcpy(temporary_channel_id_arr, temporary_channel_id->elems, 32); FREE(temporary_channel_id);
	unsigned char (*temporary_channel_id_ref)[32] = &temporary_channel_id_arr;
	LDKCResult_NoneAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneAPIErrorZ), "LDKCResult_NoneAPIErrorZ");
	*ret_conv = ChannelManager_accept_inbound_channel(&this_arg_conv, temporary_channel_id_ref, user_channel_id);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_create_inbound_payment"))) TS_ChannelManager_create_inbound_payment(uint32_t this_arg, uint32_t min_value_msat, int32_t invoice_expiry_delta_secs) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* min_value_msat_ptr = (void*)(((uintptr_t)min_value_msat) & ~1);
	CHECK_ACCESS(min_value_msat_ptr);
	LDKCOption_u64Z min_value_msat_conv = *(LDKCOption_u64Z*)(min_value_msat_ptr);
	min_value_msat_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)min_value_msat) & ~1));
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZNoneZ");
	*ret_conv = ChannelManager_create_inbound_payment(&this_arg_conv, min_value_msat_conv, invoice_expiry_delta_secs);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_create_inbound_payment_legacy"))) TS_ChannelManager_create_inbound_payment_legacy(uint32_t this_arg, uint32_t min_value_msat, int32_t invoice_expiry_delta_secs) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* min_value_msat_ptr = (void*)(((uintptr_t)min_value_msat) & ~1);
	CHECK_ACCESS(min_value_msat_ptr);
	LDKCOption_u64Z min_value_msat_conv = *(LDKCOption_u64Z*)(min_value_msat_ptr);
	min_value_msat_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)min_value_msat) & ~1));
	LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ), "LDKCResult_C2Tuple_PaymentHashPaymentSecretZAPIErrorZ");
	*ret_conv = ChannelManager_create_inbound_payment_legacy(&this_arg_conv, min_value_msat_conv, invoice_expiry_delta_secs);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_create_inbound_payment_for_hash"))) TS_ChannelManager_create_inbound_payment_for_hash(uint32_t this_arg, int8_tArray payment_hash, uint32_t min_value_msat, int32_t invoice_expiry_delta_secs) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	void* min_value_msat_ptr = (void*)(((uintptr_t)min_value_msat) & ~1);
	CHECK_ACCESS(min_value_msat_ptr);
	LDKCOption_u64Z min_value_msat_conv = *(LDKCOption_u64Z*)(min_value_msat_ptr);
	min_value_msat_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)min_value_msat) & ~1));
	LDKCResult_PaymentSecretNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretNoneZ), "LDKCResult_PaymentSecretNoneZ");
	*ret_conv = ChannelManager_create_inbound_payment_for_hash(&this_arg_conv, payment_hash_ref, min_value_msat_conv, invoice_expiry_delta_secs);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_create_inbound_payment_for_hash_legacy"))) TS_ChannelManager_create_inbound_payment_for_hash_legacy(uint32_t this_arg, int8_tArray payment_hash, uint32_t min_value_msat, int32_t invoice_expiry_delta_secs) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	void* min_value_msat_ptr = (void*)(((uintptr_t)min_value_msat) & ~1);
	CHECK_ACCESS(min_value_msat_ptr);
	LDKCOption_u64Z min_value_msat_conv = *(LDKCOption_u64Z*)(min_value_msat_ptr);
	min_value_msat_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)min_value_msat) & ~1));
	LDKCResult_PaymentSecretAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentSecretAPIErrorZ), "LDKCResult_PaymentSecretAPIErrorZ");
	*ret_conv = ChannelManager_create_inbound_payment_for_hash_legacy(&this_arg_conv, payment_hash_ref, min_value_msat_conv, invoice_expiry_delta_secs);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_get_payment_preimage"))) TS_ChannelManager_get_payment_preimage(uint32_t this_arg, int8_tArray payment_hash, int8_tArray payment_secret) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKThirtyTwoBytes payment_hash_ref;
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_ref.data, payment_hash->elems, 32); FREE(payment_hash);
	LDKThirtyTwoBytes payment_secret_ref;
	CHECK(payment_secret->arr_len == 32);
	memcpy(payment_secret_ref.data, payment_secret->elems, 32); FREE(payment_secret);
	LDKCResult_PaymentPreimageAPIErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentPreimageAPIErrorZ), "LDKCResult_PaymentPreimageAPIErrorZ");
	*ret_conv = ChannelManager_get_payment_preimage(&this_arg_conv, payment_hash_ref, payment_secret_ref);
	return (uint32_t)ret_conv;
}

int64_t  __attribute__((export_name("TS_ChannelManager_get_phantom_scid"))) TS_ChannelManager_get_phantom_scid(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = ChannelManager_get_phantom_scid(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_get_phantom_route_hints"))) TS_ChannelManager_get_phantom_route_hints(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPhantomRouteHints ret_var = ChannelManager_get_phantom_route_hints(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_as_MessageSendEventsProvider"))) TS_ChannelManager_as_MessageSendEventsProvider(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKMessageSendEventsProvider* ret_ret = MALLOC(sizeof(LDKMessageSendEventsProvider), "LDKMessageSendEventsProvider");
	*ret_ret = ChannelManager_as_MessageSendEventsProvider(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_as_EventsProvider"))) TS_ChannelManager_as_EventsProvider(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKEventsProvider* ret_ret = MALLOC(sizeof(LDKEventsProvider), "LDKEventsProvider");
	*ret_ret = ChannelManager_as_EventsProvider(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_as_Listen"))) TS_ChannelManager_as_Listen(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKListen* ret_ret = MALLOC(sizeof(LDKListen), "LDKListen");
	*ret_ret = ChannelManager_as_Listen(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_as_Confirm"))) TS_ChannelManager_as_Confirm(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKConfirm* ret_ret = MALLOC(sizeof(LDKConfirm), "LDKConfirm");
	*ret_ret = ChannelManager_as_Confirm(&this_arg_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_ChannelManager_await_persistable_update"))) TS_ChannelManager_await_persistable_update(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	ChannelManager_await_persistable_update(&this_arg_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManager_current_best_block"))) TS_ChannelManager_current_best_block(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKBestBlock ret_var = ChannelManager_current_best_block(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_as_ChannelMessageHandler"))) TS_ChannelManager_as_ChannelMessageHandler(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelMessageHandler* ret_ret = MALLOC(sizeof(LDKChannelMessageHandler), "LDKChannelMessageHandler");
	*ret_ret = ChannelManager_as_ChannelMessageHandler(&this_arg_conv);
	return (uint32_t)ret_ret;
}

int8_tArray  __attribute__((export_name("TS_CounterpartyForwardingInfo_write"))) TS_CounterpartyForwardingInfo_write(uint32_t obj) {
	LDKCounterpartyForwardingInfo obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = CounterpartyForwardingInfo_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_CounterpartyForwardingInfo_read"))) TS_CounterpartyForwardingInfo_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_CounterpartyForwardingInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyForwardingInfoDecodeErrorZ), "LDKCResult_CounterpartyForwardingInfoDecodeErrorZ");
	*ret_conv = CounterpartyForwardingInfo_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelCounterparty_write"))) TS_ChannelCounterparty_write(uint32_t obj) {
	LDKChannelCounterparty obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelCounterparty_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelCounterparty_read"))) TS_ChannelCounterparty_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelCounterpartyDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelCounterpartyDecodeErrorZ), "LDKCResult_ChannelCounterpartyDecodeErrorZ");
	*ret_conv = ChannelCounterparty_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelDetails_write"))) TS_ChannelDetails_write(uint32_t obj) {
	LDKChannelDetails obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelDetails_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelDetails_read"))) TS_ChannelDetails_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelDetailsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelDetailsDecodeErrorZ), "LDKCResult_ChannelDetailsDecodeErrorZ");
	*ret_conv = ChannelDetails_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_PhantomRouteHints_write"))) TS_PhantomRouteHints_write(uint32_t obj) {
	LDKPhantomRouteHints obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = PhantomRouteHints_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_PhantomRouteHints_read"))) TS_PhantomRouteHints_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_PhantomRouteHintsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PhantomRouteHintsDecodeErrorZ), "LDKCResult_PhantomRouteHintsDecodeErrorZ");
	*ret_conv = PhantomRouteHints_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelManager_write"))) TS_ChannelManager_write(uint32_t obj) {
	LDKChannelManager obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelManager_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelManagerReadArgs_free"))) TS_ChannelManagerReadArgs_free(uint32_t this_obj) {
	LDKChannelManagerReadArgs this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelManagerReadArgs_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManagerReadArgs_get_keys_manager"))) TS_ChannelManagerReadArgs_get_keys_manager(uint32_t this_ptr) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	// WARNING: This object doesn't live past this scope, needs clone!
	uint32_t ret_ret = ((uintptr_t)ChannelManagerReadArgs_get_keys_manager(&this_ptr_conv)) | 1;
	return ret_ret;
}

void  __attribute__((export_name("TS_ChannelManagerReadArgs_set_keys_manager"))) TS_ChannelManagerReadArgs_set_keys_manager(uint32_t this_ptr, uint32_t val) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKKeysInterface val_conv = *(LDKKeysInterface*)(val_ptr);
	if (val_conv.free == LDKKeysInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKKeysInterface_JCalls_cloned(&val_conv);
	}
	ChannelManagerReadArgs_set_keys_manager(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManagerReadArgs_get_fee_estimator"))) TS_ChannelManagerReadArgs_get_fee_estimator(uint32_t this_ptr) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	// WARNING: This object doesn't live past this scope, needs clone!
	uint32_t ret_ret = ((uintptr_t)ChannelManagerReadArgs_get_fee_estimator(&this_ptr_conv)) | 1;
	return ret_ret;
}

void  __attribute__((export_name("TS_ChannelManagerReadArgs_set_fee_estimator"))) TS_ChannelManagerReadArgs_set_fee_estimator(uint32_t this_ptr, uint32_t val) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKFeeEstimator val_conv = *(LDKFeeEstimator*)(val_ptr);
	if (val_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&val_conv);
	}
	ChannelManagerReadArgs_set_fee_estimator(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManagerReadArgs_get_chain_monitor"))) TS_ChannelManagerReadArgs_get_chain_monitor(uint32_t this_ptr) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	// WARNING: This object doesn't live past this scope, needs clone!
	uint32_t ret_ret = ((uintptr_t)ChannelManagerReadArgs_get_chain_monitor(&this_ptr_conv)) | 1;
	return ret_ret;
}

void  __attribute__((export_name("TS_ChannelManagerReadArgs_set_chain_monitor"))) TS_ChannelManagerReadArgs_set_chain_monitor(uint32_t this_ptr, uint32_t val) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKWatch val_conv = *(LDKWatch*)(val_ptr);
	if (val_conv.free == LDKWatch_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKWatch_JCalls_cloned(&val_conv);
	}
	ChannelManagerReadArgs_set_chain_monitor(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManagerReadArgs_get_tx_broadcaster"))) TS_ChannelManagerReadArgs_get_tx_broadcaster(uint32_t this_ptr) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	// WARNING: This object doesn't live past this scope, needs clone!
	uint32_t ret_ret = ((uintptr_t)ChannelManagerReadArgs_get_tx_broadcaster(&this_ptr_conv)) | 1;
	return ret_ret;
}

void  __attribute__((export_name("TS_ChannelManagerReadArgs_set_tx_broadcaster"))) TS_ChannelManagerReadArgs_set_tx_broadcaster(uint32_t this_ptr, uint32_t val) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKBroadcasterInterface val_conv = *(LDKBroadcasterInterface*)(val_ptr);
	if (val_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&val_conv);
	}
	ChannelManagerReadArgs_set_tx_broadcaster(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManagerReadArgs_get_logger"))) TS_ChannelManagerReadArgs_get_logger(uint32_t this_ptr) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	// WARNING: This object doesn't live past this scope, needs clone!
	uint32_t ret_ret = ((uintptr_t)ChannelManagerReadArgs_get_logger(&this_ptr_conv)) | 1;
	return ret_ret;
}

void  __attribute__((export_name("TS_ChannelManagerReadArgs_set_logger"))) TS_ChannelManagerReadArgs_set_logger(uint32_t this_ptr, uint32_t val) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKLogger val_conv = *(LDKLogger*)(val_ptr);
	if (val_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&val_conv);
	}
	ChannelManagerReadArgs_set_logger(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManagerReadArgs_get_default_config"))) TS_ChannelManagerReadArgs_get_default_config(uint32_t this_ptr) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUserConfig ret_var = ChannelManagerReadArgs_get_default_config(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelManagerReadArgs_set_default_config"))) TS_ChannelManagerReadArgs_set_default_config(uint32_t this_ptr, uint32_t val) {
	LDKChannelManagerReadArgs this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUserConfig val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = UserConfig_clone(&val_conv);
	ChannelManagerReadArgs_set_default_config(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelManagerReadArgs_new"))) TS_ChannelManagerReadArgs_new(uint32_t keys_manager, uint32_t fee_estimator, uint32_t chain_monitor, uint32_t tx_broadcaster, uint32_t logger, uint32_t default_config, uint32_tArray channel_monitors) {
	void* keys_manager_ptr = (void*)(((uintptr_t)keys_manager) & ~1);
	CHECK_ACCESS(keys_manager_ptr);
	LDKKeysInterface keys_manager_conv = *(LDKKeysInterface*)(keys_manager_ptr);
	if (keys_manager_conv.free == LDKKeysInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKKeysInterface_JCalls_cloned(&keys_manager_conv);
	}
	void* fee_estimator_ptr = (void*)(((uintptr_t)fee_estimator) & ~1);
	CHECK_ACCESS(fee_estimator_ptr);
	LDKFeeEstimator fee_estimator_conv = *(LDKFeeEstimator*)(fee_estimator_ptr);
	if (fee_estimator_conv.free == LDKFeeEstimator_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKFeeEstimator_JCalls_cloned(&fee_estimator_conv);
	}
	void* chain_monitor_ptr = (void*)(((uintptr_t)chain_monitor) & ~1);
	CHECK_ACCESS(chain_monitor_ptr);
	LDKWatch chain_monitor_conv = *(LDKWatch*)(chain_monitor_ptr);
	if (chain_monitor_conv.free == LDKWatch_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKWatch_JCalls_cloned(&chain_monitor_conv);
	}
	void* tx_broadcaster_ptr = (void*)(((uintptr_t)tx_broadcaster) & ~1);
	CHECK_ACCESS(tx_broadcaster_ptr);
	LDKBroadcasterInterface tx_broadcaster_conv = *(LDKBroadcasterInterface*)(tx_broadcaster_ptr);
	if (tx_broadcaster_conv.free == LDKBroadcasterInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKBroadcasterInterface_JCalls_cloned(&tx_broadcaster_conv);
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	LDKUserConfig default_config_conv;
	default_config_conv.inner = (void*)(default_config & (~1));
	default_config_conv.is_owned = (default_config & 1) || (default_config == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(default_config_conv);
	default_config_conv = UserConfig_clone(&default_config_conv);
	LDKCVec_ChannelMonitorZ channel_monitors_constr;
	channel_monitors_constr.datalen = channel_monitors->arr_len;
	if (channel_monitors_constr.datalen > 0)
		channel_monitors_constr.data = MALLOC(channel_monitors_constr.datalen * sizeof(LDKChannelMonitor), "LDKCVec_ChannelMonitorZ Elements");
	else
		channel_monitors_constr.data = NULL;
	uint32_t* channel_monitors_vals = channel_monitors->elems /* XXX channel_monitors leaks */;
	for (size_t q = 0; q < channel_monitors_constr.datalen; q++) {
		uint32_t channel_monitors_conv_16 = channel_monitors_vals[q];
		LDKChannelMonitor channel_monitors_conv_16_conv;
		channel_monitors_conv_16_conv.inner = (void*)(channel_monitors_conv_16 & (~1));
		channel_monitors_conv_16_conv.is_owned = (channel_monitors_conv_16 & 1) || (channel_monitors_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_monitors_conv_16_conv);
		channel_monitors_constr.data[q] = channel_monitors_conv_16_conv;
	}
	LDKChannelManagerReadArgs ret_var = ChannelManagerReadArgs_new(keys_manager_conv, fee_estimator_conv, chain_monitor_conv, tx_broadcaster_conv, logger_conv, default_config_conv, channel_monitors_constr);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_C2Tuple_BlockHashChannelManagerZ_read"))) TS_C2Tuple_BlockHashChannelManagerZ_read(int8_tArray ser, uint32_t arg) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKChannelManagerReadArgs arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = (arg & 1) || (arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	// WARNING: we need a move here but no clone is available for LDKChannelManagerReadArgs
	LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ), "LDKCResult_C2Tuple_BlockHashChannelManagerZDecodeErrorZ");
	*ret_conv = C2Tuple_BlockHashChannelManagerZ_read(ser_ref, arg_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_DecodeError_free"))) TS_DecodeError_free(uint32_t this_obj) {
	LDKDecodeError this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	DecodeError_free(this_obj_conv);
}

static inline uintptr_t DecodeError_clone_ptr(LDKDecodeError *NONNULL_PTR arg) {
	LDKDecodeError ret_var = DecodeError_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_DecodeError_clone_ptr"))) TS_DecodeError_clone_ptr(uint32_t arg) {
	LDKDecodeError arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = DecodeError_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_DecodeError_clone"))) TS_DecodeError_clone(uint32_t orig) {
	LDKDecodeError orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKDecodeError ret_var = DecodeError_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_Init_free"))) TS_Init_free(uint32_t this_obj) {
	LDKInit this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Init_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_Init_get_features"))) TS_Init_get_features(uint32_t this_ptr) {
	LDKInit this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKInitFeatures ret_var = Init_get_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_Init_set_features"))) TS_Init_set_features(uint32_t this_ptr, uint32_t val) {
	LDKInit this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKInitFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = InitFeatures_clone(&val_conv);
	Init_set_features(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_Init_get_remote_network_address"))) TS_Init_get_remote_network_address(uint32_t this_ptr) {
	LDKInit this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_NetAddressZ *ret_copy = MALLOC(sizeof(LDKCOption_NetAddressZ), "LDKCOption_NetAddressZ");
	*ret_copy = Init_get_remote_network_address(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_Init_set_remote_network_address"))) TS_Init_set_remote_network_address(uint32_t this_ptr, uint32_t val) {
	LDKInit this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_NetAddressZ val_conv = *(LDKCOption_NetAddressZ*)(val_ptr);
	val_conv = COption_NetAddressZ_clone((LDKCOption_NetAddressZ*)(((uintptr_t)val) & ~1));
	Init_set_remote_network_address(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_Init_new"))) TS_Init_new(uint32_t features_arg, uint32_t remote_network_address_arg) {
	LDKInitFeatures features_arg_conv;
	features_arg_conv.inner = (void*)(features_arg & (~1));
	features_arg_conv.is_owned = (features_arg & 1) || (features_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(features_arg_conv);
	features_arg_conv = InitFeatures_clone(&features_arg_conv);
	void* remote_network_address_arg_ptr = (void*)(((uintptr_t)remote_network_address_arg) & ~1);
	CHECK_ACCESS(remote_network_address_arg_ptr);
	LDKCOption_NetAddressZ remote_network_address_arg_conv = *(LDKCOption_NetAddressZ*)(remote_network_address_arg_ptr);
	LDKInit ret_var = Init_new(features_arg_conv, remote_network_address_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t Init_clone_ptr(LDKInit *NONNULL_PTR arg) {
	LDKInit ret_var = Init_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Init_clone_ptr"))) TS_Init_clone_ptr(uint32_t arg) {
	LDKInit arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Init_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Init_clone"))) TS_Init_clone(uint32_t orig) {
	LDKInit orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKInit ret_var = Init_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ErrorMessage_free"))) TS_ErrorMessage_free(uint32_t this_obj) {
	LDKErrorMessage this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ErrorMessage_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ErrorMessage_get_channel_id"))) TS_ErrorMessage_get_channel_id(uint32_t this_ptr) {
	LDKErrorMessage this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *ErrorMessage_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_ErrorMessage_set_channel_id"))) TS_ErrorMessage_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKErrorMessage this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	ErrorMessage_set_channel_id(&this_ptr_conv, val_ref);
}

jstring  __attribute__((export_name("TS_ErrorMessage_get_data"))) TS_ErrorMessage_get_data(uint32_t this_ptr) {
	LDKErrorMessage this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr ret_str = ErrorMessage_get_data(&this_ptr_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

void  __attribute__((export_name("TS_ErrorMessage_set_data"))) TS_ErrorMessage_set_data(uint32_t this_ptr, jstring val) {
	LDKErrorMessage this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr val_conv = str_ref_to_owned_c(val);
	ErrorMessage_set_data(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ErrorMessage_new"))) TS_ErrorMessage_new(int8_tArray channel_id_arg, jstring data_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKStr data_arg_conv = str_ref_to_owned_c(data_arg);
	LDKErrorMessage ret_var = ErrorMessage_new(channel_id_arg_ref, data_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ErrorMessage_clone_ptr(LDKErrorMessage *NONNULL_PTR arg) {
	LDKErrorMessage ret_var = ErrorMessage_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ErrorMessage_clone_ptr"))) TS_ErrorMessage_clone_ptr(uint32_t arg) {
	LDKErrorMessage arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ErrorMessage_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ErrorMessage_clone"))) TS_ErrorMessage_clone(uint32_t orig) {
	LDKErrorMessage orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKErrorMessage ret_var = ErrorMessage_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_WarningMessage_free"))) TS_WarningMessage_free(uint32_t this_obj) {
	LDKWarningMessage this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	WarningMessage_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_WarningMessage_get_channel_id"))) TS_WarningMessage_get_channel_id(uint32_t this_ptr) {
	LDKWarningMessage this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *WarningMessage_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_WarningMessage_set_channel_id"))) TS_WarningMessage_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKWarningMessage this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	WarningMessage_set_channel_id(&this_ptr_conv, val_ref);
}

jstring  __attribute__((export_name("TS_WarningMessage_get_data"))) TS_WarningMessage_get_data(uint32_t this_ptr) {
	LDKWarningMessage this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr ret_str = WarningMessage_get_data(&this_ptr_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

void  __attribute__((export_name("TS_WarningMessage_set_data"))) TS_WarningMessage_set_data(uint32_t this_ptr, jstring val) {
	LDKWarningMessage this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr val_conv = str_ref_to_owned_c(val);
	WarningMessage_set_data(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_WarningMessage_new"))) TS_WarningMessage_new(int8_tArray channel_id_arg, jstring data_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKStr data_arg_conv = str_ref_to_owned_c(data_arg);
	LDKWarningMessage ret_var = WarningMessage_new(channel_id_arg_ref, data_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t WarningMessage_clone_ptr(LDKWarningMessage *NONNULL_PTR arg) {
	LDKWarningMessage ret_var = WarningMessage_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_WarningMessage_clone_ptr"))) TS_WarningMessage_clone_ptr(uint32_t arg) {
	LDKWarningMessage arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = WarningMessage_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_WarningMessage_clone"))) TS_WarningMessage_clone(uint32_t orig) {
	LDKWarningMessage orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKWarningMessage ret_var = WarningMessage_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_Ping_free"))) TS_Ping_free(uint32_t this_obj) {
	LDKPing this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Ping_free(this_obj_conv);
}

int16_t  __attribute__((export_name("TS_Ping_get_ponglen"))) TS_Ping_get_ponglen(uint32_t this_ptr) {
	LDKPing this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = Ping_get_ponglen(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Ping_set_ponglen"))) TS_Ping_set_ponglen(uint32_t this_ptr, int16_t val) {
	LDKPing this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	Ping_set_ponglen(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_Ping_get_byteslen"))) TS_Ping_get_byteslen(uint32_t this_ptr) {
	LDKPing this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = Ping_get_byteslen(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Ping_set_byteslen"))) TS_Ping_set_byteslen(uint32_t this_ptr, int16_t val) {
	LDKPing this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	Ping_set_byteslen(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_Ping_new"))) TS_Ping_new(int16_t ponglen_arg, int16_t byteslen_arg) {
	LDKPing ret_var = Ping_new(ponglen_arg, byteslen_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t Ping_clone_ptr(LDKPing *NONNULL_PTR arg) {
	LDKPing ret_var = Ping_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Ping_clone_ptr"))) TS_Ping_clone_ptr(uint32_t arg) {
	LDKPing arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Ping_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Ping_clone"))) TS_Ping_clone(uint32_t orig) {
	LDKPing orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKPing ret_var = Ping_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_Pong_free"))) TS_Pong_free(uint32_t this_obj) {
	LDKPong this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Pong_free(this_obj_conv);
}

int16_t  __attribute__((export_name("TS_Pong_get_byteslen"))) TS_Pong_get_byteslen(uint32_t this_ptr) {
	LDKPong this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = Pong_get_byteslen(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Pong_set_byteslen"))) TS_Pong_set_byteslen(uint32_t this_ptr, int16_t val) {
	LDKPong this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	Pong_set_byteslen(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_Pong_new"))) TS_Pong_new(int16_t byteslen_arg) {
	LDKPong ret_var = Pong_new(byteslen_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t Pong_clone_ptr(LDKPong *NONNULL_PTR arg) {
	LDKPong ret_var = Pong_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Pong_clone_ptr"))) TS_Pong_clone_ptr(uint32_t arg) {
	LDKPong arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Pong_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Pong_clone"))) TS_Pong_clone(uint32_t orig) {
	LDKPong orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKPong ret_var = Pong_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_OpenChannel_free"))) TS_OpenChannel_free(uint32_t this_obj) {
	LDKOpenChannel this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	OpenChannel_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_get_chain_hash"))) TS_OpenChannel_get_chain_hash(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *OpenChannel_get_chain_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_OpenChannel_set_chain_hash"))) TS_OpenChannel_set_chain_hash(uint32_t this_ptr, int8_tArray val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	OpenChannel_set_chain_hash(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_get_temporary_channel_id"))) TS_OpenChannel_get_temporary_channel_id(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *OpenChannel_get_temporary_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_OpenChannel_set_temporary_channel_id"))) TS_OpenChannel_set_temporary_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	OpenChannel_set_temporary_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_OpenChannel_get_funding_satoshis"))) TS_OpenChannel_get_funding_satoshis(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = OpenChannel_get_funding_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_funding_satoshis"))) TS_OpenChannel_set_funding_satoshis(uint32_t this_ptr, int64_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_funding_satoshis(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_OpenChannel_get_push_msat"))) TS_OpenChannel_get_push_msat(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = OpenChannel_get_push_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_push_msat"))) TS_OpenChannel_set_push_msat(uint32_t this_ptr, int64_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_push_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_OpenChannel_get_dust_limit_satoshis"))) TS_OpenChannel_get_dust_limit_satoshis(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = OpenChannel_get_dust_limit_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_dust_limit_satoshis"))) TS_OpenChannel_set_dust_limit_satoshis(uint32_t this_ptr, int64_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_dust_limit_satoshis(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_OpenChannel_get_max_htlc_value_in_flight_msat"))) TS_OpenChannel_get_max_htlc_value_in_flight_msat(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = OpenChannel_get_max_htlc_value_in_flight_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_max_htlc_value_in_flight_msat"))) TS_OpenChannel_set_max_htlc_value_in_flight_msat(uint32_t this_ptr, int64_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_max_htlc_value_in_flight_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_OpenChannel_get_channel_reserve_satoshis"))) TS_OpenChannel_get_channel_reserve_satoshis(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = OpenChannel_get_channel_reserve_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_channel_reserve_satoshis"))) TS_OpenChannel_set_channel_reserve_satoshis(uint32_t this_ptr, int64_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_channel_reserve_satoshis(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_OpenChannel_get_htlc_minimum_msat"))) TS_OpenChannel_get_htlc_minimum_msat(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = OpenChannel_get_htlc_minimum_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_htlc_minimum_msat"))) TS_OpenChannel_set_htlc_minimum_msat(uint32_t this_ptr, int64_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_htlc_minimum_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_OpenChannel_get_feerate_per_kw"))) TS_OpenChannel_get_feerate_per_kw(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = OpenChannel_get_feerate_per_kw(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_feerate_per_kw"))) TS_OpenChannel_set_feerate_per_kw(uint32_t this_ptr, int32_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_feerate_per_kw(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_OpenChannel_get_to_self_delay"))) TS_OpenChannel_get_to_self_delay(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = OpenChannel_get_to_self_delay(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_to_self_delay"))) TS_OpenChannel_set_to_self_delay(uint32_t this_ptr, int16_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_to_self_delay(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_OpenChannel_get_max_accepted_htlcs"))) TS_OpenChannel_get_max_accepted_htlcs(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = OpenChannel_get_max_accepted_htlcs(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_max_accepted_htlcs"))) TS_OpenChannel_set_max_accepted_htlcs(uint32_t this_ptr, int16_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_max_accepted_htlcs(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_get_funding_pubkey"))) TS_OpenChannel_get_funding_pubkey(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, OpenChannel_get_funding_pubkey(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_OpenChannel_set_funding_pubkey"))) TS_OpenChannel_set_funding_pubkey(uint32_t this_ptr, int8_tArray val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	OpenChannel_set_funding_pubkey(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_get_revocation_basepoint"))) TS_OpenChannel_get_revocation_basepoint(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, OpenChannel_get_revocation_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_OpenChannel_set_revocation_basepoint"))) TS_OpenChannel_set_revocation_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	OpenChannel_set_revocation_basepoint(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_get_payment_point"))) TS_OpenChannel_get_payment_point(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, OpenChannel_get_payment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_OpenChannel_set_payment_point"))) TS_OpenChannel_set_payment_point(uint32_t this_ptr, int8_tArray val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	OpenChannel_set_payment_point(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_get_delayed_payment_basepoint"))) TS_OpenChannel_get_delayed_payment_basepoint(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, OpenChannel_get_delayed_payment_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_OpenChannel_set_delayed_payment_basepoint"))) TS_OpenChannel_set_delayed_payment_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	OpenChannel_set_delayed_payment_basepoint(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_get_htlc_basepoint"))) TS_OpenChannel_get_htlc_basepoint(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, OpenChannel_get_htlc_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_OpenChannel_set_htlc_basepoint"))) TS_OpenChannel_set_htlc_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	OpenChannel_set_htlc_basepoint(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_get_first_per_commitment_point"))) TS_OpenChannel_get_first_per_commitment_point(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, OpenChannel_get_first_per_commitment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_OpenChannel_set_first_per_commitment_point"))) TS_OpenChannel_set_first_per_commitment_point(uint32_t this_ptr, int8_tArray val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	OpenChannel_set_first_per_commitment_point(&this_ptr_conv, val_ref);
}

int8_t  __attribute__((export_name("TS_OpenChannel_get_channel_flags"))) TS_OpenChannel_get_channel_flags(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_t ret_val = OpenChannel_get_channel_flags(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_OpenChannel_set_channel_flags"))) TS_OpenChannel_set_channel_flags(uint32_t this_ptr, int8_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	OpenChannel_set_channel_flags(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_OpenChannel_get_channel_type"))) TS_OpenChannel_get_channel_type(uint32_t this_ptr) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelTypeFeatures ret_var = OpenChannel_get_channel_type(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_OpenChannel_set_channel_type"))) TS_OpenChannel_set_channel_type(uint32_t this_ptr, uint32_t val) {
	LDKOpenChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelTypeFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelTypeFeatures_clone(&val_conv);
	OpenChannel_set_channel_type(&this_ptr_conv, val_conv);
}

static inline uintptr_t OpenChannel_clone_ptr(LDKOpenChannel *NONNULL_PTR arg) {
	LDKOpenChannel ret_var = OpenChannel_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_OpenChannel_clone_ptr"))) TS_OpenChannel_clone_ptr(uint32_t arg) {
	LDKOpenChannel arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = OpenChannel_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_OpenChannel_clone"))) TS_OpenChannel_clone(uint32_t orig) {
	LDKOpenChannel orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKOpenChannel ret_var = OpenChannel_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_AcceptChannel_free"))) TS_AcceptChannel_free(uint32_t this_obj) {
	LDKAcceptChannel this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	AcceptChannel_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_AcceptChannel_get_temporary_channel_id"))) TS_AcceptChannel_get_temporary_channel_id(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *AcceptChannel_get_temporary_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_AcceptChannel_set_temporary_channel_id"))) TS_AcceptChannel_set_temporary_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	AcceptChannel_set_temporary_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_AcceptChannel_get_dust_limit_satoshis"))) TS_AcceptChannel_get_dust_limit_satoshis(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = AcceptChannel_get_dust_limit_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_AcceptChannel_set_dust_limit_satoshis"))) TS_AcceptChannel_set_dust_limit_satoshis(uint32_t this_ptr, int64_t val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	AcceptChannel_set_dust_limit_satoshis(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_AcceptChannel_get_max_htlc_value_in_flight_msat"))) TS_AcceptChannel_get_max_htlc_value_in_flight_msat(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = AcceptChannel_get_max_htlc_value_in_flight_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_AcceptChannel_set_max_htlc_value_in_flight_msat"))) TS_AcceptChannel_set_max_htlc_value_in_flight_msat(uint32_t this_ptr, int64_t val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	AcceptChannel_set_max_htlc_value_in_flight_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_AcceptChannel_get_channel_reserve_satoshis"))) TS_AcceptChannel_get_channel_reserve_satoshis(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = AcceptChannel_get_channel_reserve_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_AcceptChannel_set_channel_reserve_satoshis"))) TS_AcceptChannel_set_channel_reserve_satoshis(uint32_t this_ptr, int64_t val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	AcceptChannel_set_channel_reserve_satoshis(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_AcceptChannel_get_htlc_minimum_msat"))) TS_AcceptChannel_get_htlc_minimum_msat(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = AcceptChannel_get_htlc_minimum_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_AcceptChannel_set_htlc_minimum_msat"))) TS_AcceptChannel_set_htlc_minimum_msat(uint32_t this_ptr, int64_t val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	AcceptChannel_set_htlc_minimum_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_AcceptChannel_get_minimum_depth"))) TS_AcceptChannel_get_minimum_depth(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = AcceptChannel_get_minimum_depth(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_AcceptChannel_set_minimum_depth"))) TS_AcceptChannel_set_minimum_depth(uint32_t this_ptr, int32_t val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	AcceptChannel_set_minimum_depth(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_AcceptChannel_get_to_self_delay"))) TS_AcceptChannel_get_to_self_delay(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = AcceptChannel_get_to_self_delay(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_AcceptChannel_set_to_self_delay"))) TS_AcceptChannel_set_to_self_delay(uint32_t this_ptr, int16_t val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	AcceptChannel_set_to_self_delay(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_AcceptChannel_get_max_accepted_htlcs"))) TS_AcceptChannel_get_max_accepted_htlcs(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = AcceptChannel_get_max_accepted_htlcs(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_AcceptChannel_set_max_accepted_htlcs"))) TS_AcceptChannel_set_max_accepted_htlcs(uint32_t this_ptr, int16_t val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	AcceptChannel_set_max_accepted_htlcs(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_AcceptChannel_get_funding_pubkey"))) TS_AcceptChannel_get_funding_pubkey(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, AcceptChannel_get_funding_pubkey(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_AcceptChannel_set_funding_pubkey"))) TS_AcceptChannel_set_funding_pubkey(uint32_t this_ptr, int8_tArray val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	AcceptChannel_set_funding_pubkey(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_AcceptChannel_get_revocation_basepoint"))) TS_AcceptChannel_get_revocation_basepoint(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, AcceptChannel_get_revocation_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_AcceptChannel_set_revocation_basepoint"))) TS_AcceptChannel_set_revocation_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	AcceptChannel_set_revocation_basepoint(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_AcceptChannel_get_payment_point"))) TS_AcceptChannel_get_payment_point(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, AcceptChannel_get_payment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_AcceptChannel_set_payment_point"))) TS_AcceptChannel_set_payment_point(uint32_t this_ptr, int8_tArray val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	AcceptChannel_set_payment_point(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_AcceptChannel_get_delayed_payment_basepoint"))) TS_AcceptChannel_get_delayed_payment_basepoint(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, AcceptChannel_get_delayed_payment_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_AcceptChannel_set_delayed_payment_basepoint"))) TS_AcceptChannel_set_delayed_payment_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	AcceptChannel_set_delayed_payment_basepoint(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_AcceptChannel_get_htlc_basepoint"))) TS_AcceptChannel_get_htlc_basepoint(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, AcceptChannel_get_htlc_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_AcceptChannel_set_htlc_basepoint"))) TS_AcceptChannel_set_htlc_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	AcceptChannel_set_htlc_basepoint(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_AcceptChannel_get_first_per_commitment_point"))) TS_AcceptChannel_get_first_per_commitment_point(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, AcceptChannel_get_first_per_commitment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_AcceptChannel_set_first_per_commitment_point"))) TS_AcceptChannel_set_first_per_commitment_point(uint32_t this_ptr, int8_tArray val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	AcceptChannel_set_first_per_commitment_point(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_AcceptChannel_get_channel_type"))) TS_AcceptChannel_get_channel_type(uint32_t this_ptr) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelTypeFeatures ret_var = AcceptChannel_get_channel_type(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_AcceptChannel_set_channel_type"))) TS_AcceptChannel_set_channel_type(uint32_t this_ptr, uint32_t val) {
	LDKAcceptChannel this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelTypeFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelTypeFeatures_clone(&val_conv);
	AcceptChannel_set_channel_type(&this_ptr_conv, val_conv);
}

static inline uintptr_t AcceptChannel_clone_ptr(LDKAcceptChannel *NONNULL_PTR arg) {
	LDKAcceptChannel ret_var = AcceptChannel_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_AcceptChannel_clone_ptr"))) TS_AcceptChannel_clone_ptr(uint32_t arg) {
	LDKAcceptChannel arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = AcceptChannel_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_AcceptChannel_clone"))) TS_AcceptChannel_clone(uint32_t orig) {
	LDKAcceptChannel orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKAcceptChannel ret_var = AcceptChannel_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_FundingCreated_free"))) TS_FundingCreated_free(uint32_t this_obj) {
	LDKFundingCreated this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	FundingCreated_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_FundingCreated_get_temporary_channel_id"))) TS_FundingCreated_get_temporary_channel_id(uint32_t this_ptr) {
	LDKFundingCreated this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *FundingCreated_get_temporary_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_FundingCreated_set_temporary_channel_id"))) TS_FundingCreated_set_temporary_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKFundingCreated this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	FundingCreated_set_temporary_channel_id(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_FundingCreated_get_funding_txid"))) TS_FundingCreated_get_funding_txid(uint32_t this_ptr) {
	LDKFundingCreated this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *FundingCreated_get_funding_txid(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_FundingCreated_set_funding_txid"))) TS_FundingCreated_set_funding_txid(uint32_t this_ptr, int8_tArray val) {
	LDKFundingCreated this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	FundingCreated_set_funding_txid(&this_ptr_conv, val_ref);
}

int16_t  __attribute__((export_name("TS_FundingCreated_get_funding_output_index"))) TS_FundingCreated_get_funding_output_index(uint32_t this_ptr) {
	LDKFundingCreated this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = FundingCreated_get_funding_output_index(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_FundingCreated_set_funding_output_index"))) TS_FundingCreated_set_funding_output_index(uint32_t this_ptr, int16_t val) {
	LDKFundingCreated this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	FundingCreated_set_funding_output_index(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_FundingCreated_get_signature"))) TS_FundingCreated_get_signature(uint32_t this_ptr) {
	LDKFundingCreated this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, FundingCreated_get_signature(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_FundingCreated_set_signature"))) TS_FundingCreated_set_signature(uint32_t this_ptr, int8_tArray val) {
	LDKFundingCreated this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	FundingCreated_set_signature(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_FundingCreated_new"))) TS_FundingCreated_new(int8_tArray temporary_channel_id_arg, int8_tArray funding_txid_arg, int16_t funding_output_index_arg, int8_tArray signature_arg) {
	LDKThirtyTwoBytes temporary_channel_id_arg_ref;
	CHECK(temporary_channel_id_arg->arr_len == 32);
	memcpy(temporary_channel_id_arg_ref.data, temporary_channel_id_arg->elems, 32); FREE(temporary_channel_id_arg);
	LDKThirtyTwoBytes funding_txid_arg_ref;
	CHECK(funding_txid_arg->arr_len == 32);
	memcpy(funding_txid_arg_ref.data, funding_txid_arg->elems, 32); FREE(funding_txid_arg);
	LDKSignature signature_arg_ref;
	CHECK(signature_arg->arr_len == 64);
	memcpy(signature_arg_ref.compact_form, signature_arg->elems, 64); FREE(signature_arg);
	LDKFundingCreated ret_var = FundingCreated_new(temporary_channel_id_arg_ref, funding_txid_arg_ref, funding_output_index_arg, signature_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t FundingCreated_clone_ptr(LDKFundingCreated *NONNULL_PTR arg) {
	LDKFundingCreated ret_var = FundingCreated_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_FundingCreated_clone_ptr"))) TS_FundingCreated_clone_ptr(uint32_t arg) {
	LDKFundingCreated arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = FundingCreated_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_FundingCreated_clone"))) TS_FundingCreated_clone(uint32_t orig) {
	LDKFundingCreated orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKFundingCreated ret_var = FundingCreated_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_FundingSigned_free"))) TS_FundingSigned_free(uint32_t this_obj) {
	LDKFundingSigned this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	FundingSigned_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_FundingSigned_get_channel_id"))) TS_FundingSigned_get_channel_id(uint32_t this_ptr) {
	LDKFundingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *FundingSigned_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_FundingSigned_set_channel_id"))) TS_FundingSigned_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKFundingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	FundingSigned_set_channel_id(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_FundingSigned_get_signature"))) TS_FundingSigned_get_signature(uint32_t this_ptr) {
	LDKFundingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, FundingSigned_get_signature(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_FundingSigned_set_signature"))) TS_FundingSigned_set_signature(uint32_t this_ptr, int8_tArray val) {
	LDKFundingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	FundingSigned_set_signature(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_FundingSigned_new"))) TS_FundingSigned_new(int8_tArray channel_id_arg, int8_tArray signature_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKSignature signature_arg_ref;
	CHECK(signature_arg->arr_len == 64);
	memcpy(signature_arg_ref.compact_form, signature_arg->elems, 64); FREE(signature_arg);
	LDKFundingSigned ret_var = FundingSigned_new(channel_id_arg_ref, signature_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t FundingSigned_clone_ptr(LDKFundingSigned *NONNULL_PTR arg) {
	LDKFundingSigned ret_var = FundingSigned_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_FundingSigned_clone_ptr"))) TS_FundingSigned_clone_ptr(uint32_t arg) {
	LDKFundingSigned arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = FundingSigned_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_FundingSigned_clone"))) TS_FundingSigned_clone(uint32_t orig) {
	LDKFundingSigned orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKFundingSigned ret_var = FundingSigned_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_FundingLocked_free"))) TS_FundingLocked_free(uint32_t this_obj) {
	LDKFundingLocked this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	FundingLocked_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_FundingLocked_get_channel_id"))) TS_FundingLocked_get_channel_id(uint32_t this_ptr) {
	LDKFundingLocked this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *FundingLocked_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_FundingLocked_set_channel_id"))) TS_FundingLocked_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKFundingLocked this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	FundingLocked_set_channel_id(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_FundingLocked_get_next_per_commitment_point"))) TS_FundingLocked_get_next_per_commitment_point(uint32_t this_ptr) {
	LDKFundingLocked this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, FundingLocked_get_next_per_commitment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_FundingLocked_set_next_per_commitment_point"))) TS_FundingLocked_set_next_per_commitment_point(uint32_t this_ptr, int8_tArray val) {
	LDKFundingLocked this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	FundingLocked_set_next_per_commitment_point(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_FundingLocked_get_short_channel_id_alias"))) TS_FundingLocked_get_short_channel_id_alias(uint32_t this_ptr) {
	LDKFundingLocked this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = FundingLocked_get_short_channel_id_alias(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_FundingLocked_set_short_channel_id_alias"))) TS_FundingLocked_set_short_channel_id_alias(uint32_t this_ptr, uint32_t val) {
	LDKFundingLocked this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	FundingLocked_set_short_channel_id_alias(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_FundingLocked_new"))) TS_FundingLocked_new(int8_tArray channel_id_arg, int8_tArray next_per_commitment_point_arg, uint32_t short_channel_id_alias_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKPublicKey next_per_commitment_point_arg_ref;
	CHECK(next_per_commitment_point_arg->arr_len == 33);
	memcpy(next_per_commitment_point_arg_ref.compressed_form, next_per_commitment_point_arg->elems, 33); FREE(next_per_commitment_point_arg);
	void* short_channel_id_alias_arg_ptr = (void*)(((uintptr_t)short_channel_id_alias_arg) & ~1);
	CHECK_ACCESS(short_channel_id_alias_arg_ptr);
	LDKCOption_u64Z short_channel_id_alias_arg_conv = *(LDKCOption_u64Z*)(short_channel_id_alias_arg_ptr);
	short_channel_id_alias_arg_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)short_channel_id_alias_arg) & ~1));
	LDKFundingLocked ret_var = FundingLocked_new(channel_id_arg_ref, next_per_commitment_point_arg_ref, short_channel_id_alias_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t FundingLocked_clone_ptr(LDKFundingLocked *NONNULL_PTR arg) {
	LDKFundingLocked ret_var = FundingLocked_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_FundingLocked_clone_ptr"))) TS_FundingLocked_clone_ptr(uint32_t arg) {
	LDKFundingLocked arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = FundingLocked_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_FundingLocked_clone"))) TS_FundingLocked_clone(uint32_t orig) {
	LDKFundingLocked orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKFundingLocked ret_var = FundingLocked_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_Shutdown_free"))) TS_Shutdown_free(uint32_t this_obj) {
	LDKShutdown this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Shutdown_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_Shutdown_get_channel_id"))) TS_Shutdown_get_channel_id(uint32_t this_ptr) {
	LDKShutdown this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *Shutdown_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_Shutdown_set_channel_id"))) TS_Shutdown_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKShutdown this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	Shutdown_set_channel_id(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_Shutdown_get_scriptpubkey"))) TS_Shutdown_get_scriptpubkey(uint32_t this_ptr) {
	LDKShutdown this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKu8slice ret_var = Shutdown_get_scriptpubkey(&this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	return ret_arr;
}

void  __attribute__((export_name("TS_Shutdown_set_scriptpubkey"))) TS_Shutdown_set_scriptpubkey(uint32_t this_ptr, int8_tArray val) {
	LDKShutdown this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_u8Z val_ref;
	val_ref.datalen = val->arr_len;
	val_ref.data = MALLOC(val_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(val_ref.data, val->elems, val_ref.datalen); FREE(val);
	Shutdown_set_scriptpubkey(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_Shutdown_new"))) TS_Shutdown_new(int8_tArray channel_id_arg, int8_tArray scriptpubkey_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKCVec_u8Z scriptpubkey_arg_ref;
	scriptpubkey_arg_ref.datalen = scriptpubkey_arg->arr_len;
	scriptpubkey_arg_ref.data = MALLOC(scriptpubkey_arg_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(scriptpubkey_arg_ref.data, scriptpubkey_arg->elems, scriptpubkey_arg_ref.datalen); FREE(scriptpubkey_arg);
	LDKShutdown ret_var = Shutdown_new(channel_id_arg_ref, scriptpubkey_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t Shutdown_clone_ptr(LDKShutdown *NONNULL_PTR arg) {
	LDKShutdown ret_var = Shutdown_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Shutdown_clone_ptr"))) TS_Shutdown_clone_ptr(uint32_t arg) {
	LDKShutdown arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Shutdown_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Shutdown_clone"))) TS_Shutdown_clone(uint32_t orig) {
	LDKShutdown orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKShutdown ret_var = Shutdown_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ClosingSignedFeeRange_free"))) TS_ClosingSignedFeeRange_free(uint32_t this_obj) {
	LDKClosingSignedFeeRange this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ClosingSignedFeeRange_free(this_obj_conv);
}

int64_t  __attribute__((export_name("TS_ClosingSignedFeeRange_get_min_fee_satoshis"))) TS_ClosingSignedFeeRange_get_min_fee_satoshis(uint32_t this_ptr) {
	LDKClosingSignedFeeRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ClosingSignedFeeRange_get_min_fee_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ClosingSignedFeeRange_set_min_fee_satoshis"))) TS_ClosingSignedFeeRange_set_min_fee_satoshis(uint32_t this_ptr, int64_t val) {
	LDKClosingSignedFeeRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ClosingSignedFeeRange_set_min_fee_satoshis(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ClosingSignedFeeRange_get_max_fee_satoshis"))) TS_ClosingSignedFeeRange_get_max_fee_satoshis(uint32_t this_ptr) {
	LDKClosingSignedFeeRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ClosingSignedFeeRange_get_max_fee_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ClosingSignedFeeRange_set_max_fee_satoshis"))) TS_ClosingSignedFeeRange_set_max_fee_satoshis(uint32_t this_ptr, int64_t val) {
	LDKClosingSignedFeeRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ClosingSignedFeeRange_set_max_fee_satoshis(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ClosingSignedFeeRange_new"))) TS_ClosingSignedFeeRange_new(int64_t min_fee_satoshis_arg, int64_t max_fee_satoshis_arg) {
	LDKClosingSignedFeeRange ret_var = ClosingSignedFeeRange_new(min_fee_satoshis_arg, max_fee_satoshis_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ClosingSignedFeeRange_clone_ptr(LDKClosingSignedFeeRange *NONNULL_PTR arg) {
	LDKClosingSignedFeeRange ret_var = ClosingSignedFeeRange_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ClosingSignedFeeRange_clone_ptr"))) TS_ClosingSignedFeeRange_clone_ptr(uint32_t arg) {
	LDKClosingSignedFeeRange arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ClosingSignedFeeRange_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ClosingSignedFeeRange_clone"))) TS_ClosingSignedFeeRange_clone(uint32_t orig) {
	LDKClosingSignedFeeRange orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKClosingSignedFeeRange ret_var = ClosingSignedFeeRange_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ClosingSigned_free"))) TS_ClosingSigned_free(uint32_t this_obj) {
	LDKClosingSigned this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ClosingSigned_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ClosingSigned_get_channel_id"))) TS_ClosingSigned_get_channel_id(uint32_t this_ptr) {
	LDKClosingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *ClosingSigned_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_ClosingSigned_set_channel_id"))) TS_ClosingSigned_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKClosingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	ClosingSigned_set_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_ClosingSigned_get_fee_satoshis"))) TS_ClosingSigned_get_fee_satoshis(uint32_t this_ptr) {
	LDKClosingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ClosingSigned_get_fee_satoshis(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ClosingSigned_set_fee_satoshis"))) TS_ClosingSigned_set_fee_satoshis(uint32_t this_ptr, int64_t val) {
	LDKClosingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ClosingSigned_set_fee_satoshis(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_ClosingSigned_get_signature"))) TS_ClosingSigned_get_signature(uint32_t this_ptr) {
	LDKClosingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, ClosingSigned_get_signature(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_ClosingSigned_set_signature"))) TS_ClosingSigned_set_signature(uint32_t this_ptr, int8_tArray val) {
	LDKClosingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	ClosingSigned_set_signature(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_ClosingSigned_get_fee_range"))) TS_ClosingSigned_get_fee_range(uint32_t this_ptr) {
	LDKClosingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKClosingSignedFeeRange ret_var = ClosingSigned_get_fee_range(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ClosingSigned_set_fee_range"))) TS_ClosingSigned_set_fee_range(uint32_t this_ptr, uint32_t val) {
	LDKClosingSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKClosingSignedFeeRange val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ClosingSignedFeeRange_clone(&val_conv);
	ClosingSigned_set_fee_range(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ClosingSigned_new"))) TS_ClosingSigned_new(int8_tArray channel_id_arg, int64_t fee_satoshis_arg, int8_tArray signature_arg, uint32_t fee_range_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKSignature signature_arg_ref;
	CHECK(signature_arg->arr_len == 64);
	memcpy(signature_arg_ref.compact_form, signature_arg->elems, 64); FREE(signature_arg);
	LDKClosingSignedFeeRange fee_range_arg_conv;
	fee_range_arg_conv.inner = (void*)(fee_range_arg & (~1));
	fee_range_arg_conv.is_owned = (fee_range_arg & 1) || (fee_range_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(fee_range_arg_conv);
	fee_range_arg_conv = ClosingSignedFeeRange_clone(&fee_range_arg_conv);
	LDKClosingSigned ret_var = ClosingSigned_new(channel_id_arg_ref, fee_satoshis_arg, signature_arg_ref, fee_range_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ClosingSigned_clone_ptr(LDKClosingSigned *NONNULL_PTR arg) {
	LDKClosingSigned ret_var = ClosingSigned_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ClosingSigned_clone_ptr"))) TS_ClosingSigned_clone_ptr(uint32_t arg) {
	LDKClosingSigned arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ClosingSigned_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ClosingSigned_clone"))) TS_ClosingSigned_clone(uint32_t orig) {
	LDKClosingSigned orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKClosingSigned ret_var = ClosingSigned_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UpdateAddHTLC_free"))) TS_UpdateAddHTLC_free(uint32_t this_obj) {
	LDKUpdateAddHTLC this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UpdateAddHTLC_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_UpdateAddHTLC_get_channel_id"))) TS_UpdateAddHTLC_get_channel_id(uint32_t this_ptr) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UpdateAddHTLC_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UpdateAddHTLC_set_channel_id"))) TS_UpdateAddHTLC_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UpdateAddHTLC_set_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_UpdateAddHTLC_get_htlc_id"))) TS_UpdateAddHTLC_get_htlc_id(uint32_t this_ptr) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = UpdateAddHTLC_get_htlc_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UpdateAddHTLC_set_htlc_id"))) TS_UpdateAddHTLC_set_htlc_id(uint32_t this_ptr, int64_t val) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UpdateAddHTLC_set_htlc_id(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_UpdateAddHTLC_get_amount_msat"))) TS_UpdateAddHTLC_get_amount_msat(uint32_t this_ptr) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = UpdateAddHTLC_get_amount_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UpdateAddHTLC_set_amount_msat"))) TS_UpdateAddHTLC_set_amount_msat(uint32_t this_ptr, int64_t val) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UpdateAddHTLC_set_amount_msat(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_UpdateAddHTLC_get_payment_hash"))) TS_UpdateAddHTLC_get_payment_hash(uint32_t this_ptr) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UpdateAddHTLC_get_payment_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UpdateAddHTLC_set_payment_hash"))) TS_UpdateAddHTLC_set_payment_hash(uint32_t this_ptr, int8_tArray val) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UpdateAddHTLC_set_payment_hash(&this_ptr_conv, val_ref);
}

int32_t  __attribute__((export_name("TS_UpdateAddHTLC_get_cltv_expiry"))) TS_UpdateAddHTLC_get_cltv_expiry(uint32_t this_ptr) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = UpdateAddHTLC_get_cltv_expiry(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UpdateAddHTLC_set_cltv_expiry"))) TS_UpdateAddHTLC_set_cltv_expiry(uint32_t this_ptr, int32_t val) {
	LDKUpdateAddHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UpdateAddHTLC_set_cltv_expiry(&this_ptr_conv, val);
}

static inline uintptr_t UpdateAddHTLC_clone_ptr(LDKUpdateAddHTLC *NONNULL_PTR arg) {
	LDKUpdateAddHTLC ret_var = UpdateAddHTLC_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UpdateAddHTLC_clone_ptr"))) TS_UpdateAddHTLC_clone_ptr(uint32_t arg) {
	LDKUpdateAddHTLC arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UpdateAddHTLC_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UpdateAddHTLC_clone"))) TS_UpdateAddHTLC_clone(uint32_t orig) {
	LDKUpdateAddHTLC orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUpdateAddHTLC ret_var = UpdateAddHTLC_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UpdateFulfillHTLC_free"))) TS_UpdateFulfillHTLC_free(uint32_t this_obj) {
	LDKUpdateFulfillHTLC this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UpdateFulfillHTLC_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_UpdateFulfillHTLC_get_channel_id"))) TS_UpdateFulfillHTLC_get_channel_id(uint32_t this_ptr) {
	LDKUpdateFulfillHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UpdateFulfillHTLC_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UpdateFulfillHTLC_set_channel_id"))) TS_UpdateFulfillHTLC_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKUpdateFulfillHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UpdateFulfillHTLC_set_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_UpdateFulfillHTLC_get_htlc_id"))) TS_UpdateFulfillHTLC_get_htlc_id(uint32_t this_ptr) {
	LDKUpdateFulfillHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = UpdateFulfillHTLC_get_htlc_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UpdateFulfillHTLC_set_htlc_id"))) TS_UpdateFulfillHTLC_set_htlc_id(uint32_t this_ptr, int64_t val) {
	LDKUpdateFulfillHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UpdateFulfillHTLC_set_htlc_id(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_UpdateFulfillHTLC_get_payment_preimage"))) TS_UpdateFulfillHTLC_get_payment_preimage(uint32_t this_ptr) {
	LDKUpdateFulfillHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UpdateFulfillHTLC_get_payment_preimage(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UpdateFulfillHTLC_set_payment_preimage"))) TS_UpdateFulfillHTLC_set_payment_preimage(uint32_t this_ptr, int8_tArray val) {
	LDKUpdateFulfillHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UpdateFulfillHTLC_set_payment_preimage(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_UpdateFulfillHTLC_new"))) TS_UpdateFulfillHTLC_new(int8_tArray channel_id_arg, int64_t htlc_id_arg, int8_tArray payment_preimage_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKThirtyTwoBytes payment_preimage_arg_ref;
	CHECK(payment_preimage_arg->arr_len == 32);
	memcpy(payment_preimage_arg_ref.data, payment_preimage_arg->elems, 32); FREE(payment_preimage_arg);
	LDKUpdateFulfillHTLC ret_var = UpdateFulfillHTLC_new(channel_id_arg_ref, htlc_id_arg, payment_preimage_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t UpdateFulfillHTLC_clone_ptr(LDKUpdateFulfillHTLC *NONNULL_PTR arg) {
	LDKUpdateFulfillHTLC ret_var = UpdateFulfillHTLC_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UpdateFulfillHTLC_clone_ptr"))) TS_UpdateFulfillHTLC_clone_ptr(uint32_t arg) {
	LDKUpdateFulfillHTLC arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UpdateFulfillHTLC_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UpdateFulfillHTLC_clone"))) TS_UpdateFulfillHTLC_clone(uint32_t orig) {
	LDKUpdateFulfillHTLC orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUpdateFulfillHTLC ret_var = UpdateFulfillHTLC_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UpdateFailHTLC_free"))) TS_UpdateFailHTLC_free(uint32_t this_obj) {
	LDKUpdateFailHTLC this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UpdateFailHTLC_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_UpdateFailHTLC_get_channel_id"))) TS_UpdateFailHTLC_get_channel_id(uint32_t this_ptr) {
	LDKUpdateFailHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UpdateFailHTLC_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UpdateFailHTLC_set_channel_id"))) TS_UpdateFailHTLC_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKUpdateFailHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UpdateFailHTLC_set_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_UpdateFailHTLC_get_htlc_id"))) TS_UpdateFailHTLC_get_htlc_id(uint32_t this_ptr) {
	LDKUpdateFailHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = UpdateFailHTLC_get_htlc_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UpdateFailHTLC_set_htlc_id"))) TS_UpdateFailHTLC_set_htlc_id(uint32_t this_ptr, int64_t val) {
	LDKUpdateFailHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UpdateFailHTLC_set_htlc_id(&this_ptr_conv, val);
}

static inline uintptr_t UpdateFailHTLC_clone_ptr(LDKUpdateFailHTLC *NONNULL_PTR arg) {
	LDKUpdateFailHTLC ret_var = UpdateFailHTLC_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UpdateFailHTLC_clone_ptr"))) TS_UpdateFailHTLC_clone_ptr(uint32_t arg) {
	LDKUpdateFailHTLC arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UpdateFailHTLC_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UpdateFailHTLC_clone"))) TS_UpdateFailHTLC_clone(uint32_t orig) {
	LDKUpdateFailHTLC orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUpdateFailHTLC ret_var = UpdateFailHTLC_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UpdateFailMalformedHTLC_free"))) TS_UpdateFailMalformedHTLC_free(uint32_t this_obj) {
	LDKUpdateFailMalformedHTLC this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UpdateFailMalformedHTLC_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_UpdateFailMalformedHTLC_get_channel_id"))) TS_UpdateFailMalformedHTLC_get_channel_id(uint32_t this_ptr) {
	LDKUpdateFailMalformedHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UpdateFailMalformedHTLC_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UpdateFailMalformedHTLC_set_channel_id"))) TS_UpdateFailMalformedHTLC_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKUpdateFailMalformedHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UpdateFailMalformedHTLC_set_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_UpdateFailMalformedHTLC_get_htlc_id"))) TS_UpdateFailMalformedHTLC_get_htlc_id(uint32_t this_ptr) {
	LDKUpdateFailMalformedHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = UpdateFailMalformedHTLC_get_htlc_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UpdateFailMalformedHTLC_set_htlc_id"))) TS_UpdateFailMalformedHTLC_set_htlc_id(uint32_t this_ptr, int64_t val) {
	LDKUpdateFailMalformedHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UpdateFailMalformedHTLC_set_htlc_id(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_UpdateFailMalformedHTLC_get_failure_code"))) TS_UpdateFailMalformedHTLC_get_failure_code(uint32_t this_ptr) {
	LDKUpdateFailMalformedHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = UpdateFailMalformedHTLC_get_failure_code(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UpdateFailMalformedHTLC_set_failure_code"))) TS_UpdateFailMalformedHTLC_set_failure_code(uint32_t this_ptr, int16_t val) {
	LDKUpdateFailMalformedHTLC this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UpdateFailMalformedHTLC_set_failure_code(&this_ptr_conv, val);
}

static inline uintptr_t UpdateFailMalformedHTLC_clone_ptr(LDKUpdateFailMalformedHTLC *NONNULL_PTR arg) {
	LDKUpdateFailMalformedHTLC ret_var = UpdateFailMalformedHTLC_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UpdateFailMalformedHTLC_clone_ptr"))) TS_UpdateFailMalformedHTLC_clone_ptr(uint32_t arg) {
	LDKUpdateFailMalformedHTLC arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UpdateFailMalformedHTLC_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UpdateFailMalformedHTLC_clone"))) TS_UpdateFailMalformedHTLC_clone(uint32_t orig) {
	LDKUpdateFailMalformedHTLC orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUpdateFailMalformedHTLC ret_var = UpdateFailMalformedHTLC_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_CommitmentSigned_free"))) TS_CommitmentSigned_free(uint32_t this_obj) {
	LDKCommitmentSigned this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	CommitmentSigned_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_CommitmentSigned_get_channel_id"))) TS_CommitmentSigned_get_channel_id(uint32_t this_ptr) {
	LDKCommitmentSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *CommitmentSigned_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_CommitmentSigned_set_channel_id"))) TS_CommitmentSigned_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKCommitmentSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	CommitmentSigned_set_channel_id(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_CommitmentSigned_get_signature"))) TS_CommitmentSigned_get_signature(uint32_t this_ptr) {
	LDKCommitmentSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, CommitmentSigned_get_signature(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_CommitmentSigned_set_signature"))) TS_CommitmentSigned_set_signature(uint32_t this_ptr, int8_tArray val) {
	LDKCommitmentSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	CommitmentSigned_set_signature(&this_ptr_conv, val_ref);
}

void  __attribute__((export_name("TS_CommitmentSigned_set_htlc_signatures"))) TS_CommitmentSigned_set_htlc_signatures(uint32_t this_ptr, ptrArray val) {
	LDKCommitmentSigned this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_SignatureZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKSignature), "LDKCVec_SignatureZ Elements");
	else
		val_constr.data = NULL;
	int8_tArray* val_vals = (void*) val->elems /* XXX val leaks */;
	for (size_t m = 0; m < val_constr.datalen; m++) {
		int8_tArray val_conv_12 = val_vals[m];
		LDKSignature val_conv_12_ref;
		CHECK(val_conv_12->arr_len == 64);
		memcpy(val_conv_12_ref.compact_form, val_conv_12->elems, 64); FREE(val_conv_12);
		val_constr.data[m] = val_conv_12_ref;
	}
	CommitmentSigned_set_htlc_signatures(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_CommitmentSigned_new"))) TS_CommitmentSigned_new(int8_tArray channel_id_arg, int8_tArray signature_arg, ptrArray htlc_signatures_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKSignature signature_arg_ref;
	CHECK(signature_arg->arr_len == 64);
	memcpy(signature_arg_ref.compact_form, signature_arg->elems, 64); FREE(signature_arg);
	LDKCVec_SignatureZ htlc_signatures_arg_constr;
	htlc_signatures_arg_constr.datalen = htlc_signatures_arg->arr_len;
	if (htlc_signatures_arg_constr.datalen > 0)
		htlc_signatures_arg_constr.data = MALLOC(htlc_signatures_arg_constr.datalen * sizeof(LDKSignature), "LDKCVec_SignatureZ Elements");
	else
		htlc_signatures_arg_constr.data = NULL;
	int8_tArray* htlc_signatures_arg_vals = (void*) htlc_signatures_arg->elems /* XXX htlc_signatures_arg leaks */;
	for (size_t m = 0; m < htlc_signatures_arg_constr.datalen; m++) {
		int8_tArray htlc_signatures_arg_conv_12 = htlc_signatures_arg_vals[m];
		LDKSignature htlc_signatures_arg_conv_12_ref;
		CHECK(htlc_signatures_arg_conv_12->arr_len == 64);
		memcpy(htlc_signatures_arg_conv_12_ref.compact_form, htlc_signatures_arg_conv_12->elems, 64); FREE(htlc_signatures_arg_conv_12);
		htlc_signatures_arg_constr.data[m] = htlc_signatures_arg_conv_12_ref;
	}
	LDKCommitmentSigned ret_var = CommitmentSigned_new(channel_id_arg_ref, signature_arg_ref, htlc_signatures_arg_constr);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t CommitmentSigned_clone_ptr(LDKCommitmentSigned *NONNULL_PTR arg) {
	LDKCommitmentSigned ret_var = CommitmentSigned_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_CommitmentSigned_clone_ptr"))) TS_CommitmentSigned_clone_ptr(uint32_t arg) {
	LDKCommitmentSigned arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = CommitmentSigned_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CommitmentSigned_clone"))) TS_CommitmentSigned_clone(uint32_t orig) {
	LDKCommitmentSigned orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKCommitmentSigned ret_var = CommitmentSigned_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RevokeAndACK_free"))) TS_RevokeAndACK_free(uint32_t this_obj) {
	LDKRevokeAndACK this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RevokeAndACK_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_RevokeAndACK_get_channel_id"))) TS_RevokeAndACK_get_channel_id(uint32_t this_ptr) {
	LDKRevokeAndACK this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *RevokeAndACK_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_RevokeAndACK_set_channel_id"))) TS_RevokeAndACK_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKRevokeAndACK this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	RevokeAndACK_set_channel_id(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_RevokeAndACK_get_per_commitment_secret"))) TS_RevokeAndACK_get_per_commitment_secret(uint32_t this_ptr) {
	LDKRevokeAndACK this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *RevokeAndACK_get_per_commitment_secret(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_RevokeAndACK_set_per_commitment_secret"))) TS_RevokeAndACK_set_per_commitment_secret(uint32_t this_ptr, int8_tArray val) {
	LDKRevokeAndACK this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	RevokeAndACK_set_per_commitment_secret(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_RevokeAndACK_get_next_per_commitment_point"))) TS_RevokeAndACK_get_next_per_commitment_point(uint32_t this_ptr) {
	LDKRevokeAndACK this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, RevokeAndACK_get_next_per_commitment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_RevokeAndACK_set_next_per_commitment_point"))) TS_RevokeAndACK_set_next_per_commitment_point(uint32_t this_ptr, int8_tArray val) {
	LDKRevokeAndACK this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	RevokeAndACK_set_next_per_commitment_point(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_RevokeAndACK_new"))) TS_RevokeAndACK_new(int8_tArray channel_id_arg, int8_tArray per_commitment_secret_arg, int8_tArray next_per_commitment_point_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKThirtyTwoBytes per_commitment_secret_arg_ref;
	CHECK(per_commitment_secret_arg->arr_len == 32);
	memcpy(per_commitment_secret_arg_ref.data, per_commitment_secret_arg->elems, 32); FREE(per_commitment_secret_arg);
	LDKPublicKey next_per_commitment_point_arg_ref;
	CHECK(next_per_commitment_point_arg->arr_len == 33);
	memcpy(next_per_commitment_point_arg_ref.compressed_form, next_per_commitment_point_arg->elems, 33); FREE(next_per_commitment_point_arg);
	LDKRevokeAndACK ret_var = RevokeAndACK_new(channel_id_arg_ref, per_commitment_secret_arg_ref, next_per_commitment_point_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t RevokeAndACK_clone_ptr(LDKRevokeAndACK *NONNULL_PTR arg) {
	LDKRevokeAndACK ret_var = RevokeAndACK_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RevokeAndACK_clone_ptr"))) TS_RevokeAndACK_clone_ptr(uint32_t arg) {
	LDKRevokeAndACK arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RevokeAndACK_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RevokeAndACK_clone"))) TS_RevokeAndACK_clone(uint32_t orig) {
	LDKRevokeAndACK orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRevokeAndACK ret_var = RevokeAndACK_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UpdateFee_free"))) TS_UpdateFee_free(uint32_t this_obj) {
	LDKUpdateFee this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UpdateFee_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_UpdateFee_get_channel_id"))) TS_UpdateFee_get_channel_id(uint32_t this_ptr) {
	LDKUpdateFee this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UpdateFee_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UpdateFee_set_channel_id"))) TS_UpdateFee_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKUpdateFee this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UpdateFee_set_channel_id(&this_ptr_conv, val_ref);
}

int32_t  __attribute__((export_name("TS_UpdateFee_get_feerate_per_kw"))) TS_UpdateFee_get_feerate_per_kw(uint32_t this_ptr) {
	LDKUpdateFee this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = UpdateFee_get_feerate_per_kw(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UpdateFee_set_feerate_per_kw"))) TS_UpdateFee_set_feerate_per_kw(uint32_t this_ptr, int32_t val) {
	LDKUpdateFee this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UpdateFee_set_feerate_per_kw(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_UpdateFee_new"))) TS_UpdateFee_new(int8_tArray channel_id_arg, int32_t feerate_per_kw_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKUpdateFee ret_var = UpdateFee_new(channel_id_arg_ref, feerate_per_kw_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t UpdateFee_clone_ptr(LDKUpdateFee *NONNULL_PTR arg) {
	LDKUpdateFee ret_var = UpdateFee_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UpdateFee_clone_ptr"))) TS_UpdateFee_clone_ptr(uint32_t arg) {
	LDKUpdateFee arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UpdateFee_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UpdateFee_clone"))) TS_UpdateFee_clone(uint32_t orig) {
	LDKUpdateFee orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUpdateFee ret_var = UpdateFee_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_DataLossProtect_free"))) TS_DataLossProtect_free(uint32_t this_obj) {
	LDKDataLossProtect this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	DataLossProtect_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_DataLossProtect_get_your_last_per_commitment_secret"))) TS_DataLossProtect_get_your_last_per_commitment_secret(uint32_t this_ptr) {
	LDKDataLossProtect this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *DataLossProtect_get_your_last_per_commitment_secret(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_DataLossProtect_set_your_last_per_commitment_secret"))) TS_DataLossProtect_set_your_last_per_commitment_secret(uint32_t this_ptr, int8_tArray val) {
	LDKDataLossProtect this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	DataLossProtect_set_your_last_per_commitment_secret(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_DataLossProtect_get_my_current_per_commitment_point"))) TS_DataLossProtect_get_my_current_per_commitment_point(uint32_t this_ptr) {
	LDKDataLossProtect this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, DataLossProtect_get_my_current_per_commitment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_DataLossProtect_set_my_current_per_commitment_point"))) TS_DataLossProtect_set_my_current_per_commitment_point(uint32_t this_ptr, int8_tArray val) {
	LDKDataLossProtect this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	DataLossProtect_set_my_current_per_commitment_point(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_DataLossProtect_new"))) TS_DataLossProtect_new(int8_tArray your_last_per_commitment_secret_arg, int8_tArray my_current_per_commitment_point_arg) {
	LDKThirtyTwoBytes your_last_per_commitment_secret_arg_ref;
	CHECK(your_last_per_commitment_secret_arg->arr_len == 32);
	memcpy(your_last_per_commitment_secret_arg_ref.data, your_last_per_commitment_secret_arg->elems, 32); FREE(your_last_per_commitment_secret_arg);
	LDKPublicKey my_current_per_commitment_point_arg_ref;
	CHECK(my_current_per_commitment_point_arg->arr_len == 33);
	memcpy(my_current_per_commitment_point_arg_ref.compressed_form, my_current_per_commitment_point_arg->elems, 33); FREE(my_current_per_commitment_point_arg);
	LDKDataLossProtect ret_var = DataLossProtect_new(your_last_per_commitment_secret_arg_ref, my_current_per_commitment_point_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t DataLossProtect_clone_ptr(LDKDataLossProtect *NONNULL_PTR arg) {
	LDKDataLossProtect ret_var = DataLossProtect_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_DataLossProtect_clone_ptr"))) TS_DataLossProtect_clone_ptr(uint32_t arg) {
	LDKDataLossProtect arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = DataLossProtect_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_DataLossProtect_clone"))) TS_DataLossProtect_clone(uint32_t orig) {
	LDKDataLossProtect orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKDataLossProtect ret_var = DataLossProtect_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelReestablish_free"))) TS_ChannelReestablish_free(uint32_t this_obj) {
	LDKChannelReestablish this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelReestablish_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ChannelReestablish_get_channel_id"))) TS_ChannelReestablish_get_channel_id(uint32_t this_ptr) {
	LDKChannelReestablish this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *ChannelReestablish_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelReestablish_set_channel_id"))) TS_ChannelReestablish_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKChannelReestablish this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	ChannelReestablish_set_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_ChannelReestablish_get_next_local_commitment_number"))) TS_ChannelReestablish_get_next_local_commitment_number(uint32_t this_ptr) {
	LDKChannelReestablish this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelReestablish_get_next_local_commitment_number(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelReestablish_set_next_local_commitment_number"))) TS_ChannelReestablish_set_next_local_commitment_number(uint32_t this_ptr, int64_t val) {
	LDKChannelReestablish this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelReestablish_set_next_local_commitment_number(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelReestablish_get_next_remote_commitment_number"))) TS_ChannelReestablish_get_next_remote_commitment_number(uint32_t this_ptr) {
	LDKChannelReestablish this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelReestablish_get_next_remote_commitment_number(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelReestablish_set_next_remote_commitment_number"))) TS_ChannelReestablish_set_next_remote_commitment_number(uint32_t this_ptr, int64_t val) {
	LDKChannelReestablish this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelReestablish_set_next_remote_commitment_number(&this_ptr_conv, val);
}

static inline uintptr_t ChannelReestablish_clone_ptr(LDKChannelReestablish *NONNULL_PTR arg) {
	LDKChannelReestablish ret_var = ChannelReestablish_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelReestablish_clone_ptr"))) TS_ChannelReestablish_clone_ptr(uint32_t arg) {
	LDKChannelReestablish arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelReestablish_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelReestablish_clone"))) TS_ChannelReestablish_clone(uint32_t orig) {
	LDKChannelReestablish orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelReestablish ret_var = ChannelReestablish_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_AnnouncementSignatures_free"))) TS_AnnouncementSignatures_free(uint32_t this_obj) {
	LDKAnnouncementSignatures this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	AnnouncementSignatures_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_AnnouncementSignatures_get_channel_id"))) TS_AnnouncementSignatures_get_channel_id(uint32_t this_ptr) {
	LDKAnnouncementSignatures this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *AnnouncementSignatures_get_channel_id(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_AnnouncementSignatures_set_channel_id"))) TS_AnnouncementSignatures_set_channel_id(uint32_t this_ptr, int8_tArray val) {
	LDKAnnouncementSignatures this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	AnnouncementSignatures_set_channel_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_AnnouncementSignatures_get_short_channel_id"))) TS_AnnouncementSignatures_get_short_channel_id(uint32_t this_ptr) {
	LDKAnnouncementSignatures this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = AnnouncementSignatures_get_short_channel_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_AnnouncementSignatures_set_short_channel_id"))) TS_AnnouncementSignatures_set_short_channel_id(uint32_t this_ptr, int64_t val) {
	LDKAnnouncementSignatures this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	AnnouncementSignatures_set_short_channel_id(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_AnnouncementSignatures_get_node_signature"))) TS_AnnouncementSignatures_get_node_signature(uint32_t this_ptr) {
	LDKAnnouncementSignatures this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, AnnouncementSignatures_get_node_signature(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_AnnouncementSignatures_set_node_signature"))) TS_AnnouncementSignatures_set_node_signature(uint32_t this_ptr, int8_tArray val) {
	LDKAnnouncementSignatures this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	AnnouncementSignatures_set_node_signature(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_AnnouncementSignatures_get_bitcoin_signature"))) TS_AnnouncementSignatures_get_bitcoin_signature(uint32_t this_ptr) {
	LDKAnnouncementSignatures this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, AnnouncementSignatures_get_bitcoin_signature(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_AnnouncementSignatures_set_bitcoin_signature"))) TS_AnnouncementSignatures_set_bitcoin_signature(uint32_t this_ptr, int8_tArray val) {
	LDKAnnouncementSignatures this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	AnnouncementSignatures_set_bitcoin_signature(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_AnnouncementSignatures_new"))) TS_AnnouncementSignatures_new(int8_tArray channel_id_arg, int64_t short_channel_id_arg, int8_tArray node_signature_arg, int8_tArray bitcoin_signature_arg) {
	LDKThirtyTwoBytes channel_id_arg_ref;
	CHECK(channel_id_arg->arr_len == 32);
	memcpy(channel_id_arg_ref.data, channel_id_arg->elems, 32); FREE(channel_id_arg);
	LDKSignature node_signature_arg_ref;
	CHECK(node_signature_arg->arr_len == 64);
	memcpy(node_signature_arg_ref.compact_form, node_signature_arg->elems, 64); FREE(node_signature_arg);
	LDKSignature bitcoin_signature_arg_ref;
	CHECK(bitcoin_signature_arg->arr_len == 64);
	memcpy(bitcoin_signature_arg_ref.compact_form, bitcoin_signature_arg->elems, 64); FREE(bitcoin_signature_arg);
	LDKAnnouncementSignatures ret_var = AnnouncementSignatures_new(channel_id_arg_ref, short_channel_id_arg, node_signature_arg_ref, bitcoin_signature_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t AnnouncementSignatures_clone_ptr(LDKAnnouncementSignatures *NONNULL_PTR arg) {
	LDKAnnouncementSignatures ret_var = AnnouncementSignatures_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_AnnouncementSignatures_clone_ptr"))) TS_AnnouncementSignatures_clone_ptr(uint32_t arg) {
	LDKAnnouncementSignatures arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = AnnouncementSignatures_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_AnnouncementSignatures_clone"))) TS_AnnouncementSignatures_clone(uint32_t orig) {
	LDKAnnouncementSignatures orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKAnnouncementSignatures ret_var = AnnouncementSignatures_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_NetAddress_free"))) TS_NetAddress_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKNetAddress this_ptr_conv = *(LDKNetAddress*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	NetAddress_free(this_ptr_conv);
}

static inline uintptr_t NetAddress_clone_ptr(LDKNetAddress *NONNULL_PTR arg) {
	LDKNetAddress *ret_copy = MALLOC(sizeof(LDKNetAddress), "LDKNetAddress");
	*ret_copy = NetAddress_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_NetAddress_clone_ptr"))) TS_NetAddress_clone_ptr(uint32_t arg) {
	LDKNetAddress* arg_conv = (LDKNetAddress*)arg;
	uint32_t ret_val = NetAddress_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NetAddress_clone"))) TS_NetAddress_clone(uint32_t orig) {
	LDKNetAddress* orig_conv = (LDKNetAddress*)orig;
	LDKNetAddress *ret_copy = MALLOC(sizeof(LDKNetAddress), "LDKNetAddress");
	*ret_copy = NetAddress_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetAddress_ipv4"))) TS_NetAddress_ipv4(int8_tArray addr, int16_t port) {
	LDKFourBytes addr_ref;
	CHECK(addr->arr_len == 4);
	memcpy(addr_ref.data, addr->elems, 4); FREE(addr);
	LDKNetAddress *ret_copy = MALLOC(sizeof(LDKNetAddress), "LDKNetAddress");
	*ret_copy = NetAddress_ipv4(addr_ref, port);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetAddress_ipv6"))) TS_NetAddress_ipv6(int8_tArray addr, int16_t port) {
	LDKSixteenBytes addr_ref;
	CHECK(addr->arr_len == 16);
	memcpy(addr_ref.data, addr->elems, 16); FREE(addr);
	LDKNetAddress *ret_copy = MALLOC(sizeof(LDKNetAddress), "LDKNetAddress");
	*ret_copy = NetAddress_ipv6(addr_ref, port);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetAddress_onion_v2"))) TS_NetAddress_onion_v2(int8_tArray a) {
	LDKTwelveBytes a_ref;
	CHECK(a->arr_len == 12);
	memcpy(a_ref.data, a->elems, 12); FREE(a);
	LDKNetAddress *ret_copy = MALLOC(sizeof(LDKNetAddress), "LDKNetAddress");
	*ret_copy = NetAddress_onion_v2(a_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetAddress_onion_v3"))) TS_NetAddress_onion_v3(int8_tArray ed25519_pubkey, int16_t checksum, int8_t version, int16_t port) {
	LDKThirtyTwoBytes ed25519_pubkey_ref;
	CHECK(ed25519_pubkey->arr_len == 32);
	memcpy(ed25519_pubkey_ref.data, ed25519_pubkey->elems, 32); FREE(ed25519_pubkey);
	LDKNetAddress *ret_copy = MALLOC(sizeof(LDKNetAddress), "LDKNetAddress");
	*ret_copy = NetAddress_onion_v3(ed25519_pubkey_ref, checksum, version, port);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_NetAddress_write"))) TS_NetAddress_write(uint32_t obj) {
	LDKNetAddress* obj_conv = (LDKNetAddress*)obj;
	LDKCVec_u8Z ret_var = NetAddress_write(obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_NetAddress_read"))) TS_NetAddress_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_NetAddressDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetAddressDecodeErrorZ), "LDKCResult_NetAddressDecodeErrorZ");
	*ret_conv = NetAddress_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_UnsignedNodeAnnouncement_free"))) TS_UnsignedNodeAnnouncement_free(uint32_t this_obj) {
	LDKUnsignedNodeAnnouncement this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UnsignedNodeAnnouncement_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_UnsignedNodeAnnouncement_get_features"))) TS_UnsignedNodeAnnouncement_get_features(uint32_t this_ptr) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeFeatures ret_var = UnsignedNodeAnnouncement_get_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UnsignedNodeAnnouncement_set_features"))) TS_UnsignedNodeAnnouncement_set_features(uint32_t this_ptr, uint32_t val) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = NodeFeatures_clone(&val_conv);
	UnsignedNodeAnnouncement_set_features(&this_ptr_conv, val_conv);
}

int32_t  __attribute__((export_name("TS_UnsignedNodeAnnouncement_get_timestamp"))) TS_UnsignedNodeAnnouncement_get_timestamp(uint32_t this_ptr) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = UnsignedNodeAnnouncement_get_timestamp(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedNodeAnnouncement_set_timestamp"))) TS_UnsignedNodeAnnouncement_set_timestamp(uint32_t this_ptr, int32_t val) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedNodeAnnouncement_set_timestamp(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_UnsignedNodeAnnouncement_get_node_id"))) TS_UnsignedNodeAnnouncement_get_node_id(uint32_t this_ptr) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, UnsignedNodeAnnouncement_get_node_id(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedNodeAnnouncement_set_node_id"))) TS_UnsignedNodeAnnouncement_set_node_id(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	UnsignedNodeAnnouncement_set_node_id(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_UnsignedNodeAnnouncement_get_rgb"))) TS_UnsignedNodeAnnouncement_get_rgb(uint32_t this_ptr) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(3, __LINE__);
	memcpy(ret_arr->elems, *UnsignedNodeAnnouncement_get_rgb(&this_ptr_conv), 3);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedNodeAnnouncement_set_rgb"))) TS_UnsignedNodeAnnouncement_set_rgb(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThreeBytes val_ref;
	CHECK(val->arr_len == 3);
	memcpy(val_ref.data, val->elems, 3); FREE(val);
	UnsignedNodeAnnouncement_set_rgb(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_UnsignedNodeAnnouncement_get_alias"))) TS_UnsignedNodeAnnouncement_get_alias(uint32_t this_ptr) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UnsignedNodeAnnouncement_get_alias(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedNodeAnnouncement_set_alias"))) TS_UnsignedNodeAnnouncement_set_alias(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UnsignedNodeAnnouncement_set_alias(&this_ptr_conv, val_ref);
}

void  __attribute__((export_name("TS_UnsignedNodeAnnouncement_set_addresses"))) TS_UnsignedNodeAnnouncement_set_addresses(uint32_t this_ptr, uint32_tArray val) {
	LDKUnsignedNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_NetAddressZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKNetAddress), "LDKCVec_NetAddressZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t m = 0; m < val_constr.datalen; m++) {
		uint32_t val_conv_12 = val_vals[m];
		void* val_conv_12_ptr = (void*)(((uintptr_t)val_conv_12) & ~1);
		CHECK_ACCESS(val_conv_12_ptr);
		LDKNetAddress val_conv_12_conv = *(LDKNetAddress*)(val_conv_12_ptr);
		val_conv_12_conv = NetAddress_clone((LDKNetAddress*)(((uintptr_t)val_conv_12) & ~1));
		val_constr.data[m] = val_conv_12_conv;
	}
	UnsignedNodeAnnouncement_set_addresses(&this_ptr_conv, val_constr);
}

static inline uintptr_t UnsignedNodeAnnouncement_clone_ptr(LDKUnsignedNodeAnnouncement *NONNULL_PTR arg) {
	LDKUnsignedNodeAnnouncement ret_var = UnsignedNodeAnnouncement_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UnsignedNodeAnnouncement_clone_ptr"))) TS_UnsignedNodeAnnouncement_clone_ptr(uint32_t arg) {
	LDKUnsignedNodeAnnouncement arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UnsignedNodeAnnouncement_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UnsignedNodeAnnouncement_clone"))) TS_UnsignedNodeAnnouncement_clone(uint32_t orig) {
	LDKUnsignedNodeAnnouncement orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUnsignedNodeAnnouncement ret_var = UnsignedNodeAnnouncement_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_NodeAnnouncement_free"))) TS_NodeAnnouncement_free(uint32_t this_obj) {
	LDKNodeAnnouncement this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	NodeAnnouncement_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_NodeAnnouncement_get_signature"))) TS_NodeAnnouncement_get_signature(uint32_t this_ptr) {
	LDKNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, NodeAnnouncement_get_signature(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_NodeAnnouncement_set_signature"))) TS_NodeAnnouncement_set_signature(uint32_t this_ptr, int8_tArray val) {
	LDKNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	NodeAnnouncement_set_signature(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncement_get_contents"))) TS_NodeAnnouncement_get_contents(uint32_t this_ptr) {
	LDKNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUnsignedNodeAnnouncement ret_var = NodeAnnouncement_get_contents(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_NodeAnnouncement_set_contents"))) TS_NodeAnnouncement_set_contents(uint32_t this_ptr, uint32_t val) {
	LDKNodeAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUnsignedNodeAnnouncement val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = UnsignedNodeAnnouncement_clone(&val_conv);
	NodeAnnouncement_set_contents(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncement_new"))) TS_NodeAnnouncement_new(int8_tArray signature_arg, uint32_t contents_arg) {
	LDKSignature signature_arg_ref;
	CHECK(signature_arg->arr_len == 64);
	memcpy(signature_arg_ref.compact_form, signature_arg->elems, 64); FREE(signature_arg);
	LDKUnsignedNodeAnnouncement contents_arg_conv;
	contents_arg_conv.inner = (void*)(contents_arg & (~1));
	contents_arg_conv.is_owned = (contents_arg & 1) || (contents_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(contents_arg_conv);
	contents_arg_conv = UnsignedNodeAnnouncement_clone(&contents_arg_conv);
	LDKNodeAnnouncement ret_var = NodeAnnouncement_new(signature_arg_ref, contents_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t NodeAnnouncement_clone_ptr(LDKNodeAnnouncement *NONNULL_PTR arg) {
	LDKNodeAnnouncement ret_var = NodeAnnouncement_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_NodeAnnouncement_clone_ptr"))) TS_NodeAnnouncement_clone_ptr(uint32_t arg) {
	LDKNodeAnnouncement arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = NodeAnnouncement_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncement_clone"))) TS_NodeAnnouncement_clone(uint32_t orig) {
	LDKNodeAnnouncement orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKNodeAnnouncement ret_var = NodeAnnouncement_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UnsignedChannelAnnouncement_free"))) TS_UnsignedChannelAnnouncement_free(uint32_t this_obj) {
	LDKUnsignedChannelAnnouncement this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UnsignedChannelAnnouncement_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_UnsignedChannelAnnouncement_get_features"))) TS_UnsignedChannelAnnouncement_get_features(uint32_t this_ptr) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelFeatures ret_var = UnsignedChannelAnnouncement_get_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UnsignedChannelAnnouncement_set_features"))) TS_UnsignedChannelAnnouncement_set_features(uint32_t this_ptr, uint32_t val) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelFeatures_clone(&val_conv);
	UnsignedChannelAnnouncement_set_features(&this_ptr_conv, val_conv);
}

int8_tArray  __attribute__((export_name("TS_UnsignedChannelAnnouncement_get_chain_hash"))) TS_UnsignedChannelAnnouncement_get_chain_hash(uint32_t this_ptr) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UnsignedChannelAnnouncement_get_chain_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedChannelAnnouncement_set_chain_hash"))) TS_UnsignedChannelAnnouncement_set_chain_hash(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UnsignedChannelAnnouncement_set_chain_hash(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_UnsignedChannelAnnouncement_get_short_channel_id"))) TS_UnsignedChannelAnnouncement_get_short_channel_id(uint32_t this_ptr) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = UnsignedChannelAnnouncement_get_short_channel_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedChannelAnnouncement_set_short_channel_id"))) TS_UnsignedChannelAnnouncement_set_short_channel_id(uint32_t this_ptr, int64_t val) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedChannelAnnouncement_set_short_channel_id(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_UnsignedChannelAnnouncement_get_node_id_1"))) TS_UnsignedChannelAnnouncement_get_node_id_1(uint32_t this_ptr) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, UnsignedChannelAnnouncement_get_node_id_1(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedChannelAnnouncement_set_node_id_1"))) TS_UnsignedChannelAnnouncement_set_node_id_1(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	UnsignedChannelAnnouncement_set_node_id_1(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_UnsignedChannelAnnouncement_get_node_id_2"))) TS_UnsignedChannelAnnouncement_get_node_id_2(uint32_t this_ptr) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, UnsignedChannelAnnouncement_get_node_id_2(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedChannelAnnouncement_set_node_id_2"))) TS_UnsignedChannelAnnouncement_set_node_id_2(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	UnsignedChannelAnnouncement_set_node_id_2(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_UnsignedChannelAnnouncement_get_bitcoin_key_1"))) TS_UnsignedChannelAnnouncement_get_bitcoin_key_1(uint32_t this_ptr) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, UnsignedChannelAnnouncement_get_bitcoin_key_1(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedChannelAnnouncement_set_bitcoin_key_1"))) TS_UnsignedChannelAnnouncement_set_bitcoin_key_1(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	UnsignedChannelAnnouncement_set_bitcoin_key_1(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_UnsignedChannelAnnouncement_get_bitcoin_key_2"))) TS_UnsignedChannelAnnouncement_get_bitcoin_key_2(uint32_t this_ptr) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, UnsignedChannelAnnouncement_get_bitcoin_key_2(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedChannelAnnouncement_set_bitcoin_key_2"))) TS_UnsignedChannelAnnouncement_set_bitcoin_key_2(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	UnsignedChannelAnnouncement_set_bitcoin_key_2(&this_ptr_conv, val_ref);
}

static inline uintptr_t UnsignedChannelAnnouncement_clone_ptr(LDKUnsignedChannelAnnouncement *NONNULL_PTR arg) {
	LDKUnsignedChannelAnnouncement ret_var = UnsignedChannelAnnouncement_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UnsignedChannelAnnouncement_clone_ptr"))) TS_UnsignedChannelAnnouncement_clone_ptr(uint32_t arg) {
	LDKUnsignedChannelAnnouncement arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UnsignedChannelAnnouncement_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UnsignedChannelAnnouncement_clone"))) TS_UnsignedChannelAnnouncement_clone(uint32_t orig) {
	LDKUnsignedChannelAnnouncement orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUnsignedChannelAnnouncement ret_var = UnsignedChannelAnnouncement_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelAnnouncement_free"))) TS_ChannelAnnouncement_free(uint32_t this_obj) {
	LDKChannelAnnouncement this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelAnnouncement_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ChannelAnnouncement_get_node_signature_1"))) TS_ChannelAnnouncement_get_node_signature_1(uint32_t this_ptr) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, ChannelAnnouncement_get_node_signature_1(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelAnnouncement_set_node_signature_1"))) TS_ChannelAnnouncement_set_node_signature_1(uint32_t this_ptr, int8_tArray val) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	ChannelAnnouncement_set_node_signature_1(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_ChannelAnnouncement_get_node_signature_2"))) TS_ChannelAnnouncement_get_node_signature_2(uint32_t this_ptr) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, ChannelAnnouncement_get_node_signature_2(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelAnnouncement_set_node_signature_2"))) TS_ChannelAnnouncement_set_node_signature_2(uint32_t this_ptr, int8_tArray val) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	ChannelAnnouncement_set_node_signature_2(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_ChannelAnnouncement_get_bitcoin_signature_1"))) TS_ChannelAnnouncement_get_bitcoin_signature_1(uint32_t this_ptr) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, ChannelAnnouncement_get_bitcoin_signature_1(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelAnnouncement_set_bitcoin_signature_1"))) TS_ChannelAnnouncement_set_bitcoin_signature_1(uint32_t this_ptr, int8_tArray val) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	ChannelAnnouncement_set_bitcoin_signature_1(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_ChannelAnnouncement_get_bitcoin_signature_2"))) TS_ChannelAnnouncement_get_bitcoin_signature_2(uint32_t this_ptr) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, ChannelAnnouncement_get_bitcoin_signature_2(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelAnnouncement_set_bitcoin_signature_2"))) TS_ChannelAnnouncement_set_bitcoin_signature_2(uint32_t this_ptr, int8_tArray val) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	ChannelAnnouncement_set_bitcoin_signature_2(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_ChannelAnnouncement_get_contents"))) TS_ChannelAnnouncement_get_contents(uint32_t this_ptr) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUnsignedChannelAnnouncement ret_var = ChannelAnnouncement_get_contents(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelAnnouncement_set_contents"))) TS_ChannelAnnouncement_set_contents(uint32_t this_ptr, uint32_t val) {
	LDKChannelAnnouncement this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUnsignedChannelAnnouncement val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = UnsignedChannelAnnouncement_clone(&val_conv);
	ChannelAnnouncement_set_contents(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelAnnouncement_new"))) TS_ChannelAnnouncement_new(int8_tArray node_signature_1_arg, int8_tArray node_signature_2_arg, int8_tArray bitcoin_signature_1_arg, int8_tArray bitcoin_signature_2_arg, uint32_t contents_arg) {
	LDKSignature node_signature_1_arg_ref;
	CHECK(node_signature_1_arg->arr_len == 64);
	memcpy(node_signature_1_arg_ref.compact_form, node_signature_1_arg->elems, 64); FREE(node_signature_1_arg);
	LDKSignature node_signature_2_arg_ref;
	CHECK(node_signature_2_arg->arr_len == 64);
	memcpy(node_signature_2_arg_ref.compact_form, node_signature_2_arg->elems, 64); FREE(node_signature_2_arg);
	LDKSignature bitcoin_signature_1_arg_ref;
	CHECK(bitcoin_signature_1_arg->arr_len == 64);
	memcpy(bitcoin_signature_1_arg_ref.compact_form, bitcoin_signature_1_arg->elems, 64); FREE(bitcoin_signature_1_arg);
	LDKSignature bitcoin_signature_2_arg_ref;
	CHECK(bitcoin_signature_2_arg->arr_len == 64);
	memcpy(bitcoin_signature_2_arg_ref.compact_form, bitcoin_signature_2_arg->elems, 64); FREE(bitcoin_signature_2_arg);
	LDKUnsignedChannelAnnouncement contents_arg_conv;
	contents_arg_conv.inner = (void*)(contents_arg & (~1));
	contents_arg_conv.is_owned = (contents_arg & 1) || (contents_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(contents_arg_conv);
	contents_arg_conv = UnsignedChannelAnnouncement_clone(&contents_arg_conv);
	LDKChannelAnnouncement ret_var = ChannelAnnouncement_new(node_signature_1_arg_ref, node_signature_2_arg_ref, bitcoin_signature_1_arg_ref, bitcoin_signature_2_arg_ref, contents_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelAnnouncement_clone_ptr(LDKChannelAnnouncement *NONNULL_PTR arg) {
	LDKChannelAnnouncement ret_var = ChannelAnnouncement_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelAnnouncement_clone_ptr"))) TS_ChannelAnnouncement_clone_ptr(uint32_t arg) {
	LDKChannelAnnouncement arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelAnnouncement_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelAnnouncement_clone"))) TS_ChannelAnnouncement_clone(uint32_t orig) {
	LDKChannelAnnouncement orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelAnnouncement ret_var = ChannelAnnouncement_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_free"))) TS_UnsignedChannelUpdate_free(uint32_t this_obj) {
	LDKUnsignedChannelUpdate this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	UnsignedChannelUpdate_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_UnsignedChannelUpdate_get_chain_hash"))) TS_UnsignedChannelUpdate_get_chain_hash(uint32_t this_ptr) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *UnsignedChannelUpdate_get_chain_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_set_chain_hash"))) TS_UnsignedChannelUpdate_set_chain_hash(uint32_t this_ptr, int8_tArray val) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	UnsignedChannelUpdate_set_chain_hash(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_UnsignedChannelUpdate_get_short_channel_id"))) TS_UnsignedChannelUpdate_get_short_channel_id(uint32_t this_ptr) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = UnsignedChannelUpdate_get_short_channel_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_set_short_channel_id"))) TS_UnsignedChannelUpdate_set_short_channel_id(uint32_t this_ptr, int64_t val) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedChannelUpdate_set_short_channel_id(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_UnsignedChannelUpdate_get_timestamp"))) TS_UnsignedChannelUpdate_get_timestamp(uint32_t this_ptr) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = UnsignedChannelUpdate_get_timestamp(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_set_timestamp"))) TS_UnsignedChannelUpdate_set_timestamp(uint32_t this_ptr, int32_t val) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedChannelUpdate_set_timestamp(&this_ptr_conv, val);
}

int8_t  __attribute__((export_name("TS_UnsignedChannelUpdate_get_flags"))) TS_UnsignedChannelUpdate_get_flags(uint32_t this_ptr) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_t ret_val = UnsignedChannelUpdate_get_flags(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_set_flags"))) TS_UnsignedChannelUpdate_set_flags(uint32_t this_ptr, int8_t val) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedChannelUpdate_set_flags(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_UnsignedChannelUpdate_get_cltv_expiry_delta"))) TS_UnsignedChannelUpdate_get_cltv_expiry_delta(uint32_t this_ptr) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = UnsignedChannelUpdate_get_cltv_expiry_delta(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_set_cltv_expiry_delta"))) TS_UnsignedChannelUpdate_set_cltv_expiry_delta(uint32_t this_ptr, int16_t val) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedChannelUpdate_set_cltv_expiry_delta(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_UnsignedChannelUpdate_get_htlc_minimum_msat"))) TS_UnsignedChannelUpdate_get_htlc_minimum_msat(uint32_t this_ptr) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = UnsignedChannelUpdate_get_htlc_minimum_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_set_htlc_minimum_msat"))) TS_UnsignedChannelUpdate_set_htlc_minimum_msat(uint32_t this_ptr, int64_t val) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedChannelUpdate_set_htlc_minimum_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_UnsignedChannelUpdate_get_fee_base_msat"))) TS_UnsignedChannelUpdate_get_fee_base_msat(uint32_t this_ptr) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = UnsignedChannelUpdate_get_fee_base_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_set_fee_base_msat"))) TS_UnsignedChannelUpdate_set_fee_base_msat(uint32_t this_ptr, int32_t val) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedChannelUpdate_set_fee_base_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_UnsignedChannelUpdate_get_fee_proportional_millionths"))) TS_UnsignedChannelUpdate_get_fee_proportional_millionths(uint32_t this_ptr) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = UnsignedChannelUpdate_get_fee_proportional_millionths(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_UnsignedChannelUpdate_set_fee_proportional_millionths"))) TS_UnsignedChannelUpdate_set_fee_proportional_millionths(uint32_t this_ptr, int32_t val) {
	LDKUnsignedChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	UnsignedChannelUpdate_set_fee_proportional_millionths(&this_ptr_conv, val);
}

static inline uintptr_t UnsignedChannelUpdate_clone_ptr(LDKUnsignedChannelUpdate *NONNULL_PTR arg) {
	LDKUnsignedChannelUpdate ret_var = UnsignedChannelUpdate_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_UnsignedChannelUpdate_clone_ptr"))) TS_UnsignedChannelUpdate_clone_ptr(uint32_t arg) {
	LDKUnsignedChannelUpdate arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = UnsignedChannelUpdate_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_UnsignedChannelUpdate_clone"))) TS_UnsignedChannelUpdate_clone(uint32_t orig) {
	LDKUnsignedChannelUpdate orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKUnsignedChannelUpdate ret_var = UnsignedChannelUpdate_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelUpdate_free"))) TS_ChannelUpdate_free(uint32_t this_obj) {
	LDKChannelUpdate this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelUpdate_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ChannelUpdate_get_signature"))) TS_ChannelUpdate_get_signature(uint32_t this_ptr) {
	LDKChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, ChannelUpdate_get_signature(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelUpdate_set_signature"))) TS_ChannelUpdate_set_signature(uint32_t this_ptr, int8_tArray val) {
	LDKChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	ChannelUpdate_set_signature(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_ChannelUpdate_get_contents"))) TS_ChannelUpdate_get_contents(uint32_t this_ptr) {
	LDKChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUnsignedChannelUpdate ret_var = ChannelUpdate_get_contents(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelUpdate_set_contents"))) TS_ChannelUpdate_set_contents(uint32_t this_ptr, uint32_t val) {
	LDKChannelUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUnsignedChannelUpdate val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = UnsignedChannelUpdate_clone(&val_conv);
	ChannelUpdate_set_contents(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelUpdate_new"))) TS_ChannelUpdate_new(int8_tArray signature_arg, uint32_t contents_arg) {
	LDKSignature signature_arg_ref;
	CHECK(signature_arg->arr_len == 64);
	memcpy(signature_arg_ref.compact_form, signature_arg->elems, 64); FREE(signature_arg);
	LDKUnsignedChannelUpdate contents_arg_conv;
	contents_arg_conv.inner = (void*)(contents_arg & (~1));
	contents_arg_conv.is_owned = (contents_arg & 1) || (contents_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(contents_arg_conv);
	contents_arg_conv = UnsignedChannelUpdate_clone(&contents_arg_conv);
	LDKChannelUpdate ret_var = ChannelUpdate_new(signature_arg_ref, contents_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelUpdate_clone_ptr(LDKChannelUpdate *NONNULL_PTR arg) {
	LDKChannelUpdate ret_var = ChannelUpdate_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelUpdate_clone_ptr"))) TS_ChannelUpdate_clone_ptr(uint32_t arg) {
	LDKChannelUpdate arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelUpdate_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelUpdate_clone"))) TS_ChannelUpdate_clone(uint32_t orig) {
	LDKChannelUpdate orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelUpdate ret_var = ChannelUpdate_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_QueryChannelRange_free"))) TS_QueryChannelRange_free(uint32_t this_obj) {
	LDKQueryChannelRange this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	QueryChannelRange_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_QueryChannelRange_get_chain_hash"))) TS_QueryChannelRange_get_chain_hash(uint32_t this_ptr) {
	LDKQueryChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *QueryChannelRange_get_chain_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_QueryChannelRange_set_chain_hash"))) TS_QueryChannelRange_set_chain_hash(uint32_t this_ptr, int8_tArray val) {
	LDKQueryChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	QueryChannelRange_set_chain_hash(&this_ptr_conv, val_ref);
}

int32_t  __attribute__((export_name("TS_QueryChannelRange_get_first_blocknum"))) TS_QueryChannelRange_get_first_blocknum(uint32_t this_ptr) {
	LDKQueryChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = QueryChannelRange_get_first_blocknum(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_QueryChannelRange_set_first_blocknum"))) TS_QueryChannelRange_set_first_blocknum(uint32_t this_ptr, int32_t val) {
	LDKQueryChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	QueryChannelRange_set_first_blocknum(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_QueryChannelRange_get_number_of_blocks"))) TS_QueryChannelRange_get_number_of_blocks(uint32_t this_ptr) {
	LDKQueryChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = QueryChannelRange_get_number_of_blocks(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_QueryChannelRange_set_number_of_blocks"))) TS_QueryChannelRange_set_number_of_blocks(uint32_t this_ptr, int32_t val) {
	LDKQueryChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	QueryChannelRange_set_number_of_blocks(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_QueryChannelRange_new"))) TS_QueryChannelRange_new(int8_tArray chain_hash_arg, int32_t first_blocknum_arg, int32_t number_of_blocks_arg) {
	LDKThirtyTwoBytes chain_hash_arg_ref;
	CHECK(chain_hash_arg->arr_len == 32);
	memcpy(chain_hash_arg_ref.data, chain_hash_arg->elems, 32); FREE(chain_hash_arg);
	LDKQueryChannelRange ret_var = QueryChannelRange_new(chain_hash_arg_ref, first_blocknum_arg, number_of_blocks_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t QueryChannelRange_clone_ptr(LDKQueryChannelRange *NONNULL_PTR arg) {
	LDKQueryChannelRange ret_var = QueryChannelRange_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_QueryChannelRange_clone_ptr"))) TS_QueryChannelRange_clone_ptr(uint32_t arg) {
	LDKQueryChannelRange arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = QueryChannelRange_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_QueryChannelRange_clone"))) TS_QueryChannelRange_clone(uint32_t orig) {
	LDKQueryChannelRange orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKQueryChannelRange ret_var = QueryChannelRange_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ReplyChannelRange_free"))) TS_ReplyChannelRange_free(uint32_t this_obj) {
	LDKReplyChannelRange this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ReplyChannelRange_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ReplyChannelRange_get_chain_hash"))) TS_ReplyChannelRange_get_chain_hash(uint32_t this_ptr) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *ReplyChannelRange_get_chain_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_ReplyChannelRange_set_chain_hash"))) TS_ReplyChannelRange_set_chain_hash(uint32_t this_ptr, int8_tArray val) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	ReplyChannelRange_set_chain_hash(&this_ptr_conv, val_ref);
}

int32_t  __attribute__((export_name("TS_ReplyChannelRange_get_first_blocknum"))) TS_ReplyChannelRange_get_first_blocknum(uint32_t this_ptr) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = ReplyChannelRange_get_first_blocknum(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ReplyChannelRange_set_first_blocknum"))) TS_ReplyChannelRange_set_first_blocknum(uint32_t this_ptr, int32_t val) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ReplyChannelRange_set_first_blocknum(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_ReplyChannelRange_get_number_of_blocks"))) TS_ReplyChannelRange_get_number_of_blocks(uint32_t this_ptr) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = ReplyChannelRange_get_number_of_blocks(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ReplyChannelRange_set_number_of_blocks"))) TS_ReplyChannelRange_set_number_of_blocks(uint32_t this_ptr, int32_t val) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ReplyChannelRange_set_number_of_blocks(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ReplyChannelRange_get_sync_complete"))) TS_ReplyChannelRange_get_sync_complete(uint32_t this_ptr) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ReplyChannelRange_get_sync_complete(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ReplyChannelRange_set_sync_complete"))) TS_ReplyChannelRange_set_sync_complete(uint32_t this_ptr, jboolean val) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ReplyChannelRange_set_sync_complete(&this_ptr_conv, val);
}

void  __attribute__((export_name("TS_ReplyChannelRange_set_short_channel_ids"))) TS_ReplyChannelRange_set_short_channel_ids(uint32_t this_ptr, int64_tArray val) {
	LDKReplyChannelRange this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_u64Z val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(int64_t), "LDKCVec_u64Z Elements");
	else
		val_constr.data = NULL;
	int64_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t i = 0; i < val_constr.datalen; i++) {
		int64_t val_conv_8 = val_vals[i];
		val_constr.data[i] = val_conv_8;
	}
	ReplyChannelRange_set_short_channel_ids(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_ReplyChannelRange_new"))) TS_ReplyChannelRange_new(int8_tArray chain_hash_arg, int32_t first_blocknum_arg, int32_t number_of_blocks_arg, jboolean sync_complete_arg, int64_tArray short_channel_ids_arg) {
	LDKThirtyTwoBytes chain_hash_arg_ref;
	CHECK(chain_hash_arg->arr_len == 32);
	memcpy(chain_hash_arg_ref.data, chain_hash_arg->elems, 32); FREE(chain_hash_arg);
	LDKCVec_u64Z short_channel_ids_arg_constr;
	short_channel_ids_arg_constr.datalen = short_channel_ids_arg->arr_len;
	if (short_channel_ids_arg_constr.datalen > 0)
		short_channel_ids_arg_constr.data = MALLOC(short_channel_ids_arg_constr.datalen * sizeof(int64_t), "LDKCVec_u64Z Elements");
	else
		short_channel_ids_arg_constr.data = NULL;
	int64_t* short_channel_ids_arg_vals = short_channel_ids_arg->elems /* XXX short_channel_ids_arg leaks */;
	for (size_t i = 0; i < short_channel_ids_arg_constr.datalen; i++) {
		int64_t short_channel_ids_arg_conv_8 = short_channel_ids_arg_vals[i];
		short_channel_ids_arg_constr.data[i] = short_channel_ids_arg_conv_8;
	}
	LDKReplyChannelRange ret_var = ReplyChannelRange_new(chain_hash_arg_ref, first_blocknum_arg, number_of_blocks_arg, sync_complete_arg, short_channel_ids_arg_constr);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ReplyChannelRange_clone_ptr(LDKReplyChannelRange *NONNULL_PTR arg) {
	LDKReplyChannelRange ret_var = ReplyChannelRange_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ReplyChannelRange_clone_ptr"))) TS_ReplyChannelRange_clone_ptr(uint32_t arg) {
	LDKReplyChannelRange arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ReplyChannelRange_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ReplyChannelRange_clone"))) TS_ReplyChannelRange_clone(uint32_t orig) {
	LDKReplyChannelRange orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKReplyChannelRange ret_var = ReplyChannelRange_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_QueryShortChannelIds_free"))) TS_QueryShortChannelIds_free(uint32_t this_obj) {
	LDKQueryShortChannelIds this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	QueryShortChannelIds_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_QueryShortChannelIds_get_chain_hash"))) TS_QueryShortChannelIds_get_chain_hash(uint32_t this_ptr) {
	LDKQueryShortChannelIds this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *QueryShortChannelIds_get_chain_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_QueryShortChannelIds_set_chain_hash"))) TS_QueryShortChannelIds_set_chain_hash(uint32_t this_ptr, int8_tArray val) {
	LDKQueryShortChannelIds this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	QueryShortChannelIds_set_chain_hash(&this_ptr_conv, val_ref);
}

void  __attribute__((export_name("TS_QueryShortChannelIds_set_short_channel_ids"))) TS_QueryShortChannelIds_set_short_channel_ids(uint32_t this_ptr, int64_tArray val) {
	LDKQueryShortChannelIds this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_u64Z val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(int64_t), "LDKCVec_u64Z Elements");
	else
		val_constr.data = NULL;
	int64_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t i = 0; i < val_constr.datalen; i++) {
		int64_t val_conv_8 = val_vals[i];
		val_constr.data[i] = val_conv_8;
	}
	QueryShortChannelIds_set_short_channel_ids(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_QueryShortChannelIds_new"))) TS_QueryShortChannelIds_new(int8_tArray chain_hash_arg, int64_tArray short_channel_ids_arg) {
	LDKThirtyTwoBytes chain_hash_arg_ref;
	CHECK(chain_hash_arg->arr_len == 32);
	memcpy(chain_hash_arg_ref.data, chain_hash_arg->elems, 32); FREE(chain_hash_arg);
	LDKCVec_u64Z short_channel_ids_arg_constr;
	short_channel_ids_arg_constr.datalen = short_channel_ids_arg->arr_len;
	if (short_channel_ids_arg_constr.datalen > 0)
		short_channel_ids_arg_constr.data = MALLOC(short_channel_ids_arg_constr.datalen * sizeof(int64_t), "LDKCVec_u64Z Elements");
	else
		short_channel_ids_arg_constr.data = NULL;
	int64_t* short_channel_ids_arg_vals = short_channel_ids_arg->elems /* XXX short_channel_ids_arg leaks */;
	for (size_t i = 0; i < short_channel_ids_arg_constr.datalen; i++) {
		int64_t short_channel_ids_arg_conv_8 = short_channel_ids_arg_vals[i];
		short_channel_ids_arg_constr.data[i] = short_channel_ids_arg_conv_8;
	}
	LDKQueryShortChannelIds ret_var = QueryShortChannelIds_new(chain_hash_arg_ref, short_channel_ids_arg_constr);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t QueryShortChannelIds_clone_ptr(LDKQueryShortChannelIds *NONNULL_PTR arg) {
	LDKQueryShortChannelIds ret_var = QueryShortChannelIds_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_QueryShortChannelIds_clone_ptr"))) TS_QueryShortChannelIds_clone_ptr(uint32_t arg) {
	LDKQueryShortChannelIds arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = QueryShortChannelIds_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_QueryShortChannelIds_clone"))) TS_QueryShortChannelIds_clone(uint32_t orig) {
	LDKQueryShortChannelIds orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKQueryShortChannelIds ret_var = QueryShortChannelIds_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_free"))) TS_ReplyShortChannelIdsEnd_free(uint32_t this_obj) {
	LDKReplyShortChannelIdsEnd this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ReplyShortChannelIdsEnd_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_get_chain_hash"))) TS_ReplyShortChannelIdsEnd_get_chain_hash(uint32_t this_ptr) {
	LDKReplyShortChannelIdsEnd this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *ReplyShortChannelIdsEnd_get_chain_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_set_chain_hash"))) TS_ReplyShortChannelIdsEnd_set_chain_hash(uint32_t this_ptr, int8_tArray val) {
	LDKReplyShortChannelIdsEnd this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	ReplyShortChannelIdsEnd_set_chain_hash(&this_ptr_conv, val_ref);
}

jboolean  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_get_full_information"))) TS_ReplyShortChannelIdsEnd_get_full_information(uint32_t this_ptr) {
	LDKReplyShortChannelIdsEnd this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ReplyShortChannelIdsEnd_get_full_information(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_set_full_information"))) TS_ReplyShortChannelIdsEnd_set_full_information(uint32_t this_ptr, jboolean val) {
	LDKReplyShortChannelIdsEnd this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ReplyShortChannelIdsEnd_set_full_information(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_new"))) TS_ReplyShortChannelIdsEnd_new(int8_tArray chain_hash_arg, jboolean full_information_arg) {
	LDKThirtyTwoBytes chain_hash_arg_ref;
	CHECK(chain_hash_arg->arr_len == 32);
	memcpy(chain_hash_arg_ref.data, chain_hash_arg->elems, 32); FREE(chain_hash_arg);
	LDKReplyShortChannelIdsEnd ret_var = ReplyShortChannelIdsEnd_new(chain_hash_arg_ref, full_information_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ReplyShortChannelIdsEnd_clone_ptr(LDKReplyShortChannelIdsEnd *NONNULL_PTR arg) {
	LDKReplyShortChannelIdsEnd ret_var = ReplyShortChannelIdsEnd_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_clone_ptr"))) TS_ReplyShortChannelIdsEnd_clone_ptr(uint32_t arg) {
	LDKReplyShortChannelIdsEnd arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ReplyShortChannelIdsEnd_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_clone"))) TS_ReplyShortChannelIdsEnd_clone(uint32_t orig) {
	LDKReplyShortChannelIdsEnd orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKReplyShortChannelIdsEnd ret_var = ReplyShortChannelIdsEnd_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_GossipTimestampFilter_free"))) TS_GossipTimestampFilter_free(uint32_t this_obj) {
	LDKGossipTimestampFilter this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	GossipTimestampFilter_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_GossipTimestampFilter_get_chain_hash"))) TS_GossipTimestampFilter_get_chain_hash(uint32_t this_ptr) {
	LDKGossipTimestampFilter this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *GossipTimestampFilter_get_chain_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_GossipTimestampFilter_set_chain_hash"))) TS_GossipTimestampFilter_set_chain_hash(uint32_t this_ptr, int8_tArray val) {
	LDKGossipTimestampFilter this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	GossipTimestampFilter_set_chain_hash(&this_ptr_conv, val_ref);
}

int32_t  __attribute__((export_name("TS_GossipTimestampFilter_get_first_timestamp"))) TS_GossipTimestampFilter_get_first_timestamp(uint32_t this_ptr) {
	LDKGossipTimestampFilter this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = GossipTimestampFilter_get_first_timestamp(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_GossipTimestampFilter_set_first_timestamp"))) TS_GossipTimestampFilter_set_first_timestamp(uint32_t this_ptr, int32_t val) {
	LDKGossipTimestampFilter this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	GossipTimestampFilter_set_first_timestamp(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_GossipTimestampFilter_get_timestamp_range"))) TS_GossipTimestampFilter_get_timestamp_range(uint32_t this_ptr) {
	LDKGossipTimestampFilter this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = GossipTimestampFilter_get_timestamp_range(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_GossipTimestampFilter_set_timestamp_range"))) TS_GossipTimestampFilter_set_timestamp_range(uint32_t this_ptr, int32_t val) {
	LDKGossipTimestampFilter this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	GossipTimestampFilter_set_timestamp_range(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_GossipTimestampFilter_new"))) TS_GossipTimestampFilter_new(int8_tArray chain_hash_arg, int32_t first_timestamp_arg, int32_t timestamp_range_arg) {
	LDKThirtyTwoBytes chain_hash_arg_ref;
	CHECK(chain_hash_arg->arr_len == 32);
	memcpy(chain_hash_arg_ref.data, chain_hash_arg->elems, 32); FREE(chain_hash_arg);
	LDKGossipTimestampFilter ret_var = GossipTimestampFilter_new(chain_hash_arg_ref, first_timestamp_arg, timestamp_range_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t GossipTimestampFilter_clone_ptr(LDKGossipTimestampFilter *NONNULL_PTR arg) {
	LDKGossipTimestampFilter ret_var = GossipTimestampFilter_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_GossipTimestampFilter_clone_ptr"))) TS_GossipTimestampFilter_clone_ptr(uint32_t arg) {
	LDKGossipTimestampFilter arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = GossipTimestampFilter_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_GossipTimestampFilter_clone"))) TS_GossipTimestampFilter_clone(uint32_t orig) {
	LDKGossipTimestampFilter orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKGossipTimestampFilter ret_var = GossipTimestampFilter_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ErrorAction_free"))) TS_ErrorAction_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKErrorAction this_ptr_conv = *(LDKErrorAction*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	ErrorAction_free(this_ptr_conv);
}

static inline uintptr_t ErrorAction_clone_ptr(LDKErrorAction *NONNULL_PTR arg) {
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = ErrorAction_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ErrorAction_clone_ptr"))) TS_ErrorAction_clone_ptr(uint32_t arg) {
	LDKErrorAction* arg_conv = (LDKErrorAction*)arg;
	uint32_t ret_val = ErrorAction_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ErrorAction_clone"))) TS_ErrorAction_clone(uint32_t orig) {
	LDKErrorAction* orig_conv = (LDKErrorAction*)orig;
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = ErrorAction_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ErrorAction_disconnect_peer"))) TS_ErrorAction_disconnect_peer(uint32_t msg) {
	LDKErrorMessage msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ErrorMessage_clone(&msg_conv);
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = ErrorAction_disconnect_peer(msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ErrorAction_ignore_error"))) TS_ErrorAction_ignore_error() {
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = ErrorAction_ignore_error();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ErrorAction_ignore_and_log"))) TS_ErrorAction_ignore_and_log(uint32_t a) {
	LDKLevel a_conv = LDKLevel_from_js(a);
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = ErrorAction_ignore_and_log(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ErrorAction_ignore_duplicate_gossip"))) TS_ErrorAction_ignore_duplicate_gossip() {
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = ErrorAction_ignore_duplicate_gossip();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ErrorAction_send_error_message"))) TS_ErrorAction_send_error_message(uint32_t msg) {
	LDKErrorMessage msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ErrorMessage_clone(&msg_conv);
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = ErrorAction_send_error_message(msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ErrorAction_send_warning_message"))) TS_ErrorAction_send_warning_message(uint32_t msg, uint32_t log_level) {
	LDKWarningMessage msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = WarningMessage_clone(&msg_conv);
	LDKLevel log_level_conv = LDKLevel_from_js(log_level);
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = ErrorAction_send_warning_message(msg_conv, log_level_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_LightningError_free"))) TS_LightningError_free(uint32_t this_obj) {
	LDKLightningError this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	LightningError_free(this_obj_conv);
}

jstring  __attribute__((export_name("TS_LightningError_get_err"))) TS_LightningError_get_err(uint32_t this_ptr) {
	LDKLightningError this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr ret_str = LightningError_get_err(&this_ptr_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

void  __attribute__((export_name("TS_LightningError_set_err"))) TS_LightningError_set_err(uint32_t this_ptr, jstring val) {
	LDKLightningError this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKStr val_conv = str_ref_to_owned_c(val);
	LightningError_set_err(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_LightningError_get_action"))) TS_LightningError_get_action(uint32_t this_ptr) {
	LDKLightningError this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKErrorAction *ret_copy = MALLOC(sizeof(LDKErrorAction), "LDKErrorAction");
	*ret_copy = LightningError_get_action(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_LightningError_set_action"))) TS_LightningError_set_action(uint32_t this_ptr, uint32_t val) {
	LDKLightningError this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKErrorAction val_conv = *(LDKErrorAction*)(val_ptr);
	val_conv = ErrorAction_clone((LDKErrorAction*)(((uintptr_t)val) & ~1));
	LightningError_set_action(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_LightningError_new"))) TS_LightningError_new(jstring err_arg, uint32_t action_arg) {
	LDKStr err_arg_conv = str_ref_to_owned_c(err_arg);
	void* action_arg_ptr = (void*)(((uintptr_t)action_arg) & ~1);
	CHECK_ACCESS(action_arg_ptr);
	LDKErrorAction action_arg_conv = *(LDKErrorAction*)(action_arg_ptr);
	action_arg_conv = ErrorAction_clone((LDKErrorAction*)(((uintptr_t)action_arg) & ~1));
	LDKLightningError ret_var = LightningError_new(err_arg_conv, action_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t LightningError_clone_ptr(LDKLightningError *NONNULL_PTR arg) {
	LDKLightningError ret_var = LightningError_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_LightningError_clone_ptr"))) TS_LightningError_clone_ptr(uint32_t arg) {
	LDKLightningError arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = LightningError_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_LightningError_clone"))) TS_LightningError_clone(uint32_t orig) {
	LDKLightningError orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKLightningError ret_var = LightningError_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_CommitmentUpdate_free"))) TS_CommitmentUpdate_free(uint32_t this_obj) {
	LDKCommitmentUpdate this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	CommitmentUpdate_free(this_obj_conv);
}

uint32_tArray  __attribute__((export_name("TS_CommitmentUpdate_get_update_add_htlcs"))) TS_CommitmentUpdate_get_update_add_htlcs(uint32_t this_ptr) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_UpdateAddHTLCZ ret_var = CommitmentUpdate_get_update_add_htlcs(&this_ptr_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t p = 0; p < ret_var.datalen; p++) {
		LDKUpdateAddHTLC ret_conv_15_var = ret_var.data[p];
		uint32_t ret_conv_15_ref = 0;
		CHECK((((uintptr_t)ret_conv_15_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_15_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_15_var);
		ret_conv_15_ref = (uintptr_t)ret_conv_15_var.inner;
		if (ret_conv_15_var.is_owned) {
			ret_conv_15_ref |= 1;
		}
		ret_arr_ptr[p] = ret_conv_15_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_CommitmentUpdate_set_update_add_htlcs"))) TS_CommitmentUpdate_set_update_add_htlcs(uint32_t this_ptr, uint32_tArray val) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_UpdateAddHTLCZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKUpdateAddHTLC), "LDKCVec_UpdateAddHTLCZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t p = 0; p < val_constr.datalen; p++) {
		uint32_t val_conv_15 = val_vals[p];
		LDKUpdateAddHTLC val_conv_15_conv;
		val_conv_15_conv.inner = (void*)(val_conv_15 & (~1));
		val_conv_15_conv.is_owned = (val_conv_15 & 1) || (val_conv_15 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv_15_conv);
		val_conv_15_conv = UpdateAddHTLC_clone(&val_conv_15_conv);
		val_constr.data[p] = val_conv_15_conv;
	}
	CommitmentUpdate_set_update_add_htlcs(&this_ptr_conv, val_constr);
}

uint32_tArray  __attribute__((export_name("TS_CommitmentUpdate_get_update_fulfill_htlcs"))) TS_CommitmentUpdate_get_update_fulfill_htlcs(uint32_t this_ptr) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_UpdateFulfillHTLCZ ret_var = CommitmentUpdate_get_update_fulfill_htlcs(&this_ptr_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t t = 0; t < ret_var.datalen; t++) {
		LDKUpdateFulfillHTLC ret_conv_19_var = ret_var.data[t];
		uint32_t ret_conv_19_ref = 0;
		CHECK((((uintptr_t)ret_conv_19_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_19_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_19_var);
		ret_conv_19_ref = (uintptr_t)ret_conv_19_var.inner;
		if (ret_conv_19_var.is_owned) {
			ret_conv_19_ref |= 1;
		}
		ret_arr_ptr[t] = ret_conv_19_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_CommitmentUpdate_set_update_fulfill_htlcs"))) TS_CommitmentUpdate_set_update_fulfill_htlcs(uint32_t this_ptr, uint32_tArray val) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_UpdateFulfillHTLCZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKUpdateFulfillHTLC), "LDKCVec_UpdateFulfillHTLCZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t t = 0; t < val_constr.datalen; t++) {
		uint32_t val_conv_19 = val_vals[t];
		LDKUpdateFulfillHTLC val_conv_19_conv;
		val_conv_19_conv.inner = (void*)(val_conv_19 & (~1));
		val_conv_19_conv.is_owned = (val_conv_19 & 1) || (val_conv_19 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv_19_conv);
		val_conv_19_conv = UpdateFulfillHTLC_clone(&val_conv_19_conv);
		val_constr.data[t] = val_conv_19_conv;
	}
	CommitmentUpdate_set_update_fulfill_htlcs(&this_ptr_conv, val_constr);
}

uint32_tArray  __attribute__((export_name("TS_CommitmentUpdate_get_update_fail_htlcs"))) TS_CommitmentUpdate_get_update_fail_htlcs(uint32_t this_ptr) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_UpdateFailHTLCZ ret_var = CommitmentUpdate_get_update_fail_htlcs(&this_ptr_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t q = 0; q < ret_var.datalen; q++) {
		LDKUpdateFailHTLC ret_conv_16_var = ret_var.data[q];
		uint32_t ret_conv_16_ref = 0;
		CHECK((((uintptr_t)ret_conv_16_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_16_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_16_var);
		ret_conv_16_ref = (uintptr_t)ret_conv_16_var.inner;
		if (ret_conv_16_var.is_owned) {
			ret_conv_16_ref |= 1;
		}
		ret_arr_ptr[q] = ret_conv_16_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_CommitmentUpdate_set_update_fail_htlcs"))) TS_CommitmentUpdate_set_update_fail_htlcs(uint32_t this_ptr, uint32_tArray val) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_UpdateFailHTLCZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKUpdateFailHTLC), "LDKCVec_UpdateFailHTLCZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t q = 0; q < val_constr.datalen; q++) {
		uint32_t val_conv_16 = val_vals[q];
		LDKUpdateFailHTLC val_conv_16_conv;
		val_conv_16_conv.inner = (void*)(val_conv_16 & (~1));
		val_conv_16_conv.is_owned = (val_conv_16 & 1) || (val_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv_16_conv);
		val_conv_16_conv = UpdateFailHTLC_clone(&val_conv_16_conv);
		val_constr.data[q] = val_conv_16_conv;
	}
	CommitmentUpdate_set_update_fail_htlcs(&this_ptr_conv, val_constr);
}

uint32_tArray  __attribute__((export_name("TS_CommitmentUpdate_get_update_fail_malformed_htlcs"))) TS_CommitmentUpdate_get_update_fail_malformed_htlcs(uint32_t this_ptr) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_UpdateFailMalformedHTLCZ ret_var = CommitmentUpdate_get_update_fail_malformed_htlcs(&this_ptr_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t z = 0; z < ret_var.datalen; z++) {
		LDKUpdateFailMalformedHTLC ret_conv_25_var = ret_var.data[z];
		uint32_t ret_conv_25_ref = 0;
		CHECK((((uintptr_t)ret_conv_25_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_25_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_25_var);
		ret_conv_25_ref = (uintptr_t)ret_conv_25_var.inner;
		if (ret_conv_25_var.is_owned) {
			ret_conv_25_ref |= 1;
		}
		ret_arr_ptr[z] = ret_conv_25_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_CommitmentUpdate_set_update_fail_malformed_htlcs"))) TS_CommitmentUpdate_set_update_fail_malformed_htlcs(uint32_t this_ptr, uint32_tArray val) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_UpdateFailMalformedHTLCZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKUpdateFailMalformedHTLC), "LDKCVec_UpdateFailMalformedHTLCZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t z = 0; z < val_constr.datalen; z++) {
		uint32_t val_conv_25 = val_vals[z];
		LDKUpdateFailMalformedHTLC val_conv_25_conv;
		val_conv_25_conv.inner = (void*)(val_conv_25 & (~1));
		val_conv_25_conv.is_owned = (val_conv_25 & 1) || (val_conv_25 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv_25_conv);
		val_conv_25_conv = UpdateFailMalformedHTLC_clone(&val_conv_25_conv);
		val_constr.data[z] = val_conv_25_conv;
	}
	CommitmentUpdate_set_update_fail_malformed_htlcs(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_CommitmentUpdate_get_update_fee"))) TS_CommitmentUpdate_get_update_fee(uint32_t this_ptr) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUpdateFee ret_var = CommitmentUpdate_get_update_fee(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_CommitmentUpdate_set_update_fee"))) TS_CommitmentUpdate_set_update_fee(uint32_t this_ptr, uint32_t val) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKUpdateFee val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = UpdateFee_clone(&val_conv);
	CommitmentUpdate_set_update_fee(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_CommitmentUpdate_get_commitment_signed"))) TS_CommitmentUpdate_get_commitment_signed(uint32_t this_ptr) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCommitmentSigned ret_var = CommitmentUpdate_get_commitment_signed(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_CommitmentUpdate_set_commitment_signed"))) TS_CommitmentUpdate_set_commitment_signed(uint32_t this_ptr, uint32_t val) {
	LDKCommitmentUpdate this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCommitmentSigned val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = CommitmentSigned_clone(&val_conv);
	CommitmentUpdate_set_commitment_signed(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_CommitmentUpdate_new"))) TS_CommitmentUpdate_new(uint32_tArray update_add_htlcs_arg, uint32_tArray update_fulfill_htlcs_arg, uint32_tArray update_fail_htlcs_arg, uint32_tArray update_fail_malformed_htlcs_arg, uint32_t update_fee_arg, uint32_t commitment_signed_arg) {
	LDKCVec_UpdateAddHTLCZ update_add_htlcs_arg_constr;
	update_add_htlcs_arg_constr.datalen = update_add_htlcs_arg->arr_len;
	if (update_add_htlcs_arg_constr.datalen > 0)
		update_add_htlcs_arg_constr.data = MALLOC(update_add_htlcs_arg_constr.datalen * sizeof(LDKUpdateAddHTLC), "LDKCVec_UpdateAddHTLCZ Elements");
	else
		update_add_htlcs_arg_constr.data = NULL;
	uint32_t* update_add_htlcs_arg_vals = update_add_htlcs_arg->elems /* XXX update_add_htlcs_arg leaks */;
	for (size_t p = 0; p < update_add_htlcs_arg_constr.datalen; p++) {
		uint32_t update_add_htlcs_arg_conv_15 = update_add_htlcs_arg_vals[p];
		LDKUpdateAddHTLC update_add_htlcs_arg_conv_15_conv;
		update_add_htlcs_arg_conv_15_conv.inner = (void*)(update_add_htlcs_arg_conv_15 & (~1));
		update_add_htlcs_arg_conv_15_conv.is_owned = (update_add_htlcs_arg_conv_15 & 1) || (update_add_htlcs_arg_conv_15 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(update_add_htlcs_arg_conv_15_conv);
		update_add_htlcs_arg_conv_15_conv = UpdateAddHTLC_clone(&update_add_htlcs_arg_conv_15_conv);
		update_add_htlcs_arg_constr.data[p] = update_add_htlcs_arg_conv_15_conv;
	}
	LDKCVec_UpdateFulfillHTLCZ update_fulfill_htlcs_arg_constr;
	update_fulfill_htlcs_arg_constr.datalen = update_fulfill_htlcs_arg->arr_len;
	if (update_fulfill_htlcs_arg_constr.datalen > 0)
		update_fulfill_htlcs_arg_constr.data = MALLOC(update_fulfill_htlcs_arg_constr.datalen * sizeof(LDKUpdateFulfillHTLC), "LDKCVec_UpdateFulfillHTLCZ Elements");
	else
		update_fulfill_htlcs_arg_constr.data = NULL;
	uint32_t* update_fulfill_htlcs_arg_vals = update_fulfill_htlcs_arg->elems /* XXX update_fulfill_htlcs_arg leaks */;
	for (size_t t = 0; t < update_fulfill_htlcs_arg_constr.datalen; t++) {
		uint32_t update_fulfill_htlcs_arg_conv_19 = update_fulfill_htlcs_arg_vals[t];
		LDKUpdateFulfillHTLC update_fulfill_htlcs_arg_conv_19_conv;
		update_fulfill_htlcs_arg_conv_19_conv.inner = (void*)(update_fulfill_htlcs_arg_conv_19 & (~1));
		update_fulfill_htlcs_arg_conv_19_conv.is_owned = (update_fulfill_htlcs_arg_conv_19 & 1) || (update_fulfill_htlcs_arg_conv_19 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(update_fulfill_htlcs_arg_conv_19_conv);
		update_fulfill_htlcs_arg_conv_19_conv = UpdateFulfillHTLC_clone(&update_fulfill_htlcs_arg_conv_19_conv);
		update_fulfill_htlcs_arg_constr.data[t] = update_fulfill_htlcs_arg_conv_19_conv;
	}
	LDKCVec_UpdateFailHTLCZ update_fail_htlcs_arg_constr;
	update_fail_htlcs_arg_constr.datalen = update_fail_htlcs_arg->arr_len;
	if (update_fail_htlcs_arg_constr.datalen > 0)
		update_fail_htlcs_arg_constr.data = MALLOC(update_fail_htlcs_arg_constr.datalen * sizeof(LDKUpdateFailHTLC), "LDKCVec_UpdateFailHTLCZ Elements");
	else
		update_fail_htlcs_arg_constr.data = NULL;
	uint32_t* update_fail_htlcs_arg_vals = update_fail_htlcs_arg->elems /* XXX update_fail_htlcs_arg leaks */;
	for (size_t q = 0; q < update_fail_htlcs_arg_constr.datalen; q++) {
		uint32_t update_fail_htlcs_arg_conv_16 = update_fail_htlcs_arg_vals[q];
		LDKUpdateFailHTLC update_fail_htlcs_arg_conv_16_conv;
		update_fail_htlcs_arg_conv_16_conv.inner = (void*)(update_fail_htlcs_arg_conv_16 & (~1));
		update_fail_htlcs_arg_conv_16_conv.is_owned = (update_fail_htlcs_arg_conv_16 & 1) || (update_fail_htlcs_arg_conv_16 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(update_fail_htlcs_arg_conv_16_conv);
		update_fail_htlcs_arg_conv_16_conv = UpdateFailHTLC_clone(&update_fail_htlcs_arg_conv_16_conv);
		update_fail_htlcs_arg_constr.data[q] = update_fail_htlcs_arg_conv_16_conv;
	}
	LDKCVec_UpdateFailMalformedHTLCZ update_fail_malformed_htlcs_arg_constr;
	update_fail_malformed_htlcs_arg_constr.datalen = update_fail_malformed_htlcs_arg->arr_len;
	if (update_fail_malformed_htlcs_arg_constr.datalen > 0)
		update_fail_malformed_htlcs_arg_constr.data = MALLOC(update_fail_malformed_htlcs_arg_constr.datalen * sizeof(LDKUpdateFailMalformedHTLC), "LDKCVec_UpdateFailMalformedHTLCZ Elements");
	else
		update_fail_malformed_htlcs_arg_constr.data = NULL;
	uint32_t* update_fail_malformed_htlcs_arg_vals = update_fail_malformed_htlcs_arg->elems /* XXX update_fail_malformed_htlcs_arg leaks */;
	for (size_t z = 0; z < update_fail_malformed_htlcs_arg_constr.datalen; z++) {
		uint32_t update_fail_malformed_htlcs_arg_conv_25 = update_fail_malformed_htlcs_arg_vals[z];
		LDKUpdateFailMalformedHTLC update_fail_malformed_htlcs_arg_conv_25_conv;
		update_fail_malformed_htlcs_arg_conv_25_conv.inner = (void*)(update_fail_malformed_htlcs_arg_conv_25 & (~1));
		update_fail_malformed_htlcs_arg_conv_25_conv.is_owned = (update_fail_malformed_htlcs_arg_conv_25 & 1) || (update_fail_malformed_htlcs_arg_conv_25 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(update_fail_malformed_htlcs_arg_conv_25_conv);
		update_fail_malformed_htlcs_arg_conv_25_conv = UpdateFailMalformedHTLC_clone(&update_fail_malformed_htlcs_arg_conv_25_conv);
		update_fail_malformed_htlcs_arg_constr.data[z] = update_fail_malformed_htlcs_arg_conv_25_conv;
	}
	LDKUpdateFee update_fee_arg_conv;
	update_fee_arg_conv.inner = (void*)(update_fee_arg & (~1));
	update_fee_arg_conv.is_owned = (update_fee_arg & 1) || (update_fee_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(update_fee_arg_conv);
	update_fee_arg_conv = UpdateFee_clone(&update_fee_arg_conv);
	LDKCommitmentSigned commitment_signed_arg_conv;
	commitment_signed_arg_conv.inner = (void*)(commitment_signed_arg & (~1));
	commitment_signed_arg_conv.is_owned = (commitment_signed_arg & 1) || (commitment_signed_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(commitment_signed_arg_conv);
	commitment_signed_arg_conv = CommitmentSigned_clone(&commitment_signed_arg_conv);
	LDKCommitmentUpdate ret_var = CommitmentUpdate_new(update_add_htlcs_arg_constr, update_fulfill_htlcs_arg_constr, update_fail_htlcs_arg_constr, update_fail_malformed_htlcs_arg_constr, update_fee_arg_conv, commitment_signed_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t CommitmentUpdate_clone_ptr(LDKCommitmentUpdate *NONNULL_PTR arg) {
	LDKCommitmentUpdate ret_var = CommitmentUpdate_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_CommitmentUpdate_clone_ptr"))) TS_CommitmentUpdate_clone_ptr(uint32_t arg) {
	LDKCommitmentUpdate arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = CommitmentUpdate_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CommitmentUpdate_clone"))) TS_CommitmentUpdate_clone(uint32_t orig) {
	LDKCommitmentUpdate orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKCommitmentUpdate ret_var = CommitmentUpdate_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelMessageHandler_free"))) TS_ChannelMessageHandler_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKChannelMessageHandler this_ptr_conv = *(LDKChannelMessageHandler*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	ChannelMessageHandler_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_RoutingMessageHandler_free"))) TS_RoutingMessageHandler_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKRoutingMessageHandler this_ptr_conv = *(LDKRoutingMessageHandler*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	RoutingMessageHandler_free(this_ptr_conv);
}

int8_tArray  __attribute__((export_name("TS_AcceptChannel_write"))) TS_AcceptChannel_write(uint32_t obj) {
	LDKAcceptChannel obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = AcceptChannel_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_AcceptChannel_read"))) TS_AcceptChannel_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_AcceptChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AcceptChannelDecodeErrorZ), "LDKCResult_AcceptChannelDecodeErrorZ");
	*ret_conv = AcceptChannel_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_AnnouncementSignatures_write"))) TS_AnnouncementSignatures_write(uint32_t obj) {
	LDKAnnouncementSignatures obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = AnnouncementSignatures_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_AnnouncementSignatures_read"))) TS_AnnouncementSignatures_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_AnnouncementSignaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_AnnouncementSignaturesDecodeErrorZ), "LDKCResult_AnnouncementSignaturesDecodeErrorZ");
	*ret_conv = AnnouncementSignatures_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelReestablish_write"))) TS_ChannelReestablish_write(uint32_t obj) {
	LDKChannelReestablish obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelReestablish_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelReestablish_read"))) TS_ChannelReestablish_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelReestablishDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelReestablishDecodeErrorZ), "LDKCResult_ChannelReestablishDecodeErrorZ");
	*ret_conv = ChannelReestablish_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ClosingSigned_write"))) TS_ClosingSigned_write(uint32_t obj) {
	LDKClosingSigned obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ClosingSigned_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ClosingSigned_read"))) TS_ClosingSigned_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ClosingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedDecodeErrorZ), "LDKCResult_ClosingSignedDecodeErrorZ");
	*ret_conv = ClosingSigned_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ClosingSignedFeeRange_write"))) TS_ClosingSignedFeeRange_write(uint32_t obj) {
	LDKClosingSignedFeeRange obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ClosingSignedFeeRange_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ClosingSignedFeeRange_read"))) TS_ClosingSignedFeeRange_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ClosingSignedFeeRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ClosingSignedFeeRangeDecodeErrorZ), "LDKCResult_ClosingSignedFeeRangeDecodeErrorZ");
	*ret_conv = ClosingSignedFeeRange_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_CommitmentSigned_write"))) TS_CommitmentSigned_write(uint32_t obj) {
	LDKCommitmentSigned obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = CommitmentSigned_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_CommitmentSigned_read"))) TS_CommitmentSigned_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_CommitmentSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentSignedDecodeErrorZ), "LDKCResult_CommitmentSignedDecodeErrorZ");
	*ret_conv = CommitmentSigned_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_FundingCreated_write"))) TS_FundingCreated_write(uint32_t obj) {
	LDKFundingCreated obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = FundingCreated_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_FundingCreated_read"))) TS_FundingCreated_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_FundingCreatedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingCreatedDecodeErrorZ), "LDKCResult_FundingCreatedDecodeErrorZ");
	*ret_conv = FundingCreated_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_FundingSigned_write"))) TS_FundingSigned_write(uint32_t obj) {
	LDKFundingSigned obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = FundingSigned_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_FundingSigned_read"))) TS_FundingSigned_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_FundingSignedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingSignedDecodeErrorZ), "LDKCResult_FundingSignedDecodeErrorZ");
	*ret_conv = FundingSigned_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_FundingLocked_write"))) TS_FundingLocked_write(uint32_t obj) {
	LDKFundingLocked obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = FundingLocked_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_FundingLocked_read"))) TS_FundingLocked_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_FundingLockedDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FundingLockedDecodeErrorZ), "LDKCResult_FundingLockedDecodeErrorZ");
	*ret_conv = FundingLocked_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_Init_write"))) TS_Init_write(uint32_t obj) {
	LDKInit obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = Init_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Init_read"))) TS_Init_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_InitDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InitDecodeErrorZ), "LDKCResult_InitDecodeErrorZ");
	*ret_conv = Init_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_OpenChannel_write"))) TS_OpenChannel_write(uint32_t obj) {
	LDKOpenChannel obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = OpenChannel_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_OpenChannel_read"))) TS_OpenChannel_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_OpenChannelDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_OpenChannelDecodeErrorZ), "LDKCResult_OpenChannelDecodeErrorZ");
	*ret_conv = OpenChannel_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_RevokeAndACK_write"))) TS_RevokeAndACK_write(uint32_t obj) {
	LDKRevokeAndACK obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = RevokeAndACK_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RevokeAndACK_read"))) TS_RevokeAndACK_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_RevokeAndACKDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RevokeAndACKDecodeErrorZ), "LDKCResult_RevokeAndACKDecodeErrorZ");
	*ret_conv = RevokeAndACK_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_Shutdown_write"))) TS_Shutdown_write(uint32_t obj) {
	LDKShutdown obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = Shutdown_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Shutdown_read"))) TS_Shutdown_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ShutdownDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownDecodeErrorZ), "LDKCResult_ShutdownDecodeErrorZ");
	*ret_conv = Shutdown_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_UpdateFailHTLC_write"))) TS_UpdateFailHTLC_write(uint32_t obj) {
	LDKUpdateFailHTLC obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = UpdateFailHTLC_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_UpdateFailHTLC_read"))) TS_UpdateFailHTLC_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_UpdateFailHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailHTLCDecodeErrorZ), "LDKCResult_UpdateFailHTLCDecodeErrorZ");
	*ret_conv = UpdateFailHTLC_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_UpdateFailMalformedHTLC_write"))) TS_UpdateFailMalformedHTLC_write(uint32_t obj) {
	LDKUpdateFailMalformedHTLC obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = UpdateFailMalformedHTLC_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_UpdateFailMalformedHTLC_read"))) TS_UpdateFailMalformedHTLC_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ), "LDKCResult_UpdateFailMalformedHTLCDecodeErrorZ");
	*ret_conv = UpdateFailMalformedHTLC_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_UpdateFee_write"))) TS_UpdateFee_write(uint32_t obj) {
	LDKUpdateFee obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = UpdateFee_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_UpdateFee_read"))) TS_UpdateFee_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_UpdateFeeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFeeDecodeErrorZ), "LDKCResult_UpdateFeeDecodeErrorZ");
	*ret_conv = UpdateFee_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_UpdateFulfillHTLC_write"))) TS_UpdateFulfillHTLC_write(uint32_t obj) {
	LDKUpdateFulfillHTLC obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = UpdateFulfillHTLC_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_UpdateFulfillHTLC_read"))) TS_UpdateFulfillHTLC_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_UpdateFulfillHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateFulfillHTLCDecodeErrorZ), "LDKCResult_UpdateFulfillHTLCDecodeErrorZ");
	*ret_conv = UpdateFulfillHTLC_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_UpdateAddHTLC_write"))) TS_UpdateAddHTLC_write(uint32_t obj) {
	LDKUpdateAddHTLC obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = UpdateAddHTLC_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_UpdateAddHTLC_read"))) TS_UpdateAddHTLC_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_UpdateAddHTLCDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UpdateAddHTLCDecodeErrorZ), "LDKCResult_UpdateAddHTLCDecodeErrorZ");
	*ret_conv = UpdateAddHTLC_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_Ping_write"))) TS_Ping_write(uint32_t obj) {
	LDKPing obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = Ping_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Ping_read"))) TS_Ping_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_PingDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PingDecodeErrorZ), "LDKCResult_PingDecodeErrorZ");
	*ret_conv = Ping_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_Pong_write"))) TS_Pong_write(uint32_t obj) {
	LDKPong obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = Pong_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Pong_read"))) TS_Pong_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_PongDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PongDecodeErrorZ), "LDKCResult_PongDecodeErrorZ");
	*ret_conv = Pong_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_UnsignedChannelAnnouncement_write"))) TS_UnsignedChannelAnnouncement_write(uint32_t obj) {
	LDKUnsignedChannelAnnouncement obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = UnsignedChannelAnnouncement_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_UnsignedChannelAnnouncement_read"))) TS_UnsignedChannelAnnouncement_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ), "LDKCResult_UnsignedChannelAnnouncementDecodeErrorZ");
	*ret_conv = UnsignedChannelAnnouncement_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelAnnouncement_write"))) TS_ChannelAnnouncement_write(uint32_t obj) {
	LDKChannelAnnouncement obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelAnnouncement_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelAnnouncement_read"))) TS_ChannelAnnouncement_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelAnnouncementDecodeErrorZ), "LDKCResult_ChannelAnnouncementDecodeErrorZ");
	*ret_conv = ChannelAnnouncement_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_UnsignedChannelUpdate_write"))) TS_UnsignedChannelUpdate_write(uint32_t obj) {
	LDKUnsignedChannelUpdate obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = UnsignedChannelUpdate_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_UnsignedChannelUpdate_read"))) TS_UnsignedChannelUpdate_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_UnsignedChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedChannelUpdateDecodeErrorZ), "LDKCResult_UnsignedChannelUpdateDecodeErrorZ");
	*ret_conv = UnsignedChannelUpdate_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelUpdate_write"))) TS_ChannelUpdate_write(uint32_t obj) {
	LDKChannelUpdate obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelUpdate_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelUpdate_read"))) TS_ChannelUpdate_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelUpdateDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateDecodeErrorZ), "LDKCResult_ChannelUpdateDecodeErrorZ");
	*ret_conv = ChannelUpdate_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ErrorMessage_write"))) TS_ErrorMessage_write(uint32_t obj) {
	LDKErrorMessage obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ErrorMessage_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ErrorMessage_read"))) TS_ErrorMessage_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ErrorMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ErrorMessageDecodeErrorZ), "LDKCResult_ErrorMessageDecodeErrorZ");
	*ret_conv = ErrorMessage_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_WarningMessage_write"))) TS_WarningMessage_write(uint32_t obj) {
	LDKWarningMessage obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = WarningMessage_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_WarningMessage_read"))) TS_WarningMessage_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_WarningMessageDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_WarningMessageDecodeErrorZ), "LDKCResult_WarningMessageDecodeErrorZ");
	*ret_conv = WarningMessage_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_UnsignedNodeAnnouncement_write"))) TS_UnsignedNodeAnnouncement_write(uint32_t obj) {
	LDKUnsignedNodeAnnouncement obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = UnsignedNodeAnnouncement_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_UnsignedNodeAnnouncement_read"))) TS_UnsignedNodeAnnouncement_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ), "LDKCResult_UnsignedNodeAnnouncementDecodeErrorZ");
	*ret_conv = UnsignedNodeAnnouncement_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_NodeAnnouncement_write"))) TS_NodeAnnouncement_write(uint32_t obj) {
	LDKNodeAnnouncement obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = NodeAnnouncement_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncement_read"))) TS_NodeAnnouncement_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_NodeAnnouncementDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementDecodeErrorZ), "LDKCResult_NodeAnnouncementDecodeErrorZ");
	*ret_conv = NodeAnnouncement_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_QueryShortChannelIds_read"))) TS_QueryShortChannelIds_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_QueryShortChannelIdsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryShortChannelIdsDecodeErrorZ), "LDKCResult_QueryShortChannelIdsDecodeErrorZ");
	*ret_conv = QueryShortChannelIds_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_QueryShortChannelIds_write"))) TS_QueryShortChannelIds_write(uint32_t obj) {
	LDKQueryShortChannelIds obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = QueryShortChannelIds_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_write"))) TS_ReplyShortChannelIdsEnd_write(uint32_t obj) {
	LDKReplyShortChannelIdsEnd obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ReplyShortChannelIdsEnd_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ReplyShortChannelIdsEnd_read"))) TS_ReplyShortChannelIdsEnd_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ), "LDKCResult_ReplyShortChannelIdsEndDecodeErrorZ");
	*ret_conv = ReplyShortChannelIdsEnd_read(ser_ref);
	return (uint32_t)ret_conv;
}

int32_t  __attribute__((export_name("TS_QueryChannelRange_end_blocknum"))) TS_QueryChannelRange_end_blocknum(uint32_t this_arg) {
	LDKQueryChannelRange this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int32_t ret_val = QueryChannelRange_end_blocknum(&this_arg_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_QueryChannelRange_write"))) TS_QueryChannelRange_write(uint32_t obj) {
	LDKQueryChannelRange obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = QueryChannelRange_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_QueryChannelRange_read"))) TS_QueryChannelRange_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_QueryChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_QueryChannelRangeDecodeErrorZ), "LDKCResult_QueryChannelRangeDecodeErrorZ");
	*ret_conv = QueryChannelRange_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ReplyChannelRange_read"))) TS_ReplyChannelRange_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ReplyChannelRangeDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ReplyChannelRangeDecodeErrorZ), "LDKCResult_ReplyChannelRangeDecodeErrorZ");
	*ret_conv = ReplyChannelRange_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ReplyChannelRange_write"))) TS_ReplyChannelRange_write(uint32_t obj) {
	LDKReplyChannelRange obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ReplyChannelRange_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_GossipTimestampFilter_write"))) TS_GossipTimestampFilter_write(uint32_t obj) {
	LDKGossipTimestampFilter obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = GossipTimestampFilter_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_GossipTimestampFilter_read"))) TS_GossipTimestampFilter_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_GossipTimestampFilterDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_GossipTimestampFilterDecodeErrorZ), "LDKCResult_GossipTimestampFilterDecodeErrorZ");
	*ret_conv = GossipTimestampFilter_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_CustomMessageHandler_free"))) TS_CustomMessageHandler_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKCustomMessageHandler this_ptr_conv = *(LDKCustomMessageHandler*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	CustomMessageHandler_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_IgnoringMessageHandler_free"))) TS_IgnoringMessageHandler_free(uint32_t this_obj) {
	LDKIgnoringMessageHandler this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	IgnoringMessageHandler_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_IgnoringMessageHandler_new"))) TS_IgnoringMessageHandler_new() {
	LDKIgnoringMessageHandler ret_var = IgnoringMessageHandler_new();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_IgnoringMessageHandler_as_MessageSendEventsProvider"))) TS_IgnoringMessageHandler_as_MessageSendEventsProvider(uint32_t this_arg) {
	LDKIgnoringMessageHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKMessageSendEventsProvider* ret_ret = MALLOC(sizeof(LDKMessageSendEventsProvider), "LDKMessageSendEventsProvider");
	*ret_ret = IgnoringMessageHandler_as_MessageSendEventsProvider(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_IgnoringMessageHandler_as_RoutingMessageHandler"))) TS_IgnoringMessageHandler_as_RoutingMessageHandler(uint32_t this_arg) {
	LDKIgnoringMessageHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKRoutingMessageHandler* ret_ret = MALLOC(sizeof(LDKRoutingMessageHandler), "LDKRoutingMessageHandler");
	*ret_ret = IgnoringMessageHandler_as_RoutingMessageHandler(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_IgnoringMessageHandler_as_CustomMessageReader"))) TS_IgnoringMessageHandler_as_CustomMessageReader(uint32_t this_arg) {
	LDKIgnoringMessageHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCustomMessageReader* ret_ret = MALLOC(sizeof(LDKCustomMessageReader), "LDKCustomMessageReader");
	*ret_ret = IgnoringMessageHandler_as_CustomMessageReader(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_IgnoringMessageHandler_as_CustomMessageHandler"))) TS_IgnoringMessageHandler_as_CustomMessageHandler(uint32_t this_arg) {
	LDKIgnoringMessageHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCustomMessageHandler* ret_ret = MALLOC(sizeof(LDKCustomMessageHandler), "LDKCustomMessageHandler");
	*ret_ret = IgnoringMessageHandler_as_CustomMessageHandler(&this_arg_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_ErroringMessageHandler_free"))) TS_ErroringMessageHandler_free(uint32_t this_obj) {
	LDKErroringMessageHandler this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ErroringMessageHandler_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_ErroringMessageHandler_new"))) TS_ErroringMessageHandler_new() {
	LDKErroringMessageHandler ret_var = ErroringMessageHandler_new();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ErroringMessageHandler_as_MessageSendEventsProvider"))) TS_ErroringMessageHandler_as_MessageSendEventsProvider(uint32_t this_arg) {
	LDKErroringMessageHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKMessageSendEventsProvider* ret_ret = MALLOC(sizeof(LDKMessageSendEventsProvider), "LDKMessageSendEventsProvider");
	*ret_ret = ErroringMessageHandler_as_MessageSendEventsProvider(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_ErroringMessageHandler_as_ChannelMessageHandler"))) TS_ErroringMessageHandler_as_ChannelMessageHandler(uint32_t this_arg) {
	LDKErroringMessageHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelMessageHandler* ret_ret = MALLOC(sizeof(LDKChannelMessageHandler), "LDKChannelMessageHandler");
	*ret_ret = ErroringMessageHandler_as_ChannelMessageHandler(&this_arg_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_MessageHandler_free"))) TS_MessageHandler_free(uint32_t this_obj) {
	LDKMessageHandler this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	MessageHandler_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_MessageHandler_get_chan_handler"))) TS_MessageHandler_get_chan_handler(uint32_t this_ptr) {
	LDKMessageHandler this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	// WARNING: This object doesn't live past this scope, needs clone!
	uint32_t ret_ret = ((uintptr_t)MessageHandler_get_chan_handler(&this_ptr_conv)) | 1;
	return ret_ret;
}

void  __attribute__((export_name("TS_MessageHandler_set_chan_handler"))) TS_MessageHandler_set_chan_handler(uint32_t this_ptr, uint32_t val) {
	LDKMessageHandler this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKChannelMessageHandler val_conv = *(LDKChannelMessageHandler*)(val_ptr);
	if (val_conv.free == LDKChannelMessageHandler_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKChannelMessageHandler_JCalls_cloned(&val_conv);
	}
	MessageHandler_set_chan_handler(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_MessageHandler_get_route_handler"))) TS_MessageHandler_get_route_handler(uint32_t this_ptr) {
	LDKMessageHandler this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	// WARNING: This object doesn't live past this scope, needs clone!
	uint32_t ret_ret = ((uintptr_t)MessageHandler_get_route_handler(&this_ptr_conv)) | 1;
	return ret_ret;
}

void  __attribute__((export_name("TS_MessageHandler_set_route_handler"))) TS_MessageHandler_set_route_handler(uint32_t this_ptr, uint32_t val) {
	LDKMessageHandler this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKRoutingMessageHandler val_conv = *(LDKRoutingMessageHandler*)(val_ptr);
	if (val_conv.free == LDKRoutingMessageHandler_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKRoutingMessageHandler_JCalls_cloned(&val_conv);
	}
	MessageHandler_set_route_handler(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_MessageHandler_new"))) TS_MessageHandler_new(uint32_t chan_handler_arg, uint32_t route_handler_arg) {
	void* chan_handler_arg_ptr = (void*)(((uintptr_t)chan_handler_arg) & ~1);
	CHECK_ACCESS(chan_handler_arg_ptr);
	LDKChannelMessageHandler chan_handler_arg_conv = *(LDKChannelMessageHandler*)(chan_handler_arg_ptr);
	if (chan_handler_arg_conv.free == LDKChannelMessageHandler_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKChannelMessageHandler_JCalls_cloned(&chan_handler_arg_conv);
	}
	void* route_handler_arg_ptr = (void*)(((uintptr_t)route_handler_arg) & ~1);
	CHECK_ACCESS(route_handler_arg_ptr);
	LDKRoutingMessageHandler route_handler_arg_conv = *(LDKRoutingMessageHandler*)(route_handler_arg_ptr);
	if (route_handler_arg_conv.free == LDKRoutingMessageHandler_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKRoutingMessageHandler_JCalls_cloned(&route_handler_arg_conv);
	}
	LDKMessageHandler ret_var = MessageHandler_new(chan_handler_arg_conv, route_handler_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t SocketDescriptor_clone_ptr(LDKSocketDescriptor *NONNULL_PTR arg) {
	LDKSocketDescriptor* ret_ret = MALLOC(sizeof(LDKSocketDescriptor), "LDKSocketDescriptor");
	*ret_ret = SocketDescriptor_clone(arg);
	return (uint32_t)ret_ret;
}
uint32_t  __attribute__((export_name("TS_SocketDescriptor_clone_ptr"))) TS_SocketDescriptor_clone_ptr(uint32_t arg) {
	void* arg_ptr = (void*)(((uintptr_t)arg) & ~1);
	if (!(arg & 1)) { CHECK_ACCESS(arg_ptr); }
	LDKSocketDescriptor* arg_conv = (LDKSocketDescriptor*)arg_ptr;
	uint32_t ret_val = SocketDescriptor_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_SocketDescriptor_clone"))) TS_SocketDescriptor_clone(uint32_t orig) {
	void* orig_ptr = (void*)(((uintptr_t)orig) & ~1);
	if (!(orig & 1)) { CHECK_ACCESS(orig_ptr); }
	LDKSocketDescriptor* orig_conv = (LDKSocketDescriptor*)orig_ptr;
	LDKSocketDescriptor* ret_ret = MALLOC(sizeof(LDKSocketDescriptor), "LDKSocketDescriptor");
	*ret_ret = SocketDescriptor_clone(orig_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_SocketDescriptor_free"))) TS_SocketDescriptor_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKSocketDescriptor this_ptr_conv = *(LDKSocketDescriptor*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	SocketDescriptor_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_PeerHandleError_free"))) TS_PeerHandleError_free(uint32_t this_obj) {
	LDKPeerHandleError this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	PeerHandleError_free(this_obj_conv);
}

jboolean  __attribute__((export_name("TS_PeerHandleError_get_no_connection_possible"))) TS_PeerHandleError_get_no_connection_possible(uint32_t this_ptr) {
	LDKPeerHandleError this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = PeerHandleError_get_no_connection_possible(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_PeerHandleError_set_no_connection_possible"))) TS_PeerHandleError_set_no_connection_possible(uint32_t this_ptr, jboolean val) {
	LDKPeerHandleError this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	PeerHandleError_set_no_connection_possible(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_PeerHandleError_new"))) TS_PeerHandleError_new(jboolean no_connection_possible_arg) {
	LDKPeerHandleError ret_var = PeerHandleError_new(no_connection_possible_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t PeerHandleError_clone_ptr(LDKPeerHandleError *NONNULL_PTR arg) {
	LDKPeerHandleError ret_var = PeerHandleError_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PeerHandleError_clone_ptr"))) TS_PeerHandleError_clone_ptr(uint32_t arg) {
	LDKPeerHandleError arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = PeerHandleError_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PeerHandleError_clone"))) TS_PeerHandleError_clone(uint32_t orig) {
	LDKPeerHandleError orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKPeerHandleError ret_var = PeerHandleError_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_PeerManager_free"))) TS_PeerManager_free(uint32_t this_obj) {
	LDKPeerManager this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	PeerManager_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_PeerManager_new"))) TS_PeerManager_new(uint32_t message_handler, int8_tArray our_node_secret, int8_tArray ephemeral_random_data, uint32_t logger, uint32_t custom_message_handler) {
	LDKMessageHandler message_handler_conv;
	message_handler_conv.inner = (void*)(message_handler & (~1));
	message_handler_conv.is_owned = (message_handler & 1) || (message_handler == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(message_handler_conv);
	// WARNING: we need a move here but no clone is available for LDKMessageHandler
	LDKSecretKey our_node_secret_ref;
	CHECK(our_node_secret->arr_len == 32);
	memcpy(our_node_secret_ref.bytes, our_node_secret->elems, 32); FREE(our_node_secret);
	unsigned char ephemeral_random_data_arr[32];
	CHECK(ephemeral_random_data->arr_len == 32);
	memcpy(ephemeral_random_data_arr, ephemeral_random_data->elems, 32); FREE(ephemeral_random_data);
	unsigned char (*ephemeral_random_data_ref)[32] = &ephemeral_random_data_arr;
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	void* custom_message_handler_ptr = (void*)(((uintptr_t)custom_message_handler) & ~1);
	CHECK_ACCESS(custom_message_handler_ptr);
	LDKCustomMessageHandler custom_message_handler_conv = *(LDKCustomMessageHandler*)(custom_message_handler_ptr);
	if (custom_message_handler_conv.free == LDKCustomMessageHandler_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKCustomMessageHandler_JCalls_cloned(&custom_message_handler_conv);
	}
	LDKPeerManager ret_var = PeerManager_new(message_handler_conv, our_node_secret_ref, ephemeral_random_data_ref, logger_conv, custom_message_handler_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

ptrArray  __attribute__((export_name("TS_PeerManager_get_peer_node_ids"))) TS_PeerManager_get_peer_node_ids(uint32_t this_arg) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_PublicKeyZ ret_var = PeerManager_get_peer_node_ids(&this_arg_conv);
	ptrArray ret_arr = NULL;
	ret_arr = init_ptrArray(ret_var.datalen, __LINE__);
	int8_tArray *ret_arr_ptr = (int8_tArray*)(((uint8_t*)ret_arr) + 4);
	for (size_t m = 0; m < ret_var.datalen; m++) {
		int8_tArray ret_conv_12_arr = init_int8_tArray(33, __LINE__);
		memcpy(ret_conv_12_arr->elems, ret_var.data[m].compressed_form, 33);
		ret_arr_ptr[m] = ret_conv_12_arr;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_PeerManager_new_outbound_connection"))) TS_PeerManager_new_outbound_connection(uint32_t this_arg, int8_tArray their_node_id, uint32_t descriptor, uint32_t remote_network_address) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPublicKey their_node_id_ref;
	CHECK(their_node_id->arr_len == 33);
	memcpy(their_node_id_ref.compressed_form, their_node_id->elems, 33); FREE(their_node_id);
	void* descriptor_ptr = (void*)(((uintptr_t)descriptor) & ~1);
	CHECK_ACCESS(descriptor_ptr);
	LDKSocketDescriptor descriptor_conv = *(LDKSocketDescriptor*)(descriptor_ptr);
	if (descriptor_conv.free == LDKSocketDescriptor_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKSocketDescriptor_JCalls_cloned(&descriptor_conv);
	}
	void* remote_network_address_ptr = (void*)(((uintptr_t)remote_network_address) & ~1);
	CHECK_ACCESS(remote_network_address_ptr);
	LDKCOption_NetAddressZ remote_network_address_conv = *(LDKCOption_NetAddressZ*)(remote_network_address_ptr);
	LDKCResult_CVec_u8ZPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_u8ZPeerHandleErrorZ), "LDKCResult_CVec_u8ZPeerHandleErrorZ");
	*ret_conv = PeerManager_new_outbound_connection(&this_arg_conv, their_node_id_ref, descriptor_conv, remote_network_address_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_PeerManager_new_inbound_connection"))) TS_PeerManager_new_inbound_connection(uint32_t this_arg, uint32_t descriptor, uint32_t remote_network_address) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* descriptor_ptr = (void*)(((uintptr_t)descriptor) & ~1);
	CHECK_ACCESS(descriptor_ptr);
	LDKSocketDescriptor descriptor_conv = *(LDKSocketDescriptor*)(descriptor_ptr);
	if (descriptor_conv.free == LDKSocketDescriptor_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKSocketDescriptor_JCalls_cloned(&descriptor_conv);
	}
	void* remote_network_address_ptr = (void*)(((uintptr_t)remote_network_address) & ~1);
	CHECK_ACCESS(remote_network_address_ptr);
	LDKCOption_NetAddressZ remote_network_address_conv = *(LDKCOption_NetAddressZ*)(remote_network_address_ptr);
	LDKCResult_NonePeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePeerHandleErrorZ), "LDKCResult_NonePeerHandleErrorZ");
	*ret_conv = PeerManager_new_inbound_connection(&this_arg_conv, descriptor_conv, remote_network_address_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_PeerManager_write_buffer_space_avail"))) TS_PeerManager_write_buffer_space_avail(uint32_t this_arg, uint32_t descriptor) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* descriptor_ptr = (void*)(((uintptr_t)descriptor) & ~1);
	if (!(descriptor & 1)) { CHECK_ACCESS(descriptor_ptr); }
	LDKSocketDescriptor* descriptor_conv = (LDKSocketDescriptor*)descriptor_ptr;
	LDKCResult_NonePeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NonePeerHandleErrorZ), "LDKCResult_NonePeerHandleErrorZ");
	*ret_conv = PeerManager_write_buffer_space_avail(&this_arg_conv, descriptor_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_PeerManager_read_event"))) TS_PeerManager_read_event(uint32_t this_arg, uint32_t peer_descriptor, int8_tArray data) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* peer_descriptor_ptr = (void*)(((uintptr_t)peer_descriptor) & ~1);
	if (!(peer_descriptor & 1)) { CHECK_ACCESS(peer_descriptor_ptr); }
	LDKSocketDescriptor* peer_descriptor_conv = (LDKSocketDescriptor*)peer_descriptor_ptr;
	LDKu8slice data_ref;
	data_ref.datalen = data->arr_len;
	data_ref.data = data->elems /* XXX data leaks */;
	LDKCResult_boolPeerHandleErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_boolPeerHandleErrorZ), "LDKCResult_boolPeerHandleErrorZ");
	*ret_conv = PeerManager_read_event(&this_arg_conv, peer_descriptor_conv, data_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_PeerManager_process_events"))) TS_PeerManager_process_events(uint32_t this_arg) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	PeerManager_process_events(&this_arg_conv);
}

void  __attribute__((export_name("TS_PeerManager_socket_disconnected"))) TS_PeerManager_socket_disconnected(uint32_t this_arg, uint32_t descriptor) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* descriptor_ptr = (void*)(((uintptr_t)descriptor) & ~1);
	if (!(descriptor & 1)) { CHECK_ACCESS(descriptor_ptr); }
	LDKSocketDescriptor* descriptor_conv = (LDKSocketDescriptor*)descriptor_ptr;
	PeerManager_socket_disconnected(&this_arg_conv, descriptor_conv);
}

void  __attribute__((export_name("TS_PeerManager_disconnect_by_node_id"))) TS_PeerManager_disconnect_by_node_id(uint32_t this_arg, int8_tArray node_id, jboolean no_connection_possible) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	PeerManager_disconnect_by_node_id(&this_arg_conv, node_id_ref, no_connection_possible);
}

void  __attribute__((export_name("TS_PeerManager_disconnect_all_peers"))) TS_PeerManager_disconnect_all_peers(uint32_t this_arg) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	PeerManager_disconnect_all_peers(&this_arg_conv);
}

void  __attribute__((export_name("TS_PeerManager_timer_tick_occurred"))) TS_PeerManager_timer_tick_occurred(uint32_t this_arg) {
	LDKPeerManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	PeerManager_timer_tick_occurred(&this_arg_conv);
}

int64_t  __attribute__((export_name("TS_htlc_success_tx_weight"))) TS_htlc_success_tx_weight(jboolean opt_anchors) {
	int64_t ret_val = htlc_success_tx_weight(opt_anchors);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_htlc_timeout_tx_weight"))) TS_htlc_timeout_tx_weight(jboolean opt_anchors) {
	int64_t ret_val = htlc_timeout_tx_weight(opt_anchors);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_build_commitment_secret"))) TS_build_commitment_secret(int8_tArray commitment_seed, int64_t idx) {
	unsigned char commitment_seed_arr[32];
	CHECK(commitment_seed->arr_len == 32);
	memcpy(commitment_seed_arr, commitment_seed->elems, 32); FREE(commitment_seed);
	unsigned char (*commitment_seed_ref)[32] = &commitment_seed_arr;
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, build_commitment_secret(commitment_seed_ref, idx).data, 32);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_build_closing_transaction"))) TS_build_closing_transaction(int64_t to_holder_value_sat, int64_t to_counterparty_value_sat, int8_tArray to_holder_script, int8_tArray to_counterparty_script, uint32_t funding_outpoint) {
	LDKCVec_u8Z to_holder_script_ref;
	to_holder_script_ref.datalen = to_holder_script->arr_len;
	to_holder_script_ref.data = MALLOC(to_holder_script_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(to_holder_script_ref.data, to_holder_script->elems, to_holder_script_ref.datalen); FREE(to_holder_script);
	LDKCVec_u8Z to_counterparty_script_ref;
	to_counterparty_script_ref.datalen = to_counterparty_script->arr_len;
	to_counterparty_script_ref.data = MALLOC(to_counterparty_script_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(to_counterparty_script_ref.data, to_counterparty_script->elems, to_counterparty_script_ref.datalen); FREE(to_counterparty_script);
	LDKOutPoint funding_outpoint_conv;
	funding_outpoint_conv.inner = (void*)(funding_outpoint & (~1));
	funding_outpoint_conv.is_owned = (funding_outpoint & 1) || (funding_outpoint == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_outpoint_conv);
	funding_outpoint_conv = OutPoint_clone(&funding_outpoint_conv);
	LDKTransaction ret_var = build_closing_transaction(to_holder_value_sat, to_counterparty_value_sat, to_holder_script_ref, to_counterparty_script_ref, funding_outpoint_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	Transaction_free(ret_var);
	return ret_arr;
}

void  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_free"))) TS_CounterpartyCommitmentSecrets_free(uint32_t this_obj) {
	LDKCounterpartyCommitmentSecrets this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	CounterpartyCommitmentSecrets_free(this_obj_conv);
}

static inline uintptr_t CounterpartyCommitmentSecrets_clone_ptr(LDKCounterpartyCommitmentSecrets *NONNULL_PTR arg) {
	LDKCounterpartyCommitmentSecrets ret_var = CounterpartyCommitmentSecrets_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_clone_ptr"))) TS_CounterpartyCommitmentSecrets_clone_ptr(uint32_t arg) {
	LDKCounterpartyCommitmentSecrets arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = CounterpartyCommitmentSecrets_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_clone"))) TS_CounterpartyCommitmentSecrets_clone(uint32_t orig) {
	LDKCounterpartyCommitmentSecrets orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKCounterpartyCommitmentSecrets ret_var = CounterpartyCommitmentSecrets_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_new"))) TS_CounterpartyCommitmentSecrets_new() {
	LDKCounterpartyCommitmentSecrets ret_var = CounterpartyCommitmentSecrets_new();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_get_min_seen_secret"))) TS_CounterpartyCommitmentSecrets_get_min_seen_secret(uint32_t this_arg) {
	LDKCounterpartyCommitmentSecrets this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = CounterpartyCommitmentSecrets_get_min_seen_secret(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_provide_secret"))) TS_CounterpartyCommitmentSecrets_provide_secret(uint32_t this_arg, int64_t idx, int8_tArray secret) {
	LDKCounterpartyCommitmentSecrets this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKThirtyTwoBytes secret_ref;
	CHECK(secret->arr_len == 32);
	memcpy(secret_ref.data, secret->elems, 32); FREE(secret);
	LDKCResult_NoneNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneNoneZ), "LDKCResult_NoneNoneZ");
	*ret_conv = CounterpartyCommitmentSecrets_provide_secret(&this_arg_conv, idx, secret_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_get_secret"))) TS_CounterpartyCommitmentSecrets_get_secret(uint32_t this_arg, int64_t idx) {
	LDKCounterpartyCommitmentSecrets this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, CounterpartyCommitmentSecrets_get_secret(&this_arg_conv, idx).data, 32);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_write"))) TS_CounterpartyCommitmentSecrets_write(uint32_t obj) {
	LDKCounterpartyCommitmentSecrets obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = CounterpartyCommitmentSecrets_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_CounterpartyCommitmentSecrets_read"))) TS_CounterpartyCommitmentSecrets_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ), "LDKCResult_CounterpartyCommitmentSecretsDecodeErrorZ");
	*ret_conv = CounterpartyCommitmentSecrets_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_derive_private_key"))) TS_derive_private_key(int8_tArray per_commitment_point, int8_tArray base_secret) {
	LDKPublicKey per_commitment_point_ref;
	CHECK(per_commitment_point->arr_len == 33);
	memcpy(per_commitment_point_ref.compressed_form, per_commitment_point->elems, 33); FREE(per_commitment_point);
	unsigned char base_secret_arr[32];
	CHECK(base_secret->arr_len == 32);
	memcpy(base_secret_arr, base_secret->elems, 32); FREE(base_secret);
	unsigned char (*base_secret_ref)[32] = &base_secret_arr;
	LDKCResult_SecretKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyErrorZ), "LDKCResult_SecretKeyErrorZ");
	*ret_conv = derive_private_key(per_commitment_point_ref, base_secret_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_derive_public_key"))) TS_derive_public_key(int8_tArray per_commitment_point, int8_tArray base_point) {
	LDKPublicKey per_commitment_point_ref;
	CHECK(per_commitment_point->arr_len == 33);
	memcpy(per_commitment_point_ref.compressed_form, per_commitment_point->elems, 33); FREE(per_commitment_point);
	LDKPublicKey base_point_ref;
	CHECK(base_point->arr_len == 33);
	memcpy(base_point_ref.compressed_form, base_point->elems, 33); FREE(base_point);
	LDKCResult_PublicKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PublicKeyErrorZ), "LDKCResult_PublicKeyErrorZ");
	*ret_conv = derive_public_key(per_commitment_point_ref, base_point_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_derive_private_revocation_key"))) TS_derive_private_revocation_key(int8_tArray per_commitment_secret, int8_tArray countersignatory_revocation_base_secret) {
	unsigned char per_commitment_secret_arr[32];
	CHECK(per_commitment_secret->arr_len == 32);
	memcpy(per_commitment_secret_arr, per_commitment_secret->elems, 32); FREE(per_commitment_secret);
	unsigned char (*per_commitment_secret_ref)[32] = &per_commitment_secret_arr;
	unsigned char countersignatory_revocation_base_secret_arr[32];
	CHECK(countersignatory_revocation_base_secret->arr_len == 32);
	memcpy(countersignatory_revocation_base_secret_arr, countersignatory_revocation_base_secret->elems, 32); FREE(countersignatory_revocation_base_secret);
	unsigned char (*countersignatory_revocation_base_secret_ref)[32] = &countersignatory_revocation_base_secret_arr;
	LDKCResult_SecretKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SecretKeyErrorZ), "LDKCResult_SecretKeyErrorZ");
	*ret_conv = derive_private_revocation_key(per_commitment_secret_ref, countersignatory_revocation_base_secret_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_derive_public_revocation_key"))) TS_derive_public_revocation_key(int8_tArray per_commitment_point, int8_tArray countersignatory_revocation_base_point) {
	LDKPublicKey per_commitment_point_ref;
	CHECK(per_commitment_point->arr_len == 33);
	memcpy(per_commitment_point_ref.compressed_form, per_commitment_point->elems, 33); FREE(per_commitment_point);
	LDKPublicKey countersignatory_revocation_base_point_ref;
	CHECK(countersignatory_revocation_base_point->arr_len == 33);
	memcpy(countersignatory_revocation_base_point_ref.compressed_form, countersignatory_revocation_base_point->elems, 33); FREE(countersignatory_revocation_base_point);
	LDKCResult_PublicKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PublicKeyErrorZ), "LDKCResult_PublicKeyErrorZ");
	*ret_conv = derive_public_revocation_key(per_commitment_point_ref, countersignatory_revocation_base_point_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_TxCreationKeys_free"))) TS_TxCreationKeys_free(uint32_t this_obj) {
	LDKTxCreationKeys this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	TxCreationKeys_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_TxCreationKeys_get_per_commitment_point"))) TS_TxCreationKeys_get_per_commitment_point(uint32_t this_ptr) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, TxCreationKeys_get_per_commitment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_TxCreationKeys_set_per_commitment_point"))) TS_TxCreationKeys_set_per_commitment_point(uint32_t this_ptr, int8_tArray val) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	TxCreationKeys_set_per_commitment_point(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_TxCreationKeys_get_revocation_key"))) TS_TxCreationKeys_get_revocation_key(uint32_t this_ptr) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, TxCreationKeys_get_revocation_key(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_TxCreationKeys_set_revocation_key"))) TS_TxCreationKeys_set_revocation_key(uint32_t this_ptr, int8_tArray val) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	TxCreationKeys_set_revocation_key(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_TxCreationKeys_get_broadcaster_htlc_key"))) TS_TxCreationKeys_get_broadcaster_htlc_key(uint32_t this_ptr) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, TxCreationKeys_get_broadcaster_htlc_key(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_TxCreationKeys_set_broadcaster_htlc_key"))) TS_TxCreationKeys_set_broadcaster_htlc_key(uint32_t this_ptr, int8_tArray val) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	TxCreationKeys_set_broadcaster_htlc_key(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_TxCreationKeys_get_countersignatory_htlc_key"))) TS_TxCreationKeys_get_countersignatory_htlc_key(uint32_t this_ptr) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, TxCreationKeys_get_countersignatory_htlc_key(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_TxCreationKeys_set_countersignatory_htlc_key"))) TS_TxCreationKeys_set_countersignatory_htlc_key(uint32_t this_ptr, int8_tArray val) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	TxCreationKeys_set_countersignatory_htlc_key(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_TxCreationKeys_get_broadcaster_delayed_payment_key"))) TS_TxCreationKeys_get_broadcaster_delayed_payment_key(uint32_t this_ptr) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, TxCreationKeys_get_broadcaster_delayed_payment_key(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_TxCreationKeys_set_broadcaster_delayed_payment_key"))) TS_TxCreationKeys_set_broadcaster_delayed_payment_key(uint32_t this_ptr, int8_tArray val) {
	LDKTxCreationKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	TxCreationKeys_set_broadcaster_delayed_payment_key(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_TxCreationKeys_new"))) TS_TxCreationKeys_new(int8_tArray per_commitment_point_arg, int8_tArray revocation_key_arg, int8_tArray broadcaster_htlc_key_arg, int8_tArray countersignatory_htlc_key_arg, int8_tArray broadcaster_delayed_payment_key_arg) {
	LDKPublicKey per_commitment_point_arg_ref;
	CHECK(per_commitment_point_arg->arr_len == 33);
	memcpy(per_commitment_point_arg_ref.compressed_form, per_commitment_point_arg->elems, 33); FREE(per_commitment_point_arg);
	LDKPublicKey revocation_key_arg_ref;
	CHECK(revocation_key_arg->arr_len == 33);
	memcpy(revocation_key_arg_ref.compressed_form, revocation_key_arg->elems, 33); FREE(revocation_key_arg);
	LDKPublicKey broadcaster_htlc_key_arg_ref;
	CHECK(broadcaster_htlc_key_arg->arr_len == 33);
	memcpy(broadcaster_htlc_key_arg_ref.compressed_form, broadcaster_htlc_key_arg->elems, 33); FREE(broadcaster_htlc_key_arg);
	LDKPublicKey countersignatory_htlc_key_arg_ref;
	CHECK(countersignatory_htlc_key_arg->arr_len == 33);
	memcpy(countersignatory_htlc_key_arg_ref.compressed_form, countersignatory_htlc_key_arg->elems, 33); FREE(countersignatory_htlc_key_arg);
	LDKPublicKey broadcaster_delayed_payment_key_arg_ref;
	CHECK(broadcaster_delayed_payment_key_arg->arr_len == 33);
	memcpy(broadcaster_delayed_payment_key_arg_ref.compressed_form, broadcaster_delayed_payment_key_arg->elems, 33); FREE(broadcaster_delayed_payment_key_arg);
	LDKTxCreationKeys ret_var = TxCreationKeys_new(per_commitment_point_arg_ref, revocation_key_arg_ref, broadcaster_htlc_key_arg_ref, countersignatory_htlc_key_arg_ref, broadcaster_delayed_payment_key_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t TxCreationKeys_clone_ptr(LDKTxCreationKeys *NONNULL_PTR arg) {
	LDKTxCreationKeys ret_var = TxCreationKeys_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_TxCreationKeys_clone_ptr"))) TS_TxCreationKeys_clone_ptr(uint32_t arg) {
	LDKTxCreationKeys arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = TxCreationKeys_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_TxCreationKeys_clone"))) TS_TxCreationKeys_clone(uint32_t orig) {
	LDKTxCreationKeys orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKTxCreationKeys ret_var = TxCreationKeys_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_TxCreationKeys_write"))) TS_TxCreationKeys_write(uint32_t obj) {
	LDKTxCreationKeys obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = TxCreationKeys_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_TxCreationKeys_read"))) TS_TxCreationKeys_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_TxCreationKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysDecodeErrorZ), "LDKCResult_TxCreationKeysDecodeErrorZ");
	*ret_conv = TxCreationKeys_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_ChannelPublicKeys_free"))) TS_ChannelPublicKeys_free(uint32_t this_obj) {
	LDKChannelPublicKeys this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelPublicKeys_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_ChannelPublicKeys_get_funding_pubkey"))) TS_ChannelPublicKeys_get_funding_pubkey(uint32_t this_ptr) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, ChannelPublicKeys_get_funding_pubkey(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelPublicKeys_set_funding_pubkey"))) TS_ChannelPublicKeys_set_funding_pubkey(uint32_t this_ptr, int8_tArray val) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	ChannelPublicKeys_set_funding_pubkey(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_ChannelPublicKeys_get_revocation_basepoint"))) TS_ChannelPublicKeys_get_revocation_basepoint(uint32_t this_ptr) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, ChannelPublicKeys_get_revocation_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelPublicKeys_set_revocation_basepoint"))) TS_ChannelPublicKeys_set_revocation_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	ChannelPublicKeys_set_revocation_basepoint(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_ChannelPublicKeys_get_payment_point"))) TS_ChannelPublicKeys_get_payment_point(uint32_t this_ptr) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, ChannelPublicKeys_get_payment_point(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelPublicKeys_set_payment_point"))) TS_ChannelPublicKeys_set_payment_point(uint32_t this_ptr, int8_tArray val) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	ChannelPublicKeys_set_payment_point(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_ChannelPublicKeys_get_delayed_payment_basepoint"))) TS_ChannelPublicKeys_get_delayed_payment_basepoint(uint32_t this_ptr) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, ChannelPublicKeys_get_delayed_payment_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelPublicKeys_set_delayed_payment_basepoint"))) TS_ChannelPublicKeys_set_delayed_payment_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	ChannelPublicKeys_set_delayed_payment_basepoint(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_ChannelPublicKeys_get_htlc_basepoint"))) TS_ChannelPublicKeys_get_htlc_basepoint(uint32_t this_ptr) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, ChannelPublicKeys_get_htlc_basepoint(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelPublicKeys_set_htlc_basepoint"))) TS_ChannelPublicKeys_set_htlc_basepoint(uint32_t this_ptr, int8_tArray val) {
	LDKChannelPublicKeys this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	ChannelPublicKeys_set_htlc_basepoint(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_ChannelPublicKeys_new"))) TS_ChannelPublicKeys_new(int8_tArray funding_pubkey_arg, int8_tArray revocation_basepoint_arg, int8_tArray payment_point_arg, int8_tArray delayed_payment_basepoint_arg, int8_tArray htlc_basepoint_arg) {
	LDKPublicKey funding_pubkey_arg_ref;
	CHECK(funding_pubkey_arg->arr_len == 33);
	memcpy(funding_pubkey_arg_ref.compressed_form, funding_pubkey_arg->elems, 33); FREE(funding_pubkey_arg);
	LDKPublicKey revocation_basepoint_arg_ref;
	CHECK(revocation_basepoint_arg->arr_len == 33);
	memcpy(revocation_basepoint_arg_ref.compressed_form, revocation_basepoint_arg->elems, 33); FREE(revocation_basepoint_arg);
	LDKPublicKey payment_point_arg_ref;
	CHECK(payment_point_arg->arr_len == 33);
	memcpy(payment_point_arg_ref.compressed_form, payment_point_arg->elems, 33); FREE(payment_point_arg);
	LDKPublicKey delayed_payment_basepoint_arg_ref;
	CHECK(delayed_payment_basepoint_arg->arr_len == 33);
	memcpy(delayed_payment_basepoint_arg_ref.compressed_form, delayed_payment_basepoint_arg->elems, 33); FREE(delayed_payment_basepoint_arg);
	LDKPublicKey htlc_basepoint_arg_ref;
	CHECK(htlc_basepoint_arg->arr_len == 33);
	memcpy(htlc_basepoint_arg_ref.compressed_form, htlc_basepoint_arg->elems, 33); FREE(htlc_basepoint_arg);
	LDKChannelPublicKeys ret_var = ChannelPublicKeys_new(funding_pubkey_arg_ref, revocation_basepoint_arg_ref, payment_point_arg_ref, delayed_payment_basepoint_arg_ref, htlc_basepoint_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelPublicKeys_clone_ptr(LDKChannelPublicKeys *NONNULL_PTR arg) {
	LDKChannelPublicKeys ret_var = ChannelPublicKeys_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelPublicKeys_clone_ptr"))) TS_ChannelPublicKeys_clone_ptr(uint32_t arg) {
	LDKChannelPublicKeys arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelPublicKeys_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelPublicKeys_clone"))) TS_ChannelPublicKeys_clone(uint32_t orig) {
	LDKChannelPublicKeys orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelPublicKeys ret_var = ChannelPublicKeys_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ChannelPublicKeys_write"))) TS_ChannelPublicKeys_write(uint32_t obj) {
	LDKChannelPublicKeys obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelPublicKeys_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelPublicKeys_read"))) TS_ChannelPublicKeys_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelPublicKeysDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelPublicKeysDecodeErrorZ), "LDKCResult_ChannelPublicKeysDecodeErrorZ");
	*ret_conv = ChannelPublicKeys_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_TxCreationKeys_derive_new"))) TS_TxCreationKeys_derive_new(int8_tArray per_commitment_point, int8_tArray broadcaster_delayed_payment_base, int8_tArray broadcaster_htlc_base, int8_tArray countersignatory_revocation_base, int8_tArray countersignatory_htlc_base) {
	LDKPublicKey per_commitment_point_ref;
	CHECK(per_commitment_point->arr_len == 33);
	memcpy(per_commitment_point_ref.compressed_form, per_commitment_point->elems, 33); FREE(per_commitment_point);
	LDKPublicKey broadcaster_delayed_payment_base_ref;
	CHECK(broadcaster_delayed_payment_base->arr_len == 33);
	memcpy(broadcaster_delayed_payment_base_ref.compressed_form, broadcaster_delayed_payment_base->elems, 33); FREE(broadcaster_delayed_payment_base);
	LDKPublicKey broadcaster_htlc_base_ref;
	CHECK(broadcaster_htlc_base->arr_len == 33);
	memcpy(broadcaster_htlc_base_ref.compressed_form, broadcaster_htlc_base->elems, 33); FREE(broadcaster_htlc_base);
	LDKPublicKey countersignatory_revocation_base_ref;
	CHECK(countersignatory_revocation_base->arr_len == 33);
	memcpy(countersignatory_revocation_base_ref.compressed_form, countersignatory_revocation_base->elems, 33); FREE(countersignatory_revocation_base);
	LDKPublicKey countersignatory_htlc_base_ref;
	CHECK(countersignatory_htlc_base->arr_len == 33);
	memcpy(countersignatory_htlc_base_ref.compressed_form, countersignatory_htlc_base->elems, 33); FREE(countersignatory_htlc_base);
	LDKCResult_TxCreationKeysErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysErrorZ), "LDKCResult_TxCreationKeysErrorZ");
	*ret_conv = TxCreationKeys_derive_new(per_commitment_point_ref, broadcaster_delayed_payment_base_ref, broadcaster_htlc_base_ref, countersignatory_revocation_base_ref, countersignatory_htlc_base_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_TxCreationKeys_from_channel_static_keys"))) TS_TxCreationKeys_from_channel_static_keys(int8_tArray per_commitment_point, uint32_t broadcaster_keys, uint32_t countersignatory_keys) {
	LDKPublicKey per_commitment_point_ref;
	CHECK(per_commitment_point->arr_len == 33);
	memcpy(per_commitment_point_ref.compressed_form, per_commitment_point->elems, 33); FREE(per_commitment_point);
	LDKChannelPublicKeys broadcaster_keys_conv;
	broadcaster_keys_conv.inner = (void*)(broadcaster_keys & (~1));
	broadcaster_keys_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(broadcaster_keys_conv);
	LDKChannelPublicKeys countersignatory_keys_conv;
	countersignatory_keys_conv.inner = (void*)(countersignatory_keys & (~1));
	countersignatory_keys_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(countersignatory_keys_conv);
	LDKCResult_TxCreationKeysErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_TxCreationKeysErrorZ), "LDKCResult_TxCreationKeysErrorZ");
	*ret_conv = TxCreationKeys_from_channel_static_keys(per_commitment_point_ref, &broadcaster_keys_conv, &countersignatory_keys_conv);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_get_revokeable_redeemscript"))) TS_get_revokeable_redeemscript(int8_tArray revocation_key, int16_t contest_delay, int8_tArray broadcaster_delayed_payment_key) {
	LDKPublicKey revocation_key_ref;
	CHECK(revocation_key->arr_len == 33);
	memcpy(revocation_key_ref.compressed_form, revocation_key->elems, 33); FREE(revocation_key);
	LDKPublicKey broadcaster_delayed_payment_key_ref;
	CHECK(broadcaster_delayed_payment_key->arr_len == 33);
	memcpy(broadcaster_delayed_payment_key_ref.compressed_form, broadcaster_delayed_payment_key->elems, 33); FREE(broadcaster_delayed_payment_key);
	LDKCVec_u8Z ret_var = get_revokeable_redeemscript(revocation_key_ref, contest_delay, broadcaster_delayed_payment_key_ref);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

void  __attribute__((export_name("TS_HTLCOutputInCommitment_free"))) TS_HTLCOutputInCommitment_free(uint32_t this_obj) {
	LDKHTLCOutputInCommitment this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	HTLCOutputInCommitment_free(this_obj_conv);
}

jboolean  __attribute__((export_name("TS_HTLCOutputInCommitment_get_offered"))) TS_HTLCOutputInCommitment_get_offered(uint32_t this_ptr) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = HTLCOutputInCommitment_get_offered(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_HTLCOutputInCommitment_set_offered"))) TS_HTLCOutputInCommitment_set_offered(uint32_t this_ptr, jboolean val) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	HTLCOutputInCommitment_set_offered(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_HTLCOutputInCommitment_get_amount_msat"))) TS_HTLCOutputInCommitment_get_amount_msat(uint32_t this_ptr) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = HTLCOutputInCommitment_get_amount_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_HTLCOutputInCommitment_set_amount_msat"))) TS_HTLCOutputInCommitment_set_amount_msat(uint32_t this_ptr, int64_t val) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	HTLCOutputInCommitment_set_amount_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_HTLCOutputInCommitment_get_cltv_expiry"))) TS_HTLCOutputInCommitment_get_cltv_expiry(uint32_t this_ptr) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = HTLCOutputInCommitment_get_cltv_expiry(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_HTLCOutputInCommitment_set_cltv_expiry"))) TS_HTLCOutputInCommitment_set_cltv_expiry(uint32_t this_ptr, int32_t val) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	HTLCOutputInCommitment_set_cltv_expiry(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_HTLCOutputInCommitment_get_payment_hash"))) TS_HTLCOutputInCommitment_get_payment_hash(uint32_t this_ptr) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *HTLCOutputInCommitment_get_payment_hash(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_HTLCOutputInCommitment_set_payment_hash"))) TS_HTLCOutputInCommitment_set_payment_hash(uint32_t this_ptr, int8_tArray val) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	HTLCOutputInCommitment_set_payment_hash(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_HTLCOutputInCommitment_get_transaction_output_index"))) TS_HTLCOutputInCommitment_get_transaction_output_index(uint32_t this_ptr) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u32Z *ret_copy = MALLOC(sizeof(LDKCOption_u32Z), "LDKCOption_u32Z");
	*ret_copy = HTLCOutputInCommitment_get_transaction_output_index(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_HTLCOutputInCommitment_set_transaction_output_index"))) TS_HTLCOutputInCommitment_set_transaction_output_index(uint32_t this_ptr, uint32_t val) {
	LDKHTLCOutputInCommitment this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u32Z val_conv = *(LDKCOption_u32Z*)(val_ptr);
	val_conv = COption_u32Z_clone((LDKCOption_u32Z*)(((uintptr_t)val) & ~1));
	HTLCOutputInCommitment_set_transaction_output_index(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_HTLCOutputInCommitment_new"))) TS_HTLCOutputInCommitment_new(jboolean offered_arg, int64_t amount_msat_arg, int32_t cltv_expiry_arg, int8_tArray payment_hash_arg, uint32_t transaction_output_index_arg) {
	LDKThirtyTwoBytes payment_hash_arg_ref;
	CHECK(payment_hash_arg->arr_len == 32);
	memcpy(payment_hash_arg_ref.data, payment_hash_arg->elems, 32); FREE(payment_hash_arg);
	void* transaction_output_index_arg_ptr = (void*)(((uintptr_t)transaction_output_index_arg) & ~1);
	CHECK_ACCESS(transaction_output_index_arg_ptr);
	LDKCOption_u32Z transaction_output_index_arg_conv = *(LDKCOption_u32Z*)(transaction_output_index_arg_ptr);
	transaction_output_index_arg_conv = COption_u32Z_clone((LDKCOption_u32Z*)(((uintptr_t)transaction_output_index_arg) & ~1));
	LDKHTLCOutputInCommitment ret_var = HTLCOutputInCommitment_new(offered_arg, amount_msat_arg, cltv_expiry_arg, payment_hash_arg_ref, transaction_output_index_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t HTLCOutputInCommitment_clone_ptr(LDKHTLCOutputInCommitment *NONNULL_PTR arg) {
	LDKHTLCOutputInCommitment ret_var = HTLCOutputInCommitment_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_HTLCOutputInCommitment_clone_ptr"))) TS_HTLCOutputInCommitment_clone_ptr(uint32_t arg) {
	LDKHTLCOutputInCommitment arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = HTLCOutputInCommitment_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_HTLCOutputInCommitment_clone"))) TS_HTLCOutputInCommitment_clone(uint32_t orig) {
	LDKHTLCOutputInCommitment orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKHTLCOutputInCommitment ret_var = HTLCOutputInCommitment_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_HTLCOutputInCommitment_write"))) TS_HTLCOutputInCommitment_write(uint32_t obj) {
	LDKHTLCOutputInCommitment obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = HTLCOutputInCommitment_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_HTLCOutputInCommitment_read"))) TS_HTLCOutputInCommitment_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_HTLCOutputInCommitmentDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HTLCOutputInCommitmentDecodeErrorZ), "LDKCResult_HTLCOutputInCommitmentDecodeErrorZ");
	*ret_conv = HTLCOutputInCommitment_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_get_htlc_redeemscript"))) TS_get_htlc_redeemscript(uint32_t htlc, jboolean opt_anchors, uint32_t keys) {
	LDKHTLCOutputInCommitment htlc_conv;
	htlc_conv.inner = (void*)(htlc & (~1));
	htlc_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(htlc_conv);
	LDKTxCreationKeys keys_conv;
	keys_conv.inner = (void*)(keys & (~1));
	keys_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(keys_conv);
	LDKCVec_u8Z ret_var = get_htlc_redeemscript(&htlc_conv, opt_anchors, &keys_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_make_funding_redeemscript"))) TS_make_funding_redeemscript(int8_tArray broadcaster, int8_tArray countersignatory) {
	LDKPublicKey broadcaster_ref;
	CHECK(broadcaster->arr_len == 33);
	memcpy(broadcaster_ref.compressed_form, broadcaster->elems, 33); FREE(broadcaster);
	LDKPublicKey countersignatory_ref;
	CHECK(countersignatory->arr_len == 33);
	memcpy(countersignatory_ref.compressed_form, countersignatory->elems, 33); FREE(countersignatory);
	LDKCVec_u8Z ret_var = make_funding_redeemscript(broadcaster_ref, countersignatory_ref);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_build_htlc_transaction"))) TS_build_htlc_transaction(int8_tArray commitment_txid, int32_t feerate_per_kw, int16_t contest_delay, uint32_t htlc, jboolean opt_anchors, int8_tArray broadcaster_delayed_payment_key, int8_tArray revocation_key) {
	unsigned char commitment_txid_arr[32];
	CHECK(commitment_txid->arr_len == 32);
	memcpy(commitment_txid_arr, commitment_txid->elems, 32); FREE(commitment_txid);
	unsigned char (*commitment_txid_ref)[32] = &commitment_txid_arr;
	LDKHTLCOutputInCommitment htlc_conv;
	htlc_conv.inner = (void*)(htlc & (~1));
	htlc_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(htlc_conv);
	LDKPublicKey broadcaster_delayed_payment_key_ref;
	CHECK(broadcaster_delayed_payment_key->arr_len == 33);
	memcpy(broadcaster_delayed_payment_key_ref.compressed_form, broadcaster_delayed_payment_key->elems, 33); FREE(broadcaster_delayed_payment_key);
	LDKPublicKey revocation_key_ref;
	CHECK(revocation_key->arr_len == 33);
	memcpy(revocation_key_ref.compressed_form, revocation_key->elems, 33); FREE(revocation_key);
	LDKTransaction ret_var = build_htlc_transaction(commitment_txid_ref, feerate_per_kw, contest_delay, &htlc_conv, opt_anchors, broadcaster_delayed_payment_key_ref, revocation_key_ref);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	Transaction_free(ret_var);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_get_anchor_redeemscript"))) TS_get_anchor_redeemscript(int8_tArray funding_pubkey) {
	LDKPublicKey funding_pubkey_ref;
	CHECK(funding_pubkey->arr_len == 33);
	memcpy(funding_pubkey_ref.compressed_form, funding_pubkey->elems, 33); FREE(funding_pubkey);
	LDKCVec_u8Z ret_var = get_anchor_redeemscript(funding_pubkey_ref);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

void  __attribute__((export_name("TS_ChannelTransactionParameters_free"))) TS_ChannelTransactionParameters_free(uint32_t this_obj) {
	LDKChannelTransactionParameters this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelTransactionParameters_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_get_holder_pubkeys"))) TS_ChannelTransactionParameters_get_holder_pubkeys(uint32_t this_ptr) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelPublicKeys ret_var = ChannelTransactionParameters_get_holder_pubkeys(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelTransactionParameters_set_holder_pubkeys"))) TS_ChannelTransactionParameters_set_holder_pubkeys(uint32_t this_ptr, uint32_t val) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelPublicKeys val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelPublicKeys_clone(&val_conv);
	ChannelTransactionParameters_set_holder_pubkeys(&this_ptr_conv, val_conv);
}

int16_t  __attribute__((export_name("TS_ChannelTransactionParameters_get_holder_selected_contest_delay"))) TS_ChannelTransactionParameters_get_holder_selected_contest_delay(uint32_t this_ptr) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = ChannelTransactionParameters_get_holder_selected_contest_delay(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelTransactionParameters_set_holder_selected_contest_delay"))) TS_ChannelTransactionParameters_set_holder_selected_contest_delay(uint32_t this_ptr, int16_t val) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelTransactionParameters_set_holder_selected_contest_delay(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelTransactionParameters_get_is_outbound_from_holder"))) TS_ChannelTransactionParameters_get_is_outbound_from_holder(uint32_t this_ptr) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelTransactionParameters_get_is_outbound_from_holder(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelTransactionParameters_set_is_outbound_from_holder"))) TS_ChannelTransactionParameters_set_is_outbound_from_holder(uint32_t this_ptr, jboolean val) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelTransactionParameters_set_is_outbound_from_holder(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_get_counterparty_parameters"))) TS_ChannelTransactionParameters_get_counterparty_parameters(uint32_t this_ptr) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCounterpartyChannelTransactionParameters ret_var = ChannelTransactionParameters_get_counterparty_parameters(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelTransactionParameters_set_counterparty_parameters"))) TS_ChannelTransactionParameters_set_counterparty_parameters(uint32_t this_ptr, uint32_t val) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCounterpartyChannelTransactionParameters val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = CounterpartyChannelTransactionParameters_clone(&val_conv);
	ChannelTransactionParameters_set_counterparty_parameters(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_get_funding_outpoint"))) TS_ChannelTransactionParameters_get_funding_outpoint(uint32_t this_ptr) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint ret_var = ChannelTransactionParameters_get_funding_outpoint(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelTransactionParameters_set_funding_outpoint"))) TS_ChannelTransactionParameters_set_funding_outpoint(uint32_t this_ptr, uint32_t val) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKOutPoint val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = OutPoint_clone(&val_conv);
	ChannelTransactionParameters_set_funding_outpoint(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_get_opt_anchors"))) TS_ChannelTransactionParameters_get_opt_anchors(uint32_t this_ptr) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	uint32_t ret_conv = LDKCOption_NoneZ_to_js(ChannelTransactionParameters_get_opt_anchors(&this_ptr_conv));
	return ret_conv;
}

void  __attribute__((export_name("TS_ChannelTransactionParameters_set_opt_anchors"))) TS_ChannelTransactionParameters_set_opt_anchors(uint32_t this_ptr, uint32_t val) {
	LDKChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_NoneZ val_conv = LDKCOption_NoneZ_from_js(val);
	ChannelTransactionParameters_set_opt_anchors(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_new"))) TS_ChannelTransactionParameters_new(uint32_t holder_pubkeys_arg, int16_t holder_selected_contest_delay_arg, jboolean is_outbound_from_holder_arg, uint32_t counterparty_parameters_arg, uint32_t funding_outpoint_arg, uint32_t opt_anchors_arg) {
	LDKChannelPublicKeys holder_pubkeys_arg_conv;
	holder_pubkeys_arg_conv.inner = (void*)(holder_pubkeys_arg & (~1));
	holder_pubkeys_arg_conv.is_owned = (holder_pubkeys_arg & 1) || (holder_pubkeys_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(holder_pubkeys_arg_conv);
	holder_pubkeys_arg_conv = ChannelPublicKeys_clone(&holder_pubkeys_arg_conv);
	LDKCounterpartyChannelTransactionParameters counterparty_parameters_arg_conv;
	counterparty_parameters_arg_conv.inner = (void*)(counterparty_parameters_arg & (~1));
	counterparty_parameters_arg_conv.is_owned = (counterparty_parameters_arg & 1) || (counterparty_parameters_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(counterparty_parameters_arg_conv);
	counterparty_parameters_arg_conv = CounterpartyChannelTransactionParameters_clone(&counterparty_parameters_arg_conv);
	LDKOutPoint funding_outpoint_arg_conv;
	funding_outpoint_arg_conv.inner = (void*)(funding_outpoint_arg & (~1));
	funding_outpoint_arg_conv.is_owned = (funding_outpoint_arg & 1) || (funding_outpoint_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_outpoint_arg_conv);
	funding_outpoint_arg_conv = OutPoint_clone(&funding_outpoint_arg_conv);
	LDKCOption_NoneZ opt_anchors_arg_conv = LDKCOption_NoneZ_from_js(opt_anchors_arg);
	LDKChannelTransactionParameters ret_var = ChannelTransactionParameters_new(holder_pubkeys_arg_conv, holder_selected_contest_delay_arg, is_outbound_from_holder_arg, counterparty_parameters_arg_conv, funding_outpoint_arg_conv, opt_anchors_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelTransactionParameters_clone_ptr(LDKChannelTransactionParameters *NONNULL_PTR arg) {
	LDKChannelTransactionParameters ret_var = ChannelTransactionParameters_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_clone_ptr"))) TS_ChannelTransactionParameters_clone_ptr(uint32_t arg) {
	LDKChannelTransactionParameters arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelTransactionParameters_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_clone"))) TS_ChannelTransactionParameters_clone(uint32_t orig) {
	LDKChannelTransactionParameters orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelTransactionParameters ret_var = ChannelTransactionParameters_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_free"))) TS_CounterpartyChannelTransactionParameters_free(uint32_t this_obj) {
	LDKCounterpartyChannelTransactionParameters this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	CounterpartyChannelTransactionParameters_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_get_pubkeys"))) TS_CounterpartyChannelTransactionParameters_get_pubkeys(uint32_t this_ptr) {
	LDKCounterpartyChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelPublicKeys ret_var = CounterpartyChannelTransactionParameters_get_pubkeys(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_set_pubkeys"))) TS_CounterpartyChannelTransactionParameters_set_pubkeys(uint32_t this_ptr, uint32_t val) {
	LDKCounterpartyChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelPublicKeys val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelPublicKeys_clone(&val_conv);
	CounterpartyChannelTransactionParameters_set_pubkeys(&this_ptr_conv, val_conv);
}

int16_t  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_get_selected_contest_delay"))) TS_CounterpartyChannelTransactionParameters_get_selected_contest_delay(uint32_t this_ptr) {
	LDKCounterpartyChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = CounterpartyChannelTransactionParameters_get_selected_contest_delay(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_set_selected_contest_delay"))) TS_CounterpartyChannelTransactionParameters_set_selected_contest_delay(uint32_t this_ptr, int16_t val) {
	LDKCounterpartyChannelTransactionParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	CounterpartyChannelTransactionParameters_set_selected_contest_delay(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_new"))) TS_CounterpartyChannelTransactionParameters_new(uint32_t pubkeys_arg, int16_t selected_contest_delay_arg) {
	LDKChannelPublicKeys pubkeys_arg_conv;
	pubkeys_arg_conv.inner = (void*)(pubkeys_arg & (~1));
	pubkeys_arg_conv.is_owned = (pubkeys_arg & 1) || (pubkeys_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(pubkeys_arg_conv);
	pubkeys_arg_conv = ChannelPublicKeys_clone(&pubkeys_arg_conv);
	LDKCounterpartyChannelTransactionParameters ret_var = CounterpartyChannelTransactionParameters_new(pubkeys_arg_conv, selected_contest_delay_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t CounterpartyChannelTransactionParameters_clone_ptr(LDKCounterpartyChannelTransactionParameters *NONNULL_PTR arg) {
	LDKCounterpartyChannelTransactionParameters ret_var = CounterpartyChannelTransactionParameters_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_clone_ptr"))) TS_CounterpartyChannelTransactionParameters_clone_ptr(uint32_t arg) {
	LDKCounterpartyChannelTransactionParameters arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = CounterpartyChannelTransactionParameters_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_clone"))) TS_CounterpartyChannelTransactionParameters_clone(uint32_t orig) {
	LDKCounterpartyChannelTransactionParameters orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKCounterpartyChannelTransactionParameters ret_var = CounterpartyChannelTransactionParameters_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_ChannelTransactionParameters_is_populated"))) TS_ChannelTransactionParameters_is_populated(uint32_t this_arg) {
	LDKChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = ChannelTransactionParameters_is_populated(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_as_holder_broadcastable"))) TS_ChannelTransactionParameters_as_holder_broadcastable(uint32_t this_arg) {
	LDKChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKDirectedChannelTransactionParameters ret_var = ChannelTransactionParameters_as_holder_broadcastable(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_as_counterparty_broadcastable"))) TS_ChannelTransactionParameters_as_counterparty_broadcastable(uint32_t this_arg) {
	LDKChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKDirectedChannelTransactionParameters ret_var = ChannelTransactionParameters_as_counterparty_broadcastable(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_write"))) TS_CounterpartyChannelTransactionParameters_write(uint32_t obj) {
	LDKCounterpartyChannelTransactionParameters obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = CounterpartyChannelTransactionParameters_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_CounterpartyChannelTransactionParameters_read"))) TS_CounterpartyChannelTransactionParameters_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ), "LDKCResult_CounterpartyChannelTransactionParametersDecodeErrorZ");
	*ret_conv = CounterpartyChannelTransactionParameters_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelTransactionParameters_write"))) TS_ChannelTransactionParameters_write(uint32_t obj) {
	LDKChannelTransactionParameters obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelTransactionParameters_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelTransactionParameters_read"))) TS_ChannelTransactionParameters_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelTransactionParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelTransactionParametersDecodeErrorZ), "LDKCResult_ChannelTransactionParametersDecodeErrorZ");
	*ret_conv = ChannelTransactionParameters_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_DirectedChannelTransactionParameters_free"))) TS_DirectedChannelTransactionParameters_free(uint32_t this_obj) {
	LDKDirectedChannelTransactionParameters this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	DirectedChannelTransactionParameters_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_DirectedChannelTransactionParameters_broadcaster_pubkeys"))) TS_DirectedChannelTransactionParameters_broadcaster_pubkeys(uint32_t this_arg) {
	LDKDirectedChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelPublicKeys ret_var = DirectedChannelTransactionParameters_broadcaster_pubkeys(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_DirectedChannelTransactionParameters_countersignatory_pubkeys"))) TS_DirectedChannelTransactionParameters_countersignatory_pubkeys(uint32_t this_arg) {
	LDKDirectedChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelPublicKeys ret_var = DirectedChannelTransactionParameters_countersignatory_pubkeys(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int16_t  __attribute__((export_name("TS_DirectedChannelTransactionParameters_contest_delay"))) TS_DirectedChannelTransactionParameters_contest_delay(uint32_t this_arg) {
	LDKDirectedChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int16_t ret_val = DirectedChannelTransactionParameters_contest_delay(&this_arg_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_DirectedChannelTransactionParameters_is_outbound"))) TS_DirectedChannelTransactionParameters_is_outbound(uint32_t this_arg) {
	LDKDirectedChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = DirectedChannelTransactionParameters_is_outbound(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_DirectedChannelTransactionParameters_funding_outpoint"))) TS_DirectedChannelTransactionParameters_funding_outpoint(uint32_t this_arg) {
	LDKDirectedChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKOutPoint ret_var = DirectedChannelTransactionParameters_funding_outpoint(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_DirectedChannelTransactionParameters_opt_anchors"))) TS_DirectedChannelTransactionParameters_opt_anchors(uint32_t this_arg) {
	LDKDirectedChannelTransactionParameters this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = DirectedChannelTransactionParameters_opt_anchors(&this_arg_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_HolderCommitmentTransaction_free"))) TS_HolderCommitmentTransaction_free(uint32_t this_obj) {
	LDKHolderCommitmentTransaction this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	HolderCommitmentTransaction_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_HolderCommitmentTransaction_get_counterparty_sig"))) TS_HolderCommitmentTransaction_get_counterparty_sig(uint32_t this_ptr) {
	LDKHolderCommitmentTransaction this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, HolderCommitmentTransaction_get_counterparty_sig(&this_ptr_conv).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_HolderCommitmentTransaction_set_counterparty_sig"))) TS_HolderCommitmentTransaction_set_counterparty_sig(uint32_t this_ptr, int8_tArray val) {
	LDKHolderCommitmentTransaction this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKSignature val_ref;
	CHECK(val->arr_len == 64);
	memcpy(val_ref.compact_form, val->elems, 64); FREE(val);
	HolderCommitmentTransaction_set_counterparty_sig(&this_ptr_conv, val_ref);
}

void  __attribute__((export_name("TS_HolderCommitmentTransaction_set_counterparty_htlc_sigs"))) TS_HolderCommitmentTransaction_set_counterparty_htlc_sigs(uint32_t this_ptr, ptrArray val) {
	LDKHolderCommitmentTransaction this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_SignatureZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKSignature), "LDKCVec_SignatureZ Elements");
	else
		val_constr.data = NULL;
	int8_tArray* val_vals = (void*) val->elems /* XXX val leaks */;
	for (size_t m = 0; m < val_constr.datalen; m++) {
		int8_tArray val_conv_12 = val_vals[m];
		LDKSignature val_conv_12_ref;
		CHECK(val_conv_12->arr_len == 64);
		memcpy(val_conv_12_ref.compact_form, val_conv_12->elems, 64); FREE(val_conv_12);
		val_constr.data[m] = val_conv_12_ref;
	}
	HolderCommitmentTransaction_set_counterparty_htlc_sigs(&this_ptr_conv, val_constr);
}

static inline uintptr_t HolderCommitmentTransaction_clone_ptr(LDKHolderCommitmentTransaction *NONNULL_PTR arg) {
	LDKHolderCommitmentTransaction ret_var = HolderCommitmentTransaction_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_HolderCommitmentTransaction_clone_ptr"))) TS_HolderCommitmentTransaction_clone_ptr(uint32_t arg) {
	LDKHolderCommitmentTransaction arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = HolderCommitmentTransaction_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_HolderCommitmentTransaction_clone"))) TS_HolderCommitmentTransaction_clone(uint32_t orig) {
	LDKHolderCommitmentTransaction orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKHolderCommitmentTransaction ret_var = HolderCommitmentTransaction_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_HolderCommitmentTransaction_write"))) TS_HolderCommitmentTransaction_write(uint32_t obj) {
	LDKHolderCommitmentTransaction obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = HolderCommitmentTransaction_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_HolderCommitmentTransaction_read"))) TS_HolderCommitmentTransaction_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_HolderCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_HolderCommitmentTransactionDecodeErrorZ), "LDKCResult_HolderCommitmentTransactionDecodeErrorZ");
	*ret_conv = HolderCommitmentTransaction_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_HolderCommitmentTransaction_new"))) TS_HolderCommitmentTransaction_new(uint32_t commitment_tx, int8_tArray counterparty_sig, ptrArray counterparty_htlc_sigs, int8_tArray holder_funding_key, int8_tArray counterparty_funding_key) {
	LDKCommitmentTransaction commitment_tx_conv;
	commitment_tx_conv.inner = (void*)(commitment_tx & (~1));
	commitment_tx_conv.is_owned = (commitment_tx & 1) || (commitment_tx == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(commitment_tx_conv);
	commitment_tx_conv = CommitmentTransaction_clone(&commitment_tx_conv);
	LDKSignature counterparty_sig_ref;
	CHECK(counterparty_sig->arr_len == 64);
	memcpy(counterparty_sig_ref.compact_form, counterparty_sig->elems, 64); FREE(counterparty_sig);
	LDKCVec_SignatureZ counterparty_htlc_sigs_constr;
	counterparty_htlc_sigs_constr.datalen = counterparty_htlc_sigs->arr_len;
	if (counterparty_htlc_sigs_constr.datalen > 0)
		counterparty_htlc_sigs_constr.data = MALLOC(counterparty_htlc_sigs_constr.datalen * sizeof(LDKSignature), "LDKCVec_SignatureZ Elements");
	else
		counterparty_htlc_sigs_constr.data = NULL;
	int8_tArray* counterparty_htlc_sigs_vals = (void*) counterparty_htlc_sigs->elems /* XXX counterparty_htlc_sigs leaks */;
	for (size_t m = 0; m < counterparty_htlc_sigs_constr.datalen; m++) {
		int8_tArray counterparty_htlc_sigs_conv_12 = counterparty_htlc_sigs_vals[m];
		LDKSignature counterparty_htlc_sigs_conv_12_ref;
		CHECK(counterparty_htlc_sigs_conv_12->arr_len == 64);
		memcpy(counterparty_htlc_sigs_conv_12_ref.compact_form, counterparty_htlc_sigs_conv_12->elems, 64); FREE(counterparty_htlc_sigs_conv_12);
		counterparty_htlc_sigs_constr.data[m] = counterparty_htlc_sigs_conv_12_ref;
	}
	LDKPublicKey holder_funding_key_ref;
	CHECK(holder_funding_key->arr_len == 33);
	memcpy(holder_funding_key_ref.compressed_form, holder_funding_key->elems, 33); FREE(holder_funding_key);
	LDKPublicKey counterparty_funding_key_ref;
	CHECK(counterparty_funding_key->arr_len == 33);
	memcpy(counterparty_funding_key_ref.compressed_form, counterparty_funding_key->elems, 33); FREE(counterparty_funding_key);
	LDKHolderCommitmentTransaction ret_var = HolderCommitmentTransaction_new(commitment_tx_conv, counterparty_sig_ref, counterparty_htlc_sigs_constr, holder_funding_key_ref, counterparty_funding_key_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_BuiltCommitmentTransaction_free"))) TS_BuiltCommitmentTransaction_free(uint32_t this_obj) {
	LDKBuiltCommitmentTransaction this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	BuiltCommitmentTransaction_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_BuiltCommitmentTransaction_get_transaction"))) TS_BuiltCommitmentTransaction_get_transaction(uint32_t this_ptr) {
	LDKBuiltCommitmentTransaction this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKTransaction ret_var = BuiltCommitmentTransaction_get_transaction(&this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	Transaction_free(ret_var);
	return ret_arr;
}

void  __attribute__((export_name("TS_BuiltCommitmentTransaction_set_transaction"))) TS_BuiltCommitmentTransaction_set_transaction(uint32_t this_ptr, int8_tArray val) {
	LDKBuiltCommitmentTransaction this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKTransaction val_ref;
	val_ref.datalen = val->arr_len;
	val_ref.data = MALLOC(val_ref.datalen, "LDKTransaction Bytes");
	memcpy(val_ref.data, val->elems, val_ref.datalen); FREE(val);
	val_ref.data_is_owned = true;
	BuiltCommitmentTransaction_set_transaction(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_BuiltCommitmentTransaction_get_txid"))) TS_BuiltCommitmentTransaction_get_txid(uint32_t this_ptr) {
	LDKBuiltCommitmentTransaction this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *BuiltCommitmentTransaction_get_txid(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_BuiltCommitmentTransaction_set_txid"))) TS_BuiltCommitmentTransaction_set_txid(uint32_t this_ptr, int8_tArray val) {
	LDKBuiltCommitmentTransaction this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	BuiltCommitmentTransaction_set_txid(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_BuiltCommitmentTransaction_new"))) TS_BuiltCommitmentTransaction_new(int8_tArray transaction_arg, int8_tArray txid_arg) {
	LDKTransaction transaction_arg_ref;
	transaction_arg_ref.datalen = transaction_arg->arr_len;
	transaction_arg_ref.data = MALLOC(transaction_arg_ref.datalen, "LDKTransaction Bytes");
	memcpy(transaction_arg_ref.data, transaction_arg->elems, transaction_arg_ref.datalen); FREE(transaction_arg);
	transaction_arg_ref.data_is_owned = true;
	LDKThirtyTwoBytes txid_arg_ref;
	CHECK(txid_arg->arr_len == 32);
	memcpy(txid_arg_ref.data, txid_arg->elems, 32); FREE(txid_arg);
	LDKBuiltCommitmentTransaction ret_var = BuiltCommitmentTransaction_new(transaction_arg_ref, txid_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t BuiltCommitmentTransaction_clone_ptr(LDKBuiltCommitmentTransaction *NONNULL_PTR arg) {
	LDKBuiltCommitmentTransaction ret_var = BuiltCommitmentTransaction_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_BuiltCommitmentTransaction_clone_ptr"))) TS_BuiltCommitmentTransaction_clone_ptr(uint32_t arg) {
	LDKBuiltCommitmentTransaction arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = BuiltCommitmentTransaction_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_BuiltCommitmentTransaction_clone"))) TS_BuiltCommitmentTransaction_clone(uint32_t orig) {
	LDKBuiltCommitmentTransaction orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKBuiltCommitmentTransaction ret_var = BuiltCommitmentTransaction_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_BuiltCommitmentTransaction_write"))) TS_BuiltCommitmentTransaction_write(uint32_t obj) {
	LDKBuiltCommitmentTransaction obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = BuiltCommitmentTransaction_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_BuiltCommitmentTransaction_read"))) TS_BuiltCommitmentTransaction_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_BuiltCommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_BuiltCommitmentTransactionDecodeErrorZ), "LDKCResult_BuiltCommitmentTransactionDecodeErrorZ");
	*ret_conv = BuiltCommitmentTransaction_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_BuiltCommitmentTransaction_get_sighash_all"))) TS_BuiltCommitmentTransaction_get_sighash_all(uint32_t this_arg, int8_tArray funding_redeemscript, int64_t channel_value_satoshis) {
	LDKBuiltCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKu8slice funding_redeemscript_ref;
	funding_redeemscript_ref.datalen = funding_redeemscript->arr_len;
	funding_redeemscript_ref.data = funding_redeemscript->elems /* XXX funding_redeemscript leaks */;
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, BuiltCommitmentTransaction_get_sighash_all(&this_arg_conv, funding_redeemscript_ref, channel_value_satoshis).data, 32);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_BuiltCommitmentTransaction_sign"))) TS_BuiltCommitmentTransaction_sign(uint32_t this_arg, int8_tArray funding_key, int8_tArray funding_redeemscript, int64_t channel_value_satoshis) {
	LDKBuiltCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char funding_key_arr[32];
	CHECK(funding_key->arr_len == 32);
	memcpy(funding_key_arr, funding_key->elems, 32); FREE(funding_key);
	unsigned char (*funding_key_ref)[32] = &funding_key_arr;
	LDKu8slice funding_redeemscript_ref;
	funding_redeemscript_ref.datalen = funding_redeemscript->arr_len;
	funding_redeemscript_ref.data = funding_redeemscript->elems /* XXX funding_redeemscript leaks */;
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, BuiltCommitmentTransaction_sign(&this_arg_conv, funding_key_ref, funding_redeemscript_ref, channel_value_satoshis).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_ClosingTransaction_free"))) TS_ClosingTransaction_free(uint32_t this_obj) {
	LDKClosingTransaction this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ClosingTransaction_free(this_obj_conv);
}

static inline uintptr_t ClosingTransaction_clone_ptr(LDKClosingTransaction *NONNULL_PTR arg) {
	LDKClosingTransaction ret_var = ClosingTransaction_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ClosingTransaction_clone_ptr"))) TS_ClosingTransaction_clone_ptr(uint32_t arg) {
	LDKClosingTransaction arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ClosingTransaction_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ClosingTransaction_clone"))) TS_ClosingTransaction_clone(uint32_t orig) {
	LDKClosingTransaction orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKClosingTransaction ret_var = ClosingTransaction_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_ClosingTransaction_hash"))) TS_ClosingTransaction_hash(uint32_t o) {
	LDKClosingTransaction o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = ClosingTransaction_hash(&o_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ClosingTransaction_new"))) TS_ClosingTransaction_new(int64_t to_holder_value_sat, int64_t to_counterparty_value_sat, int8_tArray to_holder_script, int8_tArray to_counterparty_script, uint32_t funding_outpoint) {
	LDKCVec_u8Z to_holder_script_ref;
	to_holder_script_ref.datalen = to_holder_script->arr_len;
	to_holder_script_ref.data = MALLOC(to_holder_script_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(to_holder_script_ref.data, to_holder_script->elems, to_holder_script_ref.datalen); FREE(to_holder_script);
	LDKCVec_u8Z to_counterparty_script_ref;
	to_counterparty_script_ref.datalen = to_counterparty_script->arr_len;
	to_counterparty_script_ref.data = MALLOC(to_counterparty_script_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(to_counterparty_script_ref.data, to_counterparty_script->elems, to_counterparty_script_ref.datalen); FREE(to_counterparty_script);
	LDKOutPoint funding_outpoint_conv;
	funding_outpoint_conv.inner = (void*)(funding_outpoint & (~1));
	funding_outpoint_conv.is_owned = (funding_outpoint & 1) || (funding_outpoint == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_outpoint_conv);
	funding_outpoint_conv = OutPoint_clone(&funding_outpoint_conv);
	LDKClosingTransaction ret_var = ClosingTransaction_new(to_holder_value_sat, to_counterparty_value_sat, to_holder_script_ref, to_counterparty_script_ref, funding_outpoint_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosingTransaction_trust"))) TS_ClosingTransaction_trust(uint32_t this_arg) {
	LDKClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKTrustedClosingTransaction ret_var = ClosingTransaction_trust(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ClosingTransaction_verify"))) TS_ClosingTransaction_verify(uint32_t this_arg, uint32_t funding_outpoint) {
	LDKClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKOutPoint funding_outpoint_conv;
	funding_outpoint_conv.inner = (void*)(funding_outpoint & (~1));
	funding_outpoint_conv.is_owned = (funding_outpoint & 1) || (funding_outpoint == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(funding_outpoint_conv);
	funding_outpoint_conv = OutPoint_clone(&funding_outpoint_conv);
	LDKCResult_TrustedClosingTransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TrustedClosingTransactionNoneZ), "LDKCResult_TrustedClosingTransactionNoneZ");
	*ret_conv = ClosingTransaction_verify(&this_arg_conv, funding_outpoint_conv);
	return (uint32_t)ret_conv;
}

int64_t  __attribute__((export_name("TS_ClosingTransaction_to_holder_value_sat"))) TS_ClosingTransaction_to_holder_value_sat(uint32_t this_arg) {
	LDKClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = ClosingTransaction_to_holder_value_sat(&this_arg_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_ClosingTransaction_to_counterparty_value_sat"))) TS_ClosingTransaction_to_counterparty_value_sat(uint32_t this_arg) {
	LDKClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = ClosingTransaction_to_counterparty_value_sat(&this_arg_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_ClosingTransaction_to_holder_script"))) TS_ClosingTransaction_to_holder_script(uint32_t this_arg) {
	LDKClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKu8slice ret_var = ClosingTransaction_to_holder_script(&this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_ClosingTransaction_to_counterparty_script"))) TS_ClosingTransaction_to_counterparty_script(uint32_t this_arg) {
	LDKClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKu8slice ret_var = ClosingTransaction_to_counterparty_script(&this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	return ret_arr;
}

void  __attribute__((export_name("TS_TrustedClosingTransaction_free"))) TS_TrustedClosingTransaction_free(uint32_t this_obj) {
	LDKTrustedClosingTransaction this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	TrustedClosingTransaction_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_TrustedClosingTransaction_built_transaction"))) TS_TrustedClosingTransaction_built_transaction(uint32_t this_arg) {
	LDKTrustedClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKTransaction ret_var = TrustedClosingTransaction_built_transaction(&this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	Transaction_free(ret_var);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_TrustedClosingTransaction_get_sighash_all"))) TS_TrustedClosingTransaction_get_sighash_all(uint32_t this_arg, int8_tArray funding_redeemscript, int64_t channel_value_satoshis) {
	LDKTrustedClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKu8slice funding_redeemscript_ref;
	funding_redeemscript_ref.datalen = funding_redeemscript->arr_len;
	funding_redeemscript_ref.data = funding_redeemscript->elems /* XXX funding_redeemscript leaks */;
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, TrustedClosingTransaction_get_sighash_all(&this_arg_conv, funding_redeemscript_ref, channel_value_satoshis).data, 32);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_TrustedClosingTransaction_sign"))) TS_TrustedClosingTransaction_sign(uint32_t this_arg, int8_tArray funding_key, int8_tArray funding_redeemscript, int64_t channel_value_satoshis) {
	LDKTrustedClosingTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char funding_key_arr[32];
	CHECK(funding_key->arr_len == 32);
	memcpy(funding_key_arr, funding_key->elems, 32); FREE(funding_key);
	unsigned char (*funding_key_ref)[32] = &funding_key_arr;
	LDKu8slice funding_redeemscript_ref;
	funding_redeemscript_ref.datalen = funding_redeemscript->arr_len;
	funding_redeemscript_ref.data = funding_redeemscript->elems /* XXX funding_redeemscript leaks */;
	int8_tArray ret_arr = init_int8_tArray(64, __LINE__);
	memcpy(ret_arr->elems, TrustedClosingTransaction_sign(&this_arg_conv, funding_key_ref, funding_redeemscript_ref, channel_value_satoshis).compact_form, 64);
	return ret_arr;
}

void  __attribute__((export_name("TS_CommitmentTransaction_free"))) TS_CommitmentTransaction_free(uint32_t this_obj) {
	LDKCommitmentTransaction this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	CommitmentTransaction_free(this_obj_conv);
}

static inline uintptr_t CommitmentTransaction_clone_ptr(LDKCommitmentTransaction *NONNULL_PTR arg) {
	LDKCommitmentTransaction ret_var = CommitmentTransaction_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_CommitmentTransaction_clone_ptr"))) TS_CommitmentTransaction_clone_ptr(uint32_t arg) {
	LDKCommitmentTransaction arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = CommitmentTransaction_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CommitmentTransaction_clone"))) TS_CommitmentTransaction_clone(uint32_t orig) {
	LDKCommitmentTransaction orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKCommitmentTransaction ret_var = CommitmentTransaction_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_CommitmentTransaction_write"))) TS_CommitmentTransaction_write(uint32_t obj) {
	LDKCommitmentTransaction obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = CommitmentTransaction_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_CommitmentTransaction_read"))) TS_CommitmentTransaction_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_CommitmentTransactionDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_CommitmentTransactionDecodeErrorZ), "LDKCResult_CommitmentTransactionDecodeErrorZ");
	*ret_conv = CommitmentTransaction_read(ser_ref);
	return (uint32_t)ret_conv;
}

int64_t  __attribute__((export_name("TS_CommitmentTransaction_commitment_number"))) TS_CommitmentTransaction_commitment_number(uint32_t this_arg) {
	LDKCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = CommitmentTransaction_commitment_number(&this_arg_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_CommitmentTransaction_to_broadcaster_value_sat"))) TS_CommitmentTransaction_to_broadcaster_value_sat(uint32_t this_arg) {
	LDKCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = CommitmentTransaction_to_broadcaster_value_sat(&this_arg_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_CommitmentTransaction_to_countersignatory_value_sat"))) TS_CommitmentTransaction_to_countersignatory_value_sat(uint32_t this_arg) {
	LDKCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = CommitmentTransaction_to_countersignatory_value_sat(&this_arg_conv);
	return ret_val;
}

int32_t  __attribute__((export_name("TS_CommitmentTransaction_feerate_per_kw"))) TS_CommitmentTransaction_feerate_per_kw(uint32_t this_arg) {
	LDKCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int32_t ret_val = CommitmentTransaction_feerate_per_kw(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_CommitmentTransaction_trust"))) TS_CommitmentTransaction_trust(uint32_t this_arg) {
	LDKCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKTrustedCommitmentTransaction ret_var = CommitmentTransaction_trust(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CommitmentTransaction_verify"))) TS_CommitmentTransaction_verify(uint32_t this_arg, uint32_t channel_parameters, uint32_t broadcaster_keys, uint32_t countersignatory_keys) {
	LDKCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKDirectedChannelTransactionParameters channel_parameters_conv;
	channel_parameters_conv.inner = (void*)(channel_parameters & (~1));
	channel_parameters_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_parameters_conv);
	LDKChannelPublicKeys broadcaster_keys_conv;
	broadcaster_keys_conv.inner = (void*)(broadcaster_keys & (~1));
	broadcaster_keys_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(broadcaster_keys_conv);
	LDKChannelPublicKeys countersignatory_keys_conv;
	countersignatory_keys_conv.inner = (void*)(countersignatory_keys & (~1));
	countersignatory_keys_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(countersignatory_keys_conv);
	LDKCResult_TrustedCommitmentTransactionNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_TrustedCommitmentTransactionNoneZ), "LDKCResult_TrustedCommitmentTransactionNoneZ");
	*ret_conv = CommitmentTransaction_verify(&this_arg_conv, &channel_parameters_conv, &broadcaster_keys_conv, &countersignatory_keys_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_TrustedCommitmentTransaction_free"))) TS_TrustedCommitmentTransaction_free(uint32_t this_obj) {
	LDKTrustedCommitmentTransaction this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	TrustedCommitmentTransaction_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_TrustedCommitmentTransaction_txid"))) TS_TrustedCommitmentTransaction_txid(uint32_t this_arg) {
	LDKTrustedCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, TrustedCommitmentTransaction_txid(&this_arg_conv).data, 32);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_TrustedCommitmentTransaction_built_transaction"))) TS_TrustedCommitmentTransaction_built_transaction(uint32_t this_arg) {
	LDKTrustedCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKBuiltCommitmentTransaction ret_var = TrustedCommitmentTransaction_built_transaction(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_TrustedCommitmentTransaction_keys"))) TS_TrustedCommitmentTransaction_keys(uint32_t this_arg) {
	LDKTrustedCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKTxCreationKeys ret_var = TrustedCommitmentTransaction_keys(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_TrustedCommitmentTransaction_opt_anchors"))) TS_TrustedCommitmentTransaction_opt_anchors(uint32_t this_arg) {
	LDKTrustedCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = TrustedCommitmentTransaction_opt_anchors(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_TrustedCommitmentTransaction_get_htlc_sigs"))) TS_TrustedCommitmentTransaction_get_htlc_sigs(uint32_t this_arg, int8_tArray htlc_base_key, uint32_t channel_parameters) {
	LDKTrustedCommitmentTransaction this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char htlc_base_key_arr[32];
	CHECK(htlc_base_key->arr_len == 32);
	memcpy(htlc_base_key_arr, htlc_base_key->elems, 32); FREE(htlc_base_key);
	unsigned char (*htlc_base_key_ref)[32] = &htlc_base_key_arr;
	LDKDirectedChannelTransactionParameters channel_parameters_conv;
	channel_parameters_conv.inner = (void*)(channel_parameters & (~1));
	channel_parameters_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_parameters_conv);
	LDKCResult_CVec_SignatureZNoneZ* ret_conv = MALLOC(sizeof(LDKCResult_CVec_SignatureZNoneZ), "LDKCResult_CVec_SignatureZNoneZ");
	*ret_conv = TrustedCommitmentTransaction_get_htlc_sigs(&this_arg_conv, htlc_base_key_ref, &channel_parameters_conv);
	return (uint32_t)ret_conv;
}

int64_t  __attribute__((export_name("TS_get_commitment_transaction_number_obscure_factor"))) TS_get_commitment_transaction_number_obscure_factor(int8_tArray broadcaster_payment_basepoint, int8_tArray countersignatory_payment_basepoint, jboolean outbound_from_broadcaster) {
	LDKPublicKey broadcaster_payment_basepoint_ref;
	CHECK(broadcaster_payment_basepoint->arr_len == 33);
	memcpy(broadcaster_payment_basepoint_ref.compressed_form, broadcaster_payment_basepoint->elems, 33); FREE(broadcaster_payment_basepoint);
	LDKPublicKey countersignatory_payment_basepoint_ref;
	CHECK(countersignatory_payment_basepoint->arr_len == 33);
	memcpy(countersignatory_payment_basepoint_ref.compressed_form, countersignatory_payment_basepoint->elems, 33); FREE(countersignatory_payment_basepoint);
	int64_t ret_val = get_commitment_transaction_number_obscure_factor(broadcaster_payment_basepoint_ref, countersignatory_payment_basepoint_ref, outbound_from_broadcaster);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_InitFeatures_eq"))) TS_InitFeatures_eq(uint32_t a, uint32_t b) {
	LDKInitFeatures a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKInitFeatures b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = InitFeatures_eq(&a_conv, &b_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_NodeFeatures_eq"))) TS_NodeFeatures_eq(uint32_t a, uint32_t b) {
	LDKNodeFeatures a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKNodeFeatures b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = NodeFeatures_eq(&a_conv, &b_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_ChannelFeatures_eq"))) TS_ChannelFeatures_eq(uint32_t a, uint32_t b) {
	LDKChannelFeatures a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKChannelFeatures b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = ChannelFeatures_eq(&a_conv, &b_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_InvoiceFeatures_eq"))) TS_InvoiceFeatures_eq(uint32_t a, uint32_t b) {
	LDKInvoiceFeatures a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKInvoiceFeatures b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = InvoiceFeatures_eq(&a_conv, &b_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_ChannelTypeFeatures_eq"))) TS_ChannelTypeFeatures_eq(uint32_t a, uint32_t b) {
	LDKChannelTypeFeatures a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKChannelTypeFeatures b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = ChannelTypeFeatures_eq(&a_conv, &b_conv);
	return ret_val;
}

static inline uintptr_t InitFeatures_clone_ptr(LDKInitFeatures *NONNULL_PTR arg) {
	LDKInitFeatures ret_var = InitFeatures_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_InitFeatures_clone_ptr"))) TS_InitFeatures_clone_ptr(uint32_t arg) {
	LDKInitFeatures arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = InitFeatures_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_InitFeatures_clone"))) TS_InitFeatures_clone(uint32_t orig) {
	LDKInitFeatures orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKInitFeatures ret_var = InitFeatures_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t NodeFeatures_clone_ptr(LDKNodeFeatures *NONNULL_PTR arg) {
	LDKNodeFeatures ret_var = NodeFeatures_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_NodeFeatures_clone_ptr"))) TS_NodeFeatures_clone_ptr(uint32_t arg) {
	LDKNodeFeatures arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = NodeFeatures_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NodeFeatures_clone"))) TS_NodeFeatures_clone(uint32_t orig) {
	LDKNodeFeatures orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKNodeFeatures ret_var = NodeFeatures_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelFeatures_clone_ptr(LDKChannelFeatures *NONNULL_PTR arg) {
	LDKChannelFeatures ret_var = ChannelFeatures_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelFeatures_clone_ptr"))) TS_ChannelFeatures_clone_ptr(uint32_t arg) {
	LDKChannelFeatures arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelFeatures_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelFeatures_clone"))) TS_ChannelFeatures_clone(uint32_t orig) {
	LDKChannelFeatures orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelFeatures ret_var = ChannelFeatures_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t InvoiceFeatures_clone_ptr(LDKInvoiceFeatures *NONNULL_PTR arg) {
	LDKInvoiceFeatures ret_var = InvoiceFeatures_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_InvoiceFeatures_clone_ptr"))) TS_InvoiceFeatures_clone_ptr(uint32_t arg) {
	LDKInvoiceFeatures arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = InvoiceFeatures_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_InvoiceFeatures_clone"))) TS_InvoiceFeatures_clone(uint32_t orig) {
	LDKInvoiceFeatures orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKInvoiceFeatures ret_var = InvoiceFeatures_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelTypeFeatures_clone_ptr(LDKChannelTypeFeatures *NONNULL_PTR arg) {
	LDKChannelTypeFeatures ret_var = ChannelTypeFeatures_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelTypeFeatures_clone_ptr"))) TS_ChannelTypeFeatures_clone_ptr(uint32_t arg) {
	LDKChannelTypeFeatures arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelTypeFeatures_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelTypeFeatures_clone"))) TS_ChannelTypeFeatures_clone(uint32_t orig) {
	LDKChannelTypeFeatures orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelTypeFeatures ret_var = ChannelTypeFeatures_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_InitFeatures_free"))) TS_InitFeatures_free(uint32_t this_obj) {
	LDKInitFeatures this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	InitFeatures_free(this_obj_conv);
}

void  __attribute__((export_name("TS_NodeFeatures_free"))) TS_NodeFeatures_free(uint32_t this_obj) {
	LDKNodeFeatures this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	NodeFeatures_free(this_obj_conv);
}

void  __attribute__((export_name("TS_ChannelFeatures_free"))) TS_ChannelFeatures_free(uint32_t this_obj) {
	LDKChannelFeatures this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelFeatures_free(this_obj_conv);
}

void  __attribute__((export_name("TS_InvoiceFeatures_free"))) TS_InvoiceFeatures_free(uint32_t this_obj) {
	LDKInvoiceFeatures this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	InvoiceFeatures_free(this_obj_conv);
}

void  __attribute__((export_name("TS_ChannelTypeFeatures_free"))) TS_ChannelTypeFeatures_free(uint32_t this_obj) {
	LDKChannelTypeFeatures this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelTypeFeatures_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_InitFeatures_empty"))) TS_InitFeatures_empty() {
	LDKInitFeatures ret_var = InitFeatures_empty();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_InitFeatures_known"))) TS_InitFeatures_known() {
	LDKInitFeatures ret_var = InitFeatures_known();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_InitFeatures_requires_unknown_bits"))) TS_InitFeatures_requires_unknown_bits(uint32_t this_arg) {
	LDKInitFeatures this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = InitFeatures_requires_unknown_bits(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NodeFeatures_empty"))) TS_NodeFeatures_empty() {
	LDKNodeFeatures ret_var = NodeFeatures_empty();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NodeFeatures_known"))) TS_NodeFeatures_known() {
	LDKNodeFeatures ret_var = NodeFeatures_known();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_NodeFeatures_requires_unknown_bits"))) TS_NodeFeatures_requires_unknown_bits(uint32_t this_arg) {
	LDKNodeFeatures this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = NodeFeatures_requires_unknown_bits(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelFeatures_empty"))) TS_ChannelFeatures_empty() {
	LDKChannelFeatures ret_var = ChannelFeatures_empty();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelFeatures_known"))) TS_ChannelFeatures_known() {
	LDKChannelFeatures ret_var = ChannelFeatures_known();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_ChannelFeatures_requires_unknown_bits"))) TS_ChannelFeatures_requires_unknown_bits(uint32_t this_arg) {
	LDKChannelFeatures this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = ChannelFeatures_requires_unknown_bits(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_InvoiceFeatures_empty"))) TS_InvoiceFeatures_empty() {
	LDKInvoiceFeatures ret_var = InvoiceFeatures_empty();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_InvoiceFeatures_known"))) TS_InvoiceFeatures_known() {
	LDKInvoiceFeatures ret_var = InvoiceFeatures_known();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_InvoiceFeatures_requires_unknown_bits"))) TS_InvoiceFeatures_requires_unknown_bits(uint32_t this_arg) {
	LDKInvoiceFeatures this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = InvoiceFeatures_requires_unknown_bits(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelTypeFeatures_empty"))) TS_ChannelTypeFeatures_empty() {
	LDKChannelTypeFeatures ret_var = ChannelTypeFeatures_empty();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ChannelTypeFeatures_known"))) TS_ChannelTypeFeatures_known() {
	LDKChannelTypeFeatures ret_var = ChannelTypeFeatures_known();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_ChannelTypeFeatures_requires_unknown_bits"))) TS_ChannelTypeFeatures_requires_unknown_bits(uint32_t this_arg) {
	LDKChannelTypeFeatures this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = ChannelTypeFeatures_requires_unknown_bits(&this_arg_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_InitFeatures_write"))) TS_InitFeatures_write(uint32_t obj) {
	LDKInitFeatures obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = InitFeatures_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_InitFeatures_read"))) TS_InitFeatures_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_InitFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InitFeaturesDecodeErrorZ), "LDKCResult_InitFeaturesDecodeErrorZ");
	*ret_conv = InitFeatures_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelFeatures_write"))) TS_ChannelFeatures_write(uint32_t obj) {
	LDKChannelFeatures obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelFeatures_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelFeatures_read"))) TS_ChannelFeatures_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelFeaturesDecodeErrorZ), "LDKCResult_ChannelFeaturesDecodeErrorZ");
	*ret_conv = ChannelFeatures_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_NodeFeatures_write"))) TS_NodeFeatures_write(uint32_t obj) {
	LDKNodeFeatures obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = NodeFeatures_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_NodeFeatures_read"))) TS_NodeFeatures_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_NodeFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeFeaturesDecodeErrorZ), "LDKCResult_NodeFeaturesDecodeErrorZ");
	*ret_conv = NodeFeatures_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_InvoiceFeatures_write"))) TS_InvoiceFeatures_write(uint32_t obj) {
	LDKInvoiceFeatures obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = InvoiceFeatures_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_InvoiceFeatures_read"))) TS_InvoiceFeatures_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_InvoiceFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceFeaturesDecodeErrorZ), "LDKCResult_InvoiceFeaturesDecodeErrorZ");
	*ret_conv = InvoiceFeatures_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ChannelTypeFeatures_write"))) TS_ChannelTypeFeatures_write(uint32_t obj) {
	LDKChannelTypeFeatures obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelTypeFeatures_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelTypeFeatures_read"))) TS_ChannelTypeFeatures_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelTypeFeaturesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelTypeFeaturesDecodeErrorZ), "LDKCResult_ChannelTypeFeaturesDecodeErrorZ");
	*ret_conv = ChannelTypeFeatures_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_ShutdownScript_free"))) TS_ShutdownScript_free(uint32_t this_obj) {
	LDKShutdownScript this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ShutdownScript_free(this_obj_conv);
}

static inline uintptr_t ShutdownScript_clone_ptr(LDKShutdownScript *NONNULL_PTR arg) {
	LDKShutdownScript ret_var = ShutdownScript_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ShutdownScript_clone_ptr"))) TS_ShutdownScript_clone_ptr(uint32_t arg) {
	LDKShutdownScript arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ShutdownScript_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ShutdownScript_clone"))) TS_ShutdownScript_clone(uint32_t orig) {
	LDKShutdownScript orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKShutdownScript ret_var = ShutdownScript_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_InvalidShutdownScript_free"))) TS_InvalidShutdownScript_free(uint32_t this_obj) {
	LDKInvalidShutdownScript this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	InvalidShutdownScript_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_InvalidShutdownScript_get_script"))) TS_InvalidShutdownScript_get_script(uint32_t this_ptr) {
	LDKInvalidShutdownScript this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKu8slice ret_var = InvalidShutdownScript_get_script(&this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	return ret_arr;
}

void  __attribute__((export_name("TS_InvalidShutdownScript_set_script"))) TS_InvalidShutdownScript_set_script(uint32_t this_ptr, int8_tArray val) {
	LDKInvalidShutdownScript this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_u8Z val_ref;
	val_ref.datalen = val->arr_len;
	val_ref.data = MALLOC(val_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(val_ref.data, val->elems, val_ref.datalen); FREE(val);
	InvalidShutdownScript_set_script(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_InvalidShutdownScript_new"))) TS_InvalidShutdownScript_new(int8_tArray script_arg) {
	LDKCVec_u8Z script_arg_ref;
	script_arg_ref.datalen = script_arg->arr_len;
	script_arg_ref.data = MALLOC(script_arg_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(script_arg_ref.data, script_arg->elems, script_arg_ref.datalen); FREE(script_arg);
	LDKInvalidShutdownScript ret_var = InvalidShutdownScript_new(script_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t InvalidShutdownScript_clone_ptr(LDKInvalidShutdownScript *NONNULL_PTR arg) {
	LDKInvalidShutdownScript ret_var = InvalidShutdownScript_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_InvalidShutdownScript_clone_ptr"))) TS_InvalidShutdownScript_clone_ptr(uint32_t arg) {
	LDKInvalidShutdownScript arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = InvalidShutdownScript_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_InvalidShutdownScript_clone"))) TS_InvalidShutdownScript_clone(uint32_t orig) {
	LDKInvalidShutdownScript orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKInvalidShutdownScript ret_var = InvalidShutdownScript_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ShutdownScript_write"))) TS_ShutdownScript_write(uint32_t obj) {
	LDKShutdownScript obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ShutdownScript_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ShutdownScript_read"))) TS_ShutdownScript_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ShutdownScriptDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptDecodeErrorZ), "LDKCResult_ShutdownScriptDecodeErrorZ");
	*ret_conv = ShutdownScript_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ShutdownScript_new_p2wpkh"))) TS_ShutdownScript_new_p2wpkh(int8_tArray pubkey_hash) {
	unsigned char pubkey_hash_arr[20];
	CHECK(pubkey_hash->arr_len == 20);
	memcpy(pubkey_hash_arr, pubkey_hash->elems, 20); FREE(pubkey_hash);
	unsigned char (*pubkey_hash_ref)[20] = &pubkey_hash_arr;
	LDKShutdownScript ret_var = ShutdownScript_new_p2wpkh(pubkey_hash_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ShutdownScript_new_p2wsh"))) TS_ShutdownScript_new_p2wsh(int8_tArray script_hash) {
	unsigned char script_hash_arr[32];
	CHECK(script_hash->arr_len == 32);
	memcpy(script_hash_arr, script_hash->elems, 32); FREE(script_hash);
	unsigned char (*script_hash_ref)[32] = &script_hash_arr;
	LDKShutdownScript ret_var = ShutdownScript_new_p2wsh(script_hash_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ShutdownScript_new_witness_program"))) TS_ShutdownScript_new_witness_program(int8_t version, int8_tArray program) {
	LDKu8slice program_ref;
	program_ref.datalen = program->arr_len;
	program_ref.data = program->elems /* XXX program leaks */;
	LDKCResult_ShutdownScriptInvalidShutdownScriptZ* ret_conv = MALLOC(sizeof(LDKCResult_ShutdownScriptInvalidShutdownScriptZ), "LDKCResult_ShutdownScriptInvalidShutdownScriptZ");
	*ret_conv = ShutdownScript_new_witness_program(version, program_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_ShutdownScript_into_inner"))) TS_ShutdownScript_into_inner(uint32_t this_arg) {
	LDKShutdownScript this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = (this_arg & 1) || (this_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	this_arg_conv = ShutdownScript_clone(&this_arg_conv);
	LDKCVec_u8Z ret_var = ShutdownScript_into_inner(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_ShutdownScript_as_legacy_pubkey"))) TS_ShutdownScript_as_legacy_pubkey(uint32_t this_arg) {
	LDKShutdownScript this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, ShutdownScript_as_legacy_pubkey(&this_arg_conv).compressed_form, 33);
	return ret_arr;
}

jboolean  __attribute__((export_name("TS_ShutdownScript_is_compatible"))) TS_ShutdownScript_is_compatible(uint32_t this_arg, uint32_t features) {
	LDKShutdownScript this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKInitFeatures features_conv;
	features_conv.inner = (void*)(features & (~1));
	features_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(features_conv);
	jboolean ret_val = ShutdownScript_is_compatible(&this_arg_conv, &features_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_CustomMessageReader_free"))) TS_CustomMessageReader_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKCustomMessageReader this_ptr_conv = *(LDKCustomMessageReader*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	CustomMessageReader_free(this_ptr_conv);
}

static inline uintptr_t Type_clone_ptr(LDKType *NONNULL_PTR arg) {
	LDKType* ret_ret = MALLOC(sizeof(LDKType), "LDKType");
	*ret_ret = Type_clone(arg);
	return (uint32_t)ret_ret;
}
uint32_t  __attribute__((export_name("TS_Type_clone_ptr"))) TS_Type_clone_ptr(uint32_t arg) {
	void* arg_ptr = (void*)(((uintptr_t)arg) & ~1);
	if (!(arg & 1)) { CHECK_ACCESS(arg_ptr); }
	LDKType* arg_conv = (LDKType*)arg_ptr;
	uint32_t ret_val = Type_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Type_clone"))) TS_Type_clone(uint32_t orig) {
	void* orig_ptr = (void*)(((uintptr_t)orig) & ~1);
	if (!(orig & 1)) { CHECK_ACCESS(orig_ptr); }
	LDKType* orig_conv = (LDKType*)orig_ptr;
	LDKType* ret_ret = MALLOC(sizeof(LDKType), "LDKType");
	*ret_ret = Type_clone(orig_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_Type_free"))) TS_Type_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKType this_ptr_conv = *(LDKType*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Type_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_NodeId_free"))) TS_NodeId_free(uint32_t this_obj) {
	LDKNodeId this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	NodeId_free(this_obj_conv);
}

static inline uintptr_t NodeId_clone_ptr(LDKNodeId *NONNULL_PTR arg) {
	LDKNodeId ret_var = NodeId_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_NodeId_clone_ptr"))) TS_NodeId_clone_ptr(uint32_t arg) {
	LDKNodeId arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = NodeId_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NodeId_clone"))) TS_NodeId_clone(uint32_t orig) {
	LDKNodeId orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKNodeId ret_var = NodeId_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NodeId_from_pubkey"))) TS_NodeId_from_pubkey(int8_tArray pubkey) {
	LDKPublicKey pubkey_ref;
	CHECK(pubkey->arr_len == 33);
	memcpy(pubkey_ref.compressed_form, pubkey->elems, 33); FREE(pubkey);
	LDKNodeId ret_var = NodeId_from_pubkey(pubkey_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_NodeId_as_slice"))) TS_NodeId_as_slice(uint32_t this_arg) {
	LDKNodeId this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKu8slice ret_var = NodeId_as_slice(&this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	return ret_arr;
}

int64_t  __attribute__((export_name("TS_NodeId_hash"))) TS_NodeId_hash(uint32_t o) {
	LDKNodeId o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = NodeId_hash(&o_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_NodeId_write"))) TS_NodeId_write(uint32_t obj) {
	LDKNodeId obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = NodeId_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_NodeId_read"))) TS_NodeId_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_NodeIdDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeIdDecodeErrorZ), "LDKCResult_NodeIdDecodeErrorZ");
	*ret_conv = NodeId_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_NetworkGraph_free"))) TS_NetworkGraph_free(uint32_t this_obj) {
	LDKNetworkGraph this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	NetworkGraph_free(this_obj_conv);
}

static inline uintptr_t NetworkGraph_clone_ptr(LDKNetworkGraph *NONNULL_PTR arg) {
	LDKNetworkGraph ret_var = NetworkGraph_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_NetworkGraph_clone_ptr"))) TS_NetworkGraph_clone_ptr(uint32_t arg) {
	LDKNetworkGraph arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = NetworkGraph_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_clone"))) TS_NetworkGraph_clone(uint32_t orig) {
	LDKNetworkGraph orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKNetworkGraph ret_var = NetworkGraph_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ReadOnlyNetworkGraph_free"))) TS_ReadOnlyNetworkGraph_free(uint32_t this_obj) {
	LDKReadOnlyNetworkGraph this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ReadOnlyNetworkGraph_free(this_obj_conv);
}

void  __attribute__((export_name("TS_NetworkUpdate_free"))) TS_NetworkUpdate_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKNetworkUpdate this_ptr_conv = *(LDKNetworkUpdate*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	NetworkUpdate_free(this_ptr_conv);
}

static inline uintptr_t NetworkUpdate_clone_ptr(LDKNetworkUpdate *NONNULL_PTR arg) {
	LDKNetworkUpdate *ret_copy = MALLOC(sizeof(LDKNetworkUpdate), "LDKNetworkUpdate");
	*ret_copy = NetworkUpdate_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_NetworkUpdate_clone_ptr"))) TS_NetworkUpdate_clone_ptr(uint32_t arg) {
	LDKNetworkUpdate* arg_conv = (LDKNetworkUpdate*)arg;
	uint32_t ret_val = NetworkUpdate_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NetworkUpdate_clone"))) TS_NetworkUpdate_clone(uint32_t orig) {
	LDKNetworkUpdate* orig_conv = (LDKNetworkUpdate*)orig;
	LDKNetworkUpdate *ret_copy = MALLOC(sizeof(LDKNetworkUpdate), "LDKNetworkUpdate");
	*ret_copy = NetworkUpdate_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetworkUpdate_channel_update_message"))) TS_NetworkUpdate_channel_update_message(uint32_t msg) {
	LDKChannelUpdate msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = (msg & 1) || (msg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	msg_conv = ChannelUpdate_clone(&msg_conv);
	LDKNetworkUpdate *ret_copy = MALLOC(sizeof(LDKNetworkUpdate), "LDKNetworkUpdate");
	*ret_copy = NetworkUpdate_channel_update_message(msg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetworkUpdate_channel_closed"))) TS_NetworkUpdate_channel_closed(int64_t short_channel_id, jboolean is_permanent) {
	LDKNetworkUpdate *ret_copy = MALLOC(sizeof(LDKNetworkUpdate), "LDKNetworkUpdate");
	*ret_copy = NetworkUpdate_channel_closed(short_channel_id, is_permanent);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetworkUpdate_node_failure"))) TS_NetworkUpdate_node_failure(int8_tArray node_id, jboolean is_permanent) {
	LDKPublicKey node_id_ref;
	CHECK(node_id->arr_len == 33);
	memcpy(node_id_ref.compressed_form, node_id->elems, 33); FREE(node_id);
	LDKNetworkUpdate *ret_copy = MALLOC(sizeof(LDKNetworkUpdate), "LDKNetworkUpdate");
	*ret_copy = NetworkUpdate_node_failure(node_id_ref, is_permanent);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_NetworkUpdate_write"))) TS_NetworkUpdate_write(uint32_t obj) {
	LDKNetworkUpdate* obj_conv = (LDKNetworkUpdate*)obj;
	LDKCVec_u8Z ret_var = NetworkUpdate_write(obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_NetworkUpdate_read"))) TS_NetworkUpdate_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_COption_NetworkUpdateZDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_COption_NetworkUpdateZDecodeErrorZ), "LDKCResult_COption_NetworkUpdateZDecodeErrorZ");
	*ret_conv = NetworkUpdate_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_NetGraphMsgHandler_as_EventHandler"))) TS_NetGraphMsgHandler_as_EventHandler(uint32_t this_arg) {
	LDKNetGraphMsgHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKEventHandler* ret_ret = MALLOC(sizeof(LDKEventHandler), "LDKEventHandler");
	*ret_ret = NetGraphMsgHandler_as_EventHandler(&this_arg_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_NetGraphMsgHandler_free"))) TS_NetGraphMsgHandler_free(uint32_t this_obj) {
	LDKNetGraphMsgHandler this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	NetGraphMsgHandler_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_NetGraphMsgHandler_new"))) TS_NetGraphMsgHandler_new(uint32_t network_graph, uint32_t chain_access, uint32_t logger) {
	LDKNetworkGraph network_graph_conv;
	network_graph_conv.inner = (void*)(network_graph & (~1));
	network_graph_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(network_graph_conv);
	void* chain_access_ptr = (void*)(((uintptr_t)chain_access) & ~1);
	CHECK_ACCESS(chain_access_ptr);
	LDKCOption_AccessZ chain_access_conv = *(LDKCOption_AccessZ*)(chain_access_ptr);
	// WARNING: we may need a move here but no clone is available for LDKCOption_AccessZ
	if (chain_access_conv.tag == LDKCOption_AccessZ_Some) {
		// Manually implement clone for Java trait instances
		if (chain_access_conv.some.free == LDKAccess_JCalls_free) {
			// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
			LDKAccess_JCalls_cloned(&chain_access_conv.some);
		}
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	LDKNetGraphMsgHandler ret_var = NetGraphMsgHandler_new(&network_graph_conv, chain_access_conv, logger_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_NetGraphMsgHandler_add_chain_access"))) TS_NetGraphMsgHandler_add_chain_access(uint32_t this_arg, uint32_t chain_access) {
	LDKNetGraphMsgHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	void* chain_access_ptr = (void*)(((uintptr_t)chain_access) & ~1);
	CHECK_ACCESS(chain_access_ptr);
	LDKCOption_AccessZ chain_access_conv = *(LDKCOption_AccessZ*)(chain_access_ptr);
	// WARNING: we may need a move here but no clone is available for LDKCOption_AccessZ
	if (chain_access_conv.tag == LDKCOption_AccessZ_Some) {
		// Manually implement clone for Java trait instances
		if (chain_access_conv.some.free == LDKAccess_JCalls_free) {
			// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
			LDKAccess_JCalls_cloned(&chain_access_conv.some);
		}
	}
	NetGraphMsgHandler_add_chain_access(&this_arg_conv, chain_access_conv);
}

uint32_t  __attribute__((export_name("TS_NetGraphMsgHandler_as_RoutingMessageHandler"))) TS_NetGraphMsgHandler_as_RoutingMessageHandler(uint32_t this_arg) {
	LDKNetGraphMsgHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKRoutingMessageHandler* ret_ret = MALLOC(sizeof(LDKRoutingMessageHandler), "LDKRoutingMessageHandler");
	*ret_ret = NetGraphMsgHandler_as_RoutingMessageHandler(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_NetGraphMsgHandler_as_MessageSendEventsProvider"))) TS_NetGraphMsgHandler_as_MessageSendEventsProvider(uint32_t this_arg) {
	LDKNetGraphMsgHandler this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKMessageSendEventsProvider* ret_ret = MALLOC(sizeof(LDKMessageSendEventsProvider), "LDKMessageSendEventsProvider");
	*ret_ret = NetGraphMsgHandler_as_MessageSendEventsProvider(&this_arg_conv);
	return (uint32_t)ret_ret;
}

void  __attribute__((export_name("TS_ChannelUpdateInfo_free"))) TS_ChannelUpdateInfo_free(uint32_t this_obj) {
	LDKChannelUpdateInfo this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelUpdateInfo_free(this_obj_conv);
}

int32_t  __attribute__((export_name("TS_ChannelUpdateInfo_get_last_update"))) TS_ChannelUpdateInfo_get_last_update(uint32_t this_ptr) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = ChannelUpdateInfo_get_last_update(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelUpdateInfo_set_last_update"))) TS_ChannelUpdateInfo_set_last_update(uint32_t this_ptr, int32_t val) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelUpdateInfo_set_last_update(&this_ptr_conv, val);
}

jboolean  __attribute__((export_name("TS_ChannelUpdateInfo_get_enabled"))) TS_ChannelUpdateInfo_get_enabled(uint32_t this_ptr) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	jboolean ret_val = ChannelUpdateInfo_get_enabled(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelUpdateInfo_set_enabled"))) TS_ChannelUpdateInfo_set_enabled(uint32_t this_ptr, jboolean val) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelUpdateInfo_set_enabled(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_ChannelUpdateInfo_get_cltv_expiry_delta"))) TS_ChannelUpdateInfo_get_cltv_expiry_delta(uint32_t this_ptr) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = ChannelUpdateInfo_get_cltv_expiry_delta(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelUpdateInfo_set_cltv_expiry_delta"))) TS_ChannelUpdateInfo_set_cltv_expiry_delta(uint32_t this_ptr, int16_t val) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelUpdateInfo_set_cltv_expiry_delta(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ChannelUpdateInfo_get_htlc_minimum_msat"))) TS_ChannelUpdateInfo_get_htlc_minimum_msat(uint32_t this_ptr) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ChannelUpdateInfo_get_htlc_minimum_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ChannelUpdateInfo_set_htlc_minimum_msat"))) TS_ChannelUpdateInfo_set_htlc_minimum_msat(uint32_t this_ptr, int64_t val) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ChannelUpdateInfo_set_htlc_minimum_msat(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ChannelUpdateInfo_get_htlc_maximum_msat"))) TS_ChannelUpdateInfo_get_htlc_maximum_msat(uint32_t this_ptr) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = ChannelUpdateInfo_get_htlc_maximum_msat(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelUpdateInfo_set_htlc_maximum_msat"))) TS_ChannelUpdateInfo_set_htlc_maximum_msat(uint32_t this_ptr, uint32_t val) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	ChannelUpdateInfo_set_htlc_maximum_msat(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelUpdateInfo_get_fees"))) TS_ChannelUpdateInfo_get_fees(uint32_t this_ptr) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKRoutingFees ret_var = ChannelUpdateInfo_get_fees(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelUpdateInfo_set_fees"))) TS_ChannelUpdateInfo_set_fees(uint32_t this_ptr, uint32_t val) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKRoutingFees val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = RoutingFees_clone(&val_conv);
	ChannelUpdateInfo_set_fees(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelUpdateInfo_get_last_update_message"))) TS_ChannelUpdateInfo_get_last_update_message(uint32_t this_ptr) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelUpdate ret_var = ChannelUpdateInfo_get_last_update_message(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelUpdateInfo_set_last_update_message"))) TS_ChannelUpdateInfo_set_last_update_message(uint32_t this_ptr, uint32_t val) {
	LDKChannelUpdateInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelUpdate val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelUpdate_clone(&val_conv);
	ChannelUpdateInfo_set_last_update_message(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelUpdateInfo_new"))) TS_ChannelUpdateInfo_new(int32_t last_update_arg, jboolean enabled_arg, int16_t cltv_expiry_delta_arg, int64_t htlc_minimum_msat_arg, uint32_t htlc_maximum_msat_arg, uint32_t fees_arg, uint32_t last_update_message_arg) {
	void* htlc_maximum_msat_arg_ptr = (void*)(((uintptr_t)htlc_maximum_msat_arg) & ~1);
	CHECK_ACCESS(htlc_maximum_msat_arg_ptr);
	LDKCOption_u64Z htlc_maximum_msat_arg_conv = *(LDKCOption_u64Z*)(htlc_maximum_msat_arg_ptr);
	htlc_maximum_msat_arg_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)htlc_maximum_msat_arg) & ~1));
	LDKRoutingFees fees_arg_conv;
	fees_arg_conv.inner = (void*)(fees_arg & (~1));
	fees_arg_conv.is_owned = (fees_arg & 1) || (fees_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(fees_arg_conv);
	fees_arg_conv = RoutingFees_clone(&fees_arg_conv);
	LDKChannelUpdate last_update_message_arg_conv;
	last_update_message_arg_conv.inner = (void*)(last_update_message_arg & (~1));
	last_update_message_arg_conv.is_owned = (last_update_message_arg & 1) || (last_update_message_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(last_update_message_arg_conv);
	last_update_message_arg_conv = ChannelUpdate_clone(&last_update_message_arg_conv);
	LDKChannelUpdateInfo ret_var = ChannelUpdateInfo_new(last_update_arg, enabled_arg, cltv_expiry_delta_arg, htlc_minimum_msat_arg, htlc_maximum_msat_arg_conv, fees_arg_conv, last_update_message_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ChannelUpdateInfo_clone_ptr(LDKChannelUpdateInfo *NONNULL_PTR arg) {
	LDKChannelUpdateInfo ret_var = ChannelUpdateInfo_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelUpdateInfo_clone_ptr"))) TS_ChannelUpdateInfo_clone_ptr(uint32_t arg) {
	LDKChannelUpdateInfo arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelUpdateInfo_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelUpdateInfo_clone"))) TS_ChannelUpdateInfo_clone(uint32_t orig) {
	LDKChannelUpdateInfo orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelUpdateInfo ret_var = ChannelUpdateInfo_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ChannelUpdateInfo_write"))) TS_ChannelUpdateInfo_write(uint32_t obj) {
	LDKChannelUpdateInfo obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelUpdateInfo_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelUpdateInfo_read"))) TS_ChannelUpdateInfo_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelUpdateInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelUpdateInfoDecodeErrorZ), "LDKCResult_ChannelUpdateInfoDecodeErrorZ");
	*ret_conv = ChannelUpdateInfo_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_ChannelInfo_free"))) TS_ChannelInfo_free(uint32_t this_obj) {
	LDKChannelInfo this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ChannelInfo_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_get_features"))) TS_ChannelInfo_get_features(uint32_t this_ptr) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelFeatures ret_var = ChannelInfo_get_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelInfo_set_features"))) TS_ChannelInfo_set_features(uint32_t this_ptr, uint32_t val) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelFeatures_clone(&val_conv);
	ChannelInfo_set_features(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_get_node_one"))) TS_ChannelInfo_get_node_one(uint32_t this_ptr) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeId ret_var = ChannelInfo_get_node_one(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelInfo_set_node_one"))) TS_ChannelInfo_set_node_one(uint32_t this_ptr, uint32_t val) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeId val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = NodeId_clone(&val_conv);
	ChannelInfo_set_node_one(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_get_one_to_two"))) TS_ChannelInfo_get_one_to_two(uint32_t this_ptr) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelUpdateInfo ret_var = ChannelInfo_get_one_to_two(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelInfo_set_one_to_two"))) TS_ChannelInfo_set_one_to_two(uint32_t this_ptr, uint32_t val) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelUpdateInfo val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelUpdateInfo_clone(&val_conv);
	ChannelInfo_set_one_to_two(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_get_node_two"))) TS_ChannelInfo_get_node_two(uint32_t this_ptr) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeId ret_var = ChannelInfo_get_node_two(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelInfo_set_node_two"))) TS_ChannelInfo_set_node_two(uint32_t this_ptr, uint32_t val) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeId val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = NodeId_clone(&val_conv);
	ChannelInfo_set_node_two(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_get_two_to_one"))) TS_ChannelInfo_get_two_to_one(uint32_t this_ptr) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelUpdateInfo ret_var = ChannelInfo_get_two_to_one(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelInfo_set_two_to_one"))) TS_ChannelInfo_set_two_to_one(uint32_t this_ptr, uint32_t val) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelUpdateInfo val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelUpdateInfo_clone(&val_conv);
	ChannelInfo_set_two_to_one(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_get_capacity_sats"))) TS_ChannelInfo_get_capacity_sats(uint32_t this_ptr) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = ChannelInfo_get_capacity_sats(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelInfo_set_capacity_sats"))) TS_ChannelInfo_set_capacity_sats(uint32_t this_ptr, uint32_t val) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	ChannelInfo_set_capacity_sats(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_get_announcement_message"))) TS_ChannelInfo_get_announcement_message(uint32_t this_ptr) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelAnnouncement ret_var = ChannelInfo_get_announcement_message(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_ChannelInfo_set_announcement_message"))) TS_ChannelInfo_set_announcement_message(uint32_t this_ptr, uint32_t val) {
	LDKChannelInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelAnnouncement val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelAnnouncement_clone(&val_conv);
	ChannelInfo_set_announcement_message(&this_ptr_conv, val_conv);
}

static inline uintptr_t ChannelInfo_clone_ptr(LDKChannelInfo *NONNULL_PTR arg) {
	LDKChannelInfo ret_var = ChannelInfo_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ChannelInfo_clone_ptr"))) TS_ChannelInfo_clone_ptr(uint32_t arg) {
	LDKChannelInfo arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ChannelInfo_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_clone"))) TS_ChannelInfo_clone(uint32_t orig) {
	LDKChannelInfo orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKChannelInfo ret_var = ChannelInfo_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ChannelInfo_write"))) TS_ChannelInfo_write(uint32_t obj) {
	LDKChannelInfo obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ChannelInfo_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ChannelInfo_read"))) TS_ChannelInfo_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ChannelInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ChannelInfoDecodeErrorZ), "LDKCResult_ChannelInfoDecodeErrorZ");
	*ret_conv = ChannelInfo_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_DirectedChannelInfo_free"))) TS_DirectedChannelInfo_free(uint32_t this_obj) {
	LDKDirectedChannelInfo this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	DirectedChannelInfo_free(this_obj_conv);
}

static inline uintptr_t DirectedChannelInfo_clone_ptr(LDKDirectedChannelInfo *NONNULL_PTR arg) {
	LDKDirectedChannelInfo ret_var = DirectedChannelInfo_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_DirectedChannelInfo_clone_ptr"))) TS_DirectedChannelInfo_clone_ptr(uint32_t arg) {
	LDKDirectedChannelInfo arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = DirectedChannelInfo_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_DirectedChannelInfo_clone"))) TS_DirectedChannelInfo_clone(uint32_t orig) {
	LDKDirectedChannelInfo orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKDirectedChannelInfo ret_var = DirectedChannelInfo_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_DirectedChannelInfo_channel"))) TS_DirectedChannelInfo_channel(uint32_t this_arg) {
	LDKDirectedChannelInfo this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelInfo ret_var = DirectedChannelInfo_channel(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_DirectedChannelInfo_direction"))) TS_DirectedChannelInfo_direction(uint32_t this_arg) {
	LDKDirectedChannelInfo this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelUpdateInfo ret_var = DirectedChannelInfo_direction(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_DirectedChannelInfo_effective_capacity"))) TS_DirectedChannelInfo_effective_capacity(uint32_t this_arg) {
	LDKDirectedChannelInfo this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKEffectiveCapacity *ret_copy = MALLOC(sizeof(LDKEffectiveCapacity), "LDKEffectiveCapacity");
	*ret_copy = DirectedChannelInfo_effective_capacity(&this_arg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_EffectiveCapacity_free"))) TS_EffectiveCapacity_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKEffectiveCapacity this_ptr_conv = *(LDKEffectiveCapacity*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	EffectiveCapacity_free(this_ptr_conv);
}

static inline uintptr_t EffectiveCapacity_clone_ptr(LDKEffectiveCapacity *NONNULL_PTR arg) {
	LDKEffectiveCapacity *ret_copy = MALLOC(sizeof(LDKEffectiveCapacity), "LDKEffectiveCapacity");
	*ret_copy = EffectiveCapacity_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_EffectiveCapacity_clone_ptr"))) TS_EffectiveCapacity_clone_ptr(uint32_t arg) {
	LDKEffectiveCapacity* arg_conv = (LDKEffectiveCapacity*)arg;
	uint32_t ret_val = EffectiveCapacity_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_EffectiveCapacity_clone"))) TS_EffectiveCapacity_clone(uint32_t orig) {
	LDKEffectiveCapacity* orig_conv = (LDKEffectiveCapacity*)orig;
	LDKEffectiveCapacity *ret_copy = MALLOC(sizeof(LDKEffectiveCapacity), "LDKEffectiveCapacity");
	*ret_copy = EffectiveCapacity_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_EffectiveCapacity_exact_liquidity"))) TS_EffectiveCapacity_exact_liquidity(int64_t liquidity_msat) {
	LDKEffectiveCapacity *ret_copy = MALLOC(sizeof(LDKEffectiveCapacity), "LDKEffectiveCapacity");
	*ret_copy = EffectiveCapacity_exact_liquidity(liquidity_msat);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_EffectiveCapacity_maximum_htlc"))) TS_EffectiveCapacity_maximum_htlc(int64_t amount_msat) {
	LDKEffectiveCapacity *ret_copy = MALLOC(sizeof(LDKEffectiveCapacity), "LDKEffectiveCapacity");
	*ret_copy = EffectiveCapacity_maximum_htlc(amount_msat);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_EffectiveCapacity_total"))) TS_EffectiveCapacity_total(int64_t capacity_msat) {
	LDKEffectiveCapacity *ret_copy = MALLOC(sizeof(LDKEffectiveCapacity), "LDKEffectiveCapacity");
	*ret_copy = EffectiveCapacity_total(capacity_msat);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_EffectiveCapacity_infinite"))) TS_EffectiveCapacity_infinite() {
	LDKEffectiveCapacity *ret_copy = MALLOC(sizeof(LDKEffectiveCapacity), "LDKEffectiveCapacity");
	*ret_copy = EffectiveCapacity_infinite();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_EffectiveCapacity_unknown"))) TS_EffectiveCapacity_unknown() {
	LDKEffectiveCapacity *ret_copy = MALLOC(sizeof(LDKEffectiveCapacity), "LDKEffectiveCapacity");
	*ret_copy = EffectiveCapacity_unknown();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_EffectiveCapacity_as_msat"))) TS_EffectiveCapacity_as_msat(uint32_t this_arg) {
	LDKEffectiveCapacity* this_arg_conv = (LDKEffectiveCapacity*)this_arg;
	int64_t ret_val = EffectiveCapacity_as_msat(this_arg_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RoutingFees_free"))) TS_RoutingFees_free(uint32_t this_obj) {
	LDKRoutingFees this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RoutingFees_free(this_obj_conv);
}

int32_t  __attribute__((export_name("TS_RoutingFees_get_base_msat"))) TS_RoutingFees_get_base_msat(uint32_t this_ptr) {
	LDKRoutingFees this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = RoutingFees_get_base_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RoutingFees_set_base_msat"))) TS_RoutingFees_set_base_msat(uint32_t this_ptr, int32_t val) {
	LDKRoutingFees this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RoutingFees_set_base_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_RoutingFees_get_proportional_millionths"))) TS_RoutingFees_get_proportional_millionths(uint32_t this_ptr) {
	LDKRoutingFees this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = RoutingFees_get_proportional_millionths(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RoutingFees_set_proportional_millionths"))) TS_RoutingFees_set_proportional_millionths(uint32_t this_ptr, int32_t val) {
	LDKRoutingFees this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RoutingFees_set_proportional_millionths(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_RoutingFees_new"))) TS_RoutingFees_new(int32_t base_msat_arg, int32_t proportional_millionths_arg) {
	LDKRoutingFees ret_var = RoutingFees_new(base_msat_arg, proportional_millionths_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_RoutingFees_eq"))) TS_RoutingFees_eq(uint32_t a, uint32_t b) {
	LDKRoutingFees a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKRoutingFees b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = RoutingFees_eq(&a_conv, &b_conv);
	return ret_val;
}

static inline uintptr_t RoutingFees_clone_ptr(LDKRoutingFees *NONNULL_PTR arg) {
	LDKRoutingFees ret_var = RoutingFees_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RoutingFees_clone_ptr"))) TS_RoutingFees_clone_ptr(uint32_t arg) {
	LDKRoutingFees arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RoutingFees_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RoutingFees_clone"))) TS_RoutingFees_clone(uint32_t orig) {
	LDKRoutingFees orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRoutingFees ret_var = RoutingFees_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_RoutingFees_hash"))) TS_RoutingFees_hash(uint32_t o) {
	LDKRoutingFees o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = RoutingFees_hash(&o_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_RoutingFees_write"))) TS_RoutingFees_write(uint32_t obj) {
	LDKRoutingFees obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = RoutingFees_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RoutingFees_read"))) TS_RoutingFees_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_RoutingFeesDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RoutingFeesDecodeErrorZ), "LDKCResult_RoutingFeesDecodeErrorZ");
	*ret_conv = RoutingFees_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_NodeAnnouncementInfo_free"))) TS_NodeAnnouncementInfo_free(uint32_t this_obj) {
	LDKNodeAnnouncementInfo this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	NodeAnnouncementInfo_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncementInfo_get_features"))) TS_NodeAnnouncementInfo_get_features(uint32_t this_ptr) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeFeatures ret_var = NodeAnnouncementInfo_get_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_NodeAnnouncementInfo_set_features"))) TS_NodeAnnouncementInfo_set_features(uint32_t this_ptr, uint32_t val) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = NodeFeatures_clone(&val_conv);
	NodeAnnouncementInfo_set_features(&this_ptr_conv, val_conv);
}

int32_t  __attribute__((export_name("TS_NodeAnnouncementInfo_get_last_update"))) TS_NodeAnnouncementInfo_get_last_update(uint32_t this_ptr) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = NodeAnnouncementInfo_get_last_update(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_NodeAnnouncementInfo_set_last_update"))) TS_NodeAnnouncementInfo_set_last_update(uint32_t this_ptr, int32_t val) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	NodeAnnouncementInfo_set_last_update(&this_ptr_conv, val);
}

int8_tArray  __attribute__((export_name("TS_NodeAnnouncementInfo_get_rgb"))) TS_NodeAnnouncementInfo_get_rgb(uint32_t this_ptr) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(3, __LINE__);
	memcpy(ret_arr->elems, *NodeAnnouncementInfo_get_rgb(&this_ptr_conv), 3);
	return ret_arr;
}

void  __attribute__((export_name("TS_NodeAnnouncementInfo_set_rgb"))) TS_NodeAnnouncementInfo_set_rgb(uint32_t this_ptr, int8_tArray val) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThreeBytes val_ref;
	CHECK(val->arr_len == 3);
	memcpy(val_ref.data, val->elems, 3); FREE(val);
	NodeAnnouncementInfo_set_rgb(&this_ptr_conv, val_ref);
}

int8_tArray  __attribute__((export_name("TS_NodeAnnouncementInfo_get_alias"))) TS_NodeAnnouncementInfo_get_alias(uint32_t this_ptr) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *NodeAnnouncementInfo_get_alias(&this_ptr_conv), 32);
	return ret_arr;
}

void  __attribute__((export_name("TS_NodeAnnouncementInfo_set_alias"))) TS_NodeAnnouncementInfo_set_alias(uint32_t this_ptr, int8_tArray val) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKThirtyTwoBytes val_ref;
	CHECK(val->arr_len == 32);
	memcpy(val_ref.data, val->elems, 32); FREE(val);
	NodeAnnouncementInfo_set_alias(&this_ptr_conv, val_ref);
}

void  __attribute__((export_name("TS_NodeAnnouncementInfo_set_addresses"))) TS_NodeAnnouncementInfo_set_addresses(uint32_t this_ptr, uint32_tArray val) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_NetAddressZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKNetAddress), "LDKCVec_NetAddressZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t m = 0; m < val_constr.datalen; m++) {
		uint32_t val_conv_12 = val_vals[m];
		void* val_conv_12_ptr = (void*)(((uintptr_t)val_conv_12) & ~1);
		CHECK_ACCESS(val_conv_12_ptr);
		LDKNetAddress val_conv_12_conv = *(LDKNetAddress*)(val_conv_12_ptr);
		val_conv_12_conv = NetAddress_clone((LDKNetAddress*)(((uintptr_t)val_conv_12) & ~1));
		val_constr.data[m] = val_conv_12_conv;
	}
	NodeAnnouncementInfo_set_addresses(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncementInfo_get_announcement_message"))) TS_NodeAnnouncementInfo_get_announcement_message(uint32_t this_ptr) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeAnnouncement ret_var = NodeAnnouncementInfo_get_announcement_message(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_NodeAnnouncementInfo_set_announcement_message"))) TS_NodeAnnouncementInfo_set_announcement_message(uint32_t this_ptr, uint32_t val) {
	LDKNodeAnnouncementInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeAnnouncement val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = NodeAnnouncement_clone(&val_conv);
	NodeAnnouncementInfo_set_announcement_message(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncementInfo_new"))) TS_NodeAnnouncementInfo_new(uint32_t features_arg, int32_t last_update_arg, int8_tArray rgb_arg, int8_tArray alias_arg, uint32_tArray addresses_arg, uint32_t announcement_message_arg) {
	LDKNodeFeatures features_arg_conv;
	features_arg_conv.inner = (void*)(features_arg & (~1));
	features_arg_conv.is_owned = (features_arg & 1) || (features_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(features_arg_conv);
	features_arg_conv = NodeFeatures_clone(&features_arg_conv);
	LDKThreeBytes rgb_arg_ref;
	CHECK(rgb_arg->arr_len == 3);
	memcpy(rgb_arg_ref.data, rgb_arg->elems, 3); FREE(rgb_arg);
	LDKThirtyTwoBytes alias_arg_ref;
	CHECK(alias_arg->arr_len == 32);
	memcpy(alias_arg_ref.data, alias_arg->elems, 32); FREE(alias_arg);
	LDKCVec_NetAddressZ addresses_arg_constr;
	addresses_arg_constr.datalen = addresses_arg->arr_len;
	if (addresses_arg_constr.datalen > 0)
		addresses_arg_constr.data = MALLOC(addresses_arg_constr.datalen * sizeof(LDKNetAddress), "LDKCVec_NetAddressZ Elements");
	else
		addresses_arg_constr.data = NULL;
	uint32_t* addresses_arg_vals = addresses_arg->elems /* XXX addresses_arg leaks */;
	for (size_t m = 0; m < addresses_arg_constr.datalen; m++) {
		uint32_t addresses_arg_conv_12 = addresses_arg_vals[m];
		void* addresses_arg_conv_12_ptr = (void*)(((uintptr_t)addresses_arg_conv_12) & ~1);
		CHECK_ACCESS(addresses_arg_conv_12_ptr);
		LDKNetAddress addresses_arg_conv_12_conv = *(LDKNetAddress*)(addresses_arg_conv_12_ptr);
		addresses_arg_constr.data[m] = addresses_arg_conv_12_conv;
	}
	LDKNodeAnnouncement announcement_message_arg_conv;
	announcement_message_arg_conv.inner = (void*)(announcement_message_arg & (~1));
	announcement_message_arg_conv.is_owned = (announcement_message_arg & 1) || (announcement_message_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(announcement_message_arg_conv);
	announcement_message_arg_conv = NodeAnnouncement_clone(&announcement_message_arg_conv);
	LDKNodeAnnouncementInfo ret_var = NodeAnnouncementInfo_new(features_arg_conv, last_update_arg, rgb_arg_ref, alias_arg_ref, addresses_arg_constr, announcement_message_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t NodeAnnouncementInfo_clone_ptr(LDKNodeAnnouncementInfo *NONNULL_PTR arg) {
	LDKNodeAnnouncementInfo ret_var = NodeAnnouncementInfo_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_NodeAnnouncementInfo_clone_ptr"))) TS_NodeAnnouncementInfo_clone_ptr(uint32_t arg) {
	LDKNodeAnnouncementInfo arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = NodeAnnouncementInfo_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncementInfo_clone"))) TS_NodeAnnouncementInfo_clone(uint32_t orig) {
	LDKNodeAnnouncementInfo orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKNodeAnnouncementInfo ret_var = NodeAnnouncementInfo_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_NodeAnnouncementInfo_write"))) TS_NodeAnnouncementInfo_write(uint32_t obj) {
	LDKNodeAnnouncementInfo obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = NodeAnnouncementInfo_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_NodeAnnouncementInfo_read"))) TS_NodeAnnouncementInfo_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_NodeAnnouncementInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeAnnouncementInfoDecodeErrorZ), "LDKCResult_NodeAnnouncementInfoDecodeErrorZ");
	*ret_conv = NodeAnnouncementInfo_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_NodeInfo_free"))) TS_NodeInfo_free(uint32_t this_obj) {
	LDKNodeInfo this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	NodeInfo_free(this_obj_conv);
}

void  __attribute__((export_name("TS_NodeInfo_set_channels"))) TS_NodeInfo_set_channels(uint32_t this_ptr, int64_tArray val) {
	LDKNodeInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_u64Z val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(int64_t), "LDKCVec_u64Z Elements");
	else
		val_constr.data = NULL;
	int64_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t i = 0; i < val_constr.datalen; i++) {
		int64_t val_conv_8 = val_vals[i];
		val_constr.data[i] = val_conv_8;
	}
	NodeInfo_set_channels(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_NodeInfo_get_lowest_inbound_channel_fees"))) TS_NodeInfo_get_lowest_inbound_channel_fees(uint32_t this_ptr) {
	LDKNodeInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKRoutingFees ret_var = NodeInfo_get_lowest_inbound_channel_fees(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_NodeInfo_set_lowest_inbound_channel_fees"))) TS_NodeInfo_set_lowest_inbound_channel_fees(uint32_t this_ptr, uint32_t val) {
	LDKNodeInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKRoutingFees val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = RoutingFees_clone(&val_conv);
	NodeInfo_set_lowest_inbound_channel_fees(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_NodeInfo_get_announcement_info"))) TS_NodeInfo_get_announcement_info(uint32_t this_ptr) {
	LDKNodeInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeAnnouncementInfo ret_var = NodeInfo_get_announcement_info(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_NodeInfo_set_announcement_info"))) TS_NodeInfo_set_announcement_info(uint32_t this_ptr, uint32_t val) {
	LDKNodeInfo this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeAnnouncementInfo val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = NodeAnnouncementInfo_clone(&val_conv);
	NodeInfo_set_announcement_info(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_NodeInfo_new"))) TS_NodeInfo_new(int64_tArray channels_arg, uint32_t lowest_inbound_channel_fees_arg, uint32_t announcement_info_arg) {
	LDKCVec_u64Z channels_arg_constr;
	channels_arg_constr.datalen = channels_arg->arr_len;
	if (channels_arg_constr.datalen > 0)
		channels_arg_constr.data = MALLOC(channels_arg_constr.datalen * sizeof(int64_t), "LDKCVec_u64Z Elements");
	else
		channels_arg_constr.data = NULL;
	int64_t* channels_arg_vals = channels_arg->elems /* XXX channels_arg leaks */;
	for (size_t i = 0; i < channels_arg_constr.datalen; i++) {
		int64_t channels_arg_conv_8 = channels_arg_vals[i];
		channels_arg_constr.data[i] = channels_arg_conv_8;
	}
	LDKRoutingFees lowest_inbound_channel_fees_arg_conv;
	lowest_inbound_channel_fees_arg_conv.inner = (void*)(lowest_inbound_channel_fees_arg & (~1));
	lowest_inbound_channel_fees_arg_conv.is_owned = (lowest_inbound_channel_fees_arg & 1) || (lowest_inbound_channel_fees_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(lowest_inbound_channel_fees_arg_conv);
	lowest_inbound_channel_fees_arg_conv = RoutingFees_clone(&lowest_inbound_channel_fees_arg_conv);
	LDKNodeAnnouncementInfo announcement_info_arg_conv;
	announcement_info_arg_conv.inner = (void*)(announcement_info_arg & (~1));
	announcement_info_arg_conv.is_owned = (announcement_info_arg & 1) || (announcement_info_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(announcement_info_arg_conv);
	announcement_info_arg_conv = NodeAnnouncementInfo_clone(&announcement_info_arg_conv);
	LDKNodeInfo ret_var = NodeInfo_new(channels_arg_constr, lowest_inbound_channel_fees_arg_conv, announcement_info_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t NodeInfo_clone_ptr(LDKNodeInfo *NONNULL_PTR arg) {
	LDKNodeInfo ret_var = NodeInfo_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_NodeInfo_clone_ptr"))) TS_NodeInfo_clone_ptr(uint32_t arg) {
	LDKNodeInfo arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = NodeInfo_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_NodeInfo_clone"))) TS_NodeInfo_clone(uint32_t orig) {
	LDKNodeInfo orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKNodeInfo ret_var = NodeInfo_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_NodeInfo_write"))) TS_NodeInfo_write(uint32_t obj) {
	LDKNodeInfo obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = NodeInfo_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_NodeInfo_read"))) TS_NodeInfo_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_NodeInfoDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NodeInfoDecodeErrorZ), "LDKCResult_NodeInfoDecodeErrorZ");
	*ret_conv = NodeInfo_read(ser_ref);
	return (uint32_t)ret_conv;
}

int8_tArray  __attribute__((export_name("TS_NetworkGraph_write"))) TS_NetworkGraph_write(uint32_t obj) {
	LDKNetworkGraph obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = NetworkGraph_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_read"))) TS_NetworkGraph_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_NetworkGraphDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NetworkGraphDecodeErrorZ), "LDKCResult_NetworkGraphDecodeErrorZ");
	*ret_conv = NetworkGraph_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_new"))) TS_NetworkGraph_new(int8_tArray genesis_hash) {
	LDKThirtyTwoBytes genesis_hash_ref;
	CHECK(genesis_hash->arr_len == 32);
	memcpy(genesis_hash_ref.data, genesis_hash->elems, 32); FREE(genesis_hash);
	LDKNetworkGraph ret_var = NetworkGraph_new(genesis_hash_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_read_only"))) TS_NetworkGraph_read_only(uint32_t this_arg) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKReadOnlyNetworkGraph ret_var = NetworkGraph_read_only(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_update_node_from_announcement"))) TS_NetworkGraph_update_node_from_announcement(uint32_t this_arg, uint32_t msg) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKNodeAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = NetworkGraph_update_node_from_announcement(&this_arg_conv, &msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_update_node_from_unsigned_announcement"))) TS_NetworkGraph_update_node_from_unsigned_announcement(uint32_t this_arg, uint32_t msg) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKUnsignedNodeAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = NetworkGraph_update_node_from_unsigned_announcement(&this_arg_conv, &msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_update_channel_from_announcement"))) TS_NetworkGraph_update_channel_from_announcement(uint32_t this_arg, uint32_t msg, uint32_t chain_access) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	void* chain_access_ptr = (void*)(((uintptr_t)chain_access) & ~1);
	CHECK_ACCESS(chain_access_ptr);
	LDKCOption_AccessZ chain_access_conv = *(LDKCOption_AccessZ*)(chain_access_ptr);
	// WARNING: we may need a move here but no clone is available for LDKCOption_AccessZ
	if (chain_access_conv.tag == LDKCOption_AccessZ_Some) {
		// Manually implement clone for Java trait instances
		if (chain_access_conv.some.free == LDKAccess_JCalls_free) {
			// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
			LDKAccess_JCalls_cloned(&chain_access_conv.some);
		}
	}
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = NetworkGraph_update_channel_from_announcement(&this_arg_conv, &msg_conv, chain_access_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_update_channel_from_unsigned_announcement"))) TS_NetworkGraph_update_channel_from_unsigned_announcement(uint32_t this_arg, uint32_t msg, uint32_t chain_access) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKUnsignedChannelAnnouncement msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	void* chain_access_ptr = (void*)(((uintptr_t)chain_access) & ~1);
	CHECK_ACCESS(chain_access_ptr);
	LDKCOption_AccessZ chain_access_conv = *(LDKCOption_AccessZ*)(chain_access_ptr);
	// WARNING: we may need a move here but no clone is available for LDKCOption_AccessZ
	if (chain_access_conv.tag == LDKCOption_AccessZ_Some) {
		// Manually implement clone for Java trait instances
		if (chain_access_conv.some.free == LDKAccess_JCalls_free) {
			// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
			LDKAccess_JCalls_cloned(&chain_access_conv.some);
		}
	}
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = NetworkGraph_update_channel_from_unsigned_announcement(&this_arg_conv, &msg_conv, chain_access_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_NetworkGraph_close_channel_from_update"))) TS_NetworkGraph_close_channel_from_update(uint32_t this_arg, int64_t short_channel_id, jboolean is_permanent) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	NetworkGraph_close_channel_from_update(&this_arg_conv, short_channel_id, is_permanent);
}

void  __attribute__((export_name("TS_NetworkGraph_fail_node"))) TS_NetworkGraph_fail_node(uint32_t this_arg, int8_tArray _node_id, jboolean is_permanent) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPublicKey _node_id_ref;
	CHECK(_node_id->arr_len == 33);
	memcpy(_node_id_ref.compressed_form, _node_id->elems, 33); FREE(_node_id);
	NetworkGraph_fail_node(&this_arg_conv, _node_id_ref, is_permanent);
}

void  __attribute__((export_name("TS_NetworkGraph_remove_stale_channels_with_time"))) TS_NetworkGraph_remove_stale_channels_with_time(uint32_t this_arg, int64_t current_time_unix) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	NetworkGraph_remove_stale_channels_with_time(&this_arg_conv, current_time_unix);
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_update_channel"))) TS_NetworkGraph_update_channel(uint32_t this_arg, uint32_t msg) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKChannelUpdate msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = NetworkGraph_update_channel(&this_arg_conv, &msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_NetworkGraph_update_channel_unsigned"))) TS_NetworkGraph_update_channel_unsigned(uint32_t this_arg, uint32_t msg) {
	LDKNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKUnsignedChannelUpdate msg_conv;
	msg_conv.inner = (void*)(msg & (~1));
	msg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(msg_conv);
	LDKCResult_NoneLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneLightningErrorZ), "LDKCResult_NoneLightningErrorZ");
	*ret_conv = NetworkGraph_update_channel_unsigned(&this_arg_conv, &msg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_ReadOnlyNetworkGraph_get_addresses"))) TS_ReadOnlyNetworkGraph_get_addresses(uint32_t this_arg, int8_tArray pubkey) {
	LDKReadOnlyNetworkGraph this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPublicKey pubkey_ref;
	CHECK(pubkey->arr_len == 33);
	memcpy(pubkey_ref.compressed_form, pubkey->elems, 33); FREE(pubkey);
	LDKCOption_CVec_NetAddressZZ *ret_copy = MALLOC(sizeof(LDKCOption_CVec_NetAddressZZ), "LDKCOption_CVec_NetAddressZZ");
	*ret_copy = ReadOnlyNetworkGraph_get_addresses(&this_arg_conv, pubkey_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_RouteHop_free"))) TS_RouteHop_free(uint32_t this_obj) {
	LDKRouteHop this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RouteHop_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_RouteHop_get_pubkey"))) TS_RouteHop_get_pubkey(uint32_t this_ptr) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, RouteHop_get_pubkey(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_RouteHop_set_pubkey"))) TS_RouteHop_set_pubkey(uint32_t this_ptr, int8_tArray val) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	RouteHop_set_pubkey(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_RouteHop_get_node_features"))) TS_RouteHop_get_node_features(uint32_t this_ptr) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeFeatures ret_var = RouteHop_get_node_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RouteHop_set_node_features"))) TS_RouteHop_set_node_features(uint32_t this_ptr, uint32_t val) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKNodeFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = NodeFeatures_clone(&val_conv);
	RouteHop_set_node_features(&this_ptr_conv, val_conv);
}

int64_t  __attribute__((export_name("TS_RouteHop_get_short_channel_id"))) TS_RouteHop_get_short_channel_id(uint32_t this_ptr) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = RouteHop_get_short_channel_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RouteHop_set_short_channel_id"))) TS_RouteHop_set_short_channel_id(uint32_t this_ptr, int64_t val) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RouteHop_set_short_channel_id(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_RouteHop_get_channel_features"))) TS_RouteHop_get_channel_features(uint32_t this_ptr) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelFeatures ret_var = RouteHop_get_channel_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RouteHop_set_channel_features"))) TS_RouteHop_set_channel_features(uint32_t this_ptr, uint32_t val) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKChannelFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = ChannelFeatures_clone(&val_conv);
	RouteHop_set_channel_features(&this_ptr_conv, val_conv);
}

int64_t  __attribute__((export_name("TS_RouteHop_get_fee_msat"))) TS_RouteHop_get_fee_msat(uint32_t this_ptr) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = RouteHop_get_fee_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RouteHop_set_fee_msat"))) TS_RouteHop_set_fee_msat(uint32_t this_ptr, int64_t val) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RouteHop_set_fee_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_RouteHop_get_cltv_expiry_delta"))) TS_RouteHop_get_cltv_expiry_delta(uint32_t this_ptr) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = RouteHop_get_cltv_expiry_delta(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RouteHop_set_cltv_expiry_delta"))) TS_RouteHop_set_cltv_expiry_delta(uint32_t this_ptr, int32_t val) {
	LDKRouteHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RouteHop_set_cltv_expiry_delta(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_RouteHop_new"))) TS_RouteHop_new(int8_tArray pubkey_arg, uint32_t node_features_arg, int64_t short_channel_id_arg, uint32_t channel_features_arg, int64_t fee_msat_arg, int32_t cltv_expiry_delta_arg) {
	LDKPublicKey pubkey_arg_ref;
	CHECK(pubkey_arg->arr_len == 33);
	memcpy(pubkey_arg_ref.compressed_form, pubkey_arg->elems, 33); FREE(pubkey_arg);
	LDKNodeFeatures node_features_arg_conv;
	node_features_arg_conv.inner = (void*)(node_features_arg & (~1));
	node_features_arg_conv.is_owned = (node_features_arg & 1) || (node_features_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(node_features_arg_conv);
	node_features_arg_conv = NodeFeatures_clone(&node_features_arg_conv);
	LDKChannelFeatures channel_features_arg_conv;
	channel_features_arg_conv.inner = (void*)(channel_features_arg & (~1));
	channel_features_arg_conv.is_owned = (channel_features_arg & 1) || (channel_features_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channel_features_arg_conv);
	channel_features_arg_conv = ChannelFeatures_clone(&channel_features_arg_conv);
	LDKRouteHop ret_var = RouteHop_new(pubkey_arg_ref, node_features_arg_conv, short_channel_id_arg, channel_features_arg_conv, fee_msat_arg, cltv_expiry_delta_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t RouteHop_clone_ptr(LDKRouteHop *NONNULL_PTR arg) {
	LDKRouteHop ret_var = RouteHop_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RouteHop_clone_ptr"))) TS_RouteHop_clone_ptr(uint32_t arg) {
	LDKRouteHop arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RouteHop_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RouteHop_clone"))) TS_RouteHop_clone(uint32_t orig) {
	LDKRouteHop orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRouteHop ret_var = RouteHop_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_RouteHop_hash"))) TS_RouteHop_hash(uint32_t o) {
	LDKRouteHop o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = RouteHop_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_RouteHop_eq"))) TS_RouteHop_eq(uint32_t a, uint32_t b) {
	LDKRouteHop a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKRouteHop b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = RouteHop_eq(&a_conv, &b_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_RouteHop_write"))) TS_RouteHop_write(uint32_t obj) {
	LDKRouteHop obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = RouteHop_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RouteHop_read"))) TS_RouteHop_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_RouteHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHopDecodeErrorZ), "LDKCResult_RouteHopDecodeErrorZ");
	*ret_conv = RouteHop_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_Route_free"))) TS_Route_free(uint32_t this_obj) {
	LDKRoute this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Route_free(this_obj_conv);
}

ptrArray  __attribute__((export_name("TS_Route_get_paths"))) TS_Route_get_paths(uint32_t this_ptr) {
	LDKRoute this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_CVec_RouteHopZZ ret_var = Route_get_paths(&this_ptr_conv);
	ptrArray ret_arr = NULL;
	ret_arr = init_ptrArray(ret_var.datalen, __LINE__);
	uint32_tArray *ret_arr_ptr = (uint32_tArray*)(((uint8_t*)ret_arr) + 4);
	for (size_t m = 0; m < ret_var.datalen; m++) {
		LDKCVec_RouteHopZ ret_conv_12_var = ret_var.data[m];
		uint32_tArray ret_conv_12_arr = NULL;
		ret_conv_12_arr = init_uint32_tArray(ret_conv_12_var.datalen, __LINE__);
		uint32_t *ret_conv_12_arr_ptr = (uint32_t*)(((uint8_t*)ret_conv_12_arr) + 4);
		for (size_t k = 0; k < ret_conv_12_var.datalen; k++) {
			LDKRouteHop ret_conv_12_conv_10_var = ret_conv_12_var.data[k];
			uint32_t ret_conv_12_conv_10_ref = 0;
			CHECK((((uintptr_t)ret_conv_12_conv_10_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
			CHECK((((uintptr_t)&ret_conv_12_conv_10_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
			CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_12_conv_10_var);
			ret_conv_12_conv_10_ref = (uintptr_t)ret_conv_12_conv_10_var.inner;
			if (ret_conv_12_conv_10_var.is_owned) {
				ret_conv_12_conv_10_ref |= 1;
			}
			ret_conv_12_arr_ptr[k] = ret_conv_12_conv_10_ref;
		}
		
		FREE(ret_conv_12_var.data);
		ret_arr_ptr[m] = ret_conv_12_arr;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_Route_set_paths"))) TS_Route_set_paths(uint32_t this_ptr, ptrArray val) {
	LDKRoute this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_CVec_RouteHopZZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKCVec_RouteHopZ), "LDKCVec_CVec_RouteHopZZ Elements");
	else
		val_constr.data = NULL;
	uint32_tArray* val_vals = (void*) val->elems /* XXX val leaks */;
	for (size_t m = 0; m < val_constr.datalen; m++) {
		uint32_tArray val_conv_12 = val_vals[m];
		LDKCVec_RouteHopZ val_conv_12_constr;
		val_conv_12_constr.datalen = val_conv_12->arr_len;
		if (val_conv_12_constr.datalen > 0)
			val_conv_12_constr.data = MALLOC(val_conv_12_constr.datalen * sizeof(LDKRouteHop), "LDKCVec_RouteHopZ Elements");
		else
			val_conv_12_constr.data = NULL;
		uint32_t* val_conv_12_vals = val_conv_12->elems /* XXX val_conv_12 leaks */;
		for (size_t k = 0; k < val_conv_12_constr.datalen; k++) {
			uint32_t val_conv_12_conv_10 = val_conv_12_vals[k];
			LDKRouteHop val_conv_12_conv_10_conv;
			val_conv_12_conv_10_conv.inner = (void*)(val_conv_12_conv_10 & (~1));
			val_conv_12_conv_10_conv.is_owned = (val_conv_12_conv_10 & 1) || (val_conv_12_conv_10 == 0);
			CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv_12_conv_10_conv);
			val_conv_12_conv_10_conv = RouteHop_clone(&val_conv_12_conv_10_conv);
			val_conv_12_constr.data[k] = val_conv_12_conv_10_conv;
		}
		val_constr.data[m] = val_conv_12_constr;
	}
	Route_set_paths(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_Route_get_payment_params"))) TS_Route_get_payment_params(uint32_t this_ptr) {
	LDKRoute this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPaymentParameters ret_var = Route_get_payment_params(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_Route_set_payment_params"))) TS_Route_set_payment_params(uint32_t this_ptr, uint32_t val) {
	LDKRoute this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPaymentParameters val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = PaymentParameters_clone(&val_conv);
	Route_set_payment_params(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_Route_new"))) TS_Route_new(ptrArray paths_arg, uint32_t payment_params_arg) {
	LDKCVec_CVec_RouteHopZZ paths_arg_constr;
	paths_arg_constr.datalen = paths_arg->arr_len;
	if (paths_arg_constr.datalen > 0)
		paths_arg_constr.data = MALLOC(paths_arg_constr.datalen * sizeof(LDKCVec_RouteHopZ), "LDKCVec_CVec_RouteHopZZ Elements");
	else
		paths_arg_constr.data = NULL;
	uint32_tArray* paths_arg_vals = (void*) paths_arg->elems /* XXX paths_arg leaks */;
	for (size_t m = 0; m < paths_arg_constr.datalen; m++) {
		uint32_tArray paths_arg_conv_12 = paths_arg_vals[m];
		LDKCVec_RouteHopZ paths_arg_conv_12_constr;
		paths_arg_conv_12_constr.datalen = paths_arg_conv_12->arr_len;
		if (paths_arg_conv_12_constr.datalen > 0)
			paths_arg_conv_12_constr.data = MALLOC(paths_arg_conv_12_constr.datalen * sizeof(LDKRouteHop), "LDKCVec_RouteHopZ Elements");
		else
			paths_arg_conv_12_constr.data = NULL;
		uint32_t* paths_arg_conv_12_vals = paths_arg_conv_12->elems /* XXX paths_arg_conv_12 leaks */;
		for (size_t k = 0; k < paths_arg_conv_12_constr.datalen; k++) {
			uint32_t paths_arg_conv_12_conv_10 = paths_arg_conv_12_vals[k];
			LDKRouteHop paths_arg_conv_12_conv_10_conv;
			paths_arg_conv_12_conv_10_conv.inner = (void*)(paths_arg_conv_12_conv_10 & (~1));
			paths_arg_conv_12_conv_10_conv.is_owned = (paths_arg_conv_12_conv_10 & 1) || (paths_arg_conv_12_conv_10 == 0);
			CHECK_INNER_FIELD_ACCESS_OR_NULL(paths_arg_conv_12_conv_10_conv);
			paths_arg_conv_12_conv_10_conv = RouteHop_clone(&paths_arg_conv_12_conv_10_conv);
			paths_arg_conv_12_constr.data[k] = paths_arg_conv_12_conv_10_conv;
		}
		paths_arg_constr.data[m] = paths_arg_conv_12_constr;
	}
	LDKPaymentParameters payment_params_arg_conv;
	payment_params_arg_conv.inner = (void*)(payment_params_arg & (~1));
	payment_params_arg_conv.is_owned = (payment_params_arg & 1) || (payment_params_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(payment_params_arg_conv);
	payment_params_arg_conv = PaymentParameters_clone(&payment_params_arg_conv);
	LDKRoute ret_var = Route_new(paths_arg_constr, payment_params_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t Route_clone_ptr(LDKRoute *NONNULL_PTR arg) {
	LDKRoute ret_var = Route_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Route_clone_ptr"))) TS_Route_clone_ptr(uint32_t arg) {
	LDKRoute arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Route_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Route_clone"))) TS_Route_clone(uint32_t orig) {
	LDKRoute orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRoute ret_var = Route_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_Route_hash"))) TS_Route_hash(uint32_t o) {
	LDKRoute o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = Route_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_Route_eq"))) TS_Route_eq(uint32_t a, uint32_t b) {
	LDKRoute a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKRoute b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = Route_eq(&a_conv, &b_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_Route_get_total_fees"))) TS_Route_get_total_fees(uint32_t this_arg) {
	LDKRoute this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = Route_get_total_fees(&this_arg_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_Route_get_total_amount"))) TS_Route_get_total_amount(uint32_t this_arg) {
	LDKRoute this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = Route_get_total_amount(&this_arg_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_Route_write"))) TS_Route_write(uint32_t obj) {
	LDKRoute obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = Route_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Route_read"))) TS_Route_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_RouteDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteDecodeErrorZ), "LDKCResult_RouteDecodeErrorZ");
	*ret_conv = Route_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_RouteParameters_free"))) TS_RouteParameters_free(uint32_t this_obj) {
	LDKRouteParameters this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RouteParameters_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_RouteParameters_get_payment_params"))) TS_RouteParameters_get_payment_params(uint32_t this_ptr) {
	LDKRouteParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPaymentParameters ret_var = RouteParameters_get_payment_params(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RouteParameters_set_payment_params"))) TS_RouteParameters_set_payment_params(uint32_t this_ptr, uint32_t val) {
	LDKRouteParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPaymentParameters val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = PaymentParameters_clone(&val_conv);
	RouteParameters_set_payment_params(&this_ptr_conv, val_conv);
}

int64_t  __attribute__((export_name("TS_RouteParameters_get_final_value_msat"))) TS_RouteParameters_get_final_value_msat(uint32_t this_ptr) {
	LDKRouteParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = RouteParameters_get_final_value_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RouteParameters_set_final_value_msat"))) TS_RouteParameters_set_final_value_msat(uint32_t this_ptr, int64_t val) {
	LDKRouteParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RouteParameters_set_final_value_msat(&this_ptr_conv, val);
}

int32_t  __attribute__((export_name("TS_RouteParameters_get_final_cltv_expiry_delta"))) TS_RouteParameters_get_final_cltv_expiry_delta(uint32_t this_ptr) {
	LDKRouteParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = RouteParameters_get_final_cltv_expiry_delta(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RouteParameters_set_final_cltv_expiry_delta"))) TS_RouteParameters_set_final_cltv_expiry_delta(uint32_t this_ptr, int32_t val) {
	LDKRouteParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RouteParameters_set_final_cltv_expiry_delta(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_RouteParameters_new"))) TS_RouteParameters_new(uint32_t payment_params_arg, int64_t final_value_msat_arg, int32_t final_cltv_expiry_delta_arg) {
	LDKPaymentParameters payment_params_arg_conv;
	payment_params_arg_conv.inner = (void*)(payment_params_arg & (~1));
	payment_params_arg_conv.is_owned = (payment_params_arg & 1) || (payment_params_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(payment_params_arg_conv);
	payment_params_arg_conv = PaymentParameters_clone(&payment_params_arg_conv);
	LDKRouteParameters ret_var = RouteParameters_new(payment_params_arg_conv, final_value_msat_arg, final_cltv_expiry_delta_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t RouteParameters_clone_ptr(LDKRouteParameters *NONNULL_PTR arg) {
	LDKRouteParameters ret_var = RouteParameters_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RouteParameters_clone_ptr"))) TS_RouteParameters_clone_ptr(uint32_t arg) {
	LDKRouteParameters arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RouteParameters_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RouteParameters_clone"))) TS_RouteParameters_clone(uint32_t orig) {
	LDKRouteParameters orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRouteParameters ret_var = RouteParameters_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_RouteParameters_write"))) TS_RouteParameters_write(uint32_t obj) {
	LDKRouteParameters obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = RouteParameters_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RouteParameters_read"))) TS_RouteParameters_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_RouteParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteParametersDecodeErrorZ), "LDKCResult_RouteParametersDecodeErrorZ");
	*ret_conv = RouteParameters_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_PaymentParameters_free"))) TS_PaymentParameters_free(uint32_t this_obj) {
	LDKPaymentParameters this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	PaymentParameters_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_PaymentParameters_get_payee_pubkey"))) TS_PaymentParameters_get_payee_pubkey(uint32_t this_ptr) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, PaymentParameters_get_payee_pubkey(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_PaymentParameters_set_payee_pubkey"))) TS_PaymentParameters_set_payee_pubkey(uint32_t this_ptr, int8_tArray val) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	PaymentParameters_set_payee_pubkey(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_PaymentParameters_get_features"))) TS_PaymentParameters_get_features(uint32_t this_ptr) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKInvoiceFeatures ret_var = PaymentParameters_get_features(&this_ptr_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_PaymentParameters_set_features"))) TS_PaymentParameters_set_features(uint32_t this_ptr, uint32_t val) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKInvoiceFeatures val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = InvoiceFeatures_clone(&val_conv);
	PaymentParameters_set_features(&this_ptr_conv, val_conv);
}

uint32_tArray  __attribute__((export_name("TS_PaymentParameters_get_route_hints"))) TS_PaymentParameters_get_route_hints(uint32_t this_ptr) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_RouteHintZ ret_var = PaymentParameters_get_route_hints(&this_ptr_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t l = 0; l < ret_var.datalen; l++) {
		LDKRouteHint ret_conv_11_var = ret_var.data[l];
		uint32_t ret_conv_11_ref = 0;
		CHECK((((uintptr_t)ret_conv_11_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_11_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_11_var);
		ret_conv_11_ref = (uintptr_t)ret_conv_11_var.inner;
		if (ret_conv_11_var.is_owned) {
			ret_conv_11_ref |= 1;
		}
		ret_arr_ptr[l] = ret_conv_11_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_PaymentParameters_set_route_hints"))) TS_PaymentParameters_set_route_hints(uint32_t this_ptr, uint32_tArray val) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_RouteHintZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKRouteHint), "LDKCVec_RouteHintZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t l = 0; l < val_constr.datalen; l++) {
		uint32_t val_conv_11 = val_vals[l];
		LDKRouteHint val_conv_11_conv;
		val_conv_11_conv.inner = (void*)(val_conv_11 & (~1));
		val_conv_11_conv.is_owned = (val_conv_11 & 1) || (val_conv_11 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv_11_conv);
		val_conv_11_conv = RouteHint_clone(&val_conv_11_conv);
		val_constr.data[l] = val_conv_11_conv;
	}
	PaymentParameters_set_route_hints(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_PaymentParameters_get_expiry_time"))) TS_PaymentParameters_get_expiry_time(uint32_t this_ptr) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = PaymentParameters_get_expiry_time(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_PaymentParameters_set_expiry_time"))) TS_PaymentParameters_set_expiry_time(uint32_t this_ptr, uint32_t val) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	PaymentParameters_set_expiry_time(&this_ptr_conv, val_conv);
}

int32_t  __attribute__((export_name("TS_PaymentParameters_get_max_total_cltv_expiry_delta"))) TS_PaymentParameters_get_max_total_cltv_expiry_delta(uint32_t this_ptr) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int32_t ret_val = PaymentParameters_get_max_total_cltv_expiry_delta(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_PaymentParameters_set_max_total_cltv_expiry_delta"))) TS_PaymentParameters_set_max_total_cltv_expiry_delta(uint32_t this_ptr, int32_t val) {
	LDKPaymentParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	PaymentParameters_set_max_total_cltv_expiry_delta(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_PaymentParameters_new"))) TS_PaymentParameters_new(int8_tArray payee_pubkey_arg, uint32_t features_arg, uint32_tArray route_hints_arg, uint32_t expiry_time_arg, int32_t max_total_cltv_expiry_delta_arg) {
	LDKPublicKey payee_pubkey_arg_ref;
	CHECK(payee_pubkey_arg->arr_len == 33);
	memcpy(payee_pubkey_arg_ref.compressed_form, payee_pubkey_arg->elems, 33); FREE(payee_pubkey_arg);
	LDKInvoiceFeatures features_arg_conv;
	features_arg_conv.inner = (void*)(features_arg & (~1));
	features_arg_conv.is_owned = (features_arg & 1) || (features_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(features_arg_conv);
	features_arg_conv = InvoiceFeatures_clone(&features_arg_conv);
	LDKCVec_RouteHintZ route_hints_arg_constr;
	route_hints_arg_constr.datalen = route_hints_arg->arr_len;
	if (route_hints_arg_constr.datalen > 0)
		route_hints_arg_constr.data = MALLOC(route_hints_arg_constr.datalen * sizeof(LDKRouteHint), "LDKCVec_RouteHintZ Elements");
	else
		route_hints_arg_constr.data = NULL;
	uint32_t* route_hints_arg_vals = route_hints_arg->elems /* XXX route_hints_arg leaks */;
	for (size_t l = 0; l < route_hints_arg_constr.datalen; l++) {
		uint32_t route_hints_arg_conv_11 = route_hints_arg_vals[l];
		LDKRouteHint route_hints_arg_conv_11_conv;
		route_hints_arg_conv_11_conv.inner = (void*)(route_hints_arg_conv_11 & (~1));
		route_hints_arg_conv_11_conv.is_owned = (route_hints_arg_conv_11 & 1) || (route_hints_arg_conv_11 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(route_hints_arg_conv_11_conv);
		route_hints_arg_conv_11_conv = RouteHint_clone(&route_hints_arg_conv_11_conv);
		route_hints_arg_constr.data[l] = route_hints_arg_conv_11_conv;
	}
	void* expiry_time_arg_ptr = (void*)(((uintptr_t)expiry_time_arg) & ~1);
	CHECK_ACCESS(expiry_time_arg_ptr);
	LDKCOption_u64Z expiry_time_arg_conv = *(LDKCOption_u64Z*)(expiry_time_arg_ptr);
	expiry_time_arg_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)expiry_time_arg) & ~1));
	LDKPaymentParameters ret_var = PaymentParameters_new(payee_pubkey_arg_ref, features_arg_conv, route_hints_arg_constr, expiry_time_arg_conv, max_total_cltv_expiry_delta_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t PaymentParameters_clone_ptr(LDKPaymentParameters *NONNULL_PTR arg) {
	LDKPaymentParameters ret_var = PaymentParameters_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PaymentParameters_clone_ptr"))) TS_PaymentParameters_clone_ptr(uint32_t arg) {
	LDKPaymentParameters arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = PaymentParameters_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PaymentParameters_clone"))) TS_PaymentParameters_clone(uint32_t orig) {
	LDKPaymentParameters orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKPaymentParameters ret_var = PaymentParameters_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_PaymentParameters_hash"))) TS_PaymentParameters_hash(uint32_t o) {
	LDKPaymentParameters o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = PaymentParameters_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_PaymentParameters_eq"))) TS_PaymentParameters_eq(uint32_t a, uint32_t b) {
	LDKPaymentParameters a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKPaymentParameters b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = PaymentParameters_eq(&a_conv, &b_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_PaymentParameters_write"))) TS_PaymentParameters_write(uint32_t obj) {
	LDKPaymentParameters obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = PaymentParameters_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_PaymentParameters_read"))) TS_PaymentParameters_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_PaymentParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentParametersDecodeErrorZ), "LDKCResult_PaymentParametersDecodeErrorZ");
	*ret_conv = PaymentParameters_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_PaymentParameters_from_node_id"))) TS_PaymentParameters_from_node_id(int8_tArray payee_pubkey) {
	LDKPublicKey payee_pubkey_ref;
	CHECK(payee_pubkey->arr_len == 33);
	memcpy(payee_pubkey_ref.compressed_form, payee_pubkey->elems, 33); FREE(payee_pubkey);
	LDKPaymentParameters ret_var = PaymentParameters_from_node_id(payee_pubkey_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentParameters_for_keysend"))) TS_PaymentParameters_for_keysend(int8_tArray payee_pubkey) {
	LDKPublicKey payee_pubkey_ref;
	CHECK(payee_pubkey->arr_len == 33);
	memcpy(payee_pubkey_ref.compressed_form, payee_pubkey->elems, 33); FREE(payee_pubkey);
	LDKPaymentParameters ret_var = PaymentParameters_for_keysend(payee_pubkey_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RouteHint_free"))) TS_RouteHint_free(uint32_t this_obj) {
	LDKRouteHint this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RouteHint_free(this_obj_conv);
}

uint32_tArray  __attribute__((export_name("TS_RouteHint_get_a"))) TS_RouteHint_get_a(uint32_t this_ptr) {
	LDKRouteHint this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_RouteHintHopZ ret_var = RouteHint_get_a(&this_ptr_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t o = 0; o < ret_var.datalen; o++) {
		LDKRouteHintHop ret_conv_14_var = ret_var.data[o];
		uint32_t ret_conv_14_ref = 0;
		CHECK((((uintptr_t)ret_conv_14_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_14_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_14_var);
		ret_conv_14_ref = (uintptr_t)ret_conv_14_var.inner;
		if (ret_conv_14_var.is_owned) {
			ret_conv_14_ref |= 1;
		}
		ret_arr_ptr[o] = ret_conv_14_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

void  __attribute__((export_name("TS_RouteHint_set_a"))) TS_RouteHint_set_a(uint32_t this_ptr, uint32_tArray val) {
	LDKRouteHint this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCVec_RouteHintHopZ val_constr;
	val_constr.datalen = val->arr_len;
	if (val_constr.datalen > 0)
		val_constr.data = MALLOC(val_constr.datalen * sizeof(LDKRouteHintHop), "LDKCVec_RouteHintHopZ Elements");
	else
		val_constr.data = NULL;
	uint32_t* val_vals = val->elems /* XXX val leaks */;
	for (size_t o = 0; o < val_constr.datalen; o++) {
		uint32_t val_conv_14 = val_vals[o];
		LDKRouteHintHop val_conv_14_conv;
		val_conv_14_conv.inner = (void*)(val_conv_14 & (~1));
		val_conv_14_conv.is_owned = (val_conv_14 & 1) || (val_conv_14 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv_14_conv);
		val_conv_14_conv = RouteHintHop_clone(&val_conv_14_conv);
		val_constr.data[o] = val_conv_14_conv;
	}
	RouteHint_set_a(&this_ptr_conv, val_constr);
}

uint32_t  __attribute__((export_name("TS_RouteHint_new"))) TS_RouteHint_new(uint32_tArray a_arg) {
	LDKCVec_RouteHintHopZ a_arg_constr;
	a_arg_constr.datalen = a_arg->arr_len;
	if (a_arg_constr.datalen > 0)
		a_arg_constr.data = MALLOC(a_arg_constr.datalen * sizeof(LDKRouteHintHop), "LDKCVec_RouteHintHopZ Elements");
	else
		a_arg_constr.data = NULL;
	uint32_t* a_arg_vals = a_arg->elems /* XXX a_arg leaks */;
	for (size_t o = 0; o < a_arg_constr.datalen; o++) {
		uint32_t a_arg_conv_14 = a_arg_vals[o];
		LDKRouteHintHop a_arg_conv_14_conv;
		a_arg_conv_14_conv.inner = (void*)(a_arg_conv_14 & (~1));
		a_arg_conv_14_conv.is_owned = (a_arg_conv_14 & 1) || (a_arg_conv_14 == 0);
		CHECK_INNER_FIELD_ACCESS_OR_NULL(a_arg_conv_14_conv);
		a_arg_conv_14_conv = RouteHintHop_clone(&a_arg_conv_14_conv);
		a_arg_constr.data[o] = a_arg_conv_14_conv;
	}
	LDKRouteHint ret_var = RouteHint_new(a_arg_constr);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t RouteHint_clone_ptr(LDKRouteHint *NONNULL_PTR arg) {
	LDKRouteHint ret_var = RouteHint_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RouteHint_clone_ptr"))) TS_RouteHint_clone_ptr(uint32_t arg) {
	LDKRouteHint arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RouteHint_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RouteHint_clone"))) TS_RouteHint_clone(uint32_t orig) {
	LDKRouteHint orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRouteHint ret_var = RouteHint_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_RouteHint_hash"))) TS_RouteHint_hash(uint32_t o) {
	LDKRouteHint o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = RouteHint_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_RouteHint_eq"))) TS_RouteHint_eq(uint32_t a, uint32_t b) {
	LDKRouteHint a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKRouteHint b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = RouteHint_eq(&a_conv, &b_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_RouteHint_write"))) TS_RouteHint_write(uint32_t obj) {
	LDKRouteHint obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = RouteHint_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RouteHint_read"))) TS_RouteHint_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_RouteHintDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintDecodeErrorZ), "LDKCResult_RouteHintDecodeErrorZ");
	*ret_conv = RouteHint_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_RouteHintHop_free"))) TS_RouteHintHop_free(uint32_t this_obj) {
	LDKRouteHintHop this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RouteHintHop_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_RouteHintHop_get_src_node_id"))) TS_RouteHintHop_get_src_node_id(uint32_t this_ptr) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, RouteHintHop_get_src_node_id(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_RouteHintHop_set_src_node_id"))) TS_RouteHintHop_set_src_node_id(uint32_t this_ptr, int8_tArray val) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	RouteHintHop_set_src_node_id(&this_ptr_conv, val_ref);
}

int64_t  __attribute__((export_name("TS_RouteHintHop_get_short_channel_id"))) TS_RouteHintHop_get_short_channel_id(uint32_t this_ptr) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = RouteHintHop_get_short_channel_id(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RouteHintHop_set_short_channel_id"))) TS_RouteHintHop_set_short_channel_id(uint32_t this_ptr, int64_t val) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RouteHintHop_set_short_channel_id(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_RouteHintHop_get_fees"))) TS_RouteHintHop_get_fees(uint32_t this_ptr) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKRoutingFees ret_var = RouteHintHop_get_fees(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RouteHintHop_set_fees"))) TS_RouteHintHop_set_fees(uint32_t this_ptr, uint32_t val) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKRoutingFees val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = RoutingFees_clone(&val_conv);
	RouteHintHop_set_fees(&this_ptr_conv, val_conv);
}

int16_t  __attribute__((export_name("TS_RouteHintHop_get_cltv_expiry_delta"))) TS_RouteHintHop_get_cltv_expiry_delta(uint32_t this_ptr) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = RouteHintHop_get_cltv_expiry_delta(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RouteHintHop_set_cltv_expiry_delta"))) TS_RouteHintHop_set_cltv_expiry_delta(uint32_t this_ptr, int16_t val) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RouteHintHop_set_cltv_expiry_delta(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_RouteHintHop_get_htlc_minimum_msat"))) TS_RouteHintHop_get_htlc_minimum_msat(uint32_t this_ptr) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = RouteHintHop_get_htlc_minimum_msat(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_RouteHintHop_set_htlc_minimum_msat"))) TS_RouteHintHop_set_htlc_minimum_msat(uint32_t this_ptr, uint32_t val) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	RouteHintHop_set_htlc_minimum_msat(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_RouteHintHop_get_htlc_maximum_msat"))) TS_RouteHintHop_get_htlc_maximum_msat(uint32_t this_ptr) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = RouteHintHop_get_htlc_maximum_msat(&this_ptr_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_RouteHintHop_set_htlc_maximum_msat"))) TS_RouteHintHop_set_htlc_maximum_msat(uint32_t this_ptr, uint32_t val) {
	LDKRouteHintHop this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	void* val_ptr = (void*)(((uintptr_t)val) & ~1);
	CHECK_ACCESS(val_ptr);
	LDKCOption_u64Z val_conv = *(LDKCOption_u64Z*)(val_ptr);
	val_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)val) & ~1));
	RouteHintHop_set_htlc_maximum_msat(&this_ptr_conv, val_conv);
}

uint32_t  __attribute__((export_name("TS_RouteHintHop_new"))) TS_RouteHintHop_new(int8_tArray src_node_id_arg, int64_t short_channel_id_arg, uint32_t fees_arg, int16_t cltv_expiry_delta_arg, uint32_t htlc_minimum_msat_arg, uint32_t htlc_maximum_msat_arg) {
	LDKPublicKey src_node_id_arg_ref;
	CHECK(src_node_id_arg->arr_len == 33);
	memcpy(src_node_id_arg_ref.compressed_form, src_node_id_arg->elems, 33); FREE(src_node_id_arg);
	LDKRoutingFees fees_arg_conv;
	fees_arg_conv.inner = (void*)(fees_arg & (~1));
	fees_arg_conv.is_owned = (fees_arg & 1) || (fees_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(fees_arg_conv);
	fees_arg_conv = RoutingFees_clone(&fees_arg_conv);
	void* htlc_minimum_msat_arg_ptr = (void*)(((uintptr_t)htlc_minimum_msat_arg) & ~1);
	CHECK_ACCESS(htlc_minimum_msat_arg_ptr);
	LDKCOption_u64Z htlc_minimum_msat_arg_conv = *(LDKCOption_u64Z*)(htlc_minimum_msat_arg_ptr);
	htlc_minimum_msat_arg_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)htlc_minimum_msat_arg) & ~1));
	void* htlc_maximum_msat_arg_ptr = (void*)(((uintptr_t)htlc_maximum_msat_arg) & ~1);
	CHECK_ACCESS(htlc_maximum_msat_arg_ptr);
	LDKCOption_u64Z htlc_maximum_msat_arg_conv = *(LDKCOption_u64Z*)(htlc_maximum_msat_arg_ptr);
	htlc_maximum_msat_arg_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)htlc_maximum_msat_arg) & ~1));
	LDKRouteHintHop ret_var = RouteHintHop_new(src_node_id_arg_ref, short_channel_id_arg, fees_arg_conv, cltv_expiry_delta_arg, htlc_minimum_msat_arg_conv, htlc_maximum_msat_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t RouteHintHop_clone_ptr(LDKRouteHintHop *NONNULL_PTR arg) {
	LDKRouteHintHop ret_var = RouteHintHop_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RouteHintHop_clone_ptr"))) TS_RouteHintHop_clone_ptr(uint32_t arg) {
	LDKRouteHintHop arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RouteHintHop_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RouteHintHop_clone"))) TS_RouteHintHop_clone(uint32_t orig) {
	LDKRouteHintHop orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRouteHintHop ret_var = RouteHintHop_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_RouteHintHop_hash"))) TS_RouteHintHop_hash(uint32_t o) {
	LDKRouteHintHop o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = RouteHintHop_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_RouteHintHop_eq"))) TS_RouteHintHop_eq(uint32_t a, uint32_t b) {
	LDKRouteHintHop a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKRouteHintHop b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = RouteHintHop_eq(&a_conv, &b_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_RouteHintHop_write"))) TS_RouteHintHop_write(uint32_t obj) {
	LDKRouteHintHop obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = RouteHintHop_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RouteHintHop_read"))) TS_RouteHintHop_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_RouteHintHopDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteHintHopDecodeErrorZ), "LDKCResult_RouteHintHopDecodeErrorZ");
	*ret_conv = RouteHintHop_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_find_route"))) TS_find_route(int8_tArray our_node_pubkey, uint32_t route_params, uint32_t network, uint32_tArray first_hops, uint32_t logger, uint32_t scorer, int8_tArray random_seed_bytes) {
	LDKPublicKey our_node_pubkey_ref;
	CHECK(our_node_pubkey->arr_len == 33);
	memcpy(our_node_pubkey_ref.compressed_form, our_node_pubkey->elems, 33); FREE(our_node_pubkey);
	LDKRouteParameters route_params_conv;
	route_params_conv.inner = (void*)(route_params & (~1));
	route_params_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(route_params_conv);
	LDKNetworkGraph network_conv;
	network_conv.inner = (void*)(network & (~1));
	network_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(network_conv);
	LDKCVec_ChannelDetailsZ first_hops_constr;
	LDKCVec_ChannelDetailsZ *first_hops_ptr = NULL;
	if (first_hops != 0) {
		first_hops_constr.datalen = first_hops->arr_len;
		if (first_hops_constr.datalen > 0)
			first_hops_constr.data = MALLOC(first_hops_constr.datalen * sizeof(LDKChannelDetails), "LDKCVec_ChannelDetailsZ Elements");
		else
			first_hops_constr.data = NULL;
		uint32_t* first_hops_vals = first_hops->elems /* XXX first_hops leaks */;
		for (size_t q = 0; q < first_hops_constr.datalen; q++) {
			uint32_t first_hops_conv_16 = first_hops_vals[q];
			LDKChannelDetails first_hops_conv_16_conv;
			first_hops_conv_16_conv.inner = (void*)(first_hops_conv_16 & (~1));
			first_hops_conv_16_conv.is_owned = (first_hops_conv_16 & 1) || (first_hops_conv_16 == 0);
			CHECK_INNER_FIELD_ACCESS_OR_NULL(first_hops_conv_16_conv);
			first_hops_constr.data[q] = first_hops_conv_16_conv;
		}
		first_hops_ptr = &first_hops_constr;
	}
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	void* scorer_ptr = (void*)(((uintptr_t)scorer) & ~1);
	if (!(scorer & 1)) { CHECK_ACCESS(scorer_ptr); }
	LDKScore* scorer_conv = (LDKScore*)scorer_ptr;
	unsigned char random_seed_bytes_arr[32];
	CHECK(random_seed_bytes->arr_len == 32);
	memcpy(random_seed_bytes_arr, random_seed_bytes->elems, 32); FREE(random_seed_bytes);
	unsigned char (*random_seed_bytes_ref)[32] = &random_seed_bytes_arr;
	LDKCResult_RouteLightningErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_RouteLightningErrorZ), "LDKCResult_RouteLightningErrorZ");
	*ret_conv = find_route(our_node_pubkey_ref, &route_params_conv, &network_conv, first_hops_ptr, logger_conv, scorer_conv, random_seed_bytes_ref);
	if (first_hops_ptr != NULL) { FREE(first_hops_constr.data); }
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_Score_free"))) TS_Score_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKScore this_ptr_conv = *(LDKScore*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Score_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_LockableScore_free"))) TS_LockableScore_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKLockableScore this_ptr_conv = *(LDKLockableScore*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	LockableScore_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_MultiThreadedLockableScore_free"))) TS_MultiThreadedLockableScore_free(uint32_t this_obj) {
	LDKMultiThreadedLockableScore this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	MultiThreadedLockableScore_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_MultiThreadedLockableScore_new"))) TS_MultiThreadedLockableScore_new(uint32_t score) {
	void* score_ptr = (void*)(((uintptr_t)score) & ~1);
	CHECK_ACCESS(score_ptr);
	LDKScore score_conv = *(LDKScore*)(score_ptr);
	if (score_conv.free == LDKScore_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKScore_JCalls_cloned(&score_conv);
	}
	LDKMultiThreadedLockableScore ret_var = MultiThreadedLockableScore_new(score_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_FixedPenaltyScorer_free"))) TS_FixedPenaltyScorer_free(uint32_t this_obj) {
	LDKFixedPenaltyScorer this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	FixedPenaltyScorer_free(this_obj_conv);
}

static inline uintptr_t FixedPenaltyScorer_clone_ptr(LDKFixedPenaltyScorer *NONNULL_PTR arg) {
	LDKFixedPenaltyScorer ret_var = FixedPenaltyScorer_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_FixedPenaltyScorer_clone_ptr"))) TS_FixedPenaltyScorer_clone_ptr(uint32_t arg) {
	LDKFixedPenaltyScorer arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = FixedPenaltyScorer_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_FixedPenaltyScorer_clone"))) TS_FixedPenaltyScorer_clone(uint32_t orig) {
	LDKFixedPenaltyScorer orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKFixedPenaltyScorer ret_var = FixedPenaltyScorer_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_FixedPenaltyScorer_with_penalty"))) TS_FixedPenaltyScorer_with_penalty(int64_t penalty_msat) {
	LDKFixedPenaltyScorer ret_var = FixedPenaltyScorer_with_penalty(penalty_msat);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_FixedPenaltyScorer_as_Score"))) TS_FixedPenaltyScorer_as_Score(uint32_t this_arg) {
	LDKFixedPenaltyScorer this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKScore* ret_ret = MALLOC(sizeof(LDKScore), "LDKScore");
	*ret_ret = FixedPenaltyScorer_as_Score(&this_arg_conv);
	return (uint32_t)ret_ret;
}

int8_tArray  __attribute__((export_name("TS_FixedPenaltyScorer_write"))) TS_FixedPenaltyScorer_write(uint32_t obj) {
	LDKFixedPenaltyScorer obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = FixedPenaltyScorer_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_FixedPenaltyScorer_read"))) TS_FixedPenaltyScorer_read(int8_tArray ser, int64_t arg) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_FixedPenaltyScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_FixedPenaltyScorerDecodeErrorZ), "LDKCResult_FixedPenaltyScorerDecodeErrorZ");
	*ret_conv = FixedPenaltyScorer_read(ser_ref, arg);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_Scorer_free"))) TS_Scorer_free(uint32_t this_obj) {
	LDKScorer this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Scorer_free(this_obj_conv);
}

void  __attribute__((export_name("TS_ScoringParameters_free"))) TS_ScoringParameters_free(uint32_t this_obj) {
	LDKScoringParameters this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ScoringParameters_free(this_obj_conv);
}

int64_t  __attribute__((export_name("TS_ScoringParameters_get_base_penalty_msat"))) TS_ScoringParameters_get_base_penalty_msat(uint32_t this_ptr) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ScoringParameters_get_base_penalty_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ScoringParameters_set_base_penalty_msat"))) TS_ScoringParameters_set_base_penalty_msat(uint32_t this_ptr, int64_t val) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ScoringParameters_set_base_penalty_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ScoringParameters_get_failure_penalty_msat"))) TS_ScoringParameters_get_failure_penalty_msat(uint32_t this_ptr) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ScoringParameters_get_failure_penalty_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ScoringParameters_set_failure_penalty_msat"))) TS_ScoringParameters_set_failure_penalty_msat(uint32_t this_ptr, int64_t val) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ScoringParameters_set_failure_penalty_msat(&this_ptr_conv, val);
}

int16_t  __attribute__((export_name("TS_ScoringParameters_get_overuse_penalty_start_1024th"))) TS_ScoringParameters_get_overuse_penalty_start_1024th(uint32_t this_ptr) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int16_t ret_val = ScoringParameters_get_overuse_penalty_start_1024th(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ScoringParameters_set_overuse_penalty_start_1024th"))) TS_ScoringParameters_set_overuse_penalty_start_1024th(uint32_t this_ptr, int16_t val) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ScoringParameters_set_overuse_penalty_start_1024th(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ScoringParameters_get_overuse_penalty_msat_per_1024th"))) TS_ScoringParameters_get_overuse_penalty_msat_per_1024th(uint32_t this_ptr) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ScoringParameters_get_overuse_penalty_msat_per_1024th(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ScoringParameters_set_overuse_penalty_msat_per_1024th"))) TS_ScoringParameters_set_overuse_penalty_msat_per_1024th(uint32_t this_ptr, int64_t val) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ScoringParameters_set_overuse_penalty_msat_per_1024th(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ScoringParameters_get_failure_penalty_half_life"))) TS_ScoringParameters_get_failure_penalty_half_life(uint32_t this_ptr) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ScoringParameters_get_failure_penalty_half_life(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ScoringParameters_set_failure_penalty_half_life"))) TS_ScoringParameters_set_failure_penalty_half_life(uint32_t this_ptr, int64_t val) {
	LDKScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ScoringParameters_set_failure_penalty_half_life(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ScoringParameters_new"))) TS_ScoringParameters_new(int64_t base_penalty_msat_arg, int64_t failure_penalty_msat_arg, int16_t overuse_penalty_start_1024th_arg, int64_t overuse_penalty_msat_per_1024th_arg, int64_t failure_penalty_half_life_arg) {
	LDKScoringParameters ret_var = ScoringParameters_new(base_penalty_msat_arg, failure_penalty_msat_arg, overuse_penalty_start_1024th_arg, overuse_penalty_msat_per_1024th_arg, failure_penalty_half_life_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ScoringParameters_clone_ptr(LDKScoringParameters *NONNULL_PTR arg) {
	LDKScoringParameters ret_var = ScoringParameters_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ScoringParameters_clone_ptr"))) TS_ScoringParameters_clone_ptr(uint32_t arg) {
	LDKScoringParameters arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ScoringParameters_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ScoringParameters_clone"))) TS_ScoringParameters_clone(uint32_t orig) {
	LDKScoringParameters orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKScoringParameters ret_var = ScoringParameters_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_ScoringParameters_write"))) TS_ScoringParameters_write(uint32_t obj) {
	LDKScoringParameters obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ScoringParameters_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ScoringParameters_read"))) TS_ScoringParameters_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ScoringParametersDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ScoringParametersDecodeErrorZ), "LDKCResult_ScoringParametersDecodeErrorZ");
	*ret_conv = ScoringParameters_read(ser_ref);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_Scorer_new"))) TS_Scorer_new(uint32_t params) {
	LDKScoringParameters params_conv;
	params_conv.inner = (void*)(params & (~1));
	params_conv.is_owned = (params & 1) || (params == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(params_conv);
	params_conv = ScoringParameters_clone(&params_conv);
	LDKScorer ret_var = Scorer_new(params_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Scorer_default"))) TS_Scorer_default() {
	LDKScorer ret_var = Scorer_default();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ScoringParameters_default"))) TS_ScoringParameters_default() {
	LDKScoringParameters ret_var = ScoringParameters_default();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Scorer_as_Score"))) TS_Scorer_as_Score(uint32_t this_arg) {
	LDKScorer this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKScore* ret_ret = MALLOC(sizeof(LDKScore), "LDKScore");
	*ret_ret = Scorer_as_Score(&this_arg_conv);
	return (uint32_t)ret_ret;
}

int8_tArray  __attribute__((export_name("TS_Scorer_write"))) TS_Scorer_write(uint32_t obj) {
	LDKScorer obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = Scorer_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Scorer_read"))) TS_Scorer_read(int8_tArray ser) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKCResult_ScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ScorerDecodeErrorZ), "LDKCResult_ScorerDecodeErrorZ");
	*ret_conv = Scorer_read(ser_ref);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_ProbabilisticScorer_free"))) TS_ProbabilisticScorer_free(uint32_t this_obj) {
	LDKProbabilisticScorer this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ProbabilisticScorer_free(this_obj_conv);
}

void  __attribute__((export_name("TS_ProbabilisticScoringParameters_free"))) TS_ProbabilisticScoringParameters_free(uint32_t this_obj) {
	LDKProbabilisticScoringParameters this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ProbabilisticScoringParameters_free(this_obj_conv);
}

int64_t  __attribute__((export_name("TS_ProbabilisticScoringParameters_get_base_penalty_msat"))) TS_ProbabilisticScoringParameters_get_base_penalty_msat(uint32_t this_ptr) {
	LDKProbabilisticScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ProbabilisticScoringParameters_get_base_penalty_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ProbabilisticScoringParameters_set_base_penalty_msat"))) TS_ProbabilisticScoringParameters_set_base_penalty_msat(uint32_t this_ptr, int64_t val) {
	LDKProbabilisticScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ProbabilisticScoringParameters_set_base_penalty_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ProbabilisticScoringParameters_get_liquidity_penalty_multiplier_msat"))) TS_ProbabilisticScoringParameters_get_liquidity_penalty_multiplier_msat(uint32_t this_ptr) {
	LDKProbabilisticScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ProbabilisticScoringParameters_get_liquidity_penalty_multiplier_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ProbabilisticScoringParameters_set_liquidity_penalty_multiplier_msat"))) TS_ProbabilisticScoringParameters_set_liquidity_penalty_multiplier_msat(uint32_t this_ptr, int64_t val) {
	LDKProbabilisticScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ProbabilisticScoringParameters_set_liquidity_penalty_multiplier_msat(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ProbabilisticScoringParameters_get_liquidity_offset_half_life"))) TS_ProbabilisticScoringParameters_get_liquidity_offset_half_life(uint32_t this_ptr) {
	LDKProbabilisticScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ProbabilisticScoringParameters_get_liquidity_offset_half_life(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ProbabilisticScoringParameters_set_liquidity_offset_half_life"))) TS_ProbabilisticScoringParameters_set_liquidity_offset_half_life(uint32_t this_ptr, int64_t val) {
	LDKProbabilisticScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ProbabilisticScoringParameters_set_liquidity_offset_half_life(&this_ptr_conv, val);
}

int64_t  __attribute__((export_name("TS_ProbabilisticScoringParameters_get_amount_penalty_multiplier_msat"))) TS_ProbabilisticScoringParameters_get_amount_penalty_multiplier_msat(uint32_t this_ptr) {
	LDKProbabilisticScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = ProbabilisticScoringParameters_get_amount_penalty_multiplier_msat(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ProbabilisticScoringParameters_set_amount_penalty_multiplier_msat"))) TS_ProbabilisticScoringParameters_set_amount_penalty_multiplier_msat(uint32_t this_ptr, int64_t val) {
	LDKProbabilisticScoringParameters this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	ProbabilisticScoringParameters_set_amount_penalty_multiplier_msat(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_ProbabilisticScoringParameters_new"))) TS_ProbabilisticScoringParameters_new(int64_t base_penalty_msat_arg, int64_t liquidity_penalty_multiplier_msat_arg, int64_t liquidity_offset_half_life_arg, int64_t amount_penalty_multiplier_msat_arg) {
	LDKProbabilisticScoringParameters ret_var = ProbabilisticScoringParameters_new(base_penalty_msat_arg, liquidity_penalty_multiplier_msat_arg, liquidity_offset_half_life_arg, amount_penalty_multiplier_msat_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t ProbabilisticScoringParameters_clone_ptr(LDKProbabilisticScoringParameters *NONNULL_PTR arg) {
	LDKProbabilisticScoringParameters ret_var = ProbabilisticScoringParameters_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ProbabilisticScoringParameters_clone_ptr"))) TS_ProbabilisticScoringParameters_clone_ptr(uint32_t arg) {
	LDKProbabilisticScoringParameters arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ProbabilisticScoringParameters_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ProbabilisticScoringParameters_clone"))) TS_ProbabilisticScoringParameters_clone(uint32_t orig) {
	LDKProbabilisticScoringParameters orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKProbabilisticScoringParameters ret_var = ProbabilisticScoringParameters_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ProbabilisticScorer_new"))) TS_ProbabilisticScorer_new(uint32_t params, uint32_t network_graph) {
	LDKProbabilisticScoringParameters params_conv;
	params_conv.inner = (void*)(params & (~1));
	params_conv.is_owned = (params & 1) || (params == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(params_conv);
	params_conv = ProbabilisticScoringParameters_clone(&params_conv);
	LDKNetworkGraph network_graph_conv;
	network_graph_conv.inner = (void*)(network_graph & (~1));
	network_graph_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(network_graph_conv);
	LDKProbabilisticScorer ret_var = ProbabilisticScorer_new(params_conv, &network_graph_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ProbabilisticScoringParameters_default"))) TS_ProbabilisticScoringParameters_default() {
	LDKProbabilisticScoringParameters ret_var = ProbabilisticScoringParameters_default();
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ProbabilisticScorer_as_Score"))) TS_ProbabilisticScorer_as_Score(uint32_t this_arg) {
	LDKProbabilisticScorer this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKScore* ret_ret = MALLOC(sizeof(LDKScore), "LDKScore");
	*ret_ret = ProbabilisticScorer_as_Score(&this_arg_conv);
	return (uint32_t)ret_ret;
}

int8_tArray  __attribute__((export_name("TS_ProbabilisticScorer_write"))) TS_ProbabilisticScorer_write(uint32_t obj) {
	LDKProbabilisticScorer obj_conv;
	obj_conv.inner = (void*)(obj & (~1));
	obj_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(obj_conv);
	LDKCVec_u8Z ret_var = ProbabilisticScorer_write(&obj_conv);
	int8_tArray ret_arr = init_int8_tArray(ret_var.datalen, __LINE__);
	memcpy(ret_arr->elems, ret_var.data, ret_var.datalen);
	CVec_u8Z_free(ret_var);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_ProbabilisticScorer_read"))) TS_ProbabilisticScorer_read(int8_tArray ser, uint32_t arg_a, uint32_t arg_b) {
	LDKu8slice ser_ref;
	ser_ref.datalen = ser->arr_len;
	ser_ref.data = ser->elems /* XXX ser leaks */;
	LDKProbabilisticScoringParameters arg_a_conv;
	arg_a_conv.inner = (void*)(arg_a & (~1));
	arg_a_conv.is_owned = (arg_a & 1) || (arg_a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_a_conv);
	arg_a_conv = ProbabilisticScoringParameters_clone(&arg_a_conv);
	LDKNetworkGraph arg_b_conv;
	arg_b_conv.inner = (void*)(arg_b & (~1));
	arg_b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_b_conv);
	LDKCResult_ProbabilisticScorerDecodeErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_ProbabilisticScorerDecodeErrorZ), "LDKCResult_ProbabilisticScorerDecodeErrorZ");
	*ret_conv = ProbabilisticScorer_read(ser_ref, arg_a_conv, &arg_b_conv);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_ParseError_free"))) TS_ParseError_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKParseError this_ptr_conv = *(LDKParseError*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	ParseError_free(this_ptr_conv);
}

static inline uintptr_t ParseError_clone_ptr(LDKParseError *NONNULL_PTR arg) {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ParseError_clone_ptr"))) TS_ParseError_clone_ptr(uint32_t arg) {
	LDKParseError* arg_conv = (LDKParseError*)arg;
	uint32_t ret_val = ParseError_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ParseError_clone"))) TS_ParseError_clone(uint32_t orig) {
	LDKParseError* orig_conv = (LDKParseError*)orig;
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_bech32_error"))) TS_ParseError_bech32_error(uint32_t a) {
	void* a_ptr = (void*)(((uintptr_t)a) & ~1);
	CHECK_ACCESS(a_ptr);
	LDKBech32Error a_conv = *(LDKBech32Error*)(a_ptr);
	a_conv = Bech32Error_clone((LDKBech32Error*)(((uintptr_t)a) & ~1));
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_bech32_error(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_parse_amount_error"))) TS_ParseError_parse_amount_error(int32_t a) {
	
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_parse_amount_error((LDKError){ ._dummy = 0 });
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_malformed_signature"))) TS_ParseError_malformed_signature(uint32_t a) {
	LDKSecp256k1Error a_conv = LDKSecp256k1Error_from_js(a);
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_malformed_signature(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_bad_prefix"))) TS_ParseError_bad_prefix() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_bad_prefix();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_unknown_currency"))) TS_ParseError_unknown_currency() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_unknown_currency();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_unknown_si_prefix"))) TS_ParseError_unknown_si_prefix() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_unknown_si_prefix();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_malformed_hrp"))) TS_ParseError_malformed_hrp() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_malformed_hrp();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_too_short_data_part"))) TS_ParseError_too_short_data_part() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_too_short_data_part();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_unexpected_end_of_tagged_fields"))) TS_ParseError_unexpected_end_of_tagged_fields() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_unexpected_end_of_tagged_fields();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_description_decode_error"))) TS_ParseError_description_decode_error(int32_t a) {
	
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_description_decode_error((LDKError){ ._dummy = 0 });
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_padding_error"))) TS_ParseError_padding_error() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_padding_error();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_integer_overflow_error"))) TS_ParseError_integer_overflow_error() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_integer_overflow_error();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_invalid_seg_wit_program_length"))) TS_ParseError_invalid_seg_wit_program_length() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_invalid_seg_wit_program_length();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_invalid_pub_key_hash_length"))) TS_ParseError_invalid_pub_key_hash_length() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_invalid_pub_key_hash_length();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_invalid_script_hash_length"))) TS_ParseError_invalid_script_hash_length() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_invalid_script_hash_length();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_invalid_recovery_id"))) TS_ParseError_invalid_recovery_id() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_invalid_recovery_id();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_invalid_slice_length"))) TS_ParseError_invalid_slice_length(jstring a) {
	LDKStr a_conv = str_ref_to_owned_c(a);
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_invalid_slice_length(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseError_skip"))) TS_ParseError_skip() {
	LDKParseError *ret_copy = MALLOC(sizeof(LDKParseError), "LDKParseError");
	*ret_copy = ParseError_skip();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_ParseOrSemanticError_free"))) TS_ParseOrSemanticError_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKParseOrSemanticError this_ptr_conv = *(LDKParseOrSemanticError*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	ParseOrSemanticError_free(this_ptr_conv);
}

static inline uintptr_t ParseOrSemanticError_clone_ptr(LDKParseOrSemanticError *NONNULL_PTR arg) {
	LDKParseOrSemanticError *ret_copy = MALLOC(sizeof(LDKParseOrSemanticError), "LDKParseOrSemanticError");
	*ret_copy = ParseOrSemanticError_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ParseOrSemanticError_clone_ptr"))) TS_ParseOrSemanticError_clone_ptr(uint32_t arg) {
	LDKParseOrSemanticError* arg_conv = (LDKParseOrSemanticError*)arg;
	uint32_t ret_val = ParseOrSemanticError_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ParseOrSemanticError_clone"))) TS_ParseOrSemanticError_clone(uint32_t orig) {
	LDKParseOrSemanticError* orig_conv = (LDKParseOrSemanticError*)orig;
	LDKParseOrSemanticError *ret_copy = MALLOC(sizeof(LDKParseOrSemanticError), "LDKParseOrSemanticError");
	*ret_copy = ParseOrSemanticError_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseOrSemanticError_parse_error"))) TS_ParseOrSemanticError_parse_error(uint32_t a) {
	void* a_ptr = (void*)(((uintptr_t)a) & ~1);
	CHECK_ACCESS(a_ptr);
	LDKParseError a_conv = *(LDKParseError*)(a_ptr);
	a_conv = ParseError_clone((LDKParseError*)(((uintptr_t)a) & ~1));
	LDKParseOrSemanticError *ret_copy = MALLOC(sizeof(LDKParseOrSemanticError), "LDKParseOrSemanticError");
	*ret_copy = ParseOrSemanticError_parse_error(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ParseOrSemanticError_semantic_error"))) TS_ParseOrSemanticError_semantic_error(uint32_t a) {
	LDKSemanticError a_conv = LDKSemanticError_from_js(a);
	LDKParseOrSemanticError *ret_copy = MALLOC(sizeof(LDKParseOrSemanticError), "LDKParseOrSemanticError");
	*ret_copy = ParseOrSemanticError_semantic_error(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

void  __attribute__((export_name("TS_Invoice_free"))) TS_Invoice_free(uint32_t this_obj) {
	LDKInvoice this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Invoice_free(this_obj_conv);
}

jboolean  __attribute__((export_name("TS_Invoice_eq"))) TS_Invoice_eq(uint32_t a, uint32_t b) {
	LDKInvoice a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKInvoice b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = Invoice_eq(&a_conv, &b_conv);
	return ret_val;
}

static inline uintptr_t Invoice_clone_ptr(LDKInvoice *NONNULL_PTR arg) {
	LDKInvoice ret_var = Invoice_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Invoice_clone_ptr"))) TS_Invoice_clone_ptr(uint32_t arg) {
	LDKInvoice arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Invoice_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Invoice_clone"))) TS_Invoice_clone(uint32_t orig) {
	LDKInvoice orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKInvoice ret_var = Invoice_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_SignedRawInvoice_free"))) TS_SignedRawInvoice_free(uint32_t this_obj) {
	LDKSignedRawInvoice this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	SignedRawInvoice_free(this_obj_conv);
}

jboolean  __attribute__((export_name("TS_SignedRawInvoice_eq"))) TS_SignedRawInvoice_eq(uint32_t a, uint32_t b) {
	LDKSignedRawInvoice a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKSignedRawInvoice b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = SignedRawInvoice_eq(&a_conv, &b_conv);
	return ret_val;
}

static inline uintptr_t SignedRawInvoice_clone_ptr(LDKSignedRawInvoice *NONNULL_PTR arg) {
	LDKSignedRawInvoice ret_var = SignedRawInvoice_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_SignedRawInvoice_clone_ptr"))) TS_SignedRawInvoice_clone_ptr(uint32_t arg) {
	LDKSignedRawInvoice arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = SignedRawInvoice_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_SignedRawInvoice_clone"))) TS_SignedRawInvoice_clone(uint32_t orig) {
	LDKSignedRawInvoice orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKSignedRawInvoice ret_var = SignedRawInvoice_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RawInvoice_free"))) TS_RawInvoice_free(uint32_t this_obj) {
	LDKRawInvoice this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RawInvoice_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_RawInvoice_get_data"))) TS_RawInvoice_get_data(uint32_t this_ptr) {
	LDKRawInvoice this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKRawDataPart ret_var = RawInvoice_get_data(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RawInvoice_set_data"))) TS_RawInvoice_set_data(uint32_t this_ptr, uint32_t val) {
	LDKRawInvoice this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKRawDataPart val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = RawDataPart_clone(&val_conv);
	RawInvoice_set_data(&this_ptr_conv, val_conv);
}

jboolean  __attribute__((export_name("TS_RawInvoice_eq"))) TS_RawInvoice_eq(uint32_t a, uint32_t b) {
	LDKRawInvoice a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKRawInvoice b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = RawInvoice_eq(&a_conv, &b_conv);
	return ret_val;
}

static inline uintptr_t RawInvoice_clone_ptr(LDKRawInvoice *NONNULL_PTR arg) {
	LDKRawInvoice ret_var = RawInvoice_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RawInvoice_clone_ptr"))) TS_RawInvoice_clone_ptr(uint32_t arg) {
	LDKRawInvoice arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RawInvoice_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_clone"))) TS_RawInvoice_clone(uint32_t orig) {
	LDKRawInvoice orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRawInvoice ret_var = RawInvoice_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RawDataPart_free"))) TS_RawDataPart_free(uint32_t this_obj) {
	LDKRawDataPart this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RawDataPart_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_RawDataPart_get_timestamp"))) TS_RawDataPart_get_timestamp(uint32_t this_ptr) {
	LDKRawDataPart this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPositiveTimestamp ret_var = RawDataPart_get_timestamp(&this_ptr_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_RawDataPart_set_timestamp"))) TS_RawDataPart_set_timestamp(uint32_t this_ptr, uint32_t val) {
	LDKRawDataPart this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPositiveTimestamp val_conv;
	val_conv.inner = (void*)(val & (~1));
	val_conv.is_owned = (val & 1) || (val == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(val_conv);
	val_conv = PositiveTimestamp_clone(&val_conv);
	RawDataPart_set_timestamp(&this_ptr_conv, val_conv);
}

jboolean  __attribute__((export_name("TS_RawDataPart_eq"))) TS_RawDataPart_eq(uint32_t a, uint32_t b) {
	LDKRawDataPart a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKRawDataPart b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = RawDataPart_eq(&a_conv, &b_conv);
	return ret_val;
}

static inline uintptr_t RawDataPart_clone_ptr(LDKRawDataPart *NONNULL_PTR arg) {
	LDKRawDataPart ret_var = RawDataPart_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RawDataPart_clone_ptr"))) TS_RawDataPart_clone_ptr(uint32_t arg) {
	LDKRawDataPart arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RawDataPart_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RawDataPart_clone"))) TS_RawDataPart_clone(uint32_t orig) {
	LDKRawDataPart orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRawDataPart ret_var = RawDataPart_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

void  __attribute__((export_name("TS_PositiveTimestamp_free"))) TS_PositiveTimestamp_free(uint32_t this_obj) {
	LDKPositiveTimestamp this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	PositiveTimestamp_free(this_obj_conv);
}

jboolean  __attribute__((export_name("TS_PositiveTimestamp_eq"))) TS_PositiveTimestamp_eq(uint32_t a, uint32_t b) {
	LDKPositiveTimestamp a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKPositiveTimestamp b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = PositiveTimestamp_eq(&a_conv, &b_conv);
	return ret_val;
}

static inline uintptr_t PositiveTimestamp_clone_ptr(LDKPositiveTimestamp *NONNULL_PTR arg) {
	LDKPositiveTimestamp ret_var = PositiveTimestamp_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PositiveTimestamp_clone_ptr"))) TS_PositiveTimestamp_clone_ptr(uint32_t arg) {
	LDKPositiveTimestamp arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = PositiveTimestamp_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PositiveTimestamp_clone"))) TS_PositiveTimestamp_clone(uint32_t orig) {
	LDKPositiveTimestamp orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKPositiveTimestamp ret_var = PositiveTimestamp_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_SiPrefix_clone"))) TS_SiPrefix_clone(uint32_t orig) {
	LDKSiPrefix* orig_conv = (LDKSiPrefix*)(orig & ~1);
	uint32_t ret_conv = LDKSiPrefix_to_js(SiPrefix_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SiPrefix_milli"))) TS_SiPrefix_milli() {
	uint32_t ret_conv = LDKSiPrefix_to_js(SiPrefix_milli());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SiPrefix_micro"))) TS_SiPrefix_micro() {
	uint32_t ret_conv = LDKSiPrefix_to_js(SiPrefix_micro());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SiPrefix_nano"))) TS_SiPrefix_nano() {
	uint32_t ret_conv = LDKSiPrefix_to_js(SiPrefix_nano());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SiPrefix_pico"))) TS_SiPrefix_pico() {
	uint32_t ret_conv = LDKSiPrefix_to_js(SiPrefix_pico());
	return ret_conv;
}

jboolean  __attribute__((export_name("TS_SiPrefix_eq"))) TS_SiPrefix_eq(uint32_t a, uint32_t b) {
	LDKSiPrefix* a_conv = (LDKSiPrefix*)(a & ~1);
	LDKSiPrefix* b_conv = (LDKSiPrefix*)(b & ~1);
	jboolean ret_val = SiPrefix_eq(a_conv, b_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_SiPrefix_multiplier"))) TS_SiPrefix_multiplier(uint32_t this_arg) {
	LDKSiPrefix* this_arg_conv = (LDKSiPrefix*)(this_arg & ~1);
	int64_t ret_val = SiPrefix_multiplier(this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Currency_clone"))) TS_Currency_clone(uint32_t orig) {
	LDKCurrency* orig_conv = (LDKCurrency*)(orig & ~1);
	uint32_t ret_conv = LDKCurrency_to_js(Currency_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Currency_bitcoin"))) TS_Currency_bitcoin() {
	uint32_t ret_conv = LDKCurrency_to_js(Currency_bitcoin());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Currency_bitcoin_testnet"))) TS_Currency_bitcoin_testnet() {
	uint32_t ret_conv = LDKCurrency_to_js(Currency_bitcoin_testnet());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Currency_regtest"))) TS_Currency_regtest() {
	uint32_t ret_conv = LDKCurrency_to_js(Currency_regtest());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Currency_simnet"))) TS_Currency_simnet() {
	uint32_t ret_conv = LDKCurrency_to_js(Currency_simnet());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Currency_signet"))) TS_Currency_signet() {
	uint32_t ret_conv = LDKCurrency_to_js(Currency_signet());
	return ret_conv;
}

int64_t  __attribute__((export_name("TS_Currency_hash"))) TS_Currency_hash(uint32_t o) {
	LDKCurrency* o_conv = (LDKCurrency*)(o & ~1);
	int64_t ret_val = Currency_hash(o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_Currency_eq"))) TS_Currency_eq(uint32_t a, uint32_t b) {
	LDKCurrency* a_conv = (LDKCurrency*)(a & ~1);
	LDKCurrency* b_conv = (LDKCurrency*)(b & ~1);
	jboolean ret_val = Currency_eq(a_conv, b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Sha256_free"))) TS_Sha256_free(uint32_t this_obj) {
	LDKSha256 this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Sha256_free(this_obj_conv);
}

static inline uintptr_t Sha256_clone_ptr(LDKSha256 *NONNULL_PTR arg) {
	LDKSha256 ret_var = Sha256_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Sha256_clone_ptr"))) TS_Sha256_clone_ptr(uint32_t arg) {
	LDKSha256 arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Sha256_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Sha256_clone"))) TS_Sha256_clone(uint32_t orig) {
	LDKSha256 orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKSha256 ret_var = Sha256_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_Sha256_hash"))) TS_Sha256_hash(uint32_t o) {
	LDKSha256 o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = Sha256_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_Sha256_eq"))) TS_Sha256_eq(uint32_t a, uint32_t b) {
	LDKSha256 a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKSha256 b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = Sha256_eq(&a_conv, &b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Description_free"))) TS_Description_free(uint32_t this_obj) {
	LDKDescription this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	Description_free(this_obj_conv);
}

static inline uintptr_t Description_clone_ptr(LDKDescription *NONNULL_PTR arg) {
	LDKDescription ret_var = Description_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Description_clone_ptr"))) TS_Description_clone_ptr(uint32_t arg) {
	LDKDescription arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = Description_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Description_clone"))) TS_Description_clone(uint32_t orig) {
	LDKDescription orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKDescription ret_var = Description_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_Description_hash"))) TS_Description_hash(uint32_t o) {
	LDKDescription o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = Description_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_Description_eq"))) TS_Description_eq(uint32_t a, uint32_t b) {
	LDKDescription a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKDescription b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = Description_eq(&a_conv, &b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_PayeePubKey_free"))) TS_PayeePubKey_free(uint32_t this_obj) {
	LDKPayeePubKey this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	PayeePubKey_free(this_obj_conv);
}

int8_tArray  __attribute__((export_name("TS_PayeePubKey_get_a"))) TS_PayeePubKey_get_a(uint32_t this_ptr) {
	LDKPayeePubKey this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, PayeePubKey_get_a(&this_ptr_conv).compressed_form, 33);
	return ret_arr;
}

void  __attribute__((export_name("TS_PayeePubKey_set_a"))) TS_PayeePubKey_set_a(uint32_t this_ptr, int8_tArray val) {
	LDKPayeePubKey this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	LDKPublicKey val_ref;
	CHECK(val->arr_len == 33);
	memcpy(val_ref.compressed_form, val->elems, 33); FREE(val);
	PayeePubKey_set_a(&this_ptr_conv, val_ref);
}

uint32_t  __attribute__((export_name("TS_PayeePubKey_new"))) TS_PayeePubKey_new(int8_tArray a_arg) {
	LDKPublicKey a_arg_ref;
	CHECK(a_arg->arr_len == 33);
	memcpy(a_arg_ref.compressed_form, a_arg->elems, 33); FREE(a_arg);
	LDKPayeePubKey ret_var = PayeePubKey_new(a_arg_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t PayeePubKey_clone_ptr(LDKPayeePubKey *NONNULL_PTR arg) {
	LDKPayeePubKey ret_var = PayeePubKey_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PayeePubKey_clone_ptr"))) TS_PayeePubKey_clone_ptr(uint32_t arg) {
	LDKPayeePubKey arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = PayeePubKey_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PayeePubKey_clone"))) TS_PayeePubKey_clone(uint32_t orig) {
	LDKPayeePubKey orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKPayeePubKey ret_var = PayeePubKey_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_PayeePubKey_hash"))) TS_PayeePubKey_hash(uint32_t o) {
	LDKPayeePubKey o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = PayeePubKey_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_PayeePubKey_eq"))) TS_PayeePubKey_eq(uint32_t a, uint32_t b) {
	LDKPayeePubKey a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKPayeePubKey b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = PayeePubKey_eq(&a_conv, &b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_ExpiryTime_free"))) TS_ExpiryTime_free(uint32_t this_obj) {
	LDKExpiryTime this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	ExpiryTime_free(this_obj_conv);
}

static inline uintptr_t ExpiryTime_clone_ptr(LDKExpiryTime *NONNULL_PTR arg) {
	LDKExpiryTime ret_var = ExpiryTime_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_ExpiryTime_clone_ptr"))) TS_ExpiryTime_clone_ptr(uint32_t arg) {
	LDKExpiryTime arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = ExpiryTime_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_ExpiryTime_clone"))) TS_ExpiryTime_clone(uint32_t orig) {
	LDKExpiryTime orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKExpiryTime ret_var = ExpiryTime_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_ExpiryTime_hash"))) TS_ExpiryTime_hash(uint32_t o) {
	LDKExpiryTime o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = ExpiryTime_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_ExpiryTime_eq"))) TS_ExpiryTime_eq(uint32_t a, uint32_t b) {
	LDKExpiryTime a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKExpiryTime b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = ExpiryTime_eq(&a_conv, &b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_MinFinalCltvExpiry_free"))) TS_MinFinalCltvExpiry_free(uint32_t this_obj) {
	LDKMinFinalCltvExpiry this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	MinFinalCltvExpiry_free(this_obj_conv);
}

int64_t  __attribute__((export_name("TS_MinFinalCltvExpiry_get_a"))) TS_MinFinalCltvExpiry_get_a(uint32_t this_ptr) {
	LDKMinFinalCltvExpiry this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	int64_t ret_val = MinFinalCltvExpiry_get_a(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_MinFinalCltvExpiry_set_a"))) TS_MinFinalCltvExpiry_set_a(uint32_t this_ptr, int64_t val) {
	LDKMinFinalCltvExpiry this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	MinFinalCltvExpiry_set_a(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_MinFinalCltvExpiry_new"))) TS_MinFinalCltvExpiry_new(int64_t a_arg) {
	LDKMinFinalCltvExpiry ret_var = MinFinalCltvExpiry_new(a_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t MinFinalCltvExpiry_clone_ptr(LDKMinFinalCltvExpiry *NONNULL_PTR arg) {
	LDKMinFinalCltvExpiry ret_var = MinFinalCltvExpiry_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_MinFinalCltvExpiry_clone_ptr"))) TS_MinFinalCltvExpiry_clone_ptr(uint32_t arg) {
	LDKMinFinalCltvExpiry arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = MinFinalCltvExpiry_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_MinFinalCltvExpiry_clone"))) TS_MinFinalCltvExpiry_clone(uint32_t orig) {
	LDKMinFinalCltvExpiry orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKMinFinalCltvExpiry ret_var = MinFinalCltvExpiry_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_MinFinalCltvExpiry_hash"))) TS_MinFinalCltvExpiry_hash(uint32_t o) {
	LDKMinFinalCltvExpiry o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = MinFinalCltvExpiry_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_MinFinalCltvExpiry_eq"))) TS_MinFinalCltvExpiry_eq(uint32_t a, uint32_t b) {
	LDKMinFinalCltvExpiry a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKMinFinalCltvExpiry b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = MinFinalCltvExpiry_eq(&a_conv, &b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_Fallback_free"))) TS_Fallback_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKFallback this_ptr_conv = *(LDKFallback*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Fallback_free(this_ptr_conv);
}

static inline uintptr_t Fallback_clone_ptr(LDKFallback *NONNULL_PTR arg) {
	LDKFallback *ret_copy = MALLOC(sizeof(LDKFallback), "LDKFallback");
	*ret_copy = Fallback_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_Fallback_clone_ptr"))) TS_Fallback_clone_ptr(uint32_t arg) {
	LDKFallback* arg_conv = (LDKFallback*)arg;
	uint32_t ret_val = Fallback_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Fallback_clone"))) TS_Fallback_clone(uint32_t orig) {
	LDKFallback* orig_conv = (LDKFallback*)orig;
	LDKFallback *ret_copy = MALLOC(sizeof(LDKFallback), "LDKFallback");
	*ret_copy = Fallback_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Fallback_seg_wit_program"))) TS_Fallback_seg_wit_program(int8_t version, int8_tArray program) {
	
	LDKCVec_u8Z program_ref;
	program_ref.datalen = program->arr_len;
	program_ref.data = MALLOC(program_ref.datalen, "LDKCVec_u8Z Bytes");
	memcpy(program_ref.data, program->elems, program_ref.datalen); FREE(program);
	LDKFallback *ret_copy = MALLOC(sizeof(LDKFallback), "LDKFallback");
	*ret_copy = Fallback_seg_wit_program((LDKu5){ ._0 = version }, program_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Fallback_pub_key_hash"))) TS_Fallback_pub_key_hash(int8_tArray a) {
	LDKTwentyBytes a_ref;
	CHECK(a->arr_len == 20);
	memcpy(a_ref.data, a->elems, 20); FREE(a);
	LDKFallback *ret_copy = MALLOC(sizeof(LDKFallback), "LDKFallback");
	*ret_copy = Fallback_pub_key_hash(a_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Fallback_script_hash"))) TS_Fallback_script_hash(int8_tArray a) {
	LDKTwentyBytes a_ref;
	CHECK(a->arr_len == 20);
	memcpy(a_ref.data, a->elems, 20); FREE(a);
	LDKFallback *ret_copy = MALLOC(sizeof(LDKFallback), "LDKFallback");
	*ret_copy = Fallback_script_hash(a_ref);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_Fallback_hash"))) TS_Fallback_hash(uint32_t o) {
	LDKFallback* o_conv = (LDKFallback*)o;
	int64_t ret_val = Fallback_hash(o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_Fallback_eq"))) TS_Fallback_eq(uint32_t a, uint32_t b) {
	LDKFallback* a_conv = (LDKFallback*)a;
	LDKFallback* b_conv = (LDKFallback*)b;
	jboolean ret_val = Fallback_eq(a_conv, b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_InvoiceSignature_free"))) TS_InvoiceSignature_free(uint32_t this_obj) {
	LDKInvoiceSignature this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	InvoiceSignature_free(this_obj_conv);
}

static inline uintptr_t InvoiceSignature_clone_ptr(LDKInvoiceSignature *NONNULL_PTR arg) {
	LDKInvoiceSignature ret_var = InvoiceSignature_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_InvoiceSignature_clone_ptr"))) TS_InvoiceSignature_clone_ptr(uint32_t arg) {
	LDKInvoiceSignature arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = InvoiceSignature_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_InvoiceSignature_clone"))) TS_InvoiceSignature_clone(uint32_t orig) {
	LDKInvoiceSignature orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKInvoiceSignature ret_var = InvoiceSignature_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_InvoiceSignature_eq"))) TS_InvoiceSignature_eq(uint32_t a, uint32_t b) {
	LDKInvoiceSignature a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKInvoiceSignature b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = InvoiceSignature_eq(&a_conv, &b_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_PrivateRoute_free"))) TS_PrivateRoute_free(uint32_t this_obj) {
	LDKPrivateRoute this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	PrivateRoute_free(this_obj_conv);
}

static inline uintptr_t PrivateRoute_clone_ptr(LDKPrivateRoute *NONNULL_PTR arg) {
	LDKPrivateRoute ret_var = PrivateRoute_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PrivateRoute_clone_ptr"))) TS_PrivateRoute_clone_ptr(uint32_t arg) {
	LDKPrivateRoute arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = PrivateRoute_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PrivateRoute_clone"))) TS_PrivateRoute_clone(uint32_t orig) {
	LDKPrivateRoute orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKPrivateRoute ret_var = PrivateRoute_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_PrivateRoute_hash"))) TS_PrivateRoute_hash(uint32_t o) {
	LDKPrivateRoute o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = PrivateRoute_hash(&o_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_PrivateRoute_eq"))) TS_PrivateRoute_eq(uint32_t a, uint32_t b) {
	LDKPrivateRoute a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKPrivateRoute b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = PrivateRoute_eq(&a_conv, &b_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_SignedRawInvoice_into_parts"))) TS_SignedRawInvoice_into_parts(uint32_t this_arg) {
	LDKSignedRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = (this_arg & 1) || (this_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	this_arg_conv = SignedRawInvoice_clone(&this_arg_conv);
	LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ* ret_conv = MALLOC(sizeof(LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ), "LDKC3Tuple_RawInvoice_u832InvoiceSignatureZ");
	*ret_conv = SignedRawInvoice_into_parts(this_arg_conv);
	return ((uint32_t)ret_conv);
}

uint32_t  __attribute__((export_name("TS_SignedRawInvoice_raw_invoice"))) TS_SignedRawInvoice_raw_invoice(uint32_t this_arg) {
	LDKSignedRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKRawInvoice ret_var = SignedRawInvoice_raw_invoice(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_SignedRawInvoice_hash"))) TS_SignedRawInvoice_hash(uint32_t this_arg) {
	LDKSignedRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *SignedRawInvoice_hash(&this_arg_conv), 32);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_SignedRawInvoice_signature"))) TS_SignedRawInvoice_signature(uint32_t this_arg) {
	LDKSignedRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKInvoiceSignature ret_var = SignedRawInvoice_signature(&this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_SignedRawInvoice_recover_payee_pub_key"))) TS_SignedRawInvoice_recover_payee_pub_key(uint32_t this_arg) {
	LDKSignedRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCResult_PayeePubKeyErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PayeePubKeyErrorZ), "LDKCResult_PayeePubKeyErrorZ");
	*ret_conv = SignedRawInvoice_recover_payee_pub_key(&this_arg_conv);
	return (uint32_t)ret_conv;
}

jboolean  __attribute__((export_name("TS_SignedRawInvoice_check_signature"))) TS_SignedRawInvoice_check_signature(uint32_t this_arg) {
	LDKSignedRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = SignedRawInvoice_check_signature(&this_arg_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_RawInvoice_hash"))) TS_RawInvoice_hash(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, RawInvoice_hash(&this_arg_conv).data, 32);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_payment_hash"))) TS_RawInvoice_payment_hash(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKSha256 ret_var = RawInvoice_payment_hash(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_description"))) TS_RawInvoice_description(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKDescription ret_var = RawInvoice_description(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_payee_pub_key"))) TS_RawInvoice_payee_pub_key(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPayeePubKey ret_var = RawInvoice_payee_pub_key(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_description_hash"))) TS_RawInvoice_description_hash(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKSha256 ret_var = RawInvoice_description_hash(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_expiry_time"))) TS_RawInvoice_expiry_time(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKExpiryTime ret_var = RawInvoice_expiry_time(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_min_final_cltv_expiry"))) TS_RawInvoice_min_final_cltv_expiry(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKMinFinalCltvExpiry ret_var = RawInvoice_min_final_cltv_expiry(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_RawInvoice_payment_secret"))) TS_RawInvoice_payment_secret(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, RawInvoice_payment_secret(&this_arg_conv).data, 32);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_features"))) TS_RawInvoice_features(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKInvoiceFeatures ret_var = RawInvoice_features(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

uint32_tArray  __attribute__((export_name("TS_RawInvoice_private_routes"))) TS_RawInvoice_private_routes(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_PrivateRouteZ ret_var = RawInvoice_private_routes(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t o = 0; o < ret_var.datalen; o++) {
		LDKPrivateRoute ret_conv_14_var = ret_var.data[o];
		uint32_t ret_conv_14_ref = 0;
		CHECK((((uintptr_t)ret_conv_14_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_14_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_14_var);
		ret_conv_14_ref = (uintptr_t)ret_conv_14_var.inner;
		if (ret_conv_14_var.is_owned) {
			ret_conv_14_ref |= 1;
		}
		ret_arr_ptr[o] = ret_conv_14_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_amount_pico_btc"))) TS_RawInvoice_amount_pico_btc(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = RawInvoice_amount_pico_btc(&this_arg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_RawInvoice_currency"))) TS_RawInvoice_currency(uint32_t this_arg) {
	LDKRawInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	uint32_t ret_conv = LDKCurrency_to_js(RawInvoice_currency(&this_arg_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_PositiveTimestamp_from_unix_timestamp"))) TS_PositiveTimestamp_from_unix_timestamp(int64_t unix_seconds) {
	LDKCResult_PositiveTimestampCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PositiveTimestampCreationErrorZ), "LDKCResult_PositiveTimestampCreationErrorZ");
	*ret_conv = PositiveTimestamp_from_unix_timestamp(unix_seconds);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_PositiveTimestamp_from_duration_since_epoch"))) TS_PositiveTimestamp_from_duration_since_epoch(int64_t duration) {
	LDKCResult_PositiveTimestampCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PositiveTimestampCreationErrorZ), "LDKCResult_PositiveTimestampCreationErrorZ");
	*ret_conv = PositiveTimestamp_from_duration_since_epoch(duration);
	return (uint32_t)ret_conv;
}

int64_t  __attribute__((export_name("TS_PositiveTimestamp_as_unix_timestamp"))) TS_PositiveTimestamp_as_unix_timestamp(uint32_t this_arg) {
	LDKPositiveTimestamp this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = PositiveTimestamp_as_unix_timestamp(&this_arg_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_PositiveTimestamp_as_duration_since_epoch"))) TS_PositiveTimestamp_as_duration_since_epoch(uint32_t this_arg) {
	LDKPositiveTimestamp this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = PositiveTimestamp_as_duration_since_epoch(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_Invoice_into_signed_raw"))) TS_Invoice_into_signed_raw(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = (this_arg & 1) || (this_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	this_arg_conv = Invoice_clone(&this_arg_conv);
	LDKSignedRawInvoice ret_var = Invoice_into_signed_raw(this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Invoice_check_signature"))) TS_Invoice_check_signature(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCResult_NoneSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_NoneSemanticErrorZ), "LDKCResult_NoneSemanticErrorZ");
	*ret_conv = Invoice_check_signature(&this_arg_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_Invoice_from_signed"))) TS_Invoice_from_signed(uint32_t signed_invoice) {
	LDKSignedRawInvoice signed_invoice_conv;
	signed_invoice_conv.inner = (void*)(signed_invoice & (~1));
	signed_invoice_conv.is_owned = (signed_invoice & 1) || (signed_invoice == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(signed_invoice_conv);
	signed_invoice_conv = SignedRawInvoice_clone(&signed_invoice_conv);
	LDKCResult_InvoiceSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSemanticErrorZ), "LDKCResult_InvoiceSemanticErrorZ");
	*ret_conv = Invoice_from_signed(signed_invoice_conv);
	return (uint32_t)ret_conv;
}

int64_t  __attribute__((export_name("TS_Invoice_duration_since_epoch"))) TS_Invoice_duration_since_epoch(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = Invoice_duration_since_epoch(&this_arg_conv);
	return ret_val;
}

int8_tArray  __attribute__((export_name("TS_Invoice_payment_hash"))) TS_Invoice_payment_hash(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *Invoice_payment_hash(&this_arg_conv), 32);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_Invoice_payee_pub_key"))) TS_Invoice_payee_pub_key(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, Invoice_payee_pub_key(&this_arg_conv).compressed_form, 33);
	return ret_arr;
}

int8_tArray  __attribute__((export_name("TS_Invoice_payment_secret"))) TS_Invoice_payment_secret(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(32, __LINE__);
	memcpy(ret_arr->elems, *Invoice_payment_secret(&this_arg_conv), 32);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Invoice_features"))) TS_Invoice_features(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKInvoiceFeatures ret_var = Invoice_features(&this_arg_conv);
	uint32_t ret_ref = 0;
	if ((uintptr_t)ret_var.inner > 4096) {
		CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
		ret_ref = (uintptr_t)ret_var.inner;
		if (ret_var.is_owned) {
			ret_ref |= 1;
		}
	}
	return ret_ref;
}

int8_tArray  __attribute__((export_name("TS_Invoice_recover_payee_pub_key"))) TS_Invoice_recover_payee_pub_key(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int8_tArray ret_arr = init_int8_tArray(33, __LINE__);
	memcpy(ret_arr->elems, Invoice_recover_payee_pub_key(&this_arg_conv).compressed_form, 33);
	return ret_arr;
}

int64_t  __attribute__((export_name("TS_Invoice_expiry_time"))) TS_Invoice_expiry_time(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = Invoice_expiry_time(&this_arg_conv);
	return ret_val;
}

jboolean  __attribute__((export_name("TS_Invoice_would_expire"))) TS_Invoice_would_expire(uint32_t this_arg, int64_t at_time) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	jboolean ret_val = Invoice_would_expire(&this_arg_conv, at_time);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_Invoice_min_final_cltv_expiry"))) TS_Invoice_min_final_cltv_expiry(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = Invoice_min_final_cltv_expiry(&this_arg_conv);
	return ret_val;
}

uint32_tArray  __attribute__((export_name("TS_Invoice_private_routes"))) TS_Invoice_private_routes(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_PrivateRouteZ ret_var = Invoice_private_routes(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t o = 0; o < ret_var.datalen; o++) {
		LDKPrivateRoute ret_conv_14_var = ret_var.data[o];
		uint32_t ret_conv_14_ref = 0;
		CHECK((((uintptr_t)ret_conv_14_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_14_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_14_var);
		ret_conv_14_ref = (uintptr_t)ret_conv_14_var.inner;
		if (ret_conv_14_var.is_owned) {
			ret_conv_14_ref |= 1;
		}
		ret_arr_ptr[o] = ret_conv_14_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_tArray  __attribute__((export_name("TS_Invoice_route_hints"))) TS_Invoice_route_hints(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCVec_RouteHintZ ret_var = Invoice_route_hints(&this_arg_conv);
	uint32_tArray ret_arr = NULL;
	ret_arr = init_uint32_tArray(ret_var.datalen, __LINE__);
	uint32_t *ret_arr_ptr = (uint32_t*)(((uint8_t*)ret_arr) + 4);
	for (size_t l = 0; l < ret_var.datalen; l++) {
		LDKRouteHint ret_conv_11_var = ret_var.data[l];
		uint32_t ret_conv_11_ref = 0;
		CHECK((((uintptr_t)ret_conv_11_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
		CHECK((((uintptr_t)&ret_conv_11_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
		CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_conv_11_var);
		ret_conv_11_ref = (uintptr_t)ret_conv_11_var.inner;
		if (ret_conv_11_var.is_owned) {
			ret_conv_11_ref |= 1;
		}
		ret_arr_ptr[l] = ret_conv_11_ref;
	}
	
	FREE(ret_var.data);
	return ret_arr;
}

uint32_t  __attribute__((export_name("TS_Invoice_currency"))) TS_Invoice_currency(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	uint32_t ret_conv = LDKCurrency_to_js(Invoice_currency(&this_arg_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_Invoice_amount_milli_satoshis"))) TS_Invoice_amount_milli_satoshis(uint32_t this_arg) {
	LDKInvoice this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKCOption_u64Z *ret_copy = MALLOC(sizeof(LDKCOption_u64Z), "LDKCOption_u64Z");
	*ret_copy = Invoice_amount_milli_satoshis(&this_arg_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_Description_new"))) TS_Description_new(jstring description) {
	LDKStr description_conv = str_ref_to_owned_c(description);
	LDKCResult_DescriptionCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_DescriptionCreationErrorZ), "LDKCResult_DescriptionCreationErrorZ");
	*ret_conv = Description_new(description_conv);
	return (uint32_t)ret_conv;
}

jstring  __attribute__((export_name("TS_Description_into_inner"))) TS_Description_into_inner(uint32_t this_arg) {
	LDKDescription this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = (this_arg & 1) || (this_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	this_arg_conv = Description_clone(&this_arg_conv);
	LDKStr ret_str = Description_into_inner(this_arg_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_ExpiryTime_from_seconds"))) TS_ExpiryTime_from_seconds(int64_t seconds) {
	LDKExpiryTime ret_var = ExpiryTime_from_seconds(seconds);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_ExpiryTime_from_duration"))) TS_ExpiryTime_from_duration(int64_t duration) {
	LDKExpiryTime ret_var = ExpiryTime_from_duration(duration);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

int64_t  __attribute__((export_name("TS_ExpiryTime_as_seconds"))) TS_ExpiryTime_as_seconds(uint32_t this_arg) {
	LDKExpiryTime this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = ExpiryTime_as_seconds(&this_arg_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_ExpiryTime_as_duration"))) TS_ExpiryTime_as_duration(uint32_t this_arg) {
	LDKExpiryTime this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	int64_t ret_val = ExpiryTime_as_duration(&this_arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PrivateRoute_new"))) TS_PrivateRoute_new(uint32_t hops) {
	LDKRouteHint hops_conv;
	hops_conv.inner = (void*)(hops & (~1));
	hops_conv.is_owned = (hops & 1) || (hops == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(hops_conv);
	hops_conv = RouteHint_clone(&hops_conv);
	LDKCResult_PrivateRouteCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PrivateRouteCreationErrorZ), "LDKCResult_PrivateRouteCreationErrorZ");
	*ret_conv = PrivateRoute_new(hops_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_PrivateRoute_into_inner"))) TS_PrivateRoute_into_inner(uint32_t this_arg) {
	LDKPrivateRoute this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = (this_arg & 1) || (this_arg == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	this_arg_conv = PrivateRoute_clone(&this_arg_conv);
	LDKRouteHint ret_var = PrivateRoute_into_inner(this_arg_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_CreationError_clone"))) TS_CreationError_clone(uint32_t orig) {
	LDKCreationError* orig_conv = (LDKCreationError*)(orig & ~1);
	uint32_t ret_conv = LDKCreationError_to_js(CreationError_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_CreationError_description_too_long"))) TS_CreationError_description_too_long() {
	uint32_t ret_conv = LDKCreationError_to_js(CreationError_description_too_long());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_CreationError_route_too_long"))) TS_CreationError_route_too_long() {
	uint32_t ret_conv = LDKCreationError_to_js(CreationError_route_too_long());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_CreationError_timestamp_out_of_bounds"))) TS_CreationError_timestamp_out_of_bounds() {
	uint32_t ret_conv = LDKCreationError_to_js(CreationError_timestamp_out_of_bounds());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_CreationError_invalid_amount"))) TS_CreationError_invalid_amount() {
	uint32_t ret_conv = LDKCreationError_to_js(CreationError_invalid_amount());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_CreationError_missing_route_hints"))) TS_CreationError_missing_route_hints() {
	uint32_t ret_conv = LDKCreationError_to_js(CreationError_missing_route_hints());
	return ret_conv;
}

jboolean  __attribute__((export_name("TS_CreationError_eq"))) TS_CreationError_eq(uint32_t a, uint32_t b) {
	LDKCreationError* a_conv = (LDKCreationError*)(a & ~1);
	LDKCreationError* b_conv = (LDKCreationError*)(b & ~1);
	jboolean ret_val = CreationError_eq(a_conv, b_conv);
	return ret_val;
}

jstring  __attribute__((export_name("TS_CreationError_to_str"))) TS_CreationError_to_str(uint32_t o) {
	LDKCreationError* o_conv = (LDKCreationError*)(o & ~1);
	LDKStr ret_str = CreationError_to_str(o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_clone"))) TS_SemanticError_clone(uint32_t orig) {
	LDKSemanticError* orig_conv = (LDKSemanticError*)(orig & ~1);
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_clone(orig_conv));
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_no_payment_hash"))) TS_SemanticError_no_payment_hash() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_no_payment_hash());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_multiple_payment_hashes"))) TS_SemanticError_multiple_payment_hashes() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_multiple_payment_hashes());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_no_description"))) TS_SemanticError_no_description() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_no_description());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_multiple_descriptions"))) TS_SemanticError_multiple_descriptions() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_multiple_descriptions());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_no_payment_secret"))) TS_SemanticError_no_payment_secret() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_no_payment_secret());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_multiple_payment_secrets"))) TS_SemanticError_multiple_payment_secrets() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_multiple_payment_secrets());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_invalid_features"))) TS_SemanticError_invalid_features() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_invalid_features());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_invalid_recovery_id"))) TS_SemanticError_invalid_recovery_id() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_invalid_recovery_id());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_invalid_signature"))) TS_SemanticError_invalid_signature() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_invalid_signature());
	return ret_conv;
}

uint32_t  __attribute__((export_name("TS_SemanticError_imprecise_amount"))) TS_SemanticError_imprecise_amount() {
	uint32_t ret_conv = LDKSemanticError_to_js(SemanticError_imprecise_amount());
	return ret_conv;
}

jboolean  __attribute__((export_name("TS_SemanticError_eq"))) TS_SemanticError_eq(uint32_t a, uint32_t b) {
	LDKSemanticError* a_conv = (LDKSemanticError*)(a & ~1);
	LDKSemanticError* b_conv = (LDKSemanticError*)(b & ~1);
	jboolean ret_val = SemanticError_eq(a_conv, b_conv);
	return ret_val;
}

jstring  __attribute__((export_name("TS_SemanticError_to_str"))) TS_SemanticError_to_str(uint32_t o) {
	LDKSemanticError* o_conv = (LDKSemanticError*)(o & ~1);
	LDKStr ret_str = SemanticError_to_str(o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

void  __attribute__((export_name("TS_SignOrCreationError_free"))) TS_SignOrCreationError_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKSignOrCreationError this_ptr_conv = *(LDKSignOrCreationError*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	SignOrCreationError_free(this_ptr_conv);
}

static inline uintptr_t SignOrCreationError_clone_ptr(LDKSignOrCreationError *NONNULL_PTR arg) {
	LDKSignOrCreationError *ret_copy = MALLOC(sizeof(LDKSignOrCreationError), "LDKSignOrCreationError");
	*ret_copy = SignOrCreationError_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_SignOrCreationError_clone_ptr"))) TS_SignOrCreationError_clone_ptr(uint32_t arg) {
	LDKSignOrCreationError* arg_conv = (LDKSignOrCreationError*)arg;
	uint32_t ret_val = SignOrCreationError_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_SignOrCreationError_clone"))) TS_SignOrCreationError_clone(uint32_t orig) {
	LDKSignOrCreationError* orig_conv = (LDKSignOrCreationError*)orig;
	LDKSignOrCreationError *ret_copy = MALLOC(sizeof(LDKSignOrCreationError), "LDKSignOrCreationError");
	*ret_copy = SignOrCreationError_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_SignOrCreationError_sign_error"))) TS_SignOrCreationError_sign_error() {
	LDKSignOrCreationError *ret_copy = MALLOC(sizeof(LDKSignOrCreationError), "LDKSignOrCreationError");
	*ret_copy = SignOrCreationError_sign_error();
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_SignOrCreationError_creation_error"))) TS_SignOrCreationError_creation_error(uint32_t a) {
	LDKCreationError a_conv = LDKCreationError_from_js(a);
	LDKSignOrCreationError *ret_copy = MALLOC(sizeof(LDKSignOrCreationError), "LDKSignOrCreationError");
	*ret_copy = SignOrCreationError_creation_error(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_SignOrCreationError_eq"))) TS_SignOrCreationError_eq(uint32_t a, uint32_t b) {
	LDKSignOrCreationError* a_conv = (LDKSignOrCreationError*)a;
	LDKSignOrCreationError* b_conv = (LDKSignOrCreationError*)b;
	jboolean ret_val = SignOrCreationError_eq(a_conv, b_conv);
	return ret_val;
}

jstring  __attribute__((export_name("TS_SignOrCreationError_to_str"))) TS_SignOrCreationError_to_str(uint32_t o) {
	LDKSignOrCreationError* o_conv = (LDKSignOrCreationError*)o;
	LDKStr ret_str = SignOrCreationError_to_str(o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

void  __attribute__((export_name("TS_InvoicePayer_free"))) TS_InvoicePayer_free(uint32_t this_obj) {
	LDKInvoicePayer this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	InvoicePayer_free(this_obj_conv);
}

void  __attribute__((export_name("TS_Payer_free"))) TS_Payer_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKPayer this_ptr_conv = *(LDKPayer*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Payer_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_Router_free"))) TS_Router_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKRouter this_ptr_conv = *(LDKRouter*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	Router_free(this_ptr_conv);
}

void  __attribute__((export_name("TS_RetryAttempts_free"))) TS_RetryAttempts_free(uint32_t this_obj) {
	LDKRetryAttempts this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	RetryAttempts_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_RetryAttempts_get_a"))) TS_RetryAttempts_get_a(uint32_t this_ptr) {
	LDKRetryAttempts this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	uint32_t ret_val = RetryAttempts_get_a(&this_ptr_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_RetryAttempts_set_a"))) TS_RetryAttempts_set_a(uint32_t this_ptr, uint32_t val) {
	LDKRetryAttempts this_ptr_conv;
	this_ptr_conv.inner = (void*)(this_ptr & (~1));
	this_ptr_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_ptr_conv);
	RetryAttempts_set_a(&this_ptr_conv, val);
}

uint32_t  __attribute__((export_name("TS_RetryAttempts_new"))) TS_RetryAttempts_new(uint32_t a_arg) {
	LDKRetryAttempts ret_var = RetryAttempts_new(a_arg);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

static inline uintptr_t RetryAttempts_clone_ptr(LDKRetryAttempts *NONNULL_PTR arg) {
	LDKRetryAttempts ret_var = RetryAttempts_clone(arg);
uint32_t ret_ref = 0;
CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
ret_ref = (uintptr_t)ret_var.inner;
if (ret_var.is_owned) {
	ret_ref |= 1;
}
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_RetryAttempts_clone_ptr"))) TS_RetryAttempts_clone_ptr(uint32_t arg) {
	LDKRetryAttempts arg_conv;
	arg_conv.inner = (void*)(arg & (~1));
	arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(arg_conv);
	uint32_t ret_val = RetryAttempts_clone_ptr(&arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_RetryAttempts_clone"))) TS_RetryAttempts_clone(uint32_t orig) {
	LDKRetryAttempts orig_conv;
	orig_conv.inner = (void*)(orig & (~1));
	orig_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(orig_conv);
	LDKRetryAttempts ret_var = RetryAttempts_clone(&orig_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

jboolean  __attribute__((export_name("TS_RetryAttempts_eq"))) TS_RetryAttempts_eq(uint32_t a, uint32_t b) {
	LDKRetryAttempts a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	LDKRetryAttempts b_conv;
	b_conv.inner = (void*)(b & (~1));
	b_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(b_conv);
	jboolean ret_val = RetryAttempts_eq(&a_conv, &b_conv);
	return ret_val;
}

int64_t  __attribute__((export_name("TS_RetryAttempts_hash"))) TS_RetryAttempts_hash(uint32_t o) {
	LDKRetryAttempts o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	int64_t ret_val = RetryAttempts_hash(&o_conv);
	return ret_val;
}

void  __attribute__((export_name("TS_PaymentError_free"))) TS_PaymentError_free(uint32_t this_ptr) {
	if ((this_ptr & 1) != 0) return;
	void* this_ptr_ptr = (void*)(((uintptr_t)this_ptr) & ~1);
	CHECK_ACCESS(this_ptr_ptr);
	LDKPaymentError this_ptr_conv = *(LDKPaymentError*)(this_ptr_ptr);
	FREE((void*)this_ptr);
	PaymentError_free(this_ptr_conv);
}

static inline uintptr_t PaymentError_clone_ptr(LDKPaymentError *NONNULL_PTR arg) {
	LDKPaymentError *ret_copy = MALLOC(sizeof(LDKPaymentError), "LDKPaymentError");
	*ret_copy = PaymentError_clone(arg);
uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}
uint32_t  __attribute__((export_name("TS_PaymentError_clone_ptr"))) TS_PaymentError_clone_ptr(uint32_t arg) {
	LDKPaymentError* arg_conv = (LDKPaymentError*)arg;
	uint32_t ret_val = PaymentError_clone_ptr(arg_conv);
	return ret_val;
}

uint32_t  __attribute__((export_name("TS_PaymentError_clone"))) TS_PaymentError_clone(uint32_t orig) {
	LDKPaymentError* orig_conv = (LDKPaymentError*)orig;
	LDKPaymentError *ret_copy = MALLOC(sizeof(LDKPaymentError), "LDKPaymentError");
	*ret_copy = PaymentError_clone(orig_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentError_invoice"))) TS_PaymentError_invoice(jstring a) {
	LDKStr a_conv = str_ref_to_owned_c(a);
	LDKPaymentError *ret_copy = MALLOC(sizeof(LDKPaymentError), "LDKPaymentError");
	*ret_copy = PaymentError_invoice(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentError_routing"))) TS_PaymentError_routing(uint32_t a) {
	LDKLightningError a_conv;
	a_conv.inner = (void*)(a & (~1));
	a_conv.is_owned = (a & 1) || (a == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(a_conv);
	a_conv = LightningError_clone(&a_conv);
	LDKPaymentError *ret_copy = MALLOC(sizeof(LDKPaymentError), "LDKPaymentError");
	*ret_copy = PaymentError_routing(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_PaymentError_sending"))) TS_PaymentError_sending(uint32_t a) {
	void* a_ptr = (void*)(((uintptr_t)a) & ~1);
	CHECK_ACCESS(a_ptr);
	LDKPaymentSendFailure a_conv = *(LDKPaymentSendFailure*)(a_ptr);
	a_conv = PaymentSendFailure_clone((LDKPaymentSendFailure*)(((uintptr_t)a) & ~1));
	LDKPaymentError *ret_copy = MALLOC(sizeof(LDKPaymentError), "LDKPaymentError");
	*ret_copy = PaymentError_sending(a_conv);
	uint32_t ret_ref = (uintptr_t)ret_copy;
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_InvoicePayer_new"))) TS_InvoicePayer_new(uint32_t payer, uint32_t router, uint32_t scorer, uint32_t logger, uint32_t event_handler, uint32_t retry_attempts) {
	void* payer_ptr = (void*)(((uintptr_t)payer) & ~1);
	CHECK_ACCESS(payer_ptr);
	LDKPayer payer_conv = *(LDKPayer*)(payer_ptr);
	if (payer_conv.free == LDKPayer_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKPayer_JCalls_cloned(&payer_conv);
	}
	void* router_ptr = (void*)(((uintptr_t)router) & ~1);
	CHECK_ACCESS(router_ptr);
	LDKRouter router_conv = *(LDKRouter*)(router_ptr);
	if (router_conv.free == LDKRouter_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKRouter_JCalls_cloned(&router_conv);
	}
	LDKMultiThreadedLockableScore scorer_conv;
	scorer_conv.inner = (void*)(scorer & (~1));
	scorer_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(scorer_conv);
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	void* event_handler_ptr = (void*)(((uintptr_t)event_handler) & ~1);
	CHECK_ACCESS(event_handler_ptr);
	LDKEventHandler event_handler_conv = *(LDKEventHandler*)(event_handler_ptr);
	if (event_handler_conv.free == LDKEventHandler_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKEventHandler_JCalls_cloned(&event_handler_conv);
	}
	LDKRetryAttempts retry_attempts_conv;
	retry_attempts_conv.inner = (void*)(retry_attempts & (~1));
	retry_attempts_conv.is_owned = (retry_attempts & 1) || (retry_attempts == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(retry_attempts_conv);
	retry_attempts_conv = RetryAttempts_clone(&retry_attempts_conv);
	LDKInvoicePayer ret_var = InvoicePayer_new(payer_conv, router_conv, &scorer_conv, logger_conv, event_handler_conv, retry_attempts_conv);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_InvoicePayer_pay_invoice"))) TS_InvoicePayer_pay_invoice(uint32_t this_arg, uint32_t invoice) {
	LDKInvoicePayer this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKInvoice invoice_conv;
	invoice_conv.inner = (void*)(invoice & (~1));
	invoice_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(invoice_conv);
	LDKCResult_PaymentIdPaymentErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentErrorZ), "LDKCResult_PaymentIdPaymentErrorZ");
	*ret_conv = InvoicePayer_pay_invoice(&this_arg_conv, &invoice_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_InvoicePayer_pay_zero_value_invoice"))) TS_InvoicePayer_pay_zero_value_invoice(uint32_t this_arg, uint32_t invoice, int64_t amount_msats) {
	LDKInvoicePayer this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKInvoice invoice_conv;
	invoice_conv.inner = (void*)(invoice & (~1));
	invoice_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(invoice_conv);
	LDKCResult_PaymentIdPaymentErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentErrorZ), "LDKCResult_PaymentIdPaymentErrorZ");
	*ret_conv = InvoicePayer_pay_zero_value_invoice(&this_arg_conv, &invoice_conv, amount_msats);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_InvoicePayer_pay_pubkey"))) TS_InvoicePayer_pay_pubkey(uint32_t this_arg, int8_tArray pubkey, int8_tArray payment_preimage, int64_t amount_msats, int32_t final_cltv_expiry_delta) {
	LDKInvoicePayer this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPublicKey pubkey_ref;
	CHECK(pubkey->arr_len == 33);
	memcpy(pubkey_ref.compressed_form, pubkey->elems, 33); FREE(pubkey);
	LDKThirtyTwoBytes payment_preimage_ref;
	CHECK(payment_preimage->arr_len == 32);
	memcpy(payment_preimage_ref.data, payment_preimage->elems, 32); FREE(payment_preimage);
	LDKCResult_PaymentIdPaymentErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_PaymentIdPaymentErrorZ), "LDKCResult_PaymentIdPaymentErrorZ");
	*ret_conv = InvoicePayer_pay_pubkey(&this_arg_conv, pubkey_ref, payment_preimage_ref, amount_msats, final_cltv_expiry_delta);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_InvoicePayer_remove_cached_payment"))) TS_InvoicePayer_remove_cached_payment(uint32_t this_arg, int8_tArray payment_hash) {
	LDKInvoicePayer this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	unsigned char payment_hash_arr[32];
	CHECK(payment_hash->arr_len == 32);
	memcpy(payment_hash_arr, payment_hash->elems, 32); FREE(payment_hash);
	unsigned char (*payment_hash_ref)[32] = &payment_hash_arr;
	InvoicePayer_remove_cached_payment(&this_arg_conv, payment_hash_ref);
}

uint32_t  __attribute__((export_name("TS_InvoicePayer_as_EventHandler"))) TS_InvoicePayer_as_EventHandler(uint32_t this_arg) {
	LDKInvoicePayer this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKEventHandler* ret_ret = MALLOC(sizeof(LDKEventHandler), "LDKEventHandler");
	*ret_ret = InvoicePayer_as_EventHandler(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_create_invoice_from_channelmanager_with_description_hash_and_duration_since_epoch"))) TS_create_invoice_from_channelmanager_with_description_hash_and_duration_since_epoch(uint32_t channelmanager, uint32_t keys_manager, uint32_t network, uint32_t amt_msat, uint32_t description_hash, int64_t duration_since_epoch) {
	LDKChannelManager channelmanager_conv;
	channelmanager_conv.inner = (void*)(channelmanager & (~1));
	channelmanager_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channelmanager_conv);
	void* keys_manager_ptr = (void*)(((uintptr_t)keys_manager) & ~1);
	CHECK_ACCESS(keys_manager_ptr);
	LDKKeysInterface keys_manager_conv = *(LDKKeysInterface*)(keys_manager_ptr);
	if (keys_manager_conv.free == LDKKeysInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKKeysInterface_JCalls_cloned(&keys_manager_conv);
	}
	LDKCurrency network_conv = LDKCurrency_from_js(network);
	void* amt_msat_ptr = (void*)(((uintptr_t)amt_msat) & ~1);
	CHECK_ACCESS(amt_msat_ptr);
	LDKCOption_u64Z amt_msat_conv = *(LDKCOption_u64Z*)(amt_msat_ptr);
	amt_msat_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)amt_msat) & ~1));
	LDKSha256 description_hash_conv;
	description_hash_conv.inner = (void*)(description_hash & (~1));
	description_hash_conv.is_owned = (description_hash & 1) || (description_hash == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(description_hash_conv);
	description_hash_conv = Sha256_clone(&description_hash_conv);
	LDKCResult_InvoiceSignOrCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSignOrCreationErrorZ), "LDKCResult_InvoiceSignOrCreationErrorZ");
	*ret_conv = create_invoice_from_channelmanager_with_description_hash_and_duration_since_epoch(&channelmanager_conv, keys_manager_conv, network_conv, amt_msat_conv, description_hash_conv, duration_since_epoch);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_create_invoice_from_channelmanager_and_duration_since_epoch"))) TS_create_invoice_from_channelmanager_and_duration_since_epoch(uint32_t channelmanager, uint32_t keys_manager, uint32_t network, uint32_t amt_msat, jstring description, int64_t duration_since_epoch) {
	LDKChannelManager channelmanager_conv;
	channelmanager_conv.inner = (void*)(channelmanager & (~1));
	channelmanager_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(channelmanager_conv);
	void* keys_manager_ptr = (void*)(((uintptr_t)keys_manager) & ~1);
	CHECK_ACCESS(keys_manager_ptr);
	LDKKeysInterface keys_manager_conv = *(LDKKeysInterface*)(keys_manager_ptr);
	if (keys_manager_conv.free == LDKKeysInterface_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKKeysInterface_JCalls_cloned(&keys_manager_conv);
	}
	LDKCurrency network_conv = LDKCurrency_from_js(network);
	void* amt_msat_ptr = (void*)(((uintptr_t)amt_msat) & ~1);
	CHECK_ACCESS(amt_msat_ptr);
	LDKCOption_u64Z amt_msat_conv = *(LDKCOption_u64Z*)(amt_msat_ptr);
	amt_msat_conv = COption_u64Z_clone((LDKCOption_u64Z*)(((uintptr_t)amt_msat) & ~1));
	LDKStr description_conv = str_ref_to_owned_c(description);
	LDKCResult_InvoiceSignOrCreationErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceSignOrCreationErrorZ), "LDKCResult_InvoiceSignOrCreationErrorZ");
	*ret_conv = create_invoice_from_channelmanager_and_duration_since_epoch(&channelmanager_conv, keys_manager_conv, network_conv, amt_msat_conv, description_conv, duration_since_epoch);
	return (uint32_t)ret_conv;
}

void  __attribute__((export_name("TS_DefaultRouter_free"))) TS_DefaultRouter_free(uint32_t this_obj) {
	LDKDefaultRouter this_obj_conv;
	this_obj_conv.inner = (void*)(this_obj & (~1));
	this_obj_conv.is_owned = (this_obj & 1) || (this_obj == 0);
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_obj_conv);
	DefaultRouter_free(this_obj_conv);
}

uint32_t  __attribute__((export_name("TS_DefaultRouter_new"))) TS_DefaultRouter_new(uint32_t network_graph, uint32_t logger, int8_tArray random_seed_bytes) {
	LDKNetworkGraph network_graph_conv;
	network_graph_conv.inner = (void*)(network_graph & (~1));
	network_graph_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(network_graph_conv);
	void* logger_ptr = (void*)(((uintptr_t)logger) & ~1);
	CHECK_ACCESS(logger_ptr);
	LDKLogger logger_conv = *(LDKLogger*)(logger_ptr);
	if (logger_conv.free == LDKLogger_JCalls_free) {
		// If this_arg is a JCalls struct, then we need to increment the refcnt in it.
		LDKLogger_JCalls_cloned(&logger_conv);
	}
	LDKThirtyTwoBytes random_seed_bytes_ref;
	CHECK(random_seed_bytes->arr_len == 32);
	memcpy(random_seed_bytes_ref.data, random_seed_bytes->elems, 32); FREE(random_seed_bytes);
	LDKDefaultRouter ret_var = DefaultRouter_new(&network_graph_conv, logger_conv, random_seed_bytes_ref);
	uint32_t ret_ref = 0;
	CHECK((((uintptr_t)ret_var.inner) & 1) == 0); // We rely on a free low bit, malloc guarantees this.
	CHECK((((uintptr_t)&ret_var) & 1) == 0); // We rely on a free low bit, pointer alignment guarantees this.
	CHECK_INNER_FIELD_ACCESS_OR_NULL(ret_var);
	ret_ref = (uintptr_t)ret_var.inner;
	if (ret_var.is_owned) {
		ret_ref |= 1;
	}
	return ret_ref;
}

uint32_t  __attribute__((export_name("TS_DefaultRouter_as_Router"))) TS_DefaultRouter_as_Router(uint32_t this_arg) {
	LDKDefaultRouter this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKRouter* ret_ret = MALLOC(sizeof(LDKRouter), "LDKRouter");
	*ret_ret = DefaultRouter_as_Router(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_ChannelManager_as_Payer"))) TS_ChannelManager_as_Payer(uint32_t this_arg) {
	LDKChannelManager this_arg_conv;
	this_arg_conv.inner = (void*)(this_arg & (~1));
	this_arg_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(this_arg_conv);
	LDKPayer* ret_ret = MALLOC(sizeof(LDKPayer), "LDKPayer");
	*ret_ret = ChannelManager_as_Payer(&this_arg_conv);
	return (uint32_t)ret_ret;
}

uint32_t  __attribute__((export_name("TS_SiPrefix_from_str"))) TS_SiPrefix_from_str(jstring s) {
	LDKStr s_conv = str_ref_to_owned_c(s);
	LDKCResult_SiPrefixParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SiPrefixParseErrorZ), "LDKCResult_SiPrefixParseErrorZ");
	*ret_conv = SiPrefix_from_str(s_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_Invoice_from_str"))) TS_Invoice_from_str(jstring s) {
	LDKStr s_conv = str_ref_to_owned_c(s);
	LDKCResult_InvoiceParseOrSemanticErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_InvoiceParseOrSemanticErrorZ), "LDKCResult_InvoiceParseOrSemanticErrorZ");
	*ret_conv = Invoice_from_str(s_conv);
	return (uint32_t)ret_conv;
}

uint32_t  __attribute__((export_name("TS_SignedRawInvoice_from_str"))) TS_SignedRawInvoice_from_str(jstring s) {
	LDKStr s_conv = str_ref_to_owned_c(s);
	LDKCResult_SignedRawInvoiceParseErrorZ* ret_conv = MALLOC(sizeof(LDKCResult_SignedRawInvoiceParseErrorZ), "LDKCResult_SignedRawInvoiceParseErrorZ");
	*ret_conv = SignedRawInvoice_from_str(s_conv);
	return (uint32_t)ret_conv;
}

jstring  __attribute__((export_name("TS_ParseError_to_str"))) TS_ParseError_to_str(uint32_t o) {
	LDKParseError* o_conv = (LDKParseError*)o;
	LDKStr ret_str = ParseError_to_str(o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

jstring  __attribute__((export_name("TS_ParseOrSemanticError_to_str"))) TS_ParseOrSemanticError_to_str(uint32_t o) {
	LDKParseOrSemanticError* o_conv = (LDKParseOrSemanticError*)o;
	LDKStr ret_str = ParseOrSemanticError_to_str(o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

jstring  __attribute__((export_name("TS_Invoice_to_str"))) TS_Invoice_to_str(uint32_t o) {
	LDKInvoice o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	LDKStr ret_str = Invoice_to_str(&o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

jstring  __attribute__((export_name("TS_SignedRawInvoice_to_str"))) TS_SignedRawInvoice_to_str(uint32_t o) {
	LDKSignedRawInvoice o_conv;
	o_conv.inner = (void*)(o & (~1));
	o_conv.is_owned = false;
	CHECK_INNER_FIELD_ACCESS_OR_NULL(o_conv);
	LDKStr ret_str = SignedRawInvoice_to_str(&o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

jstring  __attribute__((export_name("TS_Currency_to_str"))) TS_Currency_to_str(uint32_t o) {
	LDKCurrency* o_conv = (LDKCurrency*)(o & ~1);
	LDKStr ret_str = Currency_to_str(o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

jstring  __attribute__((export_name("TS_SiPrefix_to_str"))) TS_SiPrefix_to_str(uint32_t o) {
	LDKSiPrefix* o_conv = (LDKSiPrefix*)(o & ~1);
	LDKStr ret_str = SiPrefix_to_str(o_conv);
	jstring ret_conv = str_ref_to_ts(ret_str.chars, ret_str.len);
	Str_free(ret_str);
	return ret_conv;
}

